let indexId = 202012

function createdData(depth, leaflen) {
    let root = {
        name: getCompanyName(),
        id: indexId++
    }

    function createChild(depth) {
        let len = parseInt(Math.random() * leaflen) + 1
        let mustId = parseInt(Math.random() * len)
        let child = null

        if (depth > 0) {
            child = []
            depth--
            for (let i = 0; i < len; i++) {
                let leaf = {
                    name: getCompanyName(),
                    id: indexId++
                }
                if (i === mustId || parseInt(Math.random() * 10 + 1) % 5 == 0) {
                    let leafchild = createChild(depth)
                    if (leafchild) {
                        leaf.children = leafchild
                    }
                }

                child.push(leaf)
            }
        }
        return child
    }

    let child = createChild(depth)
    if (child) {
        root.children = child
    }

    return root
}

let realData = {
    name: "深圳环宇科技集团有限公司",
    id: 0,
    children: [{
            name: "深圳环宇科技（厦门）集团有限公司",
            id: 1,
            children: [{
                    name: "研发中心",
                    id: 6,
                    children: [{
                            name: "项目开发组",
                            id: 12,
                            children: [{
                                    name: "后端开发组",
                                    id: 17
                                },
                                {
                                    name: "前端开发组",
                                    id: 18
                                },
                                {
                                    name: "测试组",
                                    id: 19
                                },
                                {
                                    name: "移动端开发组",
                                    id: 31
                                }
                            ]
                        },
                        {
                            name: "运维中心",
                            id: 13,
                            children: [{
                                    name: "桌面运维",
                                    id: 15
                                },
                                {
                                    name: "安全运维",
                                    id: 16
                                }
                            ]
                        },
                        {
                            name: "服务与部署",
                            id: 14
                        },
                        {
                            name: "交付中心",
                            id: 32
                        }
                    ]
                }, {
                    name: "行政中心",
                    id: 4
                },
                {
                    name: "市场部门",
                    id: 5,
                    // preChildren: true
                }
            ]
        },
        {
            name: "深圳环宇科技（广州）集团有限公司",
            id: 2,
            children: [{
                    name: "广州白云销售中心",
                    id: 7,
                    children: [{
                            id: 27,
                            name: "马智波",
                            type: "staff"
                        },
                        {
                            id: 28,
                            name: "李知更",
                            type: "staff"
                        }
                    ]
                },
                {
                    id: 8,
                    name: "张一桂",
                    type: "staff",
                    children: [{
                            id: 29,
                            name: "雷行者",
                            type: "staff"
                        },
                        {
                            id: 30,
                            name: "东哥",
                            type: "staff"
                        }
                    ]
                }
            ]
        },
        {
            name: "深圳环宇科技（上海）集团有限公司",
            id: 3,
            children: [{
                    name: "上海财务中心",
                    id: 9
                },
                {
                    name: "上海招聘与薪酬中心",
                    id: 10
                },
                {
                    name: "上海市场部门",
                    id: 11,
                    children: [{
                            name: "外滩门店",
                            id: 25
                        },
                        {
                            name: "明珠塔门店",
                            id: 26
                        }
                    ]
                }
            ]
        },
        {
            name: "深圳环宇科技（北京）集团有限公司",
            id: 21,
            children: [{
                    name: "北京对外办事处",
                    id: 22
                },
                {
                    name: "北京财务结算中心",
                    id: 23
                },
                {
                    name: "北京行政中心",
                    id: 24
                }
            ]
        },
        {
            name: "深圳环宇科技（广州）集团有限公司",
            id: 33
        },
    ]
}

let ldata = {
    "id": "1",
    "name": "Eve1",
    "children": [{
            "id": "2",
            "name": "Cain"
        }, {
            "id": "3",
            "name": "Caln",
            "children": [

                {
                    "id": "18",
                    "name": "N98i"
                },
                {
                    "id": "19",
                    "name": "k30u",
                    "children": [{
                        "id": "13",
                        "name": "Abel7",
                        "children": [{
                                "id": "14",
                                "name": "Ens8",
                                "children": [{
                                    "id": "15",
                                    "name": "nosv"
                                }]
                            },
                            {
                                "id": "17",
                                "name": "Noi1"
                            }
                        ]
                    }]
                }
            ]
        }, {
            "id": "4",
            "name": "Cani"
        },
        {
            "id": "5",
            "name": "Seth",
            "children": [{
                    "id": "6",
                    "name": "Enso"
                },
                {
                    "id": "7",
                    "name": "Novi"
                }, {
                    "id": "9",
                    "name": "Niam"
                },
                {
                    "id": "10",
                    "name": "qlao",
                    "children": [{
                            "id": "11",
                            "name": "Eno1"
                        },
                        {
                            "id": "8",
                            "name": "Noa1"
                        },
                        {
                            "id": "12",
                            "name": "No13"
                        }
                    ]
                }
            ]
        }
    ]
}

let sdata = {
    id: '1',
    name: '深圳国际什么软件有限公司',
    children: [{
            id: '2',
            name: '深圳国际什么软件有限公司罗湖办事处销售部东门老街营业厅',
            children: [{
                    id: '6',
                    name: '财务部门',
                },
                {
                    id: '7',
                    name: '后勤部门',
                },
                {
                    id: '8',
                    name: '行政部门',
                },
            ]
        },
        {
            id: '3',
            name: '广州市办事处',
            children: [{
                    id: '4',
                    name: '市场部门',
                },
                {
                    id: '5',
                    name: '行政部门',
                }
            ]
        },
        {
            id: '31',
            name: '东莞办事处',
            children: [{
                id: '32',
                name: '市场部门',
            }]
        },
        {
            id: '41',
            name: '南沙办事处',
            children: [{
                    id: '42',
                    name: '市场部门',
                },
                {
                    id: '43',
                    name: '财务部门',
                }
            ]
        }
    ]
}

let sgdata = {
    id: '1',
    name: '深圳国际什么软件有限公司',
}

let list = [{
        ppid: '',
        iid: '1',
        name: '金蝶中国'
    },
    {
        ppid: '1',
        iid: '2',
        name: '苍穹云'
    },
    {
        ppid: '1',
        iid: '3',
        name: '精斗云'
    },
    {
        ppid: '2',
        iid: '4',
        name: '组织发展'
    },
    {
        ppid: '2',
        iid: '5',
        name: '核心人力'
    }
]

function getCompanyName() {
    let harr = ["北京", "天津", "上海", "杭州", "南京", "杭州", "厦门", "深圳", "广州", "东莞", "香港", "台北", "东京", "首尔", "纽约"]
    let darr = ["百度", "阿里", "腾讯", "字节", "快手", "京东", "美团", "滴滴", "华为", "小米", "欧珀", "蚂蚁", "平安", "谷歌", "微软", "苹果", "亚马逊", "特斯拉", "喜茶", "奈雪", "瑞幸", "星巴克", "必胜客", "肯德基"]
    let marr = ["科技", "金融", "医药", "", "地产", "电商", "", "旅游", "通讯", "通信", "石油", "农业", "牧业", "渔业", "", "养殖", "航空", "智能", "制造", "汽车", "新能源", "互金", "基金", "证券", "银行", "医院", "芯片", "信息服务", "计算机", "软件", "诊所", "餐饮", "地摊"]
    let larr = ["", "控股集团", "", "有限公司", "", ""]

    let hl = harr.length
    let dl = darr.length
    let ml = marr.length
    let ll = larr.length
    return harr[parseInt(Math.random() * hl)] +
        darr[parseInt(Math.random() * dl)] +
        marr[parseInt(Math.random() * ml)] +
        larr[parseInt(Math.random() * ll)]
}

let perdata = {
    "name": "东莞腾讯智能有限公司",
    "id": 202012,
    "children": [{
        "name": "广州快手有限公司",
        "id": 202013,
        "children": [{
            "name": "天津谷歌通信",
            "id": 202014
        }, {
            "name": "东京美团芯片",
            "id": 202015
        }, {
            "name": "厦门谷歌银行",
            "id": 202016
        }, {
            "name": "台北字节基金",
            "id": 202017,
            "children": [{
                "name": "上海星巴克医院",
                "id": 202018
            }, {
                "name": "天津阿里制造",
                "id": 202019
            }, {
                "name": "厦门亚马逊农业",
                "id": 202020
            }, {
                "name": "香港平安餐饮控股集团",
                "id": 202021,
                "children": [{
                    "name": "上海华为医院",
                    "id": 202022
                }, {
                    "name": "北京滴滴农业",
                    "id": 202023,
                    "children": [{
                        "name": "东京阿里证券",
                        "id": 202024
                    }, {
                        "name": "上海苹果证券有限公司",
                        "id": 202025
                    }, {
                        "name": "天津腾讯养殖",
                        "id": 202026
                    }, {
                        "name": "南京京东诊所有限公司",
                        "id": 202027
                    }, {
                        "name": "香港小米智能",
                        "id": 202028
                    }, {
                        "name": "东莞特斯拉航空",
                        "id": 202029
                    }, {
                        "name": "深圳小米基金",
                        "id": 202030
                    }, {
                        "name": "北京必胜客",
                        "id": 202031
                    }]
                }, {
                    "name": "深圳京东诊所控股集团",
                    "id": 202032
                }, {
                    "name": "深圳京东牧业",
                    "id": 202033,
                    "children": [{
                        "name": "上海美团基金有限公司",
                        "id": 202034
                    }, {
                        "name": "台北肯德基信息服务",
                        "id": 202035
                    }, {
                        "name": "上海小米医药控股集团",
                        "id": 202036
                    }, {
                        "name": "首尔瑞幸诊所控股集团",
                        "id": 202037
                    }, {
                        "name": "东京亚马逊证券",
                        "id": 202038
                    }, {
                        "name": "北京小米诊所",
                        "id": 202039
                    }, {
                        "name": "厦门奈雪科技",
                        "id": 202040
                    }, {
                        "name": "杭州微软医药控股集团",
                        "id": 202041
                    }, {
                        "name": "东京滴滴控股集团",
                        "id": 202042
                    }, {
                        "name": "天津肯德基软件",
                        "id": 202043
                    }, {
                        "name": "香港平安",
                        "id": 202044
                    }, {
                        "name": "深圳星巴克餐饮控股集团",
                        "id": 202045
                    }, {
                        "name": "天津腾讯制造",
                        "id": 202046
                    }, {
                        "name": "厦门京东医院",
                        "id": 202047
                    }, {
                        "name": "天津滴滴金融",
                        "id": 202048
                    }, {
                        "name": "首尔京东医药控股集团",
                        "id": 202049
                    }, {
                        "name": "台北字节互金有限公司",
                        "id": 202050
                    }, {
                        "name": "南京肯德基控股集团",
                        "id": 202051
                    }, {
                        "name": "首尔奈雪渔业",
                        "id": 202052
                    }, {
                        "name": "香港喜茶基金",
                        "id": 202053
                    }, {
                        "name": "上海字节牧业",
                        "id": 202054
                    }, {
                        "name": "纽约滴滴证券",
                        "id": 202055
                    }, {
                        "name": "南京字节养殖",
                        "id": 202056
                    }, {
                        "name": "纽约星巴克科技",
                        "id": 202057
                    }]
                }, {
                    "name": "纽约肯德基科技",
                    "id": 202058,
                    "children": [{
                        "name": "天津奈雪制造",
                        "id": 202059
                    }, {
                        "name": "台北瑞幸牧业控股集团",
                        "id": 202060
                    }, {
                        "name": "首尔星巴克医院控股集团",
                        "id": 202061
                    }, {
                        "name": "深圳星巴克互金",
                        "id": 202062
                    }, {
                        "name": "台北快手基金",
                        "id": 202063
                    }, {
                        "name": "首尔百度金融",
                        "id": 202064
                    }, {
                        "name": "香港瑞幸",
                        "id": 202065
                    }, {
                        "name": "广州字节信息服务",
                        "id": 202066
                    }, {
                        "name": "北京谷歌诊所控股集团",
                        "id": 202067
                    }, {
                        "name": "上海必胜客基金",
                        "id": 202068
                    }, {
                        "name": "杭州喜茶科技",
                        "id": 202069
                    }, {
                        "name": "北京阿里软件控股集团",
                        "id": 202070
                    }, {
                        "name": "东京滴滴汽车控股集团",
                        "id": 202071
                    }, {
                        "name": "北京平安有限公司",
                        "id": 202072
                    }, {
                        "name": "上海美团地摊有限公司",
                        "id": 202073
                    }, {
                        "name": "北京小米新能源",
                        "id": 202074
                    }, {
                        "name": "香港平安芯片有限公司",
                        "id": 202075
                    }, {
                        "name": "北京亚马逊银行",
                        "id": 202076
                    }, {
                        "name": "台北星巴克科技有限公司",
                        "id": 202077
                    }]
                }, {
                    "name": "东莞华为",
                    "id": 202078
                }, {
                    "name": "杭州苹果地摊有限公司",
                    "id": 202079
                }, {
                    "name": "杭州快手汽车有限公司",
                    "id": 202080
                }, {
                    "name": "南京奈雪新能源",
                    "id": 202081
                }, {
                    "name": "天津腾讯信息服务",
                    "id": 202082
                }, {
                    "name": "纽约小米农业",
                    "id": 202083,
                    "children": [{
                        "name": "北京蚂蚁金融控股集团",
                        "id": 202084
                    }, {
                        "name": "南京奈雪证券",
                        "id": 202085
                    }, {
                        "name": "东莞腾讯牧业",
                        "id": 202086
                    }, {
                        "name": "杭州必胜客地产",
                        "id": 202087
                    }, {
                        "name": "南京蚂蚁旅游",
                        "id": 202088
                    }, {
                        "name": "东京星巴克农业控股集团",
                        "id": 202089
                    }, {
                        "name": "台北阿里计算机",
                        "id": 202090
                    }, {
                        "name": "杭州腾讯证券控股集团",
                        "id": 202091
                    }, {
                        "name": "东莞特斯拉诊所控股集团",
                        "id": 202092
                    }, {
                        "name": "天津肯德基石油",
                        "id": 202093
                    }, {
                        "name": "东莞微软金融",
                        "id": 202094
                    }, {
                        "name": "纽约阿里有限公司",
                        "id": 202095
                    }, {
                        "name": "南京谷歌银行",
                        "id": 202096
                    }, {
                        "name": "首尔微软医院",
                        "id": 202097
                    }, {
                        "name": "首尔喜茶医院",
                        "id": 202098
                    }, {
                        "name": "东京苹果诊所有限公司",
                        "id": 202099
                    }, {
                        "name": "上海必胜客航空控股集团",
                        "id": 202100
                    }, {
                        "name": "杭州喜茶诊所",
                        "id": 202101
                    }, {
                        "name": "东京滴滴制造控股集团",
                        "id": 202102
                    }, {
                        "name": "纽约蚂蚁通信",
                        "id": 202103
                    }, {
                        "name": "厦门美团汽车控股集团",
                        "id": 202104
                    }, {
                        "name": "南京亚马逊餐饮控股集团",
                        "id": 202105
                    }, {
                        "name": "深圳瑞幸通讯",
                        "id": 202106
                    }, {
                        "name": "厦门快手汽车",
                        "id": 202107
                    }, {
                        "name": "东莞平安智能有限公司",
                        "id": 202108
                    }, {
                        "name": "上海华为地产",
                        "id": 202109
                    }, {
                        "name": "首尔苹果信息服务",
                        "id": 202110
                    }, {
                        "name": "深圳平安科技控股集团",
                        "id": 202111
                    }]
                }, {
                    "name": "东京喜茶电商",
                    "id": 202112,
                    "children": [{
                        "name": "深圳奈雪金融控股集团",
                        "id": 202113
                    }, {
                        "name": "上海亚马逊软件",
                        "id": 202114
                    }, {
                        "name": "天津快手互金",
                        "id": 202115
                    }, {
                        "name": "香港瑞幸餐饮",
                        "id": 202116
                    }, {
                        "name": "广州平安银行",
                        "id": 202117
                    }, {
                        "name": "东莞美团有限公司",
                        "id": 202118
                    }, {
                        "name": "深圳肯德基电商",
                        "id": 202119
                    }, {
                        "name": "香港华为旅游",
                        "id": 202120
                    }]
                }, {
                    "name": "深圳喜茶基金控股集团",
                    "id": 202121
                }, {
                    "name": "北京奈雪餐饮有限公司",
                    "id": 202122
                }, {
                    "name": "广州阿里养殖",
                    "id": 202123
                }, {
                    "name": "东莞特斯拉诊所",
                    "id": 202124
                }, {
                    "name": "台北百度互金控股集团",
                    "id": 202125
                }, {
                    "name": "首尔欧珀汽车",
                    "id": 202126
                }, {
                    "name": "东莞必胜客地摊",
                    "id": 202127
                }, {
                    "name": "杭州肯德基医药",
                    "id": 202128
                }, {
                    "name": "深圳必胜客地摊",
                    "id": 202129
                }, {
                    "name": "东京肯德基证券",
                    "id": 202130
                }, {
                    "name": "南京字节智能",
                    "id": 202131
                }, {
                    "name": "广州喜茶农业",
                    "id": 202132
                }, {
                    "name": "北京蚂蚁芯片",
                    "id": 202133
                }, {
                    "name": "香港喜茶石油有限公司",
                    "id": 202134
                }, {
                    "name": "香港瑞幸有限公司",
                    "id": 202135
                }, {
                    "name": "广州平安科技有限公司",
                    "id": 202136,
                    "children": [{
                        "name": "首尔字节渔业",
                        "id": 202137
                    }, {
                        "name": "东京蚂蚁诊所控股集团",
                        "id": 202138
                    }, {
                        "name": "台北微软计算机有限公司",
                        "id": 202139
                    }, {
                        "name": "东京美团地产",
                        "id": 202140
                    }, {
                        "name": "纽约字节石油",
                        "id": 202141
                    }, {
                        "name": "深圳谷歌地摊控股集团",
                        "id": 202142
                    }, {
                        "name": "首尔奈雪电商",
                        "id": 202143
                    }, {
                        "name": "广州平安电商",
                        "id": 202144
                    }, {
                        "name": "南京喜茶诊所",
                        "id": 202145
                    }, {
                        "name": "台北华为新能源控股集团",
                        "id": 202146
                    }]
                }]
            }, {
                "name": "北京美团智能",
                "id": 202147,
                "children": [{
                    "name": "东莞亚马逊智能",
                    "id": 202148
                }, {
                    "name": "台北美团诊所控股集团",
                    "id": 202149,
                    "children": [{
                        "name": "厦门谷歌航空",
                        "id": 202150
                    }, {
                        "name": "深圳微软电商有限公司",
                        "id": 202151
                    }, {
                        "name": "厦门快手餐饮",
                        "id": 202152
                    }, {
                        "name": "杭州星巴克证券有限公司",
                        "id": 202153
                    }, {
                        "name": "上海小米金融",
                        "id": 202154
                    }, {
                        "name": "天津阿里航空控股集团",
                        "id": 202155
                    }, {
                        "name": "天津星巴克制造",
                        "id": 202156
                    }, {
                        "name": "广州腾讯银行控股集团",
                        "id": 202157
                    }, {
                        "name": "首尔肯德基地产",
                        "id": 202158
                    }, {
                        "name": "东莞亚马逊医药有限公司",
                        "id": 202159
                    }, {
                        "name": "上海京东科技有限公司",
                        "id": 202160
                    }, {
                        "name": "广州美团医院控股集团",
                        "id": 202161
                    }, {
                        "name": "南京蚂蚁旅游",
                        "id": 202162
                    }, {
                        "name": "上海星巴克通信",
                        "id": 202163
                    }, {
                        "name": "上海肯德基银行有限公司",
                        "id": 202164
                    }, {
                        "name": "深圳必胜客医药",
                        "id": 202165
                    }, {
                        "name": "杭州特斯拉养殖",
                        "id": 202166
                    }, {
                        "name": "东莞阿里软件",
                        "id": 202167
                    }, {
                        "name": "天津肯德基医院",
                        "id": 202168
                    }, {
                        "name": "东京必胜客金融",
                        "id": 202169
                    }, {
                        "name": "杭州小米科技",
                        "id": 202170
                    }, {
                        "name": "深圳平安银行控股集团",
                        "id": 202171
                    }, {
                        "name": "南京肯德基通讯",
                        "id": 202172
                    }, {
                        "name": "北京谷歌有限公司",
                        "id": 202173
                    }]
                }, {
                    "name": "广州滴滴",
                    "id": 202174
                }, {
                    "name": "北京欧珀医院",
                    "id": 202175
                }, {
                    "name": "天津必胜客地摊",
                    "id": 202176
                }, {
                    "name": "东莞平安诊所",
                    "id": 202177
                }, {
                    "name": "北京百度地摊",
                    "id": 202178
                }, {
                    "name": "纽约华为航空",
                    "id": 202179
                }, {
                    "name": "纽约华为通讯",
                    "id": 202180
                }, {
                    "name": "广州阿里医药",
                    "id": 202181
                }, {
                    "name": "厦门小米农业",
                    "id": 202182
                }, {
                    "name": "首尔谷歌制造",
                    "id": 202183
                }, {
                    "name": "杭州蚂蚁有限公司",
                    "id": 202184
                }, {
                    "name": "首尔瑞幸信息服务",
                    "id": 202185,
                    "children": [{
                        "name": "上海特斯拉养殖控股集团",
                        "id": 202186
                    }, {
                        "name": "首尔华为医院有限公司",
                        "id": 202187
                    }, {
                        "name": "杭州谷歌软件",
                        "id": 202188
                    }, {
                        "name": "南京肯德基航空控股集团",
                        "id": 202189
                    }, {
                        "name": "东京喜茶智能",
                        "id": 202190
                    }, {
                        "name": "东京喜茶石油有限公司",
                        "id": 202191
                    }, {
                        "name": "东莞欧珀信息服务",
                        "id": 202192
                    }, {
                        "name": "东莞肯德基餐饮",
                        "id": 202193
                    }, {
                        "name": "广州阿里通讯控股集团",
                        "id": 202194
                    }, {
                        "name": "首尔平安信息服务",
                        "id": 202195
                    }, {
                        "name": "深圳阿里旅游",
                        "id": 202196
                    }, {
                        "name": "南京谷歌芯片",
                        "id": 202197
                    }, {
                        "name": "东京特斯拉养殖",
                        "id": 202198
                    }, {
                        "name": "天津苹果医院有限公司",
                        "id": 202199
                    }, {
                        "name": "上海百度银行",
                        "id": 202200
                    }, {
                        "name": "天津必胜客信息服务",
                        "id": 202201
                    }, {
                        "name": "香港平安通讯",
                        "id": 202202
                    }, {
                        "name": "天津腾讯计算机控股集团",
                        "id": 202203
                    }, {
                        "name": "纽约京东通讯控股集团",
                        "id": 202204
                    }, {
                        "name": "北京滴滴互金",
                        "id": 202205
                    }, {
                        "name": "东京字节智能控股集团",
                        "id": 202206
                    }, {
                        "name": "纽约快手制造",
                        "id": 202207
                    }, {
                        "name": "香港必胜客医药",
                        "id": 202208
                    }, {
                        "name": "广州微软金融控股集团",
                        "id": 202209
                    }, {
                        "name": "南京瑞幸地产控股集团",
                        "id": 202210
                    }, {
                        "name": "上海京东通讯",
                        "id": 202211
                    }, {
                        "name": "香港小米科技有限公司",
                        "id": 202212
                    }, {
                        "name": "厦门腾讯金融控股集团",
                        "id": 202213
                    }, {
                        "name": "首尔小米",
                        "id": 202214
                    }, {
                        "name": "深圳肯德基金融",
                        "id": 202215
                    }, {
                        "name": "东京肯德基养殖有限公司",
                        "id": 202216
                    }, {
                        "name": "纽约快手汽车",
                        "id": 202217
                    }, {
                        "name": "深圳苹果农业",
                        "id": 202218
                    }]
                }, {
                    "name": "上海谷歌制造有限公司",
                    "id": 202219,
                    "children": [{
                        "name": "东京腾讯银行有限公司",
                        "id": 202220
                    }, {
                        "name": "杭州滴滴智能有限公司",
                        "id": 202221
                    }]
                }, {
                    "name": "杭州肯德基医药",
                    "id": 202222
                }, {
                    "name": "广州肯德基电商",
                    "id": 202223
                }, {
                    "name": "上海阿里银行控股集团",
                    "id": 202224
                }]
            }, {
                "name": "广州阿里智能",
                "id": 202225
            }, {
                "name": "东京京东",
                "id": 202226
            }, {
                "name": "上海奈雪芯片",
                "id": 202227
            }, {
                "name": "厦门喜茶计算机",
                "id": 202228
            }, {
                "name": "纽约苹果汽车",
                "id": 202229,
                "children": [{
                    "name": "广州百度牧业",
                    "id": 202230
                }, {
                    "name": "东莞百度养殖",
                    "id": 202231,
                    "children": [{
                        "name": "杭州快手智能",
                        "id": 202232
                    }, {
                        "name": "东莞腾讯牧业有限公司",
                        "id": 202233
                    }, {
                        "name": "首尔特斯拉芯片",
                        "id": 202234
                    }, {
                        "name": "厦门小米汽车有限公司",
                        "id": 202235
                    }, {
                        "name": "首尔亚马逊银行",
                        "id": 202236
                    }, {
                        "name": "厦门字节牧业有限公司",
                        "id": 202237
                    }, {
                        "name": "广州苹果计算机",
                        "id": 202238
                    }, {
                        "name": "北京快手金融",
                        "id": 202239
                    }, {
                        "name": "香港滴滴",
                        "id": 202240
                    }, {
                        "name": "南京谷歌诊所有限公司",
                        "id": 202241
                    }, {
                        "name": "广州京东牧业",
                        "id": 202242
                    }, {
                        "name": "南京特斯拉餐饮控股集团",
                        "id": 202243
                    }, {
                        "name": "厦门阿里科技",
                        "id": 202244
                    }, {
                        "name": "东莞蚂蚁牧业有限公司",
                        "id": 202245
                    }, {
                        "name": "上海微软电商",
                        "id": 202246
                    }, {
                        "name": "南京肯德基互金",
                        "id": 202247
                    }, {
                        "name": "纽约京东通讯",
                        "id": 202248
                    }, {
                        "name": "厦门肯德基通讯",
                        "id": 202249
                    }, {
                        "name": "深圳滴滴地摊",
                        "id": 202250
                    }, {
                        "name": "香港欧珀计算机",
                        "id": 202251
                    }, {
                        "name": "北京字节通信",
                        "id": 202252
                    }, {
                        "name": "南京蚂蚁电商",
                        "id": 202253
                    }, {
                        "name": "北京亚马逊计算机",
                        "id": 202254
                    }, {
                        "name": "广州必胜客地产",
                        "id": 202255
                    }, {
                        "name": "南京阿里餐饮",
                        "id": 202256
                    }, {
                        "name": "深圳滴滴医院",
                        "id": 202257
                    }, {
                        "name": "香港谷歌基金",
                        "id": 202258
                    }, {
                        "name": "杭州阿里通讯",
                        "id": 202259
                    }, {
                        "name": "厦门腾讯渔业有限公司",
                        "id": 202260
                    }, {
                        "name": "杭州苹果渔业",
                        "id": 202261
                    }, {
                        "name": "厦门美团通信控股集团",
                        "id": 202262
                    }, {
                        "name": "纽约腾讯地产",
                        "id": 202263
                    }, {
                        "name": "东莞欧珀",
                        "id": 202264
                    }]
                }, {
                    "name": "东京必胜客",
                    "id": 202265,
                    "children": [{
                        "name": "深圳美团通信",
                        "id": 202266
                    }, {
                        "name": "南京小米旅游",
                        "id": 202267
                    }, {
                        "name": "天津阿里金融",
                        "id": 202268
                    }, {
                        "name": "东莞快手科技控股集团",
                        "id": 202269
                    }, {
                        "name": "北京百度信息服务",
                        "id": 202270
                    }, {
                        "name": "首尔亚马逊基金",
                        "id": 202271
                    }, {
                        "name": "东莞小米渔业",
                        "id": 202272
                    }, {
                        "name": "台北京东地摊",
                        "id": 202273
                    }, {
                        "name": "杭州瑞幸计算机",
                        "id": 202274
                    }, {
                        "name": "天津阿里信息服务",
                        "id": 202275
                    }, {
                        "name": "东京快手银行",
                        "id": 202276
                    }, {
                        "name": "首尔蚂蚁",
                        "id": 202277
                    }, {
                        "name": "天津亚马逊医院",
                        "id": 202278
                    }, {
                        "name": "台北腾讯渔业",
                        "id": 202279
                    }, {
                        "name": "厦门特斯拉地产有限公司",
                        "id": 202280
                    }, {
                        "name": "广州瑞幸金融",
                        "id": 202281
                    }, {
                        "name": "广州美团航空",
                        "id": 202282
                    }, {
                        "name": "香港谷歌计算机控股集团",
                        "id": 202283
                    }, {
                        "name": "东京苹果智能",
                        "id": 202284
                    }, {
                        "name": "杭州美团基金有限公司",
                        "id": 202285
                    }, {
                        "name": "厦门必胜客金融控股集团",
                        "id": 202286
                    }, {
                        "name": "厦门阿里制造",
                        "id": 202287
                    }, {
                        "name": "厦门小米软件控股集团",
                        "id": 202288
                    }, {
                        "name": "南京美团智能",
                        "id": 202289
                    }, {
                        "name": "深圳蚂蚁互金",
                        "id": 202290
                    }, {
                        "name": "上海美团地产控股集团",
                        "id": 202291
                    }, {
                        "name": "东莞瑞幸证券",
                        "id": 202292
                    }, {
                        "name": "深圳百度医院",
                        "id": 202293
                    }, {
                        "name": "天津平安科技",
                        "id": 202294
                    }, {
                        "name": "天津小米医院有限公司",
                        "id": 202295
                    }, {
                        "name": "东莞小米汽车有限公司",
                        "id": 202296
                    }, {
                        "name": "南京阿里",
                        "id": 202297
                    }, {
                        "name": "天津谷歌证券",
                        "id": 202298
                    }, {
                        "name": "东莞平安芯片有限公司",
                        "id": 202299
                    }]
                }, {
                    "name": "台北字节通信",
                    "id": 202300,
                    "children": [{
                        "name": "北京阿里",
                        "id": 202301
                    }, {
                        "name": "北京美团软件",
                        "id": 202302
                    }, {
                        "name": "南京瑞幸计算机有限公司",
                        "id": 202303
                    }, {
                        "name": "厦门奈雪基金",
                        "id": 202304
                    }, {
                        "name": "上海肯德基医院",
                        "id": 202305
                    }, {
                        "name": "南京亚马逊医院有限公司",
                        "id": 202306
                    }, {
                        "name": "杭州阿里养殖",
                        "id": 202307
                    }, {
                        "name": "纽约小米通讯",
                        "id": 202308
                    }, {
                        "name": "南京字节互金控股集团",
                        "id": 202309
                    }, {
                        "name": "南京小米科技有限公司",
                        "id": 202310
                    }, {
                        "name": "天津星巴克科技",
                        "id": 202311
                    }, {
                        "name": "香港京东地产",
                        "id": 202312
                    }, {
                        "name": "南京蚂蚁诊所控股集团",
                        "id": 202313
                    }, {
                        "name": "天津必胜客软件",
                        "id": 202314
                    }, {
                        "name": "南京快手证券",
                        "id": 202315
                    }, {
                        "name": "香港亚马逊基金",
                        "id": 202316
                    }, {
                        "name": "天津奈雪旅游",
                        "id": 202317
                    }, {
                        "name": "天津欧珀通讯",
                        "id": 202318
                    }, {
                        "name": "东京肯德基控股集团",
                        "id": 202319
                    }]
                }, {
                    "name": "台北谷歌旅游控股集团",
                    "id": 202320
                }, {
                    "name": "香港喜茶石油",
                    "id": 202321
                }]
            }, {
                "name": "厦门滴滴航空",
                "id": 202322,
                "children": [{
                    "name": "南京喜茶芯片",
                    "id": 202323
                }, {
                    "name": "纽约喜茶有限公司",
                    "id": 202324
                }, {
                    "name": "天津华为农业",
                    "id": 202325
                }, {
                    "name": "纽约星巴克信息服务控股集团",
                    "id": 202326
                }, {
                    "name": "广州肯德基餐饮",
                    "id": 202327,
                    "children": [{
                        "name": "东京瑞幸有限公司",
                        "id": 202328
                    }, {
                        "name": "天津美团有限公司",
                        "id": 202329
                    }, {
                        "name": "广州奈雪控股集团",
                        "id": 202330
                    }, {
                        "name": "厦门小米金融控股集团",
                        "id": 202331
                    }, {
                        "name": "上海蚂蚁制造",
                        "id": 202332
                    }, {
                        "name": "广州阿里新能源",
                        "id": 202333
                    }, {
                        "name": "天津特斯拉基金",
                        "id": 202334
                    }, {
                        "name": "首尔喜茶制造",
                        "id": 202335
                    }, {
                        "name": "天津必胜客新能源",
                        "id": 202336
                    }, {
                        "name": "东莞亚马逊石油",
                        "id": 202337
                    }, {
                        "name": "首尔喜茶石油控股集团",
                        "id": 202338
                    }, {
                        "name": "杭州必胜客农业",
                        "id": 202339
                    }, {
                        "name": "深圳星巴克餐饮有限公司",
                        "id": 202340
                    }, {
                        "name": "北京亚马逊银行",
                        "id": 202341
                    }, {
                        "name": "杭州肯德基餐饮",
                        "id": 202342
                    }, {
                        "name": "首尔阿里证券控股集团",
                        "id": 202343
                    }, {
                        "name": "广州肯德基诊所",
                        "id": 202344
                    }, {
                        "name": "厦门京东医院",
                        "id": 202345
                    }, {
                        "name": "杭州肯德基科技",
                        "id": 202346
                    }]
                }, {
                    "name": "台北京东农业",
                    "id": 202347
                }, {
                    "name": "杭州平安制造有限公司",
                    "id": 202348
                }, {
                    "name": "香港肯德基医院",
                    "id": 202349,
                    "children": [{
                        "name": "天津喜茶",
                        "id": 202350
                    }, {
                        "name": "东莞微软农业",
                        "id": 202351
                    }, {
                        "name": "杭州阿里证券",
                        "id": 202352
                    }, {
                        "name": "首尔滴滴智能有限公司",
                        "id": 202353
                    }, {
                        "name": "广州快手软件有限公司",
                        "id": 202354
                    }, {
                        "name": "深圳必胜客芯片",
                        "id": 202355
                    }, {
                        "name": "南京华为地摊有限公司",
                        "id": 202356
                    }, {
                        "name": "杭州华为餐饮",
                        "id": 202357
                    }, {
                        "name": "北京百度医药有限公司",
                        "id": 202358
                    }, {
                        "name": "东京肯德基银行",
                        "id": 202359
                    }, {
                        "name": "天津滴滴银行控股集团",
                        "id": 202360
                    }, {
                        "name": "杭州必胜客地产控股集团",
                        "id": 202361
                    }, {
                        "name": "天津华为牧业",
                        "id": 202362
                    }, {
                        "name": "东京百度软件控股集团",
                        "id": 202363
                    }, {
                        "name": "深圳滴滴旅游",
                        "id": 202364
                    }, {
                        "name": "天津星巴克餐饮",
                        "id": 202365
                    }]
                }, {
                    "name": "上海必胜客地摊",
                    "id": 202366,
                    "children": [{
                        "name": "广州滴滴地摊",
                        "id": 202367
                    }, {
                        "name": "广州喜茶牧业控股集团",
                        "id": 202368
                    }, {
                        "name": "杭州腾讯航空",
                        "id": 202369
                    }, {
                        "name": "北京欧珀",
                        "id": 202370
                    }, {
                        "name": "广州微软信息服务",
                        "id": 202371
                    }, {
                        "name": "北京华为医院",
                        "id": 202372
                    }, {
                        "name": "东莞阿里养殖有限公司",
                        "id": 202373
                    }, {
                        "name": "南京快手电商",
                        "id": 202374
                    }, {
                        "name": "台北快手银行有限公司",
                        "id": 202375
                    }, {
                        "name": "北京小米计算机",
                        "id": 202376
                    }, {
                        "name": "东京必胜客",
                        "id": 202377
                    }, {
                        "name": "香港亚马逊软件",
                        "id": 202378
                    }, {
                        "name": "首尔肯德基",
                        "id": 202379
                    }, {
                        "name": "厦门必胜客地产",
                        "id": 202380
                    }, {
                        "name": "杭州字节新能源",
                        "id": 202381
                    }, {
                        "name": "厦门亚马逊银行",
                        "id": 202382
                    }, {
                        "name": "厦门必胜客诊所",
                        "id": 202383
                    }, {
                        "name": "深圳美团电商控股集团",
                        "id": 202384
                    }, {
                        "name": "香港亚马逊基金",
                        "id": 202385
                    }, {
                        "name": "东京奈雪航空有限公司",
                        "id": 202386
                    }, {
                        "name": "杭州快手汽车",
                        "id": 202387
                    }, {
                        "name": "北京美团通信控股集团",
                        "id": 202388
                    }, {
                        "name": "天津肯德基证券",
                        "id": 202389
                    }, {
                        "name": "广州阿里金融",
                        "id": 202390
                    }, {
                        "name": "杭州华为石油控股集团",
                        "id": 202391
                    }, {
                        "name": "广州字节软件",
                        "id": 202392
                    }, {
                        "name": "深圳亚马逊芯片",
                        "id": 202393
                    }, {
                        "name": "杭州小米",
                        "id": 202394
                    }, {
                        "name": "南京滴滴通讯",
                        "id": 202395
                    }, {
                        "name": "首尔平安互金",
                        "id": 202396
                    }, {
                        "name": "厦门瑞幸科技",
                        "id": 202397
                    }, {
                        "name": "广州特斯拉诊所控股集团",
                        "id": 202398
                    }, {
                        "name": "首尔瑞幸金融",
                        "id": 202399
                    }]
                }, {
                    "name": "纽约字节芯片",
                    "id": 202400
                }, {
                    "name": "南京奈雪医药",
                    "id": 202401
                }, {
                    "name": "广州快手新能源",
                    "id": 202402
                }, {
                    "name": "杭州快手银行有限公司",
                    "id": 202403
                }, {
                    "name": "南京小米计算机",
                    "id": 202404
                }, {
                    "name": "厦门滴滴基金",
                    "id": 202405
                }, {
                    "name": "杭州瑞幸科技",
                    "id": 202406,
                    "children": [{
                        "name": "东莞喜茶新能源",
                        "id": 202407
                    }, {
                        "name": "深圳星巴克新能源",
                        "id": 202408
                    }, {
                        "name": "台北蚂蚁地摊有限公司",
                        "id": 202409
                    }, {
                        "name": "台北快手软件有限公司",
                        "id": 202410
                    }, {
                        "name": "杭州字节电商",
                        "id": 202411
                    }, {
                        "name": "杭州阿里诊所",
                        "id": 202412
                    }, {
                        "name": "上海小米银行",
                        "id": 202413
                    }, {
                        "name": "深圳滴滴有限公司",
                        "id": 202414
                    }, {
                        "name": "上海肯德基医药",
                        "id": 202415
                    }, {
                        "name": "香港奈雪软件控股集团",
                        "id": 202416
                    }, {
                        "name": "杭州阿里渔业有限公司",
                        "id": 202417
                    }, {
                        "name": "杭州特斯拉新能源控股集团",
                        "id": 202418
                    }]
                }, {
                    "name": "首尔百度",
                    "id": 202419,
                    "children": [{
                        "name": "北京肯德基餐饮控股集团",
                        "id": 202420
                    }, {
                        "name": "东莞谷歌证券",
                        "id": 202421
                    }, {
                        "name": "深圳特斯拉计算机",
                        "id": 202422
                    }, {
                        "name": "北京腾讯软件",
                        "id": 202423
                    }, {
                        "name": "纽约字节通信",
                        "id": 202424
                    }, {
                        "name": "广州谷歌",
                        "id": 202425
                    }, {
                        "name": "厦门必胜客银行",
                        "id": 202426
                    }, {
                        "name": "香港欧珀地摊控股集团",
                        "id": 202427
                    }, {
                        "name": "纽约滴滴渔业控股集团",
                        "id": 202428
                    }, {
                        "name": "天津谷歌新能源",
                        "id": 202429
                    }, {
                        "name": "北京蚂蚁金融",
                        "id": 202430
                    }, {
                        "name": "杭州喜茶互金",
                        "id": 202431
                    }, {
                        "name": "东莞亚马逊金融控股集团",
                        "id": 202432
                    }, {
                        "name": "纽约谷歌通讯有限公司",
                        "id": 202433
                    }, {
                        "name": "纽约瑞幸医院",
                        "id": 202434
                    }, {
                        "name": "东莞滴滴地产",
                        "id": 202435
                    }, {
                        "name": "台北腾讯证券控股集团",
                        "id": 202436
                    }, {
                        "name": "广州华为软件",
                        "id": 202437
                    }, {
                        "name": "深圳星巴克证券有限公司",
                        "id": 202438
                    }, {
                        "name": "杭州瑞幸芯片控股集团",
                        "id": 202439
                    }]
                }, {
                    "name": "台北快手银行",
                    "id": 202440
                }, {
                    "name": "天津谷歌智能有限公司",
                    "id": 202441
                }, {
                    "name": "首尔字节基金",
                    "id": 202442,
                    "children": [{
                        "name": "香港平安诊所",
                        "id": 202443
                    }, {
                        "name": "上海平安牧业",
                        "id": 202444
                    }, {
                        "name": "东京欧珀航空有限公司",
                        "id": 202445
                    }, {
                        "name": "杭州苹果计算机",
                        "id": 202446
                    }, {
                        "name": "杭州腾讯通讯",
                        "id": 202447
                    }, {
                        "name": "香港字节旅游",
                        "id": 202448
                    }, {
                        "name": "厦门微软制造",
                        "id": 202449
                    }, {
                        "name": "东莞蚂蚁基金",
                        "id": 202450
                    }, {
                        "name": "东京京东科技",
                        "id": 202451
                    }, {
                        "name": "首尔滴滴计算机",
                        "id": 202452
                    }, {
                        "name": "纽约百度智能有限公司",
                        "id": 202453
                    }, {
                        "name": "台北华为制造",
                        "id": 202454
                    }, {
                        "name": "天津京东地产",
                        "id": 202455
                    }, {
                        "name": "天津微软银行",
                        "id": 202456
                    }, {
                        "name": "香港滴滴医院有限公司",
                        "id": 202457
                    }, {
                        "name": "杭州谷歌旅游",
                        "id": 202458
                    }, {
                        "name": "深圳瑞幸农业控股集团",
                        "id": 202459
                    }, {
                        "name": "首尔平安航空控股集团",
                        "id": 202460
                    }, {
                        "name": "厦门奈雪地摊",
                        "id": 202461
                    }, {
                        "name": "南京奈雪电商",
                        "id": 202462
                    }, {
                        "name": "杭州特斯拉基金控股集团",
                        "id": 202463
                    }, {
                        "name": "南京奈雪金融",
                        "id": 202464
                    }, {
                        "name": "北京字节软件有限公司",
                        "id": 202465
                    }, {
                        "name": "香港必胜客银行有限公司",
                        "id": 202466
                    }, {
                        "name": "东京平安科技",
                        "id": 202467
                    }, {
                        "name": "杭州小米计算机",
                        "id": 202468
                    }, {
                        "name": "首尔肯德基渔业控股集团",
                        "id": 202469
                    }]
                }, {
                    "name": "杭州蚂蚁石油",
                    "id": 202470
                }, {
                    "name": "深圳滴滴证券",
                    "id": 202471
                }, {
                    "name": "东莞亚马逊诊所",
                    "id": 202472
                }, {
                    "name": "深圳特斯拉农业有限公司",
                    "id": 202473
                }, {
                    "name": "东莞小米诊所",
                    "id": 202474
                }, {
                    "name": "杭州蚂蚁通讯",
                    "id": 202475,
                    "children": [{
                        "name": "杭州滴滴芯片",
                        "id": 202476
                    }, {
                        "name": "首尔百度旅游控股集团",
                        "id": 202477
                    }, {
                        "name": "深圳瑞幸旅游",
                        "id": 202478
                    }, {
                        "name": "东京小米新能源有限公司",
                        "id": 202479
                    }, {
                        "name": "广州肯德基通信",
                        "id": 202480
                    }, {
                        "name": "东京字节渔业",
                        "id": 202481
                    }, {
                        "name": "杭州快手智能",
                        "id": 202482
                    }, {
                        "name": "东京百度地产",
                        "id": 202483
                    }, {
                        "name": "深圳特斯拉通讯",
                        "id": 202484
                    }, {
                        "name": "北京欧珀渔业有限公司",
                        "id": 202485
                    }, {
                        "name": "纽约华为养殖控股集团",
                        "id": 202486
                    }, {
                        "name": "杭州奈雪芯片有限公司",
                        "id": 202487
                    }, {
                        "name": "台北美团通信",
                        "id": 202488
                    }, {
                        "name": "上海阿里科技",
                        "id": 202489
                    }, {
                        "name": "北京百度新能源有限公司",
                        "id": 202490
                    }, {
                        "name": "北京奈雪诊所",
                        "id": 202491
                    }, {
                        "name": "首尔美团金融",
                        "id": 202492
                    }, {
                        "name": "杭州必胜客信息服务",
                        "id": 202493
                    }, {
                        "name": "杭州平安医院控股集团",
                        "id": 202494
                    }, {
                        "name": "天津蚂蚁制造控股集团",
                        "id": 202495
                    }, {
                        "name": "杭州滴滴智能",
                        "id": 202496
                    }, {
                        "name": "香港百度牧业",
                        "id": 202497
                    }, {
                        "name": "广州特斯拉互金控股集团",
                        "id": 202498
                    }, {
                        "name": "杭州腾讯银行",
                        "id": 202499
                    }, {
                        "name": "香港字节基金",
                        "id": 202500
                    }, {
                        "name": "南京美团信息服务",
                        "id": 202501
                    }]
                }, {
                    "name": "东莞京东地摊有限公司",
                    "id": 202502
                }, {
                    "name": "台北肯德基智能",
                    "id": 202503
                }]
            }]
        }, {
            "name": "杭州腾讯信息服务",
            "id": 202504
        }, {
            "name": "广州字节石油",
            "id": 202505
        }, {
            "name": "东京快手金融",
            "id": 202506
        }, {
            "name": "台北亚马逊养殖有限公司",
            "id": 202507
        }, {
            "name": "上海谷歌制造控股集团",
            "id": 202508
        }, {
            "name": "厦门快手旅游",
            "id": 202509
        }, {
            "name": "广州谷歌",
            "id": 202510
        }, {
            "name": "天津亚马逊信息服务有限公司",
            "id": 202511
        }, {
            "name": "广州百度银行",
            "id": 202512,
            "children": [{
                "name": "东京快手石油有限公司",
                "id": 202513,
                "children": [{
                    "name": "天津欧珀医院",
                    "id": 202514
                }, {
                    "name": "广州瑞幸渔业",
                    "id": 202515
                }, {
                    "name": "东莞蚂蚁芯片控股集团",
                    "id": 202516
                }, {
                    "name": "深圳微软制造",
                    "id": 202517
                }, {
                    "name": "天津平安通讯",
                    "id": 202518,
                    "children": [{
                        "name": "深圳滴滴电商控股集团",
                        "id": 202519
                    }, {
                        "name": "首尔亚马逊软件控股集团",
                        "id": 202520
                    }, {
                        "name": "杭州欧珀智能控股集团",
                        "id": 202521
                    }, {
                        "name": "广州华为智能控股集团",
                        "id": 202522
                    }, {
                        "name": "纽约滴滴电商",
                        "id": 202523
                    }, {
                        "name": "广州奈雪互金",
                        "id": 202524
                    }, {
                        "name": "深圳京东",
                        "id": 202525
                    }, {
                        "name": "广州特斯拉软件",
                        "id": 202526
                    }, {
                        "name": "北京奈雪",
                        "id": 202527
                    }, {
                        "name": "纽约欧珀新能源",
                        "id": 202528
                    }, {
                        "name": "纽约谷歌汽车",
                        "id": 202529
                    }, {
                        "name": "南京快手互金",
                        "id": 202530
                    }, {
                        "name": "上海肯德基渔业",
                        "id": 202531
                    }]
                }, {
                    "name": "北京阿里医药",
                    "id": 202532,
                    "children": [{
                        "name": "杭州谷歌通信控股集团",
                        "id": 202533
                    }, {
                        "name": "杭州微软汽车",
                        "id": 202534
                    }, {
                        "name": "首尔必胜客信息服务",
                        "id": 202535
                    }]
                }, {
                    "name": "广州百度信息服务",
                    "id": 202536,
                    "children": [{
                        "name": "东京必胜客养殖有限公司",
                        "id": 202537
                    }, {
                        "name": "广州华为计算机有限公司",
                        "id": 202538
                    }, {
                        "name": "杭州苹果航空有限公司",
                        "id": 202539
                    }, {
                        "name": "香港肯德基地产有限公司",
                        "id": 202540
                    }, {
                        "name": "厦门必胜客科技",
                        "id": 202541
                    }, {
                        "name": "纽约谷歌养殖有限公司",
                        "id": 202542
                    }, {
                        "name": "深圳奈雪医药",
                        "id": 202543
                    }, {
                        "name": "香港必胜客",
                        "id": 202544
                    }, {
                        "name": "广州平安牧业",
                        "id": 202545
                    }, {
                        "name": "纽约腾讯科技",
                        "id": 202546
                    }, {
                        "name": "香港小米医院",
                        "id": 202547
                    }, {
                        "name": "东京肯德基医院",
                        "id": 202548
                    }, {
                        "name": "上海喜茶旅游",
                        "id": 202549
                    }, {
                        "name": "杭州平安",
                        "id": 202550
                    }, {
                        "name": "广州字节医院",
                        "id": 202551
                    }, {
                        "name": "杭州华为计算机",
                        "id": 202552
                    }, {
                        "name": "台北阿里渔业",
                        "id": 202553
                    }, {
                        "name": "广州苹果金融",
                        "id": 202554
                    }, {
                        "name": "东莞必胜客旅游",
                        "id": 202555
                    }, {
                        "name": "香港必胜客控股集团",
                        "id": 202556
                    }, {
                        "name": "上海瑞幸互金",
                        "id": 202557
                    }, {
                        "name": "上海阿里汽车有限公司",
                        "id": 202558
                    }, {
                        "name": "广州微软新能源",
                        "id": 202559
                    }, {
                        "name": "厦门谷歌芯片",
                        "id": 202560
                    }, {
                        "name": "香港腾讯有限公司",
                        "id": 202561
                    }, {
                        "name": "上海星巴克科技",
                        "id": 202562
                    }, {
                        "name": "杭州苹果航空",
                        "id": 202563
                    }, {
                        "name": "杭州小米航空",
                        "id": 202564
                    }, {
                        "name": "上海华为渔业控股集团",
                        "id": 202565
                    }, {
                        "name": "北京喜茶地产",
                        "id": 202566
                    }, {
                        "name": "东莞喜茶银行有限公司",
                        "id": 202567
                    }, {
                        "name": "天津快手医院",
                        "id": 202568
                    }, {
                        "name": "东京奈雪科技有限公司",
                        "id": 202569
                    }, {
                        "name": "杭州滴滴渔业",
                        "id": 202570
                    }, {
                        "name": "杭州小米石油",
                        "id": 202571
                    }]
                }, {
                    "name": "东莞欧珀金融",
                    "id": 202572
                }, {
                    "name": "东莞苹果地产有限公司",
                    "id": 202573,
                    "children": [{
                        "name": "杭州美团渔业",
                        "id": 202574
                    }, {
                        "name": "广州亚马逊信息服务",
                        "id": 202575
                    }, {
                        "name": "东莞美团石油",
                        "id": 202576
                    }, {
                        "name": "北京必胜客证券控股集团",
                        "id": 202577
                    }, {
                        "name": "首尔小米银行",
                        "id": 202578
                    }, {
                        "name": "广州平安诊所",
                        "id": 202579
                    }, {
                        "name": "杭州滴滴汽车",
                        "id": 202580
                    }, {
                        "name": "北京阿里养殖",
                        "id": 202581
                    }, {
                        "name": "纽约小米互金",
                        "id": 202582
                    }, {
                        "name": "纽约百度软件",
                        "id": 202583
                    }, {
                        "name": "东莞微软地产",
                        "id": 202584
                    }, {
                        "name": "南京华为银行",
                        "id": 202585
                    }, {
                        "name": "东莞小米制造",
                        "id": 202586
                    }, {
                        "name": "南京必胜客芯片控股集团",
                        "id": 202587
                    }, {
                        "name": "东京苹果芯片",
                        "id": 202588
                    }]
                }, {
                    "name": "东京星巴克",
                    "id": 202589,
                    "children": [{
                        "name": "杭州美团新能源",
                        "id": 202590
                    }, {
                        "name": "东莞必胜客计算机",
                        "id": 202591
                    }, {
                        "name": "台北肯德基",
                        "id": 202592
                    }, {
                        "name": "厦门平安通讯",
                        "id": 202593
                    }, {
                        "name": "北京华为养殖有限公司",
                        "id": 202594
                    }, {
                        "name": "东莞滴滴牧业控股集团",
                        "id": 202595
                    }, {
                        "name": "上海阿里电商",
                        "id": 202596
                    }, {
                        "name": "天津京东电商",
                        "id": 202597
                    }, {
                        "name": "天津瑞幸科技有限公司",
                        "id": 202598
                    }, {
                        "name": "天津星巴克计算机",
                        "id": 202599
                    }, {
                        "name": "北京蚂蚁旅游有限公司",
                        "id": 202600
                    }, {
                        "name": "北京瑞幸诊所有限公司",
                        "id": 202601
                    }, {
                        "name": "上海喜茶旅游控股集团",
                        "id": 202602
                    }, {
                        "name": "东京星巴克制造",
                        "id": 202603
                    }, {
                        "name": "东京欧珀养殖有限公司",
                        "id": 202604
                    }, {
                        "name": "首尔小米餐饮控股集团",
                        "id": 202605
                    }, {
                        "name": "杭州阿里软件控股集团",
                        "id": 202606
                    }, {
                        "name": "天津奈雪医院控股集团",
                        "id": 202607
                    }, {
                        "name": "首尔快手新能源控股集团",
                        "id": 202608
                    }]
                }, {
                    "name": "上海腾讯",
                    "id": 202609
                }, {
                    "name": "厦门必胜客农业",
                    "id": 202610
                }, {
                    "name": "天津特斯拉芯片",
                    "id": 202611
                }, {
                    "name": "首尔瑞幸餐饮",
                    "id": 202612
                }, {
                    "name": "杭州必胜客农业",
                    "id": 202613
                }, {
                    "name": "广州阿里芯片有限公司",
                    "id": 202614
                }, {
                    "name": "杭州奈雪金融",
                    "id": 202615
                }, {
                    "name": "天津华为",
                    "id": 202616
                }, {
                    "name": "杭州欧珀计算机",
                    "id": 202617,
                    "children": [{
                        "name": "香港华为银行控股集团",
                        "id": 202618
                    }, {
                        "name": "杭州必胜客餐饮",
                        "id": 202619
                    }, {
                        "name": "香港滴滴科技有限公司",
                        "id": 202620
                    }, {
                        "name": "台北亚马逊地摊",
                        "id": 202621
                    }, {
                        "name": "广州喜茶新能源有限公司",
                        "id": 202622
                    }, {
                        "name": "厦门特斯拉医院有限公司",
                        "id": 202623
                    }, {
                        "name": "南京美团养殖控股集团",
                        "id": 202624
                    }, {
                        "name": "上海欧珀计算机控股集团",
                        "id": 202625
                    }]
                }, {
                    "name": "台北小米石油控股集团",
                    "id": 202626
                }, {
                    "name": "香港快手软件",
                    "id": 202627
                }, {
                    "name": "台北滴滴汽车控股集团",
                    "id": 202628
                }, {
                    "name": "香港喜茶渔业",
                    "id": 202629,
                    "children": [{
                        "name": "广州小米牧业",
                        "id": 202630
                    }, {
                        "name": "厦门百度基金",
                        "id": 202631
                    }, {
                        "name": "南京奈雪基金",
                        "id": 202632
                    }, {
                        "name": "杭州阿里航空",
                        "id": 202633
                    }, {
                        "name": "东莞瑞幸农业控股集团",
                        "id": 202634
                    }, {
                        "name": "东莞特斯拉银行控股集团",
                        "id": 202635
                    }, {
                        "name": "天津字节石油",
                        "id": 202636
                    }, {
                        "name": "上海平安养殖有限公司",
                        "id": 202637
                    }, {
                        "name": "杭州微软科技",
                        "id": 202638
                    }, {
                        "name": "东京喜茶农业",
                        "id": 202639
                    }, {
                        "name": "东莞小米诊所",
                        "id": 202640
                    }]
                }, {
                    "name": "厦门蚂蚁航空",
                    "id": 202641,
                    "children": [{
                        "name": "杭州微软航空有限公司",
                        "id": 202642
                    }, {
                        "name": "杭州肯德基",
                        "id": 202643
                    }, {
                        "name": "纽约肯德基基金控股集团",
                        "id": 202644
                    }, {
                        "name": "首尔苹果有限公司",
                        "id": 202645
                    }, {
                        "name": "东莞滴滴信息服务",
                        "id": 202646
                    }, {
                        "name": "南京特斯拉互金有限公司",
                        "id": 202647
                    }, {
                        "name": "厦门亚马逊芯片",
                        "id": 202648
                    }, {
                        "name": "深圳星巴克餐饮控股集团",
                        "id": 202649
                    }, {
                        "name": "厦门瑞幸互金",
                        "id": 202650
                    }, {
                        "name": "南京肯德基银行",
                        "id": 202651
                    }, {
                        "name": "广州蚂蚁科技控股集团",
                        "id": 202652
                    }, {
                        "name": "首尔星巴克旅游",
                        "id": 202653
                    }, {
                        "name": "厦门快手",
                        "id": 202654
                    }, {
                        "name": "上海特斯拉信息服务",
                        "id": 202655
                    }, {
                        "name": "台北喜茶",
                        "id": 202656
                    }, {
                        "name": "香港肯德基地摊",
                        "id": 202657
                    }, {
                        "name": "上海美团渔业控股集团",
                        "id": 202658
                    }, {
                        "name": "纽约百度通信",
                        "id": 202659
                    }, {
                        "name": "杭州肯德基软件控股集团",
                        "id": 202660
                    }, {
                        "name": "厦门小米证券",
                        "id": 202661
                    }, {
                        "name": "杭州瑞幸有限公司",
                        "id": 202662
                    }, {
                        "name": "厦门必胜客芯片控股集团",
                        "id": 202663
                    }, {
                        "name": "东京滴滴金融",
                        "id": 202664
                    }, {
                        "name": "杭州滴滴有限公司",
                        "id": 202665
                    }, {
                        "name": "南京阿里汽车",
                        "id": 202666
                    }, {
                        "name": "东莞奈雪金融有限公司",
                        "id": 202667
                    }, {
                        "name": "南京瑞幸牧业",
                        "id": 202668
                    }, {
                        "name": "上海平安信息服务",
                        "id": 202669
                    }, {
                        "name": "深圳京东金融有限公司",
                        "id": 202670
                    }, {
                        "name": "纽约平安科技",
                        "id": 202671
                    }, {
                        "name": "杭州美团石油有限公司",
                        "id": 202672
                    }]
                }, {
                    "name": "厦门欧珀餐饮",
                    "id": 202673
                }, {
                    "name": "广州华为芯片",
                    "id": 202674
                }, {
                    "name": "北京华为诊所有限公司",
                    "id": 202675
                }, {
                    "name": "台北特斯拉软件",
                    "id": 202676
                }, {
                    "name": "杭州苹果金融",
                    "id": 202677
                }, {
                    "name": "杭州谷歌牧业",
                    "id": 202678,
                    "children": [{
                        "name": "东京谷歌软件",
                        "id": 202679
                    }, {
                        "name": "纽约奈雪地摊控股集团",
                        "id": 202680
                    }, {
                        "name": "纽约肯德基餐饮",
                        "id": 202681
                    }, {
                        "name": "广州百度金融",
                        "id": 202682
                    }, {
                        "name": "深圳星巴克农业",
                        "id": 202683
                    }, {
                        "name": "天津特斯拉新能源控股集团",
                        "id": 202684
                    }, {
                        "name": "东莞滴滴牧业有限公司",
                        "id": 202685
                    }, {
                        "name": "杭州快手汽车控股集团",
                        "id": 202686
                    }]
                }, {
                    "name": "南京喜茶银行",
                    "id": 202687
                }, {
                    "name": "上海美团有限公司",
                    "id": 202688
                }]
            }, {
                "name": "东莞亚马逊芯片",
                "id": 202689
            }, {
                "name": "上海小米计算机控股集团",
                "id": 202690,
                "children": [{
                    "name": "杭州阿里银行",
                    "id": 202691
                }, {
                    "name": "上海快手牧业",
                    "id": 202692,
                    "children": [{
                        "name": "东京星巴克通信",
                        "id": 202693
                    }, {
                        "name": "北京小米",
                        "id": 202694
                    }, {
                        "name": "东京必胜客基金控股集团",
                        "id": 202695
                    }, {
                        "name": "纽约欧珀医药控股集团",
                        "id": 202696
                    }, {
                        "name": "厦门苹果智能",
                        "id": 202697
                    }, {
                        "name": "广州小米证券",
                        "id": 202698
                    }, {
                        "name": "深圳肯德基软件控股集团",
                        "id": 202699
                    }, {
                        "name": "首尔瑞幸医院",
                        "id": 202700
                    }, {
                        "name": "北京欧珀渔业",
                        "id": 202701
                    }, {
                        "name": "上海特斯拉地产",
                        "id": 202702
                    }, {
                        "name": "天津欧珀控股集团",
                        "id": 202703
                    }, {
                        "name": "杭州字节地产",
                        "id": 202704
                    }, {
                        "name": "上海阿里通信控股集团",
                        "id": 202705
                    }, {
                        "name": "杭州字节地摊",
                        "id": 202706
                    }, {
                        "name": "杭州必胜客农业",
                        "id": 202707
                    }, {
                        "name": "广州蚂蚁医药有限公司",
                        "id": 202708
                    }, {
                        "name": "首尔蚂蚁科技控股集团",
                        "id": 202709
                    }, {
                        "name": "纽约特斯拉智能",
                        "id": 202710
                    }, {
                        "name": "杭州华为智能",
                        "id": 202711
                    }, {
                        "name": "杭州苹果",
                        "id": 202712
                    }, {
                        "name": "东京美团航空",
                        "id": 202713
                    }, {
                        "name": "南京亚马逊旅游控股集团",
                        "id": 202714
                    }, {
                        "name": "杭州肯德基基金",
                        "id": 202715
                    }]
                }, {
                    "name": "首尔苹果旅游",
                    "id": 202716
                }, {
                    "name": "香港阿里",
                    "id": 202717,
                    "children": [{
                        "name": "杭州必胜客制造控股集团",
                        "id": 202718
                    }, {
                        "name": "南京欧珀科技有限公司",
                        "id": 202719
                    }, {
                        "name": "台北微软通信有限公司",
                        "id": 202720
                    }, {
                        "name": "厦门欧珀芯片",
                        "id": 202721
                    }, {
                        "name": "首尔快手医院",
                        "id": 202722
                    }, {
                        "name": "东莞蚂蚁电商有限公司",
                        "id": 202723
                    }, {
                        "name": "天津苹果通讯",
                        "id": 202724
                    }, {
                        "name": "香港星巴克软件控股集团",
                        "id": 202725
                    }, {
                        "name": "天津蚂蚁科技",
                        "id": 202726
                    }, {
                        "name": "上海华为银行",
                        "id": 202727
                    }, {
                        "name": "天津喜茶石油控股集团",
                        "id": 202728
                    }, {
                        "name": "深圳奈雪智能控股集团",
                        "id": 202729
                    }, {
                        "name": "厦门快手通信控股集团",
                        "id": 202730
                    }, {
                        "name": "厦门阿里",
                        "id": 202731
                    }, {
                        "name": "杭州微软",
                        "id": 202732
                    }, {
                        "name": "首尔喜茶互金",
                        "id": 202733
                    }, {
                        "name": "深圳喜茶通讯控股集团",
                        "id": 202734
                    }, {
                        "name": "香港喜茶旅游",
                        "id": 202735
                    }, {
                        "name": "台北京东互金",
                        "id": 202736
                    }, {
                        "name": "首尔京东渔业",
                        "id": 202737
                    }, {
                        "name": "台北平安有限公司",
                        "id": 202738
                    }, {
                        "name": "厦门喜茶金融",
                        "id": 202739
                    }, {
                        "name": "香港滴滴金融控股集团",
                        "id": 202740
                    }, {
                        "name": "南京快手诊所控股集团",
                        "id": 202741
                    }, {
                        "name": "东京快手地摊",
                        "id": 202742
                    }, {
                        "name": "纽约欧珀旅游",
                        "id": 202743
                    }, {
                        "name": "杭州滴滴通讯",
                        "id": 202744
                    }]
                }, {
                    "name": "首尔苹果石油有限公司",
                    "id": 202745
                }, {
                    "name": "天津京东通信",
                    "id": 202746,
                    "children": [{
                        "name": "首尔谷歌旅游",
                        "id": 202747
                    }, {
                        "name": "台北微软渔业",
                        "id": 202748
                    }, {
                        "name": "天津星巴克证券",
                        "id": 202749
                    }, {
                        "name": "南京欧珀电商有限公司",
                        "id": 202750
                    }, {
                        "name": "首尔蚂蚁通讯控股集团",
                        "id": 202751
                    }, {
                        "name": "杭州特斯拉石油",
                        "id": 202752
                    }, {
                        "name": "东莞百度旅游",
                        "id": 202753
                    }, {
                        "name": "广州亚马逊有限公司",
                        "id": 202754
                    }, {
                        "name": "香港平安航空控股集团",
                        "id": 202755
                    }, {
                        "name": "广州喜茶渔业",
                        "id": 202756
                    }, {
                        "name": "厦门星巴克",
                        "id": 202757
                    }, {
                        "name": "杭州蚂蚁信息服务有限公司",
                        "id": 202758
                    }, {
                        "name": "天津滴滴医药控股集团",
                        "id": 202759
                    }, {
                        "name": "厦门腾讯计算机控股集团",
                        "id": 202760
                    }, {
                        "name": "厦门星巴克汽车控股集团",
                        "id": 202761
                    }, {
                        "name": "香港苹果养殖",
                        "id": 202762
                    }, {
                        "name": "天津必胜客医院有限公司",
                        "id": 202763
                    }, {
                        "name": "厦门谷歌银行",
                        "id": 202764
                    }, {
                        "name": "广州小米计算机",
                        "id": 202765
                    }, {
                        "name": "杭州腾讯医院",
                        "id": 202766
                    }, {
                        "name": "纽约亚马逊餐饮",
                        "id": 202767
                    }, {
                        "name": "台北星巴克通讯有限公司",
                        "id": 202768
                    }, {
                        "name": "东京必胜客汽车控股集团",
                        "id": 202769
                    }]
                }, {
                    "name": "厦门百度新能源",
                    "id": 202770,
                    "children": [{
                        "name": "首尔百度",
                        "id": 202771
                    }, {
                        "name": "纽约奈雪石油",
                        "id": 202772
                    }, {
                        "name": "香港字节航空",
                        "id": 202773
                    }, {
                        "name": "杭州华为牧业有限公司",
                        "id": 202774
                    }, {
                        "name": "台北滴滴餐饮",
                        "id": 202775
                    }, {
                        "name": "东莞特斯拉医院有限公司",
                        "id": 202776
                    }, {
                        "name": "杭州滴滴石油",
                        "id": 202777
                    }, {
                        "name": "深圳苹果新能源有限公司",
                        "id": 202778
                    }, {
                        "name": "杭州星巴克证券",
                        "id": 202779
                    }, {
                        "name": "东京滴滴金融",
                        "id": 202780
                    }, {
                        "name": "香港谷歌基金",
                        "id": 202781
                    }, {
                        "name": "香港蚂蚁餐饮有限公司",
                        "id": 202782
                    }, {
                        "name": "南京腾讯互金",
                        "id": 202783
                    }, {
                        "name": "东京奈雪",
                        "id": 202784
                    }, {
                        "name": "深圳滴滴农业控股集团",
                        "id": 202785
                    }, {
                        "name": "北京亚马逊通讯",
                        "id": 202786
                    }, {
                        "name": "杭州蚂蚁通讯",
                        "id": 202787
                    }, {
                        "name": "台北必胜客通信",
                        "id": 202788
                    }, {
                        "name": "纽约平安",
                        "id": 202789
                    }, {
                        "name": "南京星巴克",
                        "id": 202790
                    }, {
                        "name": "东莞特斯拉信息服务",
                        "id": 202791
                    }, {
                        "name": "东莞华为软件",
                        "id": 202792
                    }, {
                        "name": "东莞美团芯片有限公司",
                        "id": 202793
                    }, {
                        "name": "杭州阿里餐饮",
                        "id": 202794
                    }, {
                        "name": "杭州蚂蚁汽车",
                        "id": 202795
                    }, {
                        "name": "香港华为电商",
                        "id": 202796
                    }, {
                        "name": "东京亚马逊智能控股集团",
                        "id": 202797
                    }, {
                        "name": "北京特斯拉餐饮控股集团",
                        "id": 202798
                    }, {
                        "name": "东莞华为诊所",
                        "id": 202799
                    }, {
                        "name": "香港腾讯地摊",
                        "id": 202800
                    }, {
                        "name": "香港瑞幸地摊",
                        "id": 202801
                    }]
                }]
            }, {
                "name": "广州华为电商控股集团",
                "id": 202802
            }, {
                "name": "杭州美团医院",
                "id": 202803
            }, {
                "name": "台北欧珀",
                "id": 202804,
                "children": [{
                    "name": "深圳特斯拉地摊",
                    "id": 202805
                }, {
                    "name": "杭州美团地摊控股集团",
                    "id": 202806,
                    "children": [{
                        "name": "纽约小米",
                        "id": 202807
                    }, {
                        "name": "南京苹果新能源控股集团",
                        "id": 202808
                    }, {
                        "name": "杭州华为通讯",
                        "id": 202809
                    }, {
                        "name": "杭州腾讯金融",
                        "id": 202810
                    }, {
                        "name": "台北肯德基汽车有限公司",
                        "id": 202811
                    }, {
                        "name": "杭州腾讯软件有限公司",
                        "id": 202812
                    }, {
                        "name": "北京谷歌地产",
                        "id": 202813
                    }, {
                        "name": "东京肯德基航空",
                        "id": 202814
                    }, {
                        "name": "纽约必胜客养殖",
                        "id": 202815
                    }, {
                        "name": "北京亚马逊芯片有限公司",
                        "id": 202816
                    }, {
                        "name": "北京特斯拉电商有限公司",
                        "id": 202817
                    }, {
                        "name": "深圳滴滴智能",
                        "id": 202818
                    }, {
                        "name": "广州必胜客科技",
                        "id": 202819
                    }, {
                        "name": "纽约蚂蚁地摊",
                        "id": 202820
                    }, {
                        "name": "厦门平安",
                        "id": 202821
                    }, {
                        "name": "天津小米智能",
                        "id": 202822
                    }, {
                        "name": "台北平安控股集团",
                        "id": 202823
                    }, {
                        "name": "香港亚马逊渔业有限公司",
                        "id": 202824
                    }, {
                        "name": "香港华为地产有限公司",
                        "id": 202825
                    }, {
                        "name": "广州肯德基牧业控股集团",
                        "id": 202826
                    }, {
                        "name": "厦门小米互金",
                        "id": 202827
                    }, {
                        "name": "上海瑞幸",
                        "id": 202828
                    }, {
                        "name": "东京京东航空",
                        "id": 202829
                    }, {
                        "name": "杭州谷歌农业",
                        "id": 202830
                    }, {
                        "name": "南京美团控股集团",
                        "id": 202831
                    }, {
                        "name": "杭州欧珀养殖",
                        "id": 202832
                    }, {
                        "name": "台北欧珀旅游",
                        "id": 202833
                    }, {
                        "name": "东京小米诊所",
                        "id": 202834
                    }, {
                        "name": "天津谷歌渔业",
                        "id": 202835
                    }, {
                        "name": "北京苹果医药",
                        "id": 202836
                    }, {
                        "name": "香港京东牧业",
                        "id": 202837
                    }, {
                        "name": "天津微软餐饮",
                        "id": 202838
                    }]
                }, {
                    "name": "广州星巴克",
                    "id": 202839,
                    "children": [{
                        "name": "深圳特斯拉诊所",
                        "id": 202840
                    }, {
                        "name": "厦门小米诊所控股集团",
                        "id": 202841
                    }, {
                        "name": "南京京东金融有限公司",
                        "id": 202842
                    }, {
                        "name": "东莞亚马逊牧业",
                        "id": 202843
                    }, {
                        "name": "东莞特斯拉金融",
                        "id": 202844
                    }, {
                        "name": "上海星巴克控股集团",
                        "id": 202845
                    }, {
                        "name": "东京喜茶证券",
                        "id": 202846
                    }, {
                        "name": "上海美团石油",
                        "id": 202847
                    }, {
                        "name": "纽约欧珀渔业",
                        "id": 202848
                    }, {
                        "name": "深圳华为电商",
                        "id": 202849
                    }, {
                        "name": "北京蚂蚁计算机",
                        "id": 202850
                    }, {
                        "name": "上海星巴克医院",
                        "id": 202851
                    }, {
                        "name": "台北蚂蚁航空有限公司",
                        "id": 202852
                    }, {
                        "name": "南京特斯拉牧业",
                        "id": 202853
                    }, {
                        "name": "厦门欧珀金融",
                        "id": 202854
                    }, {
                        "name": "纽约美团软件",
                        "id": 202855
                    }, {
                        "name": "首尔欧珀石油",
                        "id": 202856
                    }, {
                        "name": "厦门百度科技",
                        "id": 202857
                    }, {
                        "name": "杭州肯德基汽车",
                        "id": 202858
                    }, {
                        "name": "深圳腾讯互金控股集团",
                        "id": 202859
                    }, {
                        "name": "东莞腾讯诊所有限公司",
                        "id": 202860
                    }, {
                        "name": "香港苹果汽车",
                        "id": 202861
                    }, {
                        "name": "东莞滴滴地产",
                        "id": 202862
                    }, {
                        "name": "深圳小米智能",
                        "id": 202863
                    }]
                }, {
                    "name": "南京滴滴牧业控股集团",
                    "id": 202864
                }, {
                    "name": "广州京东芯片",
                    "id": 202865
                }, {
                    "name": "杭州百度互金",
                    "id": 202866
                }, {
                    "name": "厦门星巴克电商",
                    "id": 202867
                }, {
                    "name": "香港美团通讯",
                    "id": 202868
                }, {
                    "name": "首尔美团餐饮",
                    "id": 202869
                }, {
                    "name": "南京喜茶软件控股集团",
                    "id": 202870
                }, {
                    "name": "厦门特斯拉证券",
                    "id": 202871
                }, {
                    "name": "台北蚂蚁诊所控股集团",
                    "id": 202872,
                    "children": [{
                        "name": "杭州星巴克汽车",
                        "id": 202873
                    }, {
                        "name": "广州奈雪牧业",
                        "id": 202874
                    }, {
                        "name": "天津亚马逊通讯有限公司",
                        "id": 202875
                    }, {
                        "name": "广州亚马逊诊所",
                        "id": 202876
                    }, {
                        "name": "广州喜茶诊所有限公司",
                        "id": 202877
                    }, {
                        "name": "纽约喜茶证券",
                        "id": 202878
                    }, {
                        "name": "深圳苹果航空",
                        "id": 202879
                    }, {
                        "name": "厦门苹果汽车有限公司",
                        "id": 202880
                    }, {
                        "name": "厦门京东汽车有限公司",
                        "id": 202881
                    }, {
                        "name": "东京喜茶",
                        "id": 202882
                    }, {
                        "name": "杭州百度通讯",
                        "id": 202883
                    }, {
                        "name": "杭州微软医药",
                        "id": 202884
                    }, {
                        "name": "首尔京东地摊",
                        "id": 202885
                    }, {
                        "name": "厦门谷歌芯片",
                        "id": 202886
                    }]
                }, {
                    "name": "东莞喜茶芯片有限公司",
                    "id": 202887
                }, {
                    "name": "纽约京东控股集团",
                    "id": 202888
                }, {
                    "name": "南京阿里诊所控股集团",
                    "id": 202889
                }, {
                    "name": "深圳喜茶通信",
                    "id": 202890
                }, {
                    "name": "南京快手智能",
                    "id": 202891
                }, {
                    "name": "天津奈雪通信",
                    "id": 202892
                }, {
                    "name": "杭州肯德基渔业",
                    "id": 202893
                }, {
                    "name": "东京星巴克新能源",
                    "id": 202894
                }, {
                    "name": "北京奈雪制造控股集团",
                    "id": 202895,
                    "children": [{
                        "name": "深圳字节信息服务",
                        "id": 202896
                    }, {
                        "name": "南京必胜客医院",
                        "id": 202897
                    }, {
                        "name": "深圳奈雪旅游有限公司",
                        "id": 202898
                    }]
                }, {
                    "name": "厦门奈雪餐饮控股集团",
                    "id": 202899
                }, {
                    "name": "首尔特斯拉银行",
                    "id": 202900
                }, {
                    "name": "纽约美团诊所有限公司",
                    "id": 202901
                }]
            }, {
                "name": "香港必胜客养殖",
                "id": 202902
            }, {
                "name": "南京苹果控股集团",
                "id": 202903
            }, {
                "name": "北京百度诊所",
                "id": 202904
            }, {
                "name": "深圳蚂蚁通讯",
                "id": 202905,
                "children": [{
                    "name": "东京快手农业有限公司",
                    "id": 202906
                }, {
                    "name": "香港必胜客旅游",
                    "id": 202907,
                    "children": [{
                        "name": "东莞苹果芯片",
                        "id": 202908
                    }, {
                        "name": "南京腾讯通讯有限公司",
                        "id": 202909
                    }, {
                        "name": "首尔特斯拉金融",
                        "id": 202910
                    }, {
                        "name": "杭州星巴克新能源",
                        "id": 202911
                    }, {
                        "name": "香港快手信息服务",
                        "id": 202912
                    }, {
                        "name": "上海腾讯医药",
                        "id": 202913
                    }, {
                        "name": "东京快手渔业",
                        "id": 202914
                    }, {
                        "name": "杭州京东地摊",
                        "id": 202915
                    }, {
                        "name": "南京瑞幸牧业",
                        "id": 202916
                    }, {
                        "name": "北京苹果地摊控股集团",
                        "id": 202917
                    }, {
                        "name": "广州小米石油",
                        "id": 202918
                    }, {
                        "name": "厦门字节医院控股集团",
                        "id": 202919
                    }, {
                        "name": "纽约百度银行",
                        "id": 202920
                    }, {
                        "name": "上海京东农业控股集团",
                        "id": 202921
                    }]
                }, {
                    "name": "纽约喜茶地产",
                    "id": 202922,
                    "children": [{
                        "name": "首尔特斯拉新能源",
                        "id": 202923
                    }, {
                        "name": "纽约美团制造控股集团",
                        "id": 202924
                    }, {
                        "name": "厦门蚂蚁基金",
                        "id": 202925
                    }, {
                        "name": "上海瑞幸渔业",
                        "id": 202926
                    }, {
                        "name": "北京星巴克电商有限公司",
                        "id": 202927
                    }, {
                        "name": "深圳美团地摊",
                        "id": 202928
                    }, {
                        "name": "天津小米医院",
                        "id": 202929
                    }, {
                        "name": "台北亚马逊科技有限公司",
                        "id": 202930
                    }, {
                        "name": "厦门快手餐饮控股集团",
                        "id": 202931
                    }, {
                        "name": "纽约肯德基证券",
                        "id": 202932
                    }, {
                        "name": "东莞星巴克互金",
                        "id": 202933
                    }, {
                        "name": "天津平安",
                        "id": 202934
                    }, {
                        "name": "深圳苹果有限公司",
                        "id": 202935
                    }, {
                        "name": "深圳苹果航空",
                        "id": 202936
                    }, {
                        "name": "纽约星巴克新能源",
                        "id": 202937
                    }, {
                        "name": "深圳平安汽车",
                        "id": 202938
                    }, {
                        "name": "杭州瑞幸金融",
                        "id": 202939
                    }, {
                        "name": "深圳欧珀电商有限公司",
                        "id": 202940
                    }, {
                        "name": "天津肯德基软件",
                        "id": 202941
                    }]
                }, {
                    "name": "厦门肯德基养殖",
                    "id": 202942,
                    "children": [{
                        "name": "杭州华为有限公司",
                        "id": 202943
                    }, {
                        "name": "天津瑞幸新能源控股集团",
                        "id": 202944
                    }, {
                        "name": "上海阿里新能源",
                        "id": 202945
                    }, {
                        "name": "厦门特斯拉牧业有限公司",
                        "id": 202946
                    }, {
                        "name": "南京百度诊所",
                        "id": 202947
                    }, {
                        "name": "杭州华为医院有限公司",
                        "id": 202948
                    }, {
                        "name": "香港腾讯软件控股集团",
                        "id": 202949
                    }, {
                        "name": "南京奈雪地产有限公司",
                        "id": 202950
                    }, {
                        "name": "纽约肯德基电商控股集团",
                        "id": 202951
                    }, {
                        "name": "首尔字节养殖",
                        "id": 202952
                    }, {
                        "name": "首尔亚马逊证券",
                        "id": 202953
                    }, {
                        "name": "杭州字节通讯",
                        "id": 202954
                    }, {
                        "name": "南京喜茶互金",
                        "id": 202955
                    }, {
                        "name": "广州欧珀科技有限公司",
                        "id": 202956
                    }, {
                        "name": "纽约小米",
                        "id": 202957
                    }, {
                        "name": "香港阿里基金",
                        "id": 202958
                    }, {
                        "name": "厦门星巴克汽车有限公司",
                        "id": 202959
                    }, {
                        "name": "广州腾讯智能",
                        "id": 202960
                    }, {
                        "name": "广州必胜客医院",
                        "id": 202961
                    }, {
                        "name": "杭州字节银行",
                        "id": 202962
                    }, {
                        "name": "广州亚马逊互金",
                        "id": 202963
                    }, {
                        "name": "纽约必胜客地摊控股集团",
                        "id": 202964
                    }, {
                        "name": "北京快手信息服务",
                        "id": 202965
                    }, {
                        "name": "南京亚马逊信息服务",
                        "id": 202966
                    }, {
                        "name": "香港百度",
                        "id": 202967
                    }, {
                        "name": "天津微软控股集团",
                        "id": 202968
                    }, {
                        "name": "纽约必胜客证券控股集团",
                        "id": 202969
                    }, {
                        "name": "南京蚂蚁通信",
                        "id": 202970
                    }, {
                        "name": "东莞欧珀智能",
                        "id": 202971
                    }, {
                        "name": "天津字节通讯",
                        "id": 202972
                    }, {
                        "name": "上海蚂蚁医药有限公司",
                        "id": 202973
                    }, {
                        "name": "杭州谷歌基金有限公司",
                        "id": 202974
                    }, {
                        "name": "纽约滴滴互金控股集团",
                        "id": 202975
                    }, {
                        "name": "广州喜茶养殖控股集团",
                        "id": 202976
                    }, {
                        "name": "东莞苹果通信",
                        "id": 202977
                    }]
                }, {
                    "name": "杭州特斯拉医院",
                    "id": 202978
                }, {
                    "name": "杭州平安智能",
                    "id": 202979
                }, {
                    "name": "天津百度新能源",
                    "id": 202980,
                    "children": [{
                        "name": "杭州平安制造有限公司",
                        "id": 202981
                    }, {
                        "name": "杭州平安餐饮",
                        "id": 202982
                    }, {
                        "name": "广州滴滴通讯有限公司",
                        "id": 202983
                    }, {
                        "name": "纽约百度诊所",
                        "id": 202984
                    }, {
                        "name": "杭州苹果农业",
                        "id": 202985
                    }, {
                        "name": "东京肯德基医院",
                        "id": 202986
                    }, {
                        "name": "南京苹果石油有限公司",
                        "id": 202987
                    }, {
                        "name": "香港滴滴智能",
                        "id": 202988
                    }, {
                        "name": "香港亚马逊通讯控股集团",
                        "id": 202989
                    }, {
                        "name": "东京奈雪银行",
                        "id": 202990
                    }, {
                        "name": "厦门瑞幸医药",
                        "id": 202991
                    }, {
                        "name": "天津奈雪汽车",
                        "id": 202992
                    }, {
                        "name": "香港微软牧业",
                        "id": 202993
                    }, {
                        "name": "香港小米软件控股集团",
                        "id": 202994
                    }, {
                        "name": "天津蚂蚁农业控股集团",
                        "id": 202995
                    }, {
                        "name": "深圳华为互金",
                        "id": 202996
                    }, {
                        "name": "南京蚂蚁信息服务",
                        "id": 202997
                    }, {
                        "name": "首尔肯德基石油有限公司",
                        "id": 202998
                    }, {
                        "name": "天津瑞幸地摊控股集团",
                        "id": 202999
                    }, {
                        "name": "杭州阿里航空",
                        "id": 203000
                    }, {
                        "name": "广州字节餐饮控股集团",
                        "id": 203001
                    }, {
                        "name": "广州京东",
                        "id": 203002
                    }, {
                        "name": "东莞滴滴地摊",
                        "id": 203003
                    }, {
                        "name": "东京星巴克互金",
                        "id": 203004
                    }, {
                        "name": "北京滴滴互金",
                        "id": 203005
                    }, {
                        "name": "深圳必胜客金融",
                        "id": 203006
                    }, {
                        "name": "纽约奈雪医院",
                        "id": 203007
                    }, {
                        "name": "天津华为航空",
                        "id": 203008
                    }, {
                        "name": "广州百度农业有限公司",
                        "id": 203009
                    }, {
                        "name": "天津喜茶通信",
                        "id": 203010
                    }, {
                        "name": "深圳小米牧业有限公司",
                        "id": 203011
                    }, {
                        "name": "北京小米基金",
                        "id": 203012
                    }]
                }, {
                    "name": "台北苹果旅游",
                    "id": 203013
                }, {
                    "name": "杭州平安",
                    "id": 203014
                }, {
                    "name": "东京奈雪地摊",
                    "id": 203015
                }, {
                    "name": "杭州字节软件控股集团",
                    "id": 203016
                }, {
                    "name": "纽约欧珀电商",
                    "id": 203017,
                    "children": [{
                        "name": "天津谷歌证券有限公司",
                        "id": 203018
                    }, {
                        "name": "上海谷歌通讯",
                        "id": 203019
                    }, {
                        "name": "台北快手地产",
                        "id": 203020
                    }, {
                        "name": "东莞微软通信控股集团",
                        "id": 203021
                    }, {
                        "name": "厦门喜茶信息服务有限公司",
                        "id": 203022
                    }, {
                        "name": "东莞特斯拉基金",
                        "id": 203023
                    }, {
                        "name": "广州阿里医药",
                        "id": 203024
                    }, {
                        "name": "杭州苹果",
                        "id": 203025
                    }, {
                        "name": "东京瑞幸医药控股集团",
                        "id": 203026
                    }, {
                        "name": "杭州特斯拉牧业有限公司",
                        "id": 203027
                    }, {
                        "name": "南京美团新能源",
                        "id": 203028
                    }, {
                        "name": "上海小米证券",
                        "id": 203029
                    }, {
                        "name": "天津星巴克",
                        "id": 203030
                    }, {
                        "name": "首尔星巴克石油",
                        "id": 203031
                    }, {
                        "name": "厦门字节航空",
                        "id": 203032
                    }, {
                        "name": "广州肯德基软件有限公司",
                        "id": 203033
                    }, {
                        "name": "天津欧珀证券",
                        "id": 203034
                    }, {
                        "name": "杭州瑞幸控股集团",
                        "id": 203035
                    }, {
                        "name": "台北星巴克有限公司",
                        "id": 203036
                    }, {
                        "name": "上海华为金融有限公司",
                        "id": 203037
                    }, {
                        "name": "纽约苹果芯片",
                        "id": 203038
                    }, {
                        "name": "南京特斯拉科技有限公司",
                        "id": 203039
                    }, {
                        "name": "厦门腾讯地产",
                        "id": 203040
                    }, {
                        "name": "台北奈雪地摊",
                        "id": 203041
                    }, {
                        "name": "厦门微软地摊有限公司",
                        "id": 203042
                    }, {
                        "name": "香港百度通讯",
                        "id": 203043
                    }, {
                        "name": "东莞必胜客地摊控股集团",
                        "id": 203044
                    }, {
                        "name": "台北亚马逊",
                        "id": 203045
                    }, {
                        "name": "纽约阿里芯片有限公司",
                        "id": 203046
                    }, {
                        "name": "东京腾讯旅游",
                        "id": 203047
                    }, {
                        "name": "杭州字节金融",
                        "id": 203048
                    }, {
                        "name": "杭州蚂蚁旅游",
                        "id": 203049
                    }, {
                        "name": "香港平安制造",
                        "id": 203050
                    }, {
                        "name": "天津谷歌汽车",
                        "id": 203051
                    }, {
                        "name": "天津蚂蚁石油有限公司",
                        "id": 203052
                    }]
                }, {
                    "name": "广州阿里餐饮有限公司",
                    "id": 203053
                }, {
                    "name": "广州滴滴餐饮",
                    "id": 203054
                }, {
                    "name": "厦门阿里航空有限公司",
                    "id": 203055
                }, {
                    "name": "南京奈雪石油",
                    "id": 203056,
                    "children": [{
                        "name": "首尔京东汽车有限公司",
                        "id": 203057
                    }, {
                        "name": "南京微软计算机",
                        "id": 203058
                    }, {
                        "name": "南京百度证券",
                        "id": 203059
                    }, {
                        "name": "东莞星巴克汽车",
                        "id": 203060
                    }, {
                        "name": "杭州华为基金",
                        "id": 203061
                    }, {
                        "name": "杭州腾讯",
                        "id": 203062
                    }, {
                        "name": "厦门星巴克制造",
                        "id": 203063
                    }, {
                        "name": "上海喜茶渔业",
                        "id": 203064
                    }, {
                        "name": "东莞特斯拉牧业",
                        "id": 203065
                    }, {
                        "name": "杭州腾讯汽车",
                        "id": 203066
                    }, {
                        "name": "天津欧珀石油",
                        "id": 203067
                    }, {
                        "name": "杭州字节石油控股集团",
                        "id": 203068
                    }, {
                        "name": "杭州华为通讯",
                        "id": 203069
                    }, {
                        "name": "深圳奈雪软件",
                        "id": 203070
                    }, {
                        "name": "台北字节渔业",
                        "id": 203071
                    }, {
                        "name": "东莞小米智能",
                        "id": 203072
                    }, {
                        "name": "台北腾讯通讯",
                        "id": 203073
                    }, {
                        "name": "南京阿里农业",
                        "id": 203074
                    }, {
                        "name": "厦门美团银行",
                        "id": 203075
                    }, {
                        "name": "首尔苹果芯片",
                        "id": 203076
                    }, {
                        "name": "纽约阿里通信有限公司",
                        "id": 203077
                    }, {
                        "name": "厦门快手养殖",
                        "id": 203078
                    }, {
                        "name": "深圳京东汽车",
                        "id": 203079
                    }, {
                        "name": "厦门瑞幸证券",
                        "id": 203080
                    }, {
                        "name": "北京奈雪银行",
                        "id": 203081
                    }, {
                        "name": "台北微软智能",
                        "id": 203082
                    }, {
                        "name": "南京微软医药有限公司",
                        "id": 203083
                    }, {
                        "name": "南京字节",
                        "id": 203084
                    }, {
                        "name": "纽约喜茶诊所",
                        "id": 203085
                    }, {
                        "name": "北京百度基金",
                        "id": 203086
                    }, {
                        "name": "东莞阿里",
                        "id": 203087
                    }, {
                        "name": "广州特斯拉地摊",
                        "id": 203088
                    }, {
                        "name": "东京蚂蚁基金控股集团",
                        "id": 203089
                    }, {
                        "name": "杭州肯德基渔业",
                        "id": 203090
                    }, {
                        "name": "台北肯德基",
                        "id": 203091
                    }, {
                        "name": "香港亚马逊农业控股集团",
                        "id": 203092
                    }]
                }, {
                    "name": "广州平安地产",
                    "id": 203093
                }, {
                    "name": "台北快手渔业有限公司",
                    "id": 203094
                }, {
                    "name": "纽约平安银行",
                    "id": 203095,
                    "children": [{
                        "name": "上海特斯拉金融",
                        "id": 203096
                    }, {
                        "name": "南京京东汽车控股集团",
                        "id": 203097
                    }, {
                        "name": "杭州华为信息服务有限公司",
                        "id": 203098
                    }, {
                        "name": "深圳快手航空",
                        "id": 203099
                    }, {
                        "name": "香港百度",
                        "id": 203100
                    }, {
                        "name": "东莞平安通讯",
                        "id": 203101
                    }, {
                        "name": "深圳特斯拉养殖",
                        "id": 203102
                    }, {
                        "name": "东京喜茶智能",
                        "id": 203103
                    }, {
                        "name": "杭州亚马逊软件控股集团",
                        "id": 203104
                    }, {
                        "name": "深圳必胜客养殖有限公司",
                        "id": 203105
                    }, {
                        "name": "杭州平安航空",
                        "id": 203106
                    }, {
                        "name": "上海平安银行",
                        "id": 203107
                    }, {
                        "name": "深圳奈雪医院有限公司",
                        "id": 203108
                    }, {
                        "name": "台北滴滴互金",
                        "id": 203109
                    }, {
                        "name": "深圳平安新能源控股集团",
                        "id": 203110
                    }, {
                        "name": "南京微软",
                        "id": 203111
                    }, {
                        "name": "纽约平安科技",
                        "id": 203112
                    }, {
                        "name": "厦门苹果金融有限公司",
                        "id": 203113
                    }, {
                        "name": "深圳谷歌芯片有限公司",
                        "id": 203114
                    }, {
                        "name": "纽约蚂蚁金融控股集团",
                        "id": 203115
                    }, {
                        "name": "上海京东",
                        "id": 203116
                    }, {
                        "name": "天津百度餐饮",
                        "id": 203117
                    }, {
                        "name": "香港京东控股集团",
                        "id": 203118
                    }, {
                        "name": "杭州蚂蚁计算机",
                        "id": 203119
                    }, {
                        "name": "北京阿里科技",
                        "id": 203120
                    }, {
                        "name": "香港必胜客航空",
                        "id": 203121
                    }, {
                        "name": "纽约谷歌互金",
                        "id": 203122
                    }, {
                        "name": "东莞百度电商",
                        "id": 203123
                    }, {
                        "name": "上海瑞幸餐饮",
                        "id": 203124
                    }, {
                        "name": "南京京东软件控股集团",
                        "id": 203125
                    }, {
                        "name": "广州滴滴智能控股集团",
                        "id": 203126
                    }, {
                        "name": "杭州小米",
                        "id": 203127
                    }, {
                        "name": "厦门滴滴电商",
                        "id": 203128
                    }, {
                        "name": "东莞微软牧业",
                        "id": 203129
                    }, {
                        "name": "纽约百度地摊",
                        "id": 203130
                    }, {
                        "name": "首尔美团基金",
                        "id": 203131
                    }]
                }, {
                    "name": "杭州谷歌医药控股集团",
                    "id": 203132
                }, {
                    "name": "天津喜茶渔业有限公司",
                    "id": 203133
                }]
            }, {
                "name": "台北百度通信",
                "id": 203134
            }, {
                "name": "纽约苹果通讯控股集团",
                "id": 203135
            }, {
                "name": "天津字节农业控股集团",
                "id": 203136
            }, {
                "name": "纽约京东地摊",
                "id": 203137
            }, {
                "name": "东京滴滴通讯",
                "id": 203138
            }, {
                "name": "杭州微软旅游",
                "id": 203139
            }, {
                "name": "厦门奈雪电商控股集团",
                "id": 203140
            }]
        }, {
            "name": "上海腾讯金融",
            "id": 203141
        }, {
            "name": "深圳奈雪芯片",
            "id": 203142
        }, {
            "name": "东莞字节科技",
            "id": 203143
        }, {
            "name": "纽约腾讯地摊",
            "id": 203144
        }, {
            "name": "香港奈雪通信控股集团",
            "id": 203145
        }, {
            "name": "厦门美团渔业",
            "id": 203146
        }, {
            "name": "天津瑞幸软件有限公司",
            "id": 203147
        }, {
            "name": "厦门瑞幸智能",
            "id": 203148
        }]
    }, {
        "name": "广州谷歌",
        "id": 203149,
        "children": [{
            "name": "香港美团银行",
            "id": 203150
        }, {
            "name": "天津蚂蚁信息服务",
            "id": 203151
        }, {
            "name": "北京微软互金",
            "id": 203152
        }, {
            "name": "杭州阿里诊所",
            "id": 203153,
            "children": [{
                "name": "南京快手农业",
                "id": 203154
            }, {
                "name": "北京肯德基地摊有限公司",
                "id": 203155
            }, {
                "name": "首尔亚马逊养殖",
                "id": 203156
            }, {
                "name": "广州蚂蚁养殖",
                "id": 203157
            }, {
                "name": "东莞星巴克",
                "id": 203158
            }, {
                "name": "上海特斯拉诊所有限公司",
                "id": 203159
            }, {
                "name": "广州微软互金",
                "id": 203160
            }, {
                "name": "首尔谷歌新能源",
                "id": 203161,
                "children": [{
                    "name": "杭州滴滴通讯",
                    "id": 203162
                }, {
                    "name": "北京苹果新能源",
                    "id": 203163
                }, {
                    "name": "南京美团软件有限公司",
                    "id": 203164
                }, {
                    "name": "深圳阿里制造",
                    "id": 203165,
                    "children": [{
                        "name": "广州滴滴航空控股集团",
                        "id": 203166
                    }, {
                        "name": "杭州阿里航空有限公司",
                        "id": 203167
                    }, {
                        "name": "杭州谷歌软件",
                        "id": 203168
                    }, {
                        "name": "南京百度银行",
                        "id": 203169
                    }, {
                        "name": "首尔瑞幸智能",
                        "id": 203170
                    }]
                }, {
                    "name": "纽约喜茶芯片控股集团",
                    "id": 203171,
                    "children": [{
                        "name": "东莞腾讯医药",
                        "id": 203172
                    }, {
                        "name": "厦门欧珀渔业有限公司",
                        "id": 203173
                    }, {
                        "name": "东莞肯德基银行",
                        "id": 203174
                    }, {
                        "name": "北京美团芯片",
                        "id": 203175
                    }, {
                        "name": "上海京东农业",
                        "id": 203176
                    }, {
                        "name": "上海肯德基通讯",
                        "id": 203177
                    }, {
                        "name": "厦门瑞幸科技",
                        "id": 203178
                    }, {
                        "name": "纽约华为石油",
                        "id": 203179
                    }]
                }, {
                    "name": "深圳美团金融",
                    "id": 203180
                }, {
                    "name": "纽约滴滴餐饮",
                    "id": 203181
                }, {
                    "name": "纽约小米医院",
                    "id": 203182
                }, {
                    "name": "东京微软诊所控股集团",
                    "id": 203183
                }, {
                    "name": "深圳喜茶证券",
                    "id": 203184
                }, {
                    "name": "天津小米互金",
                    "id": 203185,
                    "children": [{
                        "name": "首尔微软银行有限公司",
                        "id": 203186
                    }, {
                        "name": "厦门瑞幸证券有限公司",
                        "id": 203187
                    }, {
                        "name": "深圳百度证券",
                        "id": 203188
                    }, {
                        "name": "东莞亚马逊渔业控股集团",
                        "id": 203189
                    }, {
                        "name": "首尔美团芯片",
                        "id": 203190
                    }, {
                        "name": "台北美团餐饮",
                        "id": 203191
                    }, {
                        "name": "台北平安医药",
                        "id": 203192
                    }, {
                        "name": "北京腾讯芯片",
                        "id": 203193
                    }, {
                        "name": "东京肯德基芯片",
                        "id": 203194
                    }, {
                        "name": "香港百度餐饮",
                        "id": 203195
                    }, {
                        "name": "厦门美团农业",
                        "id": 203196
                    }, {
                        "name": "台北星巴克通信",
                        "id": 203197
                    }, {
                        "name": "东京腾讯芯片",
                        "id": 203198
                    }, {
                        "name": "广州必胜客基金",
                        "id": 203199
                    }, {
                        "name": "杭州华为医院",
                        "id": 203200
                    }, {
                        "name": "杭州星巴克医院",
                        "id": 203201
                    }, {
                        "name": "南京华为银行",
                        "id": 203202
                    }, {
                        "name": "北京阿里智能",
                        "id": 203203
                    }, {
                        "name": "广州平安汽车",
                        "id": 203204
                    }, {
                        "name": "台北美团互金",
                        "id": 203205
                    }, {
                        "name": "杭州奈雪计算机",
                        "id": 203206
                    }, {
                        "name": "香港蚂蚁电商",
                        "id": 203207
                    }, {
                        "name": "杭州谷歌智能控股集团",
                        "id": 203208
                    }, {
                        "name": "纽约微软通信",
                        "id": 203209
                    }, {
                        "name": "台北京东智能",
                        "id": 203210
                    }, {
                        "name": "纽约蚂蚁控股集团",
                        "id": 203211
                    }, {
                        "name": "南京字节石油控股集团",
                        "id": 203212
                    }, {
                        "name": "北京滴滴餐饮有限公司",
                        "id": 203213
                    }, {
                        "name": "纽约微软银行控股集团",
                        "id": 203214
                    }]
                }, {
                    "name": "天津喜茶证券有限公司",
                    "id": 203215
                }, {
                    "name": "南京京东旅游",
                    "id": 203216
                }, {
                    "name": "东莞美团电商有限公司",
                    "id": 203217,
                    "children": [{
                        "name": "深圳美团电商控股集团",
                        "id": 203218
                    }, {
                        "name": "广州特斯拉石油",
                        "id": 203219
                    }, {
                        "name": "天津京东芯片控股集团",
                        "id": 203220
                    }, {
                        "name": "杭州肯德基通信控股集团",
                        "id": 203221
                    }, {
                        "name": "上海美团航空",
                        "id": 203222
                    }, {
                        "name": "首尔喜茶计算机",
                        "id": 203223
                    }, {
                        "name": "杭州美团汽车",
                        "id": 203224
                    }, {
                        "name": "东京滴滴智能控股集团",
                        "id": 203225
                    }, {
                        "name": "杭州快手芯片",
                        "id": 203226
                    }, {
                        "name": "香港字节汽车有限公司",
                        "id": 203227
                    }, {
                        "name": "东京谷歌通讯控股集团",
                        "id": 203228
                    }, {
                        "name": "南京滴滴地产",
                        "id": 203229
                    }, {
                        "name": "首尔喜茶智能",
                        "id": 203230
                    }, {
                        "name": "杭州欧珀医院",
                        "id": 203231
                    }, {
                        "name": "杭州特斯拉制造",
                        "id": 203232
                    }, {
                        "name": "广州谷歌有限公司",
                        "id": 203233
                    }, {
                        "name": "天津肯德基养殖有限公司",
                        "id": 203234
                    }, {
                        "name": "上海美团制造",
                        "id": 203235
                    }, {
                        "name": "东京美团芯片",
                        "id": 203236
                    }, {
                        "name": "香港肯德基农业",
                        "id": 203237
                    }, {
                        "name": "香港谷歌",
                        "id": 203238
                    }, {
                        "name": "杭州特斯拉地摊",
                        "id": 203239
                    }, {
                        "name": "杭州京东软件",
                        "id": 203240
                    }, {
                        "name": "北京微软",
                        "id": 203241
                    }, {
                        "name": "杭州小米制造有限公司",
                        "id": 203242
                    }, {
                        "name": "杭州快手通信有限公司",
                        "id": 203243
                    }, {
                        "name": "杭州百度通讯",
                        "id": 203244
                    }]
                }, {
                    "name": "厦门奈雪养殖",
                    "id": 203245
                }, {
                    "name": "深圳美团基金控股集团",
                    "id": 203246,
                    "children": [{
                        "name": "深圳滴滴电商控股集团",
                        "id": 203247
                    }, {
                        "name": "厦门瑞幸医院",
                        "id": 203248
                    }, {
                        "name": "上海特斯拉芯片",
                        "id": 203249
                    }, {
                        "name": "首尔谷歌通信",
                        "id": 203250
                    }, {
                        "name": "东莞奈雪地摊控股集团",
                        "id": 203251
                    }, {
                        "name": "杭州美团有限公司",
                        "id": 203252
                    }, {
                        "name": "天津微软地产",
                        "id": 203253
                    }, {
                        "name": "首尔华为智能有限公司",
                        "id": 203254
                    }, {
                        "name": "厦门亚马逊互金",
                        "id": 203255
                    }, {
                        "name": "上海美团互金有限公司",
                        "id": 203256
                    }, {
                        "name": "纽约亚马逊计算机",
                        "id": 203257
                    }, {
                        "name": "厦门平安地摊",
                        "id": 203258
                    }, {
                        "name": "南京小米信息服务",
                        "id": 203259
                    }]
                }, {
                    "name": "深圳腾讯地摊控股集团",
                    "id": 203260
                }, {
                    "name": "北京瑞幸通信",
                    "id": 203261,
                    "children": [{
                        "name": "纽约星巴克餐饮",
                        "id": 203262
                    }, {
                        "name": "南京百度",
                        "id": 203263
                    }, {
                        "name": "南京星巴克智能",
                        "id": 203264
                    }, {
                        "name": "杭州欧珀养殖",
                        "id": 203265
                    }, {
                        "name": "南京星巴克牧业",
                        "id": 203266
                    }, {
                        "name": "南京蚂蚁",
                        "id": 203267
                    }, {
                        "name": "深圳阿里地摊",
                        "id": 203268
                    }, {
                        "name": "台北美团制造",
                        "id": 203269
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 203270
                    }, {
                        "name": "首尔蚂蚁渔业有限公司",
                        "id": 203271
                    }, {
                        "name": "广州快手基金",
                        "id": 203272
                    }, {
                        "name": "香港谷歌",
                        "id": 203273
                    }, {
                        "name": "深圳微软通讯有限公司",
                        "id": 203274
                    }, {
                        "name": "厦门小米医院有限公司",
                        "id": 203275
                    }, {
                        "name": "深圳星巴克",
                        "id": 203276
                    }, {
                        "name": "天津字节通讯",
                        "id": 203277
                    }, {
                        "name": "香港亚马逊证券",
                        "id": 203278
                    }, {
                        "name": "深圳微软计算机有限公司",
                        "id": 203279
                    }, {
                        "name": "杭州美团信息服务",
                        "id": 203280
                    }, {
                        "name": "厦门奈雪",
                        "id": 203281
                    }, {
                        "name": "香港腾讯",
                        "id": 203282
                    }, {
                        "name": "北京欧珀计算机",
                        "id": 203283
                    }, {
                        "name": "深圳平安汽车",
                        "id": 203284
                    }, {
                        "name": "杭州苹果地产",
                        "id": 203285
                    }, {
                        "name": "厦门喜茶通讯控股集团",
                        "id": 203286
                    }, {
                        "name": "台北星巴克地摊",
                        "id": 203287
                    }]
                }, {
                    "name": "首尔星巴克电商有限公司",
                    "id": 203288
                }, {
                    "name": "南京字节诊所有限公司",
                    "id": 203289,
                    "children": [{
                        "name": "天津微软航空",
                        "id": 203290
                    }, {
                        "name": "香港喜茶通讯",
                        "id": 203291
                    }, {
                        "name": "厦门百度",
                        "id": 203292
                    }, {
                        "name": "天津谷歌地产",
                        "id": 203293
                    }, {
                        "name": "东莞奈雪智能",
                        "id": 203294
                    }, {
                        "name": "香港蚂蚁牧业",
                        "id": 203295
                    }, {
                        "name": "纽约欧珀有限公司",
                        "id": 203296
                    }, {
                        "name": "东京小米",
                        "id": 203297
                    }, {
                        "name": "天津谷歌医药",
                        "id": 203298
                    }, {
                        "name": "纽约亚马逊航空",
                        "id": 203299
                    }, {
                        "name": "东莞阿里汽车控股集团",
                        "id": 203300
                    }, {
                        "name": "首尔滴滴",
                        "id": 203301
                    }, {
                        "name": "东京欧珀基金",
                        "id": 203302
                    }, {
                        "name": "东莞奈雪通信",
                        "id": 203303
                    }, {
                        "name": "东京小米制造",
                        "id": 203304
                    }, {
                        "name": "深圳欧珀软件",
                        "id": 203305
                    }, {
                        "name": "广州瑞幸牧业",
                        "id": 203306
                    }, {
                        "name": "北京微软汽车有限公司",
                        "id": 203307
                    }, {
                        "name": "东京蚂蚁软件",
                        "id": 203308
                    }, {
                        "name": "杭州喜茶智能",
                        "id": 203309
                    }, {
                        "name": "广州快手控股集团",
                        "id": 203310
                    }, {
                        "name": "天津百度石油",
                        "id": 203311
                    }, {
                        "name": "广州腾讯金融",
                        "id": 203312
                    }, {
                        "name": "厦门亚马逊渔业",
                        "id": 203313
                    }, {
                        "name": "深圳平安证券",
                        "id": 203314
                    }, {
                        "name": "首尔必胜客软件",
                        "id": 203315
                    }, {
                        "name": "东莞星巴克农业有限公司",
                        "id": 203316
                    }, {
                        "name": "香港谷歌渔业",
                        "id": 203317
                    }, {
                        "name": "杭州瑞幸汽车控股集团",
                        "id": 203318
                    }, {
                        "name": "广州阿里基金",
                        "id": 203319
                    }, {
                        "name": "深圳瑞幸有限公司",
                        "id": 203320
                    }, {
                        "name": "厦门苹果诊所",
                        "id": 203321
                    }, {
                        "name": "杭州小米石油控股集团",
                        "id": 203322
                    }]
                }, {
                    "name": "杭州京东渔业有限公司",
                    "id": 203323
                }, {
                    "name": "东莞蚂蚁养殖",
                    "id": 203324
                }, {
                    "name": "杭州滴滴农业控股集团",
                    "id": 203325
                }]
            }, {
                "name": "深圳奈雪科技有限公司",
                "id": 203326
            }, {
                "name": "杭州阿里医药",
                "id": 203327,
                "children": [{
                    "name": "首尔蚂蚁地摊",
                    "id": 203328
                }, {
                    "name": "杭州蚂蚁旅游",
                    "id": 203329,
                    "children": [{
                        "name": "首尔阿里",
                        "id": 203330
                    }, {
                        "name": "上海欧珀新能源有限公司",
                        "id": 203331
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 203332
                    }, {
                        "name": "厦门奈雪科技",
                        "id": 203333
                    }, {
                        "name": "杭州奈雪有限公司",
                        "id": 203334
                    }, {
                        "name": "香港小米新能源有限公司",
                        "id": 203335
                    }, {
                        "name": "东京美团有限公司",
                        "id": 203336
                    }, {
                        "name": "纽约必胜客餐饮有限公司",
                        "id": 203337
                    }, {
                        "name": "深圳谷歌通讯",
                        "id": 203338
                    }, {
                        "name": "上海必胜客",
                        "id": 203339
                    }, {
                        "name": "首尔苹果养殖",
                        "id": 203340
                    }, {
                        "name": "天津小米通信",
                        "id": 203341
                    }, {
                        "name": "上海必胜客计算机",
                        "id": 203342
                    }, {
                        "name": "南京美团基金有限公司",
                        "id": 203343
                    }, {
                        "name": "上海腾讯牧业",
                        "id": 203344
                    }, {
                        "name": "杭州蚂蚁地产",
                        "id": 203345
                    }, {
                        "name": "东京特斯拉养殖",
                        "id": 203346
                    }, {
                        "name": "上海快手石油控股集团",
                        "id": 203347
                    }, {
                        "name": "香港阿里科技",
                        "id": 203348
                    }]
                }, {
                    "name": "杭州百度新能源",
                    "id": 203349
                }, {
                    "name": "深圳谷歌计算机",
                    "id": 203350
                }, {
                    "name": "首尔欧珀旅游",
                    "id": 203351
                }, {
                    "name": "东京喜茶证券",
                    "id": 203352
                }, {
                    "name": "杭州必胜客互金",
                    "id": 203353
                }, {
                    "name": "广州必胜客牧业有限公司",
                    "id": 203354
                }, {
                    "name": "厦门欧珀医院",
                    "id": 203355,
                    "children": [{
                        "name": "厦门滴滴通讯",
                        "id": 203356
                    }]
                }, {
                    "name": "深圳滴滴旅游控股集团",
                    "id": 203357
                }, {
                    "name": "纽约华为航空",
                    "id": 203358
                }, {
                    "name": "杭州滴滴通信",
                    "id": 203359
                }, {
                    "name": "东京特斯拉石油",
                    "id": 203360
                }, {
                    "name": "上海特斯拉银行",
                    "id": 203361,
                    "children": [{
                        "name": "台北美团有限公司",
                        "id": 203362
                    }, {
                        "name": "首尔百度基金控股集团",
                        "id": 203363
                    }, {
                        "name": "天津百度旅游",
                        "id": 203364
                    }, {
                        "name": "纽约特斯拉控股集团",
                        "id": 203365
                    }, {
                        "name": "台北华为芯片控股集团",
                        "id": 203366
                    }, {
                        "name": "纽约谷歌农业",
                        "id": 203367
                    }, {
                        "name": "杭州苹果通信",
                        "id": 203368
                    }, {
                        "name": "台北特斯拉汽车",
                        "id": 203369
                    }, {
                        "name": "北京特斯拉牧业",
                        "id": 203370
                    }, {
                        "name": "厦门必胜客",
                        "id": 203371
                    }, {
                        "name": "香港肯德基渔业",
                        "id": 203372
                    }, {
                        "name": "天津肯德基农业",
                        "id": 203373
                    }, {
                        "name": "南京字节养殖",
                        "id": 203374
                    }, {
                        "name": "杭州滴滴证券",
                        "id": 203375
                    }, {
                        "name": "厦门华为航空",
                        "id": 203376
                    }, {
                        "name": "上海京东信息服务有限公司",
                        "id": 203377
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 203378
                    }, {
                        "name": "首尔平安地产控股集团",
                        "id": 203379
                    }, {
                        "name": "上海谷歌证券",
                        "id": 203380
                    }, {
                        "name": "北京字节新能源",
                        "id": 203381
                    }, {
                        "name": "杭州京东基金控股集团",
                        "id": 203382
                    }, {
                        "name": "东京肯德基",
                        "id": 203383
                    }]
                }, {
                    "name": "广州京东医药",
                    "id": 203384
                }, {
                    "name": "首尔必胜客计算机",
                    "id": 203385
                }, {
                    "name": "上海苹果农业有限公司",
                    "id": 203386,
                    "children": [{
                        "name": "厦门特斯拉控股集团",
                        "id": 203387
                    }, {
                        "name": "东京华为石油",
                        "id": 203388
                    }, {
                        "name": "北京必胜客新能源",
                        "id": 203389
                    }, {
                        "name": "台北星巴克航空",
                        "id": 203390
                    }, {
                        "name": "香港快手基金有限公司",
                        "id": 203391
                    }, {
                        "name": "东京亚马逊",
                        "id": 203392
                    }, {
                        "name": "北京星巴克计算机有限公司",
                        "id": 203393
                    }, {
                        "name": "北京欧珀地产有限公司",
                        "id": 203394
                    }, {
                        "name": "香港谷歌渔业",
                        "id": 203395
                    }, {
                        "name": "台北喜茶航空控股集团",
                        "id": 203396
                    }, {
                        "name": "南京百度医药",
                        "id": 203397
                    }, {
                        "name": "首尔苹果信息服务",
                        "id": 203398
                    }, {
                        "name": "杭州百度地产控股集团",
                        "id": 203399
                    }, {
                        "name": "北京谷歌牧业控股集团",
                        "id": 203400
                    }, {
                        "name": "上海苹果养殖控股集团",
                        "id": 203401
                    }, {
                        "name": "纽约星巴克航空",
                        "id": 203402
                    }, {
                        "name": "台北平安",
                        "id": 203403
                    }, {
                        "name": "北京滴滴金融",
                        "id": 203404
                    }, {
                        "name": "杭州平安航空",
                        "id": 203405
                    }, {
                        "name": "杭州喜茶牧业",
                        "id": 203406
                    }, {
                        "name": "东京微软证券控股集团",
                        "id": 203407
                    }, {
                        "name": "广州蚂蚁计算机有限公司",
                        "id": 203408
                    }, {
                        "name": "深圳亚马逊汽车",
                        "id": 203409
                    }, {
                        "name": "东京华为地产",
                        "id": 203410
                    }, {
                        "name": "天津百度银行控股集团",
                        "id": 203411
                    }, {
                        "name": "东莞美团医药",
                        "id": 203412
                    }, {
                        "name": "北京瑞幸互金控股集团",
                        "id": 203413
                    }, {
                        "name": "东莞快手有限公司",
                        "id": 203414
                    }, {
                        "name": "香港星巴克制造有限公司",
                        "id": 203415
                    }, {
                        "name": "首尔星巴克地摊",
                        "id": 203416
                    }, {
                        "name": "台北滴滴",
                        "id": 203417
                    }, {
                        "name": "东京蚂蚁渔业",
                        "id": 203418
                    }, {
                        "name": "北京特斯拉智能",
                        "id": 203419
                    }, {
                        "name": "上海腾讯牧业",
                        "id": 203420
                    }, {
                        "name": "首尔百度医院有限公司",
                        "id": 203421
                    }]
                }, {
                    "name": "杭州小米渔业",
                    "id": 203422
                }, {
                    "name": "广州京东控股集团",
                    "id": 203423,
                    "children": [{
                        "name": "东京必胜客地摊有限公司",
                        "id": 203424
                    }, {
                        "name": "香港瑞幸金融控股集团",
                        "id": 203425
                    }, {
                        "name": "北京京东渔业有限公司",
                        "id": 203426
                    }, {
                        "name": "北京奈雪智能",
                        "id": 203427
                    }, {
                        "name": "杭州苹果旅游",
                        "id": 203428
                    }]
                }, {
                    "name": "广州欧珀银行",
                    "id": 203429
                }, {
                    "name": "纽约肯德基制造",
                    "id": 203430
                }, {
                    "name": "首尔美团地产控股集团",
                    "id": 203431
                }, {
                    "name": "深圳平安地产",
                    "id": 203432
                }, {
                    "name": "厦门欧珀医院",
                    "id": 203433,
                    "children": [{
                        "name": "东莞谷歌餐饮有限公司",
                        "id": 203434
                    }, {
                        "name": "上海腾讯渔业有限公司",
                        "id": 203435
                    }, {
                        "name": "首尔阿里石油",
                        "id": 203436
                    }, {
                        "name": "东京阿里",
                        "id": 203437
                    }, {
                        "name": "香港肯德基诊所有限公司",
                        "id": 203438
                    }, {
                        "name": "纽约瑞幸有限公司",
                        "id": 203439
                    }, {
                        "name": "首尔蚂蚁智能",
                        "id": 203440
                    }, {
                        "name": "南京阿里科技有限公司",
                        "id": 203441
                    }, {
                        "name": "台北奈雪诊所",
                        "id": 203442
                    }, {
                        "name": "北京瑞幸银行",
                        "id": 203443
                    }, {
                        "name": "广州喜茶养殖有限公司",
                        "id": 203444
                    }, {
                        "name": "首尔蚂蚁银行",
                        "id": 203445
                    }, {
                        "name": "杭州百度渔业",
                        "id": 203446
                    }, {
                        "name": "广州百度旅游",
                        "id": 203447
                    }, {
                        "name": "台北快手医药",
                        "id": 203448
                    }, {
                        "name": "天津腾讯新能源",
                        "id": 203449
                    }, {
                        "name": "杭州字节计算机控股集团",
                        "id": 203450
                    }, {
                        "name": "东莞奈雪制造",
                        "id": 203451
                    }, {
                        "name": "天津华为芯片",
                        "id": 203452
                    }, {
                        "name": "香港谷歌芯片",
                        "id": 203453
                    }, {
                        "name": "南京奈雪地摊",
                        "id": 203454
                    }, {
                        "name": "深圳亚马逊证券",
                        "id": 203455
                    }, {
                        "name": "北京华为通讯",
                        "id": 203456
                    }, {
                        "name": "天津奈雪养殖",
                        "id": 203457
                    }, {
                        "name": "台北华为制造",
                        "id": 203458
                    }, {
                        "name": "香港小米医药",
                        "id": 203459
                    }, {
                        "name": "深圳肯德基金融",
                        "id": 203460
                    }, {
                        "name": "深圳滴滴地摊",
                        "id": 203461
                    }, {
                        "name": "纽约腾讯诊所",
                        "id": 203462
                    }, {
                        "name": "纽约华为通信",
                        "id": 203463
                    }, {
                        "name": "首尔腾讯",
                        "id": 203464
                    }, {
                        "name": "东京谷歌证券",
                        "id": 203465
                    }, {
                        "name": "北京苹果新能源",
                        "id": 203466
                    }, {
                        "name": "北京奈雪证券",
                        "id": 203467
                    }, {
                        "name": "首尔腾讯银行控股集团",
                        "id": 203468
                    }, {
                        "name": "杭州快手养殖",
                        "id": 203469
                    }]
                }, {
                    "name": "深圳小米信息服务有限公司",
                    "id": 203470,
                    "children": [{
                        "name": "纽约华为科技",
                        "id": 203471
                    }, {
                        "name": "东京美团石油",
                        "id": 203472
                    }, {
                        "name": "香港欧珀科技控股集团",
                        "id": 203473
                    }, {
                        "name": "纽约必胜客通讯",
                        "id": 203474
                    }, {
                        "name": "纽约华为通信有限公司",
                        "id": 203475
                    }, {
                        "name": "首尔华为渔业",
                        "id": 203476
                    }, {
                        "name": "纽约奈雪旅游",
                        "id": 203477
                    }, {
                        "name": "天津谷歌金融",
                        "id": 203478
                    }, {
                        "name": "纽约蚂蚁地摊",
                        "id": 203479
                    }, {
                        "name": "香港华为石油有限公司",
                        "id": 203480
                    }, {
                        "name": "纽约喜茶牧业有限公司",
                        "id": 203481
                    }, {
                        "name": "杭州蚂蚁通讯",
                        "id": 203482
                    }]
                }, {
                    "name": "杭州美团金融控股集团",
                    "id": 203483
                }]
            }, {
                "name": "南京小米汽车",
                "id": 203484
            }, {
                "name": "杭州喜茶电商有限公司",
                "id": 203485
            }, {
                "name": "深圳阿里航空控股集团",
                "id": 203486,
                "children": [{
                    "name": "上海谷歌渔业控股集团",
                    "id": 203487
                }, {
                    "name": "东莞肯德基牧业有限公司",
                    "id": 203488,
                    "children": [{
                        "name": "广州京东航空",
                        "id": 203489
                    }, {
                        "name": "杭州谷歌证券",
                        "id": 203490
                    }, {
                        "name": "东京华为金融",
                        "id": 203491
                    }, {
                        "name": "香港蚂蚁科技",
                        "id": 203492
                    }, {
                        "name": "北京奈雪智能",
                        "id": 203493
                    }, {
                        "name": "香港平安医药",
                        "id": 203494
                    }, {
                        "name": "香港瑞幸软件有限公司",
                        "id": 203495
                    }, {
                        "name": "香港滴滴新能源",
                        "id": 203496
                    }, {
                        "name": "天津百度医药",
                        "id": 203497
                    }]
                }, {
                    "name": "上海阿里石油",
                    "id": 203498
                }, {
                    "name": "首尔欧珀医院",
                    "id": 203499
                }, {
                    "name": "深圳奈雪养殖",
                    "id": 203500,
                    "children": [{
                        "name": "东莞蚂蚁",
                        "id": 203501
                    }, {
                        "name": "北京腾讯智能",
                        "id": 203502
                    }, {
                        "name": "东莞喜茶农业",
                        "id": 203503
                    }, {
                        "name": "天津喜茶智能有限公司",
                        "id": 203504
                    }, {
                        "name": "香港亚马逊基金",
                        "id": 203505
                    }, {
                        "name": "首尔华为证券",
                        "id": 203506
                    }, {
                        "name": "纽约特斯拉证券",
                        "id": 203507
                    }, {
                        "name": "杭州快手新能源控股集团",
                        "id": 203508
                    }, {
                        "name": "上海苹果医院有限公司",
                        "id": 203509
                    }, {
                        "name": "香港瑞幸软件",
                        "id": 203510
                    }]
                }, {
                    "name": "厦门阿里新能源",
                    "id": 203511
                }, {
                    "name": "厦门喜茶餐饮",
                    "id": 203512
                }, {
                    "name": "杭州阿里信息服务有限公司",
                    "id": 203513,
                    "children": [{
                        "name": "广州喜茶互金控股集团",
                        "id": 203514
                    }, {
                        "name": "东京欧珀航空",
                        "id": 203515
                    }, {
                        "name": "杭州必胜客通讯",
                        "id": 203516
                    }, {
                        "name": "纽约奈雪互金",
                        "id": 203517
                    }, {
                        "name": "东京苹果",
                        "id": 203518
                    }, {
                        "name": "北京肯德基养殖",
                        "id": 203519
                    }, {
                        "name": "天津腾讯地产",
                        "id": 203520
                    }, {
                        "name": "台北苹果控股集团",
                        "id": 203521
                    }, {
                        "name": "杭州滴滴航空",
                        "id": 203522
                    }, {
                        "name": "首尔特斯拉电商",
                        "id": 203523
                    }]
                }, {
                    "name": "香港蚂蚁医院",
                    "id": 203524
                }, {
                    "name": "东京谷歌医院",
                    "id": 203525
                }, {
                    "name": "台北瑞幸证券",
                    "id": 203526
                }, {
                    "name": "纽约平安",
                    "id": 203527
                }, {
                    "name": "天津蚂蚁医院",
                    "id": 203528
                }, {
                    "name": "天津蚂蚁汽车",
                    "id": 203529,
                    "children": [{
                        "name": "北京华为银行控股集团",
                        "id": 203530
                    }, {
                        "name": "天津微软地产",
                        "id": 203531
                    }, {
                        "name": "天津字节医院",
                        "id": 203532
                    }, {
                        "name": "台北亚马逊汽车有限公司",
                        "id": 203533
                    }, {
                        "name": "纽约瑞幸旅游",
                        "id": 203534
                    }, {
                        "name": "南京喜茶智能",
                        "id": 203535
                    }, {
                        "name": "天津奈雪新能源",
                        "id": 203536
                    }, {
                        "name": "天津微软地产有限公司",
                        "id": 203537
                    }, {
                        "name": "深圳奈雪信息服务有限公司",
                        "id": 203538
                    }, {
                        "name": "深圳字节信息服务",
                        "id": 203539
                    }, {
                        "name": "杭州蚂蚁新能源",
                        "id": 203540
                    }, {
                        "name": "台北谷歌信息服务",
                        "id": 203541
                    }]
                }, {
                    "name": "北京美团通讯",
                    "id": 203542,
                    "children": [{
                        "name": "上海平安基金有限公司",
                        "id": 203543
                    }, {
                        "name": "北京京东基金控股集团",
                        "id": 203544
                    }, {
                        "name": "纽约欧珀餐饮控股集团",
                        "id": 203545
                    }, {
                        "name": "东京肯德基农业",
                        "id": 203546
                    }, {
                        "name": "东莞华为航空",
                        "id": 203547
                    }, {
                        "name": "天津京东通信",
                        "id": 203548
                    }, {
                        "name": "东京平安芯片",
                        "id": 203549
                    }, {
                        "name": "南京苹果",
                        "id": 203550
                    }, {
                        "name": "台北华为养殖",
                        "id": 203551
                    }, {
                        "name": "香港平安银行",
                        "id": 203552
                    }, {
                        "name": "厦门肯德基通信",
                        "id": 203553
                    }, {
                        "name": "厦门平安旅游控股集团",
                        "id": 203554
                    }, {
                        "name": "上海星巴克医药",
                        "id": 203555
                    }, {
                        "name": "香港亚马逊软件",
                        "id": 203556
                    }, {
                        "name": "首尔华为养殖",
                        "id": 203557
                    }, {
                        "name": "台北瑞幸科技",
                        "id": 203558
                    }, {
                        "name": "上海字节控股集团",
                        "id": 203559
                    }, {
                        "name": "北京肯德基渔业",
                        "id": 203560
                    }, {
                        "name": "台北小米医院",
                        "id": 203561
                    }, {
                        "name": "深圳微软有限公司",
                        "id": 203562
                    }, {
                        "name": "厦门百度",
                        "id": 203563
                    }, {
                        "name": "北京瑞幸银行",
                        "id": 203564
                    }, {
                        "name": "深圳滴滴科技",
                        "id": 203565
                    }, {
                        "name": "杭州滴滴计算机",
                        "id": 203566
                    }, {
                        "name": "东京欧珀制造",
                        "id": 203567
                    }, {
                        "name": "首尔滴滴诊所",
                        "id": 203568
                    }, {
                        "name": "天津欧珀银行",
                        "id": 203569
                    }, {
                        "name": "纽约谷歌信息服务",
                        "id": 203570
                    }, {
                        "name": "首尔欧珀诊所",
                        "id": 203571
                    }, {
                        "name": "南京喜茶诊所",
                        "id": 203572
                    }, {
                        "name": "上海蚂蚁通讯有限公司",
                        "id": 203573
                    }, {
                        "name": "厦门平安金融",
                        "id": 203574
                    }, {
                        "name": "广州肯德基互金",
                        "id": 203575
                    }, {
                        "name": "纽约微软新能源",
                        "id": 203576
                    }, {
                        "name": "杭州京东制造",
                        "id": 203577
                    }, {
                        "name": "香港特斯拉渔业",
                        "id": 203578
                    }]
                }, {
                    "name": "北京美团新能源",
                    "id": 203579
                }, {
                    "name": "南京阿里智能",
                    "id": 203580
                }, {
                    "name": "北京肯德基互金",
                    "id": 203581
                }, {
                    "name": "台北字节基金控股集团",
                    "id": 203582
                }, {
                    "name": "深圳小米电商",
                    "id": 203583
                }, {
                    "name": "纽约特斯拉航空控股集团",
                    "id": 203584
                }, {
                    "name": "纽约字节制造",
                    "id": 203585,
                    "children": [{
                        "name": "北京亚马逊科技",
                        "id": 203586
                    }, {
                        "name": "南京星巴克医院控股集团",
                        "id": 203587
                    }, {
                        "name": "杭州字节石油控股集团",
                        "id": 203588
                    }, {
                        "name": "厦门星巴克渔业",
                        "id": 203589
                    }, {
                        "name": "杭州亚马逊科技有限公司",
                        "id": 203590
                    }, {
                        "name": "北京必胜客基金控股集团",
                        "id": 203591
                    }, {
                        "name": "首尔苹果石油有限公司",
                        "id": 203592
                    }, {
                        "name": "纽约滴滴诊所",
                        "id": 203593
                    }, {
                        "name": "深圳星巴克制造",
                        "id": 203594
                    }, {
                        "name": "台北肯德基石油",
                        "id": 203595
                    }, {
                        "name": "东莞亚马逊航空控股集团",
                        "id": 203596
                    }, {
                        "name": "杭州肯德基地摊",
                        "id": 203597
                    }, {
                        "name": "东京小米信息服务有限公司",
                        "id": 203598
                    }, {
                        "name": "深圳阿里软件控股集团",
                        "id": 203599
                    }, {
                        "name": "纽约星巴克通信控股集团",
                        "id": 203600
                    }, {
                        "name": "杭州苹果诊所有限公司",
                        "id": 203601
                    }, {
                        "name": "厦门必胜客",
                        "id": 203602
                    }, {
                        "name": "东莞特斯拉",
                        "id": 203603
                    }, {
                        "name": "杭州苹果地摊有限公司",
                        "id": 203604
                    }, {
                        "name": "东京华为电商",
                        "id": 203605
                    }, {
                        "name": "东莞喜茶汽车",
                        "id": 203606
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 203607
                    }, {
                        "name": "厦门奈雪医院控股集团",
                        "id": 203608
                    }, {
                        "name": "香港特斯拉地产控股集团",
                        "id": 203609
                    }, {
                        "name": "台北华为计算机有限公司",
                        "id": 203610
                    }, {
                        "name": "广州腾讯汽车",
                        "id": 203611
                    }, {
                        "name": "东京快手有限公司",
                        "id": 203612
                    }, {
                        "name": "台北华为医药",
                        "id": 203613
                    }, {
                        "name": "纽约星巴克通讯",
                        "id": 203614
                    }]
                }, {
                    "name": "台北欧珀渔业",
                    "id": 203615
                }, {
                    "name": "东莞谷歌科技控股集团",
                    "id": 203616
                }]
            }, {
                "name": "广州喜茶",
                "id": 203617
            }, {
                "name": "东莞奈雪金融",
                "id": 203618,
                "children": [{
                    "name": "深圳必胜客",
                    "id": 203619,
                    "children": [{
                        "name": "上海阿里诊所控股集团",
                        "id": 203620
                    }, {
                        "name": "北京亚马逊养殖有限公司",
                        "id": 203621
                    }, {
                        "name": "厦门瑞幸农业",
                        "id": 203622
                    }, {
                        "name": "香港蚂蚁渔业",
                        "id": 203623
                    }, {
                        "name": "天津肯德基旅游有限公司",
                        "id": 203624
                    }, {
                        "name": "杭州快手有限公司",
                        "id": 203625
                    }, {
                        "name": "东京星巴克通信",
                        "id": 203626
                    }, {
                        "name": "首尔特斯拉旅游",
                        "id": 203627
                    }, {
                        "name": "杭州快手电商有限公司",
                        "id": 203628
                    }, {
                        "name": "北京平安诊所",
                        "id": 203629
                    }, {
                        "name": "南京苹果农业",
                        "id": 203630
                    }, {
                        "name": "东京微软通信",
                        "id": 203631
                    }, {
                        "name": "首尔京东",
                        "id": 203632
                    }, {
                        "name": "南京美团通讯",
                        "id": 203633
                    }, {
                        "name": "东京欧珀航空",
                        "id": 203634
                    }, {
                        "name": "广州字节金融控股集团",
                        "id": 203635
                    }, {
                        "name": "杭州腾讯信息服务",
                        "id": 203636
                    }, {
                        "name": "首尔奈雪餐饮有限公司",
                        "id": 203637
                    }, {
                        "name": "北京欧珀新能源",
                        "id": 203638
                    }, {
                        "name": "厦门微软餐饮",
                        "id": 203639
                    }]
                }, {
                    "name": "杭州谷歌渔业",
                    "id": 203640,
                    "children": [{
                        "name": "广州美团银行",
                        "id": 203641
                    }, {
                        "name": "首尔蚂蚁牧业",
                        "id": 203642
                    }, {
                        "name": "台北谷歌养殖",
                        "id": 203643
                    }, {
                        "name": "天津瑞幸",
                        "id": 203644
                    }, {
                        "name": "台北字节电商",
                        "id": 203645
                    }, {
                        "name": "东京快手新能源",
                        "id": 203646
                    }, {
                        "name": "深圳欧珀",
                        "id": 203647
                    }, {
                        "name": "东京百度电商",
                        "id": 203648
                    }, {
                        "name": "深圳肯德基科技控股集团",
                        "id": 203649
                    }, {
                        "name": "杭州特斯拉制造控股集团",
                        "id": 203650
                    }, {
                        "name": "广州平安牧业",
                        "id": 203651
                    }, {
                        "name": "杭州肯德基石油",
                        "id": 203652
                    }, {
                        "name": "东莞星巴克证券",
                        "id": 203653
                    }, {
                        "name": "台北苹果信息服务",
                        "id": 203654
                    }, {
                        "name": "纽约字节养殖",
                        "id": 203655
                    }, {
                        "name": "上海微软有限公司",
                        "id": 203656
                    }, {
                        "name": "上海欧珀渔业",
                        "id": 203657
                    }, {
                        "name": "北京奈雪有限公司",
                        "id": 203658
                    }, {
                        "name": "深圳滴滴通讯有限公司",
                        "id": 203659
                    }, {
                        "name": "厦门亚马逊电商有限公司",
                        "id": 203660
                    }, {
                        "name": "杭州肯德基渔业",
                        "id": 203661
                    }, {
                        "name": "东京百度软件有限公司",
                        "id": 203662
                    }, {
                        "name": "纽约滴滴计算机",
                        "id": 203663
                    }, {
                        "name": "纽约喜茶地摊控股集团",
                        "id": 203664
                    }, {
                        "name": "纽约瑞幸通讯",
                        "id": 203665
                    }, {
                        "name": "纽约京东基金控股集团",
                        "id": 203666
                    }, {
                        "name": "东京苹果通信",
                        "id": 203667
                    }]
                }, {
                    "name": "厦门星巴克科技控股集团",
                    "id": 203668
                }, {
                    "name": "东莞百度制造",
                    "id": 203669
                }, {
                    "name": "首尔瑞幸金融",
                    "id": 203670
                }, {
                    "name": "东莞百度农业",
                    "id": 203671,
                    "children": [{
                        "name": "厦门京东通信有限公司",
                        "id": 203672
                    }, {
                        "name": "东京亚马逊诊所有限公司",
                        "id": 203673
                    }, {
                        "name": "台北字节养殖",
                        "id": 203674
                    }, {
                        "name": "广州字节证券有限公司",
                        "id": 203675
                    }]
                }, {
                    "name": "广州欧珀",
                    "id": 203676
                }, {
                    "name": "北京平安养殖有限公司",
                    "id": 203677
                }, {
                    "name": "深圳百度制造有限公司",
                    "id": 203678
                }, {
                    "name": "广州小米农业有限公司",
                    "id": 203679
                }, {
                    "name": "东莞小米石油控股集团",
                    "id": 203680
                }]
            }, {
                "name": "东莞京东信息服务控股集团",
                "id": 203681
            }, {
                "name": "台北必胜客医院",
                "id": 203682
            }, {
                "name": "南京欧珀农业控股集团",
                "id": 203683
            }]
        }, {
            "name": "杭州必胜客农业有限公司",
            "id": 203684,
            "children": [{
                "name": "上海滴滴银行",
                "id": 203685
            }, {
                "name": "上海苹果证券",
                "id": 203686
            }, {
                "name": "深圳亚马逊电商有限公司",
                "id": 203687,
                "children": [{
                    "name": "广州喜茶控股集团",
                    "id": 203688
                }, {
                    "name": "上海亚马逊餐饮",
                    "id": 203689
                }, {
                    "name": "广州平安农业",
                    "id": 203690
                }, {
                    "name": "杭州百度旅游",
                    "id": 203691
                }, {
                    "name": "深圳蚂蚁石油",
                    "id": 203692
                }, {
                    "name": "纽约微软软件控股集团",
                    "id": 203693,
                    "children": [{
                        "name": "天津微软计算机",
                        "id": 203694
                    }, {
                        "name": "北京微软养殖",
                        "id": 203695
                    }, {
                        "name": "北京特斯拉农业",
                        "id": 203696
                    }, {
                        "name": "纽约小米诊所",
                        "id": 203697
                    }, {
                        "name": "厦门喜茶养殖",
                        "id": 203698
                    }, {
                        "name": "天津平安证券",
                        "id": 203699
                    }, {
                        "name": "广州字节旅游",
                        "id": 203700
                    }, {
                        "name": "天津星巴克医药",
                        "id": 203701
                    }, {
                        "name": "南京必胜客航空",
                        "id": 203702
                    }, {
                        "name": "深圳阿里通信",
                        "id": 203703
                    }, {
                        "name": "南京腾讯证券",
                        "id": 203704
                    }, {
                        "name": "深圳腾讯软件",
                        "id": 203705
                    }, {
                        "name": "东京美团制造",
                        "id": 203706
                    }, {
                        "name": "杭州苹果电商",
                        "id": 203707
                    }, {
                        "name": "东京美团芯片",
                        "id": 203708
                    }, {
                        "name": "厦门谷歌制造",
                        "id": 203709
                    }, {
                        "name": "天津欧珀旅游",
                        "id": 203710
                    }, {
                        "name": "深圳平安",
                        "id": 203711
                    }, {
                        "name": "台北微软互金",
                        "id": 203712
                    }, {
                        "name": "杭州亚马逊通信",
                        "id": 203713
                    }, {
                        "name": "天津小米银行有限公司",
                        "id": 203714
                    }, {
                        "name": "香港阿里芯片",
                        "id": 203715
                    }, {
                        "name": "上海苹果诊所有限公司",
                        "id": 203716
                    }, {
                        "name": "台北百度牧业",
                        "id": 203717
                    }, {
                        "name": "天津阿里计算机控股集团",
                        "id": 203718
                    }]
                }, {
                    "name": "台北谷歌新能源",
                    "id": 203719
                }, {
                    "name": "南京谷歌地产",
                    "id": 203720
                }, {
                    "name": "深圳滴滴计算机",
                    "id": 203721,
                    "children": [{
                        "name": "杭州百度基金",
                        "id": 203722
                    }, {
                        "name": "杭州美团医院",
                        "id": 203723
                    }, {
                        "name": "杭州欧珀通讯有限公司",
                        "id": 203724
                    }, {
                        "name": "杭州百度证券",
                        "id": 203725
                    }, {
                        "name": "首尔快手互金",
                        "id": 203726
                    }, {
                        "name": "深圳华为",
                        "id": 203727
                    }, {
                        "name": "深圳美团智能",
                        "id": 203728
                    }, {
                        "name": "广州字节科技",
                        "id": 203729
                    }, {
                        "name": "首尔字节",
                        "id": 203730
                    }, {
                        "name": "厦门喜茶医院控股集团",
                        "id": 203731
                    }, {
                        "name": "上海亚马逊制造",
                        "id": 203732
                    }, {
                        "name": "杭州快手基金",
                        "id": 203733
                    }, {
                        "name": "北京腾讯银行",
                        "id": 203734
                    }, {
                        "name": "杭州星巴克互金有限公司",
                        "id": 203735
                    }, {
                        "name": "纽约欧珀证券",
                        "id": 203736
                    }, {
                        "name": "香港快手软件控股集团",
                        "id": 203737
                    }, {
                        "name": "香港快手基金",
                        "id": 203738
                    }, {
                        "name": "东莞喜茶汽车",
                        "id": 203739
                    }, {
                        "name": "北京瑞幸银行",
                        "id": 203740
                    }, {
                        "name": "上海喜茶餐饮控股集团",
                        "id": 203741
                    }, {
                        "name": "北京百度农业",
                        "id": 203742
                    }, {
                        "name": "东莞滴滴",
                        "id": 203743
                    }]
                }, {
                    "name": "东莞谷歌基金",
                    "id": 203744
                }, {
                    "name": "杭州平安信息服务",
                    "id": 203745
                }, {
                    "name": "天津美团软件",
                    "id": 203746
                }, {
                    "name": "东莞百度石油",
                    "id": 203747
                }, {
                    "name": "北京腾讯诊所",
                    "id": 203748,
                    "children": [{
                        "name": "上海滴滴餐饮控股集团",
                        "id": 203749
                    }, {
                        "name": "厦门肯德基航空",
                        "id": 203750
                    }, {
                        "name": "东莞小米芯片",
                        "id": 203751
                    }, {
                        "name": "首尔肯德基证券控股集团",
                        "id": 203752
                    }, {
                        "name": "深圳奈雪制造",
                        "id": 203753
                    }, {
                        "name": "广州肯德基",
                        "id": 203754
                    }, {
                        "name": "南京瑞幸养殖有限公司",
                        "id": 203755
                    }, {
                        "name": "广州阿里智能控股集团",
                        "id": 203756
                    }, {
                        "name": "纽约苹果智能有限公司",
                        "id": 203757
                    }, {
                        "name": "杭州欧珀金融",
                        "id": 203758
                    }, {
                        "name": "深圳肯德基软件",
                        "id": 203759
                    }, {
                        "name": "东京快手芯片有限公司",
                        "id": 203760
                    }, {
                        "name": "广州微软石油有限公司",
                        "id": 203761
                    }, {
                        "name": "杭州阿里航空",
                        "id": 203762
                    }, {
                        "name": "上海美团制造",
                        "id": 203763
                    }, {
                        "name": "深圳小米证券",
                        "id": 203764
                    }, {
                        "name": "杭州微软牧业",
                        "id": 203765
                    }, {
                        "name": "东京瑞幸制造",
                        "id": 203766
                    }, {
                        "name": "深圳谷歌新能源控股集团",
                        "id": 203767
                    }, {
                        "name": "天津微软诊所有限公司",
                        "id": 203768
                    }, {
                        "name": "纽约京东养殖",
                        "id": 203769
                    }, {
                        "name": "杭州必胜客证券控股集团",
                        "id": 203770
                    }, {
                        "name": "台北小米餐饮",
                        "id": 203771
                    }, {
                        "name": "天津华为互金有限公司",
                        "id": 203772
                    }, {
                        "name": "杭州美团餐饮",
                        "id": 203773
                    }, {
                        "name": "杭州奈雪通信有限公司",
                        "id": 203774
                    }, {
                        "name": "纽约快手地产",
                        "id": 203775
                    }, {
                        "name": "深圳肯德基基金",
                        "id": 203776
                    }, {
                        "name": "深圳滴滴",
                        "id": 203777
                    }, {
                        "name": "上海美团渔业有限公司",
                        "id": 203778
                    }, {
                        "name": "天津腾讯航空",
                        "id": 203779
                    }, {
                        "name": "纽约蚂蚁",
                        "id": 203780
                    }, {
                        "name": "上海特斯拉石油控股集团",
                        "id": 203781
                    }]
                }, {
                    "name": "杭州蚂蚁餐饮",
                    "id": 203782
                }, {
                    "name": "南京平安芯片",
                    "id": 203783
                }, {
                    "name": "纽约美团计算机",
                    "id": 203784
                }, {
                    "name": "纽约京东控股集团",
                    "id": 203785
                }, {
                    "name": "天津必胜客基金",
                    "id": 203786
                }, {
                    "name": "香港美团汽车有限公司",
                    "id": 203787
                }, {
                    "name": "北京快手制造有限公司",
                    "id": 203788
                }, {
                    "name": "东京快手地摊",
                    "id": 203789
                }, {
                    "name": "杭州小米",
                    "id": 203790,
                    "children": [{
                        "name": "香港平安通讯控股集团",
                        "id": 203791
                    }, {
                        "name": "首尔百度汽车",
                        "id": 203792
                    }, {
                        "name": "东京京东航空控股集团",
                        "id": 203793
                    }]
                }, {
                    "name": "纽约平安汽车",
                    "id": 203794,
                    "children": [{
                        "name": "台北京东医药",
                        "id": 203795
                    }, {
                        "name": "厦门美团石油",
                        "id": 203796
                    }, {
                        "name": "台北美团诊所控股集团",
                        "id": 203797
                    }, {
                        "name": "南京小米基金",
                        "id": 203798
                    }, {
                        "name": "南京特斯拉智能",
                        "id": 203799
                    }, {
                        "name": "杭州特斯拉渔业",
                        "id": 203800
                    }, {
                        "name": "香港亚马逊地产",
                        "id": 203801
                    }, {
                        "name": "天津滴滴航空",
                        "id": 203802
                    }, {
                        "name": "首尔快手芯片",
                        "id": 203803
                    }, {
                        "name": "首尔奈雪",
                        "id": 203804
                    }, {
                        "name": "东莞美团养殖",
                        "id": 203805
                    }, {
                        "name": "厦门京东控股集团",
                        "id": 203806
                    }, {
                        "name": "香港京东信息服务控股集团",
                        "id": 203807
                    }, {
                        "name": "杭州美团旅游",
                        "id": 203808
                    }, {
                        "name": "东莞必胜客科技",
                        "id": 203809
                    }, {
                        "name": "上海必胜客科技",
                        "id": 203810
                    }, {
                        "name": "东京快手汽车有限公司",
                        "id": 203811
                    }, {
                        "name": "广州腾讯牧业控股集团",
                        "id": 203812
                    }, {
                        "name": "东莞腾讯互金",
                        "id": 203813
                    }, {
                        "name": "首尔亚马逊软件",
                        "id": 203814
                    }, {
                        "name": "杭州必胜客科技",
                        "id": 203815
                    }, {
                        "name": "台北字节通讯有限公司",
                        "id": 203816
                    }, {
                        "name": "天津字节航空控股集团",
                        "id": 203817
                    }, {
                        "name": "北京微软芯片",
                        "id": 203818
                    }]
                }, {
                    "name": "东京奈雪地摊",
                    "id": 203819
                }, {
                    "name": "香港百度新能源",
                    "id": 203820
                }, {
                    "name": "纽约肯德基软件",
                    "id": 203821
                }]
            }, {
                "name": "东京瑞幸信息服务",
                "id": 203822,
                "children": [{
                    "name": "广州小米诊所",
                    "id": 203823,
                    "children": [{
                        "name": "首尔平安农业控股集团",
                        "id": 203824
                    }, {
                        "name": "厦门百度计算机",
                        "id": 203825
                    }, {
                        "name": "北京字节石油",
                        "id": 203826
                    }, {
                        "name": "首尔平安信息服务",
                        "id": 203827
                    }, {
                        "name": "东京特斯拉通信控股集团",
                        "id": 203828
                    }, {
                        "name": "天津特斯拉新能源",
                        "id": 203829
                    }, {
                        "name": "南京平安软件",
                        "id": 203830
                    }, {
                        "name": "杭州字节渔业控股集团",
                        "id": 203831
                    }, {
                        "name": "纽约星巴克新能源",
                        "id": 203832
                    }, {
                        "name": "东莞必胜客牧业",
                        "id": 203833
                    }, {
                        "name": "台北亚马逊地产",
                        "id": 203834
                    }, {
                        "name": "东莞亚马逊新能源",
                        "id": 203835
                    }, {
                        "name": "上海平安信息服务",
                        "id": 203836
                    }, {
                        "name": "南京星巴克电商有限公司",
                        "id": 203837
                    }, {
                        "name": "北京微软科技",
                        "id": 203838
                    }, {
                        "name": "广州奈雪",
                        "id": 203839
                    }, {
                        "name": "南京平安计算机",
                        "id": 203840
                    }, {
                        "name": "杭州字节",
                        "id": 203841
                    }, {
                        "name": "厦门欧珀基金有限公司",
                        "id": 203842
                    }, {
                        "name": "首尔亚马逊餐饮",
                        "id": 203843
                    }, {
                        "name": "北京小米医药",
                        "id": 203844
                    }, {
                        "name": "北京亚马逊汽车",
                        "id": 203845
                    }, {
                        "name": "纽约必胜客医院控股集团",
                        "id": 203846
                    }, {
                        "name": "杭州必胜客有限公司",
                        "id": 203847
                    }, {
                        "name": "南京滴滴电商",
                        "id": 203848
                    }, {
                        "name": "广州肯德基基金",
                        "id": 203849
                    }, {
                        "name": "台北平安新能源",
                        "id": 203850
                    }, {
                        "name": "杭州快手信息服务",
                        "id": 203851
                    }, {
                        "name": "纽约百度地产有限公司",
                        "id": 203852
                    }, {
                        "name": "东莞腾讯金融控股集团",
                        "id": 203853
                    }, {
                        "name": "杭州欧珀制造有限公司",
                        "id": 203854
                    }, {
                        "name": "杭州特斯拉金融",
                        "id": 203855
                    }, {
                        "name": "深圳瑞幸证券控股集团",
                        "id": 203856
                    }, {
                        "name": "东京奈雪渔业",
                        "id": 203857
                    }]
                }, {
                    "name": "厦门谷歌养殖",
                    "id": 203858
                }, {
                    "name": "东京百度石油",
                    "id": 203859
                }, {
                    "name": "北京京东基金",
                    "id": 203860,
                    "children": [{
                        "name": "上海美团基金",
                        "id": 203861
                    }, {
                        "name": "台北苹果智能控股集团",
                        "id": 203862
                    }, {
                        "name": "北京奈雪石油控股集团",
                        "id": 203863
                    }, {
                        "name": "香港阿里餐饮",
                        "id": 203864
                    }]
                }, {
                    "name": "东莞谷歌牧业",
                    "id": 203865
                }, {
                    "name": "北京星巴克牧业",
                    "id": 203866
                }, {
                    "name": "广州京东控股集团",
                    "id": 203867
                }, {
                    "name": "天津谷歌新能源",
                    "id": 203868,
                    "children": [{
                        "name": "厦门必胜客航空",
                        "id": 203869
                    }, {
                        "name": "厦门瑞幸农业",
                        "id": 203870
                    }, {
                        "name": "纽约百度医药",
                        "id": 203871
                    }, {
                        "name": "首尔星巴克",
                        "id": 203872
                    }, {
                        "name": "南京谷歌航空有限公司",
                        "id": 203873
                    }, {
                        "name": "首尔肯德基信息服务控股集团",
                        "id": 203874
                    }, {
                        "name": "纽约谷歌基金",
                        "id": 203875
                    }, {
                        "name": "台北阿里",
                        "id": 203876
                    }, {
                        "name": "台北亚马逊通讯",
                        "id": 203877
                    }, {
                        "name": "东京美团基金控股集团",
                        "id": 203878
                    }, {
                        "name": "南京苹果互金",
                        "id": 203879
                    }, {
                        "name": "纽约腾讯通信有限公司",
                        "id": 203880
                    }, {
                        "name": "广州京东控股集团",
                        "id": 203881
                    }, {
                        "name": "台北小米",
                        "id": 203882
                    }, {
                        "name": "首尔蚂蚁芯片控股集团",
                        "id": 203883
                    }, {
                        "name": "天津肯德基医药",
                        "id": 203884
                    }, {
                        "name": "天津阿里旅游",
                        "id": 203885
                    }, {
                        "name": "首尔京东旅游",
                        "id": 203886
                    }, {
                        "name": "杭州快手信息服务有限公司",
                        "id": 203887
                    }, {
                        "name": "广州肯德基软件",
                        "id": 203888
                    }, {
                        "name": "东京字节通信",
                        "id": 203889
                    }, {
                        "name": "香港百度牧业",
                        "id": 203890
                    }, {
                        "name": "上海腾讯计算机控股集团",
                        "id": 203891
                    }, {
                        "name": "香港亚马逊地产",
                        "id": 203892
                    }, {
                        "name": "首尔微软地产有限公司",
                        "id": 203893
                    }, {
                        "name": "台北平安基金",
                        "id": 203894
                    }, {
                        "name": "东京亚马逊汽车控股集团",
                        "id": 203895
                    }, {
                        "name": "天津肯德基基金",
                        "id": 203896
                    }, {
                        "name": "东莞华为牧业",
                        "id": 203897
                    }, {
                        "name": "上海字节通讯有限公司",
                        "id": 203898
                    }, {
                        "name": "上海苹果医院",
                        "id": 203899
                    }, {
                        "name": "首尔喜茶金融",
                        "id": 203900
                    }, {
                        "name": "台北喜茶制造有限公司",
                        "id": 203901
                    }, {
                        "name": "厦门欧珀新能源",
                        "id": 203902
                    }, {
                        "name": "台北华为新能源",
                        "id": 203903
                    }]
                }, {
                    "name": "深圳美团地产有限公司",
                    "id": 203904
                }, {
                    "name": "北京微软计算机有限公司",
                    "id": 203905
                }, {
                    "name": "首尔特斯拉渔业控股集团",
                    "id": 203906
                }, {
                    "name": "杭州平安互金",
                    "id": 203907
                }, {
                    "name": "深圳蚂蚁信息服务有限公司",
                    "id": 203908
                }, {
                    "name": "杭州华为医药",
                    "id": 203909,
                    "children": [{
                        "name": "天津亚马逊通讯",
                        "id": 203910
                    }, {
                        "name": "上海苹果医院控股集团",
                        "id": 203911
                    }, {
                        "name": "杭州欧珀餐饮",
                        "id": 203912
                    }, {
                        "name": "深圳肯德基软件",
                        "id": 203913
                    }, {
                        "name": "香港腾讯证券",
                        "id": 203914
                    }, {
                        "name": "杭州平安餐饮",
                        "id": 203915
                    }, {
                        "name": "北京平安计算机",
                        "id": 203916
                    }, {
                        "name": "台北小米餐饮",
                        "id": 203917
                    }, {
                        "name": "深圳谷歌计算机",
                        "id": 203918
                    }, {
                        "name": "天津平安有限公司",
                        "id": 203919
                    }, {
                        "name": "台北喜茶",
                        "id": 203920
                    }, {
                        "name": "杭州谷歌智能",
                        "id": 203921
                    }, {
                        "name": "东莞肯德基汽车",
                        "id": 203922
                    }, {
                        "name": "台北喜茶诊所",
                        "id": 203923
                    }, {
                        "name": "首尔瑞幸诊所",
                        "id": 203924
                    }, {
                        "name": "杭州美团养殖",
                        "id": 203925
                    }, {
                        "name": "首尔微软软件有限公司",
                        "id": 203926
                    }, {
                        "name": "纽约奈雪养殖控股集团",
                        "id": 203927
                    }, {
                        "name": "天津微软新能源",
                        "id": 203928
                    }, {
                        "name": "上海阿里石油",
                        "id": 203929
                    }, {
                        "name": "东京瑞幸芯片有限公司",
                        "id": 203930
                    }, {
                        "name": "台北快手",
                        "id": 203931
                    }, {
                        "name": "台北华为芯片控股集团",
                        "id": 203932
                    }, {
                        "name": "深圳喜茶基金",
                        "id": 203933
                    }, {
                        "name": "广州星巴克牧业有限公司",
                        "id": 203934
                    }, {
                        "name": "首尔快手通信",
                        "id": 203935
                    }]
                }, {
                    "name": "深圳华为地产有限公司",
                    "id": 203936,
                    "children": [{
                        "name": "台北亚马逊新能源",
                        "id": 203937
                    }, {
                        "name": "纽约字节通讯",
                        "id": 203938
                    }, {
                        "name": "广州平安金融有限公司",
                        "id": 203939
                    }, {
                        "name": "首尔肯德基芯片有限公司",
                        "id": 203940
                    }, {
                        "name": "东莞蚂蚁新能源",
                        "id": 203941
                    }, {
                        "name": "杭州特斯拉电商",
                        "id": 203942
                    }, {
                        "name": "首尔微软电商",
                        "id": 203943
                    }, {
                        "name": "深圳蚂蚁渔业控股集团",
                        "id": 203944
                    }, {
                        "name": "深圳必胜客地产",
                        "id": 203945
                    }, {
                        "name": "上海腾讯信息服务",
                        "id": 203946
                    }, {
                        "name": "广州阿里智能",
                        "id": 203947
                    }, {
                        "name": "厦门星巴克石油",
                        "id": 203948
                    }, {
                        "name": "天津滴滴通信",
                        "id": 203949
                    }, {
                        "name": "东莞星巴克通信控股集团",
                        "id": 203950
                    }]
                }, {
                    "name": "广州小米科技",
                    "id": 203951
                }, {
                    "name": "广州华为航空",
                    "id": 203952
                }, {
                    "name": "南京美团互金",
                    "id": 203953
                }, {
                    "name": "上海百度信息服务有限公司",
                    "id": 203954
                }, {
                    "name": "天津瑞幸餐饮控股集团",
                    "id": 203955
                }, {
                    "name": "厦门亚马逊证券",
                    "id": 203956
                }, {
                    "name": "首尔奈雪农业",
                    "id": 203957,
                    "children": [{
                        "name": "香港星巴克地摊有限公司",
                        "id": 203958
                    }, {
                        "name": "广州华为餐饮",
                        "id": 203959
                    }, {
                        "name": "香港谷歌地产",
                        "id": 203960
                    }, {
                        "name": "首尔小米通信",
                        "id": 203961
                    }, {
                        "name": "杭州瑞幸诊所",
                        "id": 203962
                    }, {
                        "name": "杭州京东医院",
                        "id": 203963
                    }, {
                        "name": "杭州亚马逊石油有限公司",
                        "id": 203964
                    }, {
                        "name": "东莞腾讯石油控股集团",
                        "id": 203965
                    }, {
                        "name": "深圳特斯拉证券",
                        "id": 203966
                    }, {
                        "name": "广州奈雪芯片",
                        "id": 203967
                    }, {
                        "name": "台北快手地产",
                        "id": 203968
                    }, {
                        "name": "上海阿里信息服务控股集团",
                        "id": 203969
                    }, {
                        "name": "东莞滴滴科技",
                        "id": 203970
                    }, {
                        "name": "上海亚马逊农业",
                        "id": 203971
                    }, {
                        "name": "纽约特斯拉通信有限公司",
                        "id": 203972
                    }, {
                        "name": "东莞必胜客医院控股集团",
                        "id": 203973
                    }, {
                        "name": "香港阿里银行",
                        "id": 203974
                    }, {
                        "name": "广州苹果有限公司",
                        "id": 203975
                    }, {
                        "name": "天津苹果银行有限公司",
                        "id": 203976
                    }, {
                        "name": "天津蚂蚁医院",
                        "id": 203977
                    }, {
                        "name": "杭州特斯拉有限公司",
                        "id": 203978
                    }, {
                        "name": "广州阿里通信",
                        "id": 203979
                    }, {
                        "name": "厦门美团电商",
                        "id": 203980
                    }, {
                        "name": "首尔华为汽车",
                        "id": 203981
                    }, {
                        "name": "上海百度制造",
                        "id": 203982
                    }, {
                        "name": "杭州字节科技",
                        "id": 203983
                    }, {
                        "name": "广州平安通讯有限公司",
                        "id": 203984
                    }, {
                        "name": "上海特斯拉新能源",
                        "id": 203985
                    }, {
                        "name": "纽约腾讯汽车",
                        "id": 203986
                    }, {
                        "name": "杭州蚂蚁牧业",
                        "id": 203987
                    }, {
                        "name": "台北华为农业",
                        "id": 203988
                    }, {
                        "name": "台北喜茶诊所",
                        "id": 203989
                    }, {
                        "name": "杭州小米汽车",
                        "id": 203990
                    }, {
                        "name": "香港肯德基有限公司",
                        "id": 203991
                    }, {
                        "name": "上海京东制造有限公司",
                        "id": 203992
                    }]
                }, {
                    "name": "深圳奈雪农业控股集团",
                    "id": 203993
                }, {
                    "name": "厦门字节智能",
                    "id": 203994,
                    "children": [{
                        "name": "北京奈雪证券控股集团",
                        "id": 203995
                    }, {
                        "name": "上海百度科技",
                        "id": 203996
                    }, {
                        "name": "天津小米",
                        "id": 203997
                    }, {
                        "name": "广州美团诊所",
                        "id": 203998
                    }, {
                        "name": "南京华为通讯",
                        "id": 203999
                    }, {
                        "name": "广州亚马逊银行控股集团",
                        "id": 204000
                    }, {
                        "name": "厦门亚马逊农业",
                        "id": 204001
                    }, {
                        "name": "纽约星巴克航空",
                        "id": 204002
                    }, {
                        "name": "东莞星巴克地摊有限公司",
                        "id": 204003
                    }, {
                        "name": "香港亚马逊诊所",
                        "id": 204004
                    }, {
                        "name": "杭州京东基金",
                        "id": 204005
                    }, {
                        "name": "厦门美团制造",
                        "id": 204006
                    }, {
                        "name": "上海亚马逊",
                        "id": 204007
                    }, {
                        "name": "广州喜茶旅游",
                        "id": 204008
                    }, {
                        "name": "北京必胜客牧业",
                        "id": 204009
                    }, {
                        "name": "南京京东医药",
                        "id": 204010
                    }, {
                        "name": "香港华为软件",
                        "id": 204011
                    }, {
                        "name": "纽约阿里通信",
                        "id": 204012
                    }, {
                        "name": "首尔美团牧业有限公司",
                        "id": 204013
                    }, {
                        "name": "广州谷歌养殖",
                        "id": 204014
                    }, {
                        "name": "纽约肯德基养殖有限公司",
                        "id": 204015
                    }, {
                        "name": "深圳必胜客养殖",
                        "id": 204016
                    }, {
                        "name": "天津肯德基医院",
                        "id": 204017
                    }, {
                        "name": "北京京东控股集团",
                        "id": 204018
                    }, {
                        "name": "深圳华为科技",
                        "id": 204019
                    }, {
                        "name": "杭州必胜客地产",
                        "id": 204020
                    }, {
                        "name": "天津肯德基渔业有限公司",
                        "id": 204021
                    }, {
                        "name": "杭州微软",
                        "id": 204022
                    }, {
                        "name": "上海必胜客智能",
                        "id": 204023
                    }]
                }, {
                    "name": "杭州肯德基航空控股集团",
                    "id": 204024
                }, {
                    "name": "南京平安证券",
                    "id": 204025
                }, {
                    "name": "深圳瑞幸地产有限公司",
                    "id": 204026
                }]
            }, {
                "name": "纽约蚂蚁通信",
                "id": 204027,
                "children": [{
                    "name": "东京小米渔业有限公司",
                    "id": 204028,
                    "children": [{
                        "name": "天津必胜客科技",
                        "id": 204029
                    }, {
                        "name": "香港亚马逊渔业",
                        "id": 204030
                    }, {
                        "name": "台北百度软件",
                        "id": 204031
                    }, {
                        "name": "深圳微软汽车有限公司",
                        "id": 204032
                    }, {
                        "name": "南京华为证券有限公司",
                        "id": 204033
                    }, {
                        "name": "杭州字节餐饮",
                        "id": 204034
                    }, {
                        "name": "杭州快手航空",
                        "id": 204035
                    }, {
                        "name": "天津美团医药控股集团",
                        "id": 204036
                    }, {
                        "name": "北京欧珀通讯",
                        "id": 204037
                    }, {
                        "name": "东莞美团计算机",
                        "id": 204038
                    }, {
                        "name": "杭州滴滴科技",
                        "id": 204039
                    }, {
                        "name": "杭州喜茶科技",
                        "id": 204040
                    }, {
                        "name": "东京奈雪智能",
                        "id": 204041
                    }, {
                        "name": "上海谷歌金融",
                        "id": 204042
                    }, {
                        "name": "首尔百度芯片有限公司",
                        "id": 204043
                    }, {
                        "name": "香港亚马逊银行控股集团",
                        "id": 204044
                    }]
                }, {
                    "name": "广州特斯拉旅游控股集团",
                    "id": 204045
                }, {
                    "name": "杭州字节医药",
                    "id": 204046,
                    "children": [{
                        "name": "北京肯德基渔业控股集团",
                        "id": 204047
                    }, {
                        "name": "香港百度汽车控股集团",
                        "id": 204048
                    }, {
                        "name": "杭州必胜客养殖",
                        "id": 204049
                    }, {
                        "name": "南京百度餐饮",
                        "id": 204050
                    }, {
                        "name": "厦门华为基金",
                        "id": 204051
                    }, {
                        "name": "纽约百度金融",
                        "id": 204052
                    }, {
                        "name": "纽约喜茶农业",
                        "id": 204053
                    }, {
                        "name": "东莞喜茶信息服务",
                        "id": 204054
                    }, {
                        "name": "深圳肯德基新能源控股集团",
                        "id": 204055
                    }, {
                        "name": "深圳腾讯通讯控股集团",
                        "id": 204056
                    }, {
                        "name": "南京腾讯制造",
                        "id": 204057
                    }, {
                        "name": "东莞华为芯片",
                        "id": 204058
                    }, {
                        "name": "天津滴滴诊所控股集团",
                        "id": 204059
                    }, {
                        "name": "厦门阿里养殖有限公司",
                        "id": 204060
                    }, {
                        "name": "广州百度互金",
                        "id": 204061
                    }, {
                        "name": "南京必胜客诊所",
                        "id": 204062
                    }, {
                        "name": "东莞特斯拉医院有限公司",
                        "id": 204063
                    }, {
                        "name": "深圳美团芯片有限公司",
                        "id": 204064
                    }, {
                        "name": "北京阿里石油",
                        "id": 204065
                    }, {
                        "name": "杭州喜茶智能",
                        "id": 204066
                    }]
                }, {
                    "name": "北京必胜客旅游控股集团",
                    "id": 204067
                }, {
                    "name": "广州特斯拉科技",
                    "id": 204068
                }, {
                    "name": "东京华为",
                    "id": 204069,
                    "children": [{
                        "name": "纽约京东基金控股集团",
                        "id": 204070
                    }, {
                        "name": "深圳亚马逊软件",
                        "id": 204071
                    }]
                }, {
                    "name": "广州美团软件有限公司",
                    "id": 204072,
                    "children": [{
                        "name": "南京谷歌有限公司",
                        "id": 204073
                    }, {
                        "name": "纽约必胜客软件",
                        "id": 204074
                    }, {
                        "name": "东莞微软金融有限公司",
                        "id": 204075
                    }, {
                        "name": "上海腾讯医院有限公司",
                        "id": 204076
                    }]
                }, {
                    "name": "北京阿里地产有限公司",
                    "id": 204077
                }, {
                    "name": "上海谷歌医药",
                    "id": 204078
                }, {
                    "name": "东莞小米信息服务控股集团",
                    "id": 204079
                }, {
                    "name": "深圳瑞幸渔业",
                    "id": 204080
                }, {
                    "name": "东京特斯拉金融控股集团",
                    "id": 204081,
                    "children": [{
                        "name": "南京瑞幸科技",
                        "id": 204082
                    }, {
                        "name": "天津特斯拉",
                        "id": 204083
                    }, {
                        "name": "广州亚马逊计算机",
                        "id": 204084
                    }, {
                        "name": "杭州谷歌新能源",
                        "id": 204085
                    }, {
                        "name": "东莞必胜客",
                        "id": 204086
                    }, {
                        "name": "首尔字节互金",
                        "id": 204087
                    }, {
                        "name": "广州京东航空",
                        "id": 204088
                    }, {
                        "name": "杭州华为新能源",
                        "id": 204089
                    }, {
                        "name": "首尔必胜客农业",
                        "id": 204090
                    }, {
                        "name": "纽约微软互金控股集团",
                        "id": 204091
                    }, {
                        "name": "厦门腾讯软件",
                        "id": 204092
                    }, {
                        "name": "首尔奈雪农业控股集团",
                        "id": 204093
                    }, {
                        "name": "上海微软旅游控股集团",
                        "id": 204094
                    }]
                }, {
                    "name": "南京京东养殖控股集团",
                    "id": 204095
                }, {
                    "name": "上海腾讯石油",
                    "id": 204096,
                    "children": [{
                        "name": "北京亚马逊养殖",
                        "id": 204097
                    }, {
                        "name": "深圳肯德基诊所",
                        "id": 204098
                    }, {
                        "name": "北京苹果石油控股集团",
                        "id": 204099
                    }, {
                        "name": "深圳特斯拉互金",
                        "id": 204100
                    }, {
                        "name": "纽约百度诊所",
                        "id": 204101
                    }, {
                        "name": "纽约肯德基养殖",
                        "id": 204102
                    }, {
                        "name": "东京阿里医药",
                        "id": 204103
                    }, {
                        "name": "首尔谷歌",
                        "id": 204104
                    }, {
                        "name": "首尔谷歌计算机",
                        "id": 204105
                    }, {
                        "name": "东京蚂蚁控股集团",
                        "id": 204106
                    }, {
                        "name": "北京美团信息服务",
                        "id": 204107
                    }, {
                        "name": "杭州蚂蚁",
                        "id": 204108
                    }, {
                        "name": "北京滴滴农业有限公司",
                        "id": 204109
                    }, {
                        "name": "香港百度信息服务",
                        "id": 204110
                    }, {
                        "name": "东莞美团银行",
                        "id": 204111
                    }, {
                        "name": "杭州必胜客通信控股集团",
                        "id": 204112
                    }, {
                        "name": "天津必胜客软件控股集团",
                        "id": 204113
                    }, {
                        "name": "东京谷歌地摊控股集团",
                        "id": 204114
                    }]
                }, {
                    "name": "台北肯德基牧业",
                    "id": 204115,
                    "children": [{
                        "name": "香港亚马逊证券",
                        "id": 204116
                    }, {
                        "name": "纽约奈雪科技控股集团",
                        "id": 204117
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 204118
                    }, {
                        "name": "南京微软银行有限公司",
                        "id": 204119
                    }]
                }, {
                    "name": "上海特斯拉医药",
                    "id": 204120,
                    "children": [{
                        "name": "纽约肯德基有限公司",
                        "id": 204121
                    }, {
                        "name": "天津滴滴金融",
                        "id": 204122
                    }, {
                        "name": "杭州快手餐饮",
                        "id": 204123
                    }, {
                        "name": "南京美团证券",
                        "id": 204124
                    }, {
                        "name": "东京腾讯新能源",
                        "id": 204125
                    }, {
                        "name": "厦门必胜客诊所",
                        "id": 204126
                    }, {
                        "name": "台北喜茶互金有限公司",
                        "id": 204127
                    }, {
                        "name": "纽约星巴克",
                        "id": 204128
                    }, {
                        "name": "南京字节石油",
                        "id": 204129
                    }, {
                        "name": "首尔蚂蚁通讯",
                        "id": 204130
                    }, {
                        "name": "广州必胜客",
                        "id": 204131
                    }, {
                        "name": "厦门字节软件",
                        "id": 204132
                    }, {
                        "name": "杭州瑞幸地摊",
                        "id": 204133
                    }, {
                        "name": "香港蚂蚁金融",
                        "id": 204134
                    }, {
                        "name": "天津腾讯汽车",
                        "id": 204135
                    }, {
                        "name": "广州肯德基牧业",
                        "id": 204136
                    }, {
                        "name": "北京滴滴科技",
                        "id": 204137
                    }, {
                        "name": "杭州百度科技控股集团",
                        "id": 204138
                    }, {
                        "name": "首尔喜茶互金",
                        "id": 204139
                    }, {
                        "name": "南京亚马逊银行控股集团",
                        "id": 204140
                    }, {
                        "name": "南京百度信息服务",
                        "id": 204141
                    }, {
                        "name": "杭州阿里科技",
                        "id": 204142
                    }, {
                        "name": "香港美团旅游",
                        "id": 204143
                    }, {
                        "name": "纽约必胜客金融",
                        "id": 204144
                    }, {
                        "name": "纽约微软石油有限公司",
                        "id": 204145
                    }, {
                        "name": "杭州谷歌电商有限公司",
                        "id": 204146
                    }, {
                        "name": "广州苹果证券",
                        "id": 204147
                    }, {
                        "name": "香港蚂蚁银行",
                        "id": 204148
                    }]
                }, {
                    "name": "厦门平安通信控股集团",
                    "id": 204149
                }, {
                    "name": "厦门腾讯基金控股集团",
                    "id": 204150
                }, {
                    "name": "杭州蚂蚁电商",
                    "id": 204151
                }, {
                    "name": "杭州欧珀医药",
                    "id": 204152
                }, {
                    "name": "杭州腾讯芯片",
                    "id": 204153,
                    "children": [{
                        "name": "厦门阿里石油",
                        "id": 204154
                    }, {
                        "name": "广州腾讯餐饮有限公司",
                        "id": 204155
                    }, {
                        "name": "天津谷歌地摊",
                        "id": 204156
                    }, {
                        "name": "南京亚马逊银行",
                        "id": 204157
                    }]
                }, {
                    "name": "北京瑞幸有限公司",
                    "id": 204158,
                    "children": [{
                        "name": "天津苹果渔业",
                        "id": 204159
                    }, {
                        "name": "厦门喜茶基金",
                        "id": 204160
                    }]
                }, {
                    "name": "南京百度医药",
                    "id": 204161,
                    "children": [{
                        "name": "深圳瑞幸牧业",
                        "id": 204162
                    }, {
                        "name": "深圳快手金融控股集团",
                        "id": 204163
                    }, {
                        "name": "北京星巴克信息服务",
                        "id": 204164
                    }, {
                        "name": "杭州平安计算机控股集团",
                        "id": 204165
                    }, {
                        "name": "杭州肯德基基金",
                        "id": 204166
                    }, {
                        "name": "北京小米诊所",
                        "id": 204167
                    }, {
                        "name": "上海微软地摊",
                        "id": 204168
                    }, {
                        "name": "深圳喜茶信息服务",
                        "id": 204169
                    }]
                }, {
                    "name": "广州滴滴通讯",
                    "id": 204170,
                    "children": [{
                        "name": "香港百度电商",
                        "id": 204171
                    }, {
                        "name": "上海欧珀地产控股集团",
                        "id": 204172
                    }, {
                        "name": "杭州腾讯新能源",
                        "id": 204173
                    }, {
                        "name": "天津肯德基养殖",
                        "id": 204174
                    }, {
                        "name": "东京京东养殖有限公司",
                        "id": 204175
                    }, {
                        "name": "台北苹果地产",
                        "id": 204176
                    }, {
                        "name": "天津必胜客地摊",
                        "id": 204177
                    }, {
                        "name": "东京奈雪制造有限公司",
                        "id": 204178
                    }, {
                        "name": "杭州滴滴软件控股集团",
                        "id": 204179
                    }, {
                        "name": "东京谷歌信息服务",
                        "id": 204180
                    }, {
                        "name": "南京喜茶通信",
                        "id": 204181
                    }, {
                        "name": "深圳蚂蚁诊所",
                        "id": 204182
                    }, {
                        "name": "上海滴滴芯片",
                        "id": 204183
                    }, {
                        "name": "北京亚马逊制造有限公司",
                        "id": 204184
                    }, {
                        "name": "东京平安",
                        "id": 204185
                    }]
                }, {
                    "name": "东京小米智能",
                    "id": 204186,
                    "children": [{
                        "name": "广州微软科技有限公司",
                        "id": 204187
                    }, {
                        "name": "厦门华为地摊",
                        "id": 204188
                    }, {
                        "name": "杭州字节渔业控股集团",
                        "id": 204189
                    }, {
                        "name": "台北滴滴金融",
                        "id": 204190
                    }, {
                        "name": "广州华为地产",
                        "id": 204191
                    }, {
                        "name": "香港阿里互金控股集团",
                        "id": 204192
                    }, {
                        "name": "广州华为基金有限公司",
                        "id": 204193
                    }, {
                        "name": "纽约谷歌",
                        "id": 204194
                    }, {
                        "name": "杭州喜茶地产",
                        "id": 204195
                    }, {
                        "name": "东京京东制造",
                        "id": 204196
                    }, {
                        "name": "上海蚂蚁医药",
                        "id": 204197
                    }, {
                        "name": "北京京东计算机控股集团",
                        "id": 204198
                    }, {
                        "name": "香港瑞幸养殖",
                        "id": 204199
                    }, {
                        "name": "天津百度科技",
                        "id": 204200
                    }, {
                        "name": "首尔华为软件有限公司",
                        "id": 204201
                    }, {
                        "name": "杭州喜茶医院有限公司",
                        "id": 204202
                    }, {
                        "name": "深圳亚马逊互金",
                        "id": 204203
                    }, {
                        "name": "台北亚马逊餐饮",
                        "id": 204204
                    }, {
                        "name": "深圳滴滴信息服务",
                        "id": 204205
                    }, {
                        "name": "香港苹果医院",
                        "id": 204206
                    }, {
                        "name": "广州微软软件",
                        "id": 204207
                    }, {
                        "name": "东京平安",
                        "id": 204208
                    }, {
                        "name": "南京喜茶",
                        "id": 204209
                    }, {
                        "name": "纽约蚂蚁牧业",
                        "id": 204210
                    }, {
                        "name": "东莞微软",
                        "id": 204211
                    }, {
                        "name": "首尔小米汽车有限公司",
                        "id": 204212
                    }]
                }, {
                    "name": "东莞小米芯片",
                    "id": 204213,
                    "children": [{
                        "name": "上海奈雪牧业",
                        "id": 204214
                    }, {
                        "name": "上海阿里金融控股集团",
                        "id": 204215
                    }, {
                        "name": "天津欧珀智能",
                        "id": 204216
                    }, {
                        "name": "深圳欧珀证券",
                        "id": 204217
                    }, {
                        "name": "广州瑞幸信息服务",
                        "id": 204218
                    }]
                }, {
                    "name": "天津字节软件",
                    "id": 204219
                }, {
                    "name": "杭州百度地摊",
                    "id": 204220
                }, {
                    "name": "天津微软芯片",
                    "id": 204221
                }, {
                    "name": "杭州欧珀",
                    "id": 204222
                }]
            }, {
                "name": "香港小米基金控股集团",
                "id": 204223,
                "children": [{
                    "name": "上海快手",
                    "id": 204224
                }, {
                    "name": "上海必胜客计算机",
                    "id": 204225
                }, {
                    "name": "台北苹果地产",
                    "id": 204226
                }, {
                    "name": "东莞谷歌",
                    "id": 204227
                }, {
                    "name": "杭州平安银行",
                    "id": 204228,
                    "children": [{
                        "name": "台北蚂蚁计算机",
                        "id": 204229
                    }, {
                        "name": "南京平安农业",
                        "id": 204230
                    }, {
                        "name": "北京平安渔业有限公司",
                        "id": 204231
                    }, {
                        "name": "深圳谷歌芯片",
                        "id": 204232
                    }, {
                        "name": "南京喜茶渔业控股集团",
                        "id": 204233
                    }, {
                        "name": "杭州喜茶新能源",
                        "id": 204234
                    }, {
                        "name": "台北华为诊所控股集团",
                        "id": 204235
                    }, {
                        "name": "纽约美团渔业",
                        "id": 204236
                    }, {
                        "name": "北京百度智能有限公司",
                        "id": 204237
                    }]
                }, {
                    "name": "上海瑞幸芯片",
                    "id": 204238
                }, {
                    "name": "杭州奈雪诊所",
                    "id": 204239,
                    "children": [{
                        "name": "天津京东智能",
                        "id": 204240
                    }, {
                        "name": "厦门喜茶医药",
                        "id": 204241
                    }, {
                        "name": "厦门蚂蚁地产",
                        "id": 204242
                    }, {
                        "name": "天津微软通讯",
                        "id": 204243
                    }, {
                        "name": "台北苹果地产控股集团",
                        "id": 204244
                    }, {
                        "name": "首尔快手",
                        "id": 204245
                    }, {
                        "name": "深圳快手计算机",
                        "id": 204246
                    }, {
                        "name": "深圳快手计算机",
                        "id": 204247
                    }]
                }, {
                    "name": "台北奈雪",
                    "id": 204248
                }, {
                    "name": "香港必胜客基金",
                    "id": 204249,
                    "children": [{
                        "name": "纽约京东控股集团",
                        "id": 204250
                    }, {
                        "name": "厦门小米餐饮有限公司",
                        "id": 204251
                    }, {
                        "name": "广州美团基金",
                        "id": 204252
                    }, {
                        "name": "纽约奈雪制造控股集团",
                        "id": 204253
                    }, {
                        "name": "天津肯德基石油",
                        "id": 204254
                    }, {
                        "name": "首尔蚂蚁餐饮",
                        "id": 204255
                    }, {
                        "name": "深圳小米诊所控股集团",
                        "id": 204256
                    }, {
                        "name": "天津喜茶牧业",
                        "id": 204257
                    }, {
                        "name": "南京京东智能",
                        "id": 204258
                    }, {
                        "name": "首尔瑞幸新能源",
                        "id": 204259
                    }, {
                        "name": "杭州京东餐饮有限公司",
                        "id": 204260
                    }, {
                        "name": "杭州字节新能源",
                        "id": 204261
                    }, {
                        "name": "深圳欧珀医药",
                        "id": 204262
                    }, {
                        "name": "东京字节养殖有限公司",
                        "id": 204263
                    }, {
                        "name": "首尔奈雪智能有限公司",
                        "id": 204264
                    }, {
                        "name": "上海星巴克餐饮",
                        "id": 204265
                    }, {
                        "name": "首尔苹果信息服务",
                        "id": 204266
                    }, {
                        "name": "香港喜茶银行",
                        "id": 204267
                    }, {
                        "name": "天津瑞幸控股集团",
                        "id": 204268
                    }, {
                        "name": "广州苹果诊所",
                        "id": 204269
                    }, {
                        "name": "台北华为软件控股集团",
                        "id": 204270
                    }, {
                        "name": "北京京东制造有限公司",
                        "id": 204271
                    }, {
                        "name": "杭州京东",
                        "id": 204272
                    }, {
                        "name": "广州奈雪软件",
                        "id": 204273
                    }, {
                        "name": "杭州欧珀基金",
                        "id": 204274
                    }, {
                        "name": "首尔百度芯片",
                        "id": 204275
                    }, {
                        "name": "首尔肯德基",
                        "id": 204276
                    }, {
                        "name": "香港谷歌计算机",
                        "id": 204277
                    }, {
                        "name": "纽约亚马逊科技",
                        "id": 204278
                    }, {
                        "name": "东莞亚马逊牧业",
                        "id": 204279
                    }, {
                        "name": "南京微软金融",
                        "id": 204280
                    }, {
                        "name": "东京京东航空有限公司",
                        "id": 204281
                    }, {
                        "name": "厦门谷歌科技",
                        "id": 204282
                    }, {
                        "name": "台北微软控股集团",
                        "id": 204283
                    }, {
                        "name": "天津阿里医院",
                        "id": 204284
                    }]
                }, {
                    "name": "台北特斯拉信息服务",
                    "id": 204285,
                    "children": [{
                        "name": "深圳瑞幸金融",
                        "id": 204286
                    }, {
                        "name": "北京平安农业",
                        "id": 204287
                    }, {
                        "name": "北京快手牧业",
                        "id": 204288
                    }, {
                        "name": "首尔美团有限公司",
                        "id": 204289
                    }, {
                        "name": "天津腾讯证券",
                        "id": 204290
                    }, {
                        "name": "东莞苹果证券控股集团",
                        "id": 204291
                    }, {
                        "name": "杭州字节",
                        "id": 204292
                    }, {
                        "name": "台北蚂蚁农业",
                        "id": 204293
                    }, {
                        "name": "东京特斯拉诊所有限公司",
                        "id": 204294
                    }, {
                        "name": "纽约微软通信",
                        "id": 204295
                    }, {
                        "name": "纽约苹果旅游控股集团",
                        "id": 204296
                    }, {
                        "name": "杭州百度农业有限公司",
                        "id": 204297
                    }, {
                        "name": "杭州华为银行",
                        "id": 204298
                    }, {
                        "name": "台北美团新能源",
                        "id": 204299
                    }, {
                        "name": "首尔滴滴新能源",
                        "id": 204300
                    }]
                }, {
                    "name": "首尔平安基金",
                    "id": 204301
                }, {
                    "name": "厦门小米旅游",
                    "id": 204302
                }, {
                    "name": "香港美团医药",
                    "id": 204303
                }, {
                    "name": "纽约平安科技",
                    "id": 204304
                }]
            }, {
                "name": "深圳京东",
                "id": 204305
            }, {
                "name": "台北肯德基金融",
                "id": 204306
            }, {
                "name": "首尔苹果汽车",
                "id": 204307
            }, {
                "name": "天津谷歌电商",
                "id": 204308,
                "children": [{
                    "name": "厦门苹果智能有限公司",
                    "id": 204309
                }, {
                    "name": "南京美团石油",
                    "id": 204310
                }, {
                    "name": "纽约必胜客",
                    "id": 204311
                }, {
                    "name": "纽约肯德基通讯",
                    "id": 204312
                }, {
                    "name": "南京字节石油控股集团",
                    "id": 204313
                }, {
                    "name": "香港字节软件",
                    "id": 204314,
                    "children": [{
                        "name": "南京小米医药",
                        "id": 204315
                    }, {
                        "name": "北京欧珀信息服务",
                        "id": 204316
                    }, {
                        "name": "东莞快手地摊有限公司",
                        "id": 204317
                    }, {
                        "name": "深圳滴滴诊所控股集团",
                        "id": 204318
                    }, {
                        "name": "广州快手地产",
                        "id": 204319
                    }]
                }, {
                    "name": "首尔欧珀科技",
                    "id": 204320
                }, {
                    "name": "厦门奈雪航空",
                    "id": 204321
                }, {
                    "name": "南京字节通讯",
                    "id": 204322
                }, {
                    "name": "东京苹果智能",
                    "id": 204323
                }, {
                    "name": "杭州喜茶汽车",
                    "id": 204324
                }, {
                    "name": "厦门微软诊所有限公司",
                    "id": 204325
                }, {
                    "name": "杭州快手科技",
                    "id": 204326
                }, {
                    "name": "天津百度基金有限公司",
                    "id": 204327
                }, {
                    "name": "北京必胜客基金有限公司",
                    "id": 204328
                }, {
                    "name": "北京百度农业",
                    "id": 204329
                }, {
                    "name": "东莞星巴克制造有限公司",
                    "id": 204330
                }, {
                    "name": "杭州京东石油",
                    "id": 204331
                }, {
                    "name": "深圳肯德基农业控股集团",
                    "id": 204332
                }, {
                    "name": "台北苹果医院控股集团",
                    "id": 204333
                }, {
                    "name": "厦门阿里农业控股集团",
                    "id": 204334,
                    "children": [{
                        "name": "天津京东",
                        "id": 204335
                    }, {
                        "name": "杭州喜茶电商有限公司",
                        "id": 204336
                    }, {
                        "name": "上海欧珀新能源控股集团",
                        "id": 204337
                    }, {
                        "name": "杭州平安电商",
                        "id": 204338
                    }, {
                        "name": "天津肯德基证券",
                        "id": 204339
                    }, {
                        "name": "南京瑞幸芯片有限公司",
                        "id": 204340
                    }, {
                        "name": "首尔瑞幸电商有限公司",
                        "id": 204341
                    }, {
                        "name": "纽约肯德基芯片",
                        "id": 204342
                    }, {
                        "name": "天津小米智能",
                        "id": 204343
                    }, {
                        "name": "北京平安互金",
                        "id": 204344
                    }, {
                        "name": "香港华为农业",
                        "id": 204345
                    }, {
                        "name": "台北微软诊所",
                        "id": 204346
                    }, {
                        "name": "北京腾讯旅游",
                        "id": 204347
                    }, {
                        "name": "杭州必胜客基金有限公司",
                        "id": 204348
                    }, {
                        "name": "广州星巴克地摊",
                        "id": 204349
                    }, {
                        "name": "首尔奈雪基金",
                        "id": 204350
                    }, {
                        "name": "首尔蚂蚁",
                        "id": 204351
                    }, {
                        "name": "香港平安餐饮",
                        "id": 204352
                    }, {
                        "name": "东京谷歌软件有限公司",
                        "id": 204353
                    }, {
                        "name": "东京滴滴农业控股集团",
                        "id": 204354
                    }, {
                        "name": "厦门蚂蚁渔业控股集团",
                        "id": 204355
                    }, {
                        "name": "北京华为诊所",
                        "id": 204356
                    }, {
                        "name": "东京亚马逊石油",
                        "id": 204357
                    }, {
                        "name": "南京必胜客软件",
                        "id": 204358
                    }, {
                        "name": "东莞京东智能",
                        "id": 204359
                    }, {
                        "name": "纽约谷歌电商",
                        "id": 204360
                    }, {
                        "name": "上海百度互金有限公司",
                        "id": 204361
                    }, {
                        "name": "台北快手制造控股集团",
                        "id": 204362
                    }, {
                        "name": "首尔字节新能源",
                        "id": 204363
                    }, {
                        "name": "天津快手医药",
                        "id": 204364
                    }, {
                        "name": "东莞微软制造",
                        "id": 204365
                    }, {
                        "name": "杭州滴滴计算机",
                        "id": 204366
                    }, {
                        "name": "香港蚂蚁软件",
                        "id": 204367
                    }]
                }, {
                    "name": "纽约小米控股集团",
                    "id": 204368,
                    "children": [{
                        "name": "台北华为地摊",
                        "id": 204369
                    }, {
                        "name": "深圳滴滴牧业控股集团",
                        "id": 204370
                    }, {
                        "name": "北京瑞幸地产",
                        "id": 204371
                    }, {
                        "name": "杭州百度航空",
                        "id": 204372
                    }, {
                        "name": "首尔欧珀控股集团",
                        "id": 204373
                    }]
                }]
            }, {
                "name": "东莞小米基金",
                "id": 204374
            }, {
                "name": "南京华为",
                "id": 204375
            }, {
                "name": "厦门微软新能源",
                "id": 204376
            }, {
                "name": "台北瑞幸诊所控股集团",
                "id": 204377
            }, {
                "name": "杭州百度餐饮控股集团",
                "id": 204378
            }, {
                "name": "杭州微软旅游有限公司",
                "id": 204379
            }, {
                "name": "上海华为通讯",
                "id": 204380
            }, {
                "name": "厦门蚂蚁制造有限公司",
                "id": 204381
            }]
        }, {
            "name": "东莞小米控股集团",
            "id": 204382
        }, {
            "name": "广州阿里基金",
            "id": 204383
        }, {
            "name": "台北微软",
            "id": 204384
        }]
    }, {
        "name": "南京必胜客制造",
        "id": 204385
    }, {
        "name": "北京腾讯通讯",
        "id": 204386
    }, {
        "name": "北京亚马逊汽车控股集团",
        "id": 204387,
        "children": [{
            "name": "广州滴滴",
            "id": 204388
        }, {
            "name": "广州美团计算机",
            "id": 204389
        }, {
            "name": "广州肯德基医药",
            "id": 204390,
            "children": [{
                "name": "厦门阿里控股集团",
                "id": 204391
            }, {
                "name": "北京华为新能源控股集团",
                "id": 204392
            }, {
                "name": "首尔瑞幸",
                "id": 204393
            }, {
                "name": "杭州平安",
                "id": 204394,
                "children": [{
                    "name": "香港滴滴智能控股集团",
                    "id": 204395
                }, {
                    "name": "广州京东渔业",
                    "id": 204396,
                    "children": [{
                        "name": "纽约微软金融",
                        "id": 204397
                    }, {
                        "name": "杭州滴滴金融有限公司",
                        "id": 204398
                    }, {
                        "name": "天津字节石油有限公司",
                        "id": 204399
                    }, {
                        "name": "杭州字节",
                        "id": 204400
                    }, {
                        "name": "台北腾讯金融",
                        "id": 204401
                    }, {
                        "name": "杭州苹果信息服务控股集团",
                        "id": 204402
                    }, {
                        "name": "天津喜茶汽车控股集团",
                        "id": 204403
                    }, {
                        "name": "广州美团银行",
                        "id": 204404
                    }, {
                        "name": "广州星巴克基金",
                        "id": 204405
                    }, {
                        "name": "南京蚂蚁地摊",
                        "id": 204406
                    }, {
                        "name": "东京华为通信",
                        "id": 204407
                    }, {
                        "name": "天津必胜客计算机控股集团",
                        "id": 204408
                    }, {
                        "name": "广州必胜客金融有限公司",
                        "id": 204409
                    }, {
                        "name": "东莞快手渔业有限公司",
                        "id": 204410
                    }, {
                        "name": "东莞特斯拉医院",
                        "id": 204411
                    }, {
                        "name": "上海平安通讯有限公司",
                        "id": 204412
                    }, {
                        "name": "南京喜茶地摊",
                        "id": 204413
                    }, {
                        "name": "广州欧珀旅游",
                        "id": 204414
                    }, {
                        "name": "香港特斯拉智能",
                        "id": 204415
                    }, {
                        "name": "杭州平安通讯",
                        "id": 204416
                    }, {
                        "name": "厦门奈雪航空有限公司",
                        "id": 204417
                    }, {
                        "name": "杭州苹果互金",
                        "id": 204418
                    }, {
                        "name": "北京微软地摊",
                        "id": 204419
                    }, {
                        "name": "东京星巴克控股集团",
                        "id": 204420
                    }, {
                        "name": "南京欧珀医院有限公司",
                        "id": 204421
                    }, {
                        "name": "厦门微软汽车",
                        "id": 204422
                    }, {
                        "name": "香港平安制造",
                        "id": 204423
                    }]
                }, {
                    "name": "首尔阿里计算机有限公司",
                    "id": 204424,
                    "children": [{
                        "name": "东莞滴滴金融",
                        "id": 204425
                    }, {
                        "name": "北京快手有限公司",
                        "id": 204426
                    }, {
                        "name": "杭州滴滴制造有限公司",
                        "id": 204427
                    }, {
                        "name": "上海喜茶牧业",
                        "id": 204428
                    }, {
                        "name": "杭州肯德基信息服务有限公司",
                        "id": 204429
                    }, {
                        "name": "杭州蚂蚁智能",
                        "id": 204430
                    }, {
                        "name": "杭州喜茶牧业",
                        "id": 204431
                    }, {
                        "name": "台北微软科技有限公司",
                        "id": 204432
                    }, {
                        "name": "杭州瑞幸通信有限公司",
                        "id": 204433
                    }, {
                        "name": "天津京东有限公司",
                        "id": 204434
                    }, {
                        "name": "香港平安新能源控股集团",
                        "id": 204435
                    }]
                }, {
                    "name": "东莞字节医药",
                    "id": 204436
                }, {
                    "name": "天津平安渔业",
                    "id": 204437,
                    "children": [{
                        "name": "杭州快手航空",
                        "id": 204438
                    }, {
                        "name": "纽约蚂蚁互金控股集团",
                        "id": 204439
                    }, {
                        "name": "广州亚马逊电商控股集团",
                        "id": 204440
                    }, {
                        "name": "深圳字节金融",
                        "id": 204441
                    }, {
                        "name": "广州肯德基牧业",
                        "id": 204442
                    }, {
                        "name": "首尔谷歌芯片",
                        "id": 204443
                    }, {
                        "name": "杭州平安新能源",
                        "id": 204444
                    }, {
                        "name": "杭州奈雪智能",
                        "id": 204445
                    }, {
                        "name": "杭州瑞幸旅游",
                        "id": 204446
                    }, {
                        "name": "北京快手地产",
                        "id": 204447
                    }, {
                        "name": "南京必胜客渔业控股集团",
                        "id": 204448
                    }, {
                        "name": "杭州必胜客医院",
                        "id": 204449
                    }, {
                        "name": "北京美团汽车",
                        "id": 204450
                    }, {
                        "name": "东京阿里互金",
                        "id": 204451
                    }, {
                        "name": "厦门必胜客科技控股集团",
                        "id": 204452
                    }, {
                        "name": "上海京东汽车有限公司",
                        "id": 204453
                    }, {
                        "name": "南京必胜客医药有限公司",
                        "id": 204454
                    }, {
                        "name": "南京亚马逊地产",
                        "id": 204455
                    }, {
                        "name": "深圳百度旅游",
                        "id": 204456
                    }, {
                        "name": "北京阿里地产有限公司",
                        "id": 204457
                    }, {
                        "name": "天津京东电商控股集团",
                        "id": 204458
                    }]
                }, {
                    "name": "杭州瑞幸基金",
                    "id": 204459
                }, {
                    "name": "深圳京东信息服务",
                    "id": 204460
                }, {
                    "name": "东莞京东地产",
                    "id": 204461,
                    "children": [{
                        "name": "北京小米智能",
                        "id": 204462
                    }, {
                        "name": "台北奈雪农业有限公司",
                        "id": 204463
                    }, {
                        "name": "杭州肯德基互金",
                        "id": 204464
                    }, {
                        "name": "南京微软制造",
                        "id": 204465
                    }, {
                        "name": "杭州快手通讯有限公司",
                        "id": 204466
                    }, {
                        "name": "深圳奈雪石油控股集团",
                        "id": 204467
                    }, {
                        "name": "台北阿里银行",
                        "id": 204468
                    }, {
                        "name": "厦门微软航空控股集团",
                        "id": 204469
                    }, {
                        "name": "天津亚马逊通信有限公司",
                        "id": 204470
                    }, {
                        "name": "香港华为电商",
                        "id": 204471
                    }, {
                        "name": "香港必胜客汽车",
                        "id": 204472
                    }, {
                        "name": "东京字节银行控股集团",
                        "id": 204473
                    }, {
                        "name": "香港美团地摊有限公司",
                        "id": 204474
                    }, {
                        "name": "厦门快手牧业",
                        "id": 204475
                    }, {
                        "name": "香港蚂蚁医院",
                        "id": 204476
                    }, {
                        "name": "广州蚂蚁汽车",
                        "id": 204477
                    }, {
                        "name": "厦门特斯拉通信控股集团",
                        "id": 204478
                    }, {
                        "name": "东京快手新能源控股集团",
                        "id": 204479
                    }, {
                        "name": "纽约华为牧业",
                        "id": 204480
                    }, {
                        "name": "杭州肯德基基金控股集团",
                        "id": 204481
                    }, {
                        "name": "东莞肯德基智能",
                        "id": 204482
                    }, {
                        "name": "深圳亚马逊餐饮",
                        "id": 204483
                    }, {
                        "name": "纽约字节餐饮",
                        "id": 204484
                    }, {
                        "name": "东京字节医药控股集团",
                        "id": 204485
                    }]
                }, {
                    "name": "纽约亚马逊通讯",
                    "id": 204486,
                    "children": [{
                        "name": "北京字节基金",
                        "id": 204487
                    }, {
                        "name": "东莞特斯拉金融有限公司",
                        "id": 204488
                    }, {
                        "name": "东京华为养殖",
                        "id": 204489
                    }, {
                        "name": "天津瑞幸",
                        "id": 204490
                    }, {
                        "name": "台北奈雪银行",
                        "id": 204491
                    }, {
                        "name": "北京滴滴",
                        "id": 204492
                    }, {
                        "name": "杭州瑞幸旅游",
                        "id": 204493
                    }, {
                        "name": "首尔瑞幸地摊有限公司",
                        "id": 204494
                    }, {
                        "name": "天津亚马逊",
                        "id": 204495
                    }]
                }, {
                    "name": "台北奈雪诊所控股集团",
                    "id": 204496,
                    "children": [{
                        "name": "纽约肯德基地摊",
                        "id": 204497
                    }, {
                        "name": "台北必胜客旅游",
                        "id": 204498
                    }, {
                        "name": "天津京东智能控股集团",
                        "id": 204499
                    }, {
                        "name": "北京星巴克证券",
                        "id": 204500
                    }, {
                        "name": "台北华为芯片",
                        "id": 204501
                    }, {
                        "name": "杭州蚂蚁餐饮",
                        "id": 204502
                    }, {
                        "name": "台北谷歌银行有限公司",
                        "id": 204503
                    }, {
                        "name": "纽约美团地产",
                        "id": 204504
                    }, {
                        "name": "首尔字节航空",
                        "id": 204505
                    }, {
                        "name": "南京奈雪牧业",
                        "id": 204506
                    }, {
                        "name": "东京美团地摊",
                        "id": 204507
                    }, {
                        "name": "南京特斯拉制造有限公司",
                        "id": 204508
                    }, {
                        "name": "杭州小米养殖",
                        "id": 204509
                    }, {
                        "name": "杭州肯德基",
                        "id": 204510
                    }, {
                        "name": "纽约滴滴农业",
                        "id": 204511
                    }, {
                        "name": "纽约京东医院有限公司",
                        "id": 204512
                    }, {
                        "name": "天津美团旅游",
                        "id": 204513
                    }, {
                        "name": "台北腾讯新能源有限公司",
                        "id": 204514
                    }, {
                        "name": "东莞喜茶银行控股集团",
                        "id": 204515
                    }, {
                        "name": "杭州京东金融",
                        "id": 204516
                    }, {
                        "name": "厦门奈雪通信有限公司",
                        "id": 204517
                    }, {
                        "name": "东京微软新能源",
                        "id": 204518
                    }, {
                        "name": "北京华为医药",
                        "id": 204519
                    }, {
                        "name": "东莞瑞幸旅游有限公司",
                        "id": 204520
                    }, {
                        "name": "台北瑞幸银行",
                        "id": 204521
                    }, {
                        "name": "南京小米信息服务",
                        "id": 204522
                    }, {
                        "name": "杭州奈雪石油有限公司",
                        "id": 204523
                    }, {
                        "name": "东莞奈雪软件",
                        "id": 204524
                    }, {
                        "name": "杭州苹果石油",
                        "id": 204525
                    }, {
                        "name": "杭州苹果医药",
                        "id": 204526
                    }, {
                        "name": "北京华为基金",
                        "id": 204527
                    }, {
                        "name": "香港阿里餐饮有限公司",
                        "id": 204528
                    }, {
                        "name": "香港阿里软件",
                        "id": 204529
                    }, {
                        "name": "首尔必胜客养殖",
                        "id": 204530
                    }, {
                        "name": "天津小米电商有限公司",
                        "id": 204531
                    }, {
                        "name": "杭州滴滴有限公司",
                        "id": 204532
                    }]
                }, {
                    "name": "东莞欧珀计算机有限公司",
                    "id": 204533
                }, {
                    "name": "北京平安诊所有限公司",
                    "id": 204534
                }, {
                    "name": "杭州瑞幸餐饮",
                    "id": 204535
                }, {
                    "name": "天津平安医院",
                    "id": 204536,
                    "children": [{
                        "name": "厦门苹果地摊",
                        "id": 204537
                    }, {
                        "name": "深圳华为芯片",
                        "id": 204538
                    }, {
                        "name": "东京蚂蚁互金",
                        "id": 204539
                    }, {
                        "name": "广州欧珀医药有限公司",
                        "id": 204540
                    }, {
                        "name": "厦门百度信息服务",
                        "id": 204541
                    }, {
                        "name": "天津京东制造控股集团",
                        "id": 204542
                    }, {
                        "name": "台北字节基金",
                        "id": 204543
                    }, {
                        "name": "杭州美团通讯",
                        "id": 204544
                    }, {
                        "name": "首尔腾讯医药",
                        "id": 204545
                    }, {
                        "name": "上海特斯拉银行",
                        "id": 204546
                    }, {
                        "name": "首尔阿里电商有限公司",
                        "id": 204547
                    }, {
                        "name": "香港肯德基汽车有限公司",
                        "id": 204548
                    }, {
                        "name": "天津华为地摊",
                        "id": 204549
                    }, {
                        "name": "北京华为养殖控股集团",
                        "id": 204550
                    }, {
                        "name": "纽约快手基金",
                        "id": 204551
                    }, {
                        "name": "纽约苹果农业",
                        "id": 204552
                    }, {
                        "name": "天津腾讯信息服务",
                        "id": 204553
                    }, {
                        "name": "天津字节地产",
                        "id": 204554
                    }, {
                        "name": "天津华为计算机",
                        "id": 204555
                    }, {
                        "name": "上海腾讯地摊",
                        "id": 204556
                    }]
                }, {
                    "name": "东京瑞幸牧业",
                    "id": 204557
                }, {
                    "name": "东京腾讯制造控股集团",
                    "id": 204558
                }, {
                    "name": "北京字节牧业",
                    "id": 204559
                }, {
                    "name": "首尔华为信息服务",
                    "id": 204560,
                    "children": [{
                        "name": "纽约欧珀牧业有限公司",
                        "id": 204561
                    }, {
                        "name": "台北必胜客养殖",
                        "id": 204562
                    }, {
                        "name": "北京滴滴电商",
                        "id": 204563
                    }, {
                        "name": "厦门星巴克汽车",
                        "id": 204564
                    }, {
                        "name": "北京谷歌诊所",
                        "id": 204565
                    }, {
                        "name": "纽约必胜客科技",
                        "id": 204566
                    }, {
                        "name": "天津瑞幸基金",
                        "id": 204567
                    }, {
                        "name": "广州欧珀制造",
                        "id": 204568
                    }, {
                        "name": "深圳华为通讯",
                        "id": 204569
                    }, {
                        "name": "杭州星巴克计算机",
                        "id": 204570
                    }, {
                        "name": "深圳腾讯证券有限公司",
                        "id": 204571
                    }, {
                        "name": "天津星巴克智能控股集团",
                        "id": 204572
                    }, {
                        "name": "香港亚马逊石油有限公司",
                        "id": 204573
                    }, {
                        "name": "东京腾讯渔业",
                        "id": 204574
                    }, {
                        "name": "纽约腾讯基金有限公司",
                        "id": 204575
                    }, {
                        "name": "天津平安金融控股集团",
                        "id": 204576
                    }, {
                        "name": "深圳微软通讯控股集团",
                        "id": 204577
                    }, {
                        "name": "广州喜茶证券",
                        "id": 204578
                    }, {
                        "name": "东莞瑞幸汽车",
                        "id": 204579
                    }, {
                        "name": "纽约腾讯汽车",
                        "id": 204580
                    }, {
                        "name": "东京肯德基银行控股集团",
                        "id": 204581
                    }, {
                        "name": "南京蚂蚁软件控股集团",
                        "id": 204582
                    }, {
                        "name": "北京字节",
                        "id": 204583
                    }, {
                        "name": "东莞字节养殖",
                        "id": 204584
                    }, {
                        "name": "香港特斯拉",
                        "id": 204585
                    }, {
                        "name": "深圳苹果诊所",
                        "id": 204586
                    }, {
                        "name": "厦门小米银行控股集团",
                        "id": 204587
                    }, {
                        "name": "东京小米航空",
                        "id": 204588
                    }, {
                        "name": "杭州百度控股集团",
                        "id": 204589
                    }]
                }, {
                    "name": "东京阿里餐饮控股集团",
                    "id": 204590,
                    "children": [{
                        "name": "台北奈雪餐饮控股集团",
                        "id": 204591
                    }, {
                        "name": "厦门特斯拉旅游",
                        "id": 204592
                    }, {
                        "name": "杭州肯德基医院",
                        "id": 204593
                    }, {
                        "name": "天津奈雪金融",
                        "id": 204594
                    }, {
                        "name": "天津欧珀医药有限公司",
                        "id": 204595
                    }, {
                        "name": "杭州瑞幸养殖",
                        "id": 204596
                    }, {
                        "name": "香港百度互金",
                        "id": 204597
                    }, {
                        "name": "广州快手互金有限公司",
                        "id": 204598
                    }, {
                        "name": "杭州平安汽车控股集团",
                        "id": 204599
                    }, {
                        "name": "厦门美团通讯",
                        "id": 204600
                    }, {
                        "name": "北京瑞幸石油",
                        "id": 204601
                    }, {
                        "name": "首尔小米通讯有限公司",
                        "id": 204602
                    }, {
                        "name": "杭州华为互金",
                        "id": 204603
                    }, {
                        "name": "广州华为科技",
                        "id": 204604
                    }, {
                        "name": "深圳肯德基芯片",
                        "id": 204605
                    }, {
                        "name": "首尔小米渔业有限公司",
                        "id": 204606
                    }, {
                        "name": "杭州滴滴计算机",
                        "id": 204607
                    }, {
                        "name": "香港肯德基新能源控股集团",
                        "id": 204608
                    }, {
                        "name": "广州奈雪医药",
                        "id": 204609
                    }, {
                        "name": "天津平安智能",
                        "id": 204610
                    }, {
                        "name": "厦门星巴克渔业有限公司",
                        "id": 204611
                    }, {
                        "name": "纽约腾讯汽车",
                        "id": 204612
                    }, {
                        "name": "天津必胜客",
                        "id": 204613
                    }, {
                        "name": "杭州喜茶制造",
                        "id": 204614
                    }, {
                        "name": "香港美团诊所控股集团",
                        "id": 204615
                    }, {
                        "name": "台北蚂蚁计算机",
                        "id": 204616
                    }, {
                        "name": "杭州百度金融控股集团",
                        "id": 204617
                    }, {
                        "name": "天津京东旅游",
                        "id": 204618
                    }, {
                        "name": "纽约奈雪旅游有限公司",
                        "id": 204619
                    }, {
                        "name": "杭州奈雪基金有限公司",
                        "id": 204620
                    }, {
                        "name": "杭州京东牧业",
                        "id": 204621
                    }, {
                        "name": "纽约快手基金",
                        "id": 204622
                    }, {
                        "name": "杭州百度金融有限公司",
                        "id": 204623
                    }, {
                        "name": "东莞字节牧业",
                        "id": 204624
                    }, {
                        "name": "台北必胜客农业有限公司",
                        "id": 204625
                    }]
                }, {
                    "name": "台北特斯拉基金",
                    "id": 204626,
                    "children": [{
                        "name": "杭州京东餐饮有限公司",
                        "id": 204627
                    }, {
                        "name": "南京肯德基石油",
                        "id": 204628
                    }, {
                        "name": "深圳字节通信控股集团",
                        "id": 204629
                    }, {
                        "name": "杭州瑞幸信息服务控股集团",
                        "id": 204630
                    }, {
                        "name": "北京肯德基餐饮有限公司",
                        "id": 204631
                    }, {
                        "name": "台北喜茶地产有限公司",
                        "id": 204632
                    }, {
                        "name": "东京阿里诊所有限公司",
                        "id": 204633
                    }, {
                        "name": "杭州腾讯",
                        "id": 204634
                    }, {
                        "name": "杭州百度计算机控股集团",
                        "id": 204635
                    }, {
                        "name": "上海苹果制造控股集团",
                        "id": 204636
                    }, {
                        "name": "台北腾讯",
                        "id": 204637
                    }, {
                        "name": "广州阿里诊所有限公司",
                        "id": 204638
                    }, {
                        "name": "南京京东制造",
                        "id": 204639
                    }, {
                        "name": "上海腾讯地产",
                        "id": 204640
                    }, {
                        "name": "上海百度渔业有限公司",
                        "id": 204641
                    }, {
                        "name": "上海星巴克餐饮",
                        "id": 204642
                    }, {
                        "name": "台北蚂蚁芯片",
                        "id": 204643
                    }, {
                        "name": "北京微软汽车",
                        "id": 204644
                    }, {
                        "name": "北京星巴克互金有限公司",
                        "id": 204645
                    }, {
                        "name": "广州滴滴诊所",
                        "id": 204646
                    }, {
                        "name": "厦门百度医院有限公司",
                        "id": 204647
                    }, {
                        "name": "广州快手通信",
                        "id": 204648
                    }, {
                        "name": "台北奈雪科技",
                        "id": 204649
                    }, {
                        "name": "厦门字节养殖",
                        "id": 204650
                    }, {
                        "name": "上海华为科技控股集团",
                        "id": 204651
                    }, {
                        "name": "天津谷歌智能",
                        "id": 204652
                    }, {
                        "name": "天津百度",
                        "id": 204653
                    }, {
                        "name": "深圳字节通信",
                        "id": 204654
                    }, {
                        "name": "纽约瑞幸通信有限公司",
                        "id": 204655
                    }, {
                        "name": "上海苹果旅游",
                        "id": 204656
                    }, {
                        "name": "东京小米",
                        "id": 204657
                    }, {
                        "name": "杭州苹果电商",
                        "id": 204658
                    }]
                }]
            }, {
                "name": "台北谷歌通信",
                "id": 204659
            }, {
                "name": "香港奈雪基金",
                "id": 204660
            }, {
                "name": "广州奈雪医药",
                "id": 204661
            }, {
                "name": "东莞字节汽车",
                "id": 204662
            }, {
                "name": "东莞腾讯汽车",
                "id": 204663,
                "children": [{
                    "name": "厦门平安石油控股集团",
                    "id": 204664,
                    "children": [{
                        "name": "台北瑞幸有限公司",
                        "id": 204665
                    }, {
                        "name": "东莞瑞幸计算机控股集团",
                        "id": 204666
                    }, {
                        "name": "东京苹果电商",
                        "id": 204667
                    }, {
                        "name": "台北阿里石油",
                        "id": 204668
                    }, {
                        "name": "香港星巴克基金有限公司",
                        "id": 204669
                    }, {
                        "name": "杭州华为软件",
                        "id": 204670
                    }, {
                        "name": "上海滴滴医药",
                        "id": 204671
                    }, {
                        "name": "香港亚马逊软件有限公司",
                        "id": 204672
                    }, {
                        "name": "天津微软科技",
                        "id": 204673
                    }, {
                        "name": "杭州快手餐饮",
                        "id": 204674
                    }, {
                        "name": "东莞苹果牧业",
                        "id": 204675
                    }, {
                        "name": "东京阿里基金有限公司",
                        "id": 204676
                    }, {
                        "name": "南京星巴克医院",
                        "id": 204677
                    }, {
                        "name": "首尔必胜客金融",
                        "id": 204678
                    }]
                }, {
                    "name": "深圳谷歌科技",
                    "id": 204679
                }, {
                    "name": "南京必胜客银行",
                    "id": 204680
                }, {
                    "name": "南京阿里航空有限公司",
                    "id": 204681
                }]
            }, {
                "name": "厦门亚马逊互金有限公司",
                "id": 204682,
                "children": [{
                    "name": "杭州快手养殖有限公司",
                    "id": 204683,
                    "children": [{
                        "name": "杭州微软航空",
                        "id": 204684
                    }, {
                        "name": "香港蚂蚁芯片",
                        "id": 204685
                    }]
                }, {
                    "name": "杭州微软农业有限公司",
                    "id": 204686,
                    "children": [{
                        "name": "上海京东电商",
                        "id": 204687
                    }, {
                        "name": "天津特斯拉汽车",
                        "id": 204688
                    }]
                }, {
                    "name": "南京微软信息服务有限公司",
                    "id": 204689,
                    "children": [{
                        "name": "上海肯德基医院有限公司",
                        "id": 204690
                    }, {
                        "name": "香港特斯拉餐饮控股集团",
                        "id": 204691
                    }, {
                        "name": "纽约小米地产",
                        "id": 204692
                    }, {
                        "name": "东京华为基金",
                        "id": 204693
                    }, {
                        "name": "上海必胜客制造",
                        "id": 204694
                    }, {
                        "name": "天津特斯拉",
                        "id": 204695
                    }, {
                        "name": "深圳喜茶地产",
                        "id": 204696
                    }, {
                        "name": "台北亚马逊电商",
                        "id": 204697
                    }, {
                        "name": "北京小米",
                        "id": 204698
                    }, {
                        "name": "北京百度",
                        "id": 204699
                    }, {
                        "name": "厦门特斯拉通信控股集团",
                        "id": 204700
                    }, {
                        "name": "香港蚂蚁新能源控股集团",
                        "id": 204701
                    }, {
                        "name": "厦门百度地摊控股集团",
                        "id": 204702
                    }, {
                        "name": "杭州快手汽车控股集团",
                        "id": 204703
                    }, {
                        "name": "台北必胜客智能",
                        "id": 204704
                    }, {
                        "name": "东京特斯拉制造",
                        "id": 204705
                    }, {
                        "name": "香港平安通信",
                        "id": 204706
                    }, {
                        "name": "台北亚马逊新能源有限公司",
                        "id": 204707
                    }, {
                        "name": "南京亚马逊计算机控股集团",
                        "id": 204708
                    }, {
                        "name": "天津百度医院有限公司",
                        "id": 204709
                    }, {
                        "name": "台北百度医药控股集团",
                        "id": 204710
                    }, {
                        "name": "香港亚马逊汽车控股集团",
                        "id": 204711
                    }, {
                        "name": "香港京东渔业控股集团",
                        "id": 204712
                    }, {
                        "name": "南京腾讯旅游有限公司",
                        "id": 204713
                    }, {
                        "name": "首尔美团牧业",
                        "id": 204714
                    }, {
                        "name": "杭州京东基金有限公司",
                        "id": 204715
                    }, {
                        "name": "东莞亚马逊制造",
                        "id": 204716
                    }, {
                        "name": "杭州美团",
                        "id": 204717
                    }, {
                        "name": "天津蚂蚁制造",
                        "id": 204718
                    }]
                }, {
                    "name": "上海字节新能源控股集团",
                    "id": 204719
                }, {
                    "name": "纽约蚂蚁电商",
                    "id": 204720
                }, {
                    "name": "天津星巴克互金",
                    "id": 204721
                }, {
                    "name": "上海微软金融控股集团",
                    "id": 204722
                }, {
                    "name": "纽约百度地产",
                    "id": 204723
                }, {
                    "name": "北京滴滴电商",
                    "id": 204724
                }, {
                    "name": "纽约百度金融",
                    "id": 204725
                }, {
                    "name": "首尔苹果农业",
                    "id": 204726,
                    "children": [{
                        "name": "厦门华为制造",
                        "id": 204727
                    }, {
                        "name": "首尔欧珀制造",
                        "id": 204728
                    }, {
                        "name": "纽约特斯拉通讯有限公司",
                        "id": 204729
                    }, {
                        "name": "厦门京东地产",
                        "id": 204730
                    }, {
                        "name": "杭州必胜客芯片控股集团",
                        "id": 204731
                    }, {
                        "name": "东京谷歌石油",
                        "id": 204732
                    }, {
                        "name": "广州瑞幸金融",
                        "id": 204733
                    }, {
                        "name": "东京谷歌诊所",
                        "id": 204734
                    }, {
                        "name": "首尔瑞幸芯片",
                        "id": 204735
                    }, {
                        "name": "广州欧珀通讯有限公司",
                        "id": 204736
                    }, {
                        "name": "广州快手互金",
                        "id": 204737
                    }, {
                        "name": "杭州快手汽车",
                        "id": 204738
                    }, {
                        "name": "上海滴滴医药",
                        "id": 204739
                    }]
                }, {
                    "name": "纽约快手旅游有限公司",
                    "id": 204740
                }, {
                    "name": "香港谷歌",
                    "id": 204741
                }, {
                    "name": "纽约星巴克银行控股集团",
                    "id": 204742
                }, {
                    "name": "东京快手地摊",
                    "id": 204743
                }, {
                    "name": "纽约谷歌旅游控股集团",
                    "id": 204744
                }, {
                    "name": "深圳亚马逊汽车",
                    "id": 204745
                }, {
                    "name": "厦门平安有限公司",
                    "id": 204746,
                    "children": [{
                        "name": "东京星巴克诊所有限公司",
                        "id": 204747
                    }, {
                        "name": "厦门百度地产",
                        "id": 204748
                    }, {
                        "name": "纽约美团科技",
                        "id": 204749
                    }, {
                        "name": "深圳京东制造",
                        "id": 204750
                    }, {
                        "name": "厦门亚马逊互金",
                        "id": 204751
                    }, {
                        "name": "东莞肯德基互金有限公司",
                        "id": 204752
                    }, {
                        "name": "香港快手地摊",
                        "id": 204753
                    }, {
                        "name": "广州阿里地产",
                        "id": 204754
                    }, {
                        "name": "深圳必胜客",
                        "id": 204755
                    }, {
                        "name": "天津滴滴电商",
                        "id": 204756
                    }, {
                        "name": "香港苹果餐饮有限公司",
                        "id": 204757
                    }, {
                        "name": "上海快手软件",
                        "id": 204758
                    }, {
                        "name": "台北欧珀基金有限公司",
                        "id": 204759
                    }, {
                        "name": "杭州欧珀制造",
                        "id": 204760
                    }, {
                        "name": "纽约微软医院有限公司",
                        "id": 204761
                    }, {
                        "name": "天津京东信息服务",
                        "id": 204762
                    }, {
                        "name": "台北滴滴航空",
                        "id": 204763
                    }, {
                        "name": "首尔阿里芯片有限公司",
                        "id": 204764
                    }, {
                        "name": "台北滴滴电商",
                        "id": 204765
                    }, {
                        "name": "上海滴滴制造",
                        "id": 204766
                    }, {
                        "name": "香港肯德基控股集团",
                        "id": 204767
                    }, {
                        "name": "东京瑞幸芯片有限公司",
                        "id": 204768
                    }, {
                        "name": "上海腾讯",
                        "id": 204769
                    }, {
                        "name": "上海肯德基基金有限公司",
                        "id": 204770
                    }, {
                        "name": "台北瑞幸信息服务",
                        "id": 204771
                    }, {
                        "name": "东京肯德基基金控股集团",
                        "id": 204772
                    }, {
                        "name": "杭州肯德基餐饮控股集团",
                        "id": 204773
                    }, {
                        "name": "东京亚马逊",
                        "id": 204774
                    }, {
                        "name": "香港阿里地摊",
                        "id": 204775
                    }, {
                        "name": "纽约奈雪有限公司",
                        "id": 204776
                    }]
                }, {
                    "name": "广州喜茶餐饮",
                    "id": 204777
                }, {
                    "name": "南京亚马逊通信有限公司",
                    "id": 204778
                }, {
                    "name": "南京快手控股集团",
                    "id": 204779
                }, {
                    "name": "杭州平安证券",
                    "id": 204780
                }, {
                    "name": "厦门滴滴证券有限公司",
                    "id": 204781
                }, {
                    "name": "天津微软制造",
                    "id": 204782
                }, {
                    "name": "东京滴滴医院控股集团",
                    "id": 204783,
                    "children": [{
                        "name": "东莞喜茶软件",
                        "id": 204784
                    }, {
                        "name": "杭州蚂蚁芯片",
                        "id": 204785
                    }, {
                        "name": "南京百度航空",
                        "id": 204786
                    }, {
                        "name": "香港肯德基地摊",
                        "id": 204787
                    }, {
                        "name": "东莞喜茶",
                        "id": 204788
                    }, {
                        "name": "东京华为地产",
                        "id": 204789
                    }, {
                        "name": "纽约特斯拉控股集团",
                        "id": 204790
                    }, {
                        "name": "台北苹果电商",
                        "id": 204791
                    }, {
                        "name": "深圳字节",
                        "id": 204792
                    }, {
                        "name": "南京京东旅游",
                        "id": 204793
                    }, {
                        "name": "香港肯德基科技",
                        "id": 204794
                    }, {
                        "name": "香港蚂蚁农业",
                        "id": 204795
                    }, {
                        "name": "南京微软银行",
                        "id": 204796
                    }, {
                        "name": "南京平安渔业有限公司",
                        "id": 204797
                    }, {
                        "name": "杭州美团",
                        "id": 204798
                    }, {
                        "name": "上海华为新能源控股集团",
                        "id": 204799
                    }, {
                        "name": "杭州华为诊所",
                        "id": 204800
                    }, {
                        "name": "东莞肯德基汽车",
                        "id": 204801
                    }, {
                        "name": "深圳平安通信",
                        "id": 204802
                    }, {
                        "name": "广州华为互金",
                        "id": 204803
                    }, {
                        "name": "东京腾讯科技有限公司",
                        "id": 204804
                    }, {
                        "name": "台北谷歌证券有限公司",
                        "id": 204805
                    }, {
                        "name": "深圳小米互金",
                        "id": 204806
                    }, {
                        "name": "杭州喜茶渔业",
                        "id": 204807
                    }, {
                        "name": "东京奈雪诊所",
                        "id": 204808
                    }, {
                        "name": "东京亚马逊",
                        "id": 204809
                    }, {
                        "name": "东京小米通信有限公司",
                        "id": 204810
                    }, {
                        "name": "厦门平安医药",
                        "id": 204811
                    }, {
                        "name": "上海肯德基",
                        "id": 204812
                    }, {
                        "name": "天津特斯拉餐饮",
                        "id": 204813
                    }, {
                        "name": "厦门京东",
                        "id": 204814
                    }, {
                        "name": "纽约平安基金控股集团",
                        "id": 204815
                    }, {
                        "name": "香港欧珀芯片",
                        "id": 204816
                    }, {
                        "name": "东莞小米新能源控股集团",
                        "id": 204817
                    }, {
                        "name": "台北百度计算机控股集团",
                        "id": 204818
                    }, {
                        "name": "东京特斯拉通信有限公司",
                        "id": 204819
                    }]
                }, {
                    "name": "南京美团新能源有限公司",
                    "id": 204820
                }, {
                    "name": "厦门瑞幸通信",
                    "id": 204821
                }, {
                    "name": "东京星巴克软件控股集团",
                    "id": 204822,
                    "children": [{
                        "name": "东京苹果石油",
                        "id": 204823
                    }, {
                        "name": "纽约星巴克石油有限公司",
                        "id": 204824
                    }, {
                        "name": "东京字节通讯",
                        "id": 204825
                    }, {
                        "name": "台北奈雪地摊有限公司",
                        "id": 204826
                    }, {
                        "name": "广州小米石油有限公司",
                        "id": 204827
                    }, {
                        "name": "广州星巴克控股集团",
                        "id": 204828
                    }, {
                        "name": "北京蚂蚁科技",
                        "id": 204829
                    }, {
                        "name": "东京肯德基地产",
                        "id": 204830
                    }, {
                        "name": "香港谷歌养殖",
                        "id": 204831
                    }]
                }, {
                    "name": "台北百度汽车",
                    "id": 204832,
                    "children": [{
                        "name": "南京特斯拉基金",
                        "id": 204833
                    }, {
                        "name": "厦门平安智能控股集团",
                        "id": 204834
                    }, {
                        "name": "上海腾讯",
                        "id": 204835
                    }, {
                        "name": "东京瑞幸基金有限公司",
                        "id": 204836
                    }, {
                        "name": "广州蚂蚁计算机",
                        "id": 204837
                    }, {
                        "name": "东京亚马逊医院",
                        "id": 204838
                    }, {
                        "name": "深圳欧珀石油",
                        "id": 204839
                    }, {
                        "name": "香港字节金融",
                        "id": 204840
                    }, {
                        "name": "厦门腾讯旅游",
                        "id": 204841
                    }, {
                        "name": "台北美团科技控股集团",
                        "id": 204842
                    }, {
                        "name": "东京奈雪诊所",
                        "id": 204843
                    }, {
                        "name": "杭州瑞幸汽车",
                        "id": 204844
                    }, {
                        "name": "杭州腾讯养殖控股集团",
                        "id": 204845
                    }, {
                        "name": "东京谷歌石油",
                        "id": 204846
                    }, {
                        "name": "首尔阿里科技",
                        "id": 204847
                    }, {
                        "name": "南京瑞幸基金控股集团",
                        "id": 204848
                    }, {
                        "name": "厦门滴滴有限公司",
                        "id": 204849
                    }, {
                        "name": "广州肯德基航空",
                        "id": 204850
                    }, {
                        "name": "首尔谷歌牧业控股集团",
                        "id": 204851
                    }, {
                        "name": "北京必胜客银行",
                        "id": 204852
                    }, {
                        "name": "纽约百度地摊有限公司",
                        "id": 204853
                    }, {
                        "name": "台北微软诊所",
                        "id": 204854
                    }, {
                        "name": "上海京东汽车",
                        "id": 204855
                    }, {
                        "name": "东京腾讯航空",
                        "id": 204856
                    }, {
                        "name": "广州百度通信控股集团",
                        "id": 204857
                    }]
                }, {
                    "name": "东京亚马逊",
                    "id": 204858
                }]
            }, {
                "name": "广州字节智能",
                "id": 204859
            }, {
                "name": "杭州特斯拉控股集团",
                "id": 204860
            }, {
                "name": "杭州腾讯",
                "id": 204861
            }, {
                "name": "东莞字节诊所",
                "id": 204862
            }, {
                "name": "首尔特斯拉农业",
                "id": 204863
            }, {
                "name": "广州星巴克通信",
                "id": 204864
            }, {
                "name": "纽约蚂蚁基金",
                "id": 204865,
                "children": [{
                    "name": "上海京东新能源",
                    "id": 204866
                }, {
                    "name": "首尔平安软件",
                    "id": 204867
                }, {
                    "name": "厦门华为证券",
                    "id": 204868
                }, {
                    "name": "北京字节医院",
                    "id": 204869,
                    "children": [{
                        "name": "厦门星巴克证券控股集团",
                        "id": 204870
                    }, {
                        "name": "上海瑞幸地摊有限公司",
                        "id": 204871
                    }, {
                        "name": "东京蚂蚁渔业",
                        "id": 204872
                    }, {
                        "name": "南京华为餐饮有限公司",
                        "id": 204873
                    }, {
                        "name": "天津喜茶医药控股集团",
                        "id": 204874
                    }, {
                        "name": "深圳必胜客互金",
                        "id": 204875
                    }, {
                        "name": "广州滴滴地产",
                        "id": 204876
                    }, {
                        "name": "厦门苹果通信控股集团",
                        "id": 204877
                    }, {
                        "name": "南京字节科技",
                        "id": 204878
                    }, {
                        "name": "纽约蚂蚁新能源控股集团",
                        "id": 204879
                    }, {
                        "name": "南京奈雪互金",
                        "id": 204880
                    }, {
                        "name": "天津小米金融",
                        "id": 204881
                    }, {
                        "name": "广州快手通信",
                        "id": 204882
                    }, {
                        "name": "厦门字节计算机有限公司",
                        "id": 204883
                    }, {
                        "name": "东京字节航空",
                        "id": 204884
                    }, {
                        "name": "深圳星巴克",
                        "id": 204885
                    }, {
                        "name": "上海微软制造有限公司",
                        "id": 204886
                    }, {
                        "name": "天津奈雪农业有限公司",
                        "id": 204887
                    }, {
                        "name": "上海小米互金控股集团",
                        "id": 204888
                    }, {
                        "name": "广州星巴克地摊",
                        "id": 204889
                    }, {
                        "name": "香港阿里地产控股集团",
                        "id": 204890
                    }, {
                        "name": "南京字节农业",
                        "id": 204891
                    }, {
                        "name": "厦门小米旅游",
                        "id": 204892
                    }, {
                        "name": "台北亚马逊制造",
                        "id": 204893
                    }, {
                        "name": "东莞喜茶医药",
                        "id": 204894
                    }, {
                        "name": "北京奈雪汽车有限公司",
                        "id": 204895
                    }, {
                        "name": "杭州喜茶计算机",
                        "id": 204896
                    }, {
                        "name": "北京蚂蚁芯片",
                        "id": 204897
                    }, {
                        "name": "天津小米基金",
                        "id": 204898
                    }, {
                        "name": "东京蚂蚁养殖",
                        "id": 204899
                    }, {
                        "name": "上海滴滴医院",
                        "id": 204900
                    }, {
                        "name": "杭州瑞幸牧业",
                        "id": 204901
                    }, {
                        "name": "香港亚马逊农业控股集团",
                        "id": 204902
                    }, {
                        "name": "东莞苹果有限公司",
                        "id": 204903
                    }, {
                        "name": "北京欧珀",
                        "id": 204904
                    }, {
                        "name": "天津平安金融",
                        "id": 204905
                    }]
                }, {
                    "name": "杭州快手互金",
                    "id": 204906,
                    "children": [{
                        "name": "杭州微软互金",
                        "id": 204907
                    }, {
                        "name": "东京星巴克金融",
                        "id": 204908
                    }, {
                        "name": "厦门瑞幸餐饮",
                        "id": 204909
                    }, {
                        "name": "东京必胜客金融有限公司",
                        "id": 204910
                    }, {
                        "name": "厦门亚马逊银行控股集团",
                        "id": 204911
                    }, {
                        "name": "天津苹果芯片控股集团",
                        "id": 204912
                    }, {
                        "name": "台北华为智能",
                        "id": 204913
                    }, {
                        "name": "东京奈雪牧业",
                        "id": 204914
                    }, {
                        "name": "东京滴滴科技控股集团",
                        "id": 204915
                    }, {
                        "name": "杭州必胜客银行有限公司",
                        "id": 204916
                    }, {
                        "name": "纽约字节汽车",
                        "id": 204917
                    }, {
                        "name": "广州苹果农业控股集团",
                        "id": 204918
                    }, {
                        "name": "香港特斯拉通讯有限公司",
                        "id": 204919
                    }, {
                        "name": "南京亚马逊电商",
                        "id": 204920
                    }, {
                        "name": "东莞亚马逊餐饮有限公司",
                        "id": 204921
                    }, {
                        "name": "台北华为餐饮",
                        "id": 204922
                    }, {
                        "name": "台北阿里医院",
                        "id": 204923
                    }, {
                        "name": "纽约小米地摊控股集团",
                        "id": 204924
                    }, {
                        "name": "首尔阿里基金",
                        "id": 204925
                    }, {
                        "name": "广州微软新能源",
                        "id": 204926
                    }, {
                        "name": "天津蚂蚁科技",
                        "id": 204927
                    }, {
                        "name": "东莞平安养殖控股集团",
                        "id": 204928
                    }, {
                        "name": "天津滴滴养殖有限公司",
                        "id": 204929
                    }, {
                        "name": "南京百度地摊有限公司",
                        "id": 204930
                    }, {
                        "name": "厦门京东制造",
                        "id": 204931
                    }, {
                        "name": "南京平安",
                        "id": 204932
                    }, {
                        "name": "香港特斯拉基金",
                        "id": 204933
                    }, {
                        "name": "深圳快手地产控股集团",
                        "id": 204934
                    }, {
                        "name": "台北奈雪金融",
                        "id": 204935
                    }, {
                        "name": "纽约必胜客互金",
                        "id": 204936
                    }, {
                        "name": "广州小米石油",
                        "id": 204937
                    }, {
                        "name": "广州奈雪",
                        "id": 204938
                    }, {
                        "name": "天津微软餐饮",
                        "id": 204939
                    }, {
                        "name": "广州华为通讯",
                        "id": 204940
                    }, {
                        "name": "厦门滴滴汽车",
                        "id": 204941
                    }, {
                        "name": "东京星巴克农业",
                        "id": 204942
                    }]
                }, {
                    "name": "广州亚马逊航空有限公司",
                    "id": 204943
                }, {
                    "name": "杭州阿里",
                    "id": 204944
                }, {
                    "name": "厦门滴滴旅游",
                    "id": 204945
                }, {
                    "name": "首尔京东通信有限公司",
                    "id": 204946
                }, {
                    "name": "天津快手渔业",
                    "id": 204947,
                    "children": [{
                        "name": "东莞瑞幸农业",
                        "id": 204948
                    }, {
                        "name": "杭州百度医院有限公司",
                        "id": 204949
                    }, {
                        "name": "东京星巴克新能源",
                        "id": 204950
                    }, {
                        "name": "东京快手",
                        "id": 204951
                    }, {
                        "name": "东莞特斯拉餐饮",
                        "id": 204952
                    }, {
                        "name": "天津欧珀农业控股集团",
                        "id": 204953
                    }, {
                        "name": "纽约特斯拉",
                        "id": 204954
                    }, {
                        "name": "广州微软旅游",
                        "id": 204955
                    }, {
                        "name": "杭州蚂蚁养殖",
                        "id": 204956
                    }, {
                        "name": "东京快手渔业",
                        "id": 204957
                    }, {
                        "name": "上海蚂蚁医药",
                        "id": 204958
                    }, {
                        "name": "东莞腾讯软件",
                        "id": 204959
                    }, {
                        "name": "台北京东通信",
                        "id": 204960
                    }, {
                        "name": "厦门谷歌医药有限公司",
                        "id": 204961
                    }, {
                        "name": "台北华为芯片",
                        "id": 204962
                    }, {
                        "name": "天津谷歌软件",
                        "id": 204963
                    }, {
                        "name": "东莞腾讯旅游",
                        "id": 204964
                    }, {
                        "name": "东京华为通信",
                        "id": 204965
                    }, {
                        "name": "上海谷歌汽车",
                        "id": 204966
                    }, {
                        "name": "广州平安电商",
                        "id": 204967
                    }, {
                        "name": "北京腾讯新能源",
                        "id": 204968
                    }, {
                        "name": "首尔华为证券",
                        "id": 204969
                    }, {
                        "name": "上海腾讯渔业",
                        "id": 204970
                    }, {
                        "name": "东京小米餐饮",
                        "id": 204971
                    }, {
                        "name": "上海美团汽车控股集团",
                        "id": 204972
                    }, {
                        "name": "东莞阿里互金有限公司",
                        "id": 204973
                    }]
                }, {
                    "name": "广州蚂蚁牧业",
                    "id": 204974
                }, {
                    "name": "杭州蚂蚁智能",
                    "id": 204975,
                    "children": [{
                        "name": "首尔京东通讯",
                        "id": 204976
                    }, {
                        "name": "首尔瑞幸养殖",
                        "id": 204977
                    }, {
                        "name": "南京字节地摊",
                        "id": 204978
                    }, {
                        "name": "深圳滴滴金融",
                        "id": 204979
                    }, {
                        "name": "东莞肯德基汽车控股集团",
                        "id": 204980
                    }, {
                        "name": "上海华为地产控股集团",
                        "id": 204981
                    }, {
                        "name": "天津小米软件",
                        "id": 204982
                    }, {
                        "name": "南京亚马逊制造",
                        "id": 204983
                    }, {
                        "name": "香港小米旅游",
                        "id": 204984
                    }, {
                        "name": "东莞特斯拉旅游",
                        "id": 204985
                    }, {
                        "name": "深圳特斯拉有限公司",
                        "id": 204986
                    }]
                }, {
                    "name": "杭州快手互金",
                    "id": 204987,
                    "children": [{
                        "name": "纽约平安互金控股集团",
                        "id": 204988
                    }, {
                        "name": "杭州亚马逊渔业",
                        "id": 204989
                    }, {
                        "name": "广州美团旅游",
                        "id": 204990
                    }, {
                        "name": "天津喜茶金融",
                        "id": 204991
                    }, {
                        "name": "厦门平安地产控股集团",
                        "id": 204992
                    }, {
                        "name": "广州美团金融有限公司",
                        "id": 204993
                    }, {
                        "name": "厦门美团牧业",
                        "id": 204994
                    }, {
                        "name": "杭州百度旅游",
                        "id": 204995
                    }, {
                        "name": "深圳星巴克旅游",
                        "id": 204996
                    }, {
                        "name": "东京亚马逊电商",
                        "id": 204997
                    }, {
                        "name": "厦门华为地产",
                        "id": 204998
                    }, {
                        "name": "东莞百度互金",
                        "id": 204999
                    }, {
                        "name": "北京特斯拉有限公司",
                        "id": 205000
                    }, {
                        "name": "上海喜茶制造有限公司",
                        "id": 205001
                    }, {
                        "name": "深圳腾讯证券",
                        "id": 205002
                    }, {
                        "name": "东莞苹果银行",
                        "id": 205003
                    }, {
                        "name": "香港阿里银行控股集团",
                        "id": 205004
                    }, {
                        "name": "杭州瑞幸地产",
                        "id": 205005
                    }, {
                        "name": "杭州肯德基科技",
                        "id": 205006
                    }, {
                        "name": "香港平安",
                        "id": 205007
                    }, {
                        "name": "台北欧珀石油",
                        "id": 205008
                    }, {
                        "name": "广州肯德基新能源有限公司",
                        "id": 205009
                    }, {
                        "name": "厦门字节旅游",
                        "id": 205010
                    }, {
                        "name": "东莞肯德基通讯",
                        "id": 205011
                    }, {
                        "name": "东莞肯德基农业",
                        "id": 205012
                    }, {
                        "name": "深圳京东芯片",
                        "id": 205013
                    }, {
                        "name": "南京腾讯芯片",
                        "id": 205014
                    }, {
                        "name": "北京腾讯牧业",
                        "id": 205015
                    }, {
                        "name": "杭州瑞幸基金",
                        "id": 205016
                    }, {
                        "name": "东莞奈雪通讯",
                        "id": 205017
                    }, {
                        "name": "深圳谷歌石油",
                        "id": 205018
                    }, {
                        "name": "杭州奈雪医药",
                        "id": 205019
                    }, {
                        "name": "香港京东医院",
                        "id": 205020
                    }, {
                        "name": "杭州必胜客芯片有限公司",
                        "id": 205021
                    }]
                }, {
                    "name": "首尔京东诊所",
                    "id": 205022
                }, {
                    "name": "纽约欧珀有限公司",
                    "id": 205023
                }, {
                    "name": "天津平安石油",
                    "id": 205024
                }, {
                    "name": "首尔小米通信控股集团",
                    "id": 205025
                }, {
                    "name": "东京欧珀农业控股集团",
                    "id": 205026
                }, {
                    "name": "杭州华为软件",
                    "id": 205027
                }, {
                    "name": "香港字节农业",
                    "id": 205028
                }, {
                    "name": "杭州苹果制造",
                    "id": 205029
                }, {
                    "name": "杭州欧珀证券控股集团",
                    "id": 205030
                }, {
                    "name": "纽约苹果芯片有限公司",
                    "id": 205031
                }, {
                    "name": "杭州京东控股集团",
                    "id": 205032,
                    "children": [{
                        "name": "北京京东新能源有限公司",
                        "id": 205033
                    }, {
                        "name": "天津肯德基金融控股集团",
                        "id": 205034
                    }, {
                        "name": "纽约京东农业",
                        "id": 205035
                    }, {
                        "name": "杭州微软旅游",
                        "id": 205036
                    }, {
                        "name": "深圳小米智能控股集团",
                        "id": 205037
                    }, {
                        "name": "天津蚂蚁智能",
                        "id": 205038
                    }, {
                        "name": "南京喜茶有限公司",
                        "id": 205039
                    }, {
                        "name": "东莞百度信息服务有限公司",
                        "id": 205040
                    }, {
                        "name": "上海瑞幸芯片",
                        "id": 205041
                    }, {
                        "name": "东莞蚂蚁智能有限公司",
                        "id": 205042
                    }, {
                        "name": "上海特斯拉",
                        "id": 205043
                    }, {
                        "name": "上海小米金融",
                        "id": 205044
                    }, {
                        "name": "杭州欧珀渔业控股集团",
                        "id": 205045
                    }, {
                        "name": "东京星巴克地摊",
                        "id": 205046
                    }, {
                        "name": "东京腾讯通信",
                        "id": 205047
                    }, {
                        "name": "东莞苹果信息服务",
                        "id": 205048
                    }, {
                        "name": "香港平安汽车控股集团",
                        "id": 205049
                    }, {
                        "name": "杭州欧珀农业",
                        "id": 205050
                    }, {
                        "name": "厦门瑞幸汽车",
                        "id": 205051
                    }, {
                        "name": "深圳奈雪软件有限公司",
                        "id": 205052
                    }, {
                        "name": "纽约奈雪软件",
                        "id": 205053
                    }, {
                        "name": "台北瑞幸信息服务",
                        "id": 205054
                    }, {
                        "name": "南京瑞幸农业",
                        "id": 205055
                    }, {
                        "name": "台北快手控股集团",
                        "id": 205056
                    }, {
                        "name": "上海瑞幸渔业控股集团",
                        "id": 205057
                    }, {
                        "name": "首尔滴滴通信控股集团",
                        "id": 205058
                    }, {
                        "name": "广州星巴克通讯",
                        "id": 205059
                    }, {
                        "name": "北京谷歌新能源",
                        "id": 205060
                    }, {
                        "name": "杭州肯德基基金",
                        "id": 205061
                    }]
                }, {
                    "name": "广州快手证券",
                    "id": 205062
                }, {
                    "name": "南京京东医院",
                    "id": 205063
                }, {
                    "name": "天津蚂蚁证券",
                    "id": 205064,
                    "children": [{
                        "name": "南京字节",
                        "id": 205065
                    }, {
                        "name": "广州奈雪银行",
                        "id": 205066
                    }]
                }, {
                    "name": "广州京东电商",
                    "id": 205067
                }, {
                    "name": "纽约字节电商",
                    "id": 205068
                }, {
                    "name": "厦门谷歌证券控股集团",
                    "id": 205069
                }]
            }, {
                "name": "南京特斯拉计算机",
                "id": 205070,
                "children": [{
                    "name": "杭州字节芯片",
                    "id": 205071,
                    "children": [{
                        "name": "北京微软金融",
                        "id": 205072
                    }, {
                        "name": "南京微软电商",
                        "id": 205073
                    }, {
                        "name": "北京谷歌电商控股集团",
                        "id": 205074
                    }, {
                        "name": "杭州京东航空",
                        "id": 205075
                    }, {
                        "name": "东莞百度互金有限公司",
                        "id": 205076
                    }, {
                        "name": "上海星巴克航空有限公司",
                        "id": 205077
                    }, {
                        "name": "广州平安证券",
                        "id": 205078
                    }, {
                        "name": "台北喜茶渔业",
                        "id": 205079
                    }, {
                        "name": "首尔快手证券",
                        "id": 205080
                    }, {
                        "name": "杭州字节汽车控股集团",
                        "id": 205081
                    }, {
                        "name": "香港华为地摊",
                        "id": 205082
                    }, {
                        "name": "香港滴滴科技",
                        "id": 205083
                    }, {
                        "name": "上海小米养殖",
                        "id": 205084
                    }, {
                        "name": "厦门蚂蚁科技",
                        "id": 205085
                    }, {
                        "name": "东莞蚂蚁",
                        "id": 205086
                    }, {
                        "name": "深圳苹果信息服务有限公司",
                        "id": 205087
                    }, {
                        "name": "东京必胜客金融",
                        "id": 205088
                    }, {
                        "name": "深圳微软银行有限公司",
                        "id": 205089
                    }, {
                        "name": "香港平安旅游",
                        "id": 205090
                    }, {
                        "name": "香港蚂蚁地摊",
                        "id": 205091
                    }, {
                        "name": "厦门小米养殖",
                        "id": 205092
                    }, {
                        "name": "首尔百度智能有限公司",
                        "id": 205093
                    }, {
                        "name": "东京滴滴通信",
                        "id": 205094
                    }, {
                        "name": "纽约京东汽车",
                        "id": 205095
                    }, {
                        "name": "天津平安养殖",
                        "id": 205096
                    }]
                }, {
                    "name": "杭州阿里信息服务",
                    "id": 205097
                }, {
                    "name": "上海必胜客",
                    "id": 205098
                }, {
                    "name": "台北腾讯有限公司",
                    "id": 205099,
                    "children": [{
                        "name": "首尔喜茶",
                        "id": 205100
                    }, {
                        "name": "台北喜茶餐饮有限公司",
                        "id": 205101
                    }, {
                        "name": "天津奈雪科技",
                        "id": 205102
                    }, {
                        "name": "厦门华为汽车有限公司",
                        "id": 205103
                    }, {
                        "name": "纽约滴滴通讯有限公司",
                        "id": 205104
                    }, {
                        "name": "杭州小米",
                        "id": 205105
                    }, {
                        "name": "广州平安地摊",
                        "id": 205106
                    }, {
                        "name": "广州腾讯航空",
                        "id": 205107
                    }, {
                        "name": "首尔喜茶电商控股集团",
                        "id": 205108
                    }, {
                        "name": "香港苹果",
                        "id": 205109
                    }, {
                        "name": "天津快手控股集团",
                        "id": 205110
                    }]
                }, {
                    "name": "台北小米医药",
                    "id": 205111
                }, {
                    "name": "上海亚马逊电商控股集团",
                    "id": 205112
                }, {
                    "name": "厦门平安农业",
                    "id": 205113,
                    "children": [{
                        "name": "南京百度",
                        "id": 205114
                    }, {
                        "name": "广州特斯拉地产",
                        "id": 205115
                    }, {
                        "name": "广州必胜客信息服务",
                        "id": 205116
                    }, {
                        "name": "杭州奈雪银行",
                        "id": 205117
                    }, {
                        "name": "深圳小米互金有限公司",
                        "id": 205118
                    }, {
                        "name": "广州小米",
                        "id": 205119
                    }, {
                        "name": "首尔肯德基软件",
                        "id": 205120
                    }, {
                        "name": "杭州滴滴软件控股集团",
                        "id": 205121
                    }, {
                        "name": "天津谷歌科技",
                        "id": 205122
                    }, {
                        "name": "香港欧珀旅游",
                        "id": 205123
                    }, {
                        "name": "纽约奈雪有限公司",
                        "id": 205124
                    }, {
                        "name": "杭州字节金融",
                        "id": 205125
                    }, {
                        "name": "东莞喜茶",
                        "id": 205126
                    }, {
                        "name": "杭州欧珀新能源有限公司",
                        "id": 205127
                    }, {
                        "name": "厦门快手通讯",
                        "id": 205128
                    }, {
                        "name": "东京小米新能源",
                        "id": 205129
                    }, {
                        "name": "杭州谷歌计算机",
                        "id": 205130
                    }, {
                        "name": "北京欧珀智能",
                        "id": 205131
                    }]
                }, {
                    "name": "纽约特斯拉诊所",
                    "id": 205132
                }, {
                    "name": "南京必胜客医院有限公司",
                    "id": 205133,
                    "children": [{
                        "name": "深圳瑞幸新能源",
                        "id": 205134
                    }, {
                        "name": "杭州欧珀科技有限公司",
                        "id": 205135
                    }, {
                        "name": "首尔苹果医院",
                        "id": 205136
                    }, {
                        "name": "首尔特斯拉芯片",
                        "id": 205137
                    }, {
                        "name": "首尔小米养殖有限公司",
                        "id": 205138
                    }, {
                        "name": "北京腾讯诊所有限公司",
                        "id": 205139
                    }]
                }, {
                    "name": "东莞谷歌芯片有限公司",
                    "id": 205140
                }, {
                    "name": "深圳苹果通讯",
                    "id": 205141
                }, {
                    "name": "首尔肯德基信息服务控股集团",
                    "id": 205142
                }, {
                    "name": "广州肯德基养殖",
                    "id": 205143
                }, {
                    "name": "上海滴滴渔业",
                    "id": 205144
                }, {
                    "name": "深圳滴滴地摊",
                    "id": 205145
                }, {
                    "name": "杭州奈雪通信",
                    "id": 205146,
                    "children": [{
                        "name": "广州京东",
                        "id": 205147
                    }, {
                        "name": "北京奈雪银行有限公司",
                        "id": 205148
                    }, {
                        "name": "东莞特斯拉石油",
                        "id": 205149
                    }, {
                        "name": "首尔奈雪航空",
                        "id": 205150
                    }, {
                        "name": "广州谷歌电商有限公司",
                        "id": 205151
                    }, {
                        "name": "厦门字节信息服务",
                        "id": 205152
                    }, {
                        "name": "纽约亚马逊渔业",
                        "id": 205153
                    }, {
                        "name": "东京平安牧业控股集团",
                        "id": 205154
                    }, {
                        "name": "杭州腾讯",
                        "id": 205155
                    }, {
                        "name": "北京苹果渔业",
                        "id": 205156
                    }, {
                        "name": "深圳亚马逊新能源",
                        "id": 205157
                    }, {
                        "name": "南京星巴克电商有限公司",
                        "id": 205158
                    }, {
                        "name": "南京阿里旅游",
                        "id": 205159
                    }, {
                        "name": "杭州欧珀基金",
                        "id": 205160
                    }, {
                        "name": "南京微软新能源",
                        "id": 205161
                    }, {
                        "name": "上海微软医药控股集团",
                        "id": 205162
                    }, {
                        "name": "台北喜茶汽车有限公司",
                        "id": 205163
                    }, {
                        "name": "深圳奈雪通讯",
                        "id": 205164
                    }, {
                        "name": "首尔星巴克基金有限公司",
                        "id": 205165
                    }, {
                        "name": "纽约喜茶医药控股集团",
                        "id": 205166
                    }, {
                        "name": "深圳谷歌石油",
                        "id": 205167
                    }, {
                        "name": "台北滴滴",
                        "id": 205168
                    }, {
                        "name": "香港小米金融",
                        "id": 205169
                    }, {
                        "name": "台北腾讯诊所",
                        "id": 205170
                    }, {
                        "name": "南京欧珀互金",
                        "id": 205171
                    }, {
                        "name": "北京欧珀软件",
                        "id": 205172
                    }, {
                        "name": "深圳特斯拉通讯控股集团",
                        "id": 205173
                    }, {
                        "name": "杭州亚马逊芯片控股集团",
                        "id": 205174
                    }]
                }, {
                    "name": "东莞特斯拉地摊",
                    "id": 205175,
                    "children": [{
                        "name": "深圳小米养殖",
                        "id": 205176
                    }, {
                        "name": "天津百度石油有限公司",
                        "id": 205177
                    }, {
                        "name": "深圳苹果旅游",
                        "id": 205178
                    }, {
                        "name": "广州谷歌软件控股集团",
                        "id": 205179
                    }, {
                        "name": "厦门亚马逊农业",
                        "id": 205180
                    }, {
                        "name": "杭州快手石油",
                        "id": 205181
                    }, {
                        "name": "杭州瑞幸渔业",
                        "id": 205182
                    }, {
                        "name": "台北蚂蚁计算机",
                        "id": 205183
                    }, {
                        "name": "杭州京东互金",
                        "id": 205184
                    }, {
                        "name": "深圳美团通信",
                        "id": 205185
                    }, {
                        "name": "天津腾讯金融",
                        "id": 205186
                    }, {
                        "name": "深圳特斯拉",
                        "id": 205187
                    }, {
                        "name": "北京星巴克互金",
                        "id": 205188
                    }, {
                        "name": "杭州蚂蚁",
                        "id": 205189
                    }, {
                        "name": "厦门瑞幸科技",
                        "id": 205190
                    }, {
                        "name": "杭州蚂蚁渔业控股集团",
                        "id": 205191
                    }, {
                        "name": "首尔字节控股集团",
                        "id": 205192
                    }, {
                        "name": "深圳滴滴银行",
                        "id": 205193
                    }, {
                        "name": "香港小米新能源",
                        "id": 205194
                    }, {
                        "name": "香港谷歌医药控股集团",
                        "id": 205195
                    }, {
                        "name": "纽约奈雪餐饮",
                        "id": 205196
                    }, {
                        "name": "杭州字节互金控股集团",
                        "id": 205197
                    }, {
                        "name": "首尔平安科技",
                        "id": 205198
                    }, {
                        "name": "深圳京东地产",
                        "id": 205199
                    }, {
                        "name": "广州必胜客电商控股集团",
                        "id": 205200
                    }, {
                        "name": "上海微软汽车",
                        "id": 205201
                    }, {
                        "name": "北京腾讯通讯",
                        "id": 205202
                    }, {
                        "name": "纽约字节制造控股集团",
                        "id": 205203
                    }]
                }, {
                    "name": "纽约京东控股集团",
                    "id": 205204
                }, {
                    "name": "东京百度医药",
                    "id": 205205,
                    "children": [{
                        "name": "深圳苹果石油",
                        "id": 205206
                    }, {
                        "name": "南京微软地摊有限公司",
                        "id": 205207
                    }, {
                        "name": "杭州滴滴证券",
                        "id": 205208
                    }]
                }, {
                    "name": "深圳奈雪渔业",
                    "id": 205209,
                    "children": [{
                        "name": "杭州肯德基地产",
                        "id": 205210
                    }, {
                        "name": "厦门蚂蚁软件控股集团",
                        "id": 205211
                    }, {
                        "name": "台北快手互金",
                        "id": 205212
                    }, {
                        "name": "东莞平安芯片",
                        "id": 205213
                    }, {
                        "name": "纽约微软石油",
                        "id": 205214
                    }, {
                        "name": "厦门肯德基证券",
                        "id": 205215
                    }, {
                        "name": "台北腾讯诊所控股集团",
                        "id": 205216
                    }, {
                        "name": "东莞小米智能有限公司",
                        "id": 205217
                    }, {
                        "name": "首尔快手智能",
                        "id": 205218
                    }, {
                        "name": "台北字节航空",
                        "id": 205219
                    }]
                }, {
                    "name": "上海特斯拉汽车有限公司",
                    "id": 205220
                }, {
                    "name": "上海华为科技",
                    "id": 205221
                }, {
                    "name": "深圳欧珀互金控股集团",
                    "id": 205222
                }, {
                    "name": "东京瑞幸电商",
                    "id": 205223,
                    "children": [{
                        "name": "首尔字节通讯",
                        "id": 205224
                    }, {
                        "name": "东京星巴克互金控股集团",
                        "id": 205225
                    }, {
                        "name": "东莞阿里牧业有限公司",
                        "id": 205226
                    }, {
                        "name": "广州百度金融",
                        "id": 205227
                    }, {
                        "name": "杭州京东农业有限公司",
                        "id": 205228
                    }, {
                        "name": "厦门瑞幸智能控股集团",
                        "id": 205229
                    }, {
                        "name": "上海肯德基地产",
                        "id": 205230
                    }, {
                        "name": "台北平安基金",
                        "id": 205231
                    }, {
                        "name": "东京特斯拉基金控股集团",
                        "id": 205232
                    }, {
                        "name": "北京小米银行",
                        "id": 205233
                    }, {
                        "name": "首尔奈雪软件",
                        "id": 205234
                    }, {
                        "name": "厦门欧珀汽车",
                        "id": 205235
                    }, {
                        "name": "香港喜茶新能源控股集团",
                        "id": 205236
                    }, {
                        "name": "杭州苹果渔业有限公司",
                        "id": 205237
                    }, {
                        "name": "广州瑞幸制造",
                        "id": 205238
                    }, {
                        "name": "东京星巴克渔业",
                        "id": 205239
                    }, {
                        "name": "东莞滴滴汽车控股集团",
                        "id": 205240
                    }, {
                        "name": "南京奈雪养殖控股集团",
                        "id": 205241
                    }, {
                        "name": "厦门奈雪地产",
                        "id": 205242
                    }, {
                        "name": "上海字节医院有限公司",
                        "id": 205243
                    }, {
                        "name": "东京星巴克金融",
                        "id": 205244
                    }, {
                        "name": "天津特斯拉金融",
                        "id": 205245
                    }, {
                        "name": "杭州特斯拉信息服务",
                        "id": 205246
                    }, {
                        "name": "厦门瑞幸汽车",
                        "id": 205247
                    }, {
                        "name": "首尔滴滴制造",
                        "id": 205248
                    }, {
                        "name": "东莞星巴克芯片",
                        "id": 205249
                    }, {
                        "name": "广州亚马逊",
                        "id": 205250
                    }, {
                        "name": "香港华为农业",
                        "id": 205251
                    }]
                }, {
                    "name": "杭州阿里",
                    "id": 205252,
                    "children": [{
                        "name": "广州蚂蚁互金",
                        "id": 205253
                    }, {
                        "name": "纽约百度基金有限公司",
                        "id": 205254
                    }, {
                        "name": "首尔腾讯制造",
                        "id": 205255
                    }, {
                        "name": "广州平安基金控股集团",
                        "id": 205256
                    }, {
                        "name": "广州亚马逊牧业",
                        "id": 205257
                    }, {
                        "name": "杭州百度软件",
                        "id": 205258
                    }, {
                        "name": "台北亚马逊制造",
                        "id": 205259
                    }, {
                        "name": "广州谷歌餐饮",
                        "id": 205260
                    }, {
                        "name": "杭州京东养殖",
                        "id": 205261
                    }, {
                        "name": "首尔谷歌地产",
                        "id": 205262
                    }, {
                        "name": "南京腾讯智能有限公司",
                        "id": 205263
                    }, {
                        "name": "北京微软有限公司",
                        "id": 205264
                    }, {
                        "name": "东莞微软银行",
                        "id": 205265
                    }, {
                        "name": "南京星巴克基金",
                        "id": 205266
                    }]
                }, {
                    "name": "北京滴滴科技控股集团",
                    "id": 205267
                }, {
                    "name": "广州腾讯金融",
                    "id": 205268
                }, {
                    "name": "南京奈雪智能",
                    "id": 205269,
                    "children": [{
                        "name": "东莞快手科技",
                        "id": 205270
                    }, {
                        "name": "北京腾讯",
                        "id": 205271
                    }, {
                        "name": "上海谷歌餐饮控股集团",
                        "id": 205272
                    }, {
                        "name": "南京平安石油",
                        "id": 205273
                    }, {
                        "name": "杭州平安有限公司",
                        "id": 205274
                    }, {
                        "name": "台北苹果航空有限公司",
                        "id": 205275
                    }, {
                        "name": "南京谷歌渔业",
                        "id": 205276
                    }, {
                        "name": "上海字节新能源控股集团",
                        "id": 205277
                    }, {
                        "name": "首尔阿里医药有限公司",
                        "id": 205278
                    }, {
                        "name": "南京美团诊所有限公司",
                        "id": 205279
                    }, {
                        "name": "杭州瑞幸证券有限公司",
                        "id": 205280
                    }, {
                        "name": "首尔字节芯片",
                        "id": 205281
                    }, {
                        "name": "首尔苹果证券",
                        "id": 205282
                    }, {
                        "name": "深圳平安金融",
                        "id": 205283
                    }, {
                        "name": "上海百度汽车控股集团",
                        "id": 205284
                    }, {
                        "name": "南京亚马逊信息服务有限公司",
                        "id": 205285
                    }, {
                        "name": "台北华为农业",
                        "id": 205286
                    }, {
                        "name": "东莞亚马逊芯片有限公司",
                        "id": 205287
                    }, {
                        "name": "广州特斯拉通信",
                        "id": 205288
                    }, {
                        "name": "东莞小米牧业控股集团",
                        "id": 205289
                    }, {
                        "name": "广州奈雪互金有限公司",
                        "id": 205290
                    }, {
                        "name": "东莞必胜客医院有限公司",
                        "id": 205291
                    }, {
                        "name": "南京腾讯",
                        "id": 205292
                    }, {
                        "name": "东京肯德基计算机有限公司",
                        "id": 205293
                    }, {
                        "name": "杭州小米金融控股集团",
                        "id": 205294
                    }, {
                        "name": "东莞腾讯地摊有限公司",
                        "id": 205295
                    }]
                }, {
                    "name": "杭州滴滴渔业有限公司",
                    "id": 205296
                }, {
                    "name": "台北美团餐饮",
                    "id": 205297
                }]
            }]
        }, {
            "name": "首尔特斯拉",
            "id": 205298,
            "children": [{
                "name": "香港亚马逊控股集团",
                "id": 205299
            }, {
                "name": "香港字节金融控股集团",
                "id": 205300,
                "children": [{
                    "name": "东莞苹果软件",
                    "id": 205301
                }, {
                    "name": "东莞美团牧业",
                    "id": 205302
                }, {
                    "name": "东莞亚马逊证券",
                    "id": 205303
                }, {
                    "name": "厦门腾讯养殖",
                    "id": 205304
                }, {
                    "name": "杭州京东汽车控股集团",
                    "id": 205305
                }, {
                    "name": "纽约滴滴互金控股集团",
                    "id": 205306
                }, {
                    "name": "东莞蚂蚁航空有限公司",
                    "id": 205307
                }, {
                    "name": "杭州微软汽车",
                    "id": 205308
                }, {
                    "name": "东莞谷歌餐饮",
                    "id": 205309,
                    "children": [{
                        "name": "香港字节电商",
                        "id": 205310
                    }, {
                        "name": "东莞字节",
                        "id": 205311
                    }, {
                        "name": "东京欧珀软件",
                        "id": 205312
                    }, {
                        "name": "上海腾讯养殖有限公司",
                        "id": 205313
                    }, {
                        "name": "广州星巴克通信控股集团",
                        "id": 205314
                    }, {
                        "name": "台北字节新能源",
                        "id": 205315
                    }, {
                        "name": "广州蚂蚁通信控股集团",
                        "id": 205316
                    }, {
                        "name": "广州奈雪医院",
                        "id": 205317
                    }, {
                        "name": "广州微软金融",
                        "id": 205318
                    }, {
                        "name": "东莞瑞幸软件",
                        "id": 205319
                    }, {
                        "name": "杭州奈雪农业",
                        "id": 205320
                    }, {
                        "name": "香港谷歌养殖",
                        "id": 205321
                    }, {
                        "name": "台北阿里新能源",
                        "id": 205322
                    }, {
                        "name": "杭州滴滴医药有限公司",
                        "id": 205323
                    }, {
                        "name": "杭州微软牧业",
                        "id": 205324
                    }, {
                        "name": "纽约小米",
                        "id": 205325
                    }, {
                        "name": "香港微软餐饮",
                        "id": 205326
                    }, {
                        "name": "东京华为智能",
                        "id": 205327
                    }, {
                        "name": "厦门微软基金有限公司",
                        "id": 205328
                    }, {
                        "name": "深圳喜茶餐饮",
                        "id": 205329
                    }, {
                        "name": "深圳苹果地产",
                        "id": 205330
                    }, {
                        "name": "杭州阿里医院",
                        "id": 205331
                    }, {
                        "name": "厦门蚂蚁科技控股集团",
                        "id": 205332
                    }, {
                        "name": "深圳必胜客牧业",
                        "id": 205333
                    }, {
                        "name": "南京喜茶智能控股集团",
                        "id": 205334
                    }, {
                        "name": "杭州谷歌诊所",
                        "id": 205335
                    }, {
                        "name": "深圳腾讯计算机",
                        "id": 205336
                    }, {
                        "name": "东京欧珀航空",
                        "id": 205337
                    }, {
                        "name": "深圳滴滴汽车",
                        "id": 205338
                    }, {
                        "name": "杭州亚马逊芯片",
                        "id": 205339
                    }, {
                        "name": "首尔喜茶新能源有限公司",
                        "id": 205340
                    }, {
                        "name": "台北华为电商",
                        "id": 205341
                    }, {
                        "name": "厦门必胜客控股集团",
                        "id": 205342
                    }, {
                        "name": "广州欧珀",
                        "id": 205343
                    }]
                }, {
                    "name": "南京滴滴医药",
                    "id": 205344
                }, {
                    "name": "厦门美团通讯",
                    "id": 205345
                }, {
                    "name": "东莞瑞幸汽车有限公司",
                    "id": 205346
                }, {
                    "name": "厦门苹果石油",
                    "id": 205347
                }, {
                    "name": "纽约华为旅游",
                    "id": 205348,
                    "children": [{
                        "name": "纽约滴滴信息服务",
                        "id": 205349
                    }, {
                        "name": "香港快手有限公司",
                        "id": 205350
                    }, {
                        "name": "东莞亚马逊牧业控股集团",
                        "id": 205351
                    }, {
                        "name": "北京华为农业",
                        "id": 205352
                    }, {
                        "name": "天津微软",
                        "id": 205353
                    }, {
                        "name": "厦门华为医院有限公司",
                        "id": 205354
                    }]
                }, {
                    "name": "台北谷歌渔业",
                    "id": 205355
                }, {
                    "name": "东京华为智能有限公司",
                    "id": 205356
                }, {
                    "name": "厦门喜茶医药",
                    "id": 205357
                }, {
                    "name": "上海华为渔业",
                    "id": 205358
                }, {
                    "name": "南京瑞幸地产",
                    "id": 205359
                }, {
                    "name": "杭州苹果证券",
                    "id": 205360,
                    "children": [{
                        "name": "厦门特斯拉",
                        "id": 205361
                    }, {
                        "name": "广州喜茶",
                        "id": 205362
                    }, {
                        "name": "纽约苹果科技",
                        "id": 205363
                    }, {
                        "name": "北京必胜客地摊有限公司",
                        "id": 205364
                    }, {
                        "name": "首尔瑞幸地产",
                        "id": 205365
                    }, {
                        "name": "纽约必胜客旅游有限公司",
                        "id": 205366
                    }, {
                        "name": "首尔肯德基基金",
                        "id": 205367
                    }, {
                        "name": "天津小米智能",
                        "id": 205368
                    }, {
                        "name": "纽约平安银行",
                        "id": 205369
                    }, {
                        "name": "台北亚马逊地产",
                        "id": 205370
                    }, {
                        "name": "台北小米农业",
                        "id": 205371
                    }, {
                        "name": "杭州必胜客农业",
                        "id": 205372
                    }, {
                        "name": "香港必胜客餐饮",
                        "id": 205373
                    }, {
                        "name": "厦门喜茶餐饮有限公司",
                        "id": 205374
                    }, {
                        "name": "北京华为新能源控股集团",
                        "id": 205375
                    }, {
                        "name": "深圳百度互金",
                        "id": 205376
                    }, {
                        "name": "东京京东石油控股集团",
                        "id": 205377
                    }, {
                        "name": "南京肯德基航空控股集团",
                        "id": 205378
                    }, {
                        "name": "广州京东汽车",
                        "id": 205379
                    }, {
                        "name": "杭州星巴克汽车有限公司",
                        "id": 205380
                    }, {
                        "name": "天津平安医院",
                        "id": 205381
                    }, {
                        "name": "厦门微软芯片",
                        "id": 205382
                    }, {
                        "name": "台北瑞幸渔业有限公司",
                        "id": 205383
                    }, {
                        "name": "上海特斯拉通讯",
                        "id": 205384
                    }, {
                        "name": "首尔阿里餐饮控股集团",
                        "id": 205385
                    }, {
                        "name": "广州字节",
                        "id": 205386
                    }, {
                        "name": "东莞星巴克金融",
                        "id": 205387
                    }, {
                        "name": "纽约腾讯航空有限公司",
                        "id": 205388
                    }, {
                        "name": "首尔亚马逊控股集团",
                        "id": 205389
                    }]
                }, {
                    "name": "广州小米电商",
                    "id": 205390,
                    "children": [{
                        "name": "东莞蚂蚁农业控股集团",
                        "id": 205391
                    }, {
                        "name": "纽约瑞幸通讯",
                        "id": 205392
                    }, {
                        "name": "东京瑞幸智能控股集团",
                        "id": 205393
                    }, {
                        "name": "南京华为石油有限公司",
                        "id": 205394
                    }, {
                        "name": "广州滴滴农业",
                        "id": 205395
                    }, {
                        "name": "首尔瑞幸科技有限公司",
                        "id": 205396
                    }, {
                        "name": "台北微软控股集团",
                        "id": 205397
                    }, {
                        "name": "东京美团制造",
                        "id": 205398
                    }, {
                        "name": "香港平安旅游",
                        "id": 205399
                    }, {
                        "name": "上海瑞幸石油控股集团",
                        "id": 205400
                    }, {
                        "name": "纽约特斯拉基金",
                        "id": 205401
                    }, {
                        "name": "天津谷歌控股集团",
                        "id": 205402
                    }, {
                        "name": "广州瑞幸",
                        "id": 205403
                    }, {
                        "name": "杭州百度新能源",
                        "id": 205404
                    }, {
                        "name": "上海小米旅游",
                        "id": 205405
                    }, {
                        "name": "广州肯德基渔业有限公司",
                        "id": 205406
                    }, {
                        "name": "东莞亚马逊餐饮",
                        "id": 205407
                    }, {
                        "name": "天津字节芯片控股集团",
                        "id": 205408
                    }, {
                        "name": "天津苹果旅游",
                        "id": 205409
                    }, {
                        "name": "厦门亚马逊渔业",
                        "id": 205410
                    }, {
                        "name": "广州肯德基有限公司",
                        "id": 205411
                    }, {
                        "name": "纽约喜茶汽车",
                        "id": 205412
                    }, {
                        "name": "纽约百度控股集团",
                        "id": 205413
                    }, {
                        "name": "天津谷歌汽车",
                        "id": 205414
                    }]
                }, {
                    "name": "东莞滴滴医院",
                    "id": 205415
                }, {
                    "name": "首尔肯德基互金",
                    "id": 205416,
                    "children": [{
                        "name": "厦门苹果信息服务有限公司",
                        "id": 205417
                    }]
                }, {
                    "name": "香港华为石油",
                    "id": 205418
                }, {
                    "name": "首尔特斯拉医院",
                    "id": 205419,
                    "children": [{
                        "name": "上海百度制造",
                        "id": 205420
                    }, {
                        "name": "东京瑞幸航空控股集团",
                        "id": 205421
                    }, {
                        "name": "天津奈雪基金",
                        "id": 205422
                    }, {
                        "name": "深圳京东有限公司",
                        "id": 205423
                    }, {
                        "name": "首尔京东汽车",
                        "id": 205424
                    }, {
                        "name": "厦门谷歌",
                        "id": 205425
                    }, {
                        "name": "首尔星巴克旅游",
                        "id": 205426
                    }, {
                        "name": "天津奈雪通讯有限公司",
                        "id": 205427
                    }, {
                        "name": "天津华为证券",
                        "id": 205428
                    }, {
                        "name": "天津喜茶证券有限公司",
                        "id": 205429
                    }, {
                        "name": "北京苹果银行有限公司",
                        "id": 205430
                    }, {
                        "name": "上海奈雪养殖",
                        "id": 205431
                    }, {
                        "name": "台北特斯拉制造有限公司",
                        "id": 205432
                    }, {
                        "name": "东京苹果电商",
                        "id": 205433
                    }, {
                        "name": "台北百度医药",
                        "id": 205434
                    }, {
                        "name": "深圳华为基金",
                        "id": 205435
                    }, {
                        "name": "深圳腾讯餐饮",
                        "id": 205436
                    }, {
                        "name": "上海谷歌地产",
                        "id": 205437
                    }]
                }, {
                    "name": "东京蚂蚁",
                    "id": 205438
                }, {
                    "name": "深圳滴滴诊所",
                    "id": 205439
                }]
            }, {
                "name": "北京肯德基医药",
                "id": 205440,
                "children": [{
                    "name": "香港肯德基信息服务",
                    "id": 205441
                }, {
                    "name": "台北奈雪医药",
                    "id": 205442
                }, {
                    "name": "天津平安石油有限公司",
                    "id": 205443
                }, {
                    "name": "纽约微软芯片",
                    "id": 205444
                }, {
                    "name": "上海肯德基医药控股集团",
                    "id": 205445,
                    "children": [{
                        "name": "杭州平安智能",
                        "id": 205446
                    }, {
                        "name": "东莞必胜客通讯控股集团",
                        "id": 205447
                    }, {
                        "name": "香港腾讯互金",
                        "id": 205448
                    }, {
                        "name": "上海蚂蚁医药",
                        "id": 205449
                    }, {
                        "name": "上海阿里芯片控股集团",
                        "id": 205450
                    }, {
                        "name": "台北字节汽车控股集团",
                        "id": 205451
                    }, {
                        "name": "上海亚马逊通讯",
                        "id": 205452
                    }, {
                        "name": "东京奈雪芯片控股集团",
                        "id": 205453
                    }, {
                        "name": "深圳亚马逊银行",
                        "id": 205454
                    }, {
                        "name": "厦门必胜客芯片有限公司",
                        "id": 205455
                    }, {
                        "name": "上海阿里信息服务",
                        "id": 205456
                    }, {
                        "name": "天津美团",
                        "id": 205457
                    }]
                }]
            }, {
                "name": "纽约喜茶科技",
                "id": 205458
            }, {
                "name": "北京苹果信息服务",
                "id": 205459
            }, {
                "name": "东京欧珀石油",
                "id": 205460
            }, {
                "name": "北京微软制造控股集团",
                "id": 205461,
                "children": [{
                    "name": "杭州华为餐饮控股集团",
                    "id": 205462
                }, {
                    "name": "上海蚂蚁餐饮",
                    "id": 205463
                }, {
                    "name": "台北微软新能源",
                    "id": 205464
                }, {
                    "name": "香港美团计算机有限公司",
                    "id": 205465,
                    "children": [{
                        "name": "天津京东通信",
                        "id": 205466
                    }, {
                        "name": "北京微软通信",
                        "id": 205467
                    }, {
                        "name": "广州瑞幸互金",
                        "id": 205468
                    }, {
                        "name": "东京华为通信",
                        "id": 205469
                    }, {
                        "name": "上海欧珀通信有限公司",
                        "id": 205470
                    }, {
                        "name": "深圳快手汽车控股集团",
                        "id": 205471
                    }, {
                        "name": "上海京东科技控股集团",
                        "id": 205472
                    }, {
                        "name": "北京平安软件",
                        "id": 205473
                    }, {
                        "name": "北京瑞幸牧业",
                        "id": 205474
                    }, {
                        "name": "深圳奈雪有限公司",
                        "id": 205475
                    }]
                }, {
                    "name": "广州奈雪医院",
                    "id": 205476
                }, {
                    "name": "香港字节养殖",
                    "id": 205477
                }, {
                    "name": "台北欧珀石油有限公司",
                    "id": 205478
                }, {
                    "name": "首尔平安计算机",
                    "id": 205479,
                    "children": [{
                        "name": "上海小米证券",
                        "id": 205480
                    }]
                }, {
                    "name": "上海美团航空控股集团",
                    "id": 205481
                }, {
                    "name": "东莞小米",
                    "id": 205482,
                    "children": [{
                        "name": "上海蚂蚁渔业有限公司",
                        "id": 205483
                    }, {
                        "name": "杭州喜茶渔业",
                        "id": 205484
                    }, {
                        "name": "杭州亚马逊计算机有限公司",
                        "id": 205485
                    }]
                }, {
                    "name": "东京奈雪农业有限公司",
                    "id": 205486,
                    "children": [{
                        "name": "南京字节医院控股集团",
                        "id": 205487
                    }, {
                        "name": "深圳京东证券控股集团",
                        "id": 205488
                    }, {
                        "name": "南京平安制造控股集团",
                        "id": 205489
                    }, {
                        "name": "台北蚂蚁电商",
                        "id": 205490
                    }, {
                        "name": "东莞谷歌银行",
                        "id": 205491
                    }, {
                        "name": "杭州华为旅游控股集团",
                        "id": 205492
                    }, {
                        "name": "杭州滴滴餐饮",
                        "id": 205493
                    }, {
                        "name": "香港字节芯片",
                        "id": 205494
                    }, {
                        "name": "东莞字节金融有限公司",
                        "id": 205495
                    }, {
                        "name": "台北喜茶餐饮控股集团",
                        "id": 205496
                    }, {
                        "name": "上海小米计算机",
                        "id": 205497
                    }, {
                        "name": "广州阿里牧业控股集团",
                        "id": 205498
                    }, {
                        "name": "台北奈雪互金",
                        "id": 205499
                    }, {
                        "name": "纽约京东软件",
                        "id": 205500
                    }, {
                        "name": "深圳必胜客基金有限公司",
                        "id": 205501
                    }, {
                        "name": "广州微软医药",
                        "id": 205502
                    }, {
                        "name": "首尔腾讯养殖",
                        "id": 205503
                    }, {
                        "name": "上海阿里金融",
                        "id": 205504
                    }]
                }, {
                    "name": "东京必胜客软件",
                    "id": 205505
                }, {
                    "name": "香港瑞幸餐饮",
                    "id": 205506
                }, {
                    "name": "天津欧珀旅游",
                    "id": 205507
                }, {
                    "name": "杭州奈雪农业控股集团",
                    "id": 205508
                }, {
                    "name": "东京苹果地摊控股集团",
                    "id": 205509
                }, {
                    "name": "台北字节医药有限公司",
                    "id": 205510,
                    "children": [{
                        "name": "厦门喜茶诊所控股集团",
                        "id": 205511
                    }, {
                        "name": "广州腾讯科技控股集团",
                        "id": 205512
                    }, {
                        "name": "天津京东医药",
                        "id": 205513
                    }, {
                        "name": "上海喜茶",
                        "id": 205514
                    }, {
                        "name": "厦门星巴克芯片有限公司",
                        "id": 205515
                    }, {
                        "name": "纽约小米航空",
                        "id": 205516
                    }, {
                        "name": "杭州肯德基",
                        "id": 205517
                    }, {
                        "name": "上海快手航空",
                        "id": 205518
                    }, {
                        "name": "南京奈雪医药",
                        "id": 205519
                    }, {
                        "name": "上海谷歌金融有限公司",
                        "id": 205520
                    }, {
                        "name": "台北亚马逊计算机",
                        "id": 205521
                    }, {
                        "name": "纽约华为养殖",
                        "id": 205522
                    }, {
                        "name": "上海谷歌科技",
                        "id": 205523
                    }, {
                        "name": "南京阿里农业",
                        "id": 205524
                    }, {
                        "name": "广州腾讯制造",
                        "id": 205525
                    }, {
                        "name": "天津苹果银行",
                        "id": 205526
                    }, {
                        "name": "杭州谷歌诊所有限公司",
                        "id": 205527
                    }, {
                        "name": "南京蚂蚁牧业控股集团",
                        "id": 205528
                    }, {
                        "name": "南京必胜客",
                        "id": 205529
                    }, {
                        "name": "北京快手软件控股集团",
                        "id": 205530
                    }, {
                        "name": "南京苹果牧业",
                        "id": 205531
                    }, {
                        "name": "杭州肯德基智能有限公司",
                        "id": 205532
                    }, {
                        "name": "广州谷歌通讯",
                        "id": 205533
                    }, {
                        "name": "香港滴滴旅游有限公司",
                        "id": 205534
                    }, {
                        "name": "深圳腾讯芯片",
                        "id": 205535
                    }, {
                        "name": "纽约微软农业控股集团",
                        "id": 205536
                    }, {
                        "name": "杭州快手软件",
                        "id": 205537
                    }, {
                        "name": "香港星巴克信息服务",
                        "id": 205538
                    }, {
                        "name": "北京美团航空",
                        "id": 205539
                    }, {
                        "name": "杭州小米银行有限公司",
                        "id": 205540
                    }, {
                        "name": "广州华为地摊",
                        "id": 205541
                    }, {
                        "name": "南京微软智能有限公司",
                        "id": 205542
                    }, {
                        "name": "广州京东新能源",
                        "id": 205543
                    }, {
                        "name": "广州星巴克汽车",
                        "id": 205544
                    }, {
                        "name": "上海亚马逊旅游",
                        "id": 205545
                    }, {
                        "name": "台北京东基金控股集团",
                        "id": 205546
                    }]
                }, {
                    "name": "纽约京东科技",
                    "id": 205547
                }, {
                    "name": "南京滴滴汽车",
                    "id": 205548
                }, {
                    "name": "东莞瑞幸芯片",
                    "id": 205549
                }, {
                    "name": "天津快手计算机",
                    "id": 205550
                }, {
                    "name": "东京必胜客地摊控股集团",
                    "id": 205551,
                    "children": [{
                        "name": "台北苹果证券",
                        "id": 205552
                    }, {
                        "name": "香港滴滴石油",
                        "id": 205553
                    }, {
                        "name": "上海微软智能",
                        "id": 205554
                    }, {
                        "name": "东莞肯德基新能源",
                        "id": 205555
                    }, {
                        "name": "厦门蚂蚁电商控股集团",
                        "id": 205556
                    }, {
                        "name": "上海肯德基餐饮",
                        "id": 205557
                    }, {
                        "name": "杭州快手证券",
                        "id": 205558
                    }, {
                        "name": "南京京东渔业",
                        "id": 205559
                    }, {
                        "name": "上海腾讯电商有限公司",
                        "id": 205560
                    }, {
                        "name": "杭州亚马逊医院",
                        "id": 205561
                    }, {
                        "name": "纽约平安航空",
                        "id": 205562
                    }, {
                        "name": "厦门阿里汽车有限公司",
                        "id": 205563
                    }, {
                        "name": "天津京东养殖",
                        "id": 205564
                    }, {
                        "name": "深圳美团航空有限公司",
                        "id": 205565
                    }, {
                        "name": "东莞蚂蚁医院",
                        "id": 205566
                    }, {
                        "name": "东京特斯拉牧业",
                        "id": 205567
                    }, {
                        "name": "广州百度基金",
                        "id": 205568
                    }, {
                        "name": "杭州平安石油",
                        "id": 205569
                    }, {
                        "name": "东莞华为计算机",
                        "id": 205570
                    }, {
                        "name": "广州滴滴石油",
                        "id": 205571
                    }]
                }, {
                    "name": "台北滴滴石油有限公司",
                    "id": 205572
                }, {
                    "name": "北京美团制造控股集团",
                    "id": 205573
                }, {
                    "name": "纽约腾讯石油",
                    "id": 205574
                }, {
                    "name": "北京特斯拉计算机",
                    "id": 205575
                }, {
                    "name": "南京喜茶智能",
                    "id": 205576,
                    "children": [{
                        "name": "深圳华为计算机",
                        "id": 205577
                    }, {
                        "name": "杭州华为地摊",
                        "id": 205578
                    }, {
                        "name": "深圳欧珀通信",
                        "id": 205579
                    }, {
                        "name": "东京肯德基软件",
                        "id": 205580
                    }, {
                        "name": "上海快手通信",
                        "id": 205581
                    }, {
                        "name": "北京星巴克证券",
                        "id": 205582
                    }, {
                        "name": "广州百度制造控股集团",
                        "id": 205583
                    }, {
                        "name": "首尔快手芯片控股集团",
                        "id": 205584
                    }, {
                        "name": "纽约亚马逊金融",
                        "id": 205585
                    }, {
                        "name": "纽约特斯拉互金",
                        "id": 205586
                    }, {
                        "name": "台北谷歌养殖",
                        "id": 205587
                    }, {
                        "name": "香港华为地产控股集团",
                        "id": 205588
                    }, {
                        "name": "北京亚马逊农业有限公司",
                        "id": 205589
                    }, {
                        "name": "杭州滴滴智能",
                        "id": 205590
                    }, {
                        "name": "南京京东基金有限公司",
                        "id": 205591
                    }, {
                        "name": "北京美团旅游",
                        "id": 205592
                    }, {
                        "name": "上海百度石油有限公司",
                        "id": 205593
                    }, {
                        "name": "杭州微软计算机",
                        "id": 205594
                    }, {
                        "name": "台北阿里石油",
                        "id": 205595
                    }, {
                        "name": "台北百度芯片",
                        "id": 205596
                    }, {
                        "name": "东莞小米互金有限公司",
                        "id": 205597
                    }, {
                        "name": "首尔蚂蚁芯片",
                        "id": 205598
                    }, {
                        "name": "杭州快手医药",
                        "id": 205599
                    }, {
                        "name": "南京欧珀诊所",
                        "id": 205600
                    }, {
                        "name": "杭州星巴克",
                        "id": 205601
                    }, {
                        "name": "东京微软渔业",
                        "id": 205602
                    }, {
                        "name": "深圳华为制造有限公司",
                        "id": 205603
                    }, {
                        "name": "南京美团制造",
                        "id": 205604
                    }, {
                        "name": "杭州苹果医院有限公司",
                        "id": 205605
                    }]
                }, {
                    "name": "纽约华为信息服务",
                    "id": 205606
                }, {
                    "name": "东莞谷歌计算机",
                    "id": 205607
                }, {
                    "name": "东莞京东",
                    "id": 205608
                }, {
                    "name": "深圳华为",
                    "id": 205609
                }, {
                    "name": "深圳特斯拉通信控股集团",
                    "id": 205610
                }, {
                    "name": "杭州快手餐饮",
                    "id": 205611
                }, {
                    "name": "南京腾讯航空",
                    "id": 205612
                }, {
                    "name": "天津必胜客计算机",
                    "id": 205613
                }, {
                    "name": "首尔欧珀通信控股集团",
                    "id": 205614
                }]
            }, {
                "name": "广州滴滴旅游",
                "id": 205615
            }, {
                "name": "深圳平安金融有限公司",
                "id": 205616,
                "children": [{
                    "name": "上海平安信息服务",
                    "id": 205617
                }, {
                    "name": "台北平安医药控股集团",
                    "id": 205618
                }, {
                    "name": "北京亚马逊金融有限公司",
                    "id": 205619
                }, {
                    "name": "台北百度通讯有限公司",
                    "id": 205620
                }, {
                    "name": "杭州小米软件有限公司",
                    "id": 205621,
                    "children": [{
                        "name": "上海快手诊所",
                        "id": 205622
                    }, {
                        "name": "南京美团牧业有限公司",
                        "id": 205623
                    }, {
                        "name": "杭州星巴克科技",
                        "id": 205624
                    }, {
                        "name": "台北奈雪渔业有限公司",
                        "id": 205625
                    }, {
                        "name": "杭州谷歌汽车有限公司",
                        "id": 205626
                    }, {
                        "name": "天津华为计算机",
                        "id": 205627
                    }, {
                        "name": "上海必胜客通讯",
                        "id": 205628
                    }, {
                        "name": "东京微软牧业",
                        "id": 205629
                    }, {
                        "name": "北京欧珀计算机",
                        "id": 205630
                    }, {
                        "name": "首尔腾讯渔业",
                        "id": 205631
                    }, {
                        "name": "广州华为诊所",
                        "id": 205632
                    }, {
                        "name": "首尔滴滴",
                        "id": 205633
                    }, {
                        "name": "广州必胜客医院",
                        "id": 205634
                    }, {
                        "name": "杭州美团银行有限公司",
                        "id": 205635
                    }, {
                        "name": "南京苹果证券",
                        "id": 205636
                    }, {
                        "name": "厦门美团渔业",
                        "id": 205637
                    }, {
                        "name": "天津快手农业有限公司",
                        "id": 205638
                    }, {
                        "name": "台北蚂蚁",
                        "id": 205639
                    }, {
                        "name": "首尔阿里金融",
                        "id": 205640
                    }, {
                        "name": "首尔美团渔业控股集团",
                        "id": 205641
                    }, {
                        "name": "首尔京东基金有限公司",
                        "id": 205642
                    }, {
                        "name": "纽约喜茶餐饮有限公司",
                        "id": 205643
                    }, {
                        "name": "杭州肯德基电商",
                        "id": 205644
                    }]
                }, {
                    "name": "台北特斯拉证券",
                    "id": 205645
                }, {
                    "name": "东莞苹果石油",
                    "id": 205646,
                    "children": [{
                        "name": "厦门喜茶金融",
                        "id": 205647
                    }, {
                        "name": "北京字节基金控股集团",
                        "id": 205648
                    }, {
                        "name": "杭州蚂蚁医院",
                        "id": 205649
                    }, {
                        "name": "纽约百度基金",
                        "id": 205650
                    }, {
                        "name": "上海肯德基地摊",
                        "id": 205651
                    }, {
                        "name": "南京奈雪银行",
                        "id": 205652
                    }, {
                        "name": "上海特斯拉金融",
                        "id": 205653
                    }, {
                        "name": "厦门亚马逊养殖有限公司",
                        "id": 205654
                    }, {
                        "name": "广州华为旅游有限公司",
                        "id": 205655
                    }, {
                        "name": "厦门特斯拉新能源",
                        "id": 205656
                    }, {
                        "name": "台北苹果金融",
                        "id": 205657
                    }, {
                        "name": "南京微软旅游有限公司",
                        "id": 205658
                    }, {
                        "name": "东莞星巴克通信",
                        "id": 205659
                    }, {
                        "name": "台北腾讯互金控股集团",
                        "id": 205660
                    }, {
                        "name": "广州快手地产",
                        "id": 205661
                    }, {
                        "name": "杭州京东",
                        "id": 205662
                    }, {
                        "name": "纽约蚂蚁电商",
                        "id": 205663
                    }, {
                        "name": "南京百度餐饮控股集团",
                        "id": 205664
                    }, {
                        "name": "首尔华为银行",
                        "id": 205665
                    }, {
                        "name": "首尔谷歌航空",
                        "id": 205666
                    }, {
                        "name": "台北奈雪金融控股集团",
                        "id": 205667
                    }, {
                        "name": "深圳喜茶智能有限公司",
                        "id": 205668
                    }, {
                        "name": "南京星巴克旅游",
                        "id": 205669
                    }, {
                        "name": "上海苹果计算机",
                        "id": 205670
                    }, {
                        "name": "深圳微软证券控股集团",
                        "id": 205671
                    }, {
                        "name": "厦门肯德基软件",
                        "id": 205672
                    }, {
                        "name": "首尔亚马逊信息服务",
                        "id": 205673
                    }, {
                        "name": "东京蚂蚁渔业有限公司",
                        "id": 205674
                    }, {
                        "name": "首尔美团互金控股集团",
                        "id": 205675
                    }, {
                        "name": "香港喜茶计算机有限公司",
                        "id": 205676
                    }, {
                        "name": "东京特斯拉渔业",
                        "id": 205677
                    }, {
                        "name": "台北微软软件有限公司",
                        "id": 205678
                    }, {
                        "name": "台北滴滴医药控股集团",
                        "id": 205679
                    }, {
                        "name": "南京苹果通讯",
                        "id": 205680
                    }, {
                        "name": "香港蚂蚁银行",
                        "id": 205681
                    }]
                }, {
                    "name": "天津字节银行",
                    "id": 205682
                }, {
                    "name": "厦门百度芯片",
                    "id": 205683
                }, {
                    "name": "厦门必胜客计算机",
                    "id": 205684
                }, {
                    "name": "北京百度医药",
                    "id": 205685
                }, {
                    "name": "杭州平安地摊",
                    "id": 205686
                }, {
                    "name": "南京肯德基",
                    "id": 205687
                }, {
                    "name": "南京阿里旅游",
                    "id": 205688,
                    "children": [{
                        "name": "香港肯德基证券",
                        "id": 205689
                    }, {
                        "name": "北京美团通讯控股集团",
                        "id": 205690
                    }, {
                        "name": "东莞星巴克地产",
                        "id": 205691
                    }, {
                        "name": "深圳奈雪新能源",
                        "id": 205692
                    }, {
                        "name": "纽约欧珀计算机",
                        "id": 205693
                    }, {
                        "name": "纽约蚂蚁地摊有限公司",
                        "id": 205694
                    }, {
                        "name": "北京小米医院有限公司",
                        "id": 205695
                    }, {
                        "name": "首尔必胜客",
                        "id": 205696
                    }, {
                        "name": "台北蚂蚁",
                        "id": 205697
                    }, {
                        "name": "首尔特斯拉科技",
                        "id": 205698
                    }, {
                        "name": "纽约肯德基牧业有限公司",
                        "id": 205699
                    }, {
                        "name": "北京肯德基航空控股集团",
                        "id": 205700
                    }, {
                        "name": "东莞百度信息服务",
                        "id": 205701
                    }, {
                        "name": "纽约小米证券有限公司",
                        "id": 205702
                    }, {
                        "name": "杭州小米汽车",
                        "id": 205703
                    }, {
                        "name": "深圳亚马逊科技有限公司",
                        "id": 205704
                    }, {
                        "name": "东莞字节旅游",
                        "id": 205705
                    }, {
                        "name": "香港亚马逊牧业有限公司",
                        "id": 205706
                    }, {
                        "name": "深圳平安信息服务",
                        "id": 205707
                    }, {
                        "name": "深圳星巴克诊所",
                        "id": 205708
                    }, {
                        "name": "首尔平安汽车控股集团",
                        "id": 205709
                    }, {
                        "name": "深圳滴滴新能源",
                        "id": 205710
                    }, {
                        "name": "广州欧珀计算机",
                        "id": 205711
                    }, {
                        "name": "北京瑞幸航空",
                        "id": 205712
                    }, {
                        "name": "北京平安通讯",
                        "id": 205713
                    }, {
                        "name": "南京必胜客医药控股集团",
                        "id": 205714
                    }, {
                        "name": "上海奈雪",
                        "id": 205715
                    }, {
                        "name": "杭州欧珀石油有限公司",
                        "id": 205716
                    }]
                }, {
                    "name": "南京瑞幸通讯",
                    "id": 205717
                }, {
                    "name": "香港肯德基银行",
                    "id": 205718
                }, {
                    "name": "首尔肯德基养殖",
                    "id": 205719
                }, {
                    "name": "北京华为银行",
                    "id": 205720
                }]
            }, {
                "name": "上海微软地摊控股集团",
                "id": 205721
            }, {
                "name": "深圳特斯拉地摊",
                "id": 205722,
                "children": [{
                    "name": "上海瑞幸",
                    "id": 205723
                }, {
                    "name": "首尔阿里芯片",
                    "id": 205724
                }, {
                    "name": "深圳平安地摊有限公司",
                    "id": 205725
                }, {
                    "name": "首尔肯德基制造",
                    "id": 205726,
                    "children": [{
                        "name": "南京亚马逊制造控股集团",
                        "id": 205727
                    }, {
                        "name": "首尔特斯拉地摊有限公司",
                        "id": 205728
                    }, {
                        "name": "纽约星巴克餐饮控股集团",
                        "id": 205729
                    }, {
                        "name": "天津喜茶餐饮",
                        "id": 205730
                    }, {
                        "name": "上海特斯拉互金有限公司",
                        "id": 205731
                    }, {
                        "name": "天津星巴克旅游",
                        "id": 205732
                    }, {
                        "name": "广州小米智能",
                        "id": 205733
                    }]
                }, {
                    "name": "纽约阿里互金",
                    "id": 205734
                }, {
                    "name": "香港字节牧业",
                    "id": 205735
                }, {
                    "name": "香港喜茶医院",
                    "id": 205736
                }, {
                    "name": "南京肯德基汽车有限公司",
                    "id": 205737
                }, {
                    "name": "杭州华为渔业有限公司",
                    "id": 205738
                }, {
                    "name": "首尔奈雪地产",
                    "id": 205739
                }, {
                    "name": "深圳亚马逊基金有限公司",
                    "id": 205740
                }, {
                    "name": "纽约肯德基软件",
                    "id": 205741
                }, {
                    "name": "深圳特斯拉地摊有限公司",
                    "id": 205742,
                    "children": [{
                        "name": "上海滴滴基金",
                        "id": 205743
                    }, {
                        "name": "南京平安科技控股集团",
                        "id": 205744
                    }, {
                        "name": "香港京东",
                        "id": 205745
                    }, {
                        "name": "广州小米地摊",
                        "id": 205746
                    }, {
                        "name": "首尔瑞幸科技",
                        "id": 205747
                    }, {
                        "name": "台北苹果诊所",
                        "id": 205748
                    }, {
                        "name": "台北喜茶汽车",
                        "id": 205749
                    }, {
                        "name": "香港喜茶基金",
                        "id": 205750
                    }, {
                        "name": "天津滴滴医药控股集团",
                        "id": 205751
                    }, {
                        "name": "南京特斯拉互金",
                        "id": 205752
                    }, {
                        "name": "天津必胜客芯片",
                        "id": 205753
                    }, {
                        "name": "南京平安地摊有限公司",
                        "id": 205754
                    }, {
                        "name": "杭州滴滴信息服务控股集团",
                        "id": 205755
                    }, {
                        "name": "纽约滴滴基金",
                        "id": 205756
                    }, {
                        "name": "香港奈雪养殖",
                        "id": 205757
                    }, {
                        "name": "南京平安通讯",
                        "id": 205758
                    }, {
                        "name": "上海必胜客软件",
                        "id": 205759
                    }, {
                        "name": "北京喜茶诊所",
                        "id": 205760
                    }]
                }, {
                    "name": "首尔特斯拉医药",
                    "id": 205761,
                    "children": [{
                        "name": "北京蚂蚁金融",
                        "id": 205762
                    }, {
                        "name": "深圳欧珀基金",
                        "id": 205763
                    }, {
                        "name": "首尔必胜客新能源",
                        "id": 205764
                    }, {
                        "name": "北京京东",
                        "id": 205765
                    }, {
                        "name": "南京亚马逊汽车控股集团",
                        "id": 205766
                    }, {
                        "name": "上海滴滴农业有限公司",
                        "id": 205767
                    }, {
                        "name": "深圳必胜客渔业",
                        "id": 205768
                    }, {
                        "name": "北京腾讯芯片控股集团",
                        "id": 205769
                    }, {
                        "name": "深圳蚂蚁科技",
                        "id": 205770
                    }, {
                        "name": "杭州微软制造",
                        "id": 205771
                    }]
                }]
            }, {
                "name": "首尔微软渔业",
                "id": 205772
            }, {
                "name": "东莞美团银行",
                "id": 205773
            }, {
                "name": "北京谷歌通信",
                "id": 205774
            }, {
                "name": "南京必胜客基金有限公司",
                "id": 205775
            }, {
                "name": "首尔肯德基汽车",
                "id": 205776
            }, {
                "name": "天津百度通讯",
                "id": 205777
            }, {
                "name": "北京华为农业",
                "id": 205778
            }]
        }, {
            "name": "南京华为医药",
            "id": 205779
        }, {
            "name": "杭州亚马逊养殖",
            "id": 205780
        }, {
            "name": "首尔滴滴航空",
            "id": 205781
        }, {
            "name": "杭州苹果互金",
            "id": 205782,
            "children": [{
                "name": "天津百度控股集团",
                "id": 205783
            }, {
                "name": "深圳平安",
                "id": 205784
            }, {
                "name": "南京奈雪智能控股集团",
                "id": 205785
            }, {
                "name": "香港平安诊所",
                "id": 205786
            }, {
                "name": "厦门肯德基旅游",
                "id": 205787
            }, {
                "name": "广州滴滴石油",
                "id": 205788
            }, {
                "name": "台北美团渔业",
                "id": 205789
            }, {
                "name": "杭州肯德基金融",
                "id": 205790
            }, {
                "name": "天津星巴克基金",
                "id": 205791
            }, {
                "name": "杭州瑞幸",
                "id": 205792
            }, {
                "name": "纽约微软石油",
                "id": 205793
            }, {
                "name": "首尔微软牧业",
                "id": 205794
            }, {
                "name": "广州华为金融控股集团",
                "id": 205795
            }, {
                "name": "厦门苹果制造",
                "id": 205796
            }, {
                "name": "天津小米餐饮",
                "id": 205797,
                "children": [{
                    "name": "香港微软控股集团",
                    "id": 205798,
                    "children": [{
                        "name": "纽约小米",
                        "id": 205799
                    }, {
                        "name": "首尔快手汽车有限公司",
                        "id": 205800
                    }, {
                        "name": "北京小米地产有限公司",
                        "id": 205801
                    }, {
                        "name": "台北阿里证券有限公司",
                        "id": 205802
                    }, {
                        "name": "上海美团银行",
                        "id": 205803
                    }, {
                        "name": "香港苹果",
                        "id": 205804
                    }, {
                        "name": "天津亚马逊地产",
                        "id": 205805
                    }, {
                        "name": "首尔喜茶诊所",
                        "id": 205806
                    }, {
                        "name": "纽约京东银行",
                        "id": 205807
                    }, {
                        "name": "杭州欧珀金融控股集团",
                        "id": 205808
                    }, {
                        "name": "杭州喜茶旅游有限公司",
                        "id": 205809
                    }, {
                        "name": "南京阿里智能",
                        "id": 205810
                    }, {
                        "name": "台北奈雪医院",
                        "id": 205811
                    }, {
                        "name": "杭州欧珀基金",
                        "id": 205812
                    }, {
                        "name": "上海瑞幸软件",
                        "id": 205813
                    }, {
                        "name": "天津肯德基互金",
                        "id": 205814
                    }, {
                        "name": "南京亚马逊地产",
                        "id": 205815
                    }, {
                        "name": "天津华为农业有限公司",
                        "id": 205816
                    }, {
                        "name": "首尔奈雪",
                        "id": 205817
                    }, {
                        "name": "香港阿里航空",
                        "id": 205818
                    }, {
                        "name": "厦门小米农业控股集团",
                        "id": 205819
                    }, {
                        "name": "东莞谷歌金融有限公司",
                        "id": 205820
                    }, {
                        "name": "纽约蚂蚁新能源",
                        "id": 205821
                    }, {
                        "name": "台北微软证券",
                        "id": 205822
                    }]
                }, {
                    "name": "上海腾讯电商有限公司",
                    "id": 205823
                }, {
                    "name": "香港瑞幸渔业",
                    "id": 205824
                }, {
                    "name": "东京微软汽车",
                    "id": 205825,
                    "children": [{
                        "name": "东莞喜茶金融",
                        "id": 205826
                    }, {
                        "name": "东京平安石油控股集团",
                        "id": 205827
                    }, {
                        "name": "台北小米计算机控股集团",
                        "id": 205828
                    }, {
                        "name": "深圳星巴克芯片有限公司",
                        "id": 205829
                    }, {
                        "name": "深圳京东渔业",
                        "id": 205830
                    }, {
                        "name": "杭州欧珀电商有限公司",
                        "id": 205831
                    }, {
                        "name": "北京瑞幸基金有限公司",
                        "id": 205832
                    }, {
                        "name": "台北欧珀基金",
                        "id": 205833
                    }, {
                        "name": "广州瑞幸银行",
                        "id": 205834
                    }, {
                        "name": "广州阿里地产",
                        "id": 205835
                    }, {
                        "name": "首尔微软有限公司",
                        "id": 205836
                    }, {
                        "name": "南京阿里新能源",
                        "id": 205837
                    }, {
                        "name": "广州华为养殖有限公司",
                        "id": 205838
                    }, {
                        "name": "广州谷歌牧业控股集团",
                        "id": 205839
                    }, {
                        "name": "厦门百度航空",
                        "id": 205840
                    }, {
                        "name": "东莞华为信息服务控股集团",
                        "id": 205841
                    }, {
                        "name": "杭州肯德基软件有限公司",
                        "id": 205842
                    }, {
                        "name": "北京瑞幸",
                        "id": 205843
                    }, {
                        "name": "东莞亚马逊芯片",
                        "id": 205844
                    }, {
                        "name": "台北微软科技",
                        "id": 205845
                    }, {
                        "name": "广州字节制造控股集团",
                        "id": 205846
                    }, {
                        "name": "厦门必胜客信息服务",
                        "id": 205847
                    }]
                }, {
                    "name": "杭州平安通信有限公司",
                    "id": 205848
                }, {
                    "name": "香港平安互金控股集团",
                    "id": 205849
                }, {
                    "name": "上海京东芯片有限公司",
                    "id": 205850
                }, {
                    "name": "广州肯德基",
                    "id": 205851
                }, {
                    "name": "台北星巴克控股集团",
                    "id": 205852
                }, {
                    "name": "纽约奈雪控股集团",
                    "id": 205853
                }, {
                    "name": "天津字节餐饮",
                    "id": 205854,
                    "children": [{
                        "name": "香港滴滴地产有限公司",
                        "id": 205855
                    }, {
                        "name": "香港奈雪电商控股集团",
                        "id": 205856
                    }, {
                        "name": "上海华为餐饮控股集团",
                        "id": 205857
                    }, {
                        "name": "香港谷歌智能",
                        "id": 205858
                    }, {
                        "name": "杭州欧珀石油",
                        "id": 205859
                    }, {
                        "name": "南京特斯拉医院",
                        "id": 205860
                    }, {
                        "name": "厦门小米渔业",
                        "id": 205861
                    }, {
                        "name": "广州瑞幸通讯",
                        "id": 205862
                    }, {
                        "name": "首尔必胜客牧业",
                        "id": 205863
                    }, {
                        "name": "首尔腾讯新能源",
                        "id": 205864
                    }, {
                        "name": "南京特斯拉基金",
                        "id": 205865
                    }, {
                        "name": "天津百度软件",
                        "id": 205866
                    }, {
                        "name": "东京星巴克计算机",
                        "id": 205867
                    }, {
                        "name": "北京快手计算机",
                        "id": 205868
                    }, {
                        "name": "深圳腾讯信息服务控股集团",
                        "id": 205869
                    }, {
                        "name": "东莞平安农业",
                        "id": 205870
                    }, {
                        "name": "深圳欧珀电商",
                        "id": 205871
                    }, {
                        "name": "东京京东航空",
                        "id": 205872
                    }, {
                        "name": "深圳星巴克银行",
                        "id": 205873
                    }, {
                        "name": "南京谷歌制造",
                        "id": 205874
                    }, {
                        "name": "纽约欧珀石油",
                        "id": 205875
                    }]
                }, {
                    "name": "南京微软农业",
                    "id": 205876
                }, {
                    "name": "香港肯德基",
                    "id": 205877
                }, {
                    "name": "天津滴滴地产",
                    "id": 205878
                }, {
                    "name": "香港瑞幸芯片",
                    "id": 205879
                }, {
                    "name": "深圳必胜客地摊有限公司",
                    "id": 205880
                }, {
                    "name": "东莞瑞幸智能",
                    "id": 205881
                }, {
                    "name": "香港喜茶通信",
                    "id": 205882
                }, {
                    "name": "东莞星巴克智能",
                    "id": 205883
                }, {
                    "name": "天津微软计算机有限公司",
                    "id": 205884
                }, {
                    "name": "厦门阿里基金有限公司",
                    "id": 205885
                }, {
                    "name": "上海快手",
                    "id": 205886
                }, {
                    "name": "深圳亚马逊牧业",
                    "id": 205887,
                    "children": [{
                        "name": "东京字节智能",
                        "id": 205888
                    }, {
                        "name": "厦门蚂蚁智能",
                        "id": 205889
                    }, {
                        "name": "南京蚂蚁基金有限公司",
                        "id": 205890
                    }, {
                        "name": "纽约平安医院有限公司",
                        "id": 205891
                    }, {
                        "name": "杭州必胜客芯片",
                        "id": 205892
                    }, {
                        "name": "厦门亚马逊通讯",
                        "id": 205893
                    }, {
                        "name": "南京华为养殖",
                        "id": 205894
                    }]
                }, {
                    "name": "北京字节互金有限公司",
                    "id": 205895
                }, {
                    "name": "东京阿里芯片",
                    "id": 205896,
                    "children": [{
                        "name": "南京腾讯医院",
                        "id": 205897
                    }, {
                        "name": "厦门字节汽车控股集团",
                        "id": 205898
                    }, {
                        "name": "首尔快手",
                        "id": 205899
                    }, {
                        "name": "上海美团",
                        "id": 205900
                    }, {
                        "name": "厦门快手医院控股集团",
                        "id": 205901
                    }, {
                        "name": "首尔蚂蚁汽车",
                        "id": 205902
                    }, {
                        "name": "杭州阿里航空有限公司",
                        "id": 205903
                    }, {
                        "name": "东莞亚马逊计算机",
                        "id": 205904
                    }, {
                        "name": "上海百度牧业有限公司",
                        "id": 205905
                    }, {
                        "name": "香港京东银行",
                        "id": 205906
                    }, {
                        "name": "首尔肯德基有限公司",
                        "id": 205907
                    }, {
                        "name": "深圳特斯拉有限公司",
                        "id": 205908
                    }]
                }, {
                    "name": "厦门特斯拉医院",
                    "id": 205909,
                    "children": [{
                        "name": "东莞华为",
                        "id": 205910
                    }, {
                        "name": "台北蚂蚁银行控股集团",
                        "id": 205911
                    }, {
                        "name": "深圳欧珀软件有限公司",
                        "id": 205912
                    }, {
                        "name": "杭州字节石油",
                        "id": 205913
                    }]
                }, {
                    "name": "东莞小米证券",
                    "id": 205914
                }]
            }, {
                "name": "北京苹果餐饮",
                "id": 205915,
                "children": [{
                    "name": "纽约京东渔业有限公司",
                    "id": 205916
                }, {
                    "name": "东京奈雪",
                    "id": 205917
                }, {
                    "name": "杭州蚂蚁科技",
                    "id": 205918
                }, {
                    "name": "南京微软旅游有限公司",
                    "id": 205919
                }, {
                    "name": "东莞奈雪",
                    "id": 205920
                }, {
                    "name": "北京特斯拉牧业",
                    "id": 205921
                }, {
                    "name": "台北华为基金控股集团",
                    "id": 205922
                }, {
                    "name": "深圳百度有限公司",
                    "id": 205923
                }, {
                    "name": "深圳字节旅游",
                    "id": 205924
                }, {
                    "name": "深圳瑞幸金融",
                    "id": 205925,
                    "children": [{
                        "name": "东莞必胜客电商",
                        "id": 205926
                    }, {
                        "name": "纽约苹果有限公司",
                        "id": 205927
                    }, {
                        "name": "东莞美团银行",
                        "id": 205928
                    }, {
                        "name": "天津小米科技",
                        "id": 205929
                    }]
                }, {
                    "name": "南京喜茶渔业控股集团",
                    "id": 205930
                }, {
                    "name": "杭州平安渔业有限公司",
                    "id": 205931,
                    "children": [{
                        "name": "北京苹果信息服务",
                        "id": 205932
                    }, {
                        "name": "杭州字节地摊有限公司",
                        "id": 205933
                    }, {
                        "name": "台北京东证券控股集团",
                        "id": 205934
                    }, {
                        "name": "纽约京东农业",
                        "id": 205935
                    }, {
                        "name": "纽约百度金融",
                        "id": 205936
                    }, {
                        "name": "上海华为",
                        "id": 205937
                    }, {
                        "name": "广州特斯拉旅游",
                        "id": 205938
                    }, {
                        "name": "台北平安汽车",
                        "id": 205939
                    }, {
                        "name": "上海奈雪航空",
                        "id": 205940
                    }, {
                        "name": "纽约百度石油控股集团",
                        "id": 205941
                    }, {
                        "name": "南京星巴克软件",
                        "id": 205942
                    }, {
                        "name": "台北微软计算机有限公司",
                        "id": 205943
                    }, {
                        "name": "台北瑞幸计算机控股集团",
                        "id": 205944
                    }, {
                        "name": "首尔蚂蚁汽车控股集团",
                        "id": 205945
                    }, {
                        "name": "广州必胜客有限公司",
                        "id": 205946
                    }, {
                        "name": "天津华为地摊",
                        "id": 205947
                    }, {
                        "name": "杭州奈雪牧业",
                        "id": 205948
                    }, {
                        "name": "杭州瑞幸牧业控股集团",
                        "id": 205949
                    }, {
                        "name": "上海喜茶汽车",
                        "id": 205950
                    }]
                }, {
                    "name": "广州华为石油",
                    "id": 205951
                }, {
                    "name": "东京小米",
                    "id": 205952
                }, {
                    "name": "天津星巴克金融",
                    "id": 205953
                }, {
                    "name": "杭州百度牧业",
                    "id": 205954
                }]
            }, {
                "name": "首尔字节智能",
                "id": 205955,
                "children": [{
                    "name": "香港奈雪地产有限公司",
                    "id": 205956
                }, {
                    "name": "东京亚马逊汽车",
                    "id": 205957
                }, {
                    "name": "厦门星巴克银行",
                    "id": 205958
                }, {
                    "name": "南京特斯拉电商",
                    "id": 205959
                }, {
                    "name": "东莞滴滴餐饮有限公司",
                    "id": 205960
                }, {
                    "name": "杭州百度科技有限公司",
                    "id": 205961,
                    "children": [{
                        "name": "南京星巴克养殖",
                        "id": 205962
                    }, {
                        "name": "杭州星巴克诊所",
                        "id": 205963
                    }, {
                        "name": "杭州亚马逊互金",
                        "id": 205964
                    }, {
                        "name": "杭州平安信息服务",
                        "id": 205965
                    }, {
                        "name": "北京京东医院有限公司",
                        "id": 205966
                    }, {
                        "name": "厦门苹果软件",
                        "id": 205967
                    }, {
                        "name": "广州美团医院",
                        "id": 205968
                    }, {
                        "name": "广州特斯拉基金",
                        "id": 205969
                    }, {
                        "name": "香港百度养殖",
                        "id": 205970
                    }, {
                        "name": "上海阿里养殖",
                        "id": 205971
                    }, {
                        "name": "南京瑞幸科技",
                        "id": 205972
                    }, {
                        "name": "香港肯德基制造",
                        "id": 205973
                    }, {
                        "name": "首尔美团地产控股集团",
                        "id": 205974
                    }, {
                        "name": "杭州奈雪牧业",
                        "id": 205975
                    }, {
                        "name": "广州谷歌航空",
                        "id": 205976
                    }]
                }, {
                    "name": "北京奈雪科技",
                    "id": 205977
                }, {
                    "name": "杭州谷歌",
                    "id": 205978
                }, {
                    "name": "杭州奈雪农业",
                    "id": 205979
                }, {
                    "name": "天津特斯拉医院",
                    "id": 205980
                }, {
                    "name": "东莞喜茶地摊",
                    "id": 205981
                }, {
                    "name": "香港百度新能源",
                    "id": 205982
                }, {
                    "name": "南京蚂蚁智能控股集团",
                    "id": 205983
                }, {
                    "name": "深圳字节医院",
                    "id": 205984
                }, {
                    "name": "台北肯德基制造",
                    "id": 205985
                }, {
                    "name": "厦门苹果信息服务",
                    "id": 205986
                }, {
                    "name": "台北星巴克餐饮",
                    "id": 205987
                }, {
                    "name": "广州亚马逊有限公司",
                    "id": 205988,
                    "children": [{
                        "name": "深圳喜茶地产控股集团",
                        "id": 205989
                    }, {
                        "name": "首尔奈雪汽车",
                        "id": 205990
                    }, {
                        "name": "香港肯德基互金控股集团",
                        "id": 205991
                    }, {
                        "name": "杭州奈雪诊所控股集团",
                        "id": 205992
                    }, {
                        "name": "上海微软制造",
                        "id": 205993
                    }]
                }, {
                    "name": "天津亚马逊诊所控股集团",
                    "id": 205994
                }, {
                    "name": "天津平安金融",
                    "id": 205995
                }, {
                    "name": "杭州腾讯医药有限公司",
                    "id": 205996
                }, {
                    "name": "香港百度诊所",
                    "id": 205997
                }, {
                    "name": "杭州蚂蚁软件有限公司",
                    "id": 205998
                }, {
                    "name": "杭州星巴克证券",
                    "id": 205999
                }, {
                    "name": "广州喜茶电商",
                    "id": 206000
                }, {
                    "name": "深圳欧珀餐饮",
                    "id": 206001
                }]
            }, {
                "name": "天津必胜客通讯控股集团",
                "id": 206002
            }, {
                "name": "厦门苹果诊所有限公司",
                "id": 206003,
                "children": [{
                    "name": "杭州瑞幸地产有限公司",
                    "id": 206004,
                    "children": [{
                        "name": "杭州华为养殖",
                        "id": 206005
                    }, {
                        "name": "广州星巴克医院有限公司",
                        "id": 206006
                    }, {
                        "name": "上海特斯拉农业控股集团",
                        "id": 206007
                    }, {
                        "name": "杭州苹果地产",
                        "id": 206008
                    }, {
                        "name": "东莞微软旅游有限公司",
                        "id": 206009
                    }, {
                        "name": "天津字节电商",
                        "id": 206010
                    }, {
                        "name": "北京腾讯信息服务",
                        "id": 206011
                    }, {
                        "name": "东京奈雪金融",
                        "id": 206012
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 206013
                    }, {
                        "name": "香港腾讯证券",
                        "id": 206014
                    }, {
                        "name": "上海华为地摊",
                        "id": 206015
                    }, {
                        "name": "深圳欧珀",
                        "id": 206016
                    }, {
                        "name": "东莞谷歌牧业控股集团",
                        "id": 206017
                    }, {
                        "name": "首尔美团电商",
                        "id": 206018
                    }, {
                        "name": "首尔小米医院",
                        "id": 206019
                    }, {
                        "name": "台北快手汽车",
                        "id": 206020
                    }, {
                        "name": "台北奈雪航空",
                        "id": 206021
                    }, {
                        "name": "深圳阿里金融",
                        "id": 206022
                    }, {
                        "name": "香港平安证券",
                        "id": 206023
                    }, {
                        "name": "杭州蚂蚁科技控股集团",
                        "id": 206024
                    }, {
                        "name": "香港小米医药",
                        "id": 206025
                    }]
                }, {
                    "name": "北京瑞幸诊所",
                    "id": 206026,
                    "children": [{
                        "name": "香港瑞幸有限公司",
                        "id": 206027
                    }, {
                        "name": "台北阿里牧业",
                        "id": 206028
                    }, {
                        "name": "台北星巴克证券有限公司",
                        "id": 206029
                    }, {
                        "name": "东莞京东科技控股集团",
                        "id": 206030
                    }, {
                        "name": "首尔美团汽车",
                        "id": 206031
                    }, {
                        "name": "深圳苹果电商有限公司",
                        "id": 206032
                    }, {
                        "name": "南京微软控股集团",
                        "id": 206033
                    }, {
                        "name": "上海腾讯地摊",
                        "id": 206034
                    }, {
                        "name": "北京快手控股集团",
                        "id": 206035
                    }, {
                        "name": "上海字节通讯",
                        "id": 206036
                    }, {
                        "name": "南京腾讯渔业",
                        "id": 206037
                    }, {
                        "name": "台北亚马逊互金控股集团",
                        "id": 206038
                    }, {
                        "name": "纽约平安电商",
                        "id": 206039
                    }]
                }, {
                    "name": "杭州字节航空有限公司",
                    "id": 206040
                }, {
                    "name": "杭州微软基金",
                    "id": 206041
                }, {
                    "name": "天津亚马逊养殖控股集团",
                    "id": 206042
                }, {
                    "name": "台北滴滴地产",
                    "id": 206043
                }, {
                    "name": "天津苹果基金",
                    "id": 206044
                }, {
                    "name": "深圳小米互金",
                    "id": 206045
                }, {
                    "name": "南京滴滴有限公司",
                    "id": 206046
                }, {
                    "name": "北京字节科技",
                    "id": 206047
                }, {
                    "name": "纽约苹果科技",
                    "id": 206048
                }, {
                    "name": "上海小米通讯有限公司",
                    "id": 206049,
                    "children": [{
                        "name": "首尔谷歌证券控股集团",
                        "id": 206050
                    }, {
                        "name": "东莞奈雪金融",
                        "id": 206051
                    }, {
                        "name": "天津京东农业",
                        "id": 206052
                    }, {
                        "name": "天津谷歌地产",
                        "id": 206053
                    }, {
                        "name": "台北必胜客航空",
                        "id": 206054
                    }, {
                        "name": "深圳京东农业",
                        "id": 206055
                    }, {
                        "name": "首尔腾讯旅游有限公司",
                        "id": 206056
                    }, {
                        "name": "北京喜茶新能源",
                        "id": 206057
                    }, {
                        "name": "首尔微软芯片",
                        "id": 206058
                    }, {
                        "name": "台北蚂蚁新能源控股集团",
                        "id": 206059
                    }, {
                        "name": "台北滴滴证券",
                        "id": 206060
                    }, {
                        "name": "北京亚马逊航空有限公司",
                        "id": 206061
                    }, {
                        "name": "东莞滴滴科技",
                        "id": 206062
                    }]
                }, {
                    "name": "香港瑞幸牧业",
                    "id": 206063
                }, {
                    "name": "天津亚马逊地摊",
                    "id": 206064
                }, {
                    "name": "首尔微软航空",
                    "id": 206065
                }, {
                    "name": "杭州必胜客计算机",
                    "id": 206066
                }, {
                    "name": "东莞特斯拉养殖",
                    "id": 206067
                }, {
                    "name": "上海亚马逊石油",
                    "id": 206068,
                    "children": [{
                        "name": "南京欧珀医院控股集团",
                        "id": 206069
                    }, {
                        "name": "杭州字节航空",
                        "id": 206070
                    }, {
                        "name": "广州字节互金",
                        "id": 206071
                    }, {
                        "name": "杭州美团旅游",
                        "id": 206072
                    }, {
                        "name": "杭州字节诊所",
                        "id": 206073
                    }, {
                        "name": "厦门华为",
                        "id": 206074
                    }, {
                        "name": "杭州华为",
                        "id": 206075
                    }]
                }, {
                    "name": "纽约小米医院控股集团",
                    "id": 206076,
                    "children": [{
                        "name": "杭州滴滴互金",
                        "id": 206077
                    }, {
                        "name": "南京美团证券",
                        "id": 206078
                    }, {
                        "name": "天津苹果诊所有限公司",
                        "id": 206079
                    }, {
                        "name": "天津阿里基金",
                        "id": 206080
                    }, {
                        "name": "北京肯德基互金控股集团",
                        "id": 206081
                    }]
                }, {
                    "name": "广州肯德基芯片",
                    "id": 206082
                }, {
                    "name": "东莞瑞幸电商",
                    "id": 206083
                }, {
                    "name": "上海必胜客科技",
                    "id": 206084
                }, {
                    "name": "深圳平安渔业",
                    "id": 206085,
                    "children": [{
                        "name": "首尔字节牧业",
                        "id": 206086
                    }, {
                        "name": "北京微软地摊",
                        "id": 206087
                    }, {
                        "name": "香港必胜客智能",
                        "id": 206088
                    }, {
                        "name": "南京谷歌证券有限公司",
                        "id": 206089
                    }, {
                        "name": "纽约美团地产",
                        "id": 206090
                    }, {
                        "name": "东京特斯拉石油",
                        "id": 206091
                    }, {
                        "name": "厦门特斯拉地摊",
                        "id": 206092
                    }, {
                        "name": "杭州平安农业",
                        "id": 206093
                    }, {
                        "name": "香港美团",
                        "id": 206094
                    }, {
                        "name": "北京快手制造",
                        "id": 206095
                    }, {
                        "name": "上海必胜客地摊有限公司",
                        "id": 206096
                    }, {
                        "name": "首尔滴滴芯片",
                        "id": 206097
                    }, {
                        "name": "东京肯德基养殖",
                        "id": 206098
                    }, {
                        "name": "台北阿里银行",
                        "id": 206099
                    }]
                }, {
                    "name": "香港微软计算机",
                    "id": 206100
                }, {
                    "name": "南京百度计算机",
                    "id": 206101
                }, {
                    "name": "东莞欧珀旅游控股集团",
                    "id": 206102,
                    "children": [{
                        "name": "深圳滴滴",
                        "id": 206103
                    }, {
                        "name": "香港阿里银行",
                        "id": 206104
                    }, {
                        "name": "深圳字节科技控股集团",
                        "id": 206105
                    }, {
                        "name": "首尔欧珀控股集团",
                        "id": 206106
                    }, {
                        "name": "深圳谷歌石油",
                        "id": 206107
                    }, {
                        "name": "南京星巴克银行",
                        "id": 206108
                    }, {
                        "name": "北京阿里农业有限公司",
                        "id": 206109
                    }, {
                        "name": "首尔奈雪银行",
                        "id": 206110
                    }, {
                        "name": "南京阿里航空控股集团",
                        "id": 206111
                    }, {
                        "name": "深圳腾讯智能控股集团",
                        "id": 206112
                    }, {
                        "name": "首尔阿里养殖",
                        "id": 206113
                    }, {
                        "name": "杭州奈雪科技有限公司",
                        "id": 206114
                    }, {
                        "name": "广州必胜客制造",
                        "id": 206115
                    }, {
                        "name": "天津华为科技控股集团",
                        "id": 206116
                    }]
                }, {
                    "name": "深圳特斯拉旅游控股集团",
                    "id": 206117
                }, {
                    "name": "首尔必胜客养殖",
                    "id": 206118,
                    "children": [{
                        "name": "北京微软地摊",
                        "id": 206119
                    }, {
                        "name": "天津特斯拉信息服务",
                        "id": 206120
                    }]
                }, {
                    "name": "杭州平安计算机",
                    "id": 206121
                }, {
                    "name": "台北华为地摊有限公司",
                    "id": 206122
                }, {
                    "name": "台北瑞幸通信",
                    "id": 206123
                }, {
                    "name": "天津腾讯",
                    "id": 206124
                }, {
                    "name": "杭州阿里地产有限公司",
                    "id": 206125
                }, {
                    "name": "天津特斯拉软件",
                    "id": 206126
                }, {
                    "name": "香港京东渔业",
                    "id": 206127
                }, {
                    "name": "纽约阿里医院有限公司",
                    "id": 206128
                }]
            }, {
                "name": "首尔快手石油控股集团",
                "id": 206129,
                "children": [{
                    "name": "香港特斯拉新能源控股集团",
                    "id": 206130
                }, {
                    "name": "纽约微软牧业有限公司",
                    "id": 206131
                }, {
                    "name": "东京百度芯片控股集团",
                    "id": 206132
                }, {
                    "name": "首尔谷歌制造控股集团",
                    "id": 206133
                }, {
                    "name": "东莞华为信息服务",
                    "id": 206134,
                    "children": [{
                        "name": "东京欧珀互金",
                        "id": 206135
                    }, {
                        "name": "广州平安计算机有限公司",
                        "id": 206136
                    }, {
                        "name": "广州特斯拉智能",
                        "id": 206137
                    }, {
                        "name": "首尔瑞幸互金控股集团",
                        "id": 206138
                    }, {
                        "name": "广州快手汽车",
                        "id": 206139
                    }, {
                        "name": "东京亚马逊银行",
                        "id": 206140
                    }, {
                        "name": "首尔欧珀",
                        "id": 206141
                    }, {
                        "name": "杭州谷歌牧业",
                        "id": 206142
                    }, {
                        "name": "杭州京东芯片",
                        "id": 206143
                    }, {
                        "name": "上海蚂蚁渔业",
                        "id": 206144
                    }, {
                        "name": "东京华为医院控股集团",
                        "id": 206145
                    }, {
                        "name": "天津华为",
                        "id": 206146
                    }, {
                        "name": "东京字节金融控股集团",
                        "id": 206147
                    }, {
                        "name": "上海平安诊所",
                        "id": 206148
                    }, {
                        "name": "深圳奈雪证券控股集团",
                        "id": 206149
                    }, {
                        "name": "纽约亚马逊",
                        "id": 206150
                    }, {
                        "name": "香港小米地产控股集团",
                        "id": 206151
                    }, {
                        "name": "东莞亚马逊计算机",
                        "id": 206152
                    }, {
                        "name": "厦门字节地摊控股集团",
                        "id": 206153
                    }, {
                        "name": "东莞特斯拉餐饮有限公司",
                        "id": 206154
                    }, {
                        "name": "杭州小米软件",
                        "id": 206155
                    }, {
                        "name": "上海腾讯电商",
                        "id": 206156
                    }, {
                        "name": "北京京东新能源",
                        "id": 206157
                    }, {
                        "name": "香港奈雪航空",
                        "id": 206158
                    }, {
                        "name": "台北肯德基软件控股集团",
                        "id": 206159
                    }, {
                        "name": "广州星巴克",
                        "id": 206160
                    }, {
                        "name": "杭州平安航空控股集团",
                        "id": 206161
                    }, {
                        "name": "天津快手",
                        "id": 206162
                    }, {
                        "name": "纽约平安石油控股集团",
                        "id": 206163
                    }, {
                        "name": "杭州华为农业",
                        "id": 206164
                    }, {
                        "name": "香港亚马逊基金",
                        "id": 206165
                    }]
                }, {
                    "name": "台北瑞幸互金",
                    "id": 206166,
                    "children": [{
                        "name": "首尔阿里通讯",
                        "id": 206167
                    }, {
                        "name": "天津亚马逊证券",
                        "id": 206168
                    }, {
                        "name": "纽约京东制造",
                        "id": 206169
                    }, {
                        "name": "厦门瑞幸电商",
                        "id": 206170
                    }, {
                        "name": "首尔欧珀石油控股集团",
                        "id": 206171
                    }, {
                        "name": "东京亚马逊互金",
                        "id": 206172
                    }, {
                        "name": "广州谷歌渔业",
                        "id": 206173
                    }, {
                        "name": "厦门美团农业",
                        "id": 206174
                    }, {
                        "name": "南京百度电商",
                        "id": 206175
                    }, {
                        "name": "东京蚂蚁科技",
                        "id": 206176
                    }, {
                        "name": "东莞京东医院控股集团",
                        "id": 206177
                    }, {
                        "name": "深圳必胜客制造",
                        "id": 206178
                    }, {
                        "name": "香港小米通信",
                        "id": 206179
                    }, {
                        "name": "杭州特斯拉信息服务",
                        "id": 206180
                    }, {
                        "name": "杭州平安养殖有限公司",
                        "id": 206181
                    }, {
                        "name": "东京肯德基软件",
                        "id": 206182
                    }, {
                        "name": "北京欧珀",
                        "id": 206183
                    }, {
                        "name": "香港平安计算机",
                        "id": 206184
                    }]
                }, {
                    "name": "台北亚马逊通讯",
                    "id": 206185
                }, {
                    "name": "杭州必胜客地摊有限公司",
                    "id": 206186
                }, {
                    "name": "北京平安金融有限公司",
                    "id": 206187,
                    "children": [{
                        "name": "台北必胜客制造控股集团",
                        "id": 206188
                    }, {
                        "name": "东莞必胜客航空",
                        "id": 206189
                    }, {
                        "name": "深圳腾讯石油",
                        "id": 206190
                    }, {
                        "name": "广州必胜客农业",
                        "id": 206191
                    }, {
                        "name": "上海星巴克电商有限公司",
                        "id": 206192
                    }, {
                        "name": "东京快手旅游",
                        "id": 206193
                    }, {
                        "name": "杭州京东旅游",
                        "id": 206194
                    }, {
                        "name": "北京亚马逊医药",
                        "id": 206195
                    }, {
                        "name": "天津快手医院",
                        "id": 206196
                    }, {
                        "name": "东京腾讯医药",
                        "id": 206197
                    }, {
                        "name": "杭州谷歌",
                        "id": 206198
                    }, {
                        "name": "台北欧珀地产",
                        "id": 206199
                    }, {
                        "name": "东莞华为新能源",
                        "id": 206200
                    }, {
                        "name": "北京小米信息服务控股集团",
                        "id": 206201
                    }]
                }, {
                    "name": "上海小米控股集团",
                    "id": 206202
                }, {
                    "name": "杭州平安旅游有限公司",
                    "id": 206203,
                    "children": [{
                        "name": "纽约谷歌牧业",
                        "id": 206204
                    }, {
                        "name": "厦门百度银行有限公司",
                        "id": 206205
                    }, {
                        "name": "东京华为医院",
                        "id": 206206
                    }, {
                        "name": "南京必胜客电商",
                        "id": 206207
                    }, {
                        "name": "广州阿里餐饮",
                        "id": 206208
                    }, {
                        "name": "上海美团证券有限公司",
                        "id": 206209
                    }, {
                        "name": "南京肯德基旅游有限公司",
                        "id": 206210
                    }, {
                        "name": "东京瑞幸旅游",
                        "id": 206211
                    }, {
                        "name": "杭州瑞幸",
                        "id": 206212
                    }, {
                        "name": "杭州奈雪渔业",
                        "id": 206213
                    }, {
                        "name": "台北百度互金",
                        "id": 206214
                    }, {
                        "name": "天津亚马逊互金",
                        "id": 206215
                    }, {
                        "name": "北京滴滴银行",
                        "id": 206216
                    }, {
                        "name": "广州阿里新能源",
                        "id": 206217
                    }, {
                        "name": "南京平安汽车",
                        "id": 206218
                    }, {
                        "name": "深圳谷歌新能源",
                        "id": 206219
                    }, {
                        "name": "杭州华为通信有限公司",
                        "id": 206220
                    }, {
                        "name": "东京字节智能",
                        "id": 206221
                    }, {
                        "name": "北京奈雪餐饮",
                        "id": 206222
                    }, {
                        "name": "上海美团医院有限公司",
                        "id": 206223
                    }, {
                        "name": "北京欧珀餐饮",
                        "id": 206224
                    }]
                }, {
                    "name": "厦门奈雪农业控股集团",
                    "id": 206225
                }, {
                    "name": "首尔苹果计算机有限公司",
                    "id": 206226
                }, {
                    "name": "深圳华为通讯有限公司",
                    "id": 206227
                }, {
                    "name": "天津平安软件",
                    "id": 206228
                }, {
                    "name": "北京阿里农业有限公司",
                    "id": 206229,
                    "children": [{
                        "name": "深圳星巴克电商",
                        "id": 206230
                    }, {
                        "name": "广州微软汽车",
                        "id": 206231
                    }, {
                        "name": "纽约特斯拉",
                        "id": 206232
                    }, {
                        "name": "首尔喜茶养殖有限公司",
                        "id": 206233
                    }, {
                        "name": "深圳蚂蚁渔业",
                        "id": 206234
                    }, {
                        "name": "首尔瑞幸养殖",
                        "id": 206235
                    }, {
                        "name": "深圳京东汽车控股集团",
                        "id": 206236
                    }, {
                        "name": "台北亚马逊金融",
                        "id": 206237
                    }, {
                        "name": "首尔欧珀芯片",
                        "id": 206238
                    }, {
                        "name": "纽约欧珀通讯",
                        "id": 206239
                    }, {
                        "name": "东莞滴滴电商",
                        "id": 206240
                    }, {
                        "name": "上海亚马逊软件有限公司",
                        "id": 206241
                    }, {
                        "name": "杭州必胜客医药",
                        "id": 206242
                    }, {
                        "name": "天津美团地产控股集团",
                        "id": 206243
                    }, {
                        "name": "杭州小米计算机",
                        "id": 206244
                    }, {
                        "name": "纽约瑞幸通讯",
                        "id": 206245
                    }, {
                        "name": "深圳苹果石油",
                        "id": 206246
                    }, {
                        "name": "南京小米养殖",
                        "id": 206247
                    }, {
                        "name": "纽约星巴克科技有限公司",
                        "id": 206248
                    }, {
                        "name": "东莞百度养殖控股集团",
                        "id": 206249
                    }, {
                        "name": "杭州瑞幸通讯",
                        "id": 206250
                    }, {
                        "name": "南京星巴克制造",
                        "id": 206251
                    }, {
                        "name": "香港字节航空",
                        "id": 206252
                    }, {
                        "name": "厦门美团证券",
                        "id": 206253
                    }, {
                        "name": "北京奈雪地产",
                        "id": 206254
                    }, {
                        "name": "首尔微软互金",
                        "id": 206255
                    }, {
                        "name": "上海京东地摊",
                        "id": 206256
                    }, {
                        "name": "深圳欧珀地摊",
                        "id": 206257
                    }, {
                        "name": "杭州欧珀旅游有限公司",
                        "id": 206258
                    }, {
                        "name": "杭州小米计算机",
                        "id": 206259
                    }, {
                        "name": "厦门小米控股集团",
                        "id": 206260
                    }, {
                        "name": "南京阿里养殖控股集团",
                        "id": 206261
                    }, {
                        "name": "台北瑞幸新能源有限公司",
                        "id": 206262
                    }, {
                        "name": "香港亚马逊旅游",
                        "id": 206263
                    }, {
                        "name": "香港特斯拉计算机有限公司",
                        "id": 206264
                    }]
                }, {
                    "name": "南京必胜客航空有限公司",
                    "id": 206265
                }, {
                    "name": "杭州欧珀餐饮",
                    "id": 206266
                }, {
                    "name": "北京滴滴金融",
                    "id": 206267
                }, {
                    "name": "杭州特斯拉旅游控股集团",
                    "id": 206268
                }]
            }, {
                "name": "台北京东智能",
                "id": 206269
            }, {
                "name": "台北瑞幸银行",
                "id": 206270,
                "children": [{
                    "name": "首尔亚马逊金融",
                    "id": 206271,
                    "children": [{
                        "name": "香港必胜客地产",
                        "id": 206272
                    }, {
                        "name": "东京华为智能有限公司",
                        "id": 206273
                    }, {
                        "name": "纽约苹果控股集团",
                        "id": 206274
                    }, {
                        "name": "纽约微软金融",
                        "id": 206275
                    }, {
                        "name": "台北特斯拉医药",
                        "id": 206276
                    }, {
                        "name": "纽约亚马逊银行",
                        "id": 206277
                    }, {
                        "name": "东京蚂蚁农业",
                        "id": 206278
                    }, {
                        "name": "台北京东互金",
                        "id": 206279
                    }, {
                        "name": "东莞奈雪诊所",
                        "id": 206280
                    }, {
                        "name": "东京特斯拉智能",
                        "id": 206281
                    }, {
                        "name": "纽约平安智能",
                        "id": 206282
                    }, {
                        "name": "首尔欧珀通信控股集团",
                        "id": 206283
                    }, {
                        "name": "杭州百度互金",
                        "id": 206284
                    }, {
                        "name": "台北平安科技",
                        "id": 206285
                    }, {
                        "name": "杭州谷歌诊所控股集团",
                        "id": 206286
                    }, {
                        "name": "广州苹果医药",
                        "id": 206287
                    }, {
                        "name": "天津滴滴农业控股集团",
                        "id": 206288
                    }, {
                        "name": "杭州蚂蚁",
                        "id": 206289
                    }]
                }, {
                    "name": "杭州快手",
                    "id": 206290
                }, {
                    "name": "首尔星巴克电商",
                    "id": 206291
                }, {
                    "name": "南京谷歌证券",
                    "id": 206292,
                    "children": [{
                        "name": "南京微软",
                        "id": 206293
                    }, {
                        "name": "厦门腾讯芯片",
                        "id": 206294
                    }, {
                        "name": "天津特斯拉金融",
                        "id": 206295
                    }, {
                        "name": "杭州华为石油",
                        "id": 206296
                    }, {
                        "name": "首尔肯德基养殖",
                        "id": 206297
                    }, {
                        "name": "台北字节金融",
                        "id": 206298
                    }, {
                        "name": "杭州星巴克有限公司",
                        "id": 206299
                    }, {
                        "name": "上海百度金融",
                        "id": 206300
                    }, {
                        "name": "东京欧珀信息服务",
                        "id": 206301
                    }, {
                        "name": "南京谷歌计算机",
                        "id": 206302
                    }, {
                        "name": "广州谷歌互金",
                        "id": 206303
                    }, {
                        "name": "香港亚马逊计算机",
                        "id": 206304
                    }, {
                        "name": "台北阿里科技控股集团",
                        "id": 206305
                    }, {
                        "name": "上海腾讯牧业",
                        "id": 206306
                    }, {
                        "name": "厦门谷歌地摊有限公司",
                        "id": 206307
                    }, {
                        "name": "深圳肯德基计算机",
                        "id": 206308
                    }, {
                        "name": "东莞阿里芯片",
                        "id": 206309
                    }, {
                        "name": "首尔喜茶科技",
                        "id": 206310
                    }, {
                        "name": "北京瑞幸医院控股集团",
                        "id": 206311
                    }, {
                        "name": "天津腾讯控股集团",
                        "id": 206312
                    }, {
                        "name": "香港滴滴银行",
                        "id": 206313
                    }, {
                        "name": "东莞喜茶计算机",
                        "id": 206314
                    }, {
                        "name": "杭州欧珀石油",
                        "id": 206315
                    }, {
                        "name": "广州腾讯软件控股集团",
                        "id": 206316
                    }, {
                        "name": "杭州亚马逊计算机",
                        "id": 206317
                    }, {
                        "name": "杭州喜茶地产",
                        "id": 206318
                    }, {
                        "name": "厦门快手计算机",
                        "id": 206319
                    }, {
                        "name": "杭州欧珀证券",
                        "id": 206320
                    }, {
                        "name": "东京亚马逊旅游有限公司",
                        "id": 206321
                    }]
                }, {
                    "name": "广州喜茶汽车控股集团",
                    "id": 206322
                }, {
                    "name": "东莞喜茶芯片",
                    "id": 206323
                }, {
                    "name": "台北蚂蚁互金",
                    "id": 206324
                }, {
                    "name": "东莞瑞幸医院有限公司",
                    "id": 206325
                }, {
                    "name": "天津腾讯汽车",
                    "id": 206326
                }, {
                    "name": "上海特斯拉",
                    "id": 206327
                }, {
                    "name": "天津美团养殖",
                    "id": 206328
                }, {
                    "name": "广州小米渔业控股集团",
                    "id": 206329,
                    "children": [{
                        "name": "杭州必胜客医院控股集团",
                        "id": 206330
                    }, {
                        "name": "广州必胜客有限公司",
                        "id": 206331
                    }, {
                        "name": "台北字节基金",
                        "id": 206332
                    }, {
                        "name": "纽约腾讯科技",
                        "id": 206333
                    }, {
                        "name": "杭州喜茶旅游有限公司",
                        "id": 206334
                    }, {
                        "name": "上海特斯拉渔业",
                        "id": 206335
                    }, {
                        "name": "南京小米信息服务控股集团",
                        "id": 206336
                    }, {
                        "name": "台北字节科技",
                        "id": 206337
                    }, {
                        "name": "上海蚂蚁信息服务",
                        "id": 206338
                    }, {
                        "name": "杭州京东石油",
                        "id": 206339
                    }, {
                        "name": "杭州瑞幸",
                        "id": 206340
                    }, {
                        "name": "上海欧珀养殖控股集团",
                        "id": 206341
                    }, {
                        "name": "香港腾讯",
                        "id": 206342
                    }, {
                        "name": "北京华为养殖控股集团",
                        "id": 206343
                    }, {
                        "name": "天津美团银行",
                        "id": 206344
                    }, {
                        "name": "天津奈雪旅游",
                        "id": 206345
                    }, {
                        "name": "广州华为基金控股集团",
                        "id": 206346
                    }, {
                        "name": "杭州腾讯计算机",
                        "id": 206347
                    }, {
                        "name": "广州腾讯",
                        "id": 206348
                    }, {
                        "name": "厦门平安通信",
                        "id": 206349
                    }, {
                        "name": "北京特斯拉控股集团",
                        "id": 206350
                    }, {
                        "name": "广州阿里信息服务有限公司",
                        "id": 206351
                    }, {
                        "name": "深圳华为计算机",
                        "id": 206352
                    }, {
                        "name": "天津快手芯片",
                        "id": 206353
                    }, {
                        "name": "杭州星巴克互金有限公司",
                        "id": 206354
                    }, {
                        "name": "香港美团石油控股集团",
                        "id": 206355
                    }, {
                        "name": "天津滴滴软件有限公司",
                        "id": 206356
                    }, {
                        "name": "天津小米金融有限公司",
                        "id": 206357
                    }, {
                        "name": "广州蚂蚁地产控股集团",
                        "id": 206358
                    }, {
                        "name": "厦门美团互金",
                        "id": 206359
                    }, {
                        "name": "香港华为石油",
                        "id": 206360
                    }, {
                        "name": "厦门阿里渔业控股集团",
                        "id": 206361
                    }, {
                        "name": "杭州平安新能源",
                        "id": 206362
                    }]
                }, {
                    "name": "深圳谷歌证券",
                    "id": 206363
                }, {
                    "name": "杭州必胜客地摊",
                    "id": 206364
                }, {
                    "name": "北京字节养殖有限公司",
                    "id": 206365
                }, {
                    "name": "天津腾讯石油",
                    "id": 206366
                }, {
                    "name": "北京美团地产控股集团",
                    "id": 206367
                }, {
                    "name": "上海腾讯石油",
                    "id": 206368
                }, {
                    "name": "纽约小米旅游",
                    "id": 206369
                }, {
                    "name": "北京微软渔业有限公司",
                    "id": 206370
                }, {
                    "name": "天津字节农业",
                    "id": 206371,
                    "children": [{
                        "name": "杭州阿里通信控股集团",
                        "id": 206372
                    }, {
                        "name": "南京必胜客旅游有限公司",
                        "id": 206373
                    }, {
                        "name": "香港平安计算机",
                        "id": 206374
                    }, {
                        "name": "东莞微软软件",
                        "id": 206375
                    }, {
                        "name": "首尔百度渔业",
                        "id": 206376
                    }, {
                        "name": "南京微软金融有限公司",
                        "id": 206377
                    }, {
                        "name": "首尔微软芯片有限公司",
                        "id": 206378
                    }, {
                        "name": "杭州字节基金有限公司",
                        "id": 206379
                    }, {
                        "name": "深圳谷歌航空有限公司",
                        "id": 206380
                    }, {
                        "name": "深圳星巴克农业",
                        "id": 206381
                    }, {
                        "name": "南京微软餐饮",
                        "id": 206382
                    }, {
                        "name": "深圳特斯拉基金",
                        "id": 206383
                    }, {
                        "name": "杭州奈雪地产",
                        "id": 206384
                    }, {
                        "name": "厦门百度农业控股集团",
                        "id": 206385
                    }, {
                        "name": "纽约星巴克制造",
                        "id": 206386
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 206387
                    }, {
                        "name": "香港蚂蚁诊所",
                        "id": 206388
                    }, {
                        "name": "上海平安",
                        "id": 206389
                    }, {
                        "name": "香港微软新能源",
                        "id": 206390
                    }, {
                        "name": "杭州快手通讯有限公司",
                        "id": 206391
                    }, {
                        "name": "广州华为养殖控股集团",
                        "id": 206392
                    }, {
                        "name": "广州星巴克计算机",
                        "id": 206393
                    }, {
                        "name": "北京奈雪餐饮有限公司",
                        "id": 206394
                    }, {
                        "name": "东莞苹果地产",
                        "id": 206395
                    }, {
                        "name": "东京亚马逊养殖有限公司",
                        "id": 206396
                    }, {
                        "name": "东莞华为农业",
                        "id": 206397
                    }, {
                        "name": "深圳平安金融",
                        "id": 206398
                    }, {
                        "name": "厦门瑞幸",
                        "id": 206399
                    }, {
                        "name": "首尔平安互金",
                        "id": 206400
                    }, {
                        "name": "广州苹果地产控股集团",
                        "id": 206401
                    }, {
                        "name": "厦门字节诊所控股集团",
                        "id": 206402
                    }, {
                        "name": "杭州苹果通讯",
                        "id": 206403
                    }, {
                        "name": "广州快手餐饮有限公司",
                        "id": 206404
                    }, {
                        "name": "纽约欧珀芯片控股集团",
                        "id": 206405
                    }, {
                        "name": "杭州京东航空控股集团",
                        "id": 206406
                    }, {
                        "name": "上海喜茶银行有限公司",
                        "id": 206407
                    }]
                }, {
                    "name": "东京特斯拉智能",
                    "id": 206408
                }, {
                    "name": "广州字节汽车",
                    "id": 206409
                }, {
                    "name": "台北小米餐饮",
                    "id": 206410
                }, {
                    "name": "杭州华为养殖",
                    "id": 206411
                }, {
                    "name": "厦门平安牧业",
                    "id": 206412
                }]
            }, {
                "name": "东京亚马逊牧业控股集团",
                "id": 206413
            }, {
                "name": "北京美团",
                "id": 206414
            }, {
                "name": "深圳百度",
                "id": 206415,
                "children": [{
                    "name": "台北瑞幸养殖有限公司",
                    "id": 206416,
                    "children": [{
                        "name": "南京喜茶通讯",
                        "id": 206417
                    }, {
                        "name": "广州欧珀制造",
                        "id": 206418
                    }, {
                        "name": "首尔京东石油",
                        "id": 206419
                    }, {
                        "name": "杭州阿里诊所有限公司",
                        "id": 206420
                    }, {
                        "name": "北京腾讯汽车",
                        "id": 206421
                    }, {
                        "name": "台北滴滴医院",
                        "id": 206422
                    }, {
                        "name": "南京特斯拉牧业",
                        "id": 206423
                    }, {
                        "name": "台北喜茶农业控股集团",
                        "id": 206424
                    }, {
                        "name": "香港谷歌信息服务控股集团",
                        "id": 206425
                    }, {
                        "name": "杭州美团通讯控股集团",
                        "id": 206426
                    }, {
                        "name": "台北星巴克电商",
                        "id": 206427
                    }, {
                        "name": "深圳美团信息服务控股集团",
                        "id": 206428
                    }, {
                        "name": "深圳特斯拉牧业",
                        "id": 206429
                    }, {
                        "name": "杭州必胜客石油",
                        "id": 206430
                    }, {
                        "name": "首尔喜茶养殖",
                        "id": 206431
                    }, {
                        "name": "南京阿里渔业有限公司",
                        "id": 206432
                    }]
                }, {
                    "name": "东莞快手地产",
                    "id": 206433
                }, {
                    "name": "北京星巴克基金",
                    "id": 206434
                }, {
                    "name": "天津滴滴信息服务有限公司",
                    "id": 206435
                }, {
                    "name": "杭州亚马逊农业",
                    "id": 206436
                }, {
                    "name": "上海星巴克基金",
                    "id": 206437
                }, {
                    "name": "深圳微软电商",
                    "id": 206438
                }, {
                    "name": "杭州快手航空有限公司",
                    "id": 206439,
                    "children": [{
                        "name": "深圳京东",
                        "id": 206440
                    }, {
                        "name": "东莞腾讯控股集团",
                        "id": 206441
                    }, {
                        "name": "北京美团航空有限公司",
                        "id": 206442
                    }, {
                        "name": "台北滴滴农业有限公司",
                        "id": 206443
                    }, {
                        "name": "广州星巴克地摊控股集团",
                        "id": 206444
                    }, {
                        "name": "首尔亚马逊基金",
                        "id": 206445
                    }, {
                        "name": "香港华为餐饮",
                        "id": 206446
                    }, {
                        "name": "东京百度软件控股集团",
                        "id": 206447
                    }, {
                        "name": "纽约百度信息服务有限公司",
                        "id": 206448
                    }, {
                        "name": "杭州必胜客航空",
                        "id": 206449
                    }, {
                        "name": "厦门微软电商",
                        "id": 206450
                    }, {
                        "name": "北京滴滴控股集团",
                        "id": 206451
                    }, {
                        "name": "东莞腾讯餐饮控股集团",
                        "id": 206452
                    }, {
                        "name": "杭州蚂蚁医院",
                        "id": 206453
                    }, {
                        "name": "厦门苹果养殖有限公司",
                        "id": 206454
                    }, {
                        "name": "首尔欧珀医院",
                        "id": 206455
                    }, {
                        "name": "南京肯德基通讯",
                        "id": 206456
                    }, {
                        "name": "纽约微软航空有限公司",
                        "id": 206457
                    }, {
                        "name": "天津特斯拉科技",
                        "id": 206458
                    }, {
                        "name": "深圳亚马逊科技",
                        "id": 206459
                    }, {
                        "name": "上海滴滴医院",
                        "id": 206460
                    }, {
                        "name": "深圳亚马逊医院",
                        "id": 206461
                    }, {
                        "name": "南京瑞幸计算机",
                        "id": 206462
                    }]
                }, {
                    "name": "首尔美团通信有限公司",
                    "id": 206463
                }, {
                    "name": "南京字节渔业",
                    "id": 206464,
                    "children": [{
                        "name": "深圳微软银行有限公司",
                        "id": 206465
                    }, {
                        "name": "广州腾讯汽车控股集团",
                        "id": 206466
                    }, {
                        "name": "首尔百度航空有限公司",
                        "id": 206467
                    }, {
                        "name": "东京瑞幸地产有限公司",
                        "id": 206468
                    }, {
                        "name": "上海滴滴旅游",
                        "id": 206469
                    }, {
                        "name": "东京必胜客新能源控股集团",
                        "id": 206470
                    }, {
                        "name": "杭州奈雪地产",
                        "id": 206471
                    }, {
                        "name": "台北腾讯牧业有限公司",
                        "id": 206472
                    }, {
                        "name": "厦门平安通信",
                        "id": 206473
                    }, {
                        "name": "上海字节通信",
                        "id": 206474
                    }]
                }, {
                    "name": "首尔美团地产有限公司",
                    "id": 206475,
                    "children": [{
                        "name": "上海滴滴牧业",
                        "id": 206476
                    }, {
                        "name": "北京特斯拉航空",
                        "id": 206477
                    }, {
                        "name": "香港阿里地摊控股集团",
                        "id": 206478
                    }, {
                        "name": "杭州京东基金",
                        "id": 206479
                    }, {
                        "name": "厦门滴滴科技",
                        "id": 206480
                    }, {
                        "name": "南京阿里控股集团",
                        "id": 206481
                    }]
                }, {
                    "name": "杭州蚂蚁",
                    "id": 206482
                }, {
                    "name": "纽约瑞幸电商",
                    "id": 206483
                }, {
                    "name": "北京喜茶通信",
                    "id": 206484
                }, {
                    "name": "香港京东石油控股集团",
                    "id": 206485,
                    "children": [{
                        "name": "台北百度有限公司",
                        "id": 206486
                    }, {
                        "name": "厦门华为石油控股集团",
                        "id": 206487
                    }, {
                        "name": "天津星巴克有限公司",
                        "id": 206488
                    }, {
                        "name": "东京京东航空",
                        "id": 206489
                    }, {
                        "name": "香港腾讯石油",
                        "id": 206490
                    }, {
                        "name": "上海亚马逊计算机控股集团",
                        "id": 206491
                    }, {
                        "name": "杭州奈雪软件控股集团",
                        "id": 206492
                    }, {
                        "name": "杭州喜茶控股集团",
                        "id": 206493
                    }, {
                        "name": "香港喜茶航空",
                        "id": 206494
                    }, {
                        "name": "香港特斯拉",
                        "id": 206495
                    }, {
                        "name": "厦门欧珀医药控股集团",
                        "id": 206496
                    }, {
                        "name": "东京微软地产",
                        "id": 206497
                    }, {
                        "name": "香港微软地产有限公司",
                        "id": 206498
                    }, {
                        "name": "台北谷歌制造",
                        "id": 206499
                    }, {
                        "name": "杭州蚂蚁医院有限公司",
                        "id": 206500
                    }, {
                        "name": "纽约欧珀养殖有限公司",
                        "id": 206501
                    }, {
                        "name": "香港瑞幸互金",
                        "id": 206502
                    }, {
                        "name": "纽约蚂蚁牧业",
                        "id": 206503
                    }, {
                        "name": "深圳腾讯诊所",
                        "id": 206504
                    }]
                }]
            }]
        }, {
            "name": "深圳腾讯互金",
            "id": 206505
        }, {
            "name": "台北蚂蚁地摊",
            "id": 206506
        }, {
            "name": "纽约星巴克智能控股集团",
            "id": 206507
        }, {
            "name": "厦门小米电商",
            "id": 206508
        }, {
            "name": "南京特斯拉控股集团",
            "id": 206509,
            "children": [{
                "name": "香港谷歌汽车控股集团",
                "id": 206510
            }, {
                "name": "香港字节电商",
                "id": 206511,
                "children": [{
                    "name": "南京字节证券控股集团",
                    "id": 206512
                }, {
                    "name": "杭州肯德基地摊",
                    "id": 206513
                }, {
                    "name": "香港欧珀医药",
                    "id": 206514
                }, {
                    "name": "台北京东农业控股集团",
                    "id": 206515
                }, {
                    "name": "广州欧珀证券",
                    "id": 206516,
                    "children": [{
                        "name": "南京亚马逊航空有限公司",
                        "id": 206517
                    }, {
                        "name": "南京星巴克通讯",
                        "id": 206518
                    }, {
                        "name": "厦门滴滴新能源",
                        "id": 206519
                    }, {
                        "name": "天津瑞幸新能源",
                        "id": 206520
                    }, {
                        "name": "北京蚂蚁智能有限公司",
                        "id": 206521
                    }, {
                        "name": "天津滴滴电商",
                        "id": 206522
                    }, {
                        "name": "台北滴滴诊所",
                        "id": 206523
                    }, {
                        "name": "杭州微软互金",
                        "id": 206524
                    }, {
                        "name": "广州特斯拉信息服务有限公司",
                        "id": 206525
                    }, {
                        "name": "东莞喜茶医院",
                        "id": 206526
                    }, {
                        "name": "杭州肯德基医院有限公司",
                        "id": 206527
                    }, {
                        "name": "北京喜茶医院",
                        "id": 206528
                    }, {
                        "name": "东莞蚂蚁通讯",
                        "id": 206529
                    }, {
                        "name": "天津平安通讯",
                        "id": 206530
                    }, {
                        "name": "南京腾讯新能源有限公司",
                        "id": 206531
                    }, {
                        "name": "上海欧珀",
                        "id": 206532
                    }, {
                        "name": "香港字节",
                        "id": 206533
                    }, {
                        "name": "香港微软通讯",
                        "id": 206534
                    }, {
                        "name": "台北蚂蚁有限公司",
                        "id": 206535
                    }, {
                        "name": "厦门快手通信",
                        "id": 206536
                    }, {
                        "name": "杭州星巴克诊所",
                        "id": 206537
                    }, {
                        "name": "纽约必胜客",
                        "id": 206538
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 206539
                    }, {
                        "name": "杭州字节基金",
                        "id": 206540
                    }, {
                        "name": "杭州微软有限公司",
                        "id": 206541
                    }, {
                        "name": "首尔京东智能",
                        "id": 206542
                    }, {
                        "name": "杭州字节通讯",
                        "id": 206543
                    }, {
                        "name": "香港阿里",
                        "id": 206544
                    }, {
                        "name": "台北亚马逊石油有限公司",
                        "id": 206545
                    }, {
                        "name": "南京星巴克信息服务",
                        "id": 206546
                    }]
                }, {
                    "name": "天津必胜客制造",
                    "id": 206547
                }, {
                    "name": "首尔欧珀科技",
                    "id": 206548
                }, {
                    "name": "纽约平安旅游控股集团",
                    "id": 206549
                }, {
                    "name": "天津肯德基",
                    "id": 206550,
                    "children": [{
                        "name": "上海快手通讯控股集团",
                        "id": 206551
                    }, {
                        "name": "南京瑞幸制造",
                        "id": 206552
                    }, {
                        "name": "东莞快手诊所控股集团",
                        "id": 206553
                    }, {
                        "name": "香港苹果航空",
                        "id": 206554
                    }, {
                        "name": "纽约喜茶银行",
                        "id": 206555
                    }, {
                        "name": "杭州滴滴医院有限公司",
                        "id": 206556
                    }, {
                        "name": "南京字节通信",
                        "id": 206557
                    }, {
                        "name": "深圳腾讯养殖",
                        "id": 206558
                    }, {
                        "name": "东京华为通讯控股集团",
                        "id": 206559
                    }, {
                        "name": "南京苹果地摊",
                        "id": 206560
                    }, {
                        "name": "天津快手银行",
                        "id": 206561
                    }, {
                        "name": "上海快手制造",
                        "id": 206562
                    }, {
                        "name": "北京平安控股集团",
                        "id": 206563
                    }, {
                        "name": "天津星巴克芯片",
                        "id": 206564
                    }]
                }, {
                    "name": "杭州亚马逊农业",
                    "id": 206565
                }, {
                    "name": "香港华为餐饮",
                    "id": 206566
                }, {
                    "name": "东莞快手通讯",
                    "id": 206567
                }, {
                    "name": "天津平安",
                    "id": 206568,
                    "children": [{
                        "name": "纽约字节智能有限公司",
                        "id": 206569
                    }, {
                        "name": "东京必胜客科技",
                        "id": 206570
                    }, {
                        "name": "香港百度证券",
                        "id": 206571
                    }]
                }, {
                    "name": "北京谷歌诊所",
                    "id": 206572
                }, {
                    "name": "纽约微软石油",
                    "id": 206573
                }, {
                    "name": "深圳谷歌芯片",
                    "id": 206574
                }, {
                    "name": "东京美团牧业",
                    "id": 206575
                }, {
                    "name": "南京平安旅游",
                    "id": 206576,
                    "children": [{
                        "name": "香港快手诊所",
                        "id": 206577
                    }, {
                        "name": "台北京东农业控股集团",
                        "id": 206578
                    }, {
                        "name": "北京谷歌互金",
                        "id": 206579
                    }, {
                        "name": "杭州美团信息服务",
                        "id": 206580
                    }, {
                        "name": "广州特斯拉养殖",
                        "id": 206581
                    }, {
                        "name": "杭州京东科技",
                        "id": 206582
                    }, {
                        "name": "厦门字节",
                        "id": 206583
                    }, {
                        "name": "深圳快手银行有限公司",
                        "id": 206584
                    }, {
                        "name": "天津美团地摊有限公司",
                        "id": 206585
                    }, {
                        "name": "广州百度银行",
                        "id": 206586
                    }, {
                        "name": "台北快手养殖",
                        "id": 206587
                    }, {
                        "name": "南京字节计算机",
                        "id": 206588
                    }, {
                        "name": "北京特斯拉金融有限公司",
                        "id": 206589
                    }, {
                        "name": "东莞苹果互金",
                        "id": 206590
                    }, {
                        "name": "南京星巴克石油",
                        "id": 206591
                    }, {
                        "name": "天津平安基金",
                        "id": 206592
                    }, {
                        "name": "杭州滴滴旅游",
                        "id": 206593
                    }, {
                        "name": "台北百度餐饮",
                        "id": 206594
                    }, {
                        "name": "厦门喜茶",
                        "id": 206595
                    }, {
                        "name": "北京奈雪有限公司",
                        "id": 206596
                    }, {
                        "name": "天津阿里养殖",
                        "id": 206597
                    }, {
                        "name": "深圳欧珀农业",
                        "id": 206598
                    }, {
                        "name": "南京星巴克医药有限公司",
                        "id": 206599
                    }, {
                        "name": "厦门平安航空",
                        "id": 206600
                    }, {
                        "name": "香港蚂蚁基金",
                        "id": 206601
                    }, {
                        "name": "首尔奈雪有限公司",
                        "id": 206602
                    }, {
                        "name": "厦门平安金融有限公司",
                        "id": 206603
                    }, {
                        "name": "东京特斯拉金融有限公司",
                        "id": 206604
                    }, {
                        "name": "北京阿里旅游",
                        "id": 206605
                    }, {
                        "name": "深圳字节芯片有限公司",
                        "id": 206606
                    }, {
                        "name": "南京奈雪汽车有限公司",
                        "id": 206607
                    }, {
                        "name": "深圳滴滴有限公司",
                        "id": 206608
                    }]
                }, {
                    "name": "东京快手金融有限公司",
                    "id": 206609
                }, {
                    "name": "厦门腾讯互金有限公司",
                    "id": 206610
                }, {
                    "name": "首尔苹果牧业",
                    "id": 206611,
                    "children": [{
                        "name": "东京快手基金",
                        "id": 206612
                    }, {
                        "name": "首尔谷歌养殖",
                        "id": 206613
                    }, {
                        "name": "南京瑞幸汽车",
                        "id": 206614
                    }, {
                        "name": "广州京东",
                        "id": 206615
                    }, {
                        "name": "首尔蚂蚁芯片",
                        "id": 206616
                    }, {
                        "name": "东莞喜茶医药",
                        "id": 206617
                    }, {
                        "name": "香港滴滴旅游",
                        "id": 206618
                    }, {
                        "name": "首尔平安航空",
                        "id": 206619
                    }, {
                        "name": "首尔华为地摊",
                        "id": 206620
                    }]
                }]
            }, {
                "name": "厦门亚马逊医药有限公司",
                "id": 206621
            }, {
                "name": "南京亚马逊智能",
                "id": 206622
            }, {
                "name": "东京谷歌科技有限公司",
                "id": 206623
            }, {
                "name": "东莞美团",
                "id": 206624
            }, {
                "name": "台北快手地摊有限公司",
                "id": 206625
            }, {
                "name": "杭州奈雪通讯有限公司",
                "id": 206626
            }, {
                "name": "东莞阿里养殖",
                "id": 206627
            }, {
                "name": "南京百度互金有限公司",
                "id": 206628
            }, {
                "name": "上海滴滴航空",
                "id": 206629
            }, {
                "name": "杭州星巴克医院控股集团",
                "id": 206630
            }, {
                "name": "天津小米医院",
                "id": 206631
            }, {
                "name": "纽约美团制造",
                "id": 206632
            }, {
                "name": "南京星巴克",
                "id": 206633
            }, {
                "name": "南京必胜客地产",
                "id": 206634,
                "children": [{
                    "name": "东莞肯德基控股集团",
                    "id": 206635
                }, {
                    "name": "厦门奈雪制造",
                    "id": 206636
                }, {
                    "name": "天津蚂蚁农业控股集团",
                    "id": 206637,
                    "children": [{
                        "name": "南京必胜客汽车控股集团",
                        "id": 206638
                    }, {
                        "name": "北京平安制造控股集团",
                        "id": 206639
                    }, {
                        "name": "纽约小米通讯",
                        "id": 206640
                    }, {
                        "name": "南京百度地摊",
                        "id": 206641
                    }, {
                        "name": "东莞快手互金",
                        "id": 206642
                    }, {
                        "name": "南京蚂蚁养殖控股集团",
                        "id": 206643
                    }]
                }]
            }, {
                "name": "杭州肯德基石油",
                "id": 206644,
                "children": [{
                    "name": "南京小米互金控股集团",
                    "id": 206645,
                    "children": [{
                        "name": "广州欧珀汽车",
                        "id": 206646
                    }, {
                        "name": "天津星巴克科技控股集团",
                        "id": 206647
                    }, {
                        "name": "东莞苹果信息服务控股集团",
                        "id": 206648
                    }, {
                        "name": "广州必胜客信息服务有限公司",
                        "id": 206649
                    }, {
                        "name": "首尔小米科技",
                        "id": 206650
                    }, {
                        "name": "厦门奈雪基金控股集团",
                        "id": 206651
                    }, {
                        "name": "杭州平安有限公司",
                        "id": 206652
                    }, {
                        "name": "纽约美团航空",
                        "id": 206653
                    }, {
                        "name": "东莞瑞幸农业控股集团",
                        "id": 206654
                    }, {
                        "name": "首尔瑞幸互金控股集团",
                        "id": 206655
                    }, {
                        "name": "上海微软地产",
                        "id": 206656
                    }, {
                        "name": "厦门谷歌牧业控股集团",
                        "id": 206657
                    }, {
                        "name": "南京百度医药",
                        "id": 206658
                    }, {
                        "name": "上海小米科技控股集团",
                        "id": 206659
                    }]
                }, {
                    "name": "上海奈雪有限公司",
                    "id": 206660
                }, {
                    "name": "杭州小米智能",
                    "id": 206661,
                    "children": [{
                        "name": "香港奈雪旅游",
                        "id": 206662
                    }, {
                        "name": "北京美团",
                        "id": 206663
                    }, {
                        "name": "东京微软有限公司",
                        "id": 206664
                    }, {
                        "name": "东莞滴滴汽车",
                        "id": 206665
                    }, {
                        "name": "纽约奈雪汽车有限公司",
                        "id": 206666
                    }, {
                        "name": "北京星巴克",
                        "id": 206667
                    }, {
                        "name": "纽约华为电商",
                        "id": 206668
                    }, {
                        "name": "东莞苹果芯片",
                        "id": 206669
                    }, {
                        "name": "香港蚂蚁医药控股集团",
                        "id": 206670
                    }, {
                        "name": "深圳阿里科技有限公司",
                        "id": 206671
                    }, {
                        "name": "北京苹果牧业控股集团",
                        "id": 206672
                    }, {
                        "name": "杭州华为航空",
                        "id": 206673
                    }, {
                        "name": "天津蚂蚁银行",
                        "id": 206674
                    }, {
                        "name": "深圳苹果养殖有限公司",
                        "id": 206675
                    }, {
                        "name": "香港亚马逊医药控股集团",
                        "id": 206676
                    }, {
                        "name": "东莞京东汽车控股集团",
                        "id": 206677
                    }, {
                        "name": "天津瑞幸计算机控股集团",
                        "id": 206678
                    }, {
                        "name": "南京平安餐饮控股集团",
                        "id": 206679
                    }, {
                        "name": "东京亚马逊计算机",
                        "id": 206680
                    }, {
                        "name": "上海快手科技",
                        "id": 206681
                    }, {
                        "name": "杭州京东制造",
                        "id": 206682
                    }, {
                        "name": "台北欧珀电商",
                        "id": 206683
                    }, {
                        "name": "南京奈雪医药",
                        "id": 206684
                    }]
                }, {
                    "name": "广州京东通信有限公司",
                    "id": 206685
                }]
            }, {
                "name": "上海华为基金",
                "id": 206686
            }, {
                "name": "南京华为诊所",
                "id": 206687,
                "children": [{
                    "name": "香港蚂蚁信息服务有限公司",
                    "id": 206688
                }, {
                    "name": "东莞谷歌石油",
                    "id": 206689
                }, {
                    "name": "香港快手芯片控股集团",
                    "id": 206690,
                    "children": [{
                        "name": "厦门百度互金",
                        "id": 206691
                    }, {
                        "name": "天津小米医院",
                        "id": 206692
                    }, {
                        "name": "南京腾讯汽车",
                        "id": 206693
                    }, {
                        "name": "东莞微软诊所有限公司",
                        "id": 206694
                    }, {
                        "name": "北京奈雪基金",
                        "id": 206695
                    }, {
                        "name": "北京快手银行",
                        "id": 206696
                    }, {
                        "name": "纽约美团基金",
                        "id": 206697
                    }, {
                        "name": "台北快手芯片控股集团",
                        "id": 206698
                    }, {
                        "name": "杭州美团医院",
                        "id": 206699
                    }, {
                        "name": "天津字节诊所",
                        "id": 206700
                    }, {
                        "name": "东京阿里软件控股集团",
                        "id": 206701
                    }, {
                        "name": "杭州星巴克航空",
                        "id": 206702
                    }, {
                        "name": "纽约喜茶农业",
                        "id": 206703
                    }, {
                        "name": "北京蚂蚁石油",
                        "id": 206704
                    }, {
                        "name": "厦门必胜客养殖",
                        "id": 206705
                    }, {
                        "name": "杭州欧珀信息服务",
                        "id": 206706
                    }, {
                        "name": "厦门阿里旅游",
                        "id": 206707
                    }, {
                        "name": "深圳京东地摊",
                        "id": 206708
                    }, {
                        "name": "杭州蚂蚁",
                        "id": 206709
                    }, {
                        "name": "东莞平安制造有限公司",
                        "id": 206710
                    }, {
                        "name": "上海滴滴养殖控股集团",
                        "id": 206711
                    }]
                }, {
                    "name": "杭州亚马逊地摊",
                    "id": 206712,
                    "children": [{
                        "name": "杭州字节智能有限公司",
                        "id": 206713
                    }, {
                        "name": "杭州滴滴新能源有限公司",
                        "id": 206714
                    }, {
                        "name": "北京肯德基计算机有限公司",
                        "id": 206715
                    }, {
                        "name": "厦门瑞幸",
                        "id": 206716
                    }, {
                        "name": "东京百度新能源",
                        "id": 206717
                    }, {
                        "name": "北京字节电商有限公司",
                        "id": 206718
                    }, {
                        "name": "杭州京东地产",
                        "id": 206719
                    }]
                }, {
                    "name": "广州必胜客科技控股集团",
                    "id": 206720
                }, {
                    "name": "东京小米通信",
                    "id": 206721
                }, {
                    "name": "台北阿里地摊",
                    "id": 206722
                }, {
                    "name": "东莞美团通信控股集团",
                    "id": 206723
                }, {
                    "name": "纽约必胜客电商",
                    "id": 206724
                }, {
                    "name": "天津苹果有限公司",
                    "id": 206725
                }, {
                    "name": "东莞欧珀汽车有限公司",
                    "id": 206726
                }, {
                    "name": "东京瑞幸信息服务",
                    "id": 206727
                }, {
                    "name": "东莞苹果金融",
                    "id": 206728
                }, {
                    "name": "杭州喜茶诊所控股集团",
                    "id": 206729,
                    "children": [{
                        "name": "台北华为新能源",
                        "id": 206730
                    }, {
                        "name": "厦门美团农业",
                        "id": 206731
                    }, {
                        "name": "厦门亚马逊互金",
                        "id": 206732
                    }, {
                        "name": "东莞华为",
                        "id": 206733
                    }, {
                        "name": "东京阿里通讯",
                        "id": 206734
                    }, {
                        "name": "天津喜茶智能控股集团",
                        "id": 206735
                    }, {
                        "name": "纽约阿里智能",
                        "id": 206736
                    }, {
                        "name": "上海微软诊所有限公司",
                        "id": 206737
                    }, {
                        "name": "厦门苹果医院控股集团",
                        "id": 206738
                    }, {
                        "name": "首尔京东诊所",
                        "id": 206739
                    }, {
                        "name": "广州字节农业控股集团",
                        "id": 206740
                    }, {
                        "name": "纽约百度汽车",
                        "id": 206741
                    }, {
                        "name": "首尔必胜客智能",
                        "id": 206742
                    }, {
                        "name": "首尔肯德基旅游",
                        "id": 206743
                    }, {
                        "name": "东莞苹果科技有限公司",
                        "id": 206744
                    }, {
                        "name": "首尔瑞幸通讯有限公司",
                        "id": 206745
                    }, {
                        "name": "上海阿里地摊",
                        "id": 206746
                    }, {
                        "name": "杭州小米汽车",
                        "id": 206747
                    }, {
                        "name": "厦门字节渔业",
                        "id": 206748
                    }, {
                        "name": "香港快手基金",
                        "id": 206749
                    }, {
                        "name": "东京肯德基金融",
                        "id": 206750
                    }, {
                        "name": "台北小米新能源控股集团",
                        "id": 206751
                    }, {
                        "name": "上海美团计算机",
                        "id": 206752
                    }, {
                        "name": "香港奈雪金融",
                        "id": 206753
                    }, {
                        "name": "首尔奈雪新能源有限公司",
                        "id": 206754
                    }, {
                        "name": "东京必胜客地摊控股集团",
                        "id": 206755
                    }, {
                        "name": "深圳快手控股集团",
                        "id": 206756
                    }, {
                        "name": "北京阿里通讯有限公司",
                        "id": 206757
                    }, {
                        "name": "东京亚马逊餐饮",
                        "id": 206758
                    }, {
                        "name": "杭州微软旅游",
                        "id": 206759
                    }]
                }, {
                    "name": "台北欧珀芯片控股集团",
                    "id": 206760
                }, {
                    "name": "上海瑞幸新能源有限公司",
                    "id": 206761
                }, {
                    "name": "深圳喜茶",
                    "id": 206762
                }, {
                    "name": "深圳肯德基渔业",
                    "id": 206763,
                    "children": [{
                        "name": "东莞蚂蚁诊所",
                        "id": 206764
                    }, {
                        "name": "东莞必胜客制造有限公司",
                        "id": 206765
                    }, {
                        "name": "上海蚂蚁证券",
                        "id": 206766
                    }, {
                        "name": "纽约阿里新能源有限公司",
                        "id": 206767
                    }, {
                        "name": "东莞苹果通信",
                        "id": 206768
                    }, {
                        "name": "厦门快手制造",
                        "id": 206769
                    }, {
                        "name": "北京星巴克科技",
                        "id": 206770
                    }, {
                        "name": "广州苹果石油",
                        "id": 206771
                    }, {
                        "name": "东莞微软通讯",
                        "id": 206772
                    }, {
                        "name": "香港蚂蚁电商",
                        "id": 206773
                    }, {
                        "name": "杭州小米通信",
                        "id": 206774
                    }, {
                        "name": "杭州谷歌通信",
                        "id": 206775
                    }, {
                        "name": "厦门蚂蚁科技",
                        "id": 206776
                    }, {
                        "name": "香港必胜客金融",
                        "id": 206777
                    }]
                }, {
                    "name": "香港必胜客基金",
                    "id": 206778
                }, {
                    "name": "纽约腾讯",
                    "id": 206779
                }, {
                    "name": "东莞蚂蚁控股集团",
                    "id": 206780,
                    "children": [{
                        "name": "东莞苹果科技",
                        "id": 206781
                    }, {
                        "name": "深圳京东医药控股集团",
                        "id": 206782
                    }, {
                        "name": "北京谷歌地摊控股集团",
                        "id": 206783
                    }, {
                        "name": "广州华为诊所",
                        "id": 206784
                    }, {
                        "name": "东京奈雪医院",
                        "id": 206785
                    }, {
                        "name": "北京蚂蚁旅游控股集团",
                        "id": 206786
                    }, {
                        "name": "杭州华为地摊控股集团",
                        "id": 206787
                    }, {
                        "name": "厦门瑞幸证券控股集团",
                        "id": 206788
                    }, {
                        "name": "厦门特斯拉餐饮",
                        "id": 206789
                    }, {
                        "name": "北京平安计算机",
                        "id": 206790
                    }, {
                        "name": "深圳滴滴地摊",
                        "id": 206791
                    }, {
                        "name": "厦门瑞幸旅游",
                        "id": 206792
                    }, {
                        "name": "杭州奈雪餐饮",
                        "id": 206793
                    }, {
                        "name": "天津瑞幸互金控股集团",
                        "id": 206794
                    }, {
                        "name": "上海字节新能源",
                        "id": 206795
                    }, {
                        "name": "厦门美团医院",
                        "id": 206796
                    }, {
                        "name": "首尔百度汽车",
                        "id": 206797
                    }, {
                        "name": "上海腾讯医药",
                        "id": 206798
                    }, {
                        "name": "厦门苹果石油",
                        "id": 206799
                    }, {
                        "name": "首尔华为",
                        "id": 206800
                    }, {
                        "name": "北京华为芯片",
                        "id": 206801
                    }, {
                        "name": "杭州字节科技",
                        "id": 206802
                    }, {
                        "name": "天津美团软件",
                        "id": 206803
                    }, {
                        "name": "台北华为",
                        "id": 206804
                    }, {
                        "name": "纽约谷歌互金",
                        "id": 206805
                    }, {
                        "name": "杭州微软金融",
                        "id": 206806
                    }, {
                        "name": "纽约快手汽车",
                        "id": 206807
                    }, {
                        "name": "南京华为养殖",
                        "id": 206808
                    }, {
                        "name": "上海快手牧业",
                        "id": 206809
                    }, {
                        "name": "东京苹果信息服务有限公司",
                        "id": 206810
                    }]
                }, {
                    "name": "东莞苹果石油控股集团",
                    "id": 206811,
                    "children": [{
                        "name": "南京苹果",
                        "id": 206812
                    }, {
                        "name": "广州谷歌",
                        "id": 206813
                    }, {
                        "name": "南京喜茶基金有限公司",
                        "id": 206814
                    }, {
                        "name": "南京美团航空控股集团",
                        "id": 206815
                    }, {
                        "name": "纽约特斯拉养殖",
                        "id": 206816
                    }, {
                        "name": "天津小米医院",
                        "id": 206817
                    }, {
                        "name": "南京肯德基航空",
                        "id": 206818
                    }, {
                        "name": "上海腾讯",
                        "id": 206819
                    }, {
                        "name": "上海小米科技",
                        "id": 206820
                    }, {
                        "name": "东京华为证券",
                        "id": 206821
                    }, {
                        "name": "杭州奈雪地摊控股集团",
                        "id": 206822
                    }, {
                        "name": "南京奈雪智能控股集团",
                        "id": 206823
                    }, {
                        "name": "南京京东智能",
                        "id": 206824
                    }]
                }, {
                    "name": "首尔腾讯地产",
                    "id": 206825
                }, {
                    "name": "天津小米证券有限公司",
                    "id": 206826
                }, {
                    "name": "上海奈雪餐饮有限公司",
                    "id": 206827
                }]
            }, {
                "name": "杭州蚂蚁通讯",
                "id": 206828
            }, {
                "name": "香港喜茶农业",
                "id": 206829
            }, {
                "name": "天津百度地摊控股集团",
                "id": 206830
            }, {
                "name": "上海星巴克控股集团",
                "id": 206831
            }, {
                "name": "香港腾讯计算机控股集团",
                "id": 206832
            }, {
                "name": "南京快手",
                "id": 206833
            }, {
                "name": "北京百度农业",
                "id": 206834
            }, {
                "name": "厦门百度渔业",
                "id": 206835
            }, {
                "name": "天津快手金融有限公司",
                "id": 206836
            }, {
                "name": "杭州微软互金有限公司",
                "id": 206837
            }, {
                "name": "深圳奈雪互金",
                "id": 206838
            }, {
                "name": "深圳平安航空有限公司",
                "id": 206839
            }, {
                "name": "台北华为汽车",
                "id": 206840,
                "children": [{
                    "name": "南京小米金融",
                    "id": 206841
                }, {
                    "name": "南京谷歌诊所",
                    "id": 206842,
                    "children": [{
                        "name": "东莞微软金融",
                        "id": 206843
                    }, {
                        "name": "上海滴滴汽车有限公司",
                        "id": 206844
                    }, {
                        "name": "天津微软医院",
                        "id": 206845
                    }, {
                        "name": "台北快手有限公司",
                        "id": 206846
                    }, {
                        "name": "深圳特斯拉医院",
                        "id": 206847
                    }, {
                        "name": "北京华为地产",
                        "id": 206848
                    }, {
                        "name": "台北苹果软件",
                        "id": 206849
                    }, {
                        "name": "东莞蚂蚁控股集团",
                        "id": 206850
                    }, {
                        "name": "上海特斯拉医院",
                        "id": 206851
                    }, {
                        "name": "杭州腾讯地产",
                        "id": 206852
                    }, {
                        "name": "东莞腾讯旅游有限公司",
                        "id": 206853
                    }, {
                        "name": "杭州喜茶电商有限公司",
                        "id": 206854
                    }, {
                        "name": "上海奈雪石油控股集团",
                        "id": 206855
                    }, {
                        "name": "纽约美团芯片有限公司",
                        "id": 206856
                    }, {
                        "name": "杭州平安牧业控股集团",
                        "id": 206857
                    }, {
                        "name": "台北肯德基旅游",
                        "id": 206858
                    }, {
                        "name": "杭州美团农业",
                        "id": 206859
                    }, {
                        "name": "台北亚马逊渔业",
                        "id": 206860
                    }, {
                        "name": "上海美团计算机控股集团",
                        "id": 206861
                    }]
                }, {
                    "name": "东京京东信息服务有限公司",
                    "id": 206862
                }, {
                    "name": "厦门星巴克制造",
                    "id": 206863
                }, {
                    "name": "北京阿里基金控股集团",
                    "id": 206864
                }]
            }, {
                "name": "南京星巴克软件控股集团",
                "id": 206865
            }, {
                "name": "香港肯德基证券有限公司",
                "id": 206866,
                "children": [{
                    "name": "南京谷歌通讯",
                    "id": 206867,
                    "children": [{
                        "name": "天津腾讯计算机",
                        "id": 206868
                    }, {
                        "name": "深圳瑞幸地摊控股集团",
                        "id": 206869
                    }, {
                        "name": "南京美团地产",
                        "id": 206870
                    }, {
                        "name": "杭州美团汽车控股集团",
                        "id": 206871
                    }, {
                        "name": "天津喜茶",
                        "id": 206872
                    }, {
                        "name": "香港平安证券",
                        "id": 206873
                    }, {
                        "name": "深圳瑞幸",
                        "id": 206874
                    }, {
                        "name": "杭州小米农业有限公司",
                        "id": 206875
                    }, {
                        "name": "杭州星巴克智能有限公司",
                        "id": 206876
                    }, {
                        "name": "首尔特斯拉渔业",
                        "id": 206877
                    }, {
                        "name": "纽约微软地摊",
                        "id": 206878
                    }, {
                        "name": "厦门阿里汽车",
                        "id": 206879
                    }, {
                        "name": "首尔谷歌控股集团",
                        "id": 206880
                    }, {
                        "name": "东莞阿里医药",
                        "id": 206881
                    }, {
                        "name": "厦门喜茶芯片",
                        "id": 206882
                    }, {
                        "name": "南京小米",
                        "id": 206883
                    }, {
                        "name": "首尔微软新能源控股集团",
                        "id": 206884
                    }, {
                        "name": "纽约肯德基旅游",
                        "id": 206885
                    }, {
                        "name": "东京肯德基航空",
                        "id": 206886
                    }, {
                        "name": "厦门必胜客电商",
                        "id": 206887
                    }, {
                        "name": "深圳微软信息服务",
                        "id": 206888
                    }, {
                        "name": "上海瑞幸牧业",
                        "id": 206889
                    }, {
                        "name": "上海奈雪芯片控股集团",
                        "id": 206890
                    }, {
                        "name": "天津百度科技",
                        "id": 206891
                    }, {
                        "name": "广州微软渔业控股集团",
                        "id": 206892
                    }, {
                        "name": "台北必胜客计算机",
                        "id": 206893
                    }, {
                        "name": "深圳蚂蚁有限公司",
                        "id": 206894
                    }, {
                        "name": "台北微软电商",
                        "id": 206895
                    }, {
                        "name": "东京欧珀医院有限公司",
                        "id": 206896
                    }, {
                        "name": "杭州瑞幸芯片",
                        "id": 206897
                    }, {
                        "name": "东莞欧珀石油",
                        "id": 206898
                    }, {
                        "name": "东莞百度基金控股集团",
                        "id": 206899
                    }, {
                        "name": "香港肯德基证券",
                        "id": 206900
                    }, {
                        "name": "天津美团渔业",
                        "id": 206901
                    }, {
                        "name": "厦门蚂蚁医药",
                        "id": 206902
                    }]
                }, {
                    "name": "东莞必胜客医院有限公司",
                    "id": 206903,
                    "children": [{
                        "name": "北京肯德基计算机",
                        "id": 206904
                    }, {
                        "name": "首尔喜茶信息服务控股集团",
                        "id": 206905
                    }, {
                        "name": "首尔快手诊所",
                        "id": 206906
                    }, {
                        "name": "杭州必胜客养殖有限公司",
                        "id": 206907
                    }, {
                        "name": "东京肯德基智能有限公司",
                        "id": 206908
                    }, {
                        "name": "广州特斯拉牧业",
                        "id": 206909
                    }, {
                        "name": "杭州京东农业",
                        "id": 206910
                    }, {
                        "name": "广州京东医院控股集团",
                        "id": 206911
                    }, {
                        "name": "首尔特斯拉基金有限公司",
                        "id": 206912
                    }, {
                        "name": "深圳阿里证券",
                        "id": 206913
                    }, {
                        "name": "南京奈雪牧业",
                        "id": 206914
                    }, {
                        "name": "南京欧珀渔业有限公司",
                        "id": 206915
                    }, {
                        "name": "南京阿里餐饮",
                        "id": 206916
                    }, {
                        "name": "台北华为新能源",
                        "id": 206917
                    }, {
                        "name": "香港喜茶农业",
                        "id": 206918
                    }, {
                        "name": "东莞喜茶科技",
                        "id": 206919
                    }, {
                        "name": "深圳美团制造",
                        "id": 206920
                    }, {
                        "name": "香港华为地产",
                        "id": 206921
                    }, {
                        "name": "北京京东",
                        "id": 206922
                    }, {
                        "name": "南京美团汽车",
                        "id": 206923
                    }, {
                        "name": "广州华为金融有限公司",
                        "id": 206924
                    }, {
                        "name": "广州瑞幸证券",
                        "id": 206925
                    }, {
                        "name": "深圳美团有限公司",
                        "id": 206926
                    }, {
                        "name": "北京美团有限公司",
                        "id": 206927
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 206928
                    }, {
                        "name": "杭州微软计算机",
                        "id": 206929
                    }, {
                        "name": "南京美团通讯",
                        "id": 206930
                    }, {
                        "name": "北京苹果通讯",
                        "id": 206931
                    }, {
                        "name": "天津必胜客软件",
                        "id": 206932
                    }, {
                        "name": "深圳百度信息服务有限公司",
                        "id": 206933
                    }, {
                        "name": "首尔肯德基计算机有限公司",
                        "id": 206934
                    }, {
                        "name": "杭州滴滴医院控股集团",
                        "id": 206935
                    }, {
                        "name": "天津蚂蚁信息服务有限公司",
                        "id": 206936
                    }]
                }]
            }, {
                "name": "上海亚马逊渔业控股集团",
                "id": 206937
            }, {
                "name": "东莞字节制造",
                "id": 206938,
                "children": [{
                    "name": "杭州必胜客医院",
                    "id": 206939
                }, {
                    "name": "东莞美团通信",
                    "id": 206940
                }, {
                    "name": "厦门快手地产",
                    "id": 206941,
                    "children": [{
                        "name": "东莞腾讯牧业",
                        "id": 206942
                    }, {
                        "name": "杭州快手",
                        "id": 206943
                    }, {
                        "name": "广州特斯拉芯片",
                        "id": 206944
                    }, {
                        "name": "杭州欧珀金融有限公司",
                        "id": 206945
                    }, {
                        "name": "南京苹果地产控股集团",
                        "id": 206946
                    }, {
                        "name": "上海苹果基金有限公司",
                        "id": 206947
                    }, {
                        "name": "杭州星巴克餐饮",
                        "id": 206948
                    }, {
                        "name": "东京百度",
                        "id": 206949
                    }, {
                        "name": "广州瑞幸科技",
                        "id": 206950
                    }, {
                        "name": "东京美团汽车有限公司",
                        "id": 206951
                    }, {
                        "name": "南京肯德基医药控股集团",
                        "id": 206952
                    }, {
                        "name": "香港平安地摊",
                        "id": 206953
                    }, {
                        "name": "上海欧珀渔业控股集团",
                        "id": 206954
                    }, {
                        "name": "东莞欧珀医药有限公司",
                        "id": 206955
                    }, {
                        "name": "厦门星巴克制造",
                        "id": 206956
                    }, {
                        "name": "南京奈雪医院",
                        "id": 206957
                    }, {
                        "name": "首尔腾讯软件",
                        "id": 206958
                    }, {
                        "name": "厦门瑞幸诊所",
                        "id": 206959
                    }, {
                        "name": "东京蚂蚁医药",
                        "id": 206960
                    }, {
                        "name": "厦门必胜客制造控股集团",
                        "id": 206961
                    }, {
                        "name": "香港喜茶牧业控股集团",
                        "id": 206962
                    }, {
                        "name": "东莞蚂蚁医院",
                        "id": 206963
                    }]
                }]
            }]
        }, {
            "name": "杭州阿里诊所",
            "id": 206964,
            "children": [{
                "name": "天津快手芯片",
                "id": 206965,
                "children": [{
                    "name": "厦门苹果牧业",
                    "id": 206966
                }, {
                    "name": "纽约阿里旅游有限公司",
                    "id": 206967
                }, {
                    "name": "杭州瑞幸计算机",
                    "id": 206968,
                    "children": [{
                        "name": "上海喜茶",
                        "id": 206969
                    }, {
                        "name": "台北快手医院",
                        "id": 206970
                    }, {
                        "name": "深圳蚂蚁制造",
                        "id": 206971
                    }, {
                        "name": "上海奈雪航空控股集团",
                        "id": 206972
                    }, {
                        "name": "东莞京东渔业控股集团",
                        "id": 206973
                    }, {
                        "name": "深圳平安新能源",
                        "id": 206974
                    }, {
                        "name": "首尔奈雪",
                        "id": 206975
                    }, {
                        "name": "东莞京东医院控股集团",
                        "id": 206976
                    }, {
                        "name": "杭州滴滴银行控股集团",
                        "id": 206977
                    }, {
                        "name": "天津特斯拉医院有限公司",
                        "id": 206978
                    }]
                }, {
                    "name": "上海必胜客金融",
                    "id": 206979,
                    "children": [{
                        "name": "厦门奈雪新能源",
                        "id": 206980
                    }, {
                        "name": "东京苹果计算机控股集团",
                        "id": 206981
                    }, {
                        "name": "深圳快手计算机控股集团",
                        "id": 206982
                    }, {
                        "name": "台北欧珀制造有限公司",
                        "id": 206983
                    }, {
                        "name": "首尔奈雪智能有限公司",
                        "id": 206984
                    }, {
                        "name": "南京特斯拉地产",
                        "id": 206985
                    }, {
                        "name": "东京奈雪科技",
                        "id": 206986
                    }, {
                        "name": "厦门欧珀电商控股集团",
                        "id": 206987
                    }, {
                        "name": "纽约喜茶诊所",
                        "id": 206988
                    }, {
                        "name": "天津星巴克科技有限公司",
                        "id": 206989
                    }, {
                        "name": "北京阿里基金",
                        "id": 206990
                    }, {
                        "name": "杭州阿里汽车",
                        "id": 206991
                    }, {
                        "name": "杭州苹果计算机",
                        "id": 206992
                    }, {
                        "name": "东莞苹果互金",
                        "id": 206993
                    }, {
                        "name": "杭州星巴克通信",
                        "id": 206994
                    }, {
                        "name": "北京平安航空控股集团",
                        "id": 206995
                    }, {
                        "name": "广州平安基金",
                        "id": 206996
                    }, {
                        "name": "杭州欧珀科技",
                        "id": 206997
                    }, {
                        "name": "南京苹果石油控股集团",
                        "id": 206998
                    }, {
                        "name": "广州快手诊所",
                        "id": 206999
                    }, {
                        "name": "杭州谷歌通信",
                        "id": 207000
                    }, {
                        "name": "广州亚马逊石油",
                        "id": 207001
                    }, {
                        "name": "东京瑞幸地摊有限公司",
                        "id": 207002
                    }, {
                        "name": "厦门苹果通讯",
                        "id": 207003
                    }, {
                        "name": "首尔肯德基新能源",
                        "id": 207004
                    }, {
                        "name": "深圳腾讯地产控股集团",
                        "id": 207005
                    }]
                }, {
                    "name": "广州百度基金",
                    "id": 207006
                }, {
                    "name": "广州奈雪地产",
                    "id": 207007
                }, {
                    "name": "上海蚂蚁基金有限公司",
                    "id": 207008
                }, {
                    "name": "北京滴滴渔业",
                    "id": 207009
                }, {
                    "name": "台北亚马逊地产",
                    "id": 207010
                }]
            }, {
                "name": "杭州字节银行有限公司",
                "id": 207011
            }, {
                "name": "厦门阿里智能控股集团",
                "id": 207012
            }, {
                "name": "广州奈雪石油",
                "id": 207013
            }, {
                "name": "纽约滴滴新能源",
                "id": 207014,
                "children": [{
                    "name": "东京字节电商",
                    "id": 207015
                }, {
                    "name": "上海肯德基科技",
                    "id": 207016
                }, {
                    "name": "上海京东电商有限公司",
                    "id": 207017,
                    "children": [{
                        "name": "东京肯德基基金",
                        "id": 207018
                    }, {
                        "name": "杭州瑞幸医院",
                        "id": 207019
                    }, {
                        "name": "台北快手旅游",
                        "id": 207020
                    }, {
                        "name": "天津腾讯餐饮",
                        "id": 207021
                    }, {
                        "name": "东莞京东基金",
                        "id": 207022
                    }, {
                        "name": "东莞微软互金",
                        "id": 207023
                    }, {
                        "name": "杭州苹果渔业",
                        "id": 207024
                    }, {
                        "name": "深圳百度渔业",
                        "id": 207025
                    }, {
                        "name": "杭州滴滴诊所控股集团",
                        "id": 207026
                    }, {
                        "name": "香港谷歌芯片控股集团",
                        "id": 207027
                    }, {
                        "name": "香港谷歌旅游",
                        "id": 207028
                    }, {
                        "name": "首尔苹果",
                        "id": 207029
                    }, {
                        "name": "上海亚马逊软件",
                        "id": 207030
                    }, {
                        "name": "东京亚马逊养殖控股集团",
                        "id": 207031
                    }, {
                        "name": "深圳阿里牧业",
                        "id": 207032
                    }]
                }, {
                    "name": "东京小米地摊",
                    "id": 207033,
                    "children": [{
                        "name": "南京百度有限公司",
                        "id": 207034
                    }, {
                        "name": "广州阿里电商",
                        "id": 207035
                    }, {
                        "name": "台北京东新能源",
                        "id": 207036
                    }, {
                        "name": "北京字节控股集团",
                        "id": 207037
                    }, {
                        "name": "东莞阿里计算机有限公司",
                        "id": 207038
                    }, {
                        "name": "杭州谷歌地摊",
                        "id": 207039
                    }, {
                        "name": "香港京东",
                        "id": 207040
                    }, {
                        "name": "东莞美团旅游",
                        "id": 207041
                    }, {
                        "name": "杭州喜茶餐饮",
                        "id": 207042
                    }, {
                        "name": "上海字节芯片",
                        "id": 207043
                    }, {
                        "name": "香港京东牧业",
                        "id": 207044
                    }, {
                        "name": "台北蚂蚁基金",
                        "id": 207045
                    }, {
                        "name": "首尔谷歌诊所",
                        "id": 207046
                    }, {
                        "name": "上海微软证券",
                        "id": 207047
                    }, {
                        "name": "北京必胜客医药",
                        "id": 207048
                    }, {
                        "name": "东京腾讯航空控股集团",
                        "id": 207049
                    }, {
                        "name": "台北肯德基基金",
                        "id": 207050
                    }, {
                        "name": "厦门京东地产",
                        "id": 207051
                    }, {
                        "name": "香港欧珀证券",
                        "id": 207052
                    }, {
                        "name": "杭州字节航空有限公司",
                        "id": 207053
                    }, {
                        "name": "天津小米航空",
                        "id": 207054
                    }, {
                        "name": "东莞亚马逊牧业",
                        "id": 207055
                    }, {
                        "name": "杭州百度新能源",
                        "id": 207056
                    }, {
                        "name": "天津小米",
                        "id": 207057
                    }, {
                        "name": "纽约腾讯基金控股集团",
                        "id": 207058
                    }, {
                        "name": "东京美团软件",
                        "id": 207059
                    }, {
                        "name": "厦门百度医院",
                        "id": 207060
                    }, {
                        "name": "南京微软智能控股集团",
                        "id": 207061
                    }, {
                        "name": "首尔快手养殖",
                        "id": 207062
                    }, {
                        "name": "上海亚马逊",
                        "id": 207063
                    }, {
                        "name": "首尔美团餐饮",
                        "id": 207064
                    }, {
                        "name": "香港欧珀智能",
                        "id": 207065
                    }, {
                        "name": "东莞百度汽车",
                        "id": 207066
                    }]
                }, {
                    "name": "东莞亚马逊牧业",
                    "id": 207067
                }, {
                    "name": "北京必胜客智能控股集团",
                    "id": 207068
                }, {
                    "name": "东莞美团石油",
                    "id": 207069
                }, {
                    "name": "广州小米汽车",
                    "id": 207070
                }, {
                    "name": "天津滴滴新能源控股集团",
                    "id": 207071
                }, {
                    "name": "香港滴滴有限公司",
                    "id": 207072,
                    "children": [{
                        "name": "天津美团证券",
                        "id": 207073
                    }, {
                        "name": "南京平安通信",
                        "id": 207074
                    }, {
                        "name": "北京必胜客信息服务",
                        "id": 207075
                    }, {
                        "name": "广州必胜客牧业",
                        "id": 207076
                    }, {
                        "name": "北京特斯拉计算机有限公司",
                        "id": 207077
                    }, {
                        "name": "杭州奈雪银行",
                        "id": 207078
                    }, {
                        "name": "杭州亚马逊有限公司",
                        "id": 207079
                    }, {
                        "name": "深圳必胜客控股集团",
                        "id": 207080
                    }, {
                        "name": "上海必胜客金融",
                        "id": 207081
                    }, {
                        "name": "杭州阿里航空控股集团",
                        "id": 207082
                    }, {
                        "name": "台北京东渔业",
                        "id": 207083
                    }, {
                        "name": "杭州谷歌通信控股集团",
                        "id": 207084
                    }, {
                        "name": "杭州平安石油",
                        "id": 207085
                    }, {
                        "name": "北京蚂蚁互金",
                        "id": 207086
                    }, {
                        "name": "纽约肯德基通讯控股集团",
                        "id": 207087
                    }, {
                        "name": "北京谷歌",
                        "id": 207088
                    }, {
                        "name": "台北瑞幸金融",
                        "id": 207089
                    }, {
                        "name": "北京奈雪汽车",
                        "id": 207090
                    }, {
                        "name": "天津美团地摊",
                        "id": 207091
                    }]
                }, {
                    "name": "杭州快手金融",
                    "id": 207092
                }, {
                    "name": "纽约阿里医院控股集团",
                    "id": 207093,
                    "children": [{
                        "name": "东京肯德基医药有限公司",
                        "id": 207094
                    }, {
                        "name": "上海必胜客互金",
                        "id": 207095
                    }, {
                        "name": "北京谷歌牧业",
                        "id": 207096
                    }, {
                        "name": "深圳星巴克医药有限公司",
                        "id": 207097
                    }, {
                        "name": "南京特斯拉计算机",
                        "id": 207098
                    }, {
                        "name": "首尔奈雪养殖",
                        "id": 207099
                    }, {
                        "name": "上海腾讯医院",
                        "id": 207100
                    }, {
                        "name": "厦门欧珀养殖",
                        "id": 207101
                    }, {
                        "name": "首尔阿里",
                        "id": 207102
                    }, {
                        "name": "厦门美团航空控股集团",
                        "id": 207103
                    }, {
                        "name": "深圳美团地产控股集团",
                        "id": 207104
                    }, {
                        "name": "香港肯德基银行",
                        "id": 207105
                    }, {
                        "name": "东京特斯拉制造",
                        "id": 207106
                    }, {
                        "name": "北京必胜客农业控股集团",
                        "id": 207107
                    }, {
                        "name": "广州美团银行",
                        "id": 207108
                    }, {
                        "name": "广州亚马逊通讯",
                        "id": 207109
                    }, {
                        "name": "杭州平安地产",
                        "id": 207110
                    }, {
                        "name": "东莞欧珀控股集团",
                        "id": 207111
                    }, {
                        "name": "东京喜茶科技",
                        "id": 207112
                    }, {
                        "name": "南京平安农业",
                        "id": 207113
                    }]
                }, {
                    "name": "台北字节智能控股集团",
                    "id": 207114
                }, {
                    "name": "东莞瑞幸渔业有限公司",
                    "id": 207115,
                    "children": [{
                        "name": "香港肯德基计算机",
                        "id": 207116
                    }, {
                        "name": "首尔特斯拉银行",
                        "id": 207117
                    }, {
                        "name": "上海快手地摊控股集团",
                        "id": 207118
                    }, {
                        "name": "香港苹果地摊有限公司",
                        "id": 207119
                    }, {
                        "name": "东莞特斯拉软件",
                        "id": 207120
                    }]
                }, {
                    "name": "南京谷歌计算机",
                    "id": 207121
                }, {
                    "name": "首尔美团有限公司",
                    "id": 207122,
                    "children": [{
                        "name": "厦门阿里新能源",
                        "id": 207123
                    }, {
                        "name": "东京喜茶汽车",
                        "id": 207124
                    }]
                }, {
                    "name": "台北京东农业控股集团",
                    "id": 207125
                }, {
                    "name": "厦门字节金融",
                    "id": 207126
                }, {
                    "name": "上海滴滴诊所",
                    "id": 207127
                }, {
                    "name": "北京滴滴计算机控股集团",
                    "id": 207128
                }, {
                    "name": "天津肯德基制造",
                    "id": 207129,
                    "children": [{
                        "name": "东京快手旅游有限公司",
                        "id": 207130
                    }, {
                        "name": "深圳瑞幸渔业",
                        "id": 207131
                    }, {
                        "name": "东京肯德基互金",
                        "id": 207132
                    }, {
                        "name": "天津欧珀农业控股集团",
                        "id": 207133
                    }, {
                        "name": "厦门瑞幸医院有限公司",
                        "id": 207134
                    }, {
                        "name": "杭州腾讯科技",
                        "id": 207135
                    }, {
                        "name": "广州平安电商有限公司",
                        "id": 207136
                    }, {
                        "name": "杭州百度通信控股集团",
                        "id": 207137
                    }, {
                        "name": "厦门特斯拉科技",
                        "id": 207138
                    }, {
                        "name": "东莞小米医院",
                        "id": 207139
                    }, {
                        "name": "东莞平安地产控股集团",
                        "id": 207140
                    }, {
                        "name": "首尔小米医药",
                        "id": 207141
                    }, {
                        "name": "北京欧珀农业有限公司",
                        "id": 207142
                    }, {
                        "name": "北京字节渔业控股集团",
                        "id": 207143
                    }, {
                        "name": "香港小米信息服务有限公司",
                        "id": 207144
                    }, {
                        "name": "北京苹果计算机",
                        "id": 207145
                    }, {
                        "name": "北京阿里",
                        "id": 207146
                    }, {
                        "name": "纽约美团餐饮控股集团",
                        "id": 207147
                    }, {
                        "name": "南京苹果软件控股集团",
                        "id": 207148
                    }, {
                        "name": "台北喜茶医药",
                        "id": 207149
                    }, {
                        "name": "纽约喜茶地产控股集团",
                        "id": 207150
                    }, {
                        "name": "东京腾讯金融",
                        "id": 207151
                    }, {
                        "name": "台北字节农业",
                        "id": 207152
                    }, {
                        "name": "北京喜茶",
                        "id": 207153
                    }, {
                        "name": "首尔肯德基旅游控股集团",
                        "id": 207154
                    }]
                }, {
                    "name": "广州美团医药",
                    "id": 207155
                }, {
                    "name": "首尔京东诊所",
                    "id": 207156
                }, {
                    "name": "厦门奈雪诊所",
                    "id": 207157
                }, {
                    "name": "天津瑞幸信息服务有限公司",
                    "id": 207158
                }, {
                    "name": "纽约滴滴医院有限公司",
                    "id": 207159,
                    "children": [{
                        "name": "广州肯德基渔业",
                        "id": 207160
                    }, {
                        "name": "杭州美团养殖",
                        "id": 207161
                    }, {
                        "name": "南京肯德基电商控股集团",
                        "id": 207162
                    }, {
                        "name": "上海蚂蚁通信",
                        "id": 207163
                    }, {
                        "name": "东莞美团渔业",
                        "id": 207164
                    }, {
                        "name": "厦门华为电商",
                        "id": 207165
                    }, {
                        "name": "东莞京东通讯控股集团",
                        "id": 207166
                    }, {
                        "name": "杭州喜茶有限公司",
                        "id": 207167
                    }, {
                        "name": "东京必胜客有限公司",
                        "id": 207168
                    }, {
                        "name": "首尔肯德基医院",
                        "id": 207169
                    }, {
                        "name": "香港苹果电商",
                        "id": 207170
                    }, {
                        "name": "首尔腾讯智能有限公司",
                        "id": 207171
                    }, {
                        "name": "杭州肯德基农业有限公司",
                        "id": 207172
                    }, {
                        "name": "广州瑞幸航空",
                        "id": 207173
                    }, {
                        "name": "杭州必胜客互金",
                        "id": 207174
                    }, {
                        "name": "东莞腾讯",
                        "id": 207175
                    }]
                }, {
                    "name": "深圳必胜客汽车有限公司",
                    "id": 207176
                }, {
                    "name": "杭州微软基金",
                    "id": 207177
                }]
            }, {
                "name": "天津喜茶计算机",
                "id": 207178
            }, {
                "name": "杭州苹果旅游有限公司",
                "id": 207179
            }, {
                "name": "上海滴滴医药",
                "id": 207180
            }, {
                "name": "香港小米农业",
                "id": 207181
            }, {
                "name": "东莞蚂蚁电商有限公司",
                "id": 207182
            }, {
                "name": "台北美团制造",
                "id": 207183,
                "children": [{
                    "name": "杭州肯德基新能源",
                    "id": 207184
                }, {
                    "name": "首尔阿里互金控股集团",
                    "id": 207185
                }, {
                    "name": "香港微软农业有限公司",
                    "id": 207186
                }, {
                    "name": "首尔快手智能",
                    "id": 207187
                }, {
                    "name": "北京奈雪地摊有限公司",
                    "id": 207188
                }, {
                    "name": "东莞快手养殖",
                    "id": 207189,
                    "children": [{
                        "name": "深圳快手牧业",
                        "id": 207190
                    }, {
                        "name": "南京快手软件",
                        "id": 207191
                    }, {
                        "name": "北京亚马逊软件有限公司",
                        "id": 207192
                    }, {
                        "name": "广州滴滴渔业有限公司",
                        "id": 207193
                    }, {
                        "name": "杭州阿里",
                        "id": 207194
                    }, {
                        "name": "香港华为",
                        "id": 207195
                    }, {
                        "name": "南京平安养殖",
                        "id": 207196
                    }, {
                        "name": "东京滴滴餐饮",
                        "id": 207197
                    }, {
                        "name": "杭州快手",
                        "id": 207198
                    }, {
                        "name": "台北奈雪农业",
                        "id": 207199
                    }, {
                        "name": "广州星巴克科技有限公司",
                        "id": 207200
                    }, {
                        "name": "天津欧珀",
                        "id": 207201
                    }, {
                        "name": "天津华为农业控股集团",
                        "id": 207202
                    }, {
                        "name": "天津字节金融",
                        "id": 207203
                    }, {
                        "name": "厦门京东",
                        "id": 207204
                    }, {
                        "name": "杭州百度通讯控股集团",
                        "id": 207205
                    }, {
                        "name": "厦门平安证券",
                        "id": 207206
                    }, {
                        "name": "天津滴滴基金控股集团",
                        "id": 207207
                    }, {
                        "name": "台北滴滴电商控股集团",
                        "id": 207208
                    }, {
                        "name": "纽约喜茶芯片",
                        "id": 207209
                    }, {
                        "name": "纽约奈雪医药",
                        "id": 207210
                    }, {
                        "name": "天津奈雪渔业",
                        "id": 207211
                    }]
                }, {
                    "name": "香港苹果互金有限公司",
                    "id": 207212
                }, {
                    "name": "首尔百度智能",
                    "id": 207213,
                    "children": [{
                        "name": "南京必胜客电商",
                        "id": 207214
                    }, {
                        "name": "杭州腾讯通讯控股集团",
                        "id": 207215
                    }, {
                        "name": "香港特斯拉银行有限公司",
                        "id": 207216
                    }, {
                        "name": "杭州微软芯片",
                        "id": 207217
                    }, {
                        "name": "深圳亚马逊科技有限公司",
                        "id": 207218
                    }, {
                        "name": "东莞百度制造控股集团",
                        "id": 207219
                    }, {
                        "name": "杭州肯德基牧业",
                        "id": 207220
                    }, {
                        "name": "香港阿里新能源",
                        "id": 207221
                    }, {
                        "name": "东京华为",
                        "id": 207222
                    }, {
                        "name": "厦门蚂蚁医药控股集团",
                        "id": 207223
                    }, {
                        "name": "广州百度通讯",
                        "id": 207224
                    }]
                }, {
                    "name": "东莞美团基金",
                    "id": 207225
                }, {
                    "name": "杭州亚马逊石油",
                    "id": 207226
                }, {
                    "name": "天津平安互金",
                    "id": 207227
                }, {
                    "name": "天津瑞幸金融",
                    "id": 207228
                }, {
                    "name": "深圳字节银行控股集团",
                    "id": 207229
                }, {
                    "name": "北京瑞幸证券",
                    "id": 207230
                }, {
                    "name": "香港快手地摊",
                    "id": 207231
                }, {
                    "name": "上海蚂蚁通信",
                    "id": 207232
                }, {
                    "name": "北京星巴克医药",
                    "id": 207233,
                    "children": [{
                        "name": "台北快手软件",
                        "id": 207234
                    }, {
                        "name": "纽约必胜客软件有限公司",
                        "id": 207235
                    }, {
                        "name": "天津微软制造控股集团",
                        "id": 207236
                    }, {
                        "name": "厦门滴滴互金",
                        "id": 207237
                    }, {
                        "name": "上海喜茶诊所",
                        "id": 207238
                    }, {
                        "name": "香港奈雪互金",
                        "id": 207239
                    }, {
                        "name": "首尔快手石油",
                        "id": 207240
                    }, {
                        "name": "首尔必胜客",
                        "id": 207241
                    }, {
                        "name": "台北字节诊所",
                        "id": 207242
                    }]
                }, {
                    "name": "东京阿里信息服务",
                    "id": 207243
                }, {
                    "name": "香港奈雪医药",
                    "id": 207244
                }, {
                    "name": "广州华为智能",
                    "id": 207245,
                    "children": [{
                        "name": "杭州欧珀互金有限公司",
                        "id": 207246
                    }, {
                        "name": "南京小米医院",
                        "id": 207247
                    }]
                }, {
                    "name": "厦门瑞幸银行有限公司",
                    "id": 207248
                }, {
                    "name": "深圳快手医药",
                    "id": 207249
                }, {
                    "name": "杭州滴滴餐饮",
                    "id": 207250
                }, {
                    "name": "北京肯德基证券有限公司",
                    "id": 207251
                }, {
                    "name": "南京平安科技",
                    "id": 207252
                }, {
                    "name": "深圳阿里养殖有限公司",
                    "id": 207253
                }, {
                    "name": "上海滴滴互金控股集团",
                    "id": 207254,
                    "children": [{
                        "name": "天津平安通信",
                        "id": 207255
                    }, {
                        "name": "香港华为金融",
                        "id": 207256
                    }, {
                        "name": "东京微软制造",
                        "id": 207257
                    }, {
                        "name": "南京瑞幸通信",
                        "id": 207258
                    }, {
                        "name": "杭州特斯拉地产控股集团",
                        "id": 207259
                    }, {
                        "name": "东莞小米通信",
                        "id": 207260
                    }, {
                        "name": "杭州腾讯地摊",
                        "id": 207261
                    }, {
                        "name": "东京特斯拉旅游",
                        "id": 207262
                    }, {
                        "name": "台北谷歌智能",
                        "id": 207263
                    }, {
                        "name": "上海微软石油有限公司",
                        "id": 207264
                    }, {
                        "name": "深圳阿里餐饮有限公司",
                        "id": 207265
                    }, {
                        "name": "首尔欧珀计算机",
                        "id": 207266
                    }, {
                        "name": "杭州小米石油",
                        "id": 207267
                    }, {
                        "name": "上海腾讯农业有限公司",
                        "id": 207268
                    }, {
                        "name": "杭州华为金融",
                        "id": 207269
                    }, {
                        "name": "天津微软计算机",
                        "id": 207270
                    }, {
                        "name": "广州京东基金",
                        "id": 207271
                    }, {
                        "name": "东京喜茶",
                        "id": 207272
                    }, {
                        "name": "南京滴滴信息服务有限公司",
                        "id": 207273
                    }, {
                        "name": "香港京东医院",
                        "id": 207274
                    }, {
                        "name": "纽约肯德基信息服务",
                        "id": 207275
                    }, {
                        "name": "香港京东信息服务",
                        "id": 207276
                    }, {
                        "name": "纽约必胜客医院",
                        "id": 207277
                    }, {
                        "name": "首尔奈雪计算机",
                        "id": 207278
                    }, {
                        "name": "北京肯德基诊所",
                        "id": 207279
                    }]
                }]
            }, {
                "name": "纽约阿里通信",
                "id": 207280
            }, {
                "name": "广州美团医院有限公司",
                "id": 207281
            }, {
                "name": "上海阿里医院",
                "id": 207282
            }, {
                "name": "杭州微软石油",
                "id": 207283,
                "children": [{
                    "name": "北京小米银行",
                    "id": 207284,
                    "children": [{
                        "name": "首尔百度通信控股集团",
                        "id": 207285
                    }, {
                        "name": "上海特斯拉医院",
                        "id": 207286
                    }, {
                        "name": "北京必胜客电商",
                        "id": 207287
                    }, {
                        "name": "纽约阿里软件",
                        "id": 207288
                    }, {
                        "name": "天津苹果医院",
                        "id": 207289
                    }, {
                        "name": "杭州必胜客渔业",
                        "id": 207290
                    }, {
                        "name": "深圳必胜客地产",
                        "id": 207291
                    }, {
                        "name": "北京美团芯片",
                        "id": 207292
                    }, {
                        "name": "纽约快手有限公司",
                        "id": 207293
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 207294
                    }, {
                        "name": "香港腾讯科技有限公司",
                        "id": 207295
                    }, {
                        "name": "南京滴滴医药控股集团",
                        "id": 207296
                    }, {
                        "name": "深圳华为互金控股集团",
                        "id": 207297
                    }, {
                        "name": "东莞亚马逊制造控股集团",
                        "id": 207298
                    }, {
                        "name": "深圳瑞幸计算机",
                        "id": 207299
                    }, {
                        "name": "香港平安通讯",
                        "id": 207300
                    }, {
                        "name": "天津必胜客控股集团",
                        "id": 207301
                    }, {
                        "name": "首尔滴滴银行",
                        "id": 207302
                    }, {
                        "name": "深圳星巴克通讯有限公司",
                        "id": 207303
                    }, {
                        "name": "广州欧珀科技",
                        "id": 207304
                    }, {
                        "name": "北京谷歌石油",
                        "id": 207305
                    }, {
                        "name": "上海美团基金",
                        "id": 207306
                    }, {
                        "name": "南京谷歌",
                        "id": 207307
                    }, {
                        "name": "纽约瑞幸渔业",
                        "id": 207308
                    }, {
                        "name": "深圳平安智能控股集团",
                        "id": 207309
                    }, {
                        "name": "首尔瑞幸航空",
                        "id": 207310
                    }, {
                        "name": "南京蚂蚁农业",
                        "id": 207311
                    }, {
                        "name": "杭州欧珀诊所",
                        "id": 207312
                    }, {
                        "name": "杭州必胜客证券",
                        "id": 207313
                    }, {
                        "name": "南京奈雪芯片",
                        "id": 207314
                    }]
                }, {
                    "name": "南京华为地产",
                    "id": 207315
                }, {
                    "name": "天津滴滴控股集团",
                    "id": 207316
                }]
            }, {
                "name": "北京谷歌诊所",
                "id": 207317,
                "children": [{
                    "name": "首尔平安银行",
                    "id": 207318,
                    "children": [{
                        "name": "广州京东芯片有限公司",
                        "id": 207319
                    }, {
                        "name": "杭州美团",
                        "id": 207320
                    }, {
                        "name": "杭州阿里渔业有限公司",
                        "id": 207321
                    }, {
                        "name": "东莞滴滴医药",
                        "id": 207322
                    }, {
                        "name": "东莞谷歌基金控股集团",
                        "id": 207323
                    }, {
                        "name": "东京蚂蚁牧业",
                        "id": 207324
                    }, {
                        "name": "杭州平安计算机",
                        "id": 207325
                    }, {
                        "name": "东莞特斯拉",
                        "id": 207326
                    }, {
                        "name": "天津奈雪金融控股集团",
                        "id": 207327
                    }, {
                        "name": "深圳百度地摊",
                        "id": 207328
                    }, {
                        "name": "北京肯德基农业有限公司",
                        "id": 207329
                    }, {
                        "name": "厦门喜茶芯片",
                        "id": 207330
                    }, {
                        "name": "杭州腾讯牧业",
                        "id": 207331
                    }, {
                        "name": "杭州滴滴医院控股集团",
                        "id": 207332
                    }, {
                        "name": "南京快手互金控股集团",
                        "id": 207333
                    }]
                }, {
                    "name": "首尔肯德基养殖",
                    "id": 207334,
                    "children": [{
                        "name": "广州美团航空",
                        "id": 207335
                    }, {
                        "name": "广州微软计算机",
                        "id": 207336
                    }, {
                        "name": "北京肯德基通信",
                        "id": 207337
                    }, {
                        "name": "首尔腾讯控股集团",
                        "id": 207338
                    }, {
                        "name": "北京欧珀医院",
                        "id": 207339
                    }, {
                        "name": "深圳腾讯汽车",
                        "id": 207340
                    }, {
                        "name": "杭州华为",
                        "id": 207341
                    }, {
                        "name": "杭州字节旅游控股集团",
                        "id": 207342
                    }, {
                        "name": "深圳特斯拉餐饮",
                        "id": 207343
                    }, {
                        "name": "上海腾讯证券",
                        "id": 207344
                    }, {
                        "name": "首尔字节新能源",
                        "id": 207345
                    }, {
                        "name": "东京京东基金控股集团",
                        "id": 207346
                    }, {
                        "name": "首尔美团证券有限公司",
                        "id": 207347
                    }]
                }, {
                    "name": "深圳华为科技",
                    "id": 207348
                }, {
                    "name": "深圳谷歌餐饮",
                    "id": 207349
                }, {
                    "name": "南京苹果诊所",
                    "id": 207350
                }, {
                    "name": "纽约小米地产",
                    "id": 207351
                }, {
                    "name": "杭州美团互金控股集团",
                    "id": 207352,
                    "children": [{
                        "name": "东京京东航空",
                        "id": 207353
                    }, {
                        "name": "首尔喜茶计算机控股集团",
                        "id": 207354
                    }, {
                        "name": "杭州喜茶医药",
                        "id": 207355
                    }, {
                        "name": "纽约喜茶金融",
                        "id": 207356
                    }, {
                        "name": "杭州亚马逊制造控股集团",
                        "id": 207357
                    }, {
                        "name": "广州肯德基农业",
                        "id": 207358
                    }, {
                        "name": "南京京东制造",
                        "id": 207359
                    }, {
                        "name": "杭州喜茶证券有限公司",
                        "id": 207360
                    }, {
                        "name": "天津奈雪医药控股集团",
                        "id": 207361
                    }, {
                        "name": "南京喜茶旅游",
                        "id": 207362
                    }, {
                        "name": "天津字节信息服务",
                        "id": 207363
                    }, {
                        "name": "香港字节金融",
                        "id": 207364
                    }, {
                        "name": "香港微软医院",
                        "id": 207365
                    }, {
                        "name": "杭州阿里电商",
                        "id": 207366
                    }, {
                        "name": "南京百度银行有限公司",
                        "id": 207367
                    }, {
                        "name": "杭州百度制造控股集团",
                        "id": 207368
                    }, {
                        "name": "南京星巴克汽车",
                        "id": 207369
                    }, {
                        "name": "杭州快手养殖控股集团",
                        "id": 207370
                    }, {
                        "name": "深圳快手农业有限公司",
                        "id": 207371
                    }, {
                        "name": "厦门快手信息服务",
                        "id": 207372
                    }, {
                        "name": "厦门特斯拉证券",
                        "id": 207373
                    }, {
                        "name": "杭州星巴克",
                        "id": 207374
                    }]
                }, {
                    "name": "南京蚂蚁",
                    "id": 207375,
                    "children": [{
                        "name": "纽约亚马逊芯片",
                        "id": 207376
                    }, {
                        "name": "北京百度科技",
                        "id": 207377
                    }, {
                        "name": "厦门亚马逊石油",
                        "id": 207378
                    }, {
                        "name": "纽约肯德基诊所控股集团",
                        "id": 207379
                    }, {
                        "name": "东莞谷歌汽车",
                        "id": 207380
                    }, {
                        "name": "首尔微软牧业",
                        "id": 207381
                    }, {
                        "name": "杭州小米牧业有限公司",
                        "id": 207382
                    }, {
                        "name": "首尔百度科技控股集团",
                        "id": 207383
                    }, {
                        "name": "台北快手信息服务",
                        "id": 207384
                    }, {
                        "name": "香港肯德基银行",
                        "id": 207385
                    }, {
                        "name": "东莞京东计算机",
                        "id": 207386
                    }, {
                        "name": "杭州微软地摊",
                        "id": 207387
                    }, {
                        "name": "首尔微软",
                        "id": 207388
                    }, {
                        "name": "东京滴滴渔业",
                        "id": 207389
                    }, {
                        "name": "南京奈雪旅游有限公司",
                        "id": 207390
                    }, {
                        "name": "杭州华为基金",
                        "id": 207391
                    }, {
                        "name": "首尔必胜客石油",
                        "id": 207392
                    }, {
                        "name": "纽约快手汽车控股集团",
                        "id": 207393
                    }, {
                        "name": "首尔苹果通讯有限公司",
                        "id": 207394
                    }, {
                        "name": "杭州滴滴诊所",
                        "id": 207395
                    }, {
                        "name": "杭州滴滴餐饮",
                        "id": 207396
                    }, {
                        "name": "东莞滴滴通讯有限公司",
                        "id": 207397
                    }, {
                        "name": "厦门小米地产",
                        "id": 207398
                    }, {
                        "name": "广州平安电商",
                        "id": 207399
                    }, {
                        "name": "南京腾讯信息服务",
                        "id": 207400
                    }, {
                        "name": "台北微软科技",
                        "id": 207401
                    }, {
                        "name": "香港小米金融控股集团",
                        "id": 207402
                    }, {
                        "name": "香港星巴克渔业",
                        "id": 207403
                    }, {
                        "name": "首尔阿里互金有限公司",
                        "id": 207404
                    }, {
                        "name": "纽约京东渔业有限公司",
                        "id": 207405
                    }, {
                        "name": "广州肯德基信息服务有限公司",
                        "id": 207406
                    }, {
                        "name": "广州美团智能",
                        "id": 207407
                    }, {
                        "name": "首尔华为地产",
                        "id": 207408
                    }, {
                        "name": "天津京东医药",
                        "id": 207409
                    }, {
                        "name": "纽约微软医药",
                        "id": 207410
                    }]
                }, {
                    "name": "北京美团有限公司",
                    "id": 207411,
                    "children": [{
                        "name": "北京京东智能",
                        "id": 207412
                    }, {
                        "name": "天津阿里计算机",
                        "id": 207413
                    }, {
                        "name": "香港星巴克航空",
                        "id": 207414
                    }, {
                        "name": "天津阿里养殖",
                        "id": 207415
                    }, {
                        "name": "天津快手通讯控股集团",
                        "id": 207416
                    }, {
                        "name": "广州特斯拉科技",
                        "id": 207417
                    }, {
                        "name": "南京腾讯芯片控股集团",
                        "id": 207418
                    }, {
                        "name": "上海阿里石油",
                        "id": 207419
                    }, {
                        "name": "天津特斯拉软件控股集团",
                        "id": 207420
                    }, {
                        "name": "东京瑞幸银行",
                        "id": 207421
                    }, {
                        "name": "深圳蚂蚁汽车控股集团",
                        "id": 207422
                    }, {
                        "name": "深圳百度",
                        "id": 207423
                    }, {
                        "name": "上海快手地产",
                        "id": 207424
                    }, {
                        "name": "广州小米",
                        "id": 207425
                    }, {
                        "name": "东莞快手软件",
                        "id": 207426
                    }, {
                        "name": "天津小米农业控股集团",
                        "id": 207427
                    }, {
                        "name": "杭州微软芯片",
                        "id": 207428
                    }, {
                        "name": "北京喜茶银行",
                        "id": 207429
                    }, {
                        "name": "南京欧珀餐饮控股集团",
                        "id": 207430
                    }, {
                        "name": "天津蚂蚁餐饮",
                        "id": 207431
                    }, {
                        "name": "东莞小米地摊",
                        "id": 207432
                    }]
                }, {
                    "name": "东莞滴滴计算机",
                    "id": 207433
                }, {
                    "name": "杭州亚马逊智能",
                    "id": 207434
                }, {
                    "name": "杭州阿里新能源",
                    "id": 207435
                }, {
                    "name": "广州百度银行",
                    "id": 207436
                }, {
                    "name": "天津苹果地摊",
                    "id": 207437
                }, {
                    "name": "上海阿里科技控股集团",
                    "id": 207438
                }, {
                    "name": "台北京东汽车",
                    "id": 207439
                }, {
                    "name": "东莞特斯拉智能",
                    "id": 207440
                }, {
                    "name": "天津微软",
                    "id": 207441
                }, {
                    "name": "杭州阿里诊所",
                    "id": 207442
                }, {
                    "name": "广州百度证券",
                    "id": 207443
                }, {
                    "name": "南京肯德基计算机",
                    "id": 207444
                }, {
                    "name": "台北百度医药",
                    "id": 207445,
                    "children": [{
                        "name": "厦门肯德基金融",
                        "id": 207446
                    }, {
                        "name": "东京喜茶汽车控股集团",
                        "id": 207447
                    }, {
                        "name": "东京亚马逊",
                        "id": 207448
                    }, {
                        "name": "北京特斯拉地摊",
                        "id": 207449
                    }, {
                        "name": "厦门美团牧业",
                        "id": 207450
                    }, {
                        "name": "纽约喜茶基金有限公司",
                        "id": 207451
                    }, {
                        "name": "厦门欧珀地产",
                        "id": 207452
                    }, {
                        "name": "东京阿里电商控股集团",
                        "id": 207453
                    }, {
                        "name": "首尔蚂蚁智能",
                        "id": 207454
                    }, {
                        "name": "广州肯德基地产",
                        "id": 207455
                    }, {
                        "name": "杭州腾讯制造",
                        "id": 207456
                    }, {
                        "name": "台北字节餐饮",
                        "id": 207457
                    }, {
                        "name": "南京微软养殖有限公司",
                        "id": 207458
                    }, {
                        "name": "香港美团互金",
                        "id": 207459
                    }, {
                        "name": "天津美团旅游",
                        "id": 207460
                    }, {
                        "name": "台北阿里通信",
                        "id": 207461
                    }, {
                        "name": "杭州欧珀汽车",
                        "id": 207462
                    }]
                }, {
                    "name": "北京星巴克智能",
                    "id": 207463
                }, {
                    "name": "东莞奈雪医药控股集团",
                    "id": 207464
                }, {
                    "name": "深圳华为",
                    "id": 207465
                }, {
                    "name": "深圳肯德基通信控股集团",
                    "id": 207466
                }, {
                    "name": "南京华为芯片",
                    "id": 207467
                }, {
                    "name": "南京必胜客汽车控股集团",
                    "id": 207468
                }, {
                    "name": "纽约微软通讯控股集团",
                    "id": 207469
                }, {
                    "name": "南京阿里地产控股集团",
                    "id": 207470
                }, {
                    "name": "杭州平安金融",
                    "id": 207471
                }, {
                    "name": "台北华为软件有限公司",
                    "id": 207472
                }]
            }, {
                "name": "厦门特斯拉",
                "id": 207473
            }, {
                "name": "厦门必胜客电商",
                "id": 207474
            }, {
                "name": "香港谷歌通讯控股集团",
                "id": 207475
            }, {
                "name": "台北欧珀软件有限公司",
                "id": 207476
            }, {
                "name": "深圳美团汽车",
                "id": 207477,
                "children": [{
                    "name": "深圳华为通讯",
                    "id": 207478
                }, {
                    "name": "天津特斯拉地产",
                    "id": 207479
                }, {
                    "name": "厦门腾讯芯片",
                    "id": 207480
                }, {
                    "name": "南京苹果制造",
                    "id": 207481
                }, {
                    "name": "纽约欧珀智能有限公司",
                    "id": 207482
                }, {
                    "name": "天津亚马逊旅游",
                    "id": 207483
                }, {
                    "name": "纽约滴滴航空",
                    "id": 207484
                }, {
                    "name": "纽约华为",
                    "id": 207485
                }, {
                    "name": "上海谷歌电商",
                    "id": 207486
                }, {
                    "name": "北京特斯拉航空",
                    "id": 207487
                }, {
                    "name": "深圳华为互金",
                    "id": 207488,
                    "children": [{
                        "name": "北京苹果控股集团",
                        "id": 207489
                    }, {
                        "name": "北京美团计算机",
                        "id": 207490
                    }, {
                        "name": "深圳微软地摊",
                        "id": 207491
                    }, {
                        "name": "东京蚂蚁农业",
                        "id": 207492
                    }, {
                        "name": "杭州百度科技控股集团",
                        "id": 207493
                    }, {
                        "name": "上海瑞幸医院有限公司",
                        "id": 207494
                    }, {
                        "name": "东京蚂蚁",
                        "id": 207495
                    }, {
                        "name": "东京必胜客汽车有限公司",
                        "id": 207496
                    }, {
                        "name": "香港字节旅游",
                        "id": 207497
                    }, {
                        "name": "香港微软石油",
                        "id": 207498
                    }, {
                        "name": "杭州肯德基科技",
                        "id": 207499
                    }]
                }, {
                    "name": "纽约滴滴医药有限公司",
                    "id": 207500
                }, {
                    "name": "北京欧珀新能源控股集团",
                    "id": 207501
                }, {
                    "name": "纽约喜茶汽车有限公司",
                    "id": 207502
                }, {
                    "name": "香港特斯拉金融",
                    "id": 207503
                }, {
                    "name": "天津京东制造",
                    "id": 207504
                }, {
                    "name": "北京苹果智能有限公司",
                    "id": 207505
                }, {
                    "name": "天津阿里信息服务",
                    "id": 207506,
                    "children": [{
                        "name": "天津美团互金有限公司",
                        "id": 207507
                    }, {
                        "name": "台北星巴克牧业",
                        "id": 207508
                    }, {
                        "name": "纽约美团电商",
                        "id": 207509
                    }, {
                        "name": "广州蚂蚁石油控股集团",
                        "id": 207510
                    }, {
                        "name": "深圳滴滴基金",
                        "id": 207511
                    }, {
                        "name": "首尔小米基金控股集团",
                        "id": 207512
                    }, {
                        "name": "深圳欧珀信息服务",
                        "id": 207513
                    }, {
                        "name": "南京美团牧业",
                        "id": 207514
                    }, {
                        "name": "香港腾讯金融",
                        "id": 207515
                    }, {
                        "name": "厦门微软诊所",
                        "id": 207516
                    }, {
                        "name": "南京小米信息服务控股集团",
                        "id": 207517
                    }, {
                        "name": "厦门瑞幸控股集团",
                        "id": 207518
                    }, {
                        "name": "东莞喜茶地产",
                        "id": 207519
                    }, {
                        "name": "北京字节互金",
                        "id": 207520
                    }, {
                        "name": "杭州滴滴医药控股集团",
                        "id": 207521
                    }, {
                        "name": "首尔字节农业",
                        "id": 207522
                    }, {
                        "name": "北京亚马逊牧业控股集团",
                        "id": 207523
                    }, {
                        "name": "北京蚂蚁通信",
                        "id": 207524
                    }, {
                        "name": "杭州必胜客计算机有限公司",
                        "id": 207525
                    }, {
                        "name": "东莞百度科技",
                        "id": 207526
                    }, {
                        "name": "杭州小米计算机有限公司",
                        "id": 207527
                    }, {
                        "name": "厦门肯德基基金",
                        "id": 207528
                    }, {
                        "name": "纽约腾讯航空控股集团",
                        "id": 207529
                    }, {
                        "name": "深圳滴滴",
                        "id": 207530
                    }, {
                        "name": "上海快手餐饮",
                        "id": 207531
                    }, {
                        "name": "深圳阿里",
                        "id": 207532
                    }, {
                        "name": "东京星巴克汽车",
                        "id": 207533
                    }, {
                        "name": "天津奈雪医院",
                        "id": 207534
                    }, {
                        "name": "杭州小米医院",
                        "id": 207535
                    }, {
                        "name": "香港平安牧业",
                        "id": 207536
                    }, {
                        "name": "天津肯德基",
                        "id": 207537
                    }, {
                        "name": "深圳京东诊所",
                        "id": 207538
                    }, {
                        "name": "厦门京东地产",
                        "id": 207539
                    }, {
                        "name": "深圳平安芯片",
                        "id": 207540
                    }, {
                        "name": "广州京东互金",
                        "id": 207541
                    }]
                }, {
                    "name": "厦门必胜客渔业",
                    "id": 207542
                }, {
                    "name": "首尔阿里农业",
                    "id": 207543
                }, {
                    "name": "北京滴滴计算机",
                    "id": 207544
                }, {
                    "name": "东京微软诊所",
                    "id": 207545
                }, {
                    "name": "东莞特斯拉旅游",
                    "id": 207546
                }, {
                    "name": "东莞星巴克基金有限公司",
                    "id": 207547
                }, {
                    "name": "首尔欧珀汽车",
                    "id": 207548,
                    "children": [{
                        "name": "北京蚂蚁牧业",
                        "id": 207549
                    }, {
                        "name": "香港阿里计算机",
                        "id": 207550
                    }, {
                        "name": "南京谷歌证券有限公司",
                        "id": 207551
                    }, {
                        "name": "首尔华为地产",
                        "id": 207552
                    }, {
                        "name": "纽约小米餐饮",
                        "id": 207553
                    }, {
                        "name": "上海亚马逊养殖",
                        "id": 207554
                    }, {
                        "name": "杭州苹果计算机有限公司",
                        "id": 207555
                    }, {
                        "name": "广州欧珀",
                        "id": 207556
                    }, {
                        "name": "纽约平安金融",
                        "id": 207557
                    }, {
                        "name": "香港星巴克",
                        "id": 207558
                    }, {
                        "name": "杭州必胜客银行",
                        "id": 207559
                    }, {
                        "name": "杭州欧珀航空",
                        "id": 207560
                    }, {
                        "name": "首尔星巴克石油",
                        "id": 207561
                    }, {
                        "name": "首尔必胜客科技",
                        "id": 207562
                    }, {
                        "name": "东京必胜客通信",
                        "id": 207563
                    }, {
                        "name": "杭州快手电商控股集团",
                        "id": 207564
                    }]
                }, {
                    "name": "深圳腾讯银行",
                    "id": 207565
                }, {
                    "name": "天津字节基金有限公司",
                    "id": 207566
                }, {
                    "name": "东京美团旅游",
                    "id": 207567
                }]
            }, {
                "name": "香港特斯拉汽车",
                "id": 207568
            }, {
                "name": "北京奈雪金融",
                "id": 207569
            }, {
                "name": "南京微软医院控股集团",
                "id": 207570
            }, {
                "name": "纽约蚂蚁",
                "id": 207571
            }]
        }, {
            "name": "南京百度通讯控股集团",
            "id": 207572
        }, {
            "name": "北京瑞幸通信",
            "id": 207573,
            "children": [{
                "name": "深圳肯德基信息服务",
                "id": 207574
            }, {
                "name": "南京欧珀智能",
                "id": 207575
            }, {
                "name": "厦门喜茶科技控股集团",
                "id": 207576,
                "children": [{
                    "name": "纽约美团地摊",
                    "id": 207577
                }, {
                    "name": "台北京东渔业控股集团",
                    "id": 207578
                }, {
                    "name": "南京谷歌汽车",
                    "id": 207579
                }, {
                    "name": "天津华为牧业有限公司",
                    "id": 207580
                }, {
                    "name": "香港特斯拉电商控股集团",
                    "id": 207581
                }, {
                    "name": "台北亚马逊银行",
                    "id": 207582
                }, {
                    "name": "厦门快手证券",
                    "id": 207583
                }, {
                    "name": "杭州滴滴渔业",
                    "id": 207584
                }, {
                    "name": "台北微软农业",
                    "id": 207585,
                    "children": [{
                        "name": "台北必胜客医院",
                        "id": 207586
                    }, {
                        "name": "深圳奈雪医药",
                        "id": 207587
                    }, {
                        "name": "北京瑞幸制造有限公司",
                        "id": 207588
                    }, {
                        "name": "天津蚂蚁地产",
                        "id": 207589
                    }, {
                        "name": "杭州谷歌航空",
                        "id": 207590
                    }, {
                        "name": "上海瑞幸牧业",
                        "id": 207591
                    }, {
                        "name": "香港阿里渔业控股集团",
                        "id": 207592
                    }, {
                        "name": "杭州滴滴科技",
                        "id": 207593
                    }, {
                        "name": "杭州百度石油有限公司",
                        "id": 207594
                    }, {
                        "name": "深圳快手芯片有限公司",
                        "id": 207595
                    }, {
                        "name": "台北特斯拉电商",
                        "id": 207596
                    }, {
                        "name": "台北字节养殖控股集团",
                        "id": 207597
                    }, {
                        "name": "天津微软金融控股集团",
                        "id": 207598
                    }, {
                        "name": "台北奈雪渔业",
                        "id": 207599
                    }, {
                        "name": "北京谷歌医院",
                        "id": 207600
                    }, {
                        "name": "杭州谷歌证券",
                        "id": 207601
                    }, {
                        "name": "上海亚马逊电商",
                        "id": 207602
                    }, {
                        "name": "北京奈雪牧业",
                        "id": 207603
                    }]
                }]
            }, {
                "name": "首尔欧珀航空控股集团",
                "id": 207604
            }, {
                "name": "首尔微软通讯有限公司",
                "id": 207605
            }, {
                "name": "首尔星巴克旅游",
                "id": 207606
            }, {
                "name": "台北滴滴餐饮",
                "id": 207607
            }, {
                "name": "首尔喜茶地产控股集团",
                "id": 207608
            }, {
                "name": "台北肯德基软件",
                "id": 207609
            }, {
                "name": "杭州微软通信控股集团",
                "id": 207610,
                "children": [{
                    "name": "北京欧珀地产",
                    "id": 207611
                }, {
                    "name": "天津阿里",
                    "id": 207612
                }, {
                    "name": "南京特斯拉养殖",
                    "id": 207613
                }, {
                    "name": "北京平安餐饮",
                    "id": 207614
                }, {
                    "name": "南京必胜客地产",
                    "id": 207615,
                    "children": [{
                        "name": "南京欧珀通信控股集团",
                        "id": 207616
                    }, {
                        "name": "天津奈雪养殖",
                        "id": 207617
                    }, {
                        "name": "南京谷歌",
                        "id": 207618
                    }, {
                        "name": "天津快手智能",
                        "id": 207619
                    }, {
                        "name": "杭州喜茶通讯有限公司",
                        "id": 207620
                    }, {
                        "name": "杭州谷歌农业控股集团",
                        "id": 207621
                    }, {
                        "name": "纽约快手智能控股集团",
                        "id": 207622
                    }, {
                        "name": "杭州瑞幸石油控股集团",
                        "id": 207623
                    }, {
                        "name": "天津欧珀旅游有限公司",
                        "id": 207624
                    }, {
                        "name": "厦门美团信息服务",
                        "id": 207625
                    }, {
                        "name": "深圳谷歌医药",
                        "id": 207626
                    }, {
                        "name": "天津滴滴航空",
                        "id": 207627
                    }, {
                        "name": "首尔腾讯电商",
                        "id": 207628
                    }, {
                        "name": "北京奈雪医药",
                        "id": 207629
                    }, {
                        "name": "深圳苹果信息服务",
                        "id": 207630
                    }, {
                        "name": "台北京东电商",
                        "id": 207631
                    }, {
                        "name": "南京腾讯牧业",
                        "id": 207632
                    }, {
                        "name": "首尔百度",
                        "id": 207633
                    }, {
                        "name": "东京亚马逊科技控股集团",
                        "id": 207634
                    }, {
                        "name": "首尔喜茶通信",
                        "id": 207635
                    }, {
                        "name": "广州欧珀医院",
                        "id": 207636
                    }]
                }, {
                    "name": "东莞特斯拉智能有限公司",
                    "id": 207637,
                    "children": [{
                        "name": "台北奈雪牧业有限公司",
                        "id": 207638
                    }, {
                        "name": "纽约平安证券",
                        "id": 207639
                    }, {
                        "name": "杭州美团计算机控股集团",
                        "id": 207640
                    }, {
                        "name": "厦门平安",
                        "id": 207641
                    }, {
                        "name": "东京瑞幸互金有限公司",
                        "id": 207642
                    }, {
                        "name": "杭州快手旅游",
                        "id": 207643
                    }, {
                        "name": "东莞腾讯科技",
                        "id": 207644
                    }, {
                        "name": "纽约蚂蚁医院有限公司",
                        "id": 207645
                    }, {
                        "name": "东京欧珀科技",
                        "id": 207646
                    }, {
                        "name": "上海阿里新能源",
                        "id": 207647
                    }, {
                        "name": "台北美团养殖",
                        "id": 207648
                    }]
                }, {
                    "name": "北京肯德基控股集团",
                    "id": 207649,
                    "children": [{
                        "name": "首尔小米汽车",
                        "id": 207650
                    }, {
                        "name": "深圳美团航空有限公司",
                        "id": 207651
                    }, {
                        "name": "杭州谷歌",
                        "id": 207652
                    }, {
                        "name": "东莞百度互金",
                        "id": 207653
                    }, {
                        "name": "南京必胜客银行",
                        "id": 207654
                    }, {
                        "name": "南京美团计算机有限公司",
                        "id": 207655
                    }]
                }, {
                    "name": "南京平安银行有限公司",
                    "id": 207656
                }, {
                    "name": "杭州必胜客",
                    "id": 207657
                }, {
                    "name": "南京滴滴金融",
                    "id": 207658,
                    "children": [{
                        "name": "深圳京东计算机",
                        "id": 207659
                    }, {
                        "name": "香港欧珀通信",
                        "id": 207660
                    }, {
                        "name": "北京特斯拉制造",
                        "id": 207661
                    }, {
                        "name": "厦门滴滴牧业控股集团",
                        "id": 207662
                    }, {
                        "name": "纽约蚂蚁计算机",
                        "id": 207663
                    }, {
                        "name": "天津平安芯片",
                        "id": 207664
                    }, {
                        "name": "东京奈雪",
                        "id": 207665
                    }, {
                        "name": "台北苹果医药",
                        "id": 207666
                    }, {
                        "name": "杭州奈雪有限公司",
                        "id": 207667
                    }, {
                        "name": "杭州字节诊所控股集团",
                        "id": 207668
                    }]
                }, {
                    "name": "厦门京东通信控股集团",
                    "id": 207669
                }, {
                    "name": "东莞美团银行",
                    "id": 207670
                }, {
                    "name": "台北亚马逊医药有限公司",
                    "id": 207671
                }, {
                    "name": "北京百度科技",
                    "id": 207672,
                    "children": [{
                        "name": "上海阿里通信",
                        "id": 207673
                    }, {
                        "name": "台北平安制造",
                        "id": 207674
                    }, {
                        "name": "香港小米地产",
                        "id": 207675
                    }, {
                        "name": "广州微软地摊有限公司",
                        "id": 207676
                    }, {
                        "name": "南京美团有限公司",
                        "id": 207677
                    }, {
                        "name": "东京瑞幸金融",
                        "id": 207678
                    }, {
                        "name": "纽约肯德基证券控股集团",
                        "id": 207679
                    }, {
                        "name": "东京滴滴餐饮",
                        "id": 207680
                    }, {
                        "name": "天津蚂蚁牧业",
                        "id": 207681
                    }, {
                        "name": "北京欧珀餐饮控股集团",
                        "id": 207682
                    }, {
                        "name": "深圳微软石油控股集团",
                        "id": 207683
                    }, {
                        "name": "东莞喜茶石油",
                        "id": 207684
                    }, {
                        "name": "天津特斯拉芯片",
                        "id": 207685
                    }, {
                        "name": "东京谷歌航空",
                        "id": 207686
                    }, {
                        "name": "香港必胜客旅游",
                        "id": 207687
                    }, {
                        "name": "首尔微软制造控股集团",
                        "id": 207688
                    }, {
                        "name": "香港蚂蚁牧业",
                        "id": 207689
                    }, {
                        "name": "南京奈雪制造",
                        "id": 207690
                    }, {
                        "name": "纽约滴滴互金",
                        "id": 207691
                    }, {
                        "name": "纽约微软旅游有限公司",
                        "id": 207692
                    }, {
                        "name": "天津肯德基信息服务",
                        "id": 207693
                    }, {
                        "name": "广州京东基金有限公司",
                        "id": 207694
                    }, {
                        "name": "天津滴滴基金",
                        "id": 207695
                    }, {
                        "name": "上海喜茶诊所有限公司",
                        "id": 207696
                    }, {
                        "name": "香港美团科技",
                        "id": 207697
                    }, {
                        "name": "广州平安互金",
                        "id": 207698
                    }, {
                        "name": "东莞蚂蚁航空",
                        "id": 207699
                    }, {
                        "name": "广州瑞幸地产",
                        "id": 207700
                    }, {
                        "name": "香港微软餐饮",
                        "id": 207701
                    }, {
                        "name": "纽约阿里渔业控股集团",
                        "id": 207702
                    }]
                }, {
                    "name": "纽约百度智能",
                    "id": 207703
                }, {
                    "name": "南京奈雪医药",
                    "id": 207704
                }, {
                    "name": "上海华为医院",
                    "id": 207705
                }, {
                    "name": "北京阿里智能",
                    "id": 207706
                }, {
                    "name": "首尔特斯拉牧业",
                    "id": 207707
                }, {
                    "name": "香港奈雪农业控股集团",
                    "id": 207708
                }, {
                    "name": "台北谷歌控股集团",
                    "id": 207709
                }, {
                    "name": "台北奈雪餐饮有限公司",
                    "id": 207710,
                    "children": [{
                        "name": "厦门微软诊所",
                        "id": 207711
                    }, {
                        "name": "杭州平安控股集团",
                        "id": 207712
                    }, {
                        "name": "上海肯德基农业",
                        "id": 207713
                    }]
                }, {
                    "name": "东京滴滴餐饮",
                    "id": 207714
                }, {
                    "name": "厦门苹果信息服务",
                    "id": 207715
                }]
            }, {
                "name": "杭州欧珀智能",
                "id": 207716
            }, {
                "name": "深圳奈雪证券",
                "id": 207717
            }, {
                "name": "首尔星巴克医药控股集团",
                "id": 207718
            }, {
                "name": "台北蚂蚁制造",
                "id": 207719
            }, {
                "name": "深圳美团有限公司",
                "id": 207720
            }, {
                "name": "东莞奈雪芯片",
                "id": 207721,
                "children": [{
                    "name": "北京蚂蚁汽车有限公司",
                    "id": 207722,
                    "children": [{
                        "name": "台北美团航空控股集团",
                        "id": 207723
                    }, {
                        "name": "东莞蚂蚁智能",
                        "id": 207724
                    }]
                }, {
                    "name": "首尔平安控股集团",
                    "id": 207725,
                    "children": [{
                        "name": "厦门特斯拉互金",
                        "id": 207726
                    }, {
                        "name": "杭州微软信息服务",
                        "id": 207727
                    }, {
                        "name": "厦门奈雪地产",
                        "id": 207728
                    }, {
                        "name": "香港喜茶通信",
                        "id": 207729
                    }, {
                        "name": "北京苹果",
                        "id": 207730
                    }, {
                        "name": "台北小米农业有限公司",
                        "id": 207731
                    }, {
                        "name": "首尔星巴克计算机",
                        "id": 207732
                    }, {
                        "name": "北京微软渔业",
                        "id": 207733
                    }, {
                        "name": "厦门腾讯医院",
                        "id": 207734
                    }, {
                        "name": "杭州肯德基互金",
                        "id": 207735
                    }, {
                        "name": "东京腾讯",
                        "id": 207736
                    }, {
                        "name": "上海腾讯医院控股集团",
                        "id": 207737
                    }, {
                        "name": "天津谷歌通讯",
                        "id": 207738
                    }, {
                        "name": "杭州滴滴医药",
                        "id": 207739
                    }, {
                        "name": "广州亚马逊餐饮",
                        "id": 207740
                    }, {
                        "name": "上海小米石油",
                        "id": 207741
                    }, {
                        "name": "广州星巴克软件有限公司",
                        "id": 207742
                    }, {
                        "name": "广州美团证券",
                        "id": 207743
                    }, {
                        "name": "厦门腾讯基金",
                        "id": 207744
                    }, {
                        "name": "北京快手芯片控股集团",
                        "id": 207745
                    }, {
                        "name": "深圳苹果地产",
                        "id": 207746
                    }, {
                        "name": "杭州亚马逊信息服务",
                        "id": 207747
                    }, {
                        "name": "台北字节科技",
                        "id": 207748
                    }, {
                        "name": "东莞瑞幸基金",
                        "id": 207749
                    }, {
                        "name": "广州肯德基医院",
                        "id": 207750
                    }, {
                        "name": "香港美团诊所",
                        "id": 207751
                    }, {
                        "name": "南京星巴克牧业控股集团",
                        "id": 207752
                    }, {
                        "name": "杭州奈雪新能源",
                        "id": 207753
                    }, {
                        "name": "纽约亚马逊科技",
                        "id": 207754
                    }, {
                        "name": "南京阿里银行有限公司",
                        "id": 207755
                    }, {
                        "name": "杭州苹果通信控股集团",
                        "id": 207756
                    }, {
                        "name": "香港小米计算机",
                        "id": 207757
                    }, {
                        "name": "东京亚马逊通讯",
                        "id": 207758
                    }, {
                        "name": "南京滴滴智能",
                        "id": 207759
                    }]
                }, {
                    "name": "台北美团医药",
                    "id": 207760
                }, {
                    "name": "北京京东汽车有限公司",
                    "id": 207761,
                    "children": [{
                        "name": "深圳星巴克地摊控股集团",
                        "id": 207762
                    }, {
                        "name": "香港喜茶信息服务",
                        "id": 207763
                    }, {
                        "name": "南京欧珀汽车控股集团",
                        "id": 207764
                    }, {
                        "name": "台北欧珀证券",
                        "id": 207765
                    }, {
                        "name": "杭州肯德基智能",
                        "id": 207766
                    }, {
                        "name": "杭州喜茶科技有限公司",
                        "id": 207767
                    }, {
                        "name": "厦门小米汽车控股集团",
                        "id": 207768
                    }, {
                        "name": "北京微软医药有限公司",
                        "id": 207769
                    }, {
                        "name": "台北滴滴旅游控股集团",
                        "id": 207770
                    }, {
                        "name": "北京百度计算机有限公司",
                        "id": 207771
                    }, {
                        "name": "纽约字节通信控股集团",
                        "id": 207772
                    }, {
                        "name": "南京星巴克控股集团",
                        "id": 207773
                    }, {
                        "name": "深圳苹果制造有限公司",
                        "id": 207774
                    }, {
                        "name": "深圳京东通信",
                        "id": 207775
                    }, {
                        "name": "东莞肯德基地摊",
                        "id": 207776
                    }, {
                        "name": "杭州华为渔业",
                        "id": 207777
                    }, {
                        "name": "南京阿里电商",
                        "id": 207778
                    }, {
                        "name": "香港滴滴证券",
                        "id": 207779
                    }, {
                        "name": "香港华为芯片有限公司",
                        "id": 207780
                    }, {
                        "name": "杭州腾讯有限公司",
                        "id": 207781
                    }, {
                        "name": "东京腾讯餐饮",
                        "id": 207782
                    }, {
                        "name": "深圳平安旅游",
                        "id": 207783
                    }, {
                        "name": "首尔星巴克银行",
                        "id": 207784
                    }, {
                        "name": "东莞苹果农业控股集团",
                        "id": 207785
                    }, {
                        "name": "台北必胜客石油控股集团",
                        "id": 207786
                    }, {
                        "name": "广州快手地摊",
                        "id": 207787
                    }, {
                        "name": "杭州华为基金",
                        "id": 207788
                    }, {
                        "name": "杭州小米互金",
                        "id": 207789
                    }, {
                        "name": "首尔喜茶诊所",
                        "id": 207790
                    }, {
                        "name": "纽约蚂蚁农业",
                        "id": 207791
                    }, {
                        "name": "东京必胜客农业",
                        "id": 207792
                    }, {
                        "name": "纽约阿里科技",
                        "id": 207793
                    }, {
                        "name": "广州星巴克渔业",
                        "id": 207794
                    }, {
                        "name": "香港京东科技",
                        "id": 207795
                    }]
                }, {
                    "name": "北京奈雪智能",
                    "id": 207796
                }, {
                    "name": "香港奈雪互金",
                    "id": 207797,
                    "children": [{
                        "name": "上海滴滴通信",
                        "id": 207798
                    }, {
                        "name": "东京奈雪信息服务",
                        "id": 207799
                    }, {
                        "name": "杭州华为银行",
                        "id": 207800
                    }, {
                        "name": "台北百度芯片有限公司",
                        "id": 207801
                    }, {
                        "name": "广州百度智能",
                        "id": 207802
                    }, {
                        "name": "东京华为牧业",
                        "id": 207803
                    }, {
                        "name": "上海蚂蚁医药",
                        "id": 207804
                    }]
                }, {
                    "name": "杭州瑞幸养殖",
                    "id": 207805
                }, {
                    "name": "广州蚂蚁金融有限公司",
                    "id": 207806
                }, {
                    "name": "南京蚂蚁",
                    "id": 207807
                }, {
                    "name": "杭州腾讯诊所",
                    "id": 207808,
                    "children": [{
                        "name": "天津肯德基证券",
                        "id": 207809
                    }, {
                        "name": "上海亚马逊餐饮",
                        "id": 207810
                    }, {
                        "name": "厦门瑞幸信息服务",
                        "id": 207811
                    }, {
                        "name": "厦门肯德基新能源",
                        "id": 207812
                    }, {
                        "name": "首尔奈雪智能",
                        "id": 207813
                    }, {
                        "name": "广州苹果地摊",
                        "id": 207814
                    }, {
                        "name": "首尔星巴克基金控股集团",
                        "id": 207815
                    }, {
                        "name": "纽约平安通讯",
                        "id": 207816
                    }, {
                        "name": "上海谷歌电商控股集团",
                        "id": 207817
                    }, {
                        "name": "台北腾讯石油",
                        "id": 207818
                    }, {
                        "name": "杭州美团诊所",
                        "id": 207819
                    }, {
                        "name": "上海平安银行控股集团",
                        "id": 207820
                    }, {
                        "name": "南京滴滴通信",
                        "id": 207821
                    }, {
                        "name": "南京肯德基航空",
                        "id": 207822
                    }, {
                        "name": "南京蚂蚁",
                        "id": 207823
                    }, {
                        "name": "深圳欧珀渔业",
                        "id": 207824
                    }, {
                        "name": "东京谷歌农业",
                        "id": 207825
                    }]
                }, {
                    "name": "广州腾讯新能源有限公司",
                    "id": 207826
                }, {
                    "name": "厦门字节互金有限公司",
                    "id": 207827,
                    "children": [{
                        "name": "深圳特斯拉银行",
                        "id": 207828
                    }, {
                        "name": "东莞苹果信息服务",
                        "id": 207829
                    }, {
                        "name": "东京蚂蚁通信",
                        "id": 207830
                    }, {
                        "name": "北京阿里通信",
                        "id": 207831
                    }, {
                        "name": "深圳星巴克",
                        "id": 207832
                    }, {
                        "name": "天津必胜客信息服务",
                        "id": 207833
                    }, {
                        "name": "香港必胜客新能源控股集团",
                        "id": 207834
                    }, {
                        "name": "杭州美团医院",
                        "id": 207835
                    }, {
                        "name": "台北华为旅游控股集团",
                        "id": 207836
                    }, {
                        "name": "广州苹果证券",
                        "id": 207837
                    }, {
                        "name": "台北亚马逊信息服务控股集团",
                        "id": 207838
                    }, {
                        "name": "上海微软医院控股集团",
                        "id": 207839
                    }, {
                        "name": "北京平安芯片有限公司",
                        "id": 207840
                    }, {
                        "name": "上海欧珀地摊",
                        "id": 207841
                    }]
                }, {
                    "name": "台北欧珀通讯",
                    "id": 207842
                }, {
                    "name": "香港华为芯片",
                    "id": 207843,
                    "children": [{
                        "name": "东京京东石油控股集团",
                        "id": 207844
                    }, {
                        "name": "杭州美团航空有限公司",
                        "id": 207845
                    }, {
                        "name": "广州京东芯片控股集团",
                        "id": 207846
                    }, {
                        "name": "纽约特斯拉银行控股集团",
                        "id": 207847
                    }, {
                        "name": "纽约必胜客基金",
                        "id": 207848
                    }, {
                        "name": "上海平安地摊",
                        "id": 207849
                    }, {
                        "name": "杭州微软汽车",
                        "id": 207850
                    }, {
                        "name": "上海微软银行有限公司",
                        "id": 207851
                    }, {
                        "name": "杭州字节",
                        "id": 207852
                    }, {
                        "name": "上海星巴克制造控股集团",
                        "id": 207853
                    }, {
                        "name": "厦门必胜客石油",
                        "id": 207854
                    }, {
                        "name": "东莞苹果地产",
                        "id": 207855
                    }, {
                        "name": "香港阿里医院有限公司",
                        "id": 207856
                    }, {
                        "name": "东京欧珀诊所",
                        "id": 207857
                    }, {
                        "name": "东莞谷歌芯片",
                        "id": 207858
                    }, {
                        "name": "天津华为控股集团",
                        "id": 207859
                    }, {
                        "name": "厦门京东餐饮有限公司",
                        "id": 207860
                    }, {
                        "name": "台北阿里有限公司",
                        "id": 207861
                    }, {
                        "name": "香港平安智能",
                        "id": 207862
                    }, {
                        "name": "厦门瑞幸通信",
                        "id": 207863
                    }, {
                        "name": "东京蚂蚁通讯有限公司",
                        "id": 207864
                    }, {
                        "name": "北京微软诊所控股集团",
                        "id": 207865
                    }, {
                        "name": "杭州欧珀信息服务",
                        "id": 207866
                    }, {
                        "name": "台北百度银行",
                        "id": 207867
                    }, {
                        "name": "杭州苹果养殖",
                        "id": 207868
                    }]
                }, {
                    "name": "深圳必胜客软件控股集团",
                    "id": 207869,
                    "children": [{
                        "name": "南京微软",
                        "id": 207870
                    }, {
                        "name": "首尔阿里",
                        "id": 207871
                    }, {
                        "name": "深圳美团互金",
                        "id": 207872
                    }, {
                        "name": "厦门亚马逊餐饮",
                        "id": 207873
                    }, {
                        "name": "杭州亚马逊智能有限公司",
                        "id": 207874
                    }, {
                        "name": "厦门滴滴地摊",
                        "id": 207875
                    }, {
                        "name": "天津蚂蚁通信有限公司",
                        "id": 207876
                    }, {
                        "name": "广州美团餐饮",
                        "id": 207877
                    }, {
                        "name": "南京字节金融",
                        "id": 207878
                    }, {
                        "name": "香港华为",
                        "id": 207879
                    }, {
                        "name": "台北谷歌医药有限公司",
                        "id": 207880
                    }, {
                        "name": "东莞京东航空",
                        "id": 207881
                    }, {
                        "name": "杭州快手智能有限公司",
                        "id": 207882
                    }, {
                        "name": "深圳平安养殖",
                        "id": 207883
                    }, {
                        "name": "香港苹果智能",
                        "id": 207884
                    }]
                }, {
                    "name": "深圳苹果旅游",
                    "id": 207885,
                    "children": [{
                        "name": "首尔必胜客医院控股集团",
                        "id": 207886
                    }, {
                        "name": "天津阿里",
                        "id": 207887
                    }, {
                        "name": "广州欧珀汽车控股集团",
                        "id": 207888
                    }, {
                        "name": "香港必胜客信息服务",
                        "id": 207889
                    }, {
                        "name": "厦门蚂蚁金融",
                        "id": 207890
                    }, {
                        "name": "北京喜茶地摊",
                        "id": 207891
                    }, {
                        "name": "南京蚂蚁新能源",
                        "id": 207892
                    }, {
                        "name": "杭州喜茶",
                        "id": 207893
                    }, {
                        "name": "首尔奈雪软件",
                        "id": 207894
                    }, {
                        "name": "杭州阿里航空",
                        "id": 207895
                    }, {
                        "name": "厦门华为医药",
                        "id": 207896
                    }, {
                        "name": "上海星巴克旅游",
                        "id": 207897
                    }, {
                        "name": "深圳蚂蚁计算机",
                        "id": 207898
                    }, {
                        "name": "南京腾讯地产",
                        "id": 207899
                    }, {
                        "name": "厦门京东通讯",
                        "id": 207900
                    }, {
                        "name": "杭州字节牧业控股集团",
                        "id": 207901
                    }, {
                        "name": "杭州平安金融",
                        "id": 207902
                    }, {
                        "name": "香港奈雪新能源控股集团",
                        "id": 207903
                    }, {
                        "name": "天津小米养殖",
                        "id": 207904
                    }, {
                        "name": "纽约字节通信控股集团",
                        "id": 207905
                    }, {
                        "name": "杭州欧珀智能有限公司",
                        "id": 207906
                    }, {
                        "name": "首尔谷歌计算机",
                        "id": 207907
                    }, {
                        "name": "天津华为制造有限公司",
                        "id": 207908
                    }]
                }, {
                    "name": "厦门美团互金有限公司",
                    "id": 207909
                }, {
                    "name": "东莞百度通讯",
                    "id": 207910
                }, {
                    "name": "台北蚂蚁养殖",
                    "id": 207911
                }, {
                    "name": "北京腾讯智能",
                    "id": 207912
                }, {
                    "name": "香港美团互金",
                    "id": 207913
                }]
            }, {
                "name": "纽约百度航空有限公司",
                "id": 207914
            }, {
                "name": "东莞特斯拉制造",
                "id": 207915
            }, {
                "name": "天津欧珀",
                "id": 207916
            }, {
                "name": "深圳字节",
                "id": 207917,
                "children": [{
                    "name": "厦门奈雪医院",
                    "id": 207918,
                    "children": [{
                        "name": "厦门滴滴智能",
                        "id": 207919
                    }, {
                        "name": "厦门必胜客医药",
                        "id": 207920
                    }, {
                        "name": "东莞苹果牧业有限公司",
                        "id": 207921
                    }, {
                        "name": "杭州京东地产",
                        "id": 207922
                    }, {
                        "name": "深圳亚马逊智能",
                        "id": 207923
                    }, {
                        "name": "天津小米旅游",
                        "id": 207924
                    }, {
                        "name": "台北平安",
                        "id": 207925
                    }, {
                        "name": "纽约喜茶有限公司",
                        "id": 207926
                    }, {
                        "name": "东京特斯拉智能控股集团",
                        "id": 207927
                    }, {
                        "name": "首尔喜茶",
                        "id": 207928
                    }, {
                        "name": "广州肯德基渔业控股集团",
                        "id": 207929
                    }, {
                        "name": "上海奈雪通信",
                        "id": 207930
                    }, {
                        "name": "杭州小米医药",
                        "id": 207931
                    }, {
                        "name": "纽约瑞幸电商",
                        "id": 207932
                    }, {
                        "name": "杭州星巴克互金",
                        "id": 207933
                    }, {
                        "name": "天津百度地产",
                        "id": 207934
                    }, {
                        "name": "广州谷歌地产有限公司",
                        "id": 207935
                    }, {
                        "name": "台北喜茶诊所",
                        "id": 207936
                    }, {
                        "name": "上海欧珀餐饮",
                        "id": 207937
                    }, {
                        "name": "厦门瑞幸地摊",
                        "id": 207938
                    }, {
                        "name": "北京华为地产",
                        "id": 207939
                    }]
                }, {
                    "name": "纽约肯德基信息服务",
                    "id": 207940
                }, {
                    "name": "厦门微软信息服务控股集团",
                    "id": 207941
                }, {
                    "name": "杭州百度通信",
                    "id": 207942
                }, {
                    "name": "杭州百度金融",
                    "id": 207943
                }, {
                    "name": "广州星巴克养殖",
                    "id": 207944
                }, {
                    "name": "广州瑞幸基金",
                    "id": 207945
                }, {
                    "name": "北京星巴克通信",
                    "id": 207946
                }, {
                    "name": "东京百度地产有限公司",
                    "id": 207947
                }, {
                    "name": "杭州奈雪牧业有限公司",
                    "id": 207948
                }, {
                    "name": "深圳特斯拉渔业有限公司",
                    "id": 207949
                }, {
                    "name": "上海特斯拉信息服务",
                    "id": 207950,
                    "children": [{
                        "name": "广州百度汽车",
                        "id": 207951
                    }, {
                        "name": "台北微软养殖",
                        "id": 207952
                    }, {
                        "name": "杭州华为医药控股集团",
                        "id": 207953
                    }, {
                        "name": "纽约欧珀通信",
                        "id": 207954
                    }, {
                        "name": "厦门欧珀养殖有限公司",
                        "id": 207955
                    }, {
                        "name": "东莞亚马逊银行",
                        "id": 207956
                    }, {
                        "name": "北京平安牧业",
                        "id": 207957
                    }, {
                        "name": "南京蚂蚁金融有限公司",
                        "id": 207958
                    }, {
                        "name": "上海必胜客制造有限公司",
                        "id": 207959
                    }, {
                        "name": "北京奈雪农业",
                        "id": 207960
                    }, {
                        "name": "杭州华为芯片控股集团",
                        "id": 207961
                    }, {
                        "name": "纽约苹果旅游",
                        "id": 207962
                    }, {
                        "name": "纽约百度计算机",
                        "id": 207963
                    }, {
                        "name": "北京星巴克科技",
                        "id": 207964
                    }, {
                        "name": "天津蚂蚁通信",
                        "id": 207965
                    }, {
                        "name": "香港欧珀石油",
                        "id": 207966
                    }, {
                        "name": "纽约特斯拉渔业",
                        "id": 207967
                    }, {
                        "name": "杭州平安医药有限公司",
                        "id": 207968
                    }, {
                        "name": "天津必胜客信息服务",
                        "id": 207969
                    }, {
                        "name": "厦门苹果金融控股集团",
                        "id": 207970
                    }, {
                        "name": "香港微软农业",
                        "id": 207971
                    }, {
                        "name": "天津瑞幸金融",
                        "id": 207972
                    }, {
                        "name": "东莞小米汽车有限公司",
                        "id": 207973
                    }, {
                        "name": "杭州小米银行有限公司",
                        "id": 207974
                    }, {
                        "name": "台北平安制造",
                        "id": 207975
                    }]
                }, {
                    "name": "杭州平安软件",
                    "id": 207976
                }, {
                    "name": "杭州微软科技",
                    "id": 207977
                }, {
                    "name": "东京美团证券控股集团",
                    "id": 207978
                }, {
                    "name": "北京美团医药",
                    "id": 207979
                }, {
                    "name": "东莞滴滴新能源",
                    "id": 207980
                }, {
                    "name": "广州蚂蚁",
                    "id": 207981
                }, {
                    "name": "南京华为",
                    "id": 207982
                }, {
                    "name": "厦门蚂蚁制造",
                    "id": 207983
                }, {
                    "name": "东莞腾讯航空",
                    "id": 207984
                }, {
                    "name": "杭州滴滴软件",
                    "id": 207985
                }, {
                    "name": "南京京东软件控股集团",
                    "id": 207986,
                    "children": [{
                        "name": "台北小米",
                        "id": 207987
                    }, {
                        "name": "东京奈雪科技",
                        "id": 207988
                    }, {
                        "name": "纽约欧珀通信",
                        "id": 207989
                    }, {
                        "name": "厦门谷歌科技",
                        "id": 207990
                    }, {
                        "name": "厦门苹果地摊控股集团",
                        "id": 207991
                    }, {
                        "name": "深圳阿里地产有限公司",
                        "id": 207992
                    }, {
                        "name": "厦门平安新能源",
                        "id": 207993
                    }, {
                        "name": "北京滴滴餐饮",
                        "id": 207994
                    }, {
                        "name": "杭州肯德基互金有限公司",
                        "id": 207995
                    }, {
                        "name": "台北百度通讯有限公司",
                        "id": 207996
                    }, {
                        "name": "台北美团养殖有限公司",
                        "id": 207997
                    }, {
                        "name": "台北肯德基计算机",
                        "id": 207998
                    }, {
                        "name": "杭州小米互金",
                        "id": 207999
                    }, {
                        "name": "南京字节有限公司",
                        "id": 208000
                    }, {
                        "name": "台北美团农业",
                        "id": 208001
                    }, {
                        "name": "南京特斯拉基金",
                        "id": 208002
                    }, {
                        "name": "北京字节医药",
                        "id": 208003
                    }, {
                        "name": "东莞腾讯互金",
                        "id": 208004
                    }, {
                        "name": "杭州微软计算机有限公司",
                        "id": 208005
                    }, {
                        "name": "香港字节餐饮",
                        "id": 208006
                    }, {
                        "name": "上海特斯拉地摊",
                        "id": 208007
                    }, {
                        "name": "台北京东信息服务",
                        "id": 208008
                    }, {
                        "name": "纽约腾讯银行",
                        "id": 208009
                    }, {
                        "name": "南京字节制造",
                        "id": 208010
                    }, {
                        "name": "广州滴滴基金",
                        "id": 208011
                    }, {
                        "name": "天津必胜客科技",
                        "id": 208012
                    }, {
                        "name": "上海谷歌农业有限公司",
                        "id": 208013
                    }, {
                        "name": "深圳必胜客软件控股集团",
                        "id": 208014
                    }, {
                        "name": "东莞华为银行",
                        "id": 208015
                    }, {
                        "name": "杭州阿里餐饮",
                        "id": 208016
                    }, {
                        "name": "杭州苹果新能源控股集团",
                        "id": 208017
                    }, {
                        "name": "南京微软航空有限公司",
                        "id": 208018
                    }, {
                        "name": "北京滴滴新能源控股集团",
                        "id": 208019
                    }, {
                        "name": "首尔奈雪金融控股集团",
                        "id": 208020
                    }, {
                        "name": "东莞腾讯基金控股集团",
                        "id": 208021
                    }]
                }, {
                    "name": "厦门蚂蚁诊所",
                    "id": 208022
                }, {
                    "name": "天津亚马逊计算机",
                    "id": 208023
                }, {
                    "name": "厦门快手计算机",
                    "id": 208024
                }, {
                    "name": "杭州星巴克互金",
                    "id": 208025
                }]
            }, {
                "name": "上海腾讯控股集团",
                "id": 208026
            }, {
                "name": "广州谷歌航空",
                "id": 208027
            }, {
                "name": "香港微软农业有限公司",
                "id": 208028,
                "children": [{
                    "name": "上海百度地产",
                    "id": 208029
                }, {
                    "name": "东莞谷歌芯片",
                    "id": 208030
                }, {
                    "name": "杭州字节",
                    "id": 208031
                }, {
                    "name": "广州奈雪控股集团",
                    "id": 208032,
                    "children": [{
                        "name": "深圳快手养殖",
                        "id": 208033
                    }, {
                        "name": "上海微软电商",
                        "id": 208034
                    }]
                }, {
                    "name": "深圳字节制造",
                    "id": 208035
                }, {
                    "name": "香港腾讯通讯控股集团",
                    "id": 208036
                }, {
                    "name": "天津奈雪通讯",
                    "id": 208037
                }, {
                    "name": "纽约肯德基汽车",
                    "id": 208038
                }, {
                    "name": "天津滴滴农业",
                    "id": 208039
                }, {
                    "name": "厦门谷歌软件",
                    "id": 208040,
                    "children": [{
                        "name": "纽约苹果石油",
                        "id": 208041
                    }, {
                        "name": "上海特斯拉诊所",
                        "id": 208042
                    }, {
                        "name": "东莞瑞幸",
                        "id": 208043
                    }, {
                        "name": "天津喜茶证券",
                        "id": 208044
                    }, {
                        "name": "杭州蚂蚁通信控股集团",
                        "id": 208045
                    }, {
                        "name": "南京必胜客银行有限公司",
                        "id": 208046
                    }, {
                        "name": "东京喜茶养殖有限公司",
                        "id": 208047
                    }, {
                        "name": "厦门肯德基汽车控股集团",
                        "id": 208048
                    }, {
                        "name": "深圳滴滴软件有限公司",
                        "id": 208049
                    }, {
                        "name": "深圳欧珀电商",
                        "id": 208050
                    }, {
                        "name": "南京平安基金控股集团",
                        "id": 208051
                    }, {
                        "name": "东莞肯德基互金",
                        "id": 208052
                    }, {
                        "name": "香港字节制造",
                        "id": 208053
                    }, {
                        "name": "广州谷歌软件",
                        "id": 208054
                    }, {
                        "name": "深圳京东软件",
                        "id": 208055
                    }, {
                        "name": "台北苹果新能源",
                        "id": 208056
                    }, {
                        "name": "杭州滴滴芯片有限公司",
                        "id": 208057
                    }, {
                        "name": "北京小米通信",
                        "id": 208058
                    }, {
                        "name": "东京星巴克通讯有限公司",
                        "id": 208059
                    }, {
                        "name": "上海欧珀计算机控股集团",
                        "id": 208060
                    }]
                }, {
                    "name": "杭州瑞幸",
                    "id": 208061,
                    "children": [{
                        "name": "香港华为证券",
                        "id": 208062
                    }, {
                        "name": "东莞百度地摊有限公司",
                        "id": 208063
                    }, {
                        "name": "香港谷歌航空",
                        "id": 208064
                    }, {
                        "name": "天津瑞幸医院",
                        "id": 208065
                    }, {
                        "name": "东京小米汽车有限公司",
                        "id": 208066
                    }, {
                        "name": "纽约平安新能源",
                        "id": 208067
                    }, {
                        "name": "天津奈雪养殖",
                        "id": 208068
                    }, {
                        "name": "东莞华为渔业控股集团",
                        "id": 208069
                    }, {
                        "name": "天津奈雪电商",
                        "id": 208070
                    }, {
                        "name": "广州阿里",
                        "id": 208071
                    }, {
                        "name": "东京喜茶通讯控股集团",
                        "id": 208072
                    }, {
                        "name": "北京腾讯养殖",
                        "id": 208073
                    }, {
                        "name": "纽约星巴克智能控股集团",
                        "id": 208074
                    }, {
                        "name": "广州阿里软件控股集团",
                        "id": 208075
                    }, {
                        "name": "天津亚马逊电商",
                        "id": 208076
                    }, {
                        "name": "首尔苹果地产",
                        "id": 208077
                    }, {
                        "name": "杭州瑞幸地摊",
                        "id": 208078
                    }, {
                        "name": "台北喜茶智能",
                        "id": 208079
                    }, {
                        "name": "东莞星巴克金融",
                        "id": 208080
                    }, {
                        "name": "纽约星巴克信息服务",
                        "id": 208081
                    }, {
                        "name": "广州滴滴牧业控股集团",
                        "id": 208082
                    }, {
                        "name": "厦门必胜客石油",
                        "id": 208083
                    }, {
                        "name": "香港谷歌汽车",
                        "id": 208084
                    }, {
                        "name": "杭州百度航空控股集团",
                        "id": 208085
                    }, {
                        "name": "杭州特斯拉证券",
                        "id": 208086
                    }, {
                        "name": "首尔必胜客牧业控股集团",
                        "id": 208087
                    }, {
                        "name": "厦门腾讯证券",
                        "id": 208088
                    }, {
                        "name": "杭州阿里医院有限公司",
                        "id": 208089
                    }, {
                        "name": "台北腾讯农业控股集团",
                        "id": 208090
                    }, {
                        "name": "天津亚马逊计算机",
                        "id": 208091
                    }, {
                        "name": "广州快手制造",
                        "id": 208092
                    }, {
                        "name": "台北苹果石油",
                        "id": 208093
                    }]
                }, {
                    "name": "广州京东电商有限公司",
                    "id": 208094
                }, {
                    "name": "北京特斯拉通讯",
                    "id": 208095,
                    "children": [{
                        "name": "南京谷歌养殖有限公司",
                        "id": 208096
                    }, {
                        "name": "南京腾讯医院有限公司",
                        "id": 208097
                    }, {
                        "name": "杭州喜茶通信",
                        "id": 208098
                    }, {
                        "name": "台北喜茶航空",
                        "id": 208099
                    }, {
                        "name": "首尔微软计算机控股集团",
                        "id": 208100
                    }, {
                        "name": "台北肯德基信息服务",
                        "id": 208101
                    }, {
                        "name": "香港奈雪有限公司",
                        "id": 208102
                    }, {
                        "name": "首尔美团航空",
                        "id": 208103
                    }, {
                        "name": "天津欧珀软件控股集团",
                        "id": 208104
                    }, {
                        "name": "首尔喜茶牧业",
                        "id": 208105
                    }, {
                        "name": "北京美团新能源",
                        "id": 208106
                    }, {
                        "name": "深圳奈雪计算机",
                        "id": 208107
                    }, {
                        "name": "厦门奈雪地摊",
                        "id": 208108
                    }, {
                        "name": "杭州肯德基银行",
                        "id": 208109
                    }]
                }, {
                    "name": "杭州肯德基牧业",
                    "id": 208110
                }, {
                    "name": "纽约喜茶信息服务",
                    "id": 208111
                }, {
                    "name": "南京微软互金",
                    "id": 208112
                }, {
                    "name": "东莞小米医药有限公司",
                    "id": 208113
                }, {
                    "name": "广州小米通信",
                    "id": 208114
                }, {
                    "name": "厦门瑞幸计算机",
                    "id": 208115,
                    "children": [{
                        "name": "东京奈雪科技",
                        "id": 208116
                    }, {
                        "name": "广州肯德基互金控股集团",
                        "id": 208117
                    }, {
                        "name": "天津欧珀芯片有限公司",
                        "id": 208118
                    }, {
                        "name": "香港腾讯信息服务",
                        "id": 208119
                    }, {
                        "name": "纽约华为软件",
                        "id": 208120
                    }, {
                        "name": "北京特斯拉智能",
                        "id": 208121
                    }, {
                        "name": "厦门特斯拉智能",
                        "id": 208122
                    }, {
                        "name": "东京美团通信",
                        "id": 208123
                    }, {
                        "name": "台北百度石油控股集团",
                        "id": 208124
                    }, {
                        "name": "香港微软餐饮有限公司",
                        "id": 208125
                    }, {
                        "name": "纽约滴滴智能控股集团",
                        "id": 208126
                    }]
                }, {
                    "name": "首尔肯德基制造",
                    "id": 208127,
                    "children": [{
                        "name": "天津喜茶金融",
                        "id": 208128
                    }, {
                        "name": "深圳微软控股集团",
                        "id": 208129
                    }, {
                        "name": "香港奈雪证券",
                        "id": 208130
                    }, {
                        "name": "东京华为旅游",
                        "id": 208131
                    }, {
                        "name": "杭州字节计算机",
                        "id": 208132
                    }, {
                        "name": "东京百度石油",
                        "id": 208133
                    }, {
                        "name": "南京滴滴汽车",
                        "id": 208134
                    }, {
                        "name": "杭州百度科技",
                        "id": 208135
                    }, {
                        "name": "东京腾讯制造控股集团",
                        "id": 208136
                    }, {
                        "name": "深圳字节诊所",
                        "id": 208137
                    }, {
                        "name": "杭州京东控股集团",
                        "id": 208138
                    }]
                }, {
                    "name": "广州小米智能控股集团",
                    "id": 208139
                }, {
                    "name": "广州字节诊所",
                    "id": 208140
                }, {
                    "name": "台北腾讯农业控股集团",
                    "id": 208141
                }, {
                    "name": "杭州必胜客航空",
                    "id": 208142
                }, {
                    "name": "香港腾讯餐饮有限公司",
                    "id": 208143
                }]
            }, {
                "name": "广州奈雪智能控股集团",
                "id": 208144,
                "children": [{
                    "name": "南京阿里诊所",
                    "id": 208145,
                    "children": [{
                        "name": "杭州华为新能源",
                        "id": 208146
                    }, {
                        "name": "厦门小米医药",
                        "id": 208147
                    }, {
                        "name": "东京滴滴旅游控股集团",
                        "id": 208148
                    }, {
                        "name": "厦门谷歌诊所",
                        "id": 208149
                    }, {
                        "name": "杭州苹果银行",
                        "id": 208150
                    }, {
                        "name": "厦门百度航空有限公司",
                        "id": 208151
                    }, {
                        "name": "厦门快手航空有限公司",
                        "id": 208152
                    }, {
                        "name": "杭州特斯拉电商控股集团",
                        "id": 208153
                    }, {
                        "name": "深圳字节制造控股集团",
                        "id": 208154
                    }, {
                        "name": "东京亚马逊互金有限公司",
                        "id": 208155
                    }, {
                        "name": "杭州滴滴石油",
                        "id": 208156
                    }, {
                        "name": "东京谷歌地摊",
                        "id": 208157
                    }, {
                        "name": "天津特斯拉有限公司",
                        "id": 208158
                    }, {
                        "name": "杭州必胜客农业",
                        "id": 208159
                    }, {
                        "name": "东京必胜客医药控股集团",
                        "id": 208160
                    }, {
                        "name": "纽约瑞幸餐饮",
                        "id": 208161
                    }, {
                        "name": "天津美团科技有限公司",
                        "id": 208162
                    }, {
                        "name": "厦门特斯拉医院",
                        "id": 208163
                    }, {
                        "name": "北京微软智能有限公司",
                        "id": 208164
                    }, {
                        "name": "东京奈雪电商",
                        "id": 208165
                    }, {
                        "name": "杭州必胜客新能源控股集团",
                        "id": 208166
                    }]
                }, {
                    "name": "东莞腾讯医药",
                    "id": 208167
                }, {
                    "name": "东莞微软石油有限公司",
                    "id": 208168
                }, {
                    "name": "南京蚂蚁地摊控股集团",
                    "id": 208169
                }, {
                    "name": "北京腾讯制造有限公司",
                    "id": 208170,
                    "children": [{
                        "name": "厦门小米互金",
                        "id": 208171
                    }, {
                        "name": "广州蚂蚁农业",
                        "id": 208172
                    }, {
                        "name": "深圳滴滴旅游",
                        "id": 208173
                    }, {
                        "name": "杭州苹果计算机控股集团",
                        "id": 208174
                    }, {
                        "name": "首尔京东",
                        "id": 208175
                    }, {
                        "name": "厦门平安金融有限公司",
                        "id": 208176
                    }, {
                        "name": "杭州腾讯科技",
                        "id": 208177
                    }, {
                        "name": "首尔谷歌芯片控股集团",
                        "id": 208178
                    }, {
                        "name": "广州星巴克银行",
                        "id": 208179
                    }, {
                        "name": "台北百度航空",
                        "id": 208180
                    }, {
                        "name": "北京苹果汽车控股集团",
                        "id": 208181
                    }, {
                        "name": "东京快手智能",
                        "id": 208182
                    }, {
                        "name": "北京微软",
                        "id": 208183
                    }, {
                        "name": "上海微软餐饮",
                        "id": 208184
                    }, {
                        "name": "天津小米计算机",
                        "id": 208185
                    }, {
                        "name": "东京阿里智能有限公司",
                        "id": 208186
                    }, {
                        "name": "香港苹果旅游有限公司",
                        "id": 208187
                    }, {
                        "name": "南京蚂蚁通信",
                        "id": 208188
                    }, {
                        "name": "北京快手养殖有限公司",
                        "id": 208189
                    }, {
                        "name": "厦门小米石油",
                        "id": 208190
                    }, {
                        "name": "深圳滴滴信息服务",
                        "id": 208191
                    }, {
                        "name": "杭州腾讯科技",
                        "id": 208192
                    }, {
                        "name": "北京美团",
                        "id": 208193
                    }, {
                        "name": "天津谷歌养殖",
                        "id": 208194
                    }, {
                        "name": "厦门小米",
                        "id": 208195
                    }, {
                        "name": "东莞星巴克",
                        "id": 208196
                    }, {
                        "name": "东京平安诊所",
                        "id": 208197
                    }, {
                        "name": "天津蚂蚁银行",
                        "id": 208198
                    }, {
                        "name": "南京阿里银行",
                        "id": 208199
                    }, {
                        "name": "杭州必胜客汽车控股集团",
                        "id": 208200
                    }, {
                        "name": "杭州苹果渔业有限公司",
                        "id": 208201
                    }, {
                        "name": "天津星巴克农业有限公司",
                        "id": 208202
                    }, {
                        "name": "广州滴滴牧业控股集团",
                        "id": 208203
                    }, {
                        "name": "南京平安医药",
                        "id": 208204
                    }, {
                        "name": "首尔星巴克金融",
                        "id": 208205
                    }, {
                        "name": "杭州肯德基芯片",
                        "id": 208206
                    }]
                }, {
                    "name": "首尔欧珀智能",
                    "id": 208207
                }, {
                    "name": "东京阿里智能控股集团",
                    "id": 208208,
                    "children": [{
                        "name": "香港小米医药",
                        "id": 208209
                    }, {
                        "name": "杭州特斯拉养殖",
                        "id": 208210
                    }, {
                        "name": "厦门华为养殖",
                        "id": 208211
                    }, {
                        "name": "深圳欧珀地产",
                        "id": 208212
                    }, {
                        "name": "首尔欧珀诊所控股集团",
                        "id": 208213
                    }, {
                        "name": "北京腾讯通信",
                        "id": 208214
                    }, {
                        "name": "广州京东通讯",
                        "id": 208215
                    }, {
                        "name": "深圳谷歌互金",
                        "id": 208216
                    }, {
                        "name": "广州谷歌牧业",
                        "id": 208217
                    }, {
                        "name": "杭州小米",
                        "id": 208218
                    }]
                }, {
                    "name": "广州腾讯电商控股集团",
                    "id": 208219
                }, {
                    "name": "杭州快手餐饮",
                    "id": 208220
                }, {
                    "name": "深圳美团医院",
                    "id": 208221
                }, {
                    "name": "天津亚马逊银行控股集团",
                    "id": 208222
                }, {
                    "name": "首尔阿里",
                    "id": 208223
                }]
            }, {
                "name": "纽约必胜客互金",
                "id": 208224
            }, {
                "name": "香港亚马逊诊所",
                "id": 208225
            }, {
                "name": "上海小米信息服务",
                "id": 208226
            }]
        }, {
            "name": "杭州星巴克通讯",
            "id": 208227
        }, {
            "name": "纽约瑞幸通讯控股集团",
            "id": 208228
        }, {
            "name": "上海百度互金",
            "id": 208229
        }, {
            "name": "厦门欧珀通讯",
            "id": 208230
        }, {
            "name": "杭州必胜客诊所",
            "id": 208231,
            "children": [{
                "name": "杭州滴滴电商有限公司",
                "id": 208232
            }, {
                "name": "厦门阿里互金",
                "id": 208233
            }, {
                "name": "香港腾讯养殖控股集团",
                "id": 208234
            }, {
                "name": "杭州华为石油控股集团",
                "id": 208235
            }, {
                "name": "深圳欧珀汽车",
                "id": 208236
            }, {
                "name": "南京滴滴诊所",
                "id": 208237
            }, {
                "name": "杭州华为牧业",
                "id": 208238
            }, {
                "name": "厦门瑞幸农业有限公司",
                "id": 208239
            }, {
                "name": "纽约亚马逊养殖",
                "id": 208240
            }, {
                "name": "上海小米芯片",
                "id": 208241
            }, {
                "name": "南京滴滴芯片有限公司",
                "id": 208242
            }, {
                "name": "首尔星巴克银行",
                "id": 208243,
                "children": [{
                    "name": "深圳瑞幸智能控股集团",
                    "id": 208244
                }, {
                    "name": "北京奈雪通讯",
                    "id": 208245,
                    "children": [{
                        "name": "广州瑞幸石油",
                        "id": 208246
                    }, {
                        "name": "厦门阿里制造控股集团",
                        "id": 208247
                    }, {
                        "name": "杭州华为诊所有限公司",
                        "id": 208248
                    }, {
                        "name": "东京阿里农业",
                        "id": 208249
                    }, {
                        "name": "东京京东智能",
                        "id": 208250
                    }, {
                        "name": "深圳星巴克新能源",
                        "id": 208251
                    }, {
                        "name": "深圳亚马逊互金",
                        "id": 208252
                    }, {
                        "name": "香港特斯拉信息服务有限公司",
                        "id": 208253
                    }, {
                        "name": "杭州瑞幸养殖控股集团",
                        "id": 208254
                    }]
                }, {
                    "name": "东京美团旅游",
                    "id": 208255
                }, {
                    "name": "杭州星巴克餐饮控股集团",
                    "id": 208256
                }, {
                    "name": "杭州小米地产",
                    "id": 208257
                }, {
                    "name": "首尔阿里石油有限公司",
                    "id": 208258
                }, {
                    "name": "上海奈雪互金控股集团",
                    "id": 208259
                }, {
                    "name": "杭州肯德基农业有限公司",
                    "id": 208260,
                    "children": [{
                        "name": "香港苹果餐饮",
                        "id": 208261
                    }, {
                        "name": "香港华为农业",
                        "id": 208262
                    }, {
                        "name": "香港瑞幸诊所",
                        "id": 208263
                    }, {
                        "name": "东京小米银行",
                        "id": 208264
                    }, {
                        "name": "杭州瑞幸电商有限公司",
                        "id": 208265
                    }, {
                        "name": "东京谷歌金融",
                        "id": 208266
                    }, {
                        "name": "南京阿里证券",
                        "id": 208267
                    }, {
                        "name": "广州奈雪制造控股集团",
                        "id": 208268
                    }, {
                        "name": "杭州字节养殖",
                        "id": 208269
                    }, {
                        "name": "杭州星巴克",
                        "id": 208270
                    }, {
                        "name": "纽约微软基金",
                        "id": 208271
                    }, {
                        "name": "厦门蚂蚁新能源",
                        "id": 208272
                    }, {
                        "name": "杭州滴滴",
                        "id": 208273
                    }, {
                        "name": "首尔腾讯有限公司",
                        "id": 208274
                    }, {
                        "name": "北京小米智能",
                        "id": 208275
                    }, {
                        "name": "广州奈雪渔业控股集团",
                        "id": 208276
                    }, {
                        "name": "北京微软信息服务",
                        "id": 208277
                    }, {
                        "name": "首尔喜茶证券有限公司",
                        "id": 208278
                    }, {
                        "name": "厦门亚马逊电商",
                        "id": 208279
                    }, {
                        "name": "上海瑞幸医院",
                        "id": 208280
                    }, {
                        "name": "广州百度",
                        "id": 208281
                    }, {
                        "name": "北京苹果",
                        "id": 208282
                    }, {
                        "name": "南京喜茶渔业有限公司",
                        "id": 208283
                    }, {
                        "name": "台北谷歌医药控股集团",
                        "id": 208284
                    }, {
                        "name": "广州小米科技",
                        "id": 208285
                    }, {
                        "name": "南京奈雪农业",
                        "id": 208286
                    }, {
                        "name": "东莞美团证券控股集团",
                        "id": 208287
                    }, {
                        "name": "香港百度餐饮",
                        "id": 208288
                    }, {
                        "name": "上海京东地产有限公司",
                        "id": 208289
                    }, {
                        "name": "南京肯德基计算机",
                        "id": 208290
                    }, {
                        "name": "北京滴滴基金",
                        "id": 208291
                    }, {
                        "name": "深圳美团计算机有限公司",
                        "id": 208292
                    }]
                }, {
                    "name": "深圳特斯拉牧业有限公司",
                    "id": 208293
                }, {
                    "name": "首尔腾讯医药控股集团",
                    "id": 208294
                }, {
                    "name": "天津阿里制造",
                    "id": 208295
                }, {
                    "name": "东莞阿里渔业",
                    "id": 208296,
                    "children": [{
                        "name": "广州特斯拉计算机有限公司",
                        "id": 208297
                    }, {
                        "name": "东莞美团通信",
                        "id": 208298
                    }, {
                        "name": "香港谷歌医院",
                        "id": 208299
                    }, {
                        "name": "上海亚马逊金融",
                        "id": 208300
                    }]
                }, {
                    "name": "上海蚂蚁诊所",
                    "id": 208301
                }, {
                    "name": "香港腾讯互金有限公司",
                    "id": 208302
                }, {
                    "name": "深圳欧珀诊所",
                    "id": 208303
                }, {
                    "name": "东莞星巴克证券",
                    "id": 208304
                }, {
                    "name": "台北蚂蚁养殖",
                    "id": 208305
                }, {
                    "name": "首尔字节",
                    "id": 208306
                }, {
                    "name": "杭州喜茶",
                    "id": 208307
                }, {
                    "name": "广州肯德基银行",
                    "id": 208308
                }, {
                    "name": "杭州瑞幸牧业控股集团",
                    "id": 208309
                }, {
                    "name": "杭州谷歌互金",
                    "id": 208310,
                    "children": [{
                        "name": "台北奈雪医药",
                        "id": 208311
                    }, {
                        "name": "广州特斯拉通讯",
                        "id": 208312
                    }, {
                        "name": "香港字节芯片",
                        "id": 208313
                    }, {
                        "name": "首尔华为航空控股集团",
                        "id": 208314
                    }, {
                        "name": "纽约亚马逊新能源控股集团",
                        "id": 208315
                    }, {
                        "name": "深圳星巴克互金有限公司",
                        "id": 208316
                    }, {
                        "name": "东莞小米地摊",
                        "id": 208317
                    }, {
                        "name": "东莞苹果科技",
                        "id": 208318
                    }, {
                        "name": "杭州欧珀电商",
                        "id": 208319
                    }, {
                        "name": "南京字节养殖",
                        "id": 208320
                    }, {
                        "name": "香港腾讯地产",
                        "id": 208321
                    }, {
                        "name": "上海瑞幸电商",
                        "id": 208322
                    }, {
                        "name": "首尔必胜客控股集团",
                        "id": 208323
                    }, {
                        "name": "深圳快手证券",
                        "id": 208324
                    }, {
                        "name": "天津快手养殖",
                        "id": 208325
                    }, {
                        "name": "厦门美团智能",
                        "id": 208326
                    }, {
                        "name": "东莞奈雪软件",
                        "id": 208327
                    }, {
                        "name": "天津快手",
                        "id": 208328
                    }, {
                        "name": "上海小米石油",
                        "id": 208329
                    }, {
                        "name": "天津腾讯互金有限公司",
                        "id": 208330
                    }, {
                        "name": "纽约亚马逊互金",
                        "id": 208331
                    }, {
                        "name": "纽约京东",
                        "id": 208332
                    }, {
                        "name": "南京亚马逊渔业",
                        "id": 208333
                    }, {
                        "name": "深圳蚂蚁",
                        "id": 208334
                    }, {
                        "name": "厦门必胜客地产",
                        "id": 208335
                    }, {
                        "name": "纽约字节旅游",
                        "id": 208336
                    }, {
                        "name": "深圳华为制造",
                        "id": 208337
                    }, {
                        "name": "东莞腾讯诊所",
                        "id": 208338
                    }, {
                        "name": "纽约小米金融",
                        "id": 208339
                    }, {
                        "name": "杭州腾讯基金",
                        "id": 208340
                    }]
                }, {
                    "name": "香港苹果牧业",
                    "id": 208341
                }, {
                    "name": "厦门谷歌餐饮有限公司",
                    "id": 208342,
                    "children": [{
                        "name": "首尔蚂蚁石油",
                        "id": 208343
                    }, {
                        "name": "东京星巴克电商",
                        "id": 208344
                    }, {
                        "name": "东莞瑞幸旅游控股集团",
                        "id": 208345
                    }, {
                        "name": "南京苹果银行",
                        "id": 208346
                    }, {
                        "name": "杭州星巴克通信",
                        "id": 208347
                    }, {
                        "name": "上海苹果互金",
                        "id": 208348
                    }, {
                        "name": "杭州滴滴金融有限公司",
                        "id": 208349
                    }, {
                        "name": "上海必胜客通信",
                        "id": 208350
                    }, {
                        "name": "东京星巴克地摊",
                        "id": 208351
                    }, {
                        "name": "首尔欧珀银行",
                        "id": 208352
                    }, {
                        "name": "深圳谷歌基金",
                        "id": 208353
                    }, {
                        "name": "台北平安地摊控股集团",
                        "id": 208354
                    }, {
                        "name": "北京微软科技有限公司",
                        "id": 208355
                    }, {
                        "name": "香港滴滴信息服务控股集团",
                        "id": 208356
                    }, {
                        "name": "深圳肯德基农业控股集团",
                        "id": 208357
                    }, {
                        "name": "东莞苹果软件",
                        "id": 208358
                    }, {
                        "name": "北京蚂蚁软件",
                        "id": 208359
                    }, {
                        "name": "厦门肯德基制造",
                        "id": 208360
                    }, {
                        "name": "北京字节地摊有限公司",
                        "id": 208361
                    }, {
                        "name": "东京华为医药控股集团",
                        "id": 208362
                    }, {
                        "name": "深圳字节农业",
                        "id": 208363
                    }, {
                        "name": "纽约京东金融有限公司",
                        "id": 208364
                    }]
                }, {
                    "name": "杭州奈雪电商",
                    "id": 208365
                }, {
                    "name": "厦门苹果医院",
                    "id": 208366
                }, {
                    "name": "东京喜茶软件",
                    "id": 208367
                }, {
                    "name": "上海华为计算机控股集团",
                    "id": 208368
                }]
            }, {
                "name": "杭州华为养殖",
                "id": 208369
            }, {
                "name": "香港快手石油",
                "id": 208370
            }, {
                "name": "上海百度通讯",
                "id": 208371
            }, {
                "name": "杭州阿里医院有限公司",
                "id": 208372
            }, {
                "name": "东莞快手科技有限公司",
                "id": 208373
            }, {
                "name": "东京滴滴互金",
                "id": 208374,
                "children": [{
                    "name": "杭州瑞幸银行",
                    "id": 208375,
                    "children": [{
                        "name": "南京蚂蚁金融",
                        "id": 208376
                    }, {
                        "name": "天津瑞幸通讯",
                        "id": 208377
                    }, {
                        "name": "东莞喜茶石油",
                        "id": 208378
                    }, {
                        "name": "香港小米控股集团",
                        "id": 208379
                    }]
                }, {
                    "name": "天津奈雪农业控股集团",
                    "id": 208380
                }, {
                    "name": "纽约京东计算机",
                    "id": 208381
                }, {
                    "name": "香港肯德基汽车",
                    "id": 208382
                }]
            }, {
                "name": "杭州字节科技控股集团",
                "id": 208383
            }, {
                "name": "台北百度农业",
                "id": 208384
            }, {
                "name": "纽约平安通讯控股集团",
                "id": 208385,
                "children": [{
                    "name": "南京华为科技有限公司",
                    "id": 208386
                }, {
                    "name": "北京星巴克农业",
                    "id": 208387,
                    "children": [{
                        "name": "天津百度芯片控股集团",
                        "id": 208388
                    }, {
                        "name": "东京必胜客农业控股集团",
                        "id": 208389
                    }, {
                        "name": "台北肯德基",
                        "id": 208390
                    }, {
                        "name": "杭州苹果制造",
                        "id": 208391
                    }, {
                        "name": "杭州美团牧业",
                        "id": 208392
                    }, {
                        "name": "深圳谷歌",
                        "id": 208393
                    }, {
                        "name": "东京苹果互金控股集团",
                        "id": 208394
                    }, {
                        "name": "杭州谷歌餐饮",
                        "id": 208395
                    }, {
                        "name": "上海微软石油有限公司",
                        "id": 208396
                    }, {
                        "name": "深圳特斯拉通信控股集团",
                        "id": 208397
                    }, {
                        "name": "广州蚂蚁银行有限公司",
                        "id": 208398
                    }, {
                        "name": "深圳喜茶旅游",
                        "id": 208399
                    }, {
                        "name": "首尔蚂蚁互金",
                        "id": 208400
                    }, {
                        "name": "厦门华为智能",
                        "id": 208401
                    }, {
                        "name": "广州微软控股集团",
                        "id": 208402
                    }, {
                        "name": "东京特斯拉软件控股集团",
                        "id": 208403
                    }, {
                        "name": "香港美团基金",
                        "id": 208404
                    }, {
                        "name": "东京亚马逊旅游",
                        "id": 208405
                    }, {
                        "name": "纽约奈雪证券有限公司",
                        "id": 208406
                    }, {
                        "name": "广州腾讯诊所有限公司",
                        "id": 208407
                    }, {
                        "name": "天津喜茶地产有限公司",
                        "id": 208408
                    }, {
                        "name": "东京美团牧业",
                        "id": 208409
                    }, {
                        "name": "杭州字节通讯",
                        "id": 208410
                    }, {
                        "name": "杭州平安地产有限公司",
                        "id": 208411
                    }, {
                        "name": "首尔滴滴",
                        "id": 208412
                    }, {
                        "name": "深圳必胜客制造有限公司",
                        "id": 208413
                    }, {
                        "name": "台北谷歌汽车有限公司",
                        "id": 208414
                    }, {
                        "name": "杭州必胜客诊所",
                        "id": 208415
                    }, {
                        "name": "纽约谷歌地产",
                        "id": 208416
                    }, {
                        "name": "纽约星巴克制造",
                        "id": 208417
                    }, {
                        "name": "厦门美团银行",
                        "id": 208418
                    }, {
                        "name": "厦门快手渔业",
                        "id": 208419
                    }]
                }, {
                    "name": "广州特斯拉银行",
                    "id": 208420
                }, {
                    "name": "纽约必胜客软件",
                    "id": 208421,
                    "children": [{
                        "name": "厦门喜茶农业",
                        "id": 208422
                    }, {
                        "name": "天津京东",
                        "id": 208423
                    }, {
                        "name": "东莞字节计算机控股集团",
                        "id": 208424
                    }, {
                        "name": "东莞星巴克金融",
                        "id": 208425
                    }, {
                        "name": "北京特斯拉基金有限公司",
                        "id": 208426
                    }, {
                        "name": "杭州华为旅游",
                        "id": 208427
                    }, {
                        "name": "香港亚马逊证券有限公司",
                        "id": 208428
                    }, {
                        "name": "北京必胜客",
                        "id": 208429
                    }, {
                        "name": "首尔亚马逊基金有限公司",
                        "id": 208430
                    }, {
                        "name": "广州快手通讯",
                        "id": 208431
                    }, {
                        "name": "首尔肯德基金融",
                        "id": 208432
                    }, {
                        "name": "广州奈雪银行有限公司",
                        "id": 208433
                    }, {
                        "name": "纽约京东航空",
                        "id": 208434
                    }, {
                        "name": "杭州百度电商",
                        "id": 208435
                    }, {
                        "name": "香港腾讯农业",
                        "id": 208436
                    }, {
                        "name": "纽约腾讯软件",
                        "id": 208437
                    }, {
                        "name": "广州喜茶地产",
                        "id": 208438
                    }, {
                        "name": "东莞苹果航空",
                        "id": 208439
                    }, {
                        "name": "北京特斯拉",
                        "id": 208440
                    }, {
                        "name": "广州星巴克渔业控股集团",
                        "id": 208441
                    }, {
                        "name": "厦门微软诊所",
                        "id": 208442
                    }, {
                        "name": "纽约蚂蚁通信",
                        "id": 208443
                    }, {
                        "name": "深圳必胜客汽车",
                        "id": 208444
                    }, {
                        "name": "南京肯德基诊所有限公司",
                        "id": 208445
                    }, {
                        "name": "北京谷歌牧业",
                        "id": 208446
                    }, {
                        "name": "厦门华为信息服务",
                        "id": 208447
                    }, {
                        "name": "香港谷歌汽车有限公司",
                        "id": 208448
                    }, {
                        "name": "天津亚马逊渔业",
                        "id": 208449
                    }, {
                        "name": "天津欧珀医院",
                        "id": 208450
                    }]
                }, {
                    "name": "首尔星巴克基金控股集团",
                    "id": 208451,
                    "children": [{
                        "name": "台北必胜客软件控股集团",
                        "id": 208452
                    }, {
                        "name": "北京喜茶互金",
                        "id": 208453
                    }, {
                        "name": "广州特斯拉地产",
                        "id": 208454
                    }, {
                        "name": "首尔微软软件",
                        "id": 208455
                    }, {
                        "name": "北京字节医院",
                        "id": 208456
                    }, {
                        "name": "上海字节农业控股集团",
                        "id": 208457
                    }, {
                        "name": "上海平安电商有限公司",
                        "id": 208458
                    }, {
                        "name": "广州华为芯片",
                        "id": 208459
                    }, {
                        "name": "东莞京东渔业",
                        "id": 208460
                    }, {
                        "name": "天津美团计算机控股集团",
                        "id": 208461
                    }, {
                        "name": "首尔苹果新能源有限公司",
                        "id": 208462
                    }, {
                        "name": "东京快手渔业",
                        "id": 208463
                    }, {
                        "name": "首尔星巴克地摊",
                        "id": 208464
                    }, {
                        "name": "香港字节餐饮有限公司",
                        "id": 208465
                    }, {
                        "name": "深圳亚马逊旅游有限公司",
                        "id": 208466
                    }, {
                        "name": "厦门美团互金",
                        "id": 208467
                    }, {
                        "name": "首尔谷歌新能源控股集团",
                        "id": 208468
                    }, {
                        "name": "杭州腾讯制造",
                        "id": 208469
                    }, {
                        "name": "杭州肯德基",
                        "id": 208470
                    }, {
                        "name": "东京必胜客诊所",
                        "id": 208471
                    }, {
                        "name": "广州阿里通讯",
                        "id": 208472
                    }, {
                        "name": "厦门腾讯互金有限公司",
                        "id": 208473
                    }, {
                        "name": "东京华为通信有限公司",
                        "id": 208474
                    }, {
                        "name": "东京快手制造有限公司",
                        "id": 208475
                    }, {
                        "name": "香港瑞幸牧业控股集团",
                        "id": 208476
                    }, {
                        "name": "杭州平安通讯",
                        "id": 208477
                    }, {
                        "name": "上海谷歌",
                        "id": 208478
                    }, {
                        "name": "天津星巴克汽车",
                        "id": 208479
                    }, {
                        "name": "杭州华为科技",
                        "id": 208480
                    }, {
                        "name": "上海特斯拉旅游",
                        "id": 208481
                    }, {
                        "name": "北京快手证券",
                        "id": 208482
                    }, {
                        "name": "天津京东医药",
                        "id": 208483
                    }, {
                        "name": "台北小米通信有限公司",
                        "id": 208484
                    }, {
                        "name": "厦门京东计算机",
                        "id": 208485
                    }, {
                        "name": "东京百度基金控股集团",
                        "id": 208486
                    }]
                }, {
                    "name": "北京微软计算机",
                    "id": 208487
                }, {
                    "name": "纽约阿里医药",
                    "id": 208488
                }, {
                    "name": "纽约喜茶新能源有限公司",
                    "id": 208489
                }, {
                    "name": "厦门亚马逊旅游",
                    "id": 208490
                }, {
                    "name": "上海谷歌电商",
                    "id": 208491
                }, {
                    "name": "深圳平安汽车",
                    "id": 208492
                }, {
                    "name": "深圳华为控股集团",
                    "id": 208493
                }, {
                    "name": "天津美团芯片",
                    "id": 208494
                }, {
                    "name": "东莞京东通讯",
                    "id": 208495,
                    "children": [{
                        "name": "纽约百度地产",
                        "id": 208496
                    }, {
                        "name": "南京滴滴餐饮",
                        "id": 208497
                    }, {
                        "name": "深圳蚂蚁互金",
                        "id": 208498
                    }, {
                        "name": "台北滴滴航空",
                        "id": 208499
                    }, {
                        "name": "香港苹果牧业有限公司",
                        "id": 208500
                    }, {
                        "name": "东京京东地产",
                        "id": 208501
                    }, {
                        "name": "首尔喜茶金融控股集团",
                        "id": 208502
                    }, {
                        "name": "深圳京东",
                        "id": 208503
                    }, {
                        "name": "杭州苹果互金有限公司",
                        "id": 208504
                    }, {
                        "name": "香港京东金融控股集团",
                        "id": 208505
                    }, {
                        "name": "东京蚂蚁制造",
                        "id": 208506
                    }, {
                        "name": "纽约特斯拉旅游",
                        "id": 208507
                    }, {
                        "name": "深圳必胜客控股集团",
                        "id": 208508
                    }, {
                        "name": "厦门必胜客智能",
                        "id": 208509
                    }, {
                        "name": "厦门百度地产",
                        "id": 208510
                    }, {
                        "name": "南京谷歌旅游控股集团",
                        "id": 208511
                    }, {
                        "name": "广州肯德基电商",
                        "id": 208512
                    }, {
                        "name": "南京肯德基金融",
                        "id": 208513
                    }, {
                        "name": "上海快手金融",
                        "id": 208514
                    }, {
                        "name": "北京快手科技控股集团",
                        "id": 208515
                    }, {
                        "name": "厦门快手控股集团",
                        "id": 208516
                    }, {
                        "name": "广州特斯拉证券",
                        "id": 208517
                    }, {
                        "name": "纽约喜茶金融有限公司",
                        "id": 208518
                    }, {
                        "name": "纽约阿里互金控股集团",
                        "id": 208519
                    }, {
                        "name": "东莞星巴克",
                        "id": 208520
                    }, {
                        "name": "上海华为证券",
                        "id": 208521
                    }, {
                        "name": "深圳平安地摊",
                        "id": 208522
                    }, {
                        "name": "东京苹果渔业控股集团",
                        "id": 208523
                    }, {
                        "name": "厦门滴滴航空控股集团",
                        "id": 208524
                    }, {
                        "name": "上海谷歌计算机",
                        "id": 208525
                    }, {
                        "name": "台北平安地摊",
                        "id": 208526
                    }, {
                        "name": "杭州必胜客诊所",
                        "id": 208527
                    }, {
                        "name": "东京苹果",
                        "id": 208528
                    }, {
                        "name": "北京美团银行控股集团",
                        "id": 208529
                    }, {
                        "name": "南京微软航空控股集团",
                        "id": 208530
                    }, {
                        "name": "台北快手旅游",
                        "id": 208531
                    }]
                }]
            }, {
                "name": "台北美团地产控股集团",
                "id": 208532
            }, {
                "name": "北京欧珀",
                "id": 208533
            }, {
                "name": "杭州小米农业控股集团",
                "id": 208534,
                "children": [{
                    "name": "首尔滴滴信息服务",
                    "id": 208535,
                    "children": [{
                        "name": "北京腾讯石油",
                        "id": 208536
                    }]
                }, {
                    "name": "东莞字节芯片",
                    "id": 208537
                }]
            }, {
                "name": "东莞华为证券",
                "id": 208538
            }, {
                "name": "台北欧珀银行有限公司",
                "id": 208539
            }, {
                "name": "首尔美团",
                "id": 208540,
                "children": [{
                    "name": "香港快手医院",
                    "id": 208541
                }, {
                    "name": "天津特斯拉养殖",
                    "id": 208542,
                    "children": [{
                        "name": "南京奈雪餐饮有限公司",
                        "id": 208543
                    }, {
                        "name": "北京欧珀通信",
                        "id": 208544
                    }, {
                        "name": "东京苹果制造",
                        "id": 208545
                    }, {
                        "name": "东京奈雪互金有限公司",
                        "id": 208546
                    }, {
                        "name": "上海亚马逊牧业控股集团",
                        "id": 208547
                    }, {
                        "name": "杭州瑞幸医药",
                        "id": 208548
                    }, {
                        "name": "东京美团医院",
                        "id": 208549
                    }, {
                        "name": "广州华为信息服务有限公司",
                        "id": 208550
                    }, {
                        "name": "厦门亚马逊地摊有限公司",
                        "id": 208551
                    }, {
                        "name": "深圳腾讯餐饮控股集团",
                        "id": 208552
                    }, {
                        "name": "台北亚马逊制造有限公司",
                        "id": 208553
                    }, {
                        "name": "香港苹果农业",
                        "id": 208554
                    }, {
                        "name": "东莞瑞幸软件控股集团",
                        "id": 208555
                    }, {
                        "name": "南京肯德基汽车",
                        "id": 208556
                    }, {
                        "name": "上海微软软件",
                        "id": 208557
                    }, {
                        "name": "天津奈雪医药",
                        "id": 208558
                    }, {
                        "name": "杭州百度通信控股集团",
                        "id": 208559
                    }, {
                        "name": "南京滴滴智能控股集团",
                        "id": 208560
                    }, {
                        "name": "天津特斯拉金融",
                        "id": 208561
                    }, {
                        "name": "东莞小米地摊",
                        "id": 208562
                    }, {
                        "name": "南京小米",
                        "id": 208563
                    }, {
                        "name": "台北欧珀航空",
                        "id": 208564
                    }, {
                        "name": "北京苹果有限公司",
                        "id": 208565
                    }, {
                        "name": "纽约欧珀银行控股集团",
                        "id": 208566
                    }, {
                        "name": "杭州谷歌地摊",
                        "id": 208567
                    }, {
                        "name": "纽约微软医院",
                        "id": 208568
                    }, {
                        "name": "杭州特斯拉控股集团",
                        "id": 208569
                    }, {
                        "name": "广州京东科技",
                        "id": 208570
                    }, {
                        "name": "厦门瑞幸软件控股集团",
                        "id": 208571
                    }, {
                        "name": "纽约华为诊所控股集团",
                        "id": 208572
                    }, {
                        "name": "广州谷歌制造",
                        "id": 208573
                    }, {
                        "name": "深圳肯德基养殖有限公司",
                        "id": 208574
                    }, {
                        "name": "天津字节有限公司",
                        "id": 208575
                    }]
                }, {
                    "name": "厦门微软航空",
                    "id": 208576
                }, {
                    "name": "南京百度新能源控股集团",
                    "id": 208577
                }, {
                    "name": "天津字节",
                    "id": 208578
                }, {
                    "name": "上海微软地摊",
                    "id": 208579
                }, {
                    "name": "厦门美团汽车控股集团",
                    "id": 208580
                }]
            }, {
                "name": "深圳肯德基智能",
                "id": 208581
            }, {
                "name": "北京奈雪诊所控股集团",
                "id": 208582
            }, {
                "name": "东京百度计算机",
                "id": 208583
            }, {
                "name": "纽约滴滴互金",
                "id": 208584
            }, {
                "name": "北京喜茶汽车控股集团",
                "id": 208585,
                "children": [{
                    "name": "上海谷歌养殖",
                    "id": 208586
                }, {
                    "name": "杭州星巴克旅游",
                    "id": 208587
                }, {
                    "name": "深圳谷歌互金有限公司",
                    "id": 208588
                }, {
                    "name": "广州微软",
                    "id": 208589
                }, {
                    "name": "南京欧珀",
                    "id": 208590,
                    "children": [{
                        "name": "东京腾讯芯片有限公司",
                        "id": 208591
                    }, {
                        "name": "杭州苹果牧业",
                        "id": 208592
                    }, {
                        "name": "香港苹果金融控股集团",
                        "id": 208593
                    }, {
                        "name": "天津华为金融",
                        "id": 208594
                    }, {
                        "name": "厦门苹果互金控股集团",
                        "id": 208595
                    }, {
                        "name": "东莞小米基金有限公司",
                        "id": 208596
                    }, {
                        "name": "纽约美团通信",
                        "id": 208597
                    }, {
                        "name": "杭州特斯拉农业",
                        "id": 208598
                    }, {
                        "name": "北京谷歌新能源",
                        "id": 208599
                    }, {
                        "name": "厦门腾讯石油",
                        "id": 208600
                    }, {
                        "name": "首尔快手金融控股集团",
                        "id": 208601
                    }, {
                        "name": "东京特斯拉通讯",
                        "id": 208602
                    }, {
                        "name": "南京阿里地摊",
                        "id": 208603
                    }, {
                        "name": "东京肯德基诊所",
                        "id": 208604
                    }, {
                        "name": "天津喜茶汽车",
                        "id": 208605
                    }, {
                        "name": "天津华为汽车控股集团",
                        "id": 208606
                    }, {
                        "name": "首尔微软有限公司",
                        "id": 208607
                    }]
                }, {
                    "name": "北京特斯拉",
                    "id": 208608
                }, {
                    "name": "南京百度",
                    "id": 208609
                }, {
                    "name": "北京平安互金",
                    "id": 208610
                }, {
                    "name": "纽约字节通讯",
                    "id": 208611
                }, {
                    "name": "杭州平安渔业有限公司",
                    "id": 208612
                }, {
                    "name": "天津平安智能",
                    "id": 208613
                }, {
                    "name": "台北瑞幸",
                    "id": 208614
                }, {
                    "name": "广州苹果互金",
                    "id": 208615
                }, {
                    "name": "香港微软地产",
                    "id": 208616
                }, {
                    "name": "香港华为牧业有限公司",
                    "id": 208617
                }, {
                    "name": "天津欧珀渔业",
                    "id": 208618
                }, {
                    "name": "东京字节旅游控股集团",
                    "id": 208619
                }, {
                    "name": "北京腾讯新能源控股集团",
                    "id": 208620
                }, {
                    "name": "东京阿里渔业",
                    "id": 208621
                }, {
                    "name": "北京微软汽车控股集团",
                    "id": 208622,
                    "children": [{
                        "name": "纽约美团芯片",
                        "id": 208623
                    }, {
                        "name": "香港肯德基渔业",
                        "id": 208624
                    }, {
                        "name": "上海小米",
                        "id": 208625
                    }, {
                        "name": "台北字节",
                        "id": 208626
                    }, {
                        "name": "广州喜茶餐饮",
                        "id": 208627
                    }, {
                        "name": "南京快手汽车控股集团",
                        "id": 208628
                    }, {
                        "name": "香港滴滴石油",
                        "id": 208629
                    }, {
                        "name": "纽约美团旅游",
                        "id": 208630
                    }, {
                        "name": "香港肯德基地摊",
                        "id": 208631
                    }, {
                        "name": "杭州蚂蚁汽车",
                        "id": 208632
                    }, {
                        "name": "杭州必胜客软件",
                        "id": 208633
                    }, {
                        "name": "厦门华为信息服务控股集团",
                        "id": 208634
                    }, {
                        "name": "首尔华为计算机",
                        "id": 208635
                    }, {
                        "name": "杭州快手地产",
                        "id": 208636
                    }, {
                        "name": "北京微软银行",
                        "id": 208637
                    }, {
                        "name": "台北欧珀基金",
                        "id": 208638
                    }, {
                        "name": "东京京东软件",
                        "id": 208639
                    }, {
                        "name": "东京特斯拉计算机有限公司",
                        "id": 208640
                    }, {
                        "name": "杭州瑞幸汽车",
                        "id": 208641
                    }, {
                        "name": "深圳百度",
                        "id": 208642
                    }, {
                        "name": "深圳苹果新能源",
                        "id": 208643
                    }, {
                        "name": "纽约阿里石油",
                        "id": 208644
                    }, {
                        "name": "广州华为",
                        "id": 208645
                    }, {
                        "name": "厦门喜茶智能",
                        "id": 208646
                    }, {
                        "name": "东莞喜茶渔业",
                        "id": 208647
                    }, {
                        "name": "首尔平安科技",
                        "id": 208648
                    }]
                }, {
                    "name": "首尔喜茶智能",
                    "id": 208649
                }, {
                    "name": "深圳谷歌地产",
                    "id": 208650
                }, {
                    "name": "广州奈雪医院控股集团",
                    "id": 208651
                }, {
                    "name": "厦门快手渔业",
                    "id": 208652
                }, {
                    "name": "北京百度医药",
                    "id": 208653,
                    "children": [{
                        "name": "天津滴滴渔业有限公司",
                        "id": 208654
                    }, {
                        "name": "南京京东牧业",
                        "id": 208655
                    }, {
                        "name": "纽约小米基金有限公司",
                        "id": 208656
                    }, {
                        "name": "香港小米医院",
                        "id": 208657
                    }, {
                        "name": "台北喜茶",
                        "id": 208658
                    }, {
                        "name": "杭州快手互金控股集团",
                        "id": 208659
                    }, {
                        "name": "杭州百度基金有限公司",
                        "id": 208660
                    }, {
                        "name": "台北必胜客基金",
                        "id": 208661
                    }, {
                        "name": "厦门美团通讯",
                        "id": 208662
                    }, {
                        "name": "南京谷歌渔业控股集团",
                        "id": 208663
                    }, {
                        "name": "广州快手汽车控股集团",
                        "id": 208664
                    }]
                }, {
                    "name": "首尔奈雪科技",
                    "id": 208665,
                    "children": [{
                        "name": "首尔喜茶地产",
                        "id": 208666
                    }, {
                        "name": "首尔美团餐饮",
                        "id": 208667
                    }, {
                        "name": "北京阿里地产",
                        "id": 208668
                    }, {
                        "name": "纽约微软汽车有限公司",
                        "id": 208669
                    }, {
                        "name": "杭州小米",
                        "id": 208670
                    }, {
                        "name": "深圳字节软件有限公司",
                        "id": 208671
                    }, {
                        "name": "香港平安",
                        "id": 208672
                    }, {
                        "name": "台北腾讯汽车",
                        "id": 208673
                    }, {
                        "name": "首尔蚂蚁汽车",
                        "id": 208674
                    }, {
                        "name": "台北谷歌基金有限公司",
                        "id": 208675
                    }, {
                        "name": "香港快手有限公司",
                        "id": 208676
                    }, {
                        "name": "深圳必胜客芯片",
                        "id": 208677
                    }, {
                        "name": "广州特斯拉地产",
                        "id": 208678
                    }, {
                        "name": "深圳字节渔业有限公司",
                        "id": 208679
                    }, {
                        "name": "纽约腾讯",
                        "id": 208680
                    }, {
                        "name": "厦门腾讯智能",
                        "id": 208681
                    }, {
                        "name": "香港星巴克农业有限公司",
                        "id": 208682
                    }]
                }, {
                    "name": "香港滴滴制造",
                    "id": 208683,
                    "children": [{
                        "name": "纽约蚂蚁基金有限公司",
                        "id": 208684
                    }, {
                        "name": "深圳快手智能",
                        "id": 208685
                    }, {
                        "name": "杭州百度基金",
                        "id": 208686
                    }, {
                        "name": "东京平安诊所",
                        "id": 208687
                    }, {
                        "name": "天津快手医药",
                        "id": 208688
                    }, {
                        "name": "东京华为软件有限公司",
                        "id": 208689
                    }, {
                        "name": "首尔百度石油",
                        "id": 208690
                    }, {
                        "name": "天津亚马逊新能源控股集团",
                        "id": 208691
                    }, {
                        "name": "天津欧珀航空有限公司",
                        "id": 208692
                    }, {
                        "name": "东莞喜茶医院",
                        "id": 208693
                    }, {
                        "name": "台北亚马逊金融",
                        "id": 208694
                    }, {
                        "name": "杭州特斯拉医药",
                        "id": 208695
                    }, {
                        "name": "深圳快手餐饮控股集团",
                        "id": 208696
                    }, {
                        "name": "首尔喜茶金融",
                        "id": 208697
                    }]
                }, {
                    "name": "首尔喜茶证券",
                    "id": 208698,
                    "children": [{
                        "name": "杭州谷歌计算机",
                        "id": 208699
                    }, {
                        "name": "东京喜茶智能",
                        "id": 208700
                    }, {
                        "name": "天津美团航空有限公司",
                        "id": 208701
                    }, {
                        "name": "首尔百度",
                        "id": 208702
                    }, {
                        "name": "北京苹果互金控股集团",
                        "id": 208703
                    }, {
                        "name": "天津京东互金有限公司",
                        "id": 208704
                    }, {
                        "name": "上海蚂蚁银行",
                        "id": 208705
                    }, {
                        "name": "厦门华为牧业",
                        "id": 208706
                    }, {
                        "name": "香港滴滴地产",
                        "id": 208707
                    }]
                }, {
                    "name": "深圳平安信息服务",
                    "id": 208708
                }, {
                    "name": "天津谷歌有限公司",
                    "id": 208709
                }, {
                    "name": "台北奈雪石油控股集团",
                    "id": 208710
                }, {
                    "name": "深圳奈雪科技有限公司",
                    "id": 208711
                }, {
                    "name": "天津肯德基地摊",
                    "id": 208712
                }, {
                    "name": "北京腾讯证券控股集团",
                    "id": 208713
                }]
            }, {
                "name": "北京欧珀金融控股集团",
                "id": 208714
            }]
        }, {
            "name": "香港欧珀旅游",
            "id": 208715,
            "children": [{
                "name": "天津奈雪电商有限公司",
                "id": 208716,
                "children": [{
                    "name": "深圳滴滴软件",
                    "id": 208717,
                    "children": [{
                        "name": "深圳亚马逊",
                        "id": 208718
                    }, {
                        "name": "首尔百度计算机控股集团",
                        "id": 208719
                    }, {
                        "name": "北京滴滴渔业控股集团",
                        "id": 208720
                    }, {
                        "name": "台北必胜客通讯控股集团",
                        "id": 208721
                    }, {
                        "name": "北京亚马逊航空",
                        "id": 208722
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 208723
                    }, {
                        "name": "首尔京东金融有限公司",
                        "id": 208724
                    }, {
                        "name": "杭州百度汽车",
                        "id": 208725
                    }, {
                        "name": "台北肯德基地摊",
                        "id": 208726
                    }, {
                        "name": "厦门微软农业有限公司",
                        "id": 208727
                    }, {
                        "name": "东莞小米互金",
                        "id": 208728
                    }, {
                        "name": "深圳喜茶通讯",
                        "id": 208729
                    }, {
                        "name": "东京滴滴地产",
                        "id": 208730
                    }, {
                        "name": "杭州美团石油有限公司",
                        "id": 208731
                    }, {
                        "name": "广州美团制造",
                        "id": 208732
                    }, {
                        "name": "广州快手基金控股集团",
                        "id": 208733
                    }, {
                        "name": "广州必胜客科技",
                        "id": 208734
                    }, {
                        "name": "厦门苹果",
                        "id": 208735
                    }, {
                        "name": "东莞华为电商",
                        "id": 208736
                    }, {
                        "name": "南京华为新能源",
                        "id": 208737
                    }]
                }, {
                    "name": "北京星巴克电商",
                    "id": 208738,
                    "children": [{
                        "name": "香港肯德基制造",
                        "id": 208739
                    }, {
                        "name": "上海微软旅游",
                        "id": 208740
                    }, {
                        "name": "上海欧珀医院",
                        "id": 208741
                    }, {
                        "name": "深圳阿里银行",
                        "id": 208742
                    }, {
                        "name": "东莞华为计算机",
                        "id": 208743
                    }, {
                        "name": "南京腾讯基金",
                        "id": 208744
                    }, {
                        "name": "南京奈雪软件",
                        "id": 208745
                    }, {
                        "name": "杭州瑞幸互金",
                        "id": 208746
                    }]
                }, {
                    "name": "东莞苹果诊所有限公司",
                    "id": 208747
                }, {
                    "name": "纽约苹果航空有限公司",
                    "id": 208748
                }]
            }, {
                "name": "天津特斯拉养殖",
                "id": 208749
            }, {
                "name": "南京平安",
                "id": 208750
            }]
        }, {
            "name": "首尔微软信息服务",
            "id": 208751,
            "children": [{
                "name": "广州瑞幸软件",
                "id": 208752
            }, {
                "name": "纽约字节诊所",
                "id": 208753
            }, {
                "name": "首尔平安地产有限公司",
                "id": 208754
            }, {
                "name": "北京腾讯银行",
                "id": 208755,
                "children": [{
                    "name": "纽约字节科技控股集团",
                    "id": 208756
                }, {
                    "name": "杭州瑞幸科技",
                    "id": 208757,
                    "children": [{
                        "name": "天津喜茶农业",
                        "id": 208758
                    }, {
                        "name": "香港苹果新能源",
                        "id": 208759
                    }, {
                        "name": "北京快手信息服务有限公司",
                        "id": 208760
                    }, {
                        "name": "天津特斯拉证券有限公司",
                        "id": 208761
                    }, {
                        "name": "杭州星巴克养殖控股集团",
                        "id": 208762
                    }, {
                        "name": "纽约腾讯航空",
                        "id": 208763
                    }, {
                        "name": "上海欧珀地摊",
                        "id": 208764
                    }, {
                        "name": "北京百度渔业",
                        "id": 208765
                    }, {
                        "name": "东莞必胜客软件",
                        "id": 208766
                    }, {
                        "name": "纽约平安餐饮",
                        "id": 208767
                    }, {
                        "name": "深圳平安通信",
                        "id": 208768
                    }, {
                        "name": "首尔小米证券",
                        "id": 208769
                    }, {
                        "name": "纽约肯德基计算机",
                        "id": 208770
                    }, {
                        "name": "厦门谷歌证券",
                        "id": 208771
                    }, {
                        "name": "香港字节牧业有限公司",
                        "id": 208772
                    }, {
                        "name": "上海必胜客金融控股集团",
                        "id": 208773
                    }, {
                        "name": "广州谷歌制造控股集团",
                        "id": 208774
                    }, {
                        "name": "东莞特斯拉牧业",
                        "id": 208775
                    }, {
                        "name": "深圳快手软件",
                        "id": 208776
                    }, {
                        "name": "厦门欧珀餐饮控股集团",
                        "id": 208777
                    }, {
                        "name": "香港京东旅游",
                        "id": 208778
                    }, {
                        "name": "天津必胜客",
                        "id": 208779
                    }, {
                        "name": "东京特斯拉基金",
                        "id": 208780
                    }, {
                        "name": "东京百度餐饮",
                        "id": 208781
                    }, {
                        "name": "广州平安通信",
                        "id": 208782
                    }, {
                        "name": "杭州京东渔业",
                        "id": 208783
                    }, {
                        "name": "杭州小米",
                        "id": 208784
                    }, {
                        "name": "东莞字节渔业",
                        "id": 208785
                    }]
                }, {
                    "name": "首尔欧珀餐饮",
                    "id": 208786,
                    "children": [{
                        "name": "上海快手牧业",
                        "id": 208787
                    }, {
                        "name": "上海苹果计算机控股集团",
                        "id": 208788
                    }, {
                        "name": "天津美团信息服务",
                        "id": 208789
                    }, {
                        "name": "杭州奈雪养殖控股集团",
                        "id": 208790
                    }, {
                        "name": "纽约肯德基基金控股集团",
                        "id": 208791
                    }, {
                        "name": "纽约苹果",
                        "id": 208792
                    }, {
                        "name": "厦门肯德基智能",
                        "id": 208793
                    }, {
                        "name": "东莞字节航空",
                        "id": 208794
                    }, {
                        "name": "上海亚马逊证券控股集团",
                        "id": 208795
                    }, {
                        "name": "东京星巴克通讯",
                        "id": 208796
                    }, {
                        "name": "杭州欧珀石油",
                        "id": 208797
                    }, {
                        "name": "北京喜茶医药控股集团",
                        "id": 208798
                    }, {
                        "name": "上海微软信息服务",
                        "id": 208799
                    }, {
                        "name": "东京美团新能源控股集团",
                        "id": 208800
                    }, {
                        "name": "杭州肯德基科技",
                        "id": 208801
                    }, {
                        "name": "杭州欧珀养殖有限公司",
                        "id": 208802
                    }, {
                        "name": "台北喜茶农业控股集团",
                        "id": 208803
                    }, {
                        "name": "台北字节医院有限公司",
                        "id": 208804
                    }, {
                        "name": "深圳蚂蚁旅游",
                        "id": 208805
                    }, {
                        "name": "杭州京东医院控股集团",
                        "id": 208806
                    }, {
                        "name": "天津小米智能",
                        "id": 208807
                    }, {
                        "name": "台北快手电商",
                        "id": 208808
                    }]
                }, {
                    "name": "杭州奈雪通讯控股集团",
                    "id": 208809
                }, {
                    "name": "北京美团医院",
                    "id": 208810,
                    "children": [{
                        "name": "首尔百度智能有限公司",
                        "id": 208811
                    }, {
                        "name": "首尔滴滴",
                        "id": 208812
                    }, {
                        "name": "东京亚马逊互金有限公司",
                        "id": 208813
                    }, {
                        "name": "上海肯德基石油",
                        "id": 208814
                    }, {
                        "name": "深圳滴滴诊所",
                        "id": 208815
                    }, {
                        "name": "天津滴滴医药",
                        "id": 208816
                    }]
                }, {
                    "name": "东莞字节",
                    "id": 208817
                }, {
                    "name": "香港星巴克旅游",
                    "id": 208818
                }, {
                    "name": "杭州肯德基医药",
                    "id": 208819
                }, {
                    "name": "厦门星巴克智能",
                    "id": 208820
                }, {
                    "name": "东莞华为科技",
                    "id": 208821,
                    "children": [{
                        "name": "香港快手科技有限公司",
                        "id": 208822
                    }, {
                        "name": "东莞特斯拉",
                        "id": 208823
                    }, {
                        "name": "北京滴滴渔业控股集团",
                        "id": 208824
                    }, {
                        "name": "杭州小米芯片",
                        "id": 208825
                    }, {
                        "name": "深圳喜茶",
                        "id": 208826
                    }, {
                        "name": "厦门滴滴航空",
                        "id": 208827
                    }, {
                        "name": "首尔特斯拉制造",
                        "id": 208828
                    }, {
                        "name": "首尔肯德基通信",
                        "id": 208829
                    }, {
                        "name": "上海谷歌汽车",
                        "id": 208830
                    }, {
                        "name": "北京腾讯诊所",
                        "id": 208831
                    }, {
                        "name": "东京滴滴新能源有限公司",
                        "id": 208832
                    }, {
                        "name": "杭州谷歌地摊",
                        "id": 208833
                    }, {
                        "name": "厦门美团制造",
                        "id": 208834
                    }, {
                        "name": "广州谷歌牧业有限公司",
                        "id": 208835
                    }, {
                        "name": "天津百度芯片控股集团",
                        "id": 208836
                    }, {
                        "name": "厦门快手互金",
                        "id": 208837
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 208838
                    }, {
                        "name": "东京平安科技",
                        "id": 208839
                    }, {
                        "name": "首尔喜茶制造",
                        "id": 208840
                    }, {
                        "name": "广州阿里智能有限公司",
                        "id": 208841
                    }, {
                        "name": "纽约微软计算机",
                        "id": 208842
                    }, {
                        "name": "杭州京东航空控股集团",
                        "id": 208843
                    }]
                }, {
                    "name": "南京苹果地摊",
                    "id": 208844
                }, {
                    "name": "深圳蚂蚁餐饮",
                    "id": 208845,
                    "children": [{
                        "name": "香港快手医药有限公司",
                        "id": 208846
                    }, {
                        "name": "广州肯德基石油有限公司",
                        "id": 208847
                    }, {
                        "name": "杭州苹果科技",
                        "id": 208848
                    }, {
                        "name": "北京特斯拉渔业控股集团",
                        "id": 208849
                    }, {
                        "name": "香港欧珀",
                        "id": 208850
                    }, {
                        "name": "首尔腾讯金融有限公司",
                        "id": 208851
                    }, {
                        "name": "杭州华为牧业有限公司",
                        "id": 208852
                    }, {
                        "name": "厦门京东金融有限公司",
                        "id": 208853
                    }, {
                        "name": "杭州平安餐饮控股集团",
                        "id": 208854
                    }, {
                        "name": "天津瑞幸",
                        "id": 208855
                    }]
                }, {
                    "name": "上海亚马逊",
                    "id": 208856,
                    "children": [{
                        "name": "东京百度芯片",
                        "id": 208857
                    }, {
                        "name": "厦门喜茶计算机",
                        "id": 208858
                    }, {
                        "name": "台北美团养殖",
                        "id": 208859
                    }, {
                        "name": "上海肯德基",
                        "id": 208860
                    }, {
                        "name": "上海京东",
                        "id": 208861
                    }, {
                        "name": "东京快手基金",
                        "id": 208862
                    }]
                }, {
                    "name": "香港瑞幸",
                    "id": 208863
                }, {
                    "name": "天津阿里制造",
                    "id": 208864,
                    "children": [{
                        "name": "东莞小米互金控股集团",
                        "id": 208865
                    }, {
                        "name": "东京腾讯航空",
                        "id": 208866
                    }, {
                        "name": "纽约快手银行有限公司",
                        "id": 208867
                    }, {
                        "name": "杭州美团软件有限公司",
                        "id": 208868
                    }, {
                        "name": "北京欧珀金融",
                        "id": 208869
                    }, {
                        "name": "香港腾讯餐饮",
                        "id": 208870
                    }, {
                        "name": "纽约肯德基旅游控股集团",
                        "id": 208871
                    }, {
                        "name": "厦门华为通讯",
                        "id": 208872
                    }, {
                        "name": "台北华为基金",
                        "id": 208873
                    }, {
                        "name": "厦门肯德基信息服务",
                        "id": 208874
                    }]
                }, {
                    "name": "北京谷歌农业有限公司",
                    "id": 208875,
                    "children": [{
                        "name": "香港美团石油",
                        "id": 208876
                    }, {
                        "name": "厦门平安制造",
                        "id": 208877
                    }, {
                        "name": "杭州滴滴通信控股集团",
                        "id": 208878
                    }, {
                        "name": "杭州欧珀餐饮",
                        "id": 208879
                    }, {
                        "name": "广州奈雪",
                        "id": 208880
                    }, {
                        "name": "厦门蚂蚁汽车有限公司",
                        "id": 208881
                    }, {
                        "name": "首尔小米科技",
                        "id": 208882
                    }, {
                        "name": "天津喜茶农业有限公司",
                        "id": 208883
                    }, {
                        "name": "首尔微软渔业",
                        "id": 208884
                    }, {
                        "name": "首尔肯德基控股集团",
                        "id": 208885
                    }, {
                        "name": "南京蚂蚁互金有限公司",
                        "id": 208886
                    }, {
                        "name": "东莞百度牧业",
                        "id": 208887
                    }, {
                        "name": "北京华为基金有限公司",
                        "id": 208888
                    }, {
                        "name": "天津谷歌证券",
                        "id": 208889
                    }, {
                        "name": "广州奈雪养殖",
                        "id": 208890
                    }, {
                        "name": "香港特斯拉智能",
                        "id": 208891
                    }, {
                        "name": "北京美团餐饮",
                        "id": 208892
                    }]
                }, {
                    "name": "深圳喜茶银行",
                    "id": 208893
                }, {
                    "name": "厦门瑞幸芯片有限公司",
                    "id": 208894
                }, {
                    "name": "纽约京东",
                    "id": 208895
                }, {
                    "name": "上海小米",
                    "id": 208896
                }, {
                    "name": "杭州奈雪电商控股集团",
                    "id": 208897
                }, {
                    "name": "北京快手金融有限公司",
                    "id": 208898
                }, {
                    "name": "香港瑞幸医药控股集团",
                    "id": 208899
                }, {
                    "name": "厦门必胜客智能",
                    "id": 208900
                }, {
                    "name": "南京京东",
                    "id": 208901,
                    "children": [{
                        "name": "首尔亚马逊医药控股集团",
                        "id": 208902
                    }, {
                        "name": "东莞蚂蚁石油",
                        "id": 208903
                    }, {
                        "name": "东莞京东诊所控股集团",
                        "id": 208904
                    }, {
                        "name": "天津华为医院有限公司",
                        "id": 208905
                    }, {
                        "name": "天津美团计算机",
                        "id": 208906
                    }, {
                        "name": "东莞星巴克基金",
                        "id": 208907
                    }, {
                        "name": "深圳快手计算机控股集团",
                        "id": 208908
                    }, {
                        "name": "上海百度银行",
                        "id": 208909
                    }, {
                        "name": "北京快手软件控股集团",
                        "id": 208910
                    }, {
                        "name": "香港京东基金控股集团",
                        "id": 208911
                    }, {
                        "name": "南京腾讯科技",
                        "id": 208912
                    }, {
                        "name": "南京字节医院",
                        "id": 208913
                    }, {
                        "name": "东莞苹果通信",
                        "id": 208914
                    }, {
                        "name": "台北小米计算机",
                        "id": 208915
                    }, {
                        "name": "广州必胜客",
                        "id": 208916
                    }, {
                        "name": "东莞瑞幸有限公司",
                        "id": 208917
                    }, {
                        "name": "香港微软科技",
                        "id": 208918
                    }, {
                        "name": "香港小米石油",
                        "id": 208919
                    }, {
                        "name": "广州阿里制造",
                        "id": 208920
                    }, {
                        "name": "南京谷歌通信",
                        "id": 208921
                    }, {
                        "name": "厦门小米医院控股集团",
                        "id": 208922
                    }, {
                        "name": "台北欧珀软件",
                        "id": 208923
                    }, {
                        "name": "首尔肯德基石油",
                        "id": 208924
                    }, {
                        "name": "杭州腾讯地摊控股集团",
                        "id": 208925
                    }, {
                        "name": "天津美团电商",
                        "id": 208926
                    }, {
                        "name": "首尔蚂蚁汽车有限公司",
                        "id": 208927
                    }, {
                        "name": "香港平安诊所控股集团",
                        "id": 208928
                    }, {
                        "name": "杭州百度医院控股集团",
                        "id": 208929
                    }]
                }, {
                    "name": "杭州特斯拉科技控股集团",
                    "id": 208930
                }, {
                    "name": "纽约欧珀银行",
                    "id": 208931
                }, {
                    "name": "深圳特斯拉航空",
                    "id": 208932
                }, {
                    "name": "台北美团汽车",
                    "id": 208933
                }, {
                    "name": "香港京东新能源控股集团",
                    "id": 208934
                }, {
                    "name": "东京苹果通信控股集团",
                    "id": 208935
                }, {
                    "name": "广州必胜客餐饮控股集团",
                    "id": 208936
                }, {
                    "name": "东京滴滴芯片",
                    "id": 208937,
                    "children": [{
                        "name": "杭州字节医院",
                        "id": 208938
                    }, {
                        "name": "香港欧珀科技",
                        "id": 208939
                    }, {
                        "name": "南京美团农业",
                        "id": 208940
                    }, {
                        "name": "杭州微软地摊",
                        "id": 208941
                    }, {
                        "name": "北京京东软件",
                        "id": 208942
                    }, {
                        "name": "天津美团计算机",
                        "id": 208943
                    }, {
                        "name": "香港字节餐饮",
                        "id": 208944
                    }, {
                        "name": "南京奈雪地摊",
                        "id": 208945
                    }, {
                        "name": "北京奈雪基金有限公司",
                        "id": 208946
                    }, {
                        "name": "杭州滴滴新能源",
                        "id": 208947
                    }, {
                        "name": "厦门百度地摊",
                        "id": 208948
                    }, {
                        "name": "东京滴滴金融有限公司",
                        "id": 208949
                    }, {
                        "name": "东京亚马逊养殖",
                        "id": 208950
                    }, {
                        "name": "天津腾讯计算机",
                        "id": 208951
                    }, {
                        "name": "台北星巴克通讯",
                        "id": 208952
                    }, {
                        "name": "天津华为医院",
                        "id": 208953
                    }, {
                        "name": "台北欧珀银行",
                        "id": 208954
                    }, {
                        "name": "天津蚂蚁",
                        "id": 208955
                    }, {
                        "name": "北京亚马逊芯片",
                        "id": 208956
                    }, {
                        "name": "深圳肯德基航空",
                        "id": 208957
                    }, {
                        "name": "北京瑞幸",
                        "id": 208958
                    }, {
                        "name": "深圳必胜客计算机",
                        "id": 208959
                    }, {
                        "name": "香港欧珀地产有限公司",
                        "id": 208960
                    }, {
                        "name": "深圳蚂蚁智能",
                        "id": 208961
                    }, {
                        "name": "香港亚马逊航空",
                        "id": 208962
                    }, {
                        "name": "杭州平安银行",
                        "id": 208963
                    }, {
                        "name": "厦门喜茶金融控股集团",
                        "id": 208964
                    }, {
                        "name": "杭州百度证券",
                        "id": 208965
                    }, {
                        "name": "南京华为银行",
                        "id": 208966
                    }]
                }, {
                    "name": "东京美团餐饮控股集团",
                    "id": 208967,
                    "children": [{
                        "name": "东莞百度计算机有限公司",
                        "id": 208968
                    }]
                }, {
                    "name": "东京喜茶新能源控股集团",
                    "id": 208969
                }]
            }, {
                "name": "深圳平安新能源控股集团",
                "id": 208970
            }, {
                "name": "纽约谷歌",
                "id": 208971
            }, {
                "name": "香港瑞幸通信有限公司",
                "id": 208972
            }, {
                "name": "东京特斯拉航空",
                "id": 208973
            }, {
                "name": "杭州苹果农业",
                "id": 208974
            }, {
                "name": "深圳美团新能源",
                "id": 208975,
                "children": [{
                    "name": "天津谷歌餐饮控股集团",
                    "id": 208976,
                    "children": [{
                        "name": "东京肯德基",
                        "id": 208977
                    }, {
                        "name": "深圳腾讯智能",
                        "id": 208978
                    }, {
                        "name": "天津小米互金",
                        "id": 208979
                    }, {
                        "name": "台北苹果互金",
                        "id": 208980
                    }, {
                        "name": "杭州华为养殖",
                        "id": 208981
                    }, {
                        "name": "香港平安",
                        "id": 208982
                    }, {
                        "name": "天津美团",
                        "id": 208983
                    }, {
                        "name": "东京美团科技",
                        "id": 208984
                    }, {
                        "name": "南京星巴克农业",
                        "id": 208985
                    }, {
                        "name": "首尔华为牧业",
                        "id": 208986
                    }, {
                        "name": "东京京东汽车有限公司",
                        "id": 208987
                    }, {
                        "name": "南京字节农业",
                        "id": 208988
                    }, {
                        "name": "香港小米诊所",
                        "id": 208989
                    }, {
                        "name": "香港京东渔业",
                        "id": 208990
                    }, {
                        "name": "香港瑞幸基金",
                        "id": 208991
                    }, {
                        "name": "杭州亚马逊地摊",
                        "id": 208992
                    }, {
                        "name": "东京瑞幸农业",
                        "id": 208993
                    }, {
                        "name": "首尔欧珀餐饮有限公司",
                        "id": 208994
                    }, {
                        "name": "上海华为互金",
                        "id": 208995
                    }, {
                        "name": "杭州阿里航空控股集团",
                        "id": 208996
                    }, {
                        "name": "东京谷歌新能源",
                        "id": 208997
                    }, {
                        "name": "东莞滴滴农业",
                        "id": 208998
                    }, {
                        "name": "北京必胜客渔业",
                        "id": 208999
                    }, {
                        "name": "纽约腾讯计算机",
                        "id": 209000
                    }, {
                        "name": "北京喜茶智能",
                        "id": 209001
                    }, {
                        "name": "杭州小米石油有限公司",
                        "id": 209002
                    }, {
                        "name": "东京百度电商",
                        "id": 209003
                    }]
                }, {
                    "name": "杭州蚂蚁计算机",
                    "id": 209004
                }, {
                    "name": "香港平安航空",
                    "id": 209005
                }, {
                    "name": "上海奈雪牧业",
                    "id": 209006
                }, {
                    "name": "杭州喜茶汽车有限公司",
                    "id": 209007
                }, {
                    "name": "纽约欧珀芯片",
                    "id": 209008
                }, {
                    "name": "东京喜茶证券",
                    "id": 209009,
                    "children": [{
                        "name": "首尔特斯拉石油",
                        "id": 209010
                    }, {
                        "name": "纽约星巴克",
                        "id": 209011
                    }, {
                        "name": "厦门欧珀智能",
                        "id": 209012
                    }, {
                        "name": "杭州小米信息服务",
                        "id": 209013
                    }, {
                        "name": "台北特斯拉旅游",
                        "id": 209014
                    }, {
                        "name": "深圳京东医药",
                        "id": 209015
                    }, {
                        "name": "北京肯德基汽车",
                        "id": 209016
                    }, {
                        "name": "南京美团医药",
                        "id": 209017
                    }, {
                        "name": "上海特斯拉地摊",
                        "id": 209018
                    }, {
                        "name": "东京小米",
                        "id": 209019
                    }, {
                        "name": "东莞瑞幸通讯",
                        "id": 209020
                    }, {
                        "name": "杭州华为航空有限公司",
                        "id": 209021
                    }, {
                        "name": "厦门星巴克诊所",
                        "id": 209022
                    }, {
                        "name": "台北小米通信",
                        "id": 209023
                    }, {
                        "name": "杭州谷歌航空",
                        "id": 209024
                    }, {
                        "name": "天津滴滴智能有限公司",
                        "id": 209025
                    }, {
                        "name": "厦门字节石油有限公司",
                        "id": 209026
                    }, {
                        "name": "天津京东软件有限公司",
                        "id": 209027
                    }, {
                        "name": "台北京东科技控股集团",
                        "id": 209028
                    }, {
                        "name": "北京腾讯互金",
                        "id": 209029
                    }, {
                        "name": "深圳华为有限公司",
                        "id": 209030
                    }, {
                        "name": "东京亚马逊",
                        "id": 209031
                    }, {
                        "name": "南京蚂蚁科技控股集团",
                        "id": 209032
                    }, {
                        "name": "北京肯德基金融",
                        "id": 209033
                    }, {
                        "name": "纽约星巴克计算机控股集团",
                        "id": 209034
                    }, {
                        "name": "广州华为餐饮",
                        "id": 209035
                    }, {
                        "name": "广州腾讯计算机",
                        "id": 209036
                    }]
                }, {
                    "name": "首尔阿里农业控股集团",
                    "id": 209037,
                    "children": [{
                        "name": "香港微软信息服务",
                        "id": 209038
                    }, {
                        "name": "深圳快手软件控股集团",
                        "id": 209039
                    }, {
                        "name": "香港亚马逊牧业有限公司",
                        "id": 209040
                    }, {
                        "name": "南京亚马逊通讯有限公司",
                        "id": 209041
                    }, {
                        "name": "杭州阿里制造",
                        "id": 209042
                    }, {
                        "name": "北京微软电商",
                        "id": 209043
                    }, {
                        "name": "香港字节地产控股集团",
                        "id": 209044
                    }, {
                        "name": "杭州字节牧业",
                        "id": 209045
                    }, {
                        "name": "广州瑞幸制造",
                        "id": 209046
                    }, {
                        "name": "上海滴滴旅游有限公司",
                        "id": 209047
                    }, {
                        "name": "广州特斯拉航空有限公司",
                        "id": 209048
                    }, {
                        "name": "上海快手通讯控股集团",
                        "id": 209049
                    }, {
                        "name": "台北星巴克金融有限公司",
                        "id": 209050
                    }, {
                        "name": "杭州京东医药",
                        "id": 209051
                    }, {
                        "name": "首尔谷歌汽车",
                        "id": 209052
                    }, {
                        "name": "东莞谷歌通讯",
                        "id": 209053
                    }]
                }, {
                    "name": "杭州字节软件",
                    "id": 209054,
                    "children": [{
                        "name": "广州平安医院有限公司",
                        "id": 209055
                    }, {
                        "name": "首尔谷歌计算机",
                        "id": 209056
                    }, {
                        "name": "香港快手医院",
                        "id": 209057
                    }, {
                        "name": "东莞美团智能有限公司",
                        "id": 209058
                    }, {
                        "name": "杭州喜茶地摊",
                        "id": 209059
                    }, {
                        "name": "东莞星巴克农业有限公司",
                        "id": 209060
                    }, {
                        "name": "天津京东旅游控股集团",
                        "id": 209061
                    }, {
                        "name": "台北滴滴航空控股集团",
                        "id": 209062
                    }, {
                        "name": "上海美团金融有限公司",
                        "id": 209063
                    }, {
                        "name": "台北谷歌通讯",
                        "id": 209064
                    }, {
                        "name": "厦门快手科技有限公司",
                        "id": 209065
                    }, {
                        "name": "北京华为养殖",
                        "id": 209066
                    }, {
                        "name": "厦门奈雪通讯",
                        "id": 209067
                    }, {
                        "name": "广州苹果旅游",
                        "id": 209068
                    }, {
                        "name": "广州喜茶医院",
                        "id": 209069
                    }, {
                        "name": "台北特斯拉石油",
                        "id": 209070
                    }, {
                        "name": "天津瑞幸农业",
                        "id": 209071
                    }, {
                        "name": "上海特斯拉软件",
                        "id": 209072
                    }, {
                        "name": "纽约字节科技",
                        "id": 209073
                    }, {
                        "name": "首尔滴滴计算机",
                        "id": 209074
                    }, {
                        "name": "广州快手智能",
                        "id": 209075
                    }, {
                        "name": "南京快手",
                        "id": 209076
                    }, {
                        "name": "纽约字节石油",
                        "id": 209077
                    }, {
                        "name": "杭州平安计算机",
                        "id": 209078
                    }, {
                        "name": "杭州快手软件",
                        "id": 209079
                    }, {
                        "name": "深圳阿里旅游控股集团",
                        "id": 209080
                    }, {
                        "name": "上海滴滴新能源",
                        "id": 209081
                    }, {
                        "name": "广州美团地产控股集团",
                        "id": 209082
                    }, {
                        "name": "东莞亚马逊通讯",
                        "id": 209083
                    }, {
                        "name": "南京必胜客地摊",
                        "id": 209084
                    }, {
                        "name": "深圳滴滴医药控股集团",
                        "id": 209085
                    }, {
                        "name": "厦门腾讯软件",
                        "id": 209086
                    }]
                }, {
                    "name": "首尔字节旅游",
                    "id": 209087
                }, {
                    "name": "杭州华为金融控股集团",
                    "id": 209088,
                    "children": [{
                        "name": "首尔华为电商",
                        "id": 209089
                    }, {
                        "name": "南京快手餐饮有限公司",
                        "id": 209090
                    }, {
                        "name": "首尔小米地产有限公司",
                        "id": 209091
                    }, {
                        "name": "纽约美团航空有限公司",
                        "id": 209092
                    }, {
                        "name": "南京欧珀通信",
                        "id": 209093
                    }]
                }, {
                    "name": "杭州瑞幸通讯控股集团",
                    "id": 209094
                }, {
                    "name": "东京肯德基养殖",
                    "id": 209095
                }, {
                    "name": "天津谷歌芯片有限公司",
                    "id": 209096
                }, {
                    "name": "香港京东智能",
                    "id": 209097
                }, {
                    "name": "杭州平安证券",
                    "id": 209098
                }, {
                    "name": "东莞欧珀医药",
                    "id": 209099
                }]
            }, {
                "name": "纽约瑞幸芯片",
                "id": 209100
            }, {
                "name": "广州小米诊所",
                "id": 209101
            }, {
                "name": "南京美团医药",
                "id": 209102
            }, {
                "name": "杭州滴滴计算机控股集团",
                "id": 209103
            }, {
                "name": "天津欧珀科技",
                "id": 209104
            }, {
                "name": "台北美团航空有限公司",
                "id": 209105
            }, {
                "name": "北京腾讯",
                "id": 209106
            }, {
                "name": "杭州滴滴新能源",
                "id": 209107
            }, {
                "name": "纽约亚马逊电商有限公司",
                "id": 209108,
                "children": [{
                    "name": "北京美团",
                    "id": 209109,
                    "children": [{
                        "name": "天津瑞幸餐饮",
                        "id": 209110
                    }, {
                        "name": "深圳亚马逊通信有限公司",
                        "id": 209111
                    }, {
                        "name": "天津肯德基渔业",
                        "id": 209112
                    }, {
                        "name": "首尔星巴克医药有限公司",
                        "id": 209113
                    }, {
                        "name": "纽约华为制造",
                        "id": 209114
                    }, {
                        "name": "上海星巴克软件控股集团",
                        "id": 209115
                    }, {
                        "name": "南京百度计算机",
                        "id": 209116
                    }, {
                        "name": "杭州亚马逊医院",
                        "id": 209117
                    }, {
                        "name": "上海特斯拉计算机",
                        "id": 209118
                    }, {
                        "name": "香港苹果牧业有限公司",
                        "id": 209119
                    }, {
                        "name": "杭州平安航空",
                        "id": 209120
                    }, {
                        "name": "上海特斯拉养殖",
                        "id": 209121
                    }, {
                        "name": "深圳必胜客汽车有限公司",
                        "id": 209122
                    }, {
                        "name": "广州阿里餐饮",
                        "id": 209123
                    }, {
                        "name": "首尔必胜客科技控股集团",
                        "id": 209124
                    }, {
                        "name": "上海滴滴石油",
                        "id": 209125
                    }, {
                        "name": "厦门华为渔业控股集团",
                        "id": 209126
                    }, {
                        "name": "东莞字节农业",
                        "id": 209127
                    }, {
                        "name": "东莞快手信息服务",
                        "id": 209128
                    }, {
                        "name": "厦门亚马逊信息服务有限公司",
                        "id": 209129
                    }, {
                        "name": "台北奈雪芯片",
                        "id": 209130
                    }, {
                        "name": "厦门必胜客通讯有限公司",
                        "id": 209131
                    }, {
                        "name": "广州谷歌餐饮控股集团",
                        "id": 209132
                    }, {
                        "name": "香港喜茶养殖有限公司",
                        "id": 209133
                    }, {
                        "name": "南京华为证券",
                        "id": 209134
                    }, {
                        "name": "首尔亚马逊通信",
                        "id": 209135
                    }, {
                        "name": "杭州星巴克计算机",
                        "id": 209136
                    }, {
                        "name": "南京滴滴养殖",
                        "id": 209137
                    }, {
                        "name": "北京滴滴通信",
                        "id": 209138
                    }, {
                        "name": "东京小米地摊",
                        "id": 209139
                    }]
                }, {
                    "name": "天津平安银行",
                    "id": 209140,
                    "children": [{
                        "name": "台北喜茶信息服务",
                        "id": 209141
                    }, {
                        "name": "东莞字节智能",
                        "id": 209142
                    }, {
                        "name": "南京特斯拉医药控股集团",
                        "id": 209143
                    }, {
                        "name": "上海亚马逊旅游",
                        "id": 209144
                    }, {
                        "name": "杭州欧珀电商有限公司",
                        "id": 209145
                    }, {
                        "name": "上海星巴克信息服务",
                        "id": 209146
                    }, {
                        "name": "上海京东智能有限公司",
                        "id": 209147
                    }, {
                        "name": "南京滴滴医院有限公司",
                        "id": 209148
                    }, {
                        "name": "香港小米医药",
                        "id": 209149
                    }, {
                        "name": "东莞京东芯片控股集团",
                        "id": 209150
                    }, {
                        "name": "北京瑞幸地产",
                        "id": 209151
                    }, {
                        "name": "北京欧珀基金有限公司",
                        "id": 209152
                    }, {
                        "name": "广州华为新能源控股集团",
                        "id": 209153
                    }, {
                        "name": "纽约微软电商",
                        "id": 209154
                    }, {
                        "name": "香港喜茶制造",
                        "id": 209155
                    }, {
                        "name": "首尔欧珀证券",
                        "id": 209156
                    }, {
                        "name": "广州华为新能源控股集团",
                        "id": 209157
                    }, {
                        "name": "首尔亚马逊石油",
                        "id": 209158
                    }, {
                        "name": "杭州美团渔业",
                        "id": 209159
                    }, {
                        "name": "杭州京东航空",
                        "id": 209160
                    }, {
                        "name": "纽约阿里银行",
                        "id": 209161
                    }, {
                        "name": "首尔必胜客软件",
                        "id": 209162
                    }, {
                        "name": "东京奈雪新能源有限公司",
                        "id": 209163
                    }, {
                        "name": "首尔喜茶旅游控股集团",
                        "id": 209164
                    }, {
                        "name": "南京苹果养殖",
                        "id": 209165
                    }, {
                        "name": "香港亚马逊石油",
                        "id": 209166
                    }, {
                        "name": "南京蚂蚁新能源控股集团",
                        "id": 209167
                    }, {
                        "name": "杭州瑞幸计算机",
                        "id": 209168
                    }, {
                        "name": "纽约阿里餐饮",
                        "id": 209169
                    }, {
                        "name": "天津亚马逊旅游",
                        "id": 209170
                    }, {
                        "name": "南京腾讯农业有限公司",
                        "id": 209171
                    }, {
                        "name": "厦门小米计算机",
                        "id": 209172
                    }, {
                        "name": "广州必胜客银行控股集团",
                        "id": 209173
                    }, {
                        "name": "杭州瑞幸医院",
                        "id": 209174
                    }, {
                        "name": "纽约蚂蚁智能",
                        "id": 209175
                    }]
                }]
            }, {
                "name": "上海肯德基银行",
                "id": 209176
            }, {
                "name": "天津美团医药",
                "id": 209177,
                "children": [{
                    "name": "东京华为石油有限公司",
                    "id": 209178
                }, {
                    "name": "杭州平安银行有限公司",
                    "id": 209179,
                    "children": [{
                        "name": "厦门微软互金",
                        "id": 209180
                    }, {
                        "name": "南京美团芯片有限公司",
                        "id": 209181
                    }, {
                        "name": "纽约必胜客制造",
                        "id": 209182
                    }, {
                        "name": "上海星巴克地摊有限公司",
                        "id": 209183
                    }, {
                        "name": "香港蚂蚁航空",
                        "id": 209184
                    }, {
                        "name": "天津喜茶计算机有限公司",
                        "id": 209185
                    }, {
                        "name": "纽约必胜客通讯",
                        "id": 209186
                    }, {
                        "name": "上海微软诊所控股集团",
                        "id": 209187
                    }]
                }, {
                    "name": "香港美团控股集团",
                    "id": 209188,
                    "children": [{
                        "name": "深圳蚂蚁餐饮有限公司",
                        "id": 209189
                    }, {
                        "name": "杭州星巴克汽车",
                        "id": 209190
                    }, {
                        "name": "台北必胜客旅游有限公司",
                        "id": 209191
                    }, {
                        "name": "东京阿里证券",
                        "id": 209192
                    }, {
                        "name": "广州京东互金",
                        "id": 209193
                    }, {
                        "name": "广州必胜客",
                        "id": 209194
                    }, {
                        "name": "杭州必胜客基金",
                        "id": 209195
                    }, {
                        "name": "杭州百度计算机控股集团",
                        "id": 209196
                    }, {
                        "name": "首尔亚马逊新能源有限公司",
                        "id": 209197
                    }, {
                        "name": "杭州喜茶医药有限公司",
                        "id": 209198
                    }, {
                        "name": "南京平安养殖",
                        "id": 209199
                    }, {
                        "name": "南京京东石油",
                        "id": 209200
                    }, {
                        "name": "广州奈雪牧业有限公司",
                        "id": 209201
                    }, {
                        "name": "天津亚马逊科技",
                        "id": 209202
                    }, {
                        "name": "广州微软电商控股集团",
                        "id": 209203
                    }, {
                        "name": "深圳欧珀医药",
                        "id": 209204
                    }, {
                        "name": "北京喜茶智能",
                        "id": 209205
                    }, {
                        "name": "纽约欧珀证券",
                        "id": 209206
                    }, {
                        "name": "纽约美团电商",
                        "id": 209207
                    }]
                }, {
                    "name": "台北特斯拉渔业控股集团",
                    "id": 209208
                }, {
                    "name": "天津喜茶电商有限公司",
                    "id": 209209,
                    "children": [{
                        "name": "南京谷歌石油",
                        "id": 209210
                    }, {
                        "name": "首尔奈雪软件",
                        "id": 209211
                    }, {
                        "name": "厦门喜茶软件",
                        "id": 209212
                    }, {
                        "name": "杭州瑞幸",
                        "id": 209213
                    }, {
                        "name": "杭州喜茶通信",
                        "id": 209214
                    }, {
                        "name": "纽约蚂蚁医院",
                        "id": 209215
                    }]
                }, {
                    "name": "南京奈雪信息服务",
                    "id": 209216
                }, {
                    "name": "首尔快手石油",
                    "id": 209217
                }, {
                    "name": "纽约快手牧业控股集团",
                    "id": 209218
                }, {
                    "name": "杭州奈雪地摊",
                    "id": 209219
                }, {
                    "name": "首尔星巴克科技",
                    "id": 209220
                }, {
                    "name": "台北滴滴证券",
                    "id": 209221,
                    "children": [{
                        "name": "香港星巴克医院控股集团",
                        "id": 209222
                    }, {
                        "name": "东京滴滴基金有限公司",
                        "id": 209223
                    }, {
                        "name": "台北滴滴新能源控股集团",
                        "id": 209224
                    }, {
                        "name": "上海喜茶地产",
                        "id": 209225
                    }, {
                        "name": "台北百度互金控股集团",
                        "id": 209226
                    }]
                }, {
                    "name": "杭州谷歌医药控股集团",
                    "id": 209227
                }, {
                    "name": "北京腾讯基金",
                    "id": 209228,
                    "children": [{
                        "name": "台北肯德基通讯",
                        "id": 209229
                    }, {
                        "name": "纽约小米地摊",
                        "id": 209230
                    }, {
                        "name": "南京特斯拉农业",
                        "id": 209231
                    }, {
                        "name": "广州百度控股集团",
                        "id": 209232
                    }, {
                        "name": "杭州字节证券控股集团",
                        "id": 209233
                    }, {
                        "name": "香港滴滴通信有限公司",
                        "id": 209234
                    }, {
                        "name": "广州欧珀石油控股集团",
                        "id": 209235
                    }, {
                        "name": "广州滴滴金融",
                        "id": 209236
                    }, {
                        "name": "东莞星巴克医药",
                        "id": 209237
                    }, {
                        "name": "东京星巴克医院",
                        "id": 209238
                    }, {
                        "name": "上海腾讯",
                        "id": 209239
                    }, {
                        "name": "东京京东旅游",
                        "id": 209240
                    }]
                }, {
                    "name": "纽约百度计算机",
                    "id": 209241,
                    "children": [{
                        "name": "杭州腾讯餐饮有限公司",
                        "id": 209242
                    }, {
                        "name": "天津美团",
                        "id": 209243
                    }, {
                        "name": "首尔平安地产控股集团",
                        "id": 209244
                    }]
                }, {
                    "name": "东京京东制造",
                    "id": 209245
                }]
            }, {
                "name": "台北瑞幸农业有限公司",
                "id": 209246
            }, {
                "name": "香港字节新能源",
                "id": 209247
            }, {
                "name": "纽约星巴克基金有限公司",
                "id": 209248
            }, {
                "name": "杭州平安智能控股集团",
                "id": 209249
            }, {
                "name": "首尔微软电商控股集团",
                "id": 209250,
                "children": [{
                    "name": "深圳阿里电商",
                    "id": 209251
                }, {
                    "name": "首尔亚马逊互金",
                    "id": 209252,
                    "children": [{
                        "name": "纽约美团地产",
                        "id": 209253
                    }, {
                        "name": "香港特斯拉科技",
                        "id": 209254
                    }, {
                        "name": "上海瑞幸农业控股集团",
                        "id": 209255
                    }, {
                        "name": "南京蚂蚁医药",
                        "id": 209256
                    }, {
                        "name": "纽约微软银行",
                        "id": 209257
                    }, {
                        "name": "台北字节医药",
                        "id": 209258
                    }, {
                        "name": "南京必胜客地产",
                        "id": 209259
                    }, {
                        "name": "上海百度互金控股集团",
                        "id": 209260
                    }, {
                        "name": "厦门蚂蚁科技",
                        "id": 209261
                    }, {
                        "name": "上海苹果控股集团",
                        "id": 209262
                    }, {
                        "name": "杭州腾讯制造有限公司",
                        "id": 209263
                    }, {
                        "name": "北京滴滴银行",
                        "id": 209264
                    }, {
                        "name": "上海苹果牧业",
                        "id": 209265
                    }, {
                        "name": "纽约滴滴诊所",
                        "id": 209266
                    }, {
                        "name": "香港瑞幸通讯控股集团",
                        "id": 209267
                    }, {
                        "name": "上海百度计算机",
                        "id": 209268
                    }, {
                        "name": "厦门京东诊所",
                        "id": 209269
                    }, {
                        "name": "杭州快手",
                        "id": 209270
                    }, {
                        "name": "广州奈雪医院",
                        "id": 209271
                    }, {
                        "name": "首尔亚马逊基金控股集团",
                        "id": 209272
                    }, {
                        "name": "南京奈雪互金",
                        "id": 209273
                    }]
                }, {
                    "name": "香港肯德基通信",
                    "id": 209274
                }, {
                    "name": "北京微软诊所有限公司",
                    "id": 209275
                }, {
                    "name": "北京美团电商",
                    "id": 209276,
                    "children": [{
                        "name": "首尔滴滴渔业",
                        "id": 209277
                    }, {
                        "name": "东京美团",
                        "id": 209278
                    }, {
                        "name": "杭州快手信息服务",
                        "id": 209279
                    }, {
                        "name": "杭州亚马逊基金",
                        "id": 209280
                    }, {
                        "name": "纽约快手农业",
                        "id": 209281
                    }, {
                        "name": "杭州喜茶医院",
                        "id": 209282
                    }, {
                        "name": "杭州星巴克地产",
                        "id": 209283
                    }, {
                        "name": "东莞蚂蚁石油",
                        "id": 209284
                    }, {
                        "name": "纽约腾讯",
                        "id": 209285
                    }, {
                        "name": "香港欧珀医院",
                        "id": 209286
                    }, {
                        "name": "北京美团通讯",
                        "id": 209287
                    }, {
                        "name": "首尔喜茶通信",
                        "id": 209288
                    }, {
                        "name": "杭州快手汽车",
                        "id": 209289
                    }, {
                        "name": "东莞喜茶渔业有限公司",
                        "id": 209290
                    }]
                }, {
                    "name": "厦门亚马逊农业",
                    "id": 209291
                }, {
                    "name": "北京星巴克",
                    "id": 209292,
                    "children": [{
                        "name": "北京苹果金融",
                        "id": 209293
                    }, {
                        "name": "纽约滴滴通讯",
                        "id": 209294
                    }, {
                        "name": "东京特斯拉石油",
                        "id": 209295
                    }, {
                        "name": "南京阿里计算机",
                        "id": 209296
                    }, {
                        "name": "首尔滴滴旅游",
                        "id": 209297
                    }, {
                        "name": "首尔奈雪电商",
                        "id": 209298
                    }, {
                        "name": "杭州亚马逊",
                        "id": 209299
                    }, {
                        "name": "天津百度农业有限公司",
                        "id": 209300
                    }, {
                        "name": "厦门小米信息服务控股集团",
                        "id": 209301
                    }, {
                        "name": "东莞平安餐饮",
                        "id": 209302
                    }, {
                        "name": "东莞奈雪芯片",
                        "id": 209303
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 209304
                    }, {
                        "name": "纽约特斯拉农业",
                        "id": 209305
                    }]
                }, {
                    "name": "台北肯德基基金",
                    "id": 209306,
                    "children": [{
                        "name": "广州滴滴石油控股集团",
                        "id": 209307
                    }, {
                        "name": "广州特斯拉芯片",
                        "id": 209308
                    }, {
                        "name": "深圳星巴克医药",
                        "id": 209309
                    }]
                }, {
                    "name": "北京京东计算机控股集团",
                    "id": 209310
                }, {
                    "name": "广州谷歌信息服务",
                    "id": 209311
                }, {
                    "name": "上海喜茶医院有限公司",
                    "id": 209312
                }, {
                    "name": "首尔谷歌互金控股集团",
                    "id": 209313
                }, {
                    "name": "东莞星巴克地摊有限公司",
                    "id": 209314
                }, {
                    "name": "北京百度养殖",
                    "id": 209315
                }, {
                    "name": "纽约星巴克牧业",
                    "id": 209316
                }, {
                    "name": "上海星巴克金融有限公司",
                    "id": 209317,
                    "children": [{
                        "name": "深圳京东基金",
                        "id": 209318
                    }, {
                        "name": "杭州瑞幸通讯",
                        "id": 209319
                    }, {
                        "name": "上海微软信息服务控股集团",
                        "id": 209320
                    }, {
                        "name": "厦门华为科技",
                        "id": 209321
                    }, {
                        "name": "东京谷歌互金",
                        "id": 209322
                    }, {
                        "name": "杭州滴滴地摊",
                        "id": 209323
                    }, {
                        "name": "首尔百度银行",
                        "id": 209324
                    }, {
                        "name": "北京必胜客医药",
                        "id": 209325
                    }, {
                        "name": "杭州奈雪电商",
                        "id": 209326
                    }, {
                        "name": "上海百度计算机",
                        "id": 209327
                    }, {
                        "name": "杭州奈雪计算机有限公司",
                        "id": 209328
                    }, {
                        "name": "杭州华为餐饮控股集团",
                        "id": 209329
                    }, {
                        "name": "东京欧珀医院",
                        "id": 209330
                    }, {
                        "name": "杭州京东软件",
                        "id": 209331
                    }, {
                        "name": "台北蚂蚁",
                        "id": 209332
                    }, {
                        "name": "天津奈雪汽车有限公司",
                        "id": 209333
                    }, {
                        "name": "台北谷歌新能源",
                        "id": 209334
                    }, {
                        "name": "北京喜茶信息服务",
                        "id": 209335
                    }, {
                        "name": "东京百度航空",
                        "id": 209336
                    }, {
                        "name": "杭州小米餐饮控股集团",
                        "id": 209337
                    }, {
                        "name": "深圳京东科技",
                        "id": 209338
                    }, {
                        "name": "厦门华为牧业控股集团",
                        "id": 209339
                    }, {
                        "name": "东莞字节牧业",
                        "id": 209340
                    }, {
                        "name": "首尔快手金融",
                        "id": 209341
                    }]
                }, {
                    "name": "纽约百度制造",
                    "id": 209342
                }, {
                    "name": "广州平安农业有限公司",
                    "id": 209343,
                    "children": [{
                        "name": "台北特斯拉汽车控股集团",
                        "id": 209344
                    }, {
                        "name": "纽约蚂蚁",
                        "id": 209345
                    }, {
                        "name": "杭州平安银行",
                        "id": 209346
                    }, {
                        "name": "杭州百度通信",
                        "id": 209347
                    }, {
                        "name": "杭州奈雪软件",
                        "id": 209348
                    }, {
                        "name": "上海亚马逊证券",
                        "id": 209349
                    }, {
                        "name": "香港快手通讯",
                        "id": 209350
                    }]
                }, {
                    "name": "杭州奈雪计算机控股集团",
                    "id": 209351,
                    "children": [{
                        "name": "深圳京东控股集团",
                        "id": 209352
                    }, {
                        "name": "天津腾讯旅游控股集团",
                        "id": 209353
                    }, {
                        "name": "深圳喜茶医院",
                        "id": 209354
                    }, {
                        "name": "杭州亚马逊证券控股集团",
                        "id": 209355
                    }, {
                        "name": "深圳瑞幸地产",
                        "id": 209356
                    }, {
                        "name": "东京必胜客诊所控股集团",
                        "id": 209357
                    }, {
                        "name": "广州美团地产控股集团",
                        "id": 209358
                    }, {
                        "name": "广州特斯拉电商控股集团",
                        "id": 209359
                    }]
                }]
            }, {
                "name": "广州腾讯农业",
                "id": 209360
            }, {
                "name": "天津特斯拉新能源控股集团",
                "id": 209361
            }, {
                "name": "香港京东汽车有限公司",
                "id": 209362,
                "children": [{
                    "name": "杭州微软通讯有限公司",
                    "id": 209363,
                    "children": [{
                        "name": "东京奈雪证券有限公司",
                        "id": 209364
                    }, {
                        "name": "厦门腾讯通信控股集团",
                        "id": 209365
                    }, {
                        "name": "上海肯德基渔业有限公司",
                        "id": 209366
                    }, {
                        "name": "深圳谷歌芯片",
                        "id": 209367
                    }, {
                        "name": "杭州欧珀渔业控股集团",
                        "id": 209368
                    }, {
                        "name": "杭州欧珀医院控股集团",
                        "id": 209369
                    }, {
                        "name": "深圳平安芯片控股集团",
                        "id": 209370
                    }, {
                        "name": "台北阿里地产控股集团",
                        "id": 209371
                    }, {
                        "name": "台北喜茶地摊",
                        "id": 209372
                    }, {
                        "name": "香港字节芯片",
                        "id": 209373
                    }, {
                        "name": "北京百度通信",
                        "id": 209374
                    }, {
                        "name": "杭州特斯拉新能源控股集团",
                        "id": 209375
                    }, {
                        "name": "杭州星巴克养殖控股集团",
                        "id": 209376
                    }, {
                        "name": "东莞滴滴制造",
                        "id": 209377
                    }, {
                        "name": "杭州字节餐饮有限公司",
                        "id": 209378
                    }, {
                        "name": "深圳蚂蚁医药",
                        "id": 209379
                    }]
                }, {
                    "name": "台北喜茶牧业有限公司",
                    "id": 209380,
                    "children": [{
                        "name": "台北奈雪信息服务",
                        "id": 209381
                    }, {
                        "name": "天津平安智能",
                        "id": 209382
                    }, {
                        "name": "东莞肯德基金融有限公司",
                        "id": 209383
                    }, {
                        "name": "东京瑞幸渔业",
                        "id": 209384
                    }, {
                        "name": "香港星巴克新能源",
                        "id": 209385
                    }, {
                        "name": "香港瑞幸计算机",
                        "id": 209386
                    }, {
                        "name": "东莞蚂蚁诊所",
                        "id": 209387
                    }]
                }]
            }, {
                "name": "纽约瑞幸制造控股集团",
                "id": 209388
            }, {
                "name": "东京平安诊所",
                "id": 209389
            }, {
                "name": "厦门欧珀餐饮",
                "id": 209390
            }]
        }, {
            "name": "南京星巴克基金",
            "id": 209391,
            "children": [{
                "name": "杭州微软石油",
                "id": 209392
            }, {
                "name": "厦门星巴克芯片有限公司",
                "id": 209393
            }, {
                "name": "首尔小米医院",
                "id": 209394
            }, {
                "name": "首尔蚂蚁基金",
                "id": 209395,
                "children": [{
                    "name": "天津欧珀诊所",
                    "id": 209396
                }, {
                    "name": "厦门谷歌金融有限公司",
                    "id": 209397
                }, {
                    "name": "杭州阿里金融",
                    "id": 209398
                }, {
                    "name": "香港华为",
                    "id": 209399
                }, {
                    "name": "首尔美团通讯控股集团",
                    "id": 209400
                }, {
                    "name": "深圳微软牧业有限公司",
                    "id": 209401
                }, {
                    "name": "纽约微软",
                    "id": 209402
                }, {
                    "name": "纽约奈雪信息服务",
                    "id": 209403,
                    "children": [{
                        "name": "香港亚马逊金融",
                        "id": 209404
                    }, {
                        "name": "厦门瑞幸科技",
                        "id": 209405
                    }, {
                        "name": "广州美团新能源",
                        "id": 209406
                    }, {
                        "name": "纽约喜茶旅游",
                        "id": 209407
                    }, {
                        "name": "首尔京东餐饮控股集团",
                        "id": 209408
                    }, {
                        "name": "南京瑞幸制造",
                        "id": 209409
                    }, {
                        "name": "纽约喜茶电商",
                        "id": 209410
                    }, {
                        "name": "首尔滴滴软件",
                        "id": 209411
                    }, {
                        "name": "香港京东证券",
                        "id": 209412
                    }, {
                        "name": "广州必胜客航空控股集团",
                        "id": 209413
                    }, {
                        "name": "南京阿里渔业",
                        "id": 209414
                    }, {
                        "name": "台北欧珀渔业",
                        "id": 209415
                    }, {
                        "name": "天津平安有限公司",
                        "id": 209416
                    }, {
                        "name": "东莞字节互金",
                        "id": 209417
                    }, {
                        "name": "东莞肯德基计算机",
                        "id": 209418
                    }, {
                        "name": "香港美团基金",
                        "id": 209419
                    }, {
                        "name": "天津亚马逊医院有限公司",
                        "id": 209420
                    }, {
                        "name": "首尔微软芯片",
                        "id": 209421
                    }, {
                        "name": "北京星巴克航空有限公司",
                        "id": 209422
                    }, {
                        "name": "上海瑞幸计算机",
                        "id": 209423
                    }, {
                        "name": "深圳瑞幸银行",
                        "id": 209424
                    }, {
                        "name": "上海瑞幸新能源",
                        "id": 209425
                    }, {
                        "name": "南京微软控股集团",
                        "id": 209426
                    }, {
                        "name": "南京百度诊所有限公司",
                        "id": 209427
                    }, {
                        "name": "上海微软通讯",
                        "id": 209428
                    }, {
                        "name": "首尔华为信息服务控股集团",
                        "id": 209429
                    }, {
                        "name": "广州谷歌互金",
                        "id": 209430
                    }, {
                        "name": "广州谷歌智能",
                        "id": 209431
                    }, {
                        "name": "天津特斯拉地产",
                        "id": 209432
                    }, {
                        "name": "东京美团新能源",
                        "id": 209433
                    }]
                }, {
                    "name": "深圳美团科技有限公司",
                    "id": 209434,
                    "children": [{
                        "name": "杭州美团智能控股集团",
                        "id": 209435
                    }, {
                        "name": "纽约苹果餐饮",
                        "id": 209436
                    }, {
                        "name": "纽约美团航空",
                        "id": 209437
                    }, {
                        "name": "深圳奈雪新能源有限公司",
                        "id": 209438
                    }, {
                        "name": "深圳肯德基软件控股集团",
                        "id": 209439
                    }, {
                        "name": "杭州百度制造控股集团",
                        "id": 209440
                    }, {
                        "name": "东京亚马逊新能源有限公司",
                        "id": 209441
                    }, {
                        "name": "首尔微软制造有限公司",
                        "id": 209442
                    }, {
                        "name": "深圳谷歌诊所",
                        "id": 209443
                    }, {
                        "name": "首尔亚马逊制造控股集团",
                        "id": 209444
                    }, {
                        "name": "东京谷歌养殖",
                        "id": 209445
                    }, {
                        "name": "台北奈雪新能源",
                        "id": 209446
                    }, {
                        "name": "北京蚂蚁金融有限公司",
                        "id": 209447
                    }, {
                        "name": "南京京东芯片",
                        "id": 209448
                    }, {
                        "name": "东京字节汽车",
                        "id": 209449
                    }, {
                        "name": "香港美团有限公司",
                        "id": 209450
                    }, {
                        "name": "首尔蚂蚁旅游",
                        "id": 209451
                    }, {
                        "name": "天津阿里制造控股集团",
                        "id": 209452
                    }, {
                        "name": "杭州肯德基新能源",
                        "id": 209453
                    }, {
                        "name": "东京谷歌渔业",
                        "id": 209454
                    }, {
                        "name": "杭州腾讯软件",
                        "id": 209455
                    }, {
                        "name": "首尔微软通信有限公司",
                        "id": 209456
                    }, {
                        "name": "东京苹果",
                        "id": 209457
                    }, {
                        "name": "南京阿里",
                        "id": 209458
                    }, {
                        "name": "南京星巴克计算机",
                        "id": 209459
                    }, {
                        "name": "南京京东农业",
                        "id": 209460
                    }, {
                        "name": "上海苹果科技",
                        "id": 209461
                    }, {
                        "name": "香港欧珀控股集团",
                        "id": 209462
                    }, {
                        "name": "东莞快手医院",
                        "id": 209463
                    }, {
                        "name": "深圳特斯拉银行",
                        "id": 209464
                    }]
                }, {
                    "name": "深圳肯德基信息服务",
                    "id": 209465
                }, {
                    "name": "台北腾讯金融控股集团",
                    "id": 209466
                }, {
                    "name": "厦门肯德基牧业有限公司",
                    "id": 209467
                }, {
                    "name": "台北瑞幸旅游",
                    "id": 209468
                }, {
                    "name": "深圳平安计算机",
                    "id": 209469
                }, {
                    "name": "台北平安新能源控股集团",
                    "id": 209470
                }, {
                    "name": "杭州阿里",
                    "id": 209471
                }, {
                    "name": "天津星巴克信息服务",
                    "id": 209472
                }, {
                    "name": "天津谷歌农业",
                    "id": 209473
                }, {
                    "name": "厦门快手医药",
                    "id": 209474
                }, {
                    "name": "台北谷歌通信",
                    "id": 209475
                }, {
                    "name": "上海阿里通讯有限公司",
                    "id": 209476
                }, {
                    "name": "南京百度医药",
                    "id": 209477
                }, {
                    "name": "广州平安基金",
                    "id": 209478
                }, {
                    "name": "东莞肯德基石油",
                    "id": 209479
                }, {
                    "name": "首尔字节医药有限公司",
                    "id": 209480,
                    "children": [{
                        "name": "厦门肯德基",
                        "id": 209481
                    }, {
                        "name": "杭州腾讯信息服务",
                        "id": 209482
                    }, {
                        "name": "杭州滴滴石油有限公司",
                        "id": 209483
                    }, {
                        "name": "厦门阿里医院",
                        "id": 209484
                    }, {
                        "name": "纽约腾讯通讯",
                        "id": 209485
                    }, {
                        "name": "北京快手新能源",
                        "id": 209486
                    }, {
                        "name": "杭州微软渔业",
                        "id": 209487
                    }, {
                        "name": "首尔欧珀证券",
                        "id": 209488
                    }, {
                        "name": "广州腾讯通讯",
                        "id": 209489
                    }, {
                        "name": "深圳瑞幸制造",
                        "id": 209490
                    }, {
                        "name": "深圳喜茶软件",
                        "id": 209491
                    }]
                }, {
                    "name": "厦门特斯拉银行控股集团",
                    "id": 209492
                }, {
                    "name": "广州字节控股集团",
                    "id": 209493
                }, {
                    "name": "上海苹果养殖",
                    "id": 209494
                }, {
                    "name": "杭州小米养殖",
                    "id": 209495
                }, {
                    "name": "台北快手餐饮",
                    "id": 209496,
                    "children": [{
                        "name": "东京肯德基汽车控股集团",
                        "id": 209497
                    }, {
                        "name": "东京喜茶地产",
                        "id": 209498
                    }, {
                        "name": "杭州谷歌旅游控股集团",
                        "id": 209499
                    }, {
                        "name": "深圳京东电商控股集团",
                        "id": 209500
                    }, {
                        "name": "深圳百度新能源有限公司",
                        "id": 209501
                    }, {
                        "name": "上海小米互金",
                        "id": 209502
                    }, {
                        "name": "南京滴滴智能",
                        "id": 209503
                    }, {
                        "name": "北京瑞幸通信",
                        "id": 209504
                    }, {
                        "name": "东京小米信息服务有限公司",
                        "id": 209505
                    }, {
                        "name": "天津华为通讯",
                        "id": 209506
                    }, {
                        "name": "上海喜茶芯片有限公司",
                        "id": 209507
                    }, {
                        "name": "上海肯德基互金",
                        "id": 209508
                    }, {
                        "name": "南京华为证券",
                        "id": 209509
                    }, {
                        "name": "北京快手互金有限公司",
                        "id": 209510
                    }, {
                        "name": "厦门亚马逊银行",
                        "id": 209511
                    }, {
                        "name": "上海平安农业",
                        "id": 209512
                    }, {
                        "name": "杭州星巴克",
                        "id": 209513
                    }, {
                        "name": "纽约微软石油有限公司",
                        "id": 209514
                    }, {
                        "name": "天津欧珀农业有限公司",
                        "id": 209515
                    }, {
                        "name": "杭州肯德基芯片控股集团",
                        "id": 209516
                    }, {
                        "name": "台北肯德基餐饮",
                        "id": 209517
                    }]
                }, {
                    "name": "纽约谷歌金融控股集团",
                    "id": 209518
                }, {
                    "name": "厦门小米航空有限公司",
                    "id": 209519
                }, {
                    "name": "东莞奈雪地产",
                    "id": 209520
                }, {
                    "name": "首尔华为通信",
                    "id": 209521,
                    "children": [{
                        "name": "北京特斯拉通讯控股集团",
                        "id": 209522
                    }, {
                        "name": "杭州星巴克芯片",
                        "id": 209523
                    }, {
                        "name": "北京蚂蚁汽车",
                        "id": 209524
                    }, {
                        "name": "杭州华为新能源控股集团",
                        "id": 209525
                    }, {
                        "name": "东莞必胜客银行有限公司",
                        "id": 209526
                    }, {
                        "name": "东莞奈雪",
                        "id": 209527
                    }, {
                        "name": "广州特斯拉",
                        "id": 209528
                    }, {
                        "name": "东京字节证券",
                        "id": 209529
                    }, {
                        "name": "东莞腾讯软件",
                        "id": 209530
                    }, {
                        "name": "首尔特斯拉基金",
                        "id": 209531
                    }, {
                        "name": "上海肯德基牧业",
                        "id": 209532
                    }, {
                        "name": "上海必胜客新能源",
                        "id": 209533
                    }, {
                        "name": "北京小米控股集团",
                        "id": 209534
                    }, {
                        "name": "香港京东旅游",
                        "id": 209535
                    }, {
                        "name": "深圳谷歌智能控股集团",
                        "id": 209536
                    }, {
                        "name": "杭州美团",
                        "id": 209537
                    }, {
                        "name": "广州肯德基有限公司",
                        "id": 209538
                    }, {
                        "name": "杭州京东牧业控股集团",
                        "id": 209539
                    }, {
                        "name": "南京肯德基医院控股集团",
                        "id": 209540
                    }]
                }, {
                    "name": "杭州京东金融",
                    "id": 209541,
                    "children": [{
                        "name": "南京谷歌电商",
                        "id": 209542
                    }, {
                        "name": "广州必胜客计算机有限公司",
                        "id": 209543
                    }, {
                        "name": "香港肯德基餐饮",
                        "id": 209544
                    }, {
                        "name": "香港美团芯片",
                        "id": 209545
                    }, {
                        "name": "东京平安基金",
                        "id": 209546
                    }, {
                        "name": "北京喜茶诊所",
                        "id": 209547
                    }, {
                        "name": "厦门百度餐饮",
                        "id": 209548
                    }, {
                        "name": "东莞特斯拉医院控股集团",
                        "id": 209549
                    }, {
                        "name": "深圳阿里渔业有限公司",
                        "id": 209550
                    }, {
                        "name": "东莞瑞幸互金",
                        "id": 209551
                    }, {
                        "name": "台北谷歌",
                        "id": 209552
                    }, {
                        "name": "北京瑞幸餐饮",
                        "id": 209553
                    }, {
                        "name": "天津喜茶信息服务",
                        "id": 209554
                    }, {
                        "name": "杭州百度新能源",
                        "id": 209555
                    }, {
                        "name": "杭州微软",
                        "id": 209556
                    }, {
                        "name": "广州喜茶互金",
                        "id": 209557
                    }, {
                        "name": "北京肯德基互金有限公司",
                        "id": 209558
                    }, {
                        "name": "香港谷歌渔业",
                        "id": 209559
                    }, {
                        "name": "天津欧珀通信控股集团",
                        "id": 209560
                    }, {
                        "name": "东京蚂蚁通讯",
                        "id": 209561
                    }, {
                        "name": "杭州亚马逊电商",
                        "id": 209562
                    }, {
                        "name": "深圳肯德基牧业",
                        "id": 209563
                    }, {
                        "name": "杭州腾讯计算机",
                        "id": 209564
                    }, {
                        "name": "上海欧珀医院",
                        "id": 209565
                    }]
                }]
            }]
        }, {
            "name": "南京欧珀通信",
            "id": 209566
        }, {
            "name": "纽约腾讯医院",
            "id": 209567,
            "children": [{
                "name": "杭州美团科技",
                "id": 209568
            }, {
                "name": "上海京东地摊",
                "id": 209569
            }, {
                "name": "杭州字节金融",
                "id": 209570,
                "children": [{
                    "name": "南京特斯拉证券",
                    "id": 209571
                }, {
                    "name": "东莞苹果养殖控股集团",
                    "id": 209572
                }, {
                    "name": "天津喜茶渔业",
                    "id": 209573
                }, {
                    "name": "深圳快手芯片",
                    "id": 209574
                }, {
                    "name": "杭州欧珀电商",
                    "id": 209575
                }, {
                    "name": "深圳百度制造",
                    "id": 209576,
                    "children": [{
                        "name": "东莞亚马逊航空有限公司",
                        "id": 209577
                    }, {
                        "name": "北京必胜客基金",
                        "id": 209578
                    }, {
                        "name": "纽约奈雪",
                        "id": 209579
                    }, {
                        "name": "上海快手养殖",
                        "id": 209580
                    }, {
                        "name": "杭州微软养殖有限公司",
                        "id": 209581
                    }, {
                        "name": "纽约喜茶基金",
                        "id": 209582
                    }, {
                        "name": "厦门蚂蚁医院",
                        "id": 209583
                    }, {
                        "name": "首尔必胜客渔业",
                        "id": 209584
                    }, {
                        "name": "纽约奈雪芯片",
                        "id": 209585
                    }, {
                        "name": "深圳京东银行有限公司",
                        "id": 209586
                    }, {
                        "name": "上海特斯拉科技控股集团",
                        "id": 209587
                    }]
                }, {
                    "name": "纽约奈雪餐饮控股集团",
                    "id": 209588,
                    "children": [{
                        "name": "深圳亚马逊",
                        "id": 209589
                    }, {
                        "name": "上海亚马逊银行有限公司",
                        "id": 209590
                    }, {
                        "name": "东莞华为科技有限公司",
                        "id": 209591
                    }, {
                        "name": "东京平安科技有限公司",
                        "id": 209592
                    }, {
                        "name": "天津必胜客有限公司",
                        "id": 209593
                    }]
                }, {
                    "name": "天津蚂蚁",
                    "id": 209594
                }, {
                    "name": "杭州亚马逊通讯",
                    "id": 209595
                }, {
                    "name": "东京亚马逊医药有限公司",
                    "id": 209596,
                    "children": [{
                        "name": "杭州微软信息服务",
                        "id": 209597
                    }, {
                        "name": "香港微软地产",
                        "id": 209598
                    }, {
                        "name": "纽约喜茶诊所",
                        "id": 209599
                    }, {
                        "name": "上海特斯拉石油",
                        "id": 209600
                    }, {
                        "name": "广州平安金融",
                        "id": 209601
                    }, {
                        "name": "杭州小米电商控股集团",
                        "id": 209602
                    }, {
                        "name": "南京必胜客芯片有限公司",
                        "id": 209603
                    }, {
                        "name": "天津肯德基",
                        "id": 209604
                    }, {
                        "name": "纽约星巴克银行",
                        "id": 209605
                    }]
                }, {
                    "name": "杭州必胜客石油",
                    "id": 209606
                }, {
                    "name": "广州平安牧业",
                    "id": 209607
                }, {
                    "name": "南京腾讯新能源",
                    "id": 209608
                }]
            }, {
                "name": "香港美团",
                "id": 209609
            }, {
                "name": "厦门肯德基通信控股集团",
                "id": 209610,
                "children": [{
                    "name": "上海小米金融控股集团",
                    "id": 209611
                }, {
                    "name": "深圳腾讯养殖",
                    "id": 209612
                }, {
                    "name": "东莞苹果地产",
                    "id": 209613
                }, {
                    "name": "台北奈雪汽车有限公司",
                    "id": 209614
                }, {
                    "name": "深圳美团科技",
                    "id": 209615
                }, {
                    "name": "广州京东证券",
                    "id": 209616,
                    "children": [{
                        "name": "东京华为新能源",
                        "id": 209617
                    }, {
                        "name": "首尔美团航空有限公司",
                        "id": 209618
                    }, {
                        "name": "香港瑞幸证券有限公司",
                        "id": 209619
                    }, {
                        "name": "东京喜茶芯片控股集团",
                        "id": 209620
                    }, {
                        "name": "纽约滴滴新能源",
                        "id": 209621
                    }, {
                        "name": "广州苹果电商",
                        "id": 209622
                    }, {
                        "name": "台北特斯拉有限公司",
                        "id": 209623
                    }, {
                        "name": "深圳百度石油",
                        "id": 209624
                    }, {
                        "name": "台北腾讯信息服务",
                        "id": 209625
                    }, {
                        "name": "厦门欧珀农业有限公司",
                        "id": 209626
                    }]
                }, {
                    "name": "东莞微软通讯",
                    "id": 209627
                }, {
                    "name": "香港华为智能控股集团",
                    "id": 209628
                }, {
                    "name": "杭州滴滴汽车",
                    "id": 209629
                }, {
                    "name": "深圳欧珀有限公司",
                    "id": 209630
                }]
            }, {
                "name": "上海苹果基金",
                "id": 209631
            }, {
                "name": "南京字节制造",
                "id": 209632
            }, {
                "name": "首尔字节",
                "id": 209633
            }, {
                "name": "首尔腾讯有限公司",
                "id": 209634
            }, {
                "name": "杭州京东软件",
                "id": 209635
            }, {
                "name": "广州滴滴医院",
                "id": 209636
            }, {
                "name": "上海苹果基金",
                "id": 209637
            }]
        }, {
            "name": "东莞华为医药",
            "id": 209638
        }]
    }, {
        "name": "天津微软信息服务",
        "id": 209639
    }, {
        "name": "东京欧珀地摊",
        "id": 209640
    }, {
        "name": "上海微软牧业",
        "id": 209641
    }, {
        "name": "上海字节医院有限公司",
        "id": 209642,
        "children": [{
            "name": "上海微软金融",
            "id": 209643,
            "children": [{
                "name": "台北必胜客互金",
                "id": 209644
            }, {
                "name": "香港特斯拉餐饮",
                "id": 209645
            }, {
                "name": "东莞奈雪",
                "id": 209646
            }, {
                "name": "香港平安医药有限公司",
                "id": 209647
            }, {
                "name": "东京肯德基制造",
                "id": 209648
            }, {
                "name": "天津百度通信",
                "id": 209649
            }, {
                "name": "台北华为汽车控股集团",
                "id": 209650,
                "children": [{
                    "name": "杭州京东新能源",
                    "id": 209651,
                    "children": [{
                        "name": "厦门谷歌石油",
                        "id": 209652
                    }, {
                        "name": "东京必胜客通信控股集团",
                        "id": 209653
                    }, {
                        "name": "广州必胜客科技控股集团",
                        "id": 209654
                    }, {
                        "name": "纽约快手新能源",
                        "id": 209655
                    }]
                }, {
                    "name": "首尔快手信息服务",
                    "id": 209656
                }, {
                    "name": "上海蚂蚁银行",
                    "id": 209657
                }, {
                    "name": "北京小米信息服务控股集团",
                    "id": 209658
                }, {
                    "name": "北京肯德基科技",
                    "id": 209659
                }, {
                    "name": "北京奈雪软件控股集团",
                    "id": 209660
                }, {
                    "name": "广州平安地产",
                    "id": 209661
                }, {
                    "name": "杭州星巴克牧业",
                    "id": 209662
                }, {
                    "name": "东京腾讯证券控股集团",
                    "id": 209663
                }, {
                    "name": "香港快手科技",
                    "id": 209664
                }, {
                    "name": "东莞必胜客银行有限公司",
                    "id": 209665
                }, {
                    "name": "台北美团金融",
                    "id": 209666
                }, {
                    "name": "深圳滴滴",
                    "id": 209667
                }, {
                    "name": "香港星巴克医院",
                    "id": 209668
                }, {
                    "name": "杭州字节汽车控股集团",
                    "id": 209669
                }]
            }, {
                "name": "深圳喜茶餐饮有限公司",
                "id": 209670
            }, {
                "name": "香港星巴克医药",
                "id": 209671
            }, {
                "name": "首尔小米制造",
                "id": 209672
            }, {
                "name": "台北肯德基基金控股集团",
                "id": 209673
            }, {
                "name": "首尔快手信息服务",
                "id": 209674,
                "children": [{
                    "name": "天津小米旅游控股集团",
                    "id": 209675,
                    "children": [{
                        "name": "广州瑞幸渔业",
                        "id": 209676
                    }, {
                        "name": "香港奈雪电商",
                        "id": 209677
                    }, {
                        "name": "南京谷歌电商有限公司",
                        "id": 209678
                    }, {
                        "name": "深圳字节",
                        "id": 209679
                    }, {
                        "name": "纽约谷歌牧业有限公司",
                        "id": 209680
                    }, {
                        "name": "首尔滴滴通讯",
                        "id": 209681
                    }, {
                        "name": "厦门星巴克",
                        "id": 209682
                    }, {
                        "name": "南京平安基金有限公司",
                        "id": 209683
                    }, {
                        "name": "南京喜茶诊所有限公司",
                        "id": 209684
                    }, {
                        "name": "香港滴滴银行",
                        "id": 209685
                    }, {
                        "name": "香港京东通信控股集团",
                        "id": 209686
                    }, {
                        "name": "深圳平安计算机",
                        "id": 209687
                    }, {
                        "name": "杭州美团证券有限公司",
                        "id": 209688
                    }]
                }, {
                    "name": "首尔喜茶互金",
                    "id": 209689,
                    "children": [{
                        "name": "纽约华为软件控股集团",
                        "id": 209690
                    }, {
                        "name": "东京特斯拉电商",
                        "id": 209691
                    }, {
                        "name": "广州肯德基航空",
                        "id": 209692
                    }, {
                        "name": "深圳喜茶汽车",
                        "id": 209693
                    }, {
                        "name": "台北喜茶",
                        "id": 209694
                    }, {
                        "name": "纽约欧珀芯片",
                        "id": 209695
                    }, {
                        "name": "东莞腾讯制造",
                        "id": 209696
                    }, {
                        "name": "首尔星巴克医药",
                        "id": 209697
                    }, {
                        "name": "杭州肯德基互金有限公司",
                        "id": 209698
                    }, {
                        "name": "东莞百度控股集团",
                        "id": 209699
                    }, {
                        "name": "杭州亚马逊电商",
                        "id": 209700
                    }, {
                        "name": "杭州谷歌新能源控股集团",
                        "id": 209701
                    }, {
                        "name": "东莞肯德基",
                        "id": 209702
                    }, {
                        "name": "上海亚马逊渔业",
                        "id": 209703
                    }, {
                        "name": "纽约京东电商",
                        "id": 209704
                    }, {
                        "name": "杭州快手餐饮",
                        "id": 209705
                    }, {
                        "name": "厦门谷歌",
                        "id": 209706
                    }, {
                        "name": "香港星巴克电商",
                        "id": 209707
                    }, {
                        "name": "上海阿里互金",
                        "id": 209708
                    }, {
                        "name": "杭州京东制造",
                        "id": 209709
                    }, {
                        "name": "深圳肯德基基金",
                        "id": 209710
                    }, {
                        "name": "纽约华为芯片",
                        "id": 209711
                    }, {
                        "name": "广州快手渔业有限公司",
                        "id": 209712
                    }, {
                        "name": "杭州蚂蚁软件",
                        "id": 209713
                    }, {
                        "name": "东莞快手牧业",
                        "id": 209714
                    }, {
                        "name": "杭州阿里医院控股集团",
                        "id": 209715
                    }, {
                        "name": "台北瑞幸",
                        "id": 209716
                    }, {
                        "name": "东莞京东芯片",
                        "id": 209717
                    }, {
                        "name": "香港腾讯养殖有限公司",
                        "id": 209718
                    }]
                }, {
                    "name": "南京谷歌石油有限公司",
                    "id": 209719
                }, {
                    "name": "纽约必胜客医药有限公司",
                    "id": 209720
                }, {
                    "name": "深圳字节渔业控股集团",
                    "id": 209721
                }, {
                    "name": "广州喜茶信息服务",
                    "id": 209722
                }, {
                    "name": "杭州瑞幸制造控股集团",
                    "id": 209723
                }, {
                    "name": "杭州字节餐饮",
                    "id": 209724
                }, {
                    "name": "广州苹果",
                    "id": 209725,
                    "children": [{
                        "name": "厦门瑞幸科技有限公司",
                        "id": 209726
                    }, {
                        "name": "上海阿里地摊有限公司",
                        "id": 209727
                    }, {
                        "name": "台北滴滴信息服务",
                        "id": 209728
                    }, {
                        "name": "厦门微软诊所",
                        "id": 209729
                    }, {
                        "name": "香港字节养殖",
                        "id": 209730
                    }, {
                        "name": "广州蚂蚁",
                        "id": 209731
                    }, {
                        "name": "纽约华为养殖有限公司",
                        "id": 209732
                    }, {
                        "name": "深圳腾讯汽车",
                        "id": 209733
                    }, {
                        "name": "东京快手控股集团",
                        "id": 209734
                    }, {
                        "name": "天津阿里互金",
                        "id": 209735
                    }, {
                        "name": "首尔腾讯医院控股集团",
                        "id": 209736
                    }, {
                        "name": "南京必胜客有限公司",
                        "id": 209737
                    }, {
                        "name": "东京平安汽车控股集团",
                        "id": 209738
                    }, {
                        "name": "南京亚马逊餐饮",
                        "id": 209739
                    }, {
                        "name": "天津字节电商",
                        "id": 209740
                    }, {
                        "name": "南京小米科技",
                        "id": 209741
                    }, {
                        "name": "厦门谷歌金融",
                        "id": 209742
                    }, {
                        "name": "首尔必胜客",
                        "id": 209743
                    }, {
                        "name": "北京星巴克旅游",
                        "id": 209744
                    }, {
                        "name": "杭州谷歌控股集团",
                        "id": 209745
                    }, {
                        "name": "南京美团基金",
                        "id": 209746
                    }, {
                        "name": "纽约美团金融",
                        "id": 209747
                    }, {
                        "name": "东京微软软件有限公司",
                        "id": 209748
                    }, {
                        "name": "厦门腾讯电商",
                        "id": 209749
                    }, {
                        "name": "深圳腾讯制造",
                        "id": 209750
                    }, {
                        "name": "厦门亚马逊软件",
                        "id": 209751
                    }, {
                        "name": "上海奈雪互金",
                        "id": 209752
                    }, {
                        "name": "北京亚马逊地产",
                        "id": 209753
                    }, {
                        "name": "天津欧珀旅游控股集团",
                        "id": 209754
                    }, {
                        "name": "东京腾讯通讯",
                        "id": 209755
                    }]
                }, {
                    "name": "杭州必胜客航空控股集团",
                    "id": 209756
                }, {
                    "name": "纽约瑞幸诊所控股集团",
                    "id": 209757
                }, {
                    "name": "天津星巴克通信",
                    "id": 209758,
                    "children": [{
                        "name": "东莞谷歌旅游控股集团",
                        "id": 209759
                    }, {
                        "name": "台北阿里航空",
                        "id": 209760
                    }, {
                        "name": "首尔平安金融",
                        "id": 209761
                    }, {
                        "name": "厦门阿里制造控股集团",
                        "id": 209762
                    }, {
                        "name": "厦门华为石油有限公司",
                        "id": 209763
                    }, {
                        "name": "厦门蚂蚁新能源",
                        "id": 209764
                    }, {
                        "name": "广州欧珀电商有限公司",
                        "id": 209765
                    }, {
                        "name": "上海微软牧业",
                        "id": 209766
                    }, {
                        "name": "天津微软医院控股集团",
                        "id": 209767
                    }, {
                        "name": "东莞百度医药有限公司",
                        "id": 209768
                    }, {
                        "name": "杭州华为通信控股集团",
                        "id": 209769
                    }, {
                        "name": "香港百度通讯",
                        "id": 209770
                    }, {
                        "name": "广州肯德基餐饮",
                        "id": 209771
                    }]
                }, {
                    "name": "东京微软证券",
                    "id": 209772,
                    "children": [{
                        "name": "香港百度计算机",
                        "id": 209773
                    }, {
                        "name": "东莞亚马逊诊所有限公司",
                        "id": 209774
                    }, {
                        "name": "杭州字节",
                        "id": 209775
                    }, {
                        "name": "南京蚂蚁电商",
                        "id": 209776
                    }, {
                        "name": "香港百度石油",
                        "id": 209777
                    }, {
                        "name": "天津快手医院控股集团",
                        "id": 209778
                    }, {
                        "name": "天津快手航空",
                        "id": 209779
                    }, {
                        "name": "台北亚马逊汽车",
                        "id": 209780
                    }, {
                        "name": "香港蚂蚁制造有限公司",
                        "id": 209781
                    }, {
                        "name": "东莞美团地产",
                        "id": 209782
                    }, {
                        "name": "东京特斯拉牧业有限公司",
                        "id": 209783
                    }, {
                        "name": "杭州苹果通讯有限公司",
                        "id": 209784
                    }, {
                        "name": "首尔肯德基科技",
                        "id": 209785
                    }, {
                        "name": "南京星巴克汽车有限公司",
                        "id": 209786
                    }, {
                        "name": "首尔瑞幸医药",
                        "id": 209787
                    }, {
                        "name": "东京谷歌计算机",
                        "id": 209788
                    }]
                }, {
                    "name": "杭州苹果互金控股集团",
                    "id": 209789
                }, {
                    "name": "厦门腾讯地摊",
                    "id": 209790,
                    "children": [{
                        "name": "天津微软基金控股集团",
                        "id": 209791
                    }, {
                        "name": "南京字节证券",
                        "id": 209792
                    }, {
                        "name": "纽约阿里养殖有限公司",
                        "id": 209793
                    }, {
                        "name": "杭州苹果石油",
                        "id": 209794
                    }, {
                        "name": "香港苹果地产",
                        "id": 209795
                    }, {
                        "name": "首尔肯德基航空",
                        "id": 209796
                    }, {
                        "name": "深圳小米银行",
                        "id": 209797
                    }, {
                        "name": "东京亚马逊",
                        "id": 209798
                    }, {
                        "name": "天津京东科技",
                        "id": 209799
                    }, {
                        "name": "台北必胜客科技",
                        "id": 209800
                    }, {
                        "name": "广州特斯拉餐饮有限公司",
                        "id": 209801
                    }, {
                        "name": "首尔苹果制造有限公司",
                        "id": 209802
                    }, {
                        "name": "厦门瑞幸地摊",
                        "id": 209803
                    }, {
                        "name": "厦门亚马逊餐饮",
                        "id": 209804
                    }, {
                        "name": "东京微软金融控股集团",
                        "id": 209805
                    }, {
                        "name": "南京特斯拉农业",
                        "id": 209806
                    }, {
                        "name": "台北微软有限公司",
                        "id": 209807
                    }, {
                        "name": "杭州华为软件",
                        "id": 209808
                    }, {
                        "name": "北京瑞幸芯片",
                        "id": 209809
                    }, {
                        "name": "台北必胜客航空有限公司",
                        "id": 209810
                    }, {
                        "name": "杭州京东信息服务有限公司",
                        "id": 209811
                    }, {
                        "name": "纽约亚马逊牧业有限公司",
                        "id": 209812
                    }, {
                        "name": "东莞蚂蚁农业",
                        "id": 209813
                    }, {
                        "name": "杭州喜茶餐饮",
                        "id": 209814
                    }, {
                        "name": "香港京东",
                        "id": 209815
                    }, {
                        "name": "北京华为石油",
                        "id": 209816
                    }, {
                        "name": "东京谷歌电商有限公司",
                        "id": 209817
                    }, {
                        "name": "厦门字节农业",
                        "id": 209818
                    }, {
                        "name": "东莞滴滴地摊",
                        "id": 209819
                    }, {
                        "name": "香港必胜客地产",
                        "id": 209820
                    }, {
                        "name": "香港京东制造",
                        "id": 209821
                    }, {
                        "name": "北京亚马逊渔业有限公司",
                        "id": 209822
                    }, {
                        "name": "东京微软汽车控股集团",
                        "id": 209823
                    }]
                }, {
                    "name": "北京京东汽车",
                    "id": 209824
                }, {
                    "name": "北京腾讯基金",
                    "id": 209825,
                    "children": [{
                        "name": "东莞阿里航空控股集团",
                        "id": 209826
                    }, {
                        "name": "杭州快手石油",
                        "id": 209827
                    }, {
                        "name": "深圳快手农业有限公司",
                        "id": 209828
                    }, {
                        "name": "香港阿里航空有限公司",
                        "id": 209829
                    }, {
                        "name": "天津星巴克餐饮有限公司",
                        "id": 209830
                    }, {
                        "name": "杭州美团控股集团",
                        "id": 209831
                    }, {
                        "name": "南京微软信息服务",
                        "id": 209832
                    }, {
                        "name": "深圳微软银行控股集团",
                        "id": 209833
                    }, {
                        "name": "纽约欧珀基金有限公司",
                        "id": 209834
                    }, {
                        "name": "广州腾讯通信",
                        "id": 209835
                    }, {
                        "name": "深圳阿里新能源有限公司",
                        "id": 209836
                    }, {
                        "name": "北京亚马逊地产有限公司",
                        "id": 209837
                    }, {
                        "name": "东京奈雪科技",
                        "id": 209838
                    }, {
                        "name": "纽约微软芯片",
                        "id": 209839
                    }, {
                        "name": "南京苹果石油",
                        "id": 209840
                    }, {
                        "name": "杭州谷歌控股集团",
                        "id": 209841
                    }, {
                        "name": "上海百度",
                        "id": 209842
                    }, {
                        "name": "杭州亚马逊电商控股集团",
                        "id": 209843
                    }, {
                        "name": "杭州腾讯地产控股集团",
                        "id": 209844
                    }, {
                        "name": "天津奈雪医院",
                        "id": 209845
                    }, {
                        "name": "天津瑞幸新能源",
                        "id": 209846
                    }, {
                        "name": "东京京东新能源",
                        "id": 209847
                    }, {
                        "name": "东莞字节芯片控股集团",
                        "id": 209848
                    }]
                }, {
                    "name": "杭州快手新能源",
                    "id": 209849
                }, {
                    "name": "上海小米银行",
                    "id": 209850
                }, {
                    "name": "厦门美团计算机",
                    "id": 209851,
                    "children": [{
                        "name": "纽约特斯拉",
                        "id": 209852
                    }, {
                        "name": "香港瑞幸电商",
                        "id": 209853
                    }, {
                        "name": "东京欧珀电商",
                        "id": 209854
                    }, {
                        "name": "香港喜茶地产",
                        "id": 209855
                    }, {
                        "name": "首尔快手医院",
                        "id": 209856
                    }, {
                        "name": "台北特斯拉航空",
                        "id": 209857
                    }, {
                        "name": "台北字节石油",
                        "id": 209858
                    }, {
                        "name": "首尔奈雪银行",
                        "id": 209859
                    }, {
                        "name": "天津特斯拉医药有限公司",
                        "id": 209860
                    }, {
                        "name": "东莞蚂蚁汽车",
                        "id": 209861
                    }, {
                        "name": "天津美团医院",
                        "id": 209862
                    }, {
                        "name": "东莞腾讯农业",
                        "id": 209863
                    }, {
                        "name": "首尔特斯拉汽车",
                        "id": 209864
                    }, {
                        "name": "杭州欧珀互金",
                        "id": 209865
                    }, {
                        "name": "天津字节制造",
                        "id": 209866
                    }, {
                        "name": "上海谷歌通讯控股集团",
                        "id": 209867
                    }, {
                        "name": "东莞滴滴制造控股集团",
                        "id": 209868
                    }, {
                        "name": "广州肯德基",
                        "id": 209869
                    }, {
                        "name": "台北星巴克",
                        "id": 209870
                    }, {
                        "name": "纽约阿里电商",
                        "id": 209871
                    }, {
                        "name": "深圳华为信息服务",
                        "id": 209872
                    }, {
                        "name": "北京星巴克农业",
                        "id": 209873
                    }]
                }, {
                    "name": "东京谷歌芯片",
                    "id": 209874
                }, {
                    "name": "东莞苹果地摊",
                    "id": 209875
                }, {
                    "name": "北京快手证券",
                    "id": 209876,
                    "children": [{
                        "name": "广州滴滴养殖控股集团",
                        "id": 209877
                    }, {
                        "name": "香港苹果医药",
                        "id": 209878
                    }, {
                        "name": "台北谷歌地产控股集团",
                        "id": 209879
                    }, {
                        "name": "南京喜茶诊所控股集团",
                        "id": 209880
                    }, {
                        "name": "东京微软",
                        "id": 209881
                    }, {
                        "name": "天津微软医院",
                        "id": 209882
                    }, {
                        "name": "杭州特斯拉餐饮",
                        "id": 209883
                    }, {
                        "name": "杭州腾讯地摊",
                        "id": 209884
                    }, {
                        "name": "纽约百度智能",
                        "id": 209885
                    }, {
                        "name": "厦门快手通讯",
                        "id": 209886
                    }, {
                        "name": "台北喜茶电商",
                        "id": 209887
                    }, {
                        "name": "台北美团计算机",
                        "id": 209888
                    }, {
                        "name": "杭州欧珀证券",
                        "id": 209889
                    }, {
                        "name": "杭州腾讯诊所控股集团",
                        "id": 209890
                    }, {
                        "name": "台北小米银行",
                        "id": 209891
                    }, {
                        "name": "杭州苹果通信",
                        "id": 209892
                    }, {
                        "name": "东莞美团通信有限公司",
                        "id": 209893
                    }, {
                        "name": "深圳京东地产",
                        "id": 209894
                    }, {
                        "name": "东京喜茶",
                        "id": 209895
                    }, {
                        "name": "首尔亚马逊制造",
                        "id": 209896
                    }]
                }, {
                    "name": "香港谷歌诊所控股集团",
                    "id": 209897
                }, {
                    "name": "南京必胜客基金",
                    "id": 209898,
                    "children": [{
                        "name": "上海百度电商",
                        "id": 209899
                    }, {
                        "name": "香港喜茶航空",
                        "id": 209900
                    }, {
                        "name": "天津苹果航空",
                        "id": 209901
                    }, {
                        "name": "厦门快手渔业",
                        "id": 209902
                    }, {
                        "name": "东京苹果证券有限公司",
                        "id": 209903
                    }, {
                        "name": "北京京东餐饮",
                        "id": 209904
                    }, {
                        "name": "杭州欧珀养殖",
                        "id": 209905
                    }, {
                        "name": "首尔肯德基汽车有限公司",
                        "id": 209906
                    }, {
                        "name": "香港平安计算机",
                        "id": 209907
                    }, {
                        "name": "北京喜茶牧业",
                        "id": 209908
                    }, {
                        "name": "杭州华为医院",
                        "id": 209909
                    }, {
                        "name": "天津字节芯片有限公司",
                        "id": 209910
                    }, {
                        "name": "深圳滴滴诊所",
                        "id": 209911
                    }, {
                        "name": "台北肯德基有限公司",
                        "id": 209912
                    }, {
                        "name": "东京必胜客金融控股集团",
                        "id": 209913
                    }, {
                        "name": "深圳美团证券",
                        "id": 209914
                    }, {
                        "name": "南京腾讯芯片",
                        "id": 209915
                    }, {
                        "name": "香港滴滴基金",
                        "id": 209916
                    }, {
                        "name": "东京喜茶计算机控股集团",
                        "id": 209917
                    }, {
                        "name": "纽约肯德基通信",
                        "id": 209918
                    }, {
                        "name": "东莞蚂蚁科技",
                        "id": 209919
                    }, {
                        "name": "纽约谷歌",
                        "id": 209920
                    }, {
                        "name": "广州小米制造有限公司",
                        "id": 209921
                    }, {
                        "name": "东莞欧珀金融控股集团",
                        "id": 209922
                    }, {
                        "name": "广州蚂蚁石油",
                        "id": 209923
                    }, {
                        "name": "广州特斯拉养殖控股集团",
                        "id": 209924
                    }, {
                        "name": "杭州微软渔业",
                        "id": 209925
                    }, {
                        "name": "厦门蚂蚁智能",
                        "id": 209926
                    }]
                }]
            }]
        }, {
            "name": "杭州欧珀诊所",
            "id": 209927
        }, {
            "name": "香港欧珀通讯",
            "id": 209928
        }, {
            "name": "香港特斯拉通信",
            "id": 209929
        }, {
            "name": "东莞快手医药",
            "id": 209930
        }, {
            "name": "天津字节银行控股集团",
            "id": 209931,
            "children": [{
                "name": "厦门苹果证券",
                "id": 209932,
                "children": [{
                    "name": "东莞亚马逊智能有限公司",
                    "id": 209933
                }, {
                    "name": "上海瑞幸石油",
                    "id": 209934,
                    "children": [{
                        "name": "厦门微软新能源控股集团",
                        "id": 209935
                    }, {
                        "name": "杭州星巴克基金有限公司",
                        "id": 209936
                    }, {
                        "name": "东莞腾讯旅游",
                        "id": 209937
                    }, {
                        "name": "杭州瑞幸地摊",
                        "id": 209938
                    }, {
                        "name": "深圳平安餐饮有限公司",
                        "id": 209939
                    }, {
                        "name": "南京华为银行",
                        "id": 209940
                    }, {
                        "name": "南京华为智能控股集团",
                        "id": 209941
                    }, {
                        "name": "北京苹果",
                        "id": 209942
                    }, {
                        "name": "厦门阿里医药",
                        "id": 209943
                    }, {
                        "name": "杭州瑞幸农业",
                        "id": 209944
                    }, {
                        "name": "北京谷歌养殖",
                        "id": 209945
                    }, {
                        "name": "厦门亚马逊汽车",
                        "id": 209946
                    }, {
                        "name": "台北亚马逊信息服务",
                        "id": 209947
                    }, {
                        "name": "深圳平安餐饮",
                        "id": 209948
                    }, {
                        "name": "香港滴滴牧业控股集团",
                        "id": 209949
                    }, {
                        "name": "台北谷歌",
                        "id": 209950
                    }, {
                        "name": "东京快手通讯",
                        "id": 209951
                    }, {
                        "name": "南京百度证券",
                        "id": 209952
                    }, {
                        "name": "上海平安智能",
                        "id": 209953
                    }, {
                        "name": "东京华为养殖控股集团",
                        "id": 209954
                    }, {
                        "name": "北京京东旅游",
                        "id": 209955
                    }, {
                        "name": "北京奈雪",
                        "id": 209956
                    }]
                }, {
                    "name": "广州蚂蚁旅游控股集团",
                    "id": 209957
                }, {
                    "name": "台北微软诊所",
                    "id": 209958,
                    "children": [{
                        "name": "杭州喜茶农业",
                        "id": 209959
                    }, {
                        "name": "南京小米诊所",
                        "id": 209960
                    }, {
                        "name": "北京喜茶地产",
                        "id": 209961
                    }, {
                        "name": "厦门腾讯计算机",
                        "id": 209962
                    }, {
                        "name": "上海美团旅游",
                        "id": 209963
                    }, {
                        "name": "广州喜茶基金",
                        "id": 209964
                    }, {
                        "name": "深圳阿里互金控股集团",
                        "id": 209965
                    }, {
                        "name": "东莞必胜客基金",
                        "id": 209966
                    }, {
                        "name": "上海谷歌计算机",
                        "id": 209967
                    }, {
                        "name": "厦门苹果石油",
                        "id": 209968
                    }, {
                        "name": "东京微软金融",
                        "id": 209969
                    }, {
                        "name": "东京瑞幸计算机",
                        "id": 209970
                    }, {
                        "name": "厦门华为汽车",
                        "id": 209971
                    }, {
                        "name": "南京滴滴农业控股集团",
                        "id": 209972
                    }, {
                        "name": "东京欧珀银行",
                        "id": 209973
                    }, {
                        "name": "广州平安信息服务",
                        "id": 209974
                    }, {
                        "name": "东京华为证券",
                        "id": 209975
                    }, {
                        "name": "香港京东通讯",
                        "id": 209976
                    }, {
                        "name": "上海华为诊所",
                        "id": 209977
                    }, {
                        "name": "台北小米控股集团",
                        "id": 209978
                    }, {
                        "name": "天津京东通信有限公司",
                        "id": 209979
                    }, {
                        "name": "厦门小米新能源",
                        "id": 209980
                    }, {
                        "name": "上海亚马逊电商有限公司",
                        "id": 209981
                    }, {
                        "name": "纽约小米科技",
                        "id": 209982
                    }, {
                        "name": "香港平安养殖有限公司",
                        "id": 209983
                    }, {
                        "name": "杭州苹果有限公司",
                        "id": 209984
                    }, {
                        "name": "厦门瑞幸航空",
                        "id": 209985
                    }, {
                        "name": "东京华为诊所",
                        "id": 209986
                    }, {
                        "name": "天津华为证券",
                        "id": 209987
                    }, {
                        "name": "东莞百度证券",
                        "id": 209988
                    }, {
                        "name": "厦门平安基金",
                        "id": 209989
                    }, {
                        "name": "广州京东渔业有限公司",
                        "id": 209990
                    }, {
                        "name": "深圳微软计算机",
                        "id": 209991
                    }, {
                        "name": "上海美团地摊",
                        "id": 209992
                    }, {
                        "name": "杭州必胜客计算机",
                        "id": 209993
                    }]
                }, {
                    "name": "首尔奈雪地摊控股集团",
                    "id": 209994
                }, {
                    "name": "首尔微软电商",
                    "id": 209995
                }, {
                    "name": "上海京东通信",
                    "id": 209996
                }, {
                    "name": "广州快手渔业有限公司",
                    "id": 209997,
                    "children": [{
                        "name": "东莞苹果地摊",
                        "id": 209998
                    }, {
                        "name": "南京平安信息服务",
                        "id": 209999
                    }, {
                        "name": "厦门谷歌医院有限公司",
                        "id": 210000
                    }, {
                        "name": "天津特斯拉",
                        "id": 210001
                    }, {
                        "name": "台北百度基金有限公司",
                        "id": 210002
                    }, {
                        "name": "纽约小米诊所",
                        "id": 210003
                    }, {
                        "name": "上海平安医院",
                        "id": 210004
                    }, {
                        "name": "首尔肯德基信息服务",
                        "id": 210005
                    }, {
                        "name": "杭州美团农业",
                        "id": 210006
                    }, {
                        "name": "东莞谷歌农业",
                        "id": 210007
                    }, {
                        "name": "深圳腾讯石油",
                        "id": 210008
                    }, {
                        "name": "深圳特斯拉诊所",
                        "id": 210009
                    }, {
                        "name": "上海平安石油",
                        "id": 210010
                    }, {
                        "name": "杭州百度餐饮",
                        "id": 210011
                    }, {
                        "name": "北京小米地产",
                        "id": 210012
                    }, {
                        "name": "厦门谷歌通讯有限公司",
                        "id": 210013
                    }, {
                        "name": "厦门亚马逊石油",
                        "id": 210014
                    }, {
                        "name": "天津谷歌地摊",
                        "id": 210015
                    }, {
                        "name": "上海亚马逊石油",
                        "id": 210016
                    }, {
                        "name": "天津苹果诊所",
                        "id": 210017
                    }, {
                        "name": "天津字节石油有限公司",
                        "id": 210018
                    }, {
                        "name": "杭州欧珀地产控股集团",
                        "id": 210019
                    }, {
                        "name": "纽约喜茶电商控股集团",
                        "id": 210020
                    }, {
                        "name": "台北谷歌养殖",
                        "id": 210021
                    }, {
                        "name": "广州欧珀基金",
                        "id": 210022
                    }, {
                        "name": "南京微软航空",
                        "id": 210023
                    }, {
                        "name": "东莞瑞幸芯片控股集团",
                        "id": 210024
                    }, {
                        "name": "东京蚂蚁通讯",
                        "id": 210025
                    }, {
                        "name": "杭州快手证券",
                        "id": 210026
                    }, {
                        "name": "香港苹果新能源控股集团",
                        "id": 210027
                    }, {
                        "name": "东京百度互金控股集团",
                        "id": 210028
                    }, {
                        "name": "上海平安金融",
                        "id": 210029
                    }, {
                        "name": "深圳喜茶有限公司",
                        "id": 210030
                    }]
                }, {
                    "name": "纽约美团电商",
                    "id": 210031
                }, {
                    "name": "厦门欧珀通讯控股集团",
                    "id": 210032,
                    "children": [{
                        "name": "上海京东软件控股集团",
                        "id": 210033
                    }, {
                        "name": "香港腾讯旅游",
                        "id": 210034
                    }, {
                        "name": "首尔阿里通讯控股集团",
                        "id": 210035
                    }, {
                        "name": "上海平安基金",
                        "id": 210036
                    }, {
                        "name": "香港亚马逊软件",
                        "id": 210037
                    }, {
                        "name": "厦门苹果养殖",
                        "id": 210038
                    }, {
                        "name": "东莞特斯拉证券",
                        "id": 210039
                    }, {
                        "name": "上海京东",
                        "id": 210040
                    }, {
                        "name": "台北字节证券",
                        "id": 210041
                    }, {
                        "name": "深圳特斯拉地产",
                        "id": 210042
                    }, {
                        "name": "东京字节",
                        "id": 210043
                    }, {
                        "name": "厦门喜茶农业控股集团",
                        "id": 210044
                    }, {
                        "name": "杭州微软地产控股集团",
                        "id": 210045
                    }, {
                        "name": "上海小米软件",
                        "id": 210046
                    }, {
                        "name": "首尔特斯拉芯片",
                        "id": 210047
                    }, {
                        "name": "杭州快手互金",
                        "id": 210048
                    }, {
                        "name": "天津字节基金",
                        "id": 210049
                    }, {
                        "name": "东京腾讯互金",
                        "id": 210050
                    }, {
                        "name": "纽约字节信息服务有限公司",
                        "id": 210051
                    }, {
                        "name": "杭州阿里制造",
                        "id": 210052
                    }, {
                        "name": "杭州瑞幸渔业",
                        "id": 210053
                    }]
                }, {
                    "name": "东京阿里证券",
                    "id": 210054
                }, {
                    "name": "深圳奈雪诊所",
                    "id": 210055
                }, {
                    "name": "东京美团医药控股集团",
                    "id": 210056
                }, {
                    "name": "上海字节证券",
                    "id": 210057
                }, {
                    "name": "香港百度医药",
                    "id": 210058,
                    "children": [{
                        "name": "厦门阿里智能",
                        "id": 210059
                    }, {
                        "name": "南京肯德基养殖控股集团",
                        "id": 210060
                    }, {
                        "name": "杭州腾讯金融控股集团",
                        "id": 210061
                    }, {
                        "name": "北京美团金融有限公司",
                        "id": 210062
                    }, {
                        "name": "杭州星巴克石油",
                        "id": 210063
                    }, {
                        "name": "厦门平安",
                        "id": 210064
                    }, {
                        "name": "东莞欧珀通信",
                        "id": 210065
                    }, {
                        "name": "北京华为信息服务有限公司",
                        "id": 210066
                    }, {
                        "name": "东京字节通信",
                        "id": 210067
                    }, {
                        "name": "杭州谷歌科技",
                        "id": 210068
                    }, {
                        "name": "香港平安计算机",
                        "id": 210069
                    }, {
                        "name": "东莞京东地摊",
                        "id": 210070
                    }, {
                        "name": "天津蚂蚁智能",
                        "id": 210071
                    }, {
                        "name": "台北快手制造有限公司",
                        "id": 210072
                    }, {
                        "name": "天津平安",
                        "id": 210073
                    }, {
                        "name": "厦门京东芯片",
                        "id": 210074
                    }, {
                        "name": "台北华为芯片",
                        "id": 210075
                    }, {
                        "name": "深圳奈雪航空",
                        "id": 210076
                    }, {
                        "name": "北京亚马逊医药",
                        "id": 210077
                    }, {
                        "name": "台北百度互金",
                        "id": 210078
                    }, {
                        "name": "首尔百度电商控股集团",
                        "id": 210079
                    }, {
                        "name": "香港华为医药",
                        "id": 210080
                    }, {
                        "name": "杭州苹果渔业控股集团",
                        "id": 210081
                    }, {
                        "name": "北京平安芯片有限公司",
                        "id": 210082
                    }, {
                        "name": "广州苹果软件",
                        "id": 210083
                    }, {
                        "name": "天津字节",
                        "id": 210084
                    }, {
                        "name": "厦门欧珀医院",
                        "id": 210085
                    }, {
                        "name": "北京小米金融",
                        "id": 210086
                    }, {
                        "name": "杭州华为",
                        "id": 210087
                    }, {
                        "name": "杭州华为新能源",
                        "id": 210088
                    }, {
                        "name": "南京苹果互金",
                        "id": 210089
                    }, {
                        "name": "广州喜茶养殖",
                        "id": 210090
                    }, {
                        "name": "香港字节牧业",
                        "id": 210091
                    }, {
                        "name": "东莞快手",
                        "id": 210092
                    }]
                }, {
                    "name": "纽约蚂蚁医院有限公司",
                    "id": 210093
                }, {
                    "name": "杭州微软智能",
                    "id": 210094
                }, {
                    "name": "东莞肯德基互金",
                    "id": 210095
                }, {
                    "name": "广州平安智能",
                    "id": 210096
                }, {
                    "name": "天津亚马逊智能",
                    "id": 210097
                }]
            }, {
                "name": "东京平安通讯",
                "id": 210098
            }, {
                "name": "纽约瑞幸软件",
                "id": 210099
            }, {
                "name": "深圳必胜客旅游",
                "id": 210100
            }, {
                "name": "香港平安通讯有限公司",
                "id": 210101
            }, {
                "name": "广州谷歌养殖",
                "id": 210102
            }, {
                "name": "台北奈雪石油有限公司",
                "id": 210103,
                "children": [{
                    "name": "首尔平安",
                    "id": 210104
                }, {
                    "name": "香港亚马逊",
                    "id": 210105
                }, {
                    "name": "上海美团渔业",
                    "id": 210106
                }, {
                    "name": "厦门字节金融",
                    "id": 210107
                }, {
                    "name": "东莞阿里诊所控股集团",
                    "id": 210108
                }, {
                    "name": "北京蚂蚁农业",
                    "id": 210109,
                    "children": [{
                        "name": "纽约肯德基通讯",
                        "id": 210110
                    }, {
                        "name": "台北必胜客金融",
                        "id": 210111
                    }, {
                        "name": "南京平安互金",
                        "id": 210112
                    }, {
                        "name": "杭州欧珀制造",
                        "id": 210113
                    }, {
                        "name": "纽约亚马逊餐饮控股集团",
                        "id": 210114
                    }, {
                        "name": "台北百度银行",
                        "id": 210115
                    }, {
                        "name": "广州腾讯",
                        "id": 210116
                    }, {
                        "name": "东莞谷歌地产",
                        "id": 210117
                    }, {
                        "name": "广州滴滴牧业",
                        "id": 210118
                    }, {
                        "name": "北京必胜客软件",
                        "id": 210119
                    }, {
                        "name": "天津百度养殖控股集团",
                        "id": 210120
                    }, {
                        "name": "南京欧珀金融有限公司",
                        "id": 210121
                    }, {
                        "name": "厦门奈雪通信",
                        "id": 210122
                    }, {
                        "name": "香港小米基金有限公司",
                        "id": 210123
                    }, {
                        "name": "东莞滴滴地摊",
                        "id": 210124
                    }, {
                        "name": "南京瑞幸基金控股集团",
                        "id": 210125
                    }, {
                        "name": "天津华为银行",
                        "id": 210126
                    }, {
                        "name": "纽约京东渔业",
                        "id": 210127
                    }, {
                        "name": "广州字节证券",
                        "id": 210128
                    }, {
                        "name": "杭州阿里地产",
                        "id": 210129
                    }, {
                        "name": "深圳喜茶科技",
                        "id": 210130
                    }, {
                        "name": "南京微软银行有限公司",
                        "id": 210131
                    }, {
                        "name": "南京京东智能",
                        "id": 210132
                    }, {
                        "name": "首尔肯德基智能",
                        "id": 210133
                    }, {
                        "name": "上海京东制造控股集团",
                        "id": 210134
                    }, {
                        "name": "东京苹果牧业控股集团",
                        "id": 210135
                    }, {
                        "name": "北京欧珀有限公司",
                        "id": 210136
                    }, {
                        "name": "南京欧珀通信",
                        "id": 210137
                    }, {
                        "name": "纽约蚂蚁牧业",
                        "id": 210138
                    }, {
                        "name": "南京京东软件",
                        "id": 210139
                    }]
                }, {
                    "name": "厦门华为",
                    "id": 210140
                }, {
                    "name": "北京瑞幸农业有限公司",
                    "id": 210141,
                    "children": [{
                        "name": "北京阿里有限公司",
                        "id": 210142
                    }, {
                        "name": "首尔华为芯片",
                        "id": 210143
                    }, {
                        "name": "厦门肯德基医药",
                        "id": 210144
                    }, {
                        "name": "东京特斯拉制造控股集团",
                        "id": 210145
                    }, {
                        "name": "上海蚂蚁医药",
                        "id": 210146
                    }, {
                        "name": "台北字节信息服务控股集团",
                        "id": 210147
                    }, {
                        "name": "杭州必胜客旅游",
                        "id": 210148
                    }, {
                        "name": "天津美团互金控股集团",
                        "id": 210149
                    }, {
                        "name": "首尔苹果医药",
                        "id": 210150
                    }, {
                        "name": "天津美团科技有限公司",
                        "id": 210151
                    }, {
                        "name": "杭州欧珀餐饮",
                        "id": 210152
                    }, {
                        "name": "台北瑞幸养殖",
                        "id": 210153
                    }, {
                        "name": "首尔必胜客诊所",
                        "id": 210154
                    }, {
                        "name": "天津特斯拉计算机",
                        "id": 210155
                    }, {
                        "name": "杭州亚马逊农业有限公司",
                        "id": 210156
                    }, {
                        "name": "深圳滴滴制造控股集团",
                        "id": 210157
                    }, {
                        "name": "广州苹果渔业",
                        "id": 210158
                    }, {
                        "name": "深圳苹果信息服务有限公司",
                        "id": 210159
                    }, {
                        "name": "香港京东农业",
                        "id": 210160
                    }, {
                        "name": "杭州必胜客农业控股集团",
                        "id": 210161
                    }, {
                        "name": "杭州星巴克养殖",
                        "id": 210162
                    }, {
                        "name": "东京特斯拉诊所",
                        "id": 210163
                    }, {
                        "name": "广州星巴克航空",
                        "id": 210164
                    }, {
                        "name": "东京京东银行有限公司",
                        "id": 210165
                    }, {
                        "name": "纽约苹果新能源有限公司",
                        "id": 210166
                    }, {
                        "name": "杭州奈雪证券",
                        "id": 210167
                    }, {
                        "name": "香港阿里地产",
                        "id": 210168
                    }, {
                        "name": "上海微软旅游控股集团",
                        "id": 210169
                    }, {
                        "name": "深圳奈雪汽车控股集团",
                        "id": 210170
                    }, {
                        "name": "纽约快手",
                        "id": 210171
                    }, {
                        "name": "香港腾讯石油",
                        "id": 210172
                    }, {
                        "name": "首尔谷歌",
                        "id": 210173
                    }]
                }]
            }, {
                "name": "首尔奈雪电商",
                "id": 210174
            }, {
                "name": "香港美团银行",
                "id": 210175
            }, {
                "name": "北京腾讯餐饮",
                "id": 210176,
                "children": [{
                    "name": "广州小米餐饮有限公司",
                    "id": 210177,
                    "children": [{
                        "name": "杭州星巴克基金",
                        "id": 210178
                    }, {
                        "name": "杭州美团",
                        "id": 210179
                    }, {
                        "name": "北京亚马逊证券",
                        "id": 210180
                    }, {
                        "name": "首尔平安地产",
                        "id": 210181
                    }, {
                        "name": "杭州微软金融",
                        "id": 210182
                    }, {
                        "name": "台北小米通讯有限公司",
                        "id": 210183
                    }, {
                        "name": "上海喜茶银行控股集团",
                        "id": 210184
                    }, {
                        "name": "广州腾讯汽车",
                        "id": 210185
                    }, {
                        "name": "上海美团互金",
                        "id": 210186
                    }, {
                        "name": "深圳肯德基智能",
                        "id": 210187
                    }, {
                        "name": "上海苹果旅游有限公司",
                        "id": 210188
                    }, {
                        "name": "上海平安软件有限公司",
                        "id": 210189
                    }, {
                        "name": "纽约星巴克计算机有限公司",
                        "id": 210190
                    }, {
                        "name": "广州美团航空控股集团",
                        "id": 210191
                    }, {
                        "name": "杭州微软汽车有限公司",
                        "id": 210192
                    }]
                }, {
                    "name": "天津谷歌",
                    "id": 210193,
                    "children": [{
                        "name": "广州快手电商",
                        "id": 210194
                    }, {
                        "name": "香港美团地产",
                        "id": 210195
                    }, {
                        "name": "杭州阿里航空",
                        "id": 210196
                    }, {
                        "name": "北京微软医药有限公司",
                        "id": 210197
                    }, {
                        "name": "台北小米科技",
                        "id": 210198
                    }, {
                        "name": "台北奈雪计算机控股集团",
                        "id": 210199
                    }, {
                        "name": "东京平安通信",
                        "id": 210200
                    }, {
                        "name": "纽约谷歌信息服务",
                        "id": 210201
                    }, {
                        "name": "台北小米",
                        "id": 210202
                    }, {
                        "name": "首尔快手医药",
                        "id": 210203
                    }, {
                        "name": "深圳阿里金融",
                        "id": 210204
                    }, {
                        "name": "纽约小米控股集团",
                        "id": 210205
                    }, {
                        "name": "香港苹果医药",
                        "id": 210206
                    }, {
                        "name": "纽约美团养殖",
                        "id": 210207
                    }, {
                        "name": "香港奈雪养殖",
                        "id": 210208
                    }]
                }]
            }, {
                "name": "北京欧珀银行",
                "id": 210209,
                "children": [{
                    "name": "南京滴滴互金有限公司",
                    "id": 210210
                }, {
                    "name": "天津蚂蚁科技",
                    "id": 210211
                }, {
                    "name": "天津微软医院",
                    "id": 210212
                }, {
                    "name": "杭州快手芯片控股集团",
                    "id": 210213
                }, {
                    "name": "东京京东牧业有限公司",
                    "id": 210214
                }, {
                    "name": "杭州喜茶医药",
                    "id": 210215,
                    "children": [{
                        "name": "深圳华为石油",
                        "id": 210216
                    }, {
                        "name": "天津京东银行控股集团",
                        "id": 210217
                    }, {
                        "name": "杭州必胜客诊所控股集团",
                        "id": 210218
                    }, {
                        "name": "东京小米电商控股集团",
                        "id": 210219
                    }, {
                        "name": "纽约肯德基科技",
                        "id": 210220
                    }, {
                        "name": "纽约快手证券",
                        "id": 210221
                    }, {
                        "name": "北京小米旅游",
                        "id": 210222
                    }, {
                        "name": "南京快手养殖控股集团",
                        "id": 210223
                    }, {
                        "name": "东莞必胜客证券",
                        "id": 210224
                    }, {
                        "name": "厦门小米",
                        "id": 210225
                    }, {
                        "name": "南京星巴克诊所",
                        "id": 210226
                    }, {
                        "name": "南京快手芯片有限公司",
                        "id": 210227
                    }, {
                        "name": "纽约亚马逊科技控股集团",
                        "id": 210228
                    }, {
                        "name": "南京喜茶航空有限公司",
                        "id": 210229
                    }, {
                        "name": "东京微软诊所有限公司",
                        "id": 210230
                    }, {
                        "name": "纽约亚马逊通信有限公司",
                        "id": 210231
                    }, {
                        "name": "纽约星巴克医药",
                        "id": 210232
                    }, {
                        "name": "厦门快手科技有限公司",
                        "id": 210233
                    }, {
                        "name": "广州蚂蚁旅游",
                        "id": 210234
                    }, {
                        "name": "广州奈雪牧业",
                        "id": 210235
                    }, {
                        "name": "深圳小米互金控股集团",
                        "id": 210236
                    }, {
                        "name": "首尔百度旅游",
                        "id": 210237
                    }, {
                        "name": "首尔快手航空",
                        "id": 210238
                    }, {
                        "name": "北京必胜客芯片",
                        "id": 210239
                    }, {
                        "name": "上海喜茶互金控股集团",
                        "id": 210240
                    }, {
                        "name": "上海小米渔业",
                        "id": 210241
                    }, {
                        "name": "纽约平安金融",
                        "id": 210242
                    }, {
                        "name": "香港瑞幸石油",
                        "id": 210243
                    }, {
                        "name": "南京京东计算机控股集团",
                        "id": 210244
                    }]
                }, {
                    "name": "上海蚂蚁制造有限公司",
                    "id": 210245
                }, {
                    "name": "首尔京东互金",
                    "id": 210246
                }, {
                    "name": "南京欧珀诊所",
                    "id": 210247,
                    "children": [{
                        "name": "杭州华为牧业",
                        "id": 210248
                    }]
                }, {
                    "name": "东京美团计算机控股集团",
                    "id": 210249
                }, {
                    "name": "南京特斯拉基金控股集团",
                    "id": 210250,
                    "children": [{
                        "name": "杭州奈雪农业",
                        "id": 210251
                    }, {
                        "name": "杭州阿里通讯有限公司",
                        "id": 210252
                    }]
                }, {
                    "name": "南京滴滴新能源",
                    "id": 210253
                }, {
                    "name": "上海小米互金",
                    "id": 210254,
                    "children": [{
                        "name": "厦门阿里基金有限公司",
                        "id": 210255
                    }, {
                        "name": "天津华为养殖",
                        "id": 210256
                    }, {
                        "name": "天津阿里有限公司",
                        "id": 210257
                    }, {
                        "name": "广州蚂蚁医院有限公司",
                        "id": 210258
                    }, {
                        "name": "香港特斯拉医药",
                        "id": 210259
                    }, {
                        "name": "东莞小米",
                        "id": 210260
                    }, {
                        "name": "杭州喜茶通信",
                        "id": 210261
                    }, {
                        "name": "天津百度新能源有限公司",
                        "id": 210262
                    }, {
                        "name": "南京华为农业有限公司",
                        "id": 210263
                    }, {
                        "name": "上海星巴克科技",
                        "id": 210264
                    }, {
                        "name": "东莞谷歌渔业",
                        "id": 210265
                    }, {
                        "name": "北京肯德基牧业",
                        "id": 210266
                    }, {
                        "name": "杭州蚂蚁通信",
                        "id": 210267
                    }, {
                        "name": "首尔欧珀餐饮",
                        "id": 210268
                    }, {
                        "name": "杭州微软信息服务",
                        "id": 210269
                    }, {
                        "name": "厦门腾讯信息服务",
                        "id": 210270
                    }, {
                        "name": "天津阿里渔业",
                        "id": 210271
                    }, {
                        "name": "香港谷歌电商",
                        "id": 210272
                    }, {
                        "name": "杭州腾讯芯片有限公司",
                        "id": 210273
                    }, {
                        "name": "厦门京东石油",
                        "id": 210274
                    }]
                }, {
                    "name": "广州谷歌通讯",
                    "id": 210275
                }, {
                    "name": "广州蚂蚁银行",
                    "id": 210276
                }, {
                    "name": "东莞喜茶通讯",
                    "id": 210277
                }, {
                    "name": "东莞星巴克科技",
                    "id": 210278,
                    "children": [{
                        "name": "南京亚马逊互金",
                        "id": 210279
                    }, {
                        "name": "上海星巴克基金有限公司",
                        "id": 210280
                    }, {
                        "name": "北京美团证券",
                        "id": 210281
                    }, {
                        "name": "厦门华为计算机控股集团",
                        "id": 210282
                    }, {
                        "name": "东莞肯德基医药",
                        "id": 210283
                    }]
                }, {
                    "name": "香港欧珀",
                    "id": 210284,
                    "children": [{
                        "name": "杭州苹果航空",
                        "id": 210285
                    }, {
                        "name": "香港瑞幸银行",
                        "id": 210286
                    }, {
                        "name": "北京滴滴制造控股集团",
                        "id": 210287
                    }]
                }, {
                    "name": "首尔特斯拉通信控股集团",
                    "id": 210288,
                    "children": [{
                        "name": "深圳瑞幸餐饮",
                        "id": 210289
                    }, {
                        "name": "天津苹果芯片",
                        "id": 210290
                    }, {
                        "name": "东莞特斯拉科技",
                        "id": 210291
                    }, {
                        "name": "杭州欧珀控股集团",
                        "id": 210292
                    }, {
                        "name": "深圳阿里餐饮",
                        "id": 210293
                    }, {
                        "name": "北京平安软件有限公司",
                        "id": 210294
                    }, {
                        "name": "东京瑞幸医药有限公司",
                        "id": 210295
                    }, {
                        "name": "广州美团",
                        "id": 210296
                    }, {
                        "name": "上海谷歌有限公司",
                        "id": 210297
                    }, {
                        "name": "纽约微软制造",
                        "id": 210298
                    }, {
                        "name": "广州亚马逊石油",
                        "id": 210299
                    }, {
                        "name": "首尔喜茶证券控股集团",
                        "id": 210300
                    }, {
                        "name": "杭州苹果科技控股集团",
                        "id": 210301
                    }, {
                        "name": "杭州星巴克制造",
                        "id": 210302
                    }, {
                        "name": "天津字节新能源有限公司",
                        "id": 210303
                    }, {
                        "name": "上海滴滴通讯",
                        "id": 210304
                    }, {
                        "name": "杭州华为证券有限公司",
                        "id": 210305
                    }, {
                        "name": "杭州滴滴诊所",
                        "id": 210306
                    }, {
                        "name": "厦门特斯拉制造有限公司",
                        "id": 210307
                    }, {
                        "name": "南京肯德基银行控股集团",
                        "id": 210308
                    }, {
                        "name": "香港谷歌养殖有限公司",
                        "id": 210309
                    }, {
                        "name": "天津肯德基诊所",
                        "id": 210310
                    }, {
                        "name": "香港阿里电商控股集团",
                        "id": 210311
                    }, {
                        "name": "东莞蚂蚁证券有限公司",
                        "id": 210312
                    }, {
                        "name": "首尔百度地摊",
                        "id": 210313
                    }, {
                        "name": "首尔奈雪金融",
                        "id": 210314
                    }, {
                        "name": "香港小米金融控股集团",
                        "id": 210315
                    }, {
                        "name": "东莞小米软件",
                        "id": 210316
                    }, {
                        "name": "北京腾讯航空",
                        "id": 210317
                    }, {
                        "name": "首尔欧珀芯片",
                        "id": 210318
                    }, {
                        "name": "北京平安牧业",
                        "id": 210319
                    }, {
                        "name": "广州肯德基证券",
                        "id": 210320
                    }]
                }, {
                    "name": "台北字节医院",
                    "id": 210321
                }, {
                    "name": "南京京东航空有限公司",
                    "id": 210322,
                    "children": [{
                        "name": "南京谷歌医院",
                        "id": 210323
                    }, {
                        "name": "厦门欧珀芯片",
                        "id": 210324
                    }, {
                        "name": "东莞瑞幸电商",
                        "id": 210325
                    }, {
                        "name": "天津肯德基农业有限公司",
                        "id": 210326
                    }, {
                        "name": "首尔奈雪银行",
                        "id": 210327
                    }, {
                        "name": "天津肯德基地产",
                        "id": 210328
                    }, {
                        "name": "首尔星巴克金融有限公司",
                        "id": 210329
                    }, {
                        "name": "深圳百度信息服务",
                        "id": 210330
                    }, {
                        "name": "首尔喜茶",
                        "id": 210331
                    }, {
                        "name": "首尔瑞幸",
                        "id": 210332
                    }, {
                        "name": "广州瑞幸基金",
                        "id": 210333
                    }, {
                        "name": "天津阿里基金",
                        "id": 210334
                    }, {
                        "name": "天津亚马逊地摊",
                        "id": 210335
                    }, {
                        "name": "香港百度医院控股集团",
                        "id": 210336
                    }]
                }, {
                    "name": "纽约奈雪芯片",
                    "id": 210337
                }, {
                    "name": "南京字节医院有限公司",
                    "id": 210338
                }, {
                    "name": "天津谷歌信息服务",
                    "id": 210339
                }, {
                    "name": "北京欧珀牧业",
                    "id": 210340
                }, {
                    "name": "首尔必胜客信息服务",
                    "id": 210341
                }, {
                    "name": "纽约平安计算机",
                    "id": 210342,
                    "children": [{
                        "name": "纽约蚂蚁科技控股集团",
                        "id": 210343
                    }, {
                        "name": "南京美团地产有限公司",
                        "id": 210344
                    }, {
                        "name": "东莞谷歌通信",
                        "id": 210345
                    }, {
                        "name": "天津百度芯片控股集团",
                        "id": 210346
                    }, {
                        "name": "厦门阿里航空",
                        "id": 210347
                    }, {
                        "name": "深圳亚马逊制造",
                        "id": 210348
                    }, {
                        "name": "台北微软餐饮",
                        "id": 210349
                    }, {
                        "name": "深圳谷歌金融",
                        "id": 210350
                    }, {
                        "name": "上海星巴克诊所",
                        "id": 210351
                    }]
                }, {
                    "name": "首尔亚马逊互金有限公司",
                    "id": 210352
                }, {
                    "name": "深圳小米基金",
                    "id": 210353
                }, {
                    "name": "杭州瑞幸计算机",
                    "id": 210354
                }, {
                    "name": "纽约阿里牧业有限公司",
                    "id": 210355
                }, {
                    "name": "北京星巴克电商",
                    "id": 210356,
                    "children": [{
                        "name": "香港平安",
                        "id": 210357
                    }, {
                        "name": "台北亚马逊银行",
                        "id": 210358
                    }, {
                        "name": "台北快手电商",
                        "id": 210359
                    }, {
                        "name": "首尔平安证券",
                        "id": 210360
                    }, {
                        "name": "东京华为科技",
                        "id": 210361
                    }, {
                        "name": "天津百度银行有限公司",
                        "id": 210362
                    }, {
                        "name": "上海亚马逊银行控股集团",
                        "id": 210363
                    }, {
                        "name": "东莞苹果信息服务控股集团",
                        "id": 210364
                    }, {
                        "name": "杭州滴滴地产有限公司",
                        "id": 210365
                    }, {
                        "name": "杭州喜茶养殖有限公司",
                        "id": 210366
                    }, {
                        "name": "台北华为证券控股集团",
                        "id": 210367
                    }, {
                        "name": "深圳欧珀诊所有限公司",
                        "id": 210368
                    }, {
                        "name": "深圳华为信息服务有限公司",
                        "id": 210369
                    }, {
                        "name": "天津美团计算机",
                        "id": 210370
                    }, {
                        "name": "深圳谷歌地摊控股集团",
                        "id": 210371
                    }, {
                        "name": "杭州喜茶信息服务",
                        "id": 210372
                    }, {
                        "name": "杭州华为有限公司",
                        "id": 210373
                    }, {
                        "name": "纽约星巴克石油有限公司",
                        "id": 210374
                    }, {
                        "name": "广州美团渔业控股集团",
                        "id": 210375
                    }, {
                        "name": "天津滴滴石油",
                        "id": 210376
                    }, {
                        "name": "天津特斯拉智能有限公司",
                        "id": 210377
                    }, {
                        "name": "深圳平安医院",
                        "id": 210378
                    }, {
                        "name": "东莞百度芯片控股集团",
                        "id": 210379
                    }]
                }, {
                    "name": "台北阿里新能源",
                    "id": 210380,
                    "children": [{
                        "name": "东莞小米渔业",
                        "id": 210381
                    }, {
                        "name": "东京苹果通信有限公司",
                        "id": 210382
                    }, {
                        "name": "杭州微软医院有限公司",
                        "id": 210383
                    }, {
                        "name": "香港蚂蚁",
                        "id": 210384
                    }, {
                        "name": "杭州微软地摊",
                        "id": 210385
                    }, {
                        "name": "东京瑞幸渔业",
                        "id": 210386
                    }, {
                        "name": "纽约特斯拉医药控股集团",
                        "id": 210387
                    }, {
                        "name": "东莞百度科技控股集团",
                        "id": 210388
                    }, {
                        "name": "深圳喜茶",
                        "id": 210389
                    }, {
                        "name": "香港瑞幸信息服务",
                        "id": 210390
                    }, {
                        "name": "东京喜茶",
                        "id": 210391
                    }, {
                        "name": "南京平安旅游",
                        "id": 210392
                    }, {
                        "name": "首尔小米餐饮",
                        "id": 210393
                    }, {
                        "name": "上海蚂蚁地产",
                        "id": 210394
                    }, {
                        "name": "纽约瑞幸有限公司",
                        "id": 210395
                    }, {
                        "name": "杭州华为通讯",
                        "id": 210396
                    }, {
                        "name": "北京谷歌软件",
                        "id": 210397
                    }, {
                        "name": "上海阿里芯片",
                        "id": 210398
                    }, {
                        "name": "天津苹果牧业有限公司",
                        "id": 210399
                    }]
                }]
            }, {
                "name": "南京京东通信",
                "id": 210400
            }, {
                "name": "杭州星巴克地产",
                "id": 210401
            }, {
                "name": "天津奈雪",
                "id": 210402
            }, {
                "name": "纽约微软软件",
                "id": 210403
            }, {
                "name": "上海欧珀新能源",
                "id": 210404
            }, {
                "name": "南京亚马逊渔业",
                "id": 210405
            }, {
                "name": "杭州滴滴医院控股集团",
                "id": 210406
            }, {
                "name": "广州滴滴医院",
                "id": 210407,
                "children": [{
                    "name": "南京小米基金有限公司",
                    "id": 210408
                }, {
                    "name": "香港瑞幸通讯",
                    "id": 210409
                }, {
                    "name": "杭州蚂蚁证券",
                    "id": 210410
                }, {
                    "name": "东京瑞幸制造有限公司",
                    "id": 210411
                }, {
                    "name": "厦门肯德基银行",
                    "id": 210412
                }, {
                    "name": "南京滴滴证券控股集团",
                    "id": 210413
                }, {
                    "name": "杭州必胜客",
                    "id": 210414
                }, {
                    "name": "上海喜茶石油控股集团",
                    "id": 210415,
                    "children": [{
                        "name": "纽约特斯拉计算机控股集团",
                        "id": 210416
                    }, {
                        "name": "杭州肯德基银行",
                        "id": 210417
                    }, {
                        "name": "东京欧珀地摊控股集团",
                        "id": 210418
                    }, {
                        "name": "南京平安金融",
                        "id": 210419
                    }, {
                        "name": "北京平安计算机",
                        "id": 210420
                    }, {
                        "name": "东京平安通讯控股集团",
                        "id": 210421
                    }, {
                        "name": "北京谷歌银行",
                        "id": 210422
                    }, {
                        "name": "台北苹果软件",
                        "id": 210423
                    }, {
                        "name": "南京百度旅游",
                        "id": 210424
                    }, {
                        "name": "广州谷歌电商",
                        "id": 210425
                    }, {
                        "name": "北京平安计算机",
                        "id": 210426
                    }, {
                        "name": "纽约华为",
                        "id": 210427
                    }, {
                        "name": "台北平安电商",
                        "id": 210428
                    }, {
                        "name": "杭州欧珀智能控股集团",
                        "id": 210429
                    }, {
                        "name": "厦门字节互金",
                        "id": 210430
                    }, {
                        "name": "东京滴滴诊所控股集团",
                        "id": 210431
                    }, {
                        "name": "北京平安互金",
                        "id": 210432
                    }, {
                        "name": "杭州京东石油",
                        "id": 210433
                    }, {
                        "name": "杭州美团",
                        "id": 210434
                    }, {
                        "name": "香港亚马逊软件控股集团",
                        "id": 210435
                    }, {
                        "name": "东京微软证券",
                        "id": 210436
                    }]
                }, {
                    "name": "北京阿里软件有限公司",
                    "id": 210437,
                    "children": [{
                        "name": "广州美团旅游",
                        "id": 210438
                    }, {
                        "name": "南京奈雪",
                        "id": 210439
                    }, {
                        "name": "北京平安",
                        "id": 210440
                    }, {
                        "name": "纽约美团控股集团",
                        "id": 210441
                    }, {
                        "name": "南京平安互金",
                        "id": 210442
                    }, {
                        "name": "香港苹果地摊",
                        "id": 210443
                    }, {
                        "name": "天津快手制造",
                        "id": 210444
                    }, {
                        "name": "南京微软科技",
                        "id": 210445
                    }, {
                        "name": "台北快手制造",
                        "id": 210446
                    }, {
                        "name": "杭州特斯拉互金",
                        "id": 210447
                    }, {
                        "name": "东莞欧珀通信",
                        "id": 210448
                    }, {
                        "name": "上海欧珀通讯",
                        "id": 210449
                    }, {
                        "name": "首尔蚂蚁科技控股集团",
                        "id": 210450
                    }, {
                        "name": "杭州京东餐饮",
                        "id": 210451
                    }, {
                        "name": "南京腾讯智能",
                        "id": 210452
                    }, {
                        "name": "深圳特斯拉医院",
                        "id": 210453
                    }, {
                        "name": "北京星巴克金融",
                        "id": 210454
                    }, {
                        "name": "香港腾讯新能源",
                        "id": 210455
                    }, {
                        "name": "东京平安通信",
                        "id": 210456
                    }, {
                        "name": "东莞特斯拉新能源",
                        "id": 210457
                    }, {
                        "name": "首尔腾讯金融控股集团",
                        "id": 210458
                    }, {
                        "name": "厦门喜茶芯片",
                        "id": 210459
                    }, {
                        "name": "广州肯德基科技控股集团",
                        "id": 210460
                    }, {
                        "name": "杭州谷歌",
                        "id": 210461
                    }, {
                        "name": "深圳百度计算机控股集团",
                        "id": 210462
                    }, {
                        "name": "天津平安地摊有限公司",
                        "id": 210463
                    }]
                }, {
                    "name": "杭州快手石油",
                    "id": 210464
                }, {
                    "name": "东莞特斯拉智能控股集团",
                    "id": 210465
                }, {
                    "name": "上海快手医院",
                    "id": 210466
                }, {
                    "name": "天津亚马逊餐饮有限公司",
                    "id": 210467,
                    "children": [{
                        "name": "北京星巴克养殖",
                        "id": 210468
                    }, {
                        "name": "东莞奈雪新能源有限公司",
                        "id": 210469
                    }, {
                        "name": "纽约必胜客牧业控股集团",
                        "id": 210470
                    }, {
                        "name": "纽约肯德基医药",
                        "id": 210471
                    }, {
                        "name": "杭州星巴克医院",
                        "id": 210472
                    }, {
                        "name": "纽约滴滴金融",
                        "id": 210473
                    }, {
                        "name": "首尔肯德基医药有限公司",
                        "id": 210474
                    }, {
                        "name": "杭州字节科技",
                        "id": 210475
                    }, {
                        "name": "杭州星巴克互金有限公司",
                        "id": 210476
                    }, {
                        "name": "深圳腾讯智能",
                        "id": 210477
                    }, {
                        "name": "南京平安互金",
                        "id": 210478
                    }, {
                        "name": "东京星巴克证券",
                        "id": 210479
                    }, {
                        "name": "天津奈雪",
                        "id": 210480
                    }, {
                        "name": "北京肯德基软件",
                        "id": 210481
                    }, {
                        "name": "首尔京东科技",
                        "id": 210482
                    }, {
                        "name": "广州喜茶医院控股集团",
                        "id": 210483
                    }, {
                        "name": "南京蚂蚁芯片控股集团",
                        "id": 210484
                    }, {
                        "name": "厦门京东金融",
                        "id": 210485
                    }, {
                        "name": "纽约蚂蚁智能",
                        "id": 210486
                    }, {
                        "name": "天津谷歌通讯控股集团",
                        "id": 210487
                    }, {
                        "name": "天津特斯拉制造控股集团",
                        "id": 210488
                    }, {
                        "name": "东莞滴滴养殖",
                        "id": 210489
                    }, {
                        "name": "杭州字节石油有限公司",
                        "id": 210490
                    }, {
                        "name": "杭州阿里渔业",
                        "id": 210491
                    }, {
                        "name": "广州欧珀餐饮控股集团",
                        "id": 210492
                    }, {
                        "name": "北京瑞幸智能",
                        "id": 210493
                    }, {
                        "name": "南京美团制造有限公司",
                        "id": 210494
                    }, {
                        "name": "纽约瑞幸金融控股集团",
                        "id": 210495
                    }, {
                        "name": "纽约喜茶智能",
                        "id": 210496
                    }, {
                        "name": "深圳星巴克地摊控股集团",
                        "id": 210497
                    }]
                }, {
                    "name": "东京平安通讯控股集团",
                    "id": 210498
                }, {
                    "name": "台北微软地产控股集团",
                    "id": 210499
                }, {
                    "name": "东莞滴滴诊所",
                    "id": 210500
                }, {
                    "name": "香港字节渔业",
                    "id": 210501
                }, {
                    "name": "台北星巴克金融",
                    "id": 210502
                }, {
                    "name": "东京平安餐饮",
                    "id": 210503
                }, {
                    "name": "北京快手智能",
                    "id": 210504,
                    "children": [{
                        "name": "东莞微软",
                        "id": 210505
                    }, {
                        "name": "深圳欧珀软件",
                        "id": 210506
                    }, {
                        "name": "北京百度通信",
                        "id": 210507
                    }, {
                        "name": "上海苹果医院有限公司",
                        "id": 210508
                    }, {
                        "name": "深圳必胜客新能源",
                        "id": 210509
                    }, {
                        "name": "天津小米银行控股集团",
                        "id": 210510
                    }, {
                        "name": "纽约阿里地产",
                        "id": 210511
                    }, {
                        "name": "深圳华为汽车",
                        "id": 210512
                    }, {
                        "name": "北京滴滴餐饮",
                        "id": 210513
                    }, {
                        "name": "深圳必胜客信息服务",
                        "id": 210514
                    }, {
                        "name": "杭州腾讯制造",
                        "id": 210515
                    }, {
                        "name": "北京平安渔业",
                        "id": 210516
                    }]
                }, {
                    "name": "深圳特斯拉养殖控股集团",
                    "id": 210517,
                    "children": [{
                        "name": "杭州奈雪",
                        "id": 210518
                    }, {
                        "name": "广州滴滴软件控股集团",
                        "id": 210519
                    }, {
                        "name": "北京美团地摊控股集团",
                        "id": 210520
                    }, {
                        "name": "天津星巴克渔业",
                        "id": 210521
                    }, {
                        "name": "北京星巴克科技",
                        "id": 210522
                    }, {
                        "name": "厦门星巴克科技",
                        "id": 210523
                    }, {
                        "name": "东京京东基金有限公司",
                        "id": 210524
                    }, {
                        "name": "香港蚂蚁证券控股集团",
                        "id": 210525
                    }, {
                        "name": "南京星巴克医药控股集团",
                        "id": 210526
                    }, {
                        "name": "杭州字节农业",
                        "id": 210527
                    }, {
                        "name": "杭州小米软件控股集团",
                        "id": 210528
                    }]
                }, {
                    "name": "南京腾讯证券",
                    "id": 210529,
                    "children": [{
                        "name": "台北亚马逊餐饮",
                        "id": 210530
                    }, {
                        "name": "广州滴滴餐饮",
                        "id": 210531
                    }, {
                        "name": "深圳亚马逊芯片",
                        "id": 210532
                    }, {
                        "name": "纽约星巴克",
                        "id": 210533
                    }, {
                        "name": "首尔小米制造",
                        "id": 210534
                    }, {
                        "name": "北京蚂蚁诊所控股集团",
                        "id": 210535
                    }, {
                        "name": "首尔滴滴制造",
                        "id": 210536
                    }, {
                        "name": "纽约快手",
                        "id": 210537
                    }, {
                        "name": "台北平安石油",
                        "id": 210538
                    }, {
                        "name": "东莞特斯拉地摊有限公司",
                        "id": 210539
                    }, {
                        "name": "厦门特斯拉诊所",
                        "id": 210540
                    }, {
                        "name": "台北谷歌芯片",
                        "id": 210541
                    }, {
                        "name": "台北华为计算机有限公司",
                        "id": 210542
                    }, {
                        "name": "北京百度金融有限公司",
                        "id": 210543
                    }, {
                        "name": "纽约滴滴计算机",
                        "id": 210544
                    }, {
                        "name": "东莞平安石油",
                        "id": 210545
                    }, {
                        "name": "天津京东互金控股集团",
                        "id": 210546
                    }, {
                        "name": "深圳美团",
                        "id": 210547
                    }, {
                        "name": "首尔阿里证券",
                        "id": 210548
                    }, {
                        "name": "广州京东旅游",
                        "id": 210549
                    }, {
                        "name": "厦门肯德基农业",
                        "id": 210550
                    }, {
                        "name": "上海亚马逊养殖",
                        "id": 210551
                    }, {
                        "name": "南京必胜客通讯",
                        "id": 210552
                    }, {
                        "name": "天津滴滴信息服务有限公司",
                        "id": 210553
                    }, {
                        "name": "香港百度芯片控股集团",
                        "id": 210554
                    }]
                }, {
                    "name": "纽约欧珀智能有限公司",
                    "id": 210555,
                    "children": [{
                        "name": "广州必胜客信息服务有限公司",
                        "id": 210556
                    }]
                }, {
                    "name": "北京华为电商有限公司",
                    "id": 210557
                }, {
                    "name": "纽约百度旅游",
                    "id": 210558
                }, {
                    "name": "南京字节汽车有限公司",
                    "id": 210559
                }, {
                    "name": "天津奈雪基金",
                    "id": 210560
                }, {
                    "name": "上海奈雪电商",
                    "id": 210561
                }, {
                    "name": "东京快手诊所",
                    "id": 210562
                }, {
                    "name": "深圳亚马逊软件",
                    "id": 210563
                }]
            }, {
                "name": "深圳瑞幸软件",
                "id": 210564
            }, {
                "name": "天津华为通讯",
                "id": 210565,
                "children": [{
                    "name": "广州谷歌诊所有限公司",
                    "id": 210566
                }, {
                    "name": "东莞瑞幸旅游",
                    "id": 210567
                }, {
                    "name": "东莞喜茶",
                    "id": 210568
                }, {
                    "name": "香港快手餐饮",
                    "id": 210569,
                    "children": [{
                        "name": "东京华为计算机",
                        "id": 210570
                    }, {
                        "name": "台北阿里诊所",
                        "id": 210571
                    }, {
                        "name": "香港特斯拉银行",
                        "id": 210572
                    }, {
                        "name": "东莞平安汽车",
                        "id": 210573
                    }, {
                        "name": "天津肯德基汽车",
                        "id": 210574
                    }, {
                        "name": "杭州快手金融",
                        "id": 210575
                    }, {
                        "name": "香港京东电商",
                        "id": 210576
                    }, {
                        "name": "台北星巴克金融控股集团",
                        "id": 210577
                    }, {
                        "name": "深圳腾讯通讯有限公司",
                        "id": 210578
                    }, {
                        "name": "纽约字节渔业",
                        "id": 210579
                    }, {
                        "name": "北京美团智能",
                        "id": 210580
                    }, {
                        "name": "南京必胜客医药",
                        "id": 210581
                    }, {
                        "name": "南京字节金融",
                        "id": 210582
                    }, {
                        "name": "杭州亚马逊信息服务",
                        "id": 210583
                    }, {
                        "name": "杭州必胜客银行",
                        "id": 210584
                    }, {
                        "name": "南京谷歌石油控股集团",
                        "id": 210585
                    }, {
                        "name": "杭州必胜客金融控股集团",
                        "id": 210586
                    }, {
                        "name": "南京瑞幸互金有限公司",
                        "id": 210587
                    }, {
                        "name": "首尔字节航空",
                        "id": 210588
                    }, {
                        "name": "北京小米农业",
                        "id": 210589
                    }, {
                        "name": "广州京东汽车",
                        "id": 210590
                    }, {
                        "name": "南京蚂蚁电商",
                        "id": 210591
                    }, {
                        "name": "台北百度渔业有限公司",
                        "id": 210592
                    }, {
                        "name": "东京美团养殖控股集团",
                        "id": 210593
                    }, {
                        "name": "香港必胜客牧业",
                        "id": 210594
                    }, {
                        "name": "上海欧珀牧业",
                        "id": 210595
                    }, {
                        "name": "广州亚马逊地摊有限公司",
                        "id": 210596
                    }, {
                        "name": "杭州喜茶养殖有限公司",
                        "id": 210597
                    }, {
                        "name": "上海百度医药",
                        "id": 210598
                    }, {
                        "name": "南京特斯拉牧业",
                        "id": 210599
                    }, {
                        "name": "深圳特斯拉渔业",
                        "id": 210600
                    }, {
                        "name": "杭州小米地产",
                        "id": 210601
                    }, {
                        "name": "东京华为信息服务有限公司",
                        "id": 210602
                    }, {
                        "name": "上海瑞幸通信",
                        "id": 210603
                    }, {
                        "name": "东京华为通讯",
                        "id": 210604
                    }]
                }, {
                    "name": "深圳平安基金有限公司",
                    "id": 210605
                }, {
                    "name": "香港喜茶旅游有限公司",
                    "id": 210606
                }, {
                    "name": "厦门字节航空",
                    "id": 210607
                }, {
                    "name": "东京必胜客新能源有限公司",
                    "id": 210608,
                    "children": [{
                        "name": "天津滴滴制造",
                        "id": 210609
                    }, {
                        "name": "南京星巴克计算机",
                        "id": 210610
                    }, {
                        "name": "南京苹果制造控股集团",
                        "id": 210611
                    }, {
                        "name": "广州华为银行",
                        "id": 210612
                    }, {
                        "name": "香港字节通讯",
                        "id": 210613
                    }, {
                        "name": "深圳特斯拉地摊有限公司",
                        "id": 210614
                    }, {
                        "name": "台北平安地摊控股集团",
                        "id": 210615
                    }, {
                        "name": "纽约微软芯片",
                        "id": 210616
                    }, {
                        "name": "北京谷歌地产",
                        "id": 210617
                    }, {
                        "name": "上海瑞幸信息服务",
                        "id": 210618
                    }, {
                        "name": "台北字节计算机",
                        "id": 210619
                    }, {
                        "name": "东京字节",
                        "id": 210620
                    }, {
                        "name": "天津亚马逊新能源",
                        "id": 210621
                    }, {
                        "name": "东莞滴滴通讯控股集团",
                        "id": 210622
                    }, {
                        "name": "台北平安科技",
                        "id": 210623
                    }, {
                        "name": "厦门平安基金",
                        "id": 210624
                    }, {
                        "name": "首尔平安新能源",
                        "id": 210625
                    }, {
                        "name": "北京字节航空",
                        "id": 210626
                    }, {
                        "name": "上海苹果牧业",
                        "id": 210627
                    }, {
                        "name": "深圳奈雪地产",
                        "id": 210628
                    }, {
                        "name": "台北快手计算机有限公司",
                        "id": 210629
                    }, {
                        "name": "厦门阿里石油",
                        "id": 210630
                    }, {
                        "name": "广州谷歌智能",
                        "id": 210631
                    }, {
                        "name": "首尔字节餐饮控股集团",
                        "id": 210632
                    }, {
                        "name": "杭州平安基金",
                        "id": 210633
                    }, {
                        "name": "杭州谷歌医院控股集团",
                        "id": 210634
                    }, {
                        "name": "东京蚂蚁汽车",
                        "id": 210635
                    }, {
                        "name": "上海腾讯牧业",
                        "id": 210636
                    }]
                }, {
                    "name": "南京美团智能",
                    "id": 210637
                }, {
                    "name": "台北星巴克医院",
                    "id": 210638
                }, {
                    "name": "广州平安基金有限公司",
                    "id": 210639,
                    "children": [{
                        "name": "东莞谷歌汽车",
                        "id": 210640
                    }, {
                        "name": "纽约奈雪制造",
                        "id": 210641
                    }, {
                        "name": "杭州阿里石油",
                        "id": 210642
                    }, {
                        "name": "厦门腾讯科技",
                        "id": 210643
                    }, {
                        "name": "天津肯德基",
                        "id": 210644
                    }, {
                        "name": "纽约阿里证券",
                        "id": 210645
                    }]
                }]
            }, {
                "name": "杭州特斯拉渔业",
                "id": 210646
            }, {
                "name": "台北蚂蚁信息服务",
                "id": 210647
            }, {
                "name": "东京喜茶诊所有限公司",
                "id": 210648
            }, {
                "name": "纽约字节诊所控股集团",
                "id": 210649
            }, {
                "name": "厦门瑞幸信息服务",
                "id": 210650
            }, {
                "name": "东京苹果石油控股集团",
                "id": 210651,
                "children": [{
                    "name": "首尔快手制造有限公司",
                    "id": 210652,
                    "children": [{
                        "name": "香港小米养殖有限公司",
                        "id": 210653
                    }, {
                        "name": "广州平安医院",
                        "id": 210654
                    }, {
                        "name": "杭州苹果芯片",
                        "id": 210655
                    }, {
                        "name": "上海苹果渔业控股集团",
                        "id": 210656
                    }, {
                        "name": "香港星巴克",
                        "id": 210657
                    }, {
                        "name": "台北欧珀基金有限公司",
                        "id": 210658
                    }, {
                        "name": "首尔腾讯通信",
                        "id": 210659
                    }, {
                        "name": "上海肯德基软件有限公司",
                        "id": 210660
                    }]
                }, {
                    "name": "广州亚马逊银行",
                    "id": 210661
                }, {
                    "name": "北京瑞幸计算机",
                    "id": 210662,
                    "children": [{
                        "name": "台北腾讯渔业",
                        "id": 210663
                    }, {
                        "name": "深圳瑞幸互金",
                        "id": 210664
                    }, {
                        "name": "上海京东医药",
                        "id": 210665
                    }, {
                        "name": "上海必胜客电商控股集团",
                        "id": 210666
                    }, {
                        "name": "广州微软养殖有限公司",
                        "id": 210667
                    }, {
                        "name": "首尔特斯拉汽车控股集团",
                        "id": 210668
                    }, {
                        "name": "天津必胜客养殖",
                        "id": 210669
                    }, {
                        "name": "深圳苹果证券",
                        "id": 210670
                    }, {
                        "name": "首尔谷歌地产",
                        "id": 210671
                    }, {
                        "name": "上海喜茶芯片",
                        "id": 210672
                    }, {
                        "name": "东莞蚂蚁地摊",
                        "id": 210673
                    }, {
                        "name": "北京欧珀旅游",
                        "id": 210674
                    }, {
                        "name": "东京谷歌芯片控股集团",
                        "id": 210675
                    }]
                }, {
                    "name": "杭州谷歌旅游",
                    "id": 210676
                }, {
                    "name": "上海亚马逊渔业控股集团",
                    "id": 210677
                }, {
                    "name": "天津瑞幸控股集团",
                    "id": 210678
                }, {
                    "name": "纽约喜茶计算机控股集团",
                    "id": 210679
                }, {
                    "name": "杭州百度计算机",
                    "id": 210680
                }, {
                    "name": "广州蚂蚁医药",
                    "id": 210681,
                    "children": [{
                        "name": "深圳喜茶医院",
                        "id": 210682
                    }, {
                        "name": "天津腾讯基金",
                        "id": 210683
                    }, {
                        "name": "上海苹果",
                        "id": 210684
                    }, {
                        "name": "北京字节银行",
                        "id": 210685
                    }, {
                        "name": "杭州滴滴证券",
                        "id": 210686
                    }, {
                        "name": "香港滴滴通信控股集团",
                        "id": 210687
                    }, {
                        "name": "厦门蚂蚁牧业",
                        "id": 210688
                    }, {
                        "name": "首尔平安电商有限公司",
                        "id": 210689
                    }, {
                        "name": "东莞必胜客计算机",
                        "id": 210690
                    }, {
                        "name": "纽约百度地产",
                        "id": 210691
                    }, {
                        "name": "厦门平安证券有限公司",
                        "id": 210692
                    }, {
                        "name": "厦门瑞幸医院",
                        "id": 210693
                    }, {
                        "name": "上海奈雪汽车",
                        "id": 210694
                    }, {
                        "name": "天津快手渔业",
                        "id": 210695
                    }, {
                        "name": "天津特斯拉医药",
                        "id": 210696
                    }, {
                        "name": "北京阿里信息服务",
                        "id": 210697
                    }, {
                        "name": "杭州滴滴芯片",
                        "id": 210698
                    }, {
                        "name": "杭州苹果新能源控股集团",
                        "id": 210699
                    }, {
                        "name": "杭州瑞幸信息服务",
                        "id": 210700
                    }, {
                        "name": "北京苹果科技控股集团",
                        "id": 210701
                    }, {
                        "name": "深圳星巴克证券控股集团",
                        "id": 210702
                    }, {
                        "name": "南京京东医院",
                        "id": 210703
                    }, {
                        "name": "东莞滴滴航空",
                        "id": 210704
                    }, {
                        "name": "天津滴滴银行",
                        "id": 210705
                    }, {
                        "name": "首尔微软医院控股集团",
                        "id": 210706
                    }, {
                        "name": "厦门滴滴汽车控股集团",
                        "id": 210707
                    }, {
                        "name": "香港喜茶通讯",
                        "id": 210708
                    }]
                }, {
                    "name": "北京小米科技",
                    "id": 210709
                }, {
                    "name": "杭州腾讯餐饮控股集团",
                    "id": 210710,
                    "children": [{
                        "name": "首尔平安",
                        "id": 210711
                    }, {
                        "name": "深圳瑞幸汽车",
                        "id": 210712
                    }, {
                        "name": "香港欧珀金融控股集团",
                        "id": 210713
                    }, {
                        "name": "香港星巴克银行",
                        "id": 210714
                    }]
                }, {
                    "name": "杭州苹果制造",
                    "id": 210715
                }, {
                    "name": "杭州星巴克银行有限公司",
                    "id": 210716
                }, {
                    "name": "东莞华为银行",
                    "id": 210717
                }, {
                    "name": "首尔亚马逊新能源控股集团",
                    "id": 210718
                }, {
                    "name": "杭州谷歌地摊",
                    "id": 210719
                }, {
                    "name": "东京微软银行有限公司",
                    "id": 210720,
                    "children": [{
                        "name": "台北小米石油",
                        "id": 210721
                    }, {
                        "name": "东京喜茶汽车控股集团",
                        "id": 210722
                    }, {
                        "name": "上海苹果软件",
                        "id": 210723
                    }, {
                        "name": "台北瑞幸电商",
                        "id": 210724
                    }, {
                        "name": "纽约星巴克新能源",
                        "id": 210725
                    }]
                }, {
                    "name": "杭州字节电商",
                    "id": 210726
                }, {
                    "name": "台北肯德基地摊",
                    "id": 210727
                }, {
                    "name": "南京滴滴通信控股集团",
                    "id": 210728
                }]
            }, {
                "name": "首尔特斯拉证券控股集团",
                "id": 210729
            }]
        }, {
            "name": "杭州滴滴智能",
            "id": 210730
        }, {
            "name": "东莞滴滴基金",
            "id": 210731
        }, {
            "name": "东京快手智能",
            "id": 210732
        }, {
            "name": "东莞滴滴计算机控股集团",
            "id": 210733,
            "children": [{
                "name": "首尔亚马逊诊所",
                "id": 210734
            }, {
                "name": "香港必胜客软件",
                "id": 210735,
                "children": [{
                    "name": "深圳京东航空",
                    "id": 210736
                }, {
                    "name": "东莞小米电商",
                    "id": 210737
                }, {
                    "name": "深圳亚马逊牧业控股集团",
                    "id": 210738
                }, {
                    "name": "杭州亚马逊地产",
                    "id": 210739,
                    "children": [{
                        "name": "天津滴滴软件有限公司",
                        "id": 210740
                    }, {
                        "name": "北京谷歌证券",
                        "id": 210741
                    }, {
                        "name": "纽约亚马逊制造有限公司",
                        "id": 210742
                    }, {
                        "name": "首尔喜茶智能",
                        "id": 210743
                    }, {
                        "name": "深圳肯德基软件",
                        "id": 210744
                    }, {
                        "name": "杭州小米芯片",
                        "id": 210745
                    }, {
                        "name": "东莞字节证券控股集团",
                        "id": 210746
                    }, {
                        "name": "东莞奈雪芯片控股集团",
                        "id": 210747
                    }]
                }, {
                    "name": "台北亚马逊",
                    "id": 210748
                }, {
                    "name": "上海快手农业",
                    "id": 210749
                }, {
                    "name": "杭州微软餐饮",
                    "id": 210750,
                    "children": [{
                        "name": "厦门特斯拉地摊有限公司",
                        "id": 210751
                    }, {
                        "name": "厦门平安基金有限公司",
                        "id": 210752
                    }, {
                        "name": "东莞快手航空",
                        "id": 210753
                    }, {
                        "name": "南京美团农业",
                        "id": 210754
                    }, {
                        "name": "杭州必胜客金融",
                        "id": 210755
                    }, {
                        "name": "厦门百度互金",
                        "id": 210756
                    }, {
                        "name": "天津百度互金有限公司",
                        "id": 210757
                    }, {
                        "name": "东莞美团新能源有限公司",
                        "id": 210758
                    }, {
                        "name": "厦门华为制造",
                        "id": 210759
                    }, {
                        "name": "首尔特斯拉",
                        "id": 210760
                    }, {
                        "name": "杭州京东通信",
                        "id": 210761
                    }, {
                        "name": "深圳蚂蚁制造有限公司",
                        "id": 210762
                    }, {
                        "name": "南京喜茶医药有限公司",
                        "id": 210763
                    }, {
                        "name": "杭州京东控股集团",
                        "id": 210764
                    }, {
                        "name": "杭州小米基金",
                        "id": 210765
                    }, {
                        "name": "厦门特斯拉计算机",
                        "id": 210766
                    }, {
                        "name": "纽约华为诊所",
                        "id": 210767
                    }, {
                        "name": "厦门微软",
                        "id": 210768
                    }, {
                        "name": "厦门喜茶证券",
                        "id": 210769
                    }, {
                        "name": "东莞腾讯互金",
                        "id": 210770
                    }, {
                        "name": "杭州腾讯地产",
                        "id": 210771
                    }, {
                        "name": "杭州奈雪农业控股集团",
                        "id": 210772
                    }, {
                        "name": "香港必胜客互金有限公司",
                        "id": 210773
                    }, {
                        "name": "香港字节金融",
                        "id": 210774
                    }]
                }, {
                    "name": "天津快手医院",
                    "id": 210775
                }, {
                    "name": "上海华为银行",
                    "id": 210776
                }, {
                    "name": "深圳百度制造",
                    "id": 210777
                }, {
                    "name": "东京华为医药",
                    "id": 210778
                }, {
                    "name": "北京亚马逊科技有限公司",
                    "id": 210779
                }, {
                    "name": "深圳京东渔业有限公司",
                    "id": 210780
                }, {
                    "name": "香港瑞幸科技",
                    "id": 210781
                }, {
                    "name": "纽约平安渔业",
                    "id": 210782,
                    "children": [{
                        "name": "台北腾讯软件",
                        "id": 210783
                    }, {
                        "name": "北京美团金融",
                        "id": 210784
                    }, {
                        "name": "南京谷歌",
                        "id": 210785
                    }, {
                        "name": "北京平安渔业",
                        "id": 210786
                    }, {
                        "name": "深圳字节制造",
                        "id": 210787
                    }, {
                        "name": "杭州亚马逊旅游",
                        "id": 210788
                    }, {
                        "name": "天津美团旅游",
                        "id": 210789
                    }, {
                        "name": "东京阿里诊所",
                        "id": 210790
                    }, {
                        "name": "上海百度牧业控股集团",
                        "id": 210791
                    }, {
                        "name": "香港蚂蚁软件",
                        "id": 210792
                    }, {
                        "name": "深圳喜茶新能源",
                        "id": 210793
                    }, {
                        "name": "天津平安软件",
                        "id": 210794
                    }, {
                        "name": "东京华为农业",
                        "id": 210795
                    }, {
                        "name": "天津快手互金控股集团",
                        "id": 210796
                    }, {
                        "name": "北京微软证券",
                        "id": 210797
                    }, {
                        "name": "东莞快手制造",
                        "id": 210798
                    }, {
                        "name": "杭州京东农业控股集团",
                        "id": 210799
                    }, {
                        "name": "杭州美团互金",
                        "id": 210800
                    }, {
                        "name": "台北平安医药",
                        "id": 210801
                    }, {
                        "name": "广州华为医院控股集团",
                        "id": 210802
                    }]
                }, {
                    "name": "厦门星巴克旅游",
                    "id": 210803
                }, {
                    "name": "深圳京东",
                    "id": 210804
                }, {
                    "name": "杭州京东新能源控股集团",
                    "id": 210805
                }, {
                    "name": "深圳谷歌地摊",
                    "id": 210806,
                    "children": [{
                        "name": "上海快手旅游",
                        "id": 210807
                    }, {
                        "name": "深圳腾讯航空",
                        "id": 210808
                    }, {
                        "name": "东京瑞幸农业控股集团",
                        "id": 210809
                    }, {
                        "name": "厦门腾讯地产",
                        "id": 210810
                    }, {
                        "name": "纽约谷歌芯片",
                        "id": 210811
                    }, {
                        "name": "厦门苹果通讯",
                        "id": 210812
                    }, {
                        "name": "首尔瑞幸航空",
                        "id": 210813
                    }, {
                        "name": "深圳必胜客石油控股集团",
                        "id": 210814
                    }, {
                        "name": "南京平安银行",
                        "id": 210815
                    }, {
                        "name": "北京蚂蚁银行",
                        "id": 210816
                    }, {
                        "name": "首尔阿里餐饮",
                        "id": 210817
                    }, {
                        "name": "首尔欧珀医院有限公司",
                        "id": 210818
                    }, {
                        "name": "首尔蚂蚁石油有限公司",
                        "id": 210819
                    }, {
                        "name": "香港星巴克农业控股集团",
                        "id": 210820
                    }, {
                        "name": "北京字节基金控股集团",
                        "id": 210821
                    }, {
                        "name": "台北腾讯通讯控股集团",
                        "id": 210822
                    }, {
                        "name": "厦门喜茶诊所控股集团",
                        "id": 210823
                    }, {
                        "name": "厦门肯德基互金",
                        "id": 210824
                    }, {
                        "name": "首尔欧珀新能源",
                        "id": 210825
                    }]
                }, {
                    "name": "东京亚马逊医药控股集团",
                    "id": 210826
                }, {
                    "name": "上海滴滴医院",
                    "id": 210827,
                    "children": [{
                        "name": "广州微软银行",
                        "id": 210828
                    }, {
                        "name": "厦门瑞幸",
                        "id": 210829
                    }, {
                        "name": "天津阿里农业",
                        "id": 210830
                    }, {
                        "name": "杭州快手制造",
                        "id": 210831
                    }, {
                        "name": "深圳华为新能源",
                        "id": 210832
                    }, {
                        "name": "厦门阿里基金有限公司",
                        "id": 210833
                    }, {
                        "name": "深圳小米医药",
                        "id": 210834
                    }, {
                        "name": "杭州百度餐饮有限公司",
                        "id": 210835
                    }, {
                        "name": "南京京东软件控股集团",
                        "id": 210836
                    }, {
                        "name": "台北字节医药控股集团",
                        "id": 210837
                    }, {
                        "name": "天津欧珀农业有限公司",
                        "id": 210838
                    }, {
                        "name": "杭州必胜客电商",
                        "id": 210839
                    }, {
                        "name": "上海阿里金融",
                        "id": 210840
                    }, {
                        "name": "台北肯德基航空",
                        "id": 210841
                    }, {
                        "name": "深圳欧珀智能有限公司",
                        "id": 210842
                    }, {
                        "name": "深圳瑞幸软件",
                        "id": 210843
                    }, {
                        "name": "东莞腾讯控股集团",
                        "id": 210844
                    }, {
                        "name": "南京平安有限公司",
                        "id": 210845
                    }, {
                        "name": "东莞星巴克通讯",
                        "id": 210846
                    }, {
                        "name": "纽约奈雪医药有限公司",
                        "id": 210847
                    }, {
                        "name": "首尔快手软件控股集团",
                        "id": 210848
                    }, {
                        "name": "首尔阿里通信",
                        "id": 210849
                    }, {
                        "name": "南京阿里",
                        "id": 210850
                    }]
                }]
            }, {
                "name": "东京字节地产控股集团",
                "id": 210851,
                "children": [{
                    "name": "东京奈雪科技",
                    "id": 210852
                }, {
                    "name": "南京肯德基金融",
                    "id": 210853
                }, {
                    "name": "天津亚马逊汽车",
                    "id": 210854,
                    "children": [{
                        "name": "北京欧珀航空有限公司",
                        "id": 210855
                    }, {
                        "name": "台北腾讯地摊有限公司",
                        "id": 210856
                    }, {
                        "name": "厦门字节",
                        "id": 210857
                    }, {
                        "name": "天津平安诊所有限公司",
                        "id": 210858
                    }, {
                        "name": "杭州特斯拉医药",
                        "id": 210859
                    }, {
                        "name": "杭州亚马逊智能控股集团",
                        "id": 210860
                    }, {
                        "name": "东莞星巴克通讯有限公司",
                        "id": 210861
                    }, {
                        "name": "广州苹果医药有限公司",
                        "id": 210862
                    }, {
                        "name": "东莞谷歌牧业",
                        "id": 210863
                    }, {
                        "name": "首尔快手证券控股集团",
                        "id": 210864
                    }, {
                        "name": "纽约肯德基汽车",
                        "id": 210865
                    }, {
                        "name": "上海喜茶银行控股集团",
                        "id": 210866
                    }, {
                        "name": "杭州微软有限公司",
                        "id": 210867
                    }, {
                        "name": "杭州阿里有限公司",
                        "id": 210868
                    }, {
                        "name": "纽约奈雪石油",
                        "id": 210869
                    }, {
                        "name": "杭州肯德基石油",
                        "id": 210870
                    }, {
                        "name": "北京快手智能",
                        "id": 210871
                    }, {
                        "name": "北京喜茶汽车有限公司",
                        "id": 210872
                    }, {
                        "name": "上海特斯拉基金",
                        "id": 210873
                    }, {
                        "name": "杭州小米科技控股集团",
                        "id": 210874
                    }, {
                        "name": "南京瑞幸地产",
                        "id": 210875
                    }, {
                        "name": "杭州喜茶电商",
                        "id": 210876
                    }]
                }, {
                    "name": "香港奈雪",
                    "id": 210877
                }, {
                    "name": "杭州腾讯互金",
                    "id": 210878,
                    "children": [{
                        "name": "杭州阿里智能",
                        "id": 210879
                    }, {
                        "name": "香港滴滴",
                        "id": 210880
                    }, {
                        "name": "上海快手诊所",
                        "id": 210881
                    }, {
                        "name": "纽约京东餐饮",
                        "id": 210882
                    }, {
                        "name": "深圳字节旅游",
                        "id": 210883
                    }, {
                        "name": "天津奈雪",
                        "id": 210884
                    }, {
                        "name": "天津谷歌软件",
                        "id": 210885
                    }, {
                        "name": "纽约欧珀养殖控股集团",
                        "id": 210886
                    }, {
                        "name": "台北美团通讯",
                        "id": 210887
                    }, {
                        "name": "香港瑞幸渔业",
                        "id": 210888
                    }, {
                        "name": "南京京东",
                        "id": 210889
                    }, {
                        "name": "上海瑞幸有限公司",
                        "id": 210890
                    }, {
                        "name": "纽约喜茶基金",
                        "id": 210891
                    }, {
                        "name": "东京欧珀诊所",
                        "id": 210892
                    }, {
                        "name": "纽约腾讯智能",
                        "id": 210893
                    }, {
                        "name": "首尔京东石油",
                        "id": 210894
                    }, {
                        "name": "杭州奈雪石油",
                        "id": 210895
                    }, {
                        "name": "香港奈雪软件有限公司",
                        "id": 210896
                    }, {
                        "name": "天津华为智能控股集团",
                        "id": 210897
                    }, {
                        "name": "广州必胜客航空",
                        "id": 210898
                    }, {
                        "name": "台北谷歌地摊",
                        "id": 210899
                    }, {
                        "name": "东京滴滴",
                        "id": 210900
                    }, {
                        "name": "香港小米医院",
                        "id": 210901
                    }, {
                        "name": "上海华为软件",
                        "id": 210902
                    }, {
                        "name": "台北星巴克餐饮有限公司",
                        "id": 210903
                    }, {
                        "name": "天津腾讯电商",
                        "id": 210904
                    }, {
                        "name": "杭州小米餐饮",
                        "id": 210905
                    }, {
                        "name": "纽约快手渔业",
                        "id": 210906
                    }, {
                        "name": "厦门京东芯片",
                        "id": 210907
                    }, {
                        "name": "杭州微软芯片有限公司",
                        "id": 210908
                    }, {
                        "name": "杭州谷歌渔业",
                        "id": 210909
                    }]
                }, {
                    "name": "纽约谷歌芯片",
                    "id": 210910
                }, {
                    "name": "台北快手渔业",
                    "id": 210911
                }, {
                    "name": "杭州喜茶信息服务",
                    "id": 210912
                }, {
                    "name": "纽约必胜客新能源",
                    "id": 210913
                }, {
                    "name": "台北字节基金有限公司",
                    "id": 210914
                }, {
                    "name": "东京喜茶汽车",
                    "id": 210915
                }, {
                    "name": "北京平安科技",
                    "id": 210916
                }, {
                    "name": "广州百度控股集团",
                    "id": 210917
                }, {
                    "name": "杭州微软农业有限公司",
                    "id": 210918
                }, {
                    "name": "杭州美团科技",
                    "id": 210919
                }, {
                    "name": "杭州美团",
                    "id": 210920
                }, {
                    "name": "首尔蚂蚁旅游",
                    "id": 210921
                }, {
                    "name": "南京滴滴农业",
                    "id": 210922,
                    "children": [{
                        "name": "上海字节软件有限公司",
                        "id": 210923
                    }, {
                        "name": "广州阿里旅游",
                        "id": 210924
                    }, {
                        "name": "首尔特斯拉农业",
                        "id": 210925
                    }, {
                        "name": "首尔阿里芯片",
                        "id": 210926
                    }, {
                        "name": "杭州瑞幸科技控股集团",
                        "id": 210927
                    }, {
                        "name": "深圳欧珀航空有限公司",
                        "id": 210928
                    }, {
                        "name": "纽约滴滴地摊",
                        "id": 210929
                    }, {
                        "name": "杭州必胜客计算机",
                        "id": 210930
                    }, {
                        "name": "杭州特斯拉渔业控股集团",
                        "id": 210931
                    }, {
                        "name": "首尔欧珀证券",
                        "id": 210932
                    }, {
                        "name": "天津奈雪制造",
                        "id": 210933
                    }, {
                        "name": "广州欧珀互金控股集团",
                        "id": 210934
                    }, {
                        "name": "深圳平安通信",
                        "id": 210935
                    }, {
                        "name": "北京平安通信有限公司",
                        "id": 210936
                    }, {
                        "name": "厦门平安控股集团",
                        "id": 210937
                    }, {
                        "name": "南京快手农业",
                        "id": 210938
                    }, {
                        "name": "上海奈雪互金",
                        "id": 210939
                    }, {
                        "name": "杭州京东金融",
                        "id": 210940
                    }, {
                        "name": "南京平安证券",
                        "id": 210941
                    }, {
                        "name": "上海小米科技",
                        "id": 210942
                    }, {
                        "name": "天津字节石油",
                        "id": 210943
                    }, {
                        "name": "杭州阿里餐饮控股集团",
                        "id": 210944
                    }, {
                        "name": "首尔阿里通信",
                        "id": 210945
                    }, {
                        "name": "深圳小米互金",
                        "id": 210946
                    }, {
                        "name": "深圳平安医院",
                        "id": 210947
                    }, {
                        "name": "北京京东农业",
                        "id": 210948
                    }, {
                        "name": "香港小米基金",
                        "id": 210949
                    }, {
                        "name": "台北阿里航空控股集团",
                        "id": 210950
                    }, {
                        "name": "天津亚马逊农业",
                        "id": 210951
                    }, {
                        "name": "首尔奈雪通信有限公司",
                        "id": 210952
                    }, {
                        "name": "深圳快手医药",
                        "id": 210953
                    }, {
                        "name": "深圳瑞幸互金",
                        "id": 210954
                    }, {
                        "name": "广州必胜客芯片控股集团",
                        "id": 210955
                    }, {
                        "name": "香港阿里互金控股集团",
                        "id": 210956
                    }, {
                        "name": "纽约特斯拉信息服务",
                        "id": 210957
                    }, {
                        "name": "深圳小米地产",
                        "id": 210958
                    }]
                }, {
                    "name": "东京星巴克农业",
                    "id": 210959,
                    "children": [{
                        "name": "深圳亚马逊医院",
                        "id": 210960
                    }, {
                        "name": "厦门欧珀互金控股集团",
                        "id": 210961
                    }, {
                        "name": "上海苹果银行",
                        "id": 210962
                    }, {
                        "name": "东京苹果养殖",
                        "id": 210963
                    }, {
                        "name": "杭州阿里医院控股集团",
                        "id": 210964
                    }, {
                        "name": "北京京东证券有限公司",
                        "id": 210965
                    }, {
                        "name": "纽约苹果软件",
                        "id": 210966
                    }, {
                        "name": "纽约华为新能源有限公司",
                        "id": 210967
                    }, {
                        "name": "深圳微软有限公司",
                        "id": 210968
                    }, {
                        "name": "杭州平安医院有限公司",
                        "id": 210969
                    }, {
                        "name": "台北星巴克证券",
                        "id": 210970
                    }, {
                        "name": "北京欧珀科技控股集团",
                        "id": 210971
                    }, {
                        "name": "广州必胜客汽车有限公司",
                        "id": 210972
                    }, {
                        "name": "广州美团农业",
                        "id": 210973
                    }, {
                        "name": "东京小米基金",
                        "id": 210974
                    }, {
                        "name": "东莞瑞幸",
                        "id": 210975
                    }, {
                        "name": "纽约星巴克牧业有限公司",
                        "id": 210976
                    }, {
                        "name": "上海特斯拉旅游有限公司",
                        "id": 210977
                    }, {
                        "name": "广州华为科技",
                        "id": 210978
                    }, {
                        "name": "广州特斯拉农业控股集团",
                        "id": 210979
                    }, {
                        "name": "厦门必胜客控股集团",
                        "id": 210980
                    }, {
                        "name": "纽约奈雪控股集团",
                        "id": 210981
                    }, {
                        "name": "杭州小米科技有限公司",
                        "id": 210982
                    }, {
                        "name": "南京微软航空",
                        "id": 210983
                    }, {
                        "name": "首尔百度医院",
                        "id": 210984
                    }, {
                        "name": "上海滴滴",
                        "id": 210985
                    }, {
                        "name": "上海亚马逊控股集团",
                        "id": 210986
                    }, {
                        "name": "台北喜茶医院有限公司",
                        "id": 210987
                    }, {
                        "name": "广州特斯拉",
                        "id": 210988
                    }, {
                        "name": "上海百度有限公司",
                        "id": 210989
                    }, {
                        "name": "纽约华为制造有限公司",
                        "id": 210990
                    }, {
                        "name": "东莞滴滴牧业",
                        "id": 210991
                    }]
                }, {
                    "name": "台北喜茶牧业控股集团",
                    "id": 210992
                }]
            }, {
                "name": "广州小米互金",
                "id": 210993
            }, {
                "name": "厦门瑞幸基金有限公司",
                "id": 210994,
                "children": [{
                    "name": "深圳京东软件有限公司",
                    "id": 210995
                }, {
                    "name": "杭州亚马逊智能",
                    "id": 210996
                }, {
                    "name": "台北苹果互金",
                    "id": 210997
                }, {
                    "name": "东莞星巴克通信",
                    "id": 210998
                }, {
                    "name": "北京亚马逊地摊有限公司",
                    "id": 210999
                }, {
                    "name": "杭州肯德基养殖有限公司",
                    "id": 211000
                }, {
                    "name": "广州美团电商",
                    "id": 211001
                }, {
                    "name": "天津字节通讯",
                    "id": 211002
                }, {
                    "name": "上海字节控股集团",
                    "id": 211003,
                    "children": [{
                        "name": "纽约必胜客电商",
                        "id": 211004
                    }, {
                        "name": "杭州小米基金",
                        "id": 211005
                    }, {
                        "name": "上海必胜客旅游",
                        "id": 211006
                    }, {
                        "name": "厦门必胜客新能源",
                        "id": 211007
                    }, {
                        "name": "东莞特斯拉",
                        "id": 211008
                    }, {
                        "name": "杭州腾讯牧业",
                        "id": 211009
                    }, {
                        "name": "广州谷歌地摊控股集团",
                        "id": 211010
                    }, {
                        "name": "台北必胜客",
                        "id": 211011
                    }, {
                        "name": "南京星巴克互金",
                        "id": 211012
                    }, {
                        "name": "首尔肯德基金融有限公司",
                        "id": 211013
                    }, {
                        "name": "东京字节养殖控股集团",
                        "id": 211014
                    }, {
                        "name": "杭州快手医药有限公司",
                        "id": 211015
                    }, {
                        "name": "北京腾讯金融",
                        "id": 211016
                    }, {
                        "name": "北京必胜客控股集团",
                        "id": 211017
                    }, {
                        "name": "东京阿里地摊",
                        "id": 211018
                    }, {
                        "name": "南京星巴克诊所有限公司",
                        "id": 211019
                    }, {
                        "name": "杭州特斯拉智能有限公司",
                        "id": 211020
                    }, {
                        "name": "东莞平安科技",
                        "id": 211021
                    }, {
                        "name": "东京谷歌金融",
                        "id": 211022
                    }, {
                        "name": "杭州美团芯片控股集团",
                        "id": 211023
                    }, {
                        "name": "天津百度地摊",
                        "id": 211024
                    }, {
                        "name": "南京喜茶航空",
                        "id": 211025
                    }, {
                        "name": "天津蚂蚁旅游",
                        "id": 211026
                    }, {
                        "name": "南京瑞幸石油",
                        "id": 211027
                    }, {
                        "name": "香港阿里地产",
                        "id": 211028
                    }, {
                        "name": "杭州苹果地产",
                        "id": 211029
                    }, {
                        "name": "东莞肯德基智能",
                        "id": 211030
                    }, {
                        "name": "深圳蚂蚁航空有限公司",
                        "id": 211031
                    }, {
                        "name": "杭州喜茶诊所",
                        "id": 211032
                    }, {
                        "name": "纽约京东通信",
                        "id": 211033
                    }, {
                        "name": "纽约滴滴制造",
                        "id": 211034
                    }, {
                        "name": "首尔谷歌智能",
                        "id": 211035
                    }, {
                        "name": "南京肯德基农业",
                        "id": 211036
                    }, {
                        "name": "首尔欧珀通讯",
                        "id": 211037
                    }, {
                        "name": "天津百度证券控股集团",
                        "id": 211038
                    }, {
                        "name": "东京微软证券控股集团",
                        "id": 211039
                    }]
                }, {
                    "name": "香港谷歌制造控股集团",
                    "id": 211040
                }, {
                    "name": "杭州微软软件",
                    "id": 211041
                }, {
                    "name": "天津星巴克证券有限公司",
                    "id": 211042
                }, {
                    "name": "北京谷歌信息服务",
                    "id": 211043,
                    "children": [{
                        "name": "广州肯德基电商控股集团",
                        "id": 211044
                    }, {
                        "name": "天津腾讯",
                        "id": 211045
                    }, {
                        "name": "深圳奈雪旅游",
                        "id": 211046
                    }, {
                        "name": "东莞滴滴旅游有限公司",
                        "id": 211047
                    }, {
                        "name": "纽约滴滴养殖",
                        "id": 211048
                    }, {
                        "name": "杭州微软制造有限公司",
                        "id": 211049
                    }, {
                        "name": "北京阿里石油控股集团",
                        "id": 211050
                    }, {
                        "name": "深圳肯德基有限公司",
                        "id": 211051
                    }, {
                        "name": "厦门阿里有限公司",
                        "id": 211052
                    }, {
                        "name": "天津肯德基控股集团",
                        "id": 211053
                    }, {
                        "name": "厦门肯德基芯片有限公司",
                        "id": 211054
                    }, {
                        "name": "深圳苹果医药",
                        "id": 211055
                    }, {
                        "name": "天津亚马逊餐饮有限公司",
                        "id": 211056
                    }, {
                        "name": "广州瑞幸科技控股集团",
                        "id": 211057
                    }, {
                        "name": "杭州肯德基智能控股集团",
                        "id": 211058
                    }, {
                        "name": "首尔必胜客",
                        "id": 211059
                    }, {
                        "name": "东莞平安",
                        "id": 211060
                    }, {
                        "name": "北京肯德基农业",
                        "id": 211061
                    }, {
                        "name": "天津京东",
                        "id": 211062
                    }, {
                        "name": "杭州蚂蚁科技",
                        "id": 211063
                    }, {
                        "name": "杭州腾讯智能",
                        "id": 211064
                    }, {
                        "name": "东京星巴克银行",
                        "id": 211065
                    }, {
                        "name": "上海滴滴医药",
                        "id": 211066
                    }, {
                        "name": "东莞喜茶地摊",
                        "id": 211067
                    }, {
                        "name": "厦门美团银行",
                        "id": 211068
                    }, {
                        "name": "南京必胜客诊所",
                        "id": 211069
                    }]
                }, {
                    "name": "台北蚂蚁制造",
                    "id": 211070
                }, {
                    "name": "纽约平安石油",
                    "id": 211071
                }, {
                    "name": "杭州平安电商",
                    "id": 211072
                }, {
                    "name": "杭州阿里地产",
                    "id": 211073
                }, {
                    "name": "杭州瑞幸有限公司",
                    "id": 211074,
                    "children": [{
                        "name": "杭州滴滴农业",
                        "id": 211075
                    }, {
                        "name": "台北蚂蚁通讯",
                        "id": 211076
                    }, {
                        "name": "纽约肯德基芯片有限公司",
                        "id": 211077
                    }, {
                        "name": "纽约奈雪诊所",
                        "id": 211078
                    }, {
                        "name": "首尔蚂蚁牧业",
                        "id": 211079
                    }, {
                        "name": "台北小米芯片有限公司",
                        "id": 211080
                    }, {
                        "name": "东京美团医药有限公司",
                        "id": 211081
                    }, {
                        "name": "首尔字节金融有限公司",
                        "id": 211082
                    }, {
                        "name": "北京快手养殖有限公司",
                        "id": 211083
                    }, {
                        "name": "南京谷歌旅游",
                        "id": 211084
                    }, {
                        "name": "杭州特斯拉计算机",
                        "id": 211085
                    }, {
                        "name": "台北百度旅游",
                        "id": 211086
                    }, {
                        "name": "东京欧珀制造",
                        "id": 211087
                    }, {
                        "name": "东京百度有限公司",
                        "id": 211088
                    }, {
                        "name": "东莞阿里电商",
                        "id": 211089
                    }, {
                        "name": "东莞小米互金",
                        "id": 211090
                    }, {
                        "name": "纽约滴滴智能",
                        "id": 211091
                    }, {
                        "name": "首尔微软智能",
                        "id": 211092
                    }, {
                        "name": "杭州肯德基地摊",
                        "id": 211093
                    }, {
                        "name": "厦门喜茶金融有限公司",
                        "id": 211094
                    }, {
                        "name": "东京欧珀电商",
                        "id": 211095
                    }]
                }, {
                    "name": "首尔亚马逊银行",
                    "id": 211096,
                    "children": [{
                        "name": "广州滴滴有限公司",
                        "id": 211097
                    }, {
                        "name": "杭州阿里科技",
                        "id": 211098
                    }, {
                        "name": "上海苹果",
                        "id": 211099
                    }, {
                        "name": "深圳亚马逊电商",
                        "id": 211100
                    }, {
                        "name": "东莞腾讯农业有限公司",
                        "id": 211101
                    }, {
                        "name": "广州腾讯软件",
                        "id": 211102
                    }, {
                        "name": "北京华为计算机有限公司",
                        "id": 211103
                    }, {
                        "name": "深圳欧珀地产",
                        "id": 211104
                    }, {
                        "name": "东京欧珀汽车",
                        "id": 211105
                    }, {
                        "name": "北京蚂蚁基金控股集团",
                        "id": 211106
                    }, {
                        "name": "首尔亚马逊芯片",
                        "id": 211107
                    }, {
                        "name": "台北奈雪汽车控股集团",
                        "id": 211108
                    }, {
                        "name": "厦门华为石油",
                        "id": 211109
                    }, {
                        "name": "东京字节银行",
                        "id": 211110
                    }, {
                        "name": "香港阿里科技",
                        "id": 211111
                    }, {
                        "name": "厦门瑞幸医院",
                        "id": 211112
                    }, {
                        "name": "南京微软芯片控股集团",
                        "id": 211113
                    }, {
                        "name": "北京奈雪",
                        "id": 211114
                    }, {
                        "name": "台北滴滴银行",
                        "id": 211115
                    }, {
                        "name": "厦门美团渔业有限公司",
                        "id": 211116
                    }, {
                        "name": "北京快手通讯",
                        "id": 211117
                    }, {
                        "name": "东京微软石油",
                        "id": 211118
                    }, {
                        "name": "首尔欧珀农业",
                        "id": 211119
                    }, {
                        "name": "上海必胜客诊所",
                        "id": 211120
                    }, {
                        "name": "上海快手",
                        "id": 211121
                    }, {
                        "name": "东京平安通讯",
                        "id": 211122
                    }, {
                        "name": "厦门肯德基证券",
                        "id": 211123
                    }, {
                        "name": "纽约京东航空",
                        "id": 211124
                    }]
                }, {
                    "name": "天津华为旅游控股集团",
                    "id": 211125
                }, {
                    "name": "纽约必胜客农业有限公司",
                    "id": 211126
                }]
            }, {
                "name": "北京蚂蚁汽车",
                "id": 211127
            }, {
                "name": "东莞瑞幸汽车",
                "id": 211128
            }]
        }, {
            "name": "杭州阿里医院",
            "id": 211129
        }]
    }, {
        "name": "厦门滴滴智能",
        "id": 211130
    }, {
        "name": "北京谷歌养殖控股集团",
        "id": 211131,
        "children": [{
            "name": "上海特斯拉控股集团",
            "id": 211132
        }, {
            "name": "南京特斯拉银行有限公司",
            "id": 211133
        }, {
            "name": "纽约瑞幸科技",
            "id": 211134
        }, {
            "name": "香港苹果诊所",
            "id": 211135,
            "children": [{
                "name": "纽约京东农业",
                "id": 211136,
                "children": [{
                    "name": "东京必胜客",
                    "id": 211137
                }, {
                    "name": "台北必胜客芯片有限公司",
                    "id": 211138
                }, {
                    "name": "杭州奈雪科技",
                    "id": 211139,
                    "children": [{
                        "name": "杭州特斯拉诊所",
                        "id": 211140
                    }, {
                        "name": "天津字节地摊有限公司",
                        "id": 211141
                    }]
                }, {
                    "name": "首尔百度地产",
                    "id": 211142
                }, {
                    "name": "台北美团",
                    "id": 211143,
                    "children": [{
                        "name": "深圳华为医院控股集团",
                        "id": 211144
                    }, {
                        "name": "台北蚂蚁科技",
                        "id": 211145
                    }, {
                        "name": "香港蚂蚁互金有限公司",
                        "id": 211146
                    }, {
                        "name": "上海字节金融",
                        "id": 211147
                    }, {
                        "name": "纽约喜茶科技有限公司",
                        "id": 211148
                    }, {
                        "name": "东莞亚马逊养殖有限公司",
                        "id": 211149
                    }, {
                        "name": "杭州星巴克诊所",
                        "id": 211150
                    }, {
                        "name": "首尔百度通信",
                        "id": 211151
                    }, {
                        "name": "杭州小米石油控股集团",
                        "id": 211152
                    }, {
                        "name": "杭州滴滴地摊",
                        "id": 211153
                    }, {
                        "name": "东莞肯德基地摊",
                        "id": 211154
                    }, {
                        "name": "纽约华为互金",
                        "id": 211155
                    }, {
                        "name": "深圳小米石油控股集团",
                        "id": 211156
                    }, {
                        "name": "杭州平安医药",
                        "id": 211157
                    }, {
                        "name": "深圳字节餐饮",
                        "id": 211158
                    }, {
                        "name": "首尔欧珀餐饮",
                        "id": 211159
                    }, {
                        "name": "杭州微软",
                        "id": 211160
                    }, {
                        "name": "深圳瑞幸医院",
                        "id": 211161
                    }, {
                        "name": "上海华为互金",
                        "id": 211162
                    }, {
                        "name": "纽约快手银行",
                        "id": 211163
                    }, {
                        "name": "杭州京东地摊",
                        "id": 211164
                    }, {
                        "name": "深圳腾讯芯片",
                        "id": 211165
                    }, {
                        "name": "南京快手航空",
                        "id": 211166
                    }, {
                        "name": "广州快手航空",
                        "id": 211167
                    }, {
                        "name": "杭州星巴克通讯",
                        "id": 211168
                    }, {
                        "name": "台北蚂蚁地产",
                        "id": 211169
                    }, {
                        "name": "东京奈雪科技",
                        "id": 211170
                    }, {
                        "name": "东京奈雪旅游有限公司",
                        "id": 211171
                    }, {
                        "name": "广州腾讯芯片",
                        "id": 211172
                    }, {
                        "name": "天津字节牧业控股集团",
                        "id": 211173
                    }, {
                        "name": "深圳平安地产控股集团",
                        "id": 211174
                    }, {
                        "name": "首尔美团旅游",
                        "id": 211175
                    }, {
                        "name": "杭州肯德基电商",
                        "id": 211176
                    }]
                }, {
                    "name": "天津京东医药",
                    "id": 211177
                }, {
                    "name": "香港谷歌地摊控股集团",
                    "id": 211178
                }, {
                    "name": "上海星巴克控股集团",
                    "id": 211179
                }, {
                    "name": "北京星巴克渔业有限公司",
                    "id": 211180
                }, {
                    "name": "北京必胜客医院",
                    "id": 211181,
                    "children": [{
                        "name": "首尔特斯拉互金有限公司",
                        "id": 211182
                    }, {
                        "name": "上海京东诊所",
                        "id": 211183
                    }, {
                        "name": "天津苹果科技有限公司",
                        "id": 211184
                    }, {
                        "name": "杭州阿里航空",
                        "id": 211185
                    }, {
                        "name": "东莞华为牧业",
                        "id": 211186
                    }, {
                        "name": "香港滴滴金融有限公司",
                        "id": 211187
                    }, {
                        "name": "东京欧珀通讯",
                        "id": 211188
                    }, {
                        "name": "香港小米汽车",
                        "id": 211189
                    }, {
                        "name": "台北奈雪通信",
                        "id": 211190
                    }, {
                        "name": "上海瑞幸软件",
                        "id": 211191
                    }, {
                        "name": "厦门小米金融控股集团",
                        "id": 211192
                    }, {
                        "name": "纽约欧珀信息服务控股集团",
                        "id": 211193
                    }, {
                        "name": "香港美团医院",
                        "id": 211194
                    }, {
                        "name": "杭州字节航空",
                        "id": 211195
                    }, {
                        "name": "纽约特斯拉",
                        "id": 211196
                    }, {
                        "name": "厦门腾讯有限公司",
                        "id": 211197
                    }, {
                        "name": "台北瑞幸智能",
                        "id": 211198
                    }, {
                        "name": "厦门小米芯片控股集团",
                        "id": 211199
                    }, {
                        "name": "厦门谷歌金融",
                        "id": 211200
                    }, {
                        "name": "广州微软",
                        "id": 211201
                    }, {
                        "name": "东莞特斯拉芯片",
                        "id": 211202
                    }, {
                        "name": "北京特斯拉地产",
                        "id": 211203
                    }, {
                        "name": "北京苹果金融",
                        "id": 211204
                    }]
                }, {
                    "name": "厦门阿里地摊",
                    "id": 211205
                }, {
                    "name": "香港微软农业",
                    "id": 211206
                }, {
                    "name": "东莞滴滴计算机控股集团",
                    "id": 211207
                }, {
                    "name": "香港华为",
                    "id": 211208
                }, {
                    "name": "台北特斯拉养殖",
                    "id": 211209
                }, {
                    "name": "杭州美团芯片有限公司",
                    "id": 211210
                }, {
                    "name": "北京特斯拉地产有限公司",
                    "id": 211211
                }, {
                    "name": "广州喜茶农业",
                    "id": 211212,
                    "children": [{
                        "name": "厦门京东餐饮",
                        "id": 211213
                    }, {
                        "name": "北京奈雪有限公司",
                        "id": 211214
                    }, {
                        "name": "深圳谷歌诊所",
                        "id": 211215
                    }, {
                        "name": "首尔苹果基金",
                        "id": 211216
                    }, {
                        "name": "香港阿里电商",
                        "id": 211217
                    }, {
                        "name": "首尔滴滴证券",
                        "id": 211218
                    }, {
                        "name": "杭州阿里诊所",
                        "id": 211219
                    }, {
                        "name": "南京平安电商有限公司",
                        "id": 211220
                    }, {
                        "name": "天津京东石油",
                        "id": 211221
                    }, {
                        "name": "东京喜茶控股集团",
                        "id": 211222
                    }, {
                        "name": "天津腾讯诊所",
                        "id": 211223
                    }, {
                        "name": "台北瑞幸控股集团",
                        "id": 211224
                    }, {
                        "name": "纽约快手新能源控股集团",
                        "id": 211225
                    }, {
                        "name": "广州星巴克",
                        "id": 211226
                    }, {
                        "name": "杭州美团互金",
                        "id": 211227
                    }]
                }, {
                    "name": "厦门小米银行",
                    "id": 211228
                }, {
                    "name": "首尔喜茶证券",
                    "id": 211229
                }, {
                    "name": "香港美团养殖",
                    "id": 211230
                }, {
                    "name": "杭州美团诊所",
                    "id": 211231
                }, {
                    "name": "台北阿里医院",
                    "id": 211232
                }, {
                    "name": "杭州京东通信控股集团",
                    "id": 211233,
                    "children": [{
                        "name": "广州美团证券",
                        "id": 211234
                    }, {
                        "name": "东京蚂蚁软件",
                        "id": 211235
                    }, {
                        "name": "厦门欧珀旅游",
                        "id": 211236
                    }, {
                        "name": "首尔星巴克汽车控股集团",
                        "id": 211237
                    }, {
                        "name": "杭州星巴克电商有限公司",
                        "id": 211238
                    }, {
                        "name": "深圳小米基金",
                        "id": 211239
                    }, {
                        "name": "香港苹果新能源",
                        "id": 211240
                    }, {
                        "name": "首尔快手医药",
                        "id": 211241
                    }, {
                        "name": "东莞百度医院控股集团",
                        "id": 211242
                    }, {
                        "name": "杭州微软旅游",
                        "id": 211243
                    }, {
                        "name": "南京微软制造",
                        "id": 211244
                    }, {
                        "name": "东京字节软件",
                        "id": 211245
                    }, {
                        "name": "上海特斯拉地产有限公司",
                        "id": 211246
                    }, {
                        "name": "深圳字节通讯",
                        "id": 211247
                    }, {
                        "name": "首尔星巴克软件",
                        "id": 211248
                    }, {
                        "name": "厦门蚂蚁新能源",
                        "id": 211249
                    }, {
                        "name": "东莞特斯拉互金",
                        "id": 211250
                    }, {
                        "name": "首尔喜茶银行有限公司",
                        "id": 211251
                    }, {
                        "name": "香港亚马逊互金",
                        "id": 211252
                    }, {
                        "name": "杭州快手养殖控股集团",
                        "id": 211253
                    }, {
                        "name": "北京滴滴医院",
                        "id": 211254
                    }, {
                        "name": "杭州必胜客银行控股集团",
                        "id": 211255
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 211256
                    }, {
                        "name": "厦门谷歌制造",
                        "id": 211257
                    }, {
                        "name": "杭州百度养殖",
                        "id": 211258
                    }, {
                        "name": "南京字节电商",
                        "id": 211259
                    }, {
                        "name": "首尔平安养殖有限公司",
                        "id": 211260
                    }, {
                        "name": "南京小米有限公司",
                        "id": 211261
                    }, {
                        "name": "杭州京东餐饮",
                        "id": 211262
                    }, {
                        "name": "纽约必胜客养殖控股集团",
                        "id": 211263
                    }, {
                        "name": "南京蚂蚁诊所控股集团",
                        "id": 211264
                    }, {
                        "name": "上海百度通信控股集团",
                        "id": 211265
                    }]
                }, {
                    "name": "台北星巴克石油",
                    "id": 211266
                }]
            }, {
                "name": "南京肯德基软件控股集团",
                "id": 211267,
                "children": [{
                    "name": "天津华为汽车",
                    "id": 211268
                }, {
                    "name": "东京美团农业有限公司",
                    "id": 211269,
                    "children": [{
                        "name": "南京必胜客通讯控股集团",
                        "id": 211270
                    }, {
                        "name": "杭州星巴克新能源有限公司",
                        "id": 211271
                    }, {
                        "name": "厦门京东基金",
                        "id": 211272
                    }, {
                        "name": "上海微软信息服务",
                        "id": 211273
                    }, {
                        "name": "杭州小米证券控股集团",
                        "id": 211274
                    }, {
                        "name": "天津欧珀汽车",
                        "id": 211275
                    }, {
                        "name": "首尔百度石油",
                        "id": 211276
                    }, {
                        "name": "香港字节",
                        "id": 211277
                    }, {
                        "name": "纽约瑞幸科技有限公司",
                        "id": 211278
                    }, {
                        "name": "广州奈雪科技",
                        "id": 211279
                    }, {
                        "name": "杭州微软地摊",
                        "id": 211280
                    }, {
                        "name": "广州华为医院控股集团",
                        "id": 211281
                    }, {
                        "name": "东京亚马逊软件",
                        "id": 211282
                    }, {
                        "name": "台北字节养殖",
                        "id": 211283
                    }, {
                        "name": "南京滴滴石油",
                        "id": 211284
                    }, {
                        "name": "首尔谷歌信息服务",
                        "id": 211285
                    }, {
                        "name": "北京欧珀制造控股集团",
                        "id": 211286
                    }, {
                        "name": "台北百度汽车有限公司",
                        "id": 211287
                    }, {
                        "name": "深圳星巴克银行",
                        "id": 211288
                    }, {
                        "name": "广州美团金融",
                        "id": 211289
                    }, {
                        "name": "香港百度电商控股集团",
                        "id": 211290
                    }, {
                        "name": "厦门平安",
                        "id": 211291
                    }, {
                        "name": "南京京东新能源",
                        "id": 211292
                    }, {
                        "name": "东京蚂蚁养殖",
                        "id": 211293
                    }, {
                        "name": "台北喜茶信息服务",
                        "id": 211294
                    }, {
                        "name": "广州肯德基证券",
                        "id": 211295
                    }, {
                        "name": "广州喜茶控股集团",
                        "id": 211296
                    }, {
                        "name": "深圳蚂蚁地摊",
                        "id": 211297
                    }, {
                        "name": "东京字节信息服务",
                        "id": 211298
                    }, {
                        "name": "深圳平安科技控股集团",
                        "id": 211299
                    }, {
                        "name": "台北奈雪",
                        "id": 211300
                    }, {
                        "name": "天津苹果芯片",
                        "id": 211301
                    }, {
                        "name": "香港奈雪基金",
                        "id": 211302
                    }, {
                        "name": "台北谷歌诊所",
                        "id": 211303
                    }, {
                        "name": "东京平安芯片",
                        "id": 211304
                    }, {
                        "name": "广州亚马逊科技",
                        "id": 211305
                    }]
                }]
            }]
        }, {
            "name": "广州滴滴汽车",
            "id": 211306,
            "children": [{
                "name": "台北平安农业",
                "id": 211307
            }, {
                "name": "杭州亚马逊石油",
                "id": 211308
            }, {
                "name": "杭州肯德基餐饮",
                "id": 211309
            }, {
                "name": "天津欧珀旅游",
                "id": 211310,
                "children": [{
                    "name": "深圳华为证券",
                    "id": 211311
                }, {
                    "name": "厦门肯德基电商",
                    "id": 211312
                }, {
                    "name": "北京字节",
                    "id": 211313,
                    "children": [{
                        "name": "厦门平安医院",
                        "id": 211314
                    }, {
                        "name": "厦门腾讯互金",
                        "id": 211315
                    }, {
                        "name": "南京瑞幸计算机",
                        "id": 211316
                    }, {
                        "name": "东京百度牧业",
                        "id": 211317
                    }, {
                        "name": "杭州奈雪农业控股集团",
                        "id": 211318
                    }, {
                        "name": "广州小米科技",
                        "id": 211319
                    }, {
                        "name": "天津奈雪地摊",
                        "id": 211320
                    }, {
                        "name": "北京谷歌餐饮控股集团",
                        "id": 211321
                    }]
                }, {
                    "name": "纽约字节软件",
                    "id": 211322,
                    "children": [{
                        "name": "台北百度互金控股集团",
                        "id": 211323
                    }, {
                        "name": "杭州奈雪制造",
                        "id": 211324
                    }, {
                        "name": "深圳肯德基电商",
                        "id": 211325
                    }, {
                        "name": "上海百度养殖",
                        "id": 211326
                    }, {
                        "name": "台北华为汽车",
                        "id": 211327
                    }, {
                        "name": "东京美团有限公司",
                        "id": 211328
                    }, {
                        "name": "广州特斯拉石油",
                        "id": 211329
                    }, {
                        "name": "杭州欧珀电商有限公司",
                        "id": 211330
                    }, {
                        "name": "深圳蚂蚁基金",
                        "id": 211331
                    }, {
                        "name": "南京苹果通信",
                        "id": 211332
                    }, {
                        "name": "广州必胜客渔业控股集团",
                        "id": 211333
                    }, {
                        "name": "上海京东有限公司",
                        "id": 211334
                    }, {
                        "name": "深圳百度渔业",
                        "id": 211335
                    }, {
                        "name": "南京亚马逊智能有限公司",
                        "id": 211336
                    }, {
                        "name": "广州欧珀地摊有限公司",
                        "id": 211337
                    }, {
                        "name": "东莞华为科技",
                        "id": 211338
                    }, {
                        "name": "北京奈雪科技控股集团",
                        "id": 211339
                    }, {
                        "name": "深圳华为控股集团",
                        "id": 211340
                    }, {
                        "name": "杭州小米医院",
                        "id": 211341
                    }, {
                        "name": "香港小米证券",
                        "id": 211342
                    }, {
                        "name": "东莞欧珀地摊控股集团",
                        "id": 211343
                    }, {
                        "name": "厦门华为控股集团",
                        "id": 211344
                    }, {
                        "name": "香港瑞幸芯片",
                        "id": 211345
                    }, {
                        "name": "香港小米地摊控股集团",
                        "id": 211346
                    }, {
                        "name": "深圳小米科技控股集团",
                        "id": 211347
                    }, {
                        "name": "首尔奈雪证券",
                        "id": 211348
                    }, {
                        "name": "厦门美团信息服务有限公司",
                        "id": 211349
                    }]
                }, {
                    "name": "深圳快手新能源",
                    "id": 211350
                }]
            }, {
                "name": "北京喜茶农业",
                "id": 211351
            }, {
                "name": "南京阿里基金",
                "id": 211352,
                "children": [{
                    "name": "台北京东汽车",
                    "id": 211353
                }, {
                    "name": "纽约星巴克互金",
                    "id": 211354
                }, {
                    "name": "香港美团养殖",
                    "id": 211355
                }, {
                    "name": "台北瑞幸",
                    "id": 211356
                }, {
                    "name": "广州苹果新能源",
                    "id": 211357,
                    "children": [{
                        "name": "广州华为诊所",
                        "id": 211358
                    }, {
                        "name": "厦门百度互金有限公司",
                        "id": 211359
                    }, {
                        "name": "北京腾讯通讯有限公司",
                        "id": 211360
                    }, {
                        "name": "深圳喜茶石油",
                        "id": 211361
                    }, {
                        "name": "东莞瑞幸渔业",
                        "id": 211362
                    }, {
                        "name": "广州滴滴牧业",
                        "id": 211363
                    }, {
                        "name": "纽约苹果地摊",
                        "id": 211364
                    }, {
                        "name": "广州京东农业控股集团",
                        "id": 211365
                    }, {
                        "name": "厦门快手通信有限公司",
                        "id": 211366
                    }, {
                        "name": "北京苹果智能",
                        "id": 211367
                    }, {
                        "name": "上海京东有限公司",
                        "id": 211368
                    }, {
                        "name": "广州美团医院有限公司",
                        "id": 211369
                    }, {
                        "name": "北京喜茶地摊控股集团",
                        "id": 211370
                    }, {
                        "name": "北京微软诊所",
                        "id": 211371
                    }, {
                        "name": "天津平安新能源",
                        "id": 211372
                    }, {
                        "name": "香港奈雪农业控股集团",
                        "id": 211373
                    }, {
                        "name": "杭州欧珀医药有限公司",
                        "id": 211374
                    }, {
                        "name": "首尔百度芯片",
                        "id": 211375
                    }, {
                        "name": "天津字节通讯",
                        "id": 211376
                    }]
                }, {
                    "name": "深圳肯德基石油控股集团",
                    "id": 211377,
                    "children": [{
                        "name": "广州谷歌",
                        "id": 211378
                    }, {
                        "name": "香港亚马逊旅游",
                        "id": 211379
                    }, {
                        "name": "杭州滴滴地产控股集团",
                        "id": 211380
                    }, {
                        "name": "纽约奈雪地产",
                        "id": 211381
                    }, {
                        "name": "杭州小米信息服务",
                        "id": 211382
                    }, {
                        "name": "上海腾讯芯片",
                        "id": 211383
                    }, {
                        "name": "纽约星巴克科技控股集团",
                        "id": 211384
                    }, {
                        "name": "北京平安证券控股集团",
                        "id": 211385
                    }, {
                        "name": "首尔小米养殖",
                        "id": 211386
                    }, {
                        "name": "广州星巴克有限公司",
                        "id": 211387
                    }, {
                        "name": "香港蚂蚁渔业",
                        "id": 211388
                    }, {
                        "name": "广州必胜客通信",
                        "id": 211389
                    }, {
                        "name": "东莞瑞幸银行",
                        "id": 211390
                    }, {
                        "name": "台北肯德基科技有限公司",
                        "id": 211391
                    }, {
                        "name": "纽约百度有限公司",
                        "id": 211392
                    }, {
                        "name": "广州星巴克互金有限公司",
                        "id": 211393
                    }, {
                        "name": "北京美团",
                        "id": 211394
                    }, {
                        "name": "香港滴滴通信",
                        "id": 211395
                    }, {
                        "name": "杭州平安基金控股集团",
                        "id": 211396
                    }, {
                        "name": "香港肯德基地摊",
                        "id": 211397
                    }, {
                        "name": "台北肯德基制造",
                        "id": 211398
                    }, {
                        "name": "杭州星巴克制造",
                        "id": 211399
                    }, {
                        "name": "首尔蚂蚁科技",
                        "id": 211400
                    }, {
                        "name": "杭州必胜客制造控股集团",
                        "id": 211401
                    }, {
                        "name": "杭州亚马逊地摊",
                        "id": 211402
                    }, {
                        "name": "纽约华为医院",
                        "id": 211403
                    }, {
                        "name": "天津肯德基有限公司",
                        "id": 211404
                    }, {
                        "name": "首尔瑞幸软件控股集团",
                        "id": 211405
                    }, {
                        "name": "杭州必胜客芯片",
                        "id": 211406
                    }, {
                        "name": "深圳喜茶医药",
                        "id": 211407
                    }, {
                        "name": "广州美团地摊",
                        "id": 211408
                    }, {
                        "name": "南京肯德基地产控股集团",
                        "id": 211409
                    }]
                }, {
                    "name": "香港特斯拉控股集团",
                    "id": 211410,
                    "children": [{
                        "name": "天津阿里通讯",
                        "id": 211411
                    }, {
                        "name": "东京滴滴基金",
                        "id": 211412
                    }, {
                        "name": "首尔星巴克医院",
                        "id": 211413
                    }, {
                        "name": "厦门腾讯互金控股集团",
                        "id": 211414
                    }, {
                        "name": "首尔谷歌地产",
                        "id": 211415
                    }, {
                        "name": "上海华为地摊",
                        "id": 211416
                    }, {
                        "name": "北京星巴克制造有限公司",
                        "id": 211417
                    }, {
                        "name": "香港京东信息服务",
                        "id": 211418
                    }, {
                        "name": "香港亚马逊养殖",
                        "id": 211419
                    }, {
                        "name": "纽约华为餐饮",
                        "id": 211420
                    }, {
                        "name": "台北美团石油",
                        "id": 211421
                    }, {
                        "name": "深圳滴滴农业",
                        "id": 211422
                    }, {
                        "name": "首尔瑞幸基金",
                        "id": 211423
                    }, {
                        "name": "东京华为制造",
                        "id": 211424
                    }, {
                        "name": "杭州星巴克通讯控股集团",
                        "id": 211425
                    }, {
                        "name": "天津肯德基控股集团",
                        "id": 211426
                    }, {
                        "name": "东莞特斯拉信息服务",
                        "id": 211427
                    }, {
                        "name": "纽约京东芯片控股集团",
                        "id": 211428
                    }, {
                        "name": "广州谷歌电商",
                        "id": 211429
                    }, {
                        "name": "南京小米计算机控股集团",
                        "id": 211430
                    }, {
                        "name": "杭州平安医院控股集团",
                        "id": 211431
                    }, {
                        "name": "台北平安地摊",
                        "id": 211432
                    }, {
                        "name": "厦门肯德基渔业",
                        "id": 211433
                    }, {
                        "name": "深圳奈雪医院",
                        "id": 211434
                    }, {
                        "name": "南京苹果基金",
                        "id": 211435
                    }, {
                        "name": "杭州谷歌信息服务",
                        "id": 211436
                    }, {
                        "name": "香港亚马逊",
                        "id": 211437
                    }, {
                        "name": "北京滴滴",
                        "id": 211438
                    }, {
                        "name": "天津阿里医院",
                        "id": 211439
                    }, {
                        "name": "杭州微软旅游",
                        "id": 211440
                    }, {
                        "name": "上海华为地产",
                        "id": 211441
                    }, {
                        "name": "杭州阿里医院",
                        "id": 211442
                    }, {
                        "name": "广州喜茶银行控股集团",
                        "id": 211443
                    }, {
                        "name": "北京小米控股集团",
                        "id": 211444
                    }, {
                        "name": "首尔京东地产",
                        "id": 211445
                    }]
                }, {
                    "name": "杭州星巴克证券",
                    "id": 211446,
                    "children": [{
                        "name": "杭州星巴克互金",
                        "id": 211447
                    }, {
                        "name": "东京必胜客证券",
                        "id": 211448
                    }, {
                        "name": "东京肯德基渔业",
                        "id": 211449
                    }, {
                        "name": "厦门蚂蚁诊所有限公司",
                        "id": 211450
                    }, {
                        "name": "广州美团餐饮",
                        "id": 211451
                    }, {
                        "name": "深圳特斯拉医院控股集团",
                        "id": 211452
                    }]
                }, {
                    "name": "香港京东渔业",
                    "id": 211453
                }, {
                    "name": "东莞谷歌信息服务",
                    "id": 211454
                }, {
                    "name": "北京微软软件",
                    "id": 211455
                }, {
                    "name": "香港腾讯电商",
                    "id": 211456
                }, {
                    "name": "杭州必胜客",
                    "id": 211457
                }, {
                    "name": "天津谷歌基金",
                    "id": 211458
                }, {
                    "name": "上海百度医院",
                    "id": 211459
                }, {
                    "name": "东京喜茶基金",
                    "id": 211460
                }, {
                    "name": "台北喜茶渔业",
                    "id": 211461,
                    "children": [{
                        "name": "纽约美团地产",
                        "id": 211462
                    }, {
                        "name": "上海京东地摊有限公司",
                        "id": 211463
                    }, {
                        "name": "广州必胜客餐饮",
                        "id": 211464
                    }, {
                        "name": "东京滴滴医药",
                        "id": 211465
                    }, {
                        "name": "首尔欧珀旅游",
                        "id": 211466
                    }, {
                        "name": "厦门必胜客牧业",
                        "id": 211467
                    }, {
                        "name": "深圳星巴克汽车",
                        "id": 211468
                    }, {
                        "name": "香港滴滴银行有限公司",
                        "id": 211469
                    }, {
                        "name": "广州奈雪证券有限公司",
                        "id": 211470
                    }, {
                        "name": "厦门小米新能源有限公司",
                        "id": 211471
                    }, {
                        "name": "深圳喜茶通信",
                        "id": 211472
                    }, {
                        "name": "东京肯德基基金",
                        "id": 211473
                    }, {
                        "name": "东京滴滴金融",
                        "id": 211474
                    }, {
                        "name": "广州星巴克养殖",
                        "id": 211475
                    }, {
                        "name": "杭州小米信息服务",
                        "id": 211476
                    }, {
                        "name": "上海阿里通信",
                        "id": 211477
                    }, {
                        "name": "厦门苹果软件",
                        "id": 211478
                    }, {
                        "name": "北京蚂蚁银行",
                        "id": 211479
                    }, {
                        "name": "首尔华为计算机",
                        "id": 211480
                    }, {
                        "name": "台北滴滴石油",
                        "id": 211481
                    }, {
                        "name": "东京肯德基农业有限公司",
                        "id": 211482
                    }, {
                        "name": "北京特斯拉航空",
                        "id": 211483
                    }, {
                        "name": "上海谷歌餐饮",
                        "id": 211484
                    }, {
                        "name": "首尔谷歌航空",
                        "id": 211485
                    }, {
                        "name": "广州京东航空有限公司",
                        "id": 211486
                    }, {
                        "name": "北京蚂蚁电商",
                        "id": 211487
                    }, {
                        "name": "首尔小米信息服务",
                        "id": 211488
                    }]
                }, {
                    "name": "杭州京东",
                    "id": 211489,
                    "children": [{
                        "name": "厦门快手金融",
                        "id": 211490
                    }, {
                        "name": "台北滴滴地产控股集团",
                        "id": 211491
                    }, {
                        "name": "香港特斯拉基金有限公司",
                        "id": 211492
                    }, {
                        "name": "东莞美团餐饮控股集团",
                        "id": 211493
                    }, {
                        "name": "北京美团科技控股集团",
                        "id": 211494
                    }, {
                        "name": "台北字节计算机有限公司",
                        "id": 211495
                    }, {
                        "name": "厦门奈雪智能",
                        "id": 211496
                    }, {
                        "name": "杭州苹果",
                        "id": 211497
                    }, {
                        "name": "杭州欧珀通讯",
                        "id": 211498
                    }, {
                        "name": "台北苹果新能源",
                        "id": 211499
                    }, {
                        "name": "厦门华为软件控股集团",
                        "id": 211500
                    }, {
                        "name": "首尔星巴克地摊",
                        "id": 211501
                    }, {
                        "name": "北京必胜客科技有限公司",
                        "id": 211502
                    }, {
                        "name": "纽约字节有限公司",
                        "id": 211503
                    }]
                }, {
                    "name": "广州微软",
                    "id": 211504
                }, {
                    "name": "纽约阿里养殖",
                    "id": 211505
                }]
            }, {
                "name": "杭州谷歌医药有限公司",
                "id": 211506
            }, {
                "name": "北京星巴克电商",
                "id": 211507
            }, {
                "name": "纽约星巴克汽车",
                "id": 211508,
                "children": [{
                    "name": "天津平安旅游",
                    "id": 211509
                }, {
                    "name": "杭州欧珀芯片",
                    "id": 211510,
                    "children": [{
                        "name": "南京平安通讯",
                        "id": 211511
                    }, {
                        "name": "厦门瑞幸通信",
                        "id": 211512
                    }, {
                        "name": "天津微软新能源",
                        "id": 211513
                    }, {
                        "name": "东莞奈雪制造",
                        "id": 211514
                    }, {
                        "name": "深圳必胜客牧业",
                        "id": 211515
                    }, {
                        "name": "首尔平安地产",
                        "id": 211516
                    }, {
                        "name": "台北美团汽车有限公司",
                        "id": 211517
                    }, {
                        "name": "香港欧珀通信",
                        "id": 211518
                    }, {
                        "name": "深圳华为汽车",
                        "id": 211519
                    }, {
                        "name": "广州喜茶电商有限公司",
                        "id": 211520
                    }, {
                        "name": "杭州滴滴石油",
                        "id": 211521
                    }, {
                        "name": "杭州特斯拉牧业",
                        "id": 211522
                    }, {
                        "name": "杭州字节地摊",
                        "id": 211523
                    }, {
                        "name": "纽约星巴克信息服务",
                        "id": 211524
                    }, {
                        "name": "厦门平安信息服务有限公司",
                        "id": 211525
                    }, {
                        "name": "香港华为科技控股集团",
                        "id": 211526
                    }, {
                        "name": "纽约华为地摊控股集团",
                        "id": 211527
                    }, {
                        "name": "东京蚂蚁旅游控股集团",
                        "id": 211528
                    }, {
                        "name": "厦门腾讯航空有限公司",
                        "id": 211529
                    }, {
                        "name": "深圳快手电商",
                        "id": 211530
                    }, {
                        "name": "上海肯德基芯片",
                        "id": 211531
                    }, {
                        "name": "杭州特斯拉航空控股集团",
                        "id": 211532
                    }, {
                        "name": "纽约必胜客牧业",
                        "id": 211533
                    }, {
                        "name": "杭州华为计算机控股集团",
                        "id": 211534
                    }, {
                        "name": "首尔腾讯智能",
                        "id": 211535
                    }, {
                        "name": "东莞微软养殖有限公司",
                        "id": 211536
                    }, {
                        "name": "南京滴滴芯片有限公司",
                        "id": 211537
                    }, {
                        "name": "杭州欧珀新能源",
                        "id": 211538
                    }, {
                        "name": "天津欧珀石油",
                        "id": 211539
                    }, {
                        "name": "香港小米养殖控股集团",
                        "id": 211540
                    }, {
                        "name": "东京谷歌通信",
                        "id": 211541
                    }, {
                        "name": "南京华为石油",
                        "id": 211542
                    }, {
                        "name": "台北肯德基科技",
                        "id": 211543
                    }]
                }, {
                    "name": "南京喜茶电商",
                    "id": 211544
                }, {
                    "name": "南京蚂蚁软件",
                    "id": 211545,
                    "children": [{
                        "name": "台北美团智能",
                        "id": 211546
                    }, {
                        "name": "北京星巴克渔业",
                        "id": 211547
                    }, {
                        "name": "深圳奈雪信息服务",
                        "id": 211548
                    }, {
                        "name": "天津瑞幸基金",
                        "id": 211549
                    }, {
                        "name": "北京肯德基地产",
                        "id": 211550
                    }, {
                        "name": "广州滴滴牧业控股集团",
                        "id": 211551
                    }, {
                        "name": "台北美团牧业",
                        "id": 211552
                    }, {
                        "name": "南京百度地摊控股集团",
                        "id": 211553
                    }, {
                        "name": "台北美团银行",
                        "id": 211554
                    }, {
                        "name": "天津喜茶新能源有限公司",
                        "id": 211555
                    }, {
                        "name": "东京肯德基餐饮",
                        "id": 211556
                    }, {
                        "name": "上海华为渔业控股集团",
                        "id": 211557
                    }, {
                        "name": "杭州字节智能控股集团",
                        "id": 211558
                    }]
                }, {
                    "name": "纽约肯德基金融",
                    "id": 211559,
                    "children": [{
                        "name": "北京快手软件",
                        "id": 211560
                    }, {
                        "name": "首尔快手银行有限公司",
                        "id": 211561
                    }, {
                        "name": "上海蚂蚁证券",
                        "id": 211562
                    }, {
                        "name": "北京特斯拉制造",
                        "id": 211563
                    }, {
                        "name": "香港蚂蚁航空",
                        "id": 211564
                    }, {
                        "name": "首尔微软旅游",
                        "id": 211565
                    }, {
                        "name": "首尔蚂蚁电商",
                        "id": 211566
                    }, {
                        "name": "南京滴滴",
                        "id": 211567
                    }, {
                        "name": "厦门喜茶制造",
                        "id": 211568
                    }, {
                        "name": "厦门星巴克医院",
                        "id": 211569
                    }, {
                        "name": "首尔字节银行",
                        "id": 211570
                    }, {
                        "name": "广州华为有限公司",
                        "id": 211571
                    }, {
                        "name": "东京谷歌医药",
                        "id": 211572
                    }, {
                        "name": "深圳蚂蚁地产",
                        "id": 211573
                    }, {
                        "name": "台北华为证券",
                        "id": 211574
                    }]
                }, {
                    "name": "纽约百度科技控股集团",
                    "id": 211575
                }, {
                    "name": "天津亚马逊",
                    "id": 211576,
                    "children": [{
                        "name": "杭州瑞幸智能",
                        "id": 211577
                    }, {
                        "name": "北京特斯拉汽车",
                        "id": 211578
                    }, {
                        "name": "香港小米电商控股集团",
                        "id": 211579
                    }, {
                        "name": "台北微软互金",
                        "id": 211580
                    }, {
                        "name": "南京蚂蚁地摊",
                        "id": 211581
                    }, {
                        "name": "东京快手",
                        "id": 211582
                    }, {
                        "name": "天津奈雪农业",
                        "id": 211583
                    }, {
                        "name": "首尔平安养殖",
                        "id": 211584
                    }, {
                        "name": "上海苹果医药有限公司",
                        "id": 211585
                    }, {
                        "name": "东莞京东航空",
                        "id": 211586
                    }, {
                        "name": "厦门苹果软件控股集团",
                        "id": 211587
                    }, {
                        "name": "杭州特斯拉",
                        "id": 211588
                    }, {
                        "name": "深圳奈雪银行",
                        "id": 211589
                    }, {
                        "name": "深圳星巴克软件",
                        "id": 211590
                    }, {
                        "name": "杭州星巴克芯片",
                        "id": 211591
                    }, {
                        "name": "台北特斯拉通讯",
                        "id": 211592
                    }, {
                        "name": "厦门京东石油有限公司",
                        "id": 211593
                    }, {
                        "name": "台北百度金融控股集团",
                        "id": 211594
                    }, {
                        "name": "杭州美团",
                        "id": 211595
                    }, {
                        "name": "香港快手通讯",
                        "id": 211596
                    }, {
                        "name": "杭州小米软件",
                        "id": 211597
                    }, {
                        "name": "深圳平安智能有限公司",
                        "id": 211598
                    }, {
                        "name": "深圳特斯拉信息服务有限公司",
                        "id": 211599
                    }, {
                        "name": "厦门亚马逊信息服务有限公司",
                        "id": 211600
                    }, {
                        "name": "东莞奈雪航空",
                        "id": 211601
                    }, {
                        "name": "纽约蚂蚁证券",
                        "id": 211602
                    }, {
                        "name": "香港瑞幸有限公司",
                        "id": 211603
                    }, {
                        "name": "上海小米养殖",
                        "id": 211604
                    }, {
                        "name": "北京快手航空控股集团",
                        "id": 211605
                    }, {
                        "name": "天津华为石油",
                        "id": 211606
                    }, {
                        "name": "广州百度地产",
                        "id": 211607
                    }, {
                        "name": "纽约肯德基计算机",
                        "id": 211608
                    }, {
                        "name": "首尔快手制造控股集团",
                        "id": 211609
                    }, {
                        "name": "天津瑞幸通信有限公司",
                        "id": 211610
                    }, {
                        "name": "南京亚马逊诊所",
                        "id": 211611
                    }, {
                        "name": "深圳字节航空",
                        "id": 211612
                    }]
                }, {
                    "name": "北京亚马逊医药",
                    "id": 211613
                }, {
                    "name": "南京字节旅游",
                    "id": 211614
                }, {
                    "name": "纽约快手金融",
                    "id": 211615
                }, {
                    "name": "香港阿里医院",
                    "id": 211616
                }, {
                    "name": "天津蚂蚁",
                    "id": 211617
                }, {
                    "name": "北京肯德基智能控股集团",
                    "id": 211618
                }, {
                    "name": "首尔快手牧业",
                    "id": 211619
                }, {
                    "name": "杭州小米渔业",
                    "id": 211620,
                    "children": [{
                        "name": "香港特斯拉医药控股集团",
                        "id": 211621
                    }, {
                        "name": "南京快手信息服务",
                        "id": 211622
                    }, {
                        "name": "上海瑞幸基金",
                        "id": 211623
                    }, {
                        "name": "台北腾讯汽车控股集团",
                        "id": 211624
                    }, {
                        "name": "东京喜茶通讯有限公司",
                        "id": 211625
                    }, {
                        "name": "厦门星巴克智能",
                        "id": 211626
                    }, {
                        "name": "台北蚂蚁农业控股集团",
                        "id": 211627
                    }, {
                        "name": "厦门亚马逊餐饮",
                        "id": 211628
                    }, {
                        "name": "南京腾讯医药",
                        "id": 211629
                    }, {
                        "name": "香港快手渔业",
                        "id": 211630
                    }, {
                        "name": "东莞亚马逊地产控股集团",
                        "id": 211631
                    }, {
                        "name": "广州欧珀互金控股集团",
                        "id": 211632
                    }, {
                        "name": "天津滴滴养殖",
                        "id": 211633
                    }, {
                        "name": "杭州喜茶餐饮控股集团",
                        "id": 211634
                    }, {
                        "name": "南京平安",
                        "id": 211635
                    }, {
                        "name": "纽约美团制造",
                        "id": 211636
                    }, {
                        "name": "纽约蚂蚁芯片",
                        "id": 211637
                    }, {
                        "name": "杭州腾讯",
                        "id": 211638
                    }, {
                        "name": "上海百度汽车",
                        "id": 211639
                    }]
                }, {
                    "name": "广州美团渔业",
                    "id": 211640
                }]
            }, {
                "name": "厦门字节",
                "id": 211641
            }, {
                "name": "南京蚂蚁旅游控股集团",
                "id": 211642
            }, {
                "name": "台北亚马逊新能源",
                "id": 211643
            }, {
                "name": "南京奈雪农业",
                "id": 211644
            }, {
                "name": "东莞字节基金",
                "id": 211645
            }, {
                "name": "上海快手科技有限公司",
                "id": 211646,
                "children": [{
                    "name": "香港必胜客软件控股集团",
                    "id": 211647
                }, {
                    "name": "北京美团",
                    "id": 211648
                }, {
                    "name": "东莞蚂蚁石油",
                    "id": 211649
                }, {
                    "name": "上海谷歌旅游",
                    "id": 211650
                }, {
                    "name": "南京美团科技有限公司",
                    "id": 211651
                }, {
                    "name": "厦门小米餐饮",
                    "id": 211652,
                    "children": [{
                        "name": "深圳星巴克渔业",
                        "id": 211653
                    }, {
                        "name": "广州美团通讯有限公司",
                        "id": 211654
                    }, {
                        "name": "台北字节旅游控股集团",
                        "id": 211655
                    }, {
                        "name": "首尔字节",
                        "id": 211656
                    }, {
                        "name": "广州滴滴证券",
                        "id": 211657
                    }, {
                        "name": "首尔阿里证券控股集团",
                        "id": 211658
                    }, {
                        "name": "深圳特斯拉农业控股集团",
                        "id": 211659
                    }, {
                        "name": "东莞苹果证券",
                        "id": 211660
                    }, {
                        "name": "南京瑞幸软件有限公司",
                        "id": 211661
                    }, {
                        "name": "首尔必胜客金融",
                        "id": 211662
                    }, {
                        "name": "东京微软制造",
                        "id": 211663
                    }, {
                        "name": "纽约阿里牧业",
                        "id": 211664
                    }, {
                        "name": "南京华为制造",
                        "id": 211665
                    }, {
                        "name": "香港瑞幸证券有限公司",
                        "id": 211666
                    }, {
                        "name": "台北苹果控股集团",
                        "id": 211667
                    }, {
                        "name": "东京百度养殖有限公司",
                        "id": 211668
                    }, {
                        "name": "深圳奈雪软件控股集团",
                        "id": 211669
                    }, {
                        "name": "深圳京东牧业",
                        "id": 211670
                    }, {
                        "name": "广州喜茶软件",
                        "id": 211671
                    }, {
                        "name": "厦门滴滴餐饮",
                        "id": 211672
                    }, {
                        "name": "香港特斯拉芯片",
                        "id": 211673
                    }, {
                        "name": "北京奈雪医药",
                        "id": 211674
                    }, {
                        "name": "天津苹果航空控股集团",
                        "id": 211675
                    }, {
                        "name": "东京特斯拉汽车控股集团",
                        "id": 211676
                    }, {
                        "name": "首尔腾讯汽车控股集团",
                        "id": 211677
                    }, {
                        "name": "台北谷歌医院控股集团",
                        "id": 211678
                    }, {
                        "name": "香港平安诊所",
                        "id": 211679
                    }]
                }, {
                    "name": "香港美团渔业控股集团",
                    "id": 211680,
                    "children": [{
                        "name": "东京腾讯制造有限公司",
                        "id": 211681
                    }, {
                        "name": "台北滴滴航空",
                        "id": 211682
                    }, {
                        "name": "香港小米科技",
                        "id": 211683
                    }, {
                        "name": "南京字节医药",
                        "id": 211684
                    }, {
                        "name": "天津亚马逊旅游",
                        "id": 211685
                    }, {
                        "name": "东莞必胜客制造",
                        "id": 211686
                    }, {
                        "name": "首尔百度智能有限公司",
                        "id": 211687
                    }, {
                        "name": "杭州百度科技有限公司",
                        "id": 211688
                    }, {
                        "name": "北京阿里旅游有限公司",
                        "id": 211689
                    }, {
                        "name": "杭州星巴克芯片有限公司",
                        "id": 211690
                    }, {
                        "name": "东莞京东通信有限公司",
                        "id": 211691
                    }, {
                        "name": "深圳瑞幸软件有限公司",
                        "id": 211692
                    }, {
                        "name": "北京平安科技",
                        "id": 211693
                    }, {
                        "name": "杭州微软基金",
                        "id": 211694
                    }, {
                        "name": "台北美团新能源有限公司",
                        "id": 211695
                    }, {
                        "name": "首尔字节银行",
                        "id": 211696
                    }, {
                        "name": "东京瑞幸",
                        "id": 211697
                    }, {
                        "name": "台北阿里通信",
                        "id": 211698
                    }, {
                        "name": "纽约华为新能源",
                        "id": 211699
                    }, {
                        "name": "首尔小米农业",
                        "id": 211700
                    }, {
                        "name": "台北小米通信控股集团",
                        "id": 211701
                    }, {
                        "name": "上海肯德基地摊控股集团",
                        "id": 211702
                    }, {
                        "name": "深圳微软通讯",
                        "id": 211703
                    }, {
                        "name": "上海阿里地产有限公司",
                        "id": 211704
                    }, {
                        "name": "上海必胜客农业",
                        "id": 211705
                    }]
                }, {
                    "name": "天津腾讯智能",
                    "id": 211706
                }, {
                    "name": "东京滴滴地摊控股集团",
                    "id": 211707
                }, {
                    "name": "杭州必胜客信息服务控股集团",
                    "id": 211708
                }, {
                    "name": "香港小米",
                    "id": 211709,
                    "children": [{
                        "name": "纽约苹果",
                        "id": 211710
                    }, {
                        "name": "上海喜茶牧业",
                        "id": 211711
                    }, {
                        "name": "天津京东渔业有限公司",
                        "id": 211712
                    }, {
                        "name": "东莞滴滴证券",
                        "id": 211713
                    }, {
                        "name": "首尔华为控股集团",
                        "id": 211714
                    }, {
                        "name": "台北亚马逊基金",
                        "id": 211715
                    }, {
                        "name": "纽约肯德基银行",
                        "id": 211716
                    }, {
                        "name": "台北京东科技",
                        "id": 211717
                    }, {
                        "name": "杭州苹果餐饮",
                        "id": 211718
                    }, {
                        "name": "厦门美团医院",
                        "id": 211719
                    }, {
                        "name": "东京快手电商",
                        "id": 211720
                    }, {
                        "name": "杭州亚马逊电商",
                        "id": 211721
                    }, {
                        "name": "纽约阿里新能源",
                        "id": 211722
                    }, {
                        "name": "杭州字节石油",
                        "id": 211723
                    }, {
                        "name": "深圳腾讯牧业",
                        "id": 211724
                    }, {
                        "name": "东莞阿里计算机",
                        "id": 211725
                    }, {
                        "name": "广州瑞幸计算机",
                        "id": 211726
                    }, {
                        "name": "天津蚂蚁诊所",
                        "id": 211727
                    }, {
                        "name": "台北星巴克旅游",
                        "id": 211728
                    }, {
                        "name": "杭州华为控股集团",
                        "id": 211729
                    }, {
                        "name": "南京亚马逊基金控股集团",
                        "id": 211730
                    }, {
                        "name": "天津必胜客牧业",
                        "id": 211731
                    }, {
                        "name": "北京京东银行有限公司",
                        "id": 211732
                    }, {
                        "name": "香港亚马逊渔业",
                        "id": 211733
                    }, {
                        "name": "天津字节新能源",
                        "id": 211734
                    }, {
                        "name": "东京必胜客汽车",
                        "id": 211735
                    }, {
                        "name": "深圳苹果新能源",
                        "id": 211736
                    }, {
                        "name": "杭州小米智能",
                        "id": 211737
                    }, {
                        "name": "深圳苹果餐饮有限公司",
                        "id": 211738
                    }, {
                        "name": "首尔腾讯地摊",
                        "id": 211739
                    }]
                }, {
                    "name": "香港蚂蚁地摊",
                    "id": 211740
                }, {
                    "name": "广州滴滴有限公司",
                    "id": 211741
                }, {
                    "name": "香港瑞幸医院",
                    "id": 211742
                }, {
                    "name": "首尔特斯拉金融",
                    "id": 211743
                }]
            }, {
                "name": "杭州谷歌软件",
                "id": 211744
            }, {
                "name": "首尔微软农业",
                "id": 211745,
                "children": [{
                    "name": "台北平安银行",
                    "id": 211746
                }, {
                    "name": "上海亚马逊",
                    "id": 211747
                }, {
                    "name": "东京美团通信",
                    "id": 211748
                }, {
                    "name": "深圳快手石油控股集团",
                    "id": 211749,
                    "children": [{
                        "name": "南京字节通信控股集团",
                        "id": 211750
                    }, {
                        "name": "厦门蚂蚁农业",
                        "id": 211751
                    }, {
                        "name": "深圳华为芯片",
                        "id": 211752
                    }, {
                        "name": "北京百度科技控股集团",
                        "id": 211753
                    }, {
                        "name": "东京平安新能源有限公司",
                        "id": 211754
                    }, {
                        "name": "杭州特斯拉餐饮",
                        "id": 211755
                    }, {
                        "name": "杭州滴滴科技",
                        "id": 211756
                    }, {
                        "name": "香港微软汽车",
                        "id": 211757
                    }, {
                        "name": "东莞苹果汽车",
                        "id": 211758
                    }, {
                        "name": "杭州蚂蚁医药",
                        "id": 211759
                    }, {
                        "name": "首尔奈雪科技有限公司",
                        "id": 211760
                    }, {
                        "name": "南京欧珀信息服务",
                        "id": 211761
                    }, {
                        "name": "香港肯德基金融",
                        "id": 211762
                    }, {
                        "name": "东莞阿里证券",
                        "id": 211763
                    }, {
                        "name": "台北肯德基智能",
                        "id": 211764
                    }, {
                        "name": "首尔蚂蚁通信",
                        "id": 211765
                    }, {
                        "name": "上海平安医药有限公司",
                        "id": 211766
                    }, {
                        "name": "北京星巴克餐饮",
                        "id": 211767
                    }, {
                        "name": "香港谷歌通讯控股集团",
                        "id": 211768
                    }, {
                        "name": "南京亚马逊有限公司",
                        "id": 211769
                    }, {
                        "name": "南京亚马逊汽车",
                        "id": 211770
                    }, {
                        "name": "南京欧珀芯片有限公司",
                        "id": 211771
                    }, {
                        "name": "纽约亚马逊餐饮",
                        "id": 211772
                    }, {
                        "name": "台北特斯拉诊所",
                        "id": 211773
                    }, {
                        "name": "广州美团医药有限公司",
                        "id": 211774
                    }, {
                        "name": "台北华为芯片",
                        "id": 211775
                    }, {
                        "name": "深圳肯德基汽车有限公司",
                        "id": 211776
                    }, {
                        "name": "东莞亚马逊汽车有限公司",
                        "id": 211777
                    }, {
                        "name": "南京苹果计算机控股集团",
                        "id": 211778
                    }]
                }, {
                    "name": "深圳星巴克养殖有限公司",
                    "id": 211779
                }, {
                    "name": "香港特斯拉",
                    "id": 211780
                }, {
                    "name": "首尔阿里金融",
                    "id": 211781
                }, {
                    "name": "首尔谷歌芯片控股集团",
                    "id": 211782
                }, {
                    "name": "香港平安新能源控股集团",
                    "id": 211783
                }, {
                    "name": "东京亚马逊汽车有限公司",
                    "id": 211784
                }, {
                    "name": "北京微软互金",
                    "id": 211785
                }, {
                    "name": "天津字节银行",
                    "id": 211786
                }, {
                    "name": "香港亚马逊通讯控股集团",
                    "id": 211787,
                    "children": [{
                        "name": "广州必胜客电商",
                        "id": 211788
                    }, {
                        "name": "广州小米渔业",
                        "id": 211789
                    }, {
                        "name": "深圳平安石油",
                        "id": 211790
                    }, {
                        "name": "杭州华为养殖有限公司",
                        "id": 211791
                    }, {
                        "name": "台北奈雪",
                        "id": 211792
                    }, {
                        "name": "上海京东信息服务",
                        "id": 211793
                    }, {
                        "name": "首尔华为通讯",
                        "id": 211794
                    }, {
                        "name": "上海字节软件",
                        "id": 211795
                    }, {
                        "name": "北京特斯拉地摊有限公司",
                        "id": 211796
                    }, {
                        "name": "厦门星巴克金融",
                        "id": 211797
                    }, {
                        "name": "香港快手智能",
                        "id": 211798
                    }, {
                        "name": "上海阿里信息服务有限公司",
                        "id": 211799
                    }, {
                        "name": "南京滴滴航空有限公司",
                        "id": 211800
                    }, {
                        "name": "深圳美团制造",
                        "id": 211801
                    }]
                }, {
                    "name": "上海肯德基互金控股集团",
                    "id": 211802,
                    "children": [{
                        "name": "厦门腾讯芯片",
                        "id": 211803
                    }, {
                        "name": "台北小米通信",
                        "id": 211804
                    }, {
                        "name": "东京微软互金",
                        "id": 211805
                    }, {
                        "name": "杭州滴滴芯片",
                        "id": 211806
                    }]
                }, {
                    "name": "台北华为金融",
                    "id": 211807
                }, {
                    "name": "深圳必胜客银行",
                    "id": 211808,
                    "children": [{
                        "name": "上海谷歌航空控股集团",
                        "id": 211809
                    }, {
                        "name": "台北星巴克基金有限公司",
                        "id": 211810
                    }, {
                        "name": "首尔蚂蚁证券",
                        "id": 211811
                    }, {
                        "name": "东京华为石油",
                        "id": 211812
                    }, {
                        "name": "杭州小米汽车",
                        "id": 211813
                    }]
                }, {
                    "name": "厦门平安地摊控股集团",
                    "id": 211814
                }, {
                    "name": "深圳美团餐饮",
                    "id": 211815,
                    "children": [{
                        "name": "纽约微软地摊",
                        "id": 211816
                    }, {
                        "name": "香港蚂蚁医药有限公司",
                        "id": 211817
                    }, {
                        "name": "东莞百度养殖有限公司",
                        "id": 211818
                    }, {
                        "name": "台北美团电商",
                        "id": 211819
                    }, {
                        "name": "东京瑞幸金融控股集团",
                        "id": 211820
                    }, {
                        "name": "东京肯德基地产",
                        "id": 211821
                    }, {
                        "name": "南京欧珀医院",
                        "id": 211822
                    }, {
                        "name": "天津华为新能源",
                        "id": 211823
                    }, {
                        "name": "台北阿里互金",
                        "id": 211824
                    }, {
                        "name": "广州百度信息服务",
                        "id": 211825
                    }, {
                        "name": "首尔快手互金",
                        "id": 211826
                    }, {
                        "name": "北京喜茶互金控股集团",
                        "id": 211827
                    }, {
                        "name": "杭州苹果制造",
                        "id": 211828
                    }, {
                        "name": "上海小米地产控股集团",
                        "id": 211829
                    }, {
                        "name": "天津奈雪制造有限公司",
                        "id": 211830
                    }, {
                        "name": "首尔肯德基智能",
                        "id": 211831
                    }, {
                        "name": "上海滴滴渔业有限公司",
                        "id": 211832
                    }, {
                        "name": "台北平安",
                        "id": 211833
                    }, {
                        "name": "杭州星巴克芯片",
                        "id": 211834
                    }, {
                        "name": "南京奈雪石油",
                        "id": 211835
                    }, {
                        "name": "首尔百度信息服务",
                        "id": 211836
                    }, {
                        "name": "台北华为航空",
                        "id": 211837
                    }, {
                        "name": "厦门喜茶互金",
                        "id": 211838
                    }, {
                        "name": "广州微软控股集团",
                        "id": 211839
                    }, {
                        "name": "南京京东通信",
                        "id": 211840
                    }, {
                        "name": "厦门小米地产",
                        "id": 211841
                    }, {
                        "name": "东莞星巴克新能源有限公司",
                        "id": 211842
                    }, {
                        "name": "杭州苹果互金控股集团",
                        "id": 211843
                    }, {
                        "name": "南京瑞幸航空",
                        "id": 211844
                    }, {
                        "name": "厦门苹果",
                        "id": 211845
                    }, {
                        "name": "杭州必胜客制造",
                        "id": 211846
                    }, {
                        "name": "天津快手航空控股集团",
                        "id": 211847
                    }, {
                        "name": "南京京东牧业",
                        "id": 211848
                    }]
                }, {
                    "name": "杭州亚马逊旅游控股集团",
                    "id": 211849
                }, {
                    "name": "南京阿里农业有限公司",
                    "id": 211850
                }, {
                    "name": "东京喜茶芯片",
                    "id": 211851
                }, {
                    "name": "东莞美团农业",
                    "id": 211852,
                    "children": [{
                        "name": "厦门必胜客通信",
                        "id": 211853
                    }, {
                        "name": "广州瑞幸地摊",
                        "id": 211854
                    }, {
                        "name": "南京蚂蚁制造控股集团",
                        "id": 211855
                    }, {
                        "name": "北京亚马逊互金",
                        "id": 211856
                    }, {
                        "name": "杭州阿里医药控股集团",
                        "id": 211857
                    }, {
                        "name": "台北亚马逊新能源有限公司",
                        "id": 211858
                    }]
                }, {
                    "name": "首尔亚马逊计算机",
                    "id": 211859
                }, {
                    "name": "北京百度基金",
                    "id": 211860,
                    "children": [{
                        "name": "首尔字节制造",
                        "id": 211861
                    }, {
                        "name": "北京谷歌航空",
                        "id": 211862
                    }, {
                        "name": "纽约星巴克控股集团",
                        "id": 211863
                    }, {
                        "name": "东京京东通信",
                        "id": 211864
                    }, {
                        "name": "广州特斯拉渔业",
                        "id": 211865
                    }, {
                        "name": "北京小米芯片",
                        "id": 211866
                    }, {
                        "name": "天津百度软件控股集团",
                        "id": 211867
                    }, {
                        "name": "天津奈雪计算机",
                        "id": 211868
                    }, {
                        "name": "东莞谷歌制造有限公司",
                        "id": 211869
                    }, {
                        "name": "杭州特斯拉金融",
                        "id": 211870
                    }, {
                        "name": "天津欧珀旅游",
                        "id": 211871
                    }, {
                        "name": "杭州百度",
                        "id": 211872
                    }, {
                        "name": "上海星巴克证券",
                        "id": 211873
                    }, {
                        "name": "台北京东医药",
                        "id": 211874
                    }, {
                        "name": "东莞阿里信息服务",
                        "id": 211875
                    }, {
                        "name": "上海腾讯地产",
                        "id": 211876
                    }, {
                        "name": "上海滴滴牧业",
                        "id": 211877
                    }, {
                        "name": "台北肯德基地产",
                        "id": 211878
                    }, {
                        "name": "杭州字节智能",
                        "id": 211879
                    }, {
                        "name": "上海华为渔业",
                        "id": 211880
                    }, {
                        "name": "上海微软金融",
                        "id": 211881
                    }, {
                        "name": "深圳特斯拉信息服务控股集团",
                        "id": 211882
                    }, {
                        "name": "杭州快手计算机有限公司",
                        "id": 211883
                    }, {
                        "name": "纽约必胜客制造",
                        "id": 211884
                    }, {
                        "name": "东莞快手养殖",
                        "id": 211885
                    }, {
                        "name": "首尔欧珀通信",
                        "id": 211886
                    }, {
                        "name": "台北星巴克信息服务",
                        "id": 211887
                    }, {
                        "name": "上海特斯拉地产",
                        "id": 211888
                    }, {
                        "name": "东莞谷歌渔业",
                        "id": 211889
                    }, {
                        "name": "台北必胜客基金",
                        "id": 211890
                    }, {
                        "name": "厦门微软软件",
                        "id": 211891
                    }, {
                        "name": "上海小米信息服务",
                        "id": 211892
                    }, {
                        "name": "香港滴滴医院",
                        "id": 211893
                    }]
                }, {
                    "name": "杭州肯德基牧业",
                    "id": 211894
                }, {
                    "name": "纽约阿里计算机",
                    "id": 211895
                }, {
                    "name": "天津奈雪金融",
                    "id": 211896
                }, {
                    "name": "东京百度通讯",
                    "id": 211897
                }, {
                    "name": "纽约百度养殖",
                    "id": 211898
                }, {
                    "name": "台北平安航空",
                    "id": 211899
                }, {
                    "name": "杭州蚂蚁",
                    "id": 211900,
                    "children": [{
                        "name": "东京星巴克诊所",
                        "id": 211901
                    }, {
                        "name": "上海字节制造",
                        "id": 211902
                    }, {
                        "name": "香港亚马逊软件",
                        "id": 211903
                    }, {
                        "name": "南京京东科技",
                        "id": 211904
                    }, {
                        "name": "杭州滴滴旅游控股集团",
                        "id": 211905
                    }, {
                        "name": "厦门美团通讯",
                        "id": 211906
                    }, {
                        "name": "台北阿里航空",
                        "id": 211907
                    }, {
                        "name": "东莞平安医药有限公司",
                        "id": 211908
                    }, {
                        "name": "上海奈雪餐饮控股集团",
                        "id": 211909
                    }]
                }, {
                    "name": "广州肯德基通信有限公司",
                    "id": 211910
                }, {
                    "name": "杭州小米科技有限公司",
                    "id": 211911
                }, {
                    "name": "东京美团控股集团",
                    "id": 211912
                }]
            }, {
                "name": "台北华为渔业",
                "id": 211913
            }, {
                "name": "台北必胜客医院",
                "id": 211914
            }, {
                "name": "天津快手智能",
                "id": 211915
            }]
        }, {
            "name": "台北阿里计算机控股集团",
            "id": 211916
        }, {
            "name": "首尔瑞幸计算机控股集团",
            "id": 211917
        }, {
            "name": "杭州喜茶",
            "id": 211918
        }, {
            "name": "厦门快手软件",
            "id": 211919,
            "children": [{
                "name": "广州腾讯渔业",
                "id": 211920
            }, {
                "name": "杭州美团芯片",
                "id": 211921,
                "children": [{
                    "name": "东莞必胜客养殖",
                    "id": 211922
                }, {
                    "name": "香港京东旅游",
                    "id": 211923,
                    "children": [{
                        "name": "深圳喜茶银行",
                        "id": 211924
                    }, {
                        "name": "台北瑞幸石油",
                        "id": 211925
                    }, {
                        "name": "上海小米计算机有限公司",
                        "id": 211926
                    }, {
                        "name": "上海微软通讯",
                        "id": 211927
                    }, {
                        "name": "天津阿里牧业",
                        "id": 211928
                    }, {
                        "name": "厦门阿里基金",
                        "id": 211929
                    }, {
                        "name": "天津肯德基地摊",
                        "id": 211930
                    }, {
                        "name": "深圳小米基金控股集团",
                        "id": 211931
                    }]
                }, {
                    "name": "香港百度医院有限公司",
                    "id": 211932
                }, {
                    "name": "东莞亚马逊旅游",
                    "id": 211933
                }, {
                    "name": "纽约字节地摊有限公司",
                    "id": 211934
                }, {
                    "name": "香港小米控股集团",
                    "id": 211935
                }, {
                    "name": "厦门必胜客软件有限公司",
                    "id": 211936
                }, {
                    "name": "东京快手金融控股集团",
                    "id": 211937
                }, {
                    "name": "东京百度地产",
                    "id": 211938
                }, {
                    "name": "东京特斯拉通信",
                    "id": 211939,
                    "children": [{
                        "name": "广州喜茶通讯有限公司",
                        "id": 211940
                    }, {
                        "name": "首尔瑞幸医药有限公司",
                        "id": 211941
                    }, {
                        "name": "厦门字节互金",
                        "id": 211942
                    }, {
                        "name": "上海亚马逊农业",
                        "id": 211943
                    }, {
                        "name": "杭州腾讯电商",
                        "id": 211944
                    }, {
                        "name": "东京华为诊所控股集团",
                        "id": 211945
                    }]
                }, {
                    "name": "台北百度银行",
                    "id": 211946
                }, {
                    "name": "杭州瑞幸",
                    "id": 211947
                }, {
                    "name": "东京特斯拉科技",
                    "id": 211948
                }, {
                    "name": "厦门百度餐饮",
                    "id": 211949
                }, {
                    "name": "南京奈雪金融",
                    "id": 211950
                }, {
                    "name": "香港瑞幸智能有限公司",
                    "id": 211951
                }, {
                    "name": "天津字节互金",
                    "id": 211952
                }, {
                    "name": "首尔美团石油控股集团",
                    "id": 211953,
                    "children": [{
                        "name": "广州喜茶科技有限公司",
                        "id": 211954
                    }, {
                        "name": "纽约阿里计算机有限公司",
                        "id": 211955
                    }, {
                        "name": "东京肯德基软件控股集团",
                        "id": 211956
                    }, {
                        "name": "东莞快手证券",
                        "id": 211957
                    }, {
                        "name": "东京喜茶旅游",
                        "id": 211958
                    }, {
                        "name": "厦门腾讯芯片",
                        "id": 211959
                    }, {
                        "name": "深圳蚂蚁基金控股集团",
                        "id": 211960
                    }, {
                        "name": "南京肯德基汽车控股集团",
                        "id": 211961
                    }, {
                        "name": "东莞字节软件有限公司",
                        "id": 211962
                    }, {
                        "name": "台北瑞幸石油",
                        "id": 211963
                    }, {
                        "name": "深圳奈雪基金",
                        "id": 211964
                    }, {
                        "name": "杭州必胜客地摊",
                        "id": 211965
                    }, {
                        "name": "香港百度地产",
                        "id": 211966
                    }]
                }, {
                    "name": "厦门字节信息服务控股集团",
                    "id": 211967,
                    "children": [{
                        "name": "首尔欧珀地摊有限公司",
                        "id": 211968
                    }, {
                        "name": "香港星巴克医院控股集团",
                        "id": 211969
                    }, {
                        "name": "东莞快手新能源控股集团",
                        "id": 211970
                    }, {
                        "name": "厦门百度",
                        "id": 211971
                    }, {
                        "name": "首尔瑞幸农业",
                        "id": 211972
                    }, {
                        "name": "东莞星巴克诊所有限公司",
                        "id": 211973
                    }, {
                        "name": "南京必胜客基金",
                        "id": 211974
                    }, {
                        "name": "首尔肯德基医院",
                        "id": 211975
                    }, {
                        "name": "东京肯德基",
                        "id": 211976
                    }, {
                        "name": "深圳阿里银行",
                        "id": 211977
                    }, {
                        "name": "东莞京东医院",
                        "id": 211978
                    }, {
                        "name": "台北星巴克证券",
                        "id": 211979
                    }, {
                        "name": "南京苹果科技",
                        "id": 211980
                    }, {
                        "name": "纽约欧珀金融控股集团",
                        "id": 211981
                    }, {
                        "name": "厦门平安旅游",
                        "id": 211982
                    }, {
                        "name": "杭州特斯拉科技",
                        "id": 211983
                    }, {
                        "name": "上海微软控股集团",
                        "id": 211984
                    }, {
                        "name": "杭州特斯拉牧业",
                        "id": 211985
                    }, {
                        "name": "东莞蚂蚁新能源有限公司",
                        "id": 211986
                    }, {
                        "name": "首尔欧珀互金控股集团",
                        "id": 211987
                    }, {
                        "name": "上海特斯拉基金",
                        "id": 211988
                    }, {
                        "name": "南京腾讯芯片",
                        "id": 211989
                    }, {
                        "name": "杭州奈雪地摊有限公司",
                        "id": 211990
                    }, {
                        "name": "杭州平安牧业",
                        "id": 211991
                    }, {
                        "name": "深圳星巴克通讯有限公司",
                        "id": 211992
                    }, {
                        "name": "杭州滴滴旅游",
                        "id": 211993
                    }, {
                        "name": "深圳喜茶银行",
                        "id": 211994
                    }, {
                        "name": "厦门华为制造有限公司",
                        "id": 211995
                    }, {
                        "name": "厦门蚂蚁",
                        "id": 211996
                    }, {
                        "name": "纽约星巴克制造",
                        "id": 211997
                    }]
                }, {
                    "name": "南京华为互金",
                    "id": 211998
                }, {
                    "name": "东京阿里医药",
                    "id": 211999
                }, {
                    "name": "杭州滴滴通讯有限公司",
                    "id": 212000
                }, {
                    "name": "深圳美团地产",
                    "id": 212001
                }, {
                    "name": "上海特斯拉智能",
                    "id": 212002,
                    "children": [{
                        "name": "台北蚂蚁汽车有限公司",
                        "id": 212003
                    }, {
                        "name": "南京字节互金",
                        "id": 212004
                    }, {
                        "name": "北京小米",
                        "id": 212005
                    }, {
                        "name": "南京美团通信",
                        "id": 212006
                    }, {
                        "name": "厦门亚马逊养殖控股集团",
                        "id": 212007
                    }, {
                        "name": "北京阿里石油",
                        "id": 212008
                    }, {
                        "name": "北京京东计算机",
                        "id": 212009
                    }, {
                        "name": "杭州平安科技",
                        "id": 212010
                    }, {
                        "name": "台北肯德基诊所控股集团",
                        "id": 212011
                    }, {
                        "name": "北京星巴克渔业有限公司",
                        "id": 212012
                    }, {
                        "name": "天津星巴克通讯控股集团",
                        "id": 212013
                    }, {
                        "name": "上海字节航空",
                        "id": 212014
                    }, {
                        "name": "纽约快手电商",
                        "id": 212015
                    }, {
                        "name": "广州滴滴",
                        "id": 212016
                    }, {
                        "name": "首尔百度养殖",
                        "id": 212017
                    }, {
                        "name": "台北肯德基",
                        "id": 212018
                    }, {
                        "name": "杭州平安智能有限公司",
                        "id": 212019
                    }, {
                        "name": "深圳瑞幸医院",
                        "id": 212020
                    }, {
                        "name": "东莞快手新能源控股集团",
                        "id": 212021
                    }, {
                        "name": "纽约微软银行有限公司",
                        "id": 212022
                    }, {
                        "name": "东京必胜客证券有限公司",
                        "id": 212023
                    }, {
                        "name": "台北欧珀智能控股集团",
                        "id": 212024
                    }, {
                        "name": "深圳苹果石油控股集团",
                        "id": 212025
                    }, {
                        "name": "杭州喜茶农业",
                        "id": 212026
                    }, {
                        "name": "首尔华为互金控股集团",
                        "id": 212027
                    }, {
                        "name": "厦门华为银行",
                        "id": 212028
                    }, {
                        "name": "杭州星巴克养殖",
                        "id": 212029
                    }, {
                        "name": "杭州华为",
                        "id": 212030
                    }, {
                        "name": "北京字节石油",
                        "id": 212031
                    }, {
                        "name": "东莞特斯拉",
                        "id": 212032
                    }]
                }, {
                    "name": "东京奈雪新能源控股集团",
                    "id": 212033,
                    "children": [{
                        "name": "台北蚂蚁软件",
                        "id": 212034
                    }, {
                        "name": "厦门华为医院控股集团",
                        "id": 212035
                    }, {
                        "name": "东京苹果智能",
                        "id": 212036
                    }, {
                        "name": "厦门百度互金控股集团",
                        "id": 212037
                    }, {
                        "name": "纽约亚马逊地产",
                        "id": 212038
                    }, {
                        "name": "广州必胜客",
                        "id": 212039
                    }, {
                        "name": "深圳星巴克",
                        "id": 212040
                    }, {
                        "name": "香港蚂蚁金融",
                        "id": 212041
                    }, {
                        "name": "东京喜茶旅游",
                        "id": 212042
                    }, {
                        "name": "纽约谷歌",
                        "id": 212043
                    }, {
                        "name": "天津特斯拉科技控股集团",
                        "id": 212044
                    }, {
                        "name": "上海平安证券有限公司",
                        "id": 212045
                    }, {
                        "name": "纽约奈雪旅游",
                        "id": 212046
                    }, {
                        "name": "东京亚马逊智能有限公司",
                        "id": 212047
                    }, {
                        "name": "香港华为基金",
                        "id": 212048
                    }, {
                        "name": "上海星巴克牧业",
                        "id": 212049
                    }, {
                        "name": "杭州谷歌智能",
                        "id": 212050
                    }, {
                        "name": "纽约亚马逊地摊",
                        "id": 212051
                    }, {
                        "name": "东莞滴滴基金有限公司",
                        "id": 212052
                    }, {
                        "name": "东莞百度基金有限公司",
                        "id": 212053
                    }, {
                        "name": "香港百度牧业",
                        "id": 212054
                    }, {
                        "name": "台北阿里金融",
                        "id": 212055
                    }, {
                        "name": "北京肯德基",
                        "id": 212056
                    }, {
                        "name": "首尔必胜客石油",
                        "id": 212057
                    }, {
                        "name": "香港华为计算机",
                        "id": 212058
                    }, {
                        "name": "北京美团医药",
                        "id": 212059
                    }, {
                        "name": "广州蚂蚁养殖",
                        "id": 212060
                    }, {
                        "name": "杭州华为养殖控股集团",
                        "id": 212061
                    }, {
                        "name": "纽约奈雪旅游控股集团",
                        "id": 212062
                    }, {
                        "name": "北京蚂蚁",
                        "id": 212063
                    }, {
                        "name": "东京肯德基智能",
                        "id": 212064
                    }]
                }, {
                    "name": "北京瑞幸银行",
                    "id": 212065
                }, {
                    "name": "东莞微软基金有限公司",
                    "id": 212066
                }, {
                    "name": "杭州肯德基地摊",
                    "id": 212067,
                    "children": [{
                        "name": "广州苹果智能有限公司",
                        "id": 212068
                    }, {
                        "name": "厦门滴滴餐饮",
                        "id": 212069
                    }, {
                        "name": "东京苹果有限公司",
                        "id": 212070
                    }, {
                        "name": "北京星巴克石油",
                        "id": 212071
                    }, {
                        "name": "东莞阿里智能",
                        "id": 212072
                    }, {
                        "name": "天津亚马逊计算机",
                        "id": 212073
                    }, {
                        "name": "上海蚂蚁诊所控股集团",
                        "id": 212074
                    }, {
                        "name": "东莞平安渔业控股集团",
                        "id": 212075
                    }, {
                        "name": "厦门滴滴农业控股集团",
                        "id": 212076
                    }, {
                        "name": "东莞小米地摊",
                        "id": 212077
                    }, {
                        "name": "杭州欧珀芯片",
                        "id": 212078
                    }, {
                        "name": "杭州谷歌餐饮",
                        "id": 212079
                    }, {
                        "name": "广州美团",
                        "id": 212080
                    }, {
                        "name": "上海百度",
                        "id": 212081
                    }, {
                        "name": "南京字节石油有限公司",
                        "id": 212082
                    }]
                }, {
                    "name": "首尔小米渔业",
                    "id": 212083
                }, {
                    "name": "东京阿里",
                    "id": 212084
                }, {
                    "name": "南京阿里计算机",
                    "id": 212085
                }]
            }, {
                "name": "南京字节智能",
                "id": 212086
            }, {
                "name": "杭州喜茶科技",
                "id": 212087
            }, {
                "name": "首尔微软航空",
                "id": 212088
            }, {
                "name": "台北百度旅游",
                "id": 212089
            }, {
                "name": "首尔欧珀有限公司",
                "id": 212090
            }, {
                "name": "杭州阿里养殖有限公司",
                "id": 212091
            }, {
                "name": "南京蚂蚁互金",
                "id": 212092
            }, {
                "name": "上海小米石油控股集团",
                "id": 212093
            }, {
                "name": "厦门华为医药有限公司",
                "id": 212094
            }, {
                "name": "天津特斯拉芯片",
                "id": 212095
            }, {
                "name": "纽约苹果地产",
                "id": 212096
            }]
        }, {
            "name": "南京瑞幸餐饮",
            "id": 212097
        }, {
            "name": "广州百度软件",
            "id": 212098,
            "children": [{
                "name": "首尔蚂蚁科技控股集团",
                "id": 212099
            }, {
                "name": "香港特斯拉",
                "id": 212100
            }, {
                "name": "纽约小米基金控股集团",
                "id": 212101,
                "children": [{
                    "name": "台北阿里",
                    "id": 212102,
                    "children": [{
                        "name": "台北奈雪餐饮有限公司",
                        "id": 212103
                    }, {
                        "name": "深圳喜茶养殖",
                        "id": 212104
                    }, {
                        "name": "东莞小米金融",
                        "id": 212105
                    }, {
                        "name": "深圳平安诊所",
                        "id": 212106
                    }, {
                        "name": "香港谷歌牧业",
                        "id": 212107
                    }, {
                        "name": "东莞美团银行控股集团",
                        "id": 212108
                    }, {
                        "name": "东莞苹果软件",
                        "id": 212109
                    }, {
                        "name": "纽约奈雪软件",
                        "id": 212110
                    }, {
                        "name": "北京谷歌有限公司",
                        "id": 212111
                    }, {
                        "name": "南京腾讯医院有限公司",
                        "id": 212112
                    }, {
                        "name": "首尔必胜客新能源",
                        "id": 212113
                    }, {
                        "name": "南京奈雪通信",
                        "id": 212114
                    }, {
                        "name": "深圳滴滴汽车有限公司",
                        "id": 212115
                    }, {
                        "name": "深圳欧珀有限公司",
                        "id": 212116
                    }, {
                        "name": "杭州小米控股集团",
                        "id": 212117
                    }, {
                        "name": "纽约腾讯通讯",
                        "id": 212118
                    }, {
                        "name": "台北星巴克金融",
                        "id": 212119
                    }, {
                        "name": "广州星巴克农业",
                        "id": 212120
                    }, {
                        "name": "台北阿里汽车控股集团",
                        "id": 212121
                    }, {
                        "name": "北京奈雪芯片",
                        "id": 212122
                    }, {
                        "name": "厦门小米诊所",
                        "id": 212123
                    }, {
                        "name": "纽约星巴克控股集团",
                        "id": 212124
                    }, {
                        "name": "深圳特斯拉汽车",
                        "id": 212125
                    }, {
                        "name": "纽约必胜客汽车",
                        "id": 212126
                    }, {
                        "name": "首尔小米诊所有限公司",
                        "id": 212127
                    }, {
                        "name": "深圳腾讯证券",
                        "id": 212128
                    }, {
                        "name": "香港小米地产",
                        "id": 212129
                    }, {
                        "name": "厦门亚马逊医院",
                        "id": 212130
                    }, {
                        "name": "首尔美团银行",
                        "id": 212131
                    }, {
                        "name": "首尔京东银行控股集团",
                        "id": 212132
                    }]
                }, {
                    "name": "东莞瑞幸互金",
                    "id": 212133,
                    "children": [{
                        "name": "杭州特斯拉基金",
                        "id": 212134
                    }, {
                        "name": "纽约必胜客信息服务",
                        "id": 212135
                    }, {
                        "name": "广州欧珀智能有限公司",
                        "id": 212136
                    }, {
                        "name": "香港特斯拉地产",
                        "id": 212137
                    }, {
                        "name": "广州平安智能控股集团",
                        "id": 212138
                    }, {
                        "name": "南京星巴克基金",
                        "id": 212139
                    }, {
                        "name": "上海腾讯航空",
                        "id": 212140
                    }, {
                        "name": "南京平安软件",
                        "id": 212141
                    }, {
                        "name": "南京蚂蚁通信",
                        "id": 212142
                    }, {
                        "name": "深圳快手智能",
                        "id": 212143
                    }, {
                        "name": "广州美团通讯有限公司",
                        "id": 212144
                    }, {
                        "name": "杭州阿里新能源控股集团",
                        "id": 212145
                    }, {
                        "name": "首尔亚马逊金融",
                        "id": 212146
                    }, {
                        "name": "南京字节科技",
                        "id": 212147
                    }]
                }, {
                    "name": "杭州星巴克科技",
                    "id": 212148
                }, {
                    "name": "上海小米证券",
                    "id": 212149
                }, {
                    "name": "厦门美团",
                    "id": 212150
                }, {
                    "name": "东莞蚂蚁电商控股集团",
                    "id": 212151
                }, {
                    "name": "上海蚂蚁有限公司",
                    "id": 212152
                }, {
                    "name": "东莞亚马逊养殖",
                    "id": 212153
                }, {
                    "name": "厦门谷歌牧业有限公司",
                    "id": 212154
                }, {
                    "name": "杭州欧珀旅游控股集团",
                    "id": 212155,
                    "children": [{
                        "name": "台北必胜客控股集团",
                        "id": 212156
                    }, {
                        "name": "香港蚂蚁航空有限公司",
                        "id": 212157
                    }, {
                        "name": "广州美团医药控股集团",
                        "id": 212158
                    }, {
                        "name": "东京京东医院控股集团",
                        "id": 212159
                    }, {
                        "name": "东莞华为控股集团",
                        "id": 212160
                    }, {
                        "name": "深圳百度通讯",
                        "id": 212161
                    }, {
                        "name": "首尔必胜客新能源有限公司",
                        "id": 212162
                    }, {
                        "name": "东京特斯拉医院",
                        "id": 212163
                    }, {
                        "name": "南京华为诊所",
                        "id": 212164
                    }, {
                        "name": "厦门百度互金有限公司",
                        "id": 212165
                    }, {
                        "name": "厦门华为牧业",
                        "id": 212166
                    }, {
                        "name": "纽约京东通讯",
                        "id": 212167
                    }, {
                        "name": "厦门瑞幸信息服务",
                        "id": 212168
                    }, {
                        "name": "杭州欧珀芯片控股集团",
                        "id": 212169
                    }, {
                        "name": "广州肯德基地摊控股集团",
                        "id": 212170
                    }, {
                        "name": "香港美团地摊",
                        "id": 212171
                    }, {
                        "name": "广州奈雪银行控股集团",
                        "id": 212172
                    }, {
                        "name": "深圳肯德基基金有限公司",
                        "id": 212173
                    }, {
                        "name": "南京欧珀农业控股集团",
                        "id": 212174
                    }, {
                        "name": "东京百度制造控股集团",
                        "id": 212175
                    }, {
                        "name": "纽约奈雪证券",
                        "id": 212176
                    }, {
                        "name": "杭州美团牧业控股集团",
                        "id": 212177
                    }, {
                        "name": "杭州京东金融",
                        "id": 212178
                    }, {
                        "name": "深圳特斯拉渔业",
                        "id": 212179
                    }, {
                        "name": "纽约星巴克软件有限公司",
                        "id": 212180
                    }, {
                        "name": "东京肯德基牧业有限公司",
                        "id": 212181
                    }, {
                        "name": "纽约滴滴",
                        "id": 212182
                    }, {
                        "name": "厦门华为地摊控股集团",
                        "id": 212183
                    }, {
                        "name": "上海苹果牧业",
                        "id": 212184
                    }, {
                        "name": "天津瑞幸养殖有限公司",
                        "id": 212185
                    }]
                }, {
                    "name": "北京谷歌软件",
                    "id": 212186,
                    "children": [{
                        "name": "广州京东",
                        "id": 212187
                    }, {
                        "name": "首尔华为制造",
                        "id": 212188
                    }, {
                        "name": "厦门谷歌航空有限公司",
                        "id": 212189
                    }, {
                        "name": "厦门快手电商",
                        "id": 212190
                    }, {
                        "name": "东莞滴滴养殖",
                        "id": 212191
                    }, {
                        "name": "纽约平安证券",
                        "id": 212192
                    }, {
                        "name": "上海亚马逊证券有限公司",
                        "id": 212193
                    }, {
                        "name": "厦门瑞幸",
                        "id": 212194
                    }, {
                        "name": "纽约平安",
                        "id": 212195
                    }, {
                        "name": "杭州亚马逊通信",
                        "id": 212196
                    }, {
                        "name": "东莞平安医院",
                        "id": 212197
                    }, {
                        "name": "深圳小米医药控股集团",
                        "id": 212198
                    }, {
                        "name": "杭州肯德基银行",
                        "id": 212199
                    }, {
                        "name": "天津美团科技",
                        "id": 212200
                    }, {
                        "name": "东京字节计算机",
                        "id": 212201
                    }, {
                        "name": "东京小米新能源",
                        "id": 212202
                    }, {
                        "name": "南京华为制造",
                        "id": 212203
                    }, {
                        "name": "上海苹果金融控股集团",
                        "id": 212204
                    }, {
                        "name": "东京阿里航空",
                        "id": 212205
                    }, {
                        "name": "台北特斯拉农业",
                        "id": 212206
                    }, {
                        "name": "深圳微软软件",
                        "id": 212207
                    }, {
                        "name": "纽约谷歌",
                        "id": 212208
                    }, {
                        "name": "厦门阿里证券控股集团",
                        "id": 212209
                    }, {
                        "name": "东京华为",
                        "id": 212210
                    }, {
                        "name": "台北美团地产",
                        "id": 212211
                    }]
                }, {
                    "name": "上海滴滴",
                    "id": 212212
                }, {
                    "name": "东莞星巴克农业",
                    "id": 212213,
                    "children": [{
                        "name": "南京京东智能",
                        "id": 212214
                    }, {
                        "name": "北京喜茶农业",
                        "id": 212215
                    }, {
                        "name": "纽约华为通信控股集团",
                        "id": 212216
                    }, {
                        "name": "北京特斯拉石油",
                        "id": 212217
                    }, {
                        "name": "上海喜茶地摊控股集团",
                        "id": 212218
                    }, {
                        "name": "杭州必胜客制造有限公司",
                        "id": 212219
                    }, {
                        "name": "广州小米餐饮",
                        "id": 212220
                    }, {
                        "name": "厦门瑞幸牧业",
                        "id": 212221
                    }, {
                        "name": "天津华为",
                        "id": 212222
                    }]
                }, {
                    "name": "杭州百度制造",
                    "id": 212223,
                    "children": [{
                        "name": "天津奈雪航空控股集团",
                        "id": 212224
                    }, {
                        "name": "东京华为通信有限公司",
                        "id": 212225
                    }, {
                        "name": "北京肯德基医药",
                        "id": 212226
                    }, {
                        "name": "南京肯德基基金",
                        "id": 212227
                    }, {
                        "name": "纽约平安基金",
                        "id": 212228
                    }, {
                        "name": "广州特斯拉计算机",
                        "id": 212229
                    }]
                }, {
                    "name": "香港特斯拉",
                    "id": 212230
                }, {
                    "name": "广州华为渔业",
                    "id": 212231
                }, {
                    "name": "香港京东养殖控股集团",
                    "id": 212232,
                    "children": [{
                        "name": "杭州阿里电商",
                        "id": 212233
                    }, {
                        "name": "上海瑞幸地摊",
                        "id": 212234
                    }, {
                        "name": "东莞阿里餐饮有限公司",
                        "id": 212235
                    }, {
                        "name": "台北微软互金",
                        "id": 212236
                    }, {
                        "name": "台北欧珀银行",
                        "id": 212237
                    }, {
                        "name": "东莞快手信息服务",
                        "id": 212238
                    }, {
                        "name": "东莞特斯拉农业有限公司",
                        "id": 212239
                    }]
                }, {
                    "name": "纽约蚂蚁金融",
                    "id": 212240
                }, {
                    "name": "首尔瑞幸航空",
                    "id": 212241
                }]
            }]
        }, {
            "name": "杭州百度渔业有限公司",
            "id": 212242
        }, {
            "name": "天津亚马逊电商",
            "id": 212243,
            "children": [{
                "name": "上海小米金融",
                "id": 212244
            }, {
                "name": "香港瑞幸电商",
                "id": 212245
            }, {
                "name": "厦门微软农业控股集团",
                "id": 212246,
                "children": [{
                    "name": "台北亚马逊牧业控股集团",
                    "id": 212247
                }, {
                    "name": "香港微软互金有限公司",
                    "id": 212248,
                    "children": [{
                        "name": "天津百度通讯控股集团",
                        "id": 212249
                    }, {
                        "name": "上海华为计算机",
                        "id": 212250
                    }, {
                        "name": "厦门字节石油有限公司",
                        "id": 212251
                    }, {
                        "name": "南京滴滴制造",
                        "id": 212252
                    }, {
                        "name": "东京苹果科技",
                        "id": 212253
                    }, {
                        "name": "北京美团基金有限公司",
                        "id": 212254
                    }, {
                        "name": "首尔谷歌证券",
                        "id": 212255
                    }, {
                        "name": "纽约苹果基金",
                        "id": 212256
                    }, {
                        "name": "杭州京东养殖控股集团",
                        "id": 212257
                    }, {
                        "name": "厦门字节互金控股集团",
                        "id": 212258
                    }, {
                        "name": "杭州美团银行控股集团",
                        "id": 212259
                    }, {
                        "name": "北京华为信息服务",
                        "id": 212260
                    }, {
                        "name": "杭州欧珀通讯",
                        "id": 212261
                    }, {
                        "name": "南京蚂蚁石油",
                        "id": 212262
                    }, {
                        "name": "南京亚马逊科技",
                        "id": 212263
                    }, {
                        "name": "厦门奈雪医院",
                        "id": 212264
                    }, {
                        "name": "深圳亚马逊计算机",
                        "id": 212265
                    }, {
                        "name": "南京必胜客渔业控股集团",
                        "id": 212266
                    }, {
                        "name": "杭州欧珀餐饮",
                        "id": 212267
                    }, {
                        "name": "台北字节地产",
                        "id": 212268
                    }, {
                        "name": "首尔小米诊所",
                        "id": 212269
                    }, {
                        "name": "杭州星巴克电商",
                        "id": 212270
                    }, {
                        "name": "纽约苹果医院",
                        "id": 212271
                    }, {
                        "name": "香港腾讯石油",
                        "id": 212272
                    }, {
                        "name": "深圳喜茶",
                        "id": 212273
                    }, {
                        "name": "北京特斯拉",
                        "id": 212274
                    }, {
                        "name": "纽约小米农业",
                        "id": 212275
                    }, {
                        "name": "香港华为牧业",
                        "id": 212276
                    }]
                }, {
                    "name": "广州特斯拉石油",
                    "id": 212277,
                    "children": [{
                        "name": "纽约星巴克诊所有限公司",
                        "id": 212278
                    }, {
                        "name": "厦门谷歌计算机",
                        "id": 212279
                    }, {
                        "name": "厦门腾讯信息服务",
                        "id": 212280
                    }, {
                        "name": "东莞亚马逊诊所控股集团",
                        "id": 212281
                    }, {
                        "name": "天津平安",
                        "id": 212282
                    }, {
                        "name": "首尔欧珀医院",
                        "id": 212283
                    }, {
                        "name": "香港瑞幸汽车有限公司",
                        "id": 212284
                    }, {
                        "name": "北京蚂蚁农业",
                        "id": 212285
                    }, {
                        "name": "东莞瑞幸旅游",
                        "id": 212286
                    }, {
                        "name": "首尔蚂蚁金融",
                        "id": 212287
                    }, {
                        "name": "北京美团基金有限公司",
                        "id": 212288
                    }, {
                        "name": "北京星巴克航空有限公司",
                        "id": 212289
                    }, {
                        "name": "杭州腾讯电商",
                        "id": 212290
                    }, {
                        "name": "台北平安渔业",
                        "id": 212291
                    }, {
                        "name": "东莞必胜客互金有限公司",
                        "id": 212292
                    }, {
                        "name": "南京华为银行",
                        "id": 212293
                    }, {
                        "name": "东京字节地产",
                        "id": 212294
                    }, {
                        "name": "深圳蚂蚁基金控股集团",
                        "id": 212295
                    }, {
                        "name": "广州苹果计算机有限公司",
                        "id": 212296
                    }, {
                        "name": "杭州腾讯控股集团",
                        "id": 212297
                    }, {
                        "name": "深圳蚂蚁电商",
                        "id": 212298
                    }, {
                        "name": "深圳喜茶诊所",
                        "id": 212299
                    }, {
                        "name": "深圳阿里通信控股集团",
                        "id": 212300
                    }, {
                        "name": "南京快手",
                        "id": 212301
                    }, {
                        "name": "杭州谷歌有限公司",
                        "id": 212302
                    }, {
                        "name": "东莞特斯拉证券",
                        "id": 212303
                    }, {
                        "name": "杭州阿里智能",
                        "id": 212304
                    }, {
                        "name": "上海华为银行",
                        "id": 212305
                    }, {
                        "name": "杭州美团渔业控股集团",
                        "id": 212306
                    }, {
                        "name": "广州喜茶餐饮",
                        "id": 212307
                    }, {
                        "name": "厦门奈雪电商",
                        "id": 212308
                    }, {
                        "name": "首尔星巴克农业",
                        "id": 212309
                    }]
                }, {
                    "name": "东莞蚂蚁养殖控股集团",
                    "id": 212310
                }, {
                    "name": "广州特斯拉银行控股集团",
                    "id": 212311,
                    "children": [{
                        "name": "广州华为计算机",
                        "id": 212312
                    }, {
                        "name": "天津腾讯证券有限公司",
                        "id": 212313
                    }, {
                        "name": "南京微软餐饮",
                        "id": 212314
                    }, {
                        "name": "广州平安医院",
                        "id": 212315
                    }, {
                        "name": "天津美团渔业控股集团",
                        "id": 212316
                    }, {
                        "name": "杭州奈雪地产",
                        "id": 212317
                    }, {
                        "name": "天津瑞幸互金",
                        "id": 212318
                    }, {
                        "name": "杭州瑞幸牧业",
                        "id": 212319
                    }]
                }, {
                    "name": "纽约华为",
                    "id": 212320,
                    "children": [{
                        "name": "厦门瑞幸制造",
                        "id": 212321
                    }, {
                        "name": "首尔亚马逊有限公司",
                        "id": 212322
                    }, {
                        "name": "东京微软汽车控股集团",
                        "id": 212323
                    }, {
                        "name": "上海平安农业",
                        "id": 212324
                    }, {
                        "name": "上海喜茶金融",
                        "id": 212325
                    }, {
                        "name": "东莞快手软件",
                        "id": 212326
                    }, {
                        "name": "厦门华为医药",
                        "id": 212327
                    }, {
                        "name": "上海欧珀计算机有限公司",
                        "id": 212328
                    }, {
                        "name": "上海小米银行",
                        "id": 212329
                    }, {
                        "name": "香港必胜客航空",
                        "id": 212330
                    }, {
                        "name": "东京滴滴通讯",
                        "id": 212331
                    }, {
                        "name": "香港阿里科技",
                        "id": 212332
                    }, {
                        "name": "东莞特斯拉餐饮",
                        "id": 212333
                    }, {
                        "name": "深圳快手",
                        "id": 212334
                    }, {
                        "name": "台北百度养殖",
                        "id": 212335
                    }, {
                        "name": "广州瑞幸制造",
                        "id": 212336
                    }, {
                        "name": "东京蚂蚁石油有限公司",
                        "id": 212337
                    }, {
                        "name": "广州美团地摊",
                        "id": 212338
                    }, {
                        "name": "首尔谷歌地摊",
                        "id": 212339
                    }, {
                        "name": "厦门阿里航空",
                        "id": 212340
                    }, {
                        "name": "东莞蚂蚁制造",
                        "id": 212341
                    }, {
                        "name": "首尔美团渔业",
                        "id": 212342
                    }, {
                        "name": "南京百度农业",
                        "id": 212343
                    }, {
                        "name": "东莞小米新能源",
                        "id": 212344
                    }, {
                        "name": "北京奈雪餐饮",
                        "id": 212345
                    }, {
                        "name": "天津华为汽车",
                        "id": 212346
                    }, {
                        "name": "厦门瑞幸智能",
                        "id": 212347
                    }, {
                        "name": "广州苹果医院",
                        "id": 212348
                    }, {
                        "name": "天津肯德基地摊",
                        "id": 212349
                    }, {
                        "name": "台北美团通讯有限公司",
                        "id": 212350
                    }, {
                        "name": "南京阿里地产控股集团",
                        "id": 212351
                    }, {
                        "name": "广州喜茶医药",
                        "id": 212352
                    }, {
                        "name": "杭州奈雪医药",
                        "id": 212353
                    }, {
                        "name": "天津美团通讯",
                        "id": 212354
                    }, {
                        "name": "东莞亚马逊地摊控股集团",
                        "id": 212355
                    }, {
                        "name": "台北快手农业",
                        "id": 212356
                    }]
                }, {
                    "name": "深圳奈雪智能",
                    "id": 212357
                }, {
                    "name": "南京必胜客互金",
                    "id": 212358
                }, {
                    "name": "广州喜茶",
                    "id": 212359
                }, {
                    "name": "首尔字节智能",
                    "id": 212360
                }, {
                    "name": "广州微软新能源",
                    "id": 212361
                }, {
                    "name": "上海苹果计算机",
                    "id": 212362
                }, {
                    "name": "杭州平安证券",
                    "id": 212363
                }, {
                    "name": "东京欧珀新能源有限公司",
                    "id": 212364
                }, {
                    "name": "纽约京东新能源控股集团",
                    "id": 212365
                }, {
                    "name": "南京美团渔业控股集团",
                    "id": 212366
                }, {
                    "name": "南京快手诊所控股集团",
                    "id": 212367
                }, {
                    "name": "天津瑞幸通信",
                    "id": 212368
                }, {
                    "name": "香港平安芯片",
                    "id": 212369
                }, {
                    "name": "纽约肯德基软件有限公司",
                    "id": 212370
                }, {
                    "name": "杭州百度计算机有限公司",
                    "id": 212371
                }, {
                    "name": "广州星巴克互金有限公司",
                    "id": 212372
                }, {
                    "name": "广州平安芯片有限公司",
                    "id": 212373,
                    "children": [{
                        "name": "纽约奈雪地产",
                        "id": 212374
                    }, {
                        "name": "东莞小米有限公司",
                        "id": 212375
                    }, {
                        "name": "北京特斯拉芯片有限公司",
                        "id": 212376
                    }, {
                        "name": "台北阿里计算机",
                        "id": 212377
                    }, {
                        "name": "上海快手证券控股集团",
                        "id": 212378
                    }, {
                        "name": "东京京东餐饮",
                        "id": 212379
                    }, {
                        "name": "杭州蚂蚁智能",
                        "id": 212380
                    }, {
                        "name": "东京快手电商控股集团",
                        "id": 212381
                    }, {
                        "name": "深圳星巴克石油有限公司",
                        "id": 212382
                    }, {
                        "name": "纽约星巴克通讯",
                        "id": 212383
                    }, {
                        "name": "香港蚂蚁控股集团",
                        "id": 212384
                    }, {
                        "name": "台北喜茶",
                        "id": 212385
                    }, {
                        "name": "南京奈雪诊所",
                        "id": 212386
                    }, {
                        "name": "纽约华为牧业有限公司",
                        "id": 212387
                    }, {
                        "name": "东莞奈雪汽车",
                        "id": 212388
                    }, {
                        "name": "广州美团石油有限公司",
                        "id": 212389
                    }, {
                        "name": "天津阿里有限公司",
                        "id": 212390
                    }, {
                        "name": "南京星巴克牧业",
                        "id": 212391
                    }, {
                        "name": "厦门微软智能有限公司",
                        "id": 212392
                    }, {
                        "name": "南京亚马逊医院",
                        "id": 212393
                    }, {
                        "name": "杭州京东电商",
                        "id": 212394
                    }, {
                        "name": "首尔百度医院",
                        "id": 212395
                    }, {
                        "name": "杭州微软控股集团",
                        "id": 212396
                    }]
                }, {
                    "name": "香港滴滴科技",
                    "id": 212397
                }, {
                    "name": "东莞阿里新能源",
                    "id": 212398
                }]
            }, {
                "name": "东京蚂蚁医药",
                "id": 212399
            }, {
                "name": "杭州滴滴农业",
                "id": 212400
            }]
        }, {
            "name": "东莞蚂蚁农业",
            "id": 212401
        }, {
            "name": "香港亚马逊控股集团",
            "id": 212402
        }, {
            "name": "东京华为证券控股集团",
            "id": 212403
        }, {
            "name": "香港微软医院",
            "id": 212404
        }, {
            "name": "深圳星巴克养殖",
            "id": 212405,
            "children": [{
                "name": "杭州谷歌控股集团",
                "id": 212406,
                "children": [{
                    "name": "香港星巴克银行",
                    "id": 212407
                }, {
                    "name": "纽约快手牧业",
                    "id": 212408
                }, {
                    "name": "天津滴滴地摊控股集团",
                    "id": 212409
                }, {
                    "name": "南京瑞幸电商",
                    "id": 212410
                }, {
                    "name": "首尔微软计算机",
                    "id": 212411
                }, {
                    "name": "东京星巴克诊所控股集团",
                    "id": 212412
                }, {
                    "name": "北京小米旅游控股集团",
                    "id": 212413,
                    "children": [{
                        "name": "东莞欧珀农业",
                        "id": 212414
                    }, {
                        "name": "杭州特斯拉证券有限公司",
                        "id": 212415
                    }, {
                        "name": "南京特斯拉",
                        "id": 212416
                    }, {
                        "name": "厦门阿里基金",
                        "id": 212417
                    }, {
                        "name": "纽约亚马逊芯片",
                        "id": 212418
                    }, {
                        "name": "上海美团地摊",
                        "id": 212419
                    }, {
                        "name": "纽约特斯拉新能源",
                        "id": 212420
                    }, {
                        "name": "纽约欧珀控股集团",
                        "id": 212421
                    }, {
                        "name": "天津腾讯农业",
                        "id": 212422
                    }, {
                        "name": "天津必胜客餐饮有限公司",
                        "id": 212423
                    }, {
                        "name": "北京喜茶智能控股集团",
                        "id": 212424
                    }, {
                        "name": "纽约喜茶养殖",
                        "id": 212425
                    }, {
                        "name": "东京百度医药有限公司",
                        "id": 212426
                    }, {
                        "name": "厦门平安养殖",
                        "id": 212427
                    }, {
                        "name": "广州字节基金有限公司",
                        "id": 212428
                    }, {
                        "name": "厦门苹果诊所控股集团",
                        "id": 212429
                    }, {
                        "name": "首尔亚马逊计算机控股集团",
                        "id": 212430
                    }, {
                        "name": "杭州苹果信息服务",
                        "id": 212431
                    }, {
                        "name": "上海滴滴航空",
                        "id": 212432
                    }, {
                        "name": "台北阿里石油有限公司",
                        "id": 212433
                    }, {
                        "name": "北京阿里",
                        "id": 212434
                    }]
                }, {
                    "name": "台北肯德基旅游",
                    "id": 212435,
                    "children": [{
                        "name": "杭州欧珀电商",
                        "id": 212436
                    }, {
                        "name": "台北苹果地产",
                        "id": 212437
                    }, {
                        "name": "东莞京东新能源控股集团",
                        "id": 212438
                    }, {
                        "name": "上海特斯拉",
                        "id": 212439
                    }, {
                        "name": "北京喜茶智能",
                        "id": 212440
                    }, {
                        "name": "厦门阿里计算机控股集团",
                        "id": 212441
                    }, {
                        "name": "台北字节金融",
                        "id": 212442
                    }, {
                        "name": "纽约美团互金",
                        "id": 212443
                    }, {
                        "name": "香港微软通讯控股集团",
                        "id": 212444
                    }, {
                        "name": "首尔字节养殖",
                        "id": 212445
                    }, {
                        "name": "东莞京东航空",
                        "id": 212446
                    }, {
                        "name": "纽约苹果控股集团",
                        "id": 212447
                    }, {
                        "name": "天津蚂蚁软件有限公司",
                        "id": 212448
                    }, {
                        "name": "杭州特斯拉信息服务控股集团",
                        "id": 212449
                    }, {
                        "name": "台北星巴克诊所控股集团",
                        "id": 212450
                    }]
                }, {
                    "name": "首尔腾讯证券",
                    "id": 212451
                }, {
                    "name": "纽约滴滴基金有限公司",
                    "id": 212452
                }, {
                    "name": "东京瑞幸金融",
                    "id": 212453,
                    "children": [{
                        "name": "北京平安金融有限公司",
                        "id": 212454
                    }, {
                        "name": "广州星巴克基金",
                        "id": 212455
                    }, {
                        "name": "纽约华为制造有限公司",
                        "id": 212456
                    }, {
                        "name": "天津快手餐饮控股集团",
                        "id": 212457
                    }, {
                        "name": "上海谷歌控股集团",
                        "id": 212458
                    }, {
                        "name": "北京百度养殖",
                        "id": 212459
                    }, {
                        "name": "南京百度医药",
                        "id": 212460
                    }, {
                        "name": "广州腾讯控股集团",
                        "id": 212461
                    }, {
                        "name": "香港小米智能控股集团",
                        "id": 212462
                    }, {
                        "name": "东京星巴克餐饮有限公司",
                        "id": 212463
                    }, {
                        "name": "杭州腾讯汽车控股集团",
                        "id": 212464
                    }, {
                        "name": "杭州腾讯养殖",
                        "id": 212465
                    }, {
                        "name": "杭州滴滴电商",
                        "id": 212466
                    }, {
                        "name": "南京亚马逊智能控股集团",
                        "id": 212467
                    }, {
                        "name": "上海欧珀旅游控股集团",
                        "id": 212468
                    }, {
                        "name": "深圳滴滴软件控股集团",
                        "id": 212469
                    }, {
                        "name": "杭州京东诊所",
                        "id": 212470
                    }, {
                        "name": "南京滴滴通讯有限公司",
                        "id": 212471
                    }, {
                        "name": "厦门阿里银行",
                        "id": 212472
                    }, {
                        "name": "深圳阿里汽车控股集团",
                        "id": 212473
                    }, {
                        "name": "香港瑞幸养殖",
                        "id": 212474
                    }, {
                        "name": "杭州星巴克汽车",
                        "id": 212475
                    }, {
                        "name": "杭州蚂蚁基金有限公司",
                        "id": 212476
                    }]
                }, {
                    "name": "杭州百度新能源有限公司",
                    "id": 212477
                }, {
                    "name": "厦门肯德基新能源",
                    "id": 212478
                }, {
                    "name": "纽约腾讯基金有限公司",
                    "id": 212479
                }]
            }, {
                "name": "东莞必胜客证券控股集团",
                "id": 212480
            }, {
                "name": "杭州平安计算机",
                "id": 212481,
                "children": [{
                    "name": "东京蚂蚁智能有限公司",
                    "id": 212482
                }, {
                    "name": "深圳奈雪地产",
                    "id": 212483
                }, {
                    "name": "天津蚂蚁控股集团",
                    "id": 212484
                }, {
                    "name": "首尔必胜客控股集团",
                    "id": 212485
                }, {
                    "name": "南京欧珀金融有限公司",
                    "id": 212486
                }, {
                    "name": "天津欧珀电商",
                    "id": 212487
                }, {
                    "name": "纽约亚马逊渔业",
                    "id": 212488,
                    "children": [{
                        "name": "台北微软通信",
                        "id": 212489
                    }, {
                        "name": "台北星巴克地摊",
                        "id": 212490
                    }, {
                        "name": "首尔快手科技控股集团",
                        "id": 212491
                    }, {
                        "name": "北京特斯拉银行",
                        "id": 212492
                    }, {
                        "name": "香港美团芯片",
                        "id": 212493
                    }, {
                        "name": "东莞必胜客计算机",
                        "id": 212494
                    }, {
                        "name": "东莞快手牧业",
                        "id": 212495
                    }, {
                        "name": "东京必胜客牧业",
                        "id": 212496
                    }, {
                        "name": "广州必胜客制造",
                        "id": 212497
                    }, {
                        "name": "东莞特斯拉",
                        "id": 212498
                    }, {
                        "name": "天津滴滴信息服务",
                        "id": 212499
                    }, {
                        "name": "东莞美团基金",
                        "id": 212500
                    }, {
                        "name": "台北必胜客",
                        "id": 212501
                    }, {
                        "name": "香港瑞幸银行",
                        "id": 212502
                    }, {
                        "name": "杭州美团通信",
                        "id": 212503
                    }, {
                        "name": "杭州喜茶农业有限公司",
                        "id": 212504
                    }, {
                        "name": "首尔奈雪金融控股集团",
                        "id": 212505
                    }, {
                        "name": "南京京东农业",
                        "id": 212506
                    }, {
                        "name": "南京百度",
                        "id": 212507
                    }, {
                        "name": "首尔百度养殖",
                        "id": 212508
                    }, {
                        "name": "台北谷歌科技",
                        "id": 212509
                    }, {
                        "name": "杭州瑞幸信息服务控股集团",
                        "id": 212510
                    }, {
                        "name": "纽约美团诊所",
                        "id": 212511
                    }, {
                        "name": "杭州滴滴餐饮",
                        "id": 212512
                    }, {
                        "name": "香港星巴克基金",
                        "id": 212513
                    }, {
                        "name": "香港肯德基有限公司",
                        "id": 212514
                    }, {
                        "name": "南京瑞幸银行",
                        "id": 212515
                    }, {
                        "name": "广州肯德基医院",
                        "id": 212516
                    }, {
                        "name": "南京平安汽车",
                        "id": 212517
                    }]
                }]
            }, {
                "name": "东京字节信息服务",
                "id": 212518
            }, {
                "name": "杭州蚂蚁地摊控股集团",
                "id": 212519
            }]
        }, {
            "name": "东莞特斯拉餐饮控股集团",
            "id": 212520
        }, {
            "name": "杭州欧珀地产",
            "id": 212521
        }, {
            "name": "台北苹果通信",
            "id": 212522
        }, {
            "name": "广州喜茶",
            "id": 212523,
            "children": [{
                "name": "香港阿里金融控股集团",
                "id": 212524
            }, {
                "name": "纽约谷歌医院有限公司",
                "id": 212525
            }, {
                "name": "杭州蚂蚁航空",
                "id": 212526
            }, {
                "name": "纽约亚马逊餐饮有限公司",
                "id": 212527
            }, {
                "name": "上海特斯拉计算机",
                "id": 212528,
                "children": [{
                    "name": "杭州星巴克航空控股集团",
                    "id": 212529,
                    "children": [{
                        "name": "台北美团基金",
                        "id": 212530
                    }, {
                        "name": "深圳华为新能源",
                        "id": 212531
                    }, {
                        "name": "台北微软医药",
                        "id": 212532
                    }, {
                        "name": "杭州字节互金",
                        "id": 212533
                    }, {
                        "name": "厦门欧珀银行",
                        "id": 212534
                    }, {
                        "name": "首尔京东地摊有限公司",
                        "id": 212535
                    }, {
                        "name": "杭州特斯拉控股集团",
                        "id": 212536
                    }, {
                        "name": "台北滴滴地产",
                        "id": 212537
                    }, {
                        "name": "上海快手智能",
                        "id": 212538
                    }, {
                        "name": "东京微软养殖",
                        "id": 212539
                    }, {
                        "name": "东莞快手餐饮",
                        "id": 212540
                    }, {
                        "name": "广州必胜客",
                        "id": 212541
                    }, {
                        "name": "东京华为芯片",
                        "id": 212542
                    }]
                }, {
                    "name": "广州平安农业",
                    "id": 212543
                }, {
                    "name": "上海苹果地摊控股集团",
                    "id": 212544
                }, {
                    "name": "厦门平安医药",
                    "id": 212545,
                    "children": [{
                        "name": "纽约京东智能",
                        "id": 212546
                    }, {
                        "name": "厦门阿里渔业有限公司",
                        "id": 212547
                    }, {
                        "name": "南京腾讯",
                        "id": 212548
                    }, {
                        "name": "台北美团养殖控股集团",
                        "id": 212549
                    }, {
                        "name": "上海喜茶制造控股集团",
                        "id": 212550
                    }, {
                        "name": "广州滴滴银行",
                        "id": 212551
                    }, {
                        "name": "首尔字节电商",
                        "id": 212552
                    }, {
                        "name": "东莞苹果芯片控股集团",
                        "id": 212553
                    }, {
                        "name": "广州快手地摊有限公司",
                        "id": 212554
                    }, {
                        "name": "纽约亚马逊诊所",
                        "id": 212555
                    }, {
                        "name": "深圳快手航空",
                        "id": 212556
                    }, {
                        "name": "北京美团石油有限公司",
                        "id": 212557
                    }, {
                        "name": "纽约亚马逊证券",
                        "id": 212558
                    }, {
                        "name": "广州瑞幸智能控股集团",
                        "id": 212559
                    }, {
                        "name": "广州奈雪航空控股集团",
                        "id": 212560
                    }, {
                        "name": "天津亚马逊旅游",
                        "id": 212561
                    }, {
                        "name": "东京阿里地摊有限公司",
                        "id": 212562
                    }, {
                        "name": "东京腾讯旅游控股集团",
                        "id": 212563
                    }, {
                        "name": "首尔谷歌养殖有限公司",
                        "id": 212564
                    }, {
                        "name": "上海蚂蚁汽车",
                        "id": 212565
                    }, {
                        "name": "杭州小米",
                        "id": 212566
                    }, {
                        "name": "厦门美团银行",
                        "id": 212567
                    }, {
                        "name": "东莞亚马逊农业",
                        "id": 212568
                    }, {
                        "name": "上海奈雪新能源",
                        "id": 212569
                    }, {
                        "name": "广州阿里",
                        "id": 212570
                    }, {
                        "name": "东京京东软件",
                        "id": 212571
                    }]
                }, {
                    "name": "东京肯德基通信",
                    "id": 212572
                }, {
                    "name": "杭州字节计算机",
                    "id": 212573
                }, {
                    "name": "上海微软通讯",
                    "id": 212574
                }, {
                    "name": "杭州腾讯",
                    "id": 212575
                }, {
                    "name": "纽约必胜客计算机",
                    "id": 212576
                }, {
                    "name": "东京微软电商",
                    "id": 212577
                }, {
                    "name": "上海蚂蚁旅游控股集团",
                    "id": 212578
                }, {
                    "name": "香港瑞幸餐饮",
                    "id": 212579
                }, {
                    "name": "深圳欧珀",
                    "id": 212580
                }, {
                    "name": "东京欧珀地产",
                    "id": 212581,
                    "children": [{
                        "name": "杭州特斯拉",
                        "id": 212582
                    }, {
                        "name": "首尔滴滴科技有限公司",
                        "id": 212583
                    }, {
                        "name": "上海快手",
                        "id": 212584
                    }, {
                        "name": "上海苹果科技",
                        "id": 212585
                    }, {
                        "name": "东莞华为金融控股集团",
                        "id": 212586
                    }, {
                        "name": "广州快手旅游有限公司",
                        "id": 212587
                    }, {
                        "name": "东京星巴克计算机",
                        "id": 212588
                    }, {
                        "name": "厦门必胜客金融有限公司",
                        "id": 212589
                    }, {
                        "name": "杭州美团牧业控股集团",
                        "id": 212590
                    }, {
                        "name": "杭州喜茶地产",
                        "id": 212591
                    }, {
                        "name": "广州喜茶金融有限公司",
                        "id": 212592
                    }, {
                        "name": "广州星巴克芯片控股集团",
                        "id": 212593
                    }, {
                        "name": "上海欧珀地产",
                        "id": 212594
                    }, {
                        "name": "台北百度",
                        "id": 212595
                    }, {
                        "name": "广州快手诊所",
                        "id": 212596
                    }, {
                        "name": "厦门华为通讯控股集团",
                        "id": 212597
                    }, {
                        "name": "纽约喜茶智能",
                        "id": 212598
                    }, {
                        "name": "厦门华为芯片有限公司",
                        "id": 212599
                    }]
                }, {
                    "name": "杭州蚂蚁科技",
                    "id": 212600
                }, {
                    "name": "台北滴滴信息服务",
                    "id": 212601
                }, {
                    "name": "台北百度医院控股集团",
                    "id": 212602
                }, {
                    "name": "纽约微软医院",
                    "id": 212603
                }, {
                    "name": "杭州亚马逊养殖",
                    "id": 212604
                }, {
                    "name": "香港阿里养殖控股集团",
                    "id": 212605,
                    "children": [{
                        "name": "广州阿里互金",
                        "id": 212606
                    }, {
                        "name": "纽约平安制造",
                        "id": 212607
                    }, {
                        "name": "上海腾讯旅游",
                        "id": 212608
                    }, {
                        "name": "广州肯德基有限公司",
                        "id": 212609
                    }]
                }, {
                    "name": "首尔平安计算机",
                    "id": 212610
                }, {
                    "name": "纽约微软地摊有限公司",
                    "id": 212611
                }, {
                    "name": "厦门小米新能源有限公司",
                    "id": 212612
                }, {
                    "name": "上海腾讯",
                    "id": 212613
                }, {
                    "name": "东京肯德基信息服务",
                    "id": 212614
                }, {
                    "name": "深圳腾讯软件",
                    "id": 212615
                }]
            }, {
                "name": "北京肯德基农业控股集团",
                "id": 212616,
                "children": [{
                    "name": "杭州奈雪电商",
                    "id": 212617
                }, {
                    "name": "东京蚂蚁基金",
                    "id": 212618
                }, {
                    "name": "纽约字节基金",
                    "id": 212619,
                    "children": [{
                        "name": "纽约谷歌",
                        "id": 212620
                    }, {
                        "name": "纽约肯德基新能源",
                        "id": 212621
                    }]
                }, {
                    "name": "南京美团诊所有限公司",
                    "id": 212622
                }, {
                    "name": "台北欧珀地产",
                    "id": 212623
                }, {
                    "name": "广州欧珀基金有限公司",
                    "id": 212624,
                    "children": [{
                        "name": "南京亚马逊控股集团",
                        "id": 212625
                    }, {
                        "name": "香港苹果通信控股集团",
                        "id": 212626
                    }, {
                        "name": "东京美团牧业控股集团",
                        "id": 212627
                    }, {
                        "name": "香港奈雪银行",
                        "id": 212628
                    }, {
                        "name": "东莞阿里互金",
                        "id": 212629
                    }, {
                        "name": "东京字节通讯",
                        "id": 212630
                    }, {
                        "name": "东京欧珀医院",
                        "id": 212631
                    }, {
                        "name": "上海特斯拉基金",
                        "id": 212632
                    }, {
                        "name": "东莞瑞幸医药控股集团",
                        "id": 212633
                    }, {
                        "name": "东京苹果制造",
                        "id": 212634
                    }, {
                        "name": "首尔喜茶制造控股集团",
                        "id": 212635
                    }, {
                        "name": "香港阿里餐饮控股集团",
                        "id": 212636
                    }]
                }, {
                    "name": "深圳谷歌养殖",
                    "id": 212637,
                    "children": [{
                        "name": "广州谷歌软件控股集团",
                        "id": 212638
                    }, {
                        "name": "东京谷歌航空控股集团",
                        "id": 212639
                    }, {
                        "name": "香港腾讯",
                        "id": 212640
                    }, {
                        "name": "杭州阿里餐饮",
                        "id": 212641
                    }, {
                        "name": "广州奈雪航空",
                        "id": 212642
                    }, {
                        "name": "上海腾讯电商有限公司",
                        "id": 212643
                    }]
                }, {
                    "name": "台北欧珀新能源",
                    "id": 212644
                }, {
                    "name": "南京小米旅游",
                    "id": 212645
                }]
            }, {
                "name": "杭州亚马逊通信",
                "id": 212646
            }, {
                "name": "厦门京东医院",
                "id": 212647
            }, {
                "name": "纽约滴滴渔业",
                "id": 212648
            }, {
                "name": "杭州肯德基互金",
                "id": 212649
            }, {
                "name": "广州必胜客金融",
                "id": 212650
            }, {
                "name": "台北苹果互金",
                "id": 212651
            }, {
                "name": "台北快手通信",
                "id": 212652
            }, {
                "name": "北京奈雪医院有限公司",
                "id": 212653
            }, {
                "name": "南京微软农业",
                "id": 212654,
                "children": [{
                    "name": "台北美团科技",
                    "id": 212655
                }, {
                    "name": "广州欧珀农业",
                    "id": 212656
                }, {
                    "name": "广州滴滴诊所",
                    "id": 212657
                }, {
                    "name": "东莞阿里智能",
                    "id": 212658,
                    "children": [{
                        "name": "纽约亚马逊汽车",
                        "id": 212659
                    }, {
                        "name": "纽约星巴克旅游",
                        "id": 212660
                    }, {
                        "name": "南京华为餐饮",
                        "id": 212661
                    }, {
                        "name": "广州谷歌农业",
                        "id": 212662
                    }, {
                        "name": "南京小米通信",
                        "id": 212663
                    }, {
                        "name": "香港亚马逊制造控股集团",
                        "id": 212664
                    }, {
                        "name": "杭州谷歌石油控股集团",
                        "id": 212665
                    }, {
                        "name": "纽约京东智能有限公司",
                        "id": 212666
                    }, {
                        "name": "纽约肯德基农业有限公司",
                        "id": 212667
                    }, {
                        "name": "东莞百度汽车",
                        "id": 212668
                    }, {
                        "name": "杭州微软银行有限公司",
                        "id": 212669
                    }, {
                        "name": "香港微软互金",
                        "id": 212670
                    }, {
                        "name": "深圳必胜客",
                        "id": 212671
                    }, {
                        "name": "首尔肯德基地产",
                        "id": 212672
                    }, {
                        "name": "东莞必胜客通信",
                        "id": 212673
                    }, {
                        "name": "南京京东互金",
                        "id": 212674
                    }, {
                        "name": "上海亚马逊石油",
                        "id": 212675
                    }, {
                        "name": "厦门瑞幸科技",
                        "id": 212676
                    }, {
                        "name": "东莞小米",
                        "id": 212677
                    }, {
                        "name": "台北阿里芯片",
                        "id": 212678
                    }, {
                        "name": "杭州必胜客餐饮",
                        "id": 212679
                    }, {
                        "name": "东京美团互金控股集团",
                        "id": 212680
                    }, {
                        "name": "台北京东诊所",
                        "id": 212681
                    }, {
                        "name": "香港京东信息服务",
                        "id": 212682
                    }, {
                        "name": "北京快手计算机有限公司",
                        "id": 212683
                    }, {
                        "name": "杭州美团医药",
                        "id": 212684
                    }, {
                        "name": "东莞肯德基旅游有限公司",
                        "id": 212685
                    }, {
                        "name": "广州奈雪石油控股集团",
                        "id": 212686
                    }, {
                        "name": "北京美团计算机",
                        "id": 212687
                    }, {
                        "name": "上海微软银行",
                        "id": 212688
                    }, {
                        "name": "广州蚂蚁通讯",
                        "id": 212689
                    }, {
                        "name": "北京星巴克信息服务",
                        "id": 212690
                    }, {
                        "name": "深圳小米石油控股集团",
                        "id": 212691
                    }, {
                        "name": "首尔华为石油",
                        "id": 212692
                    }, {
                        "name": "香港欧珀互金",
                        "id": 212693
                    }, {
                        "name": "北京微软养殖控股集团",
                        "id": 212694
                    }]
                }, {
                    "name": "杭州特斯拉新能源有限公司",
                    "id": 212695
                }, {
                    "name": "北京平安通讯控股集团",
                    "id": 212696
                }, {
                    "name": "上海阿里餐饮控股集团",
                    "id": 212697
                }, {
                    "name": "厦门美团渔业控股集团",
                    "id": 212698
                }, {
                    "name": "杭州欧珀地摊",
                    "id": 212699
                }, {
                    "name": "东京苹果牧业有限公司",
                    "id": 212700
                }, {
                    "name": "首尔特斯拉医院",
                    "id": 212701
                }, {
                    "name": "广州星巴克芯片控股集团",
                    "id": 212702
                }, {
                    "name": "南京星巴克软件有限公司",
                    "id": 212703
                }, {
                    "name": "纽约百度医院",
                    "id": 212704
                }, {
                    "name": "深圳百度新能源",
                    "id": 212705
                }, {
                    "name": "厦门谷歌航空控股集团",
                    "id": 212706,
                    "children": [{
                        "name": "香港欧珀信息服务",
                        "id": 212707
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 212708
                    }, {
                        "name": "东京华为银行",
                        "id": 212709
                    }, {
                        "name": "东莞快手医院",
                        "id": 212710
                    }, {
                        "name": "杭州快手",
                        "id": 212711
                    }, {
                        "name": "台北微软旅游有限公司",
                        "id": 212712
                    }, {
                        "name": "台北谷歌互金控股集团",
                        "id": 212713
                    }, {
                        "name": "广州谷歌新能源",
                        "id": 212714
                    }, {
                        "name": "杭州亚马逊石油",
                        "id": 212715
                    }, {
                        "name": "北京瑞幸基金",
                        "id": 212716
                    }, {
                        "name": "香港字节地摊",
                        "id": 212717
                    }]
                }, {
                    "name": "东京欧珀旅游",
                    "id": 212718
                }, {
                    "name": "首尔特斯拉医药",
                    "id": 212719
                }, {
                    "name": "南京阿里诊所",
                    "id": 212720
                }, {
                    "name": "天津阿里",
                    "id": 212721
                }, {
                    "name": "北京瑞幸地摊控股集团",
                    "id": 212722
                }, {
                    "name": "纽约京东旅游",
                    "id": 212723,
                    "children": [{
                        "name": "首尔肯德基金融",
                        "id": 212724
                    }, {
                        "name": "上海美团科技",
                        "id": 212725
                    }, {
                        "name": "台北谷歌基金",
                        "id": 212726
                    }, {
                        "name": "东莞肯德基信息服务控股集团",
                        "id": 212727
                    }, {
                        "name": "杭州腾讯新能源",
                        "id": 212728
                    }, {
                        "name": "台北瑞幸牧业有限公司",
                        "id": 212729
                    }, {
                        "name": "广州蚂蚁地摊",
                        "id": 212730
                    }, {
                        "name": "上海苹果通信控股集团",
                        "id": 212731
                    }, {
                        "name": "南京蚂蚁通信",
                        "id": 212732
                    }, {
                        "name": "台北滴滴汽车",
                        "id": 212733
                    }, {
                        "name": "厦门华为养殖有限公司",
                        "id": 212734
                    }, {
                        "name": "南京快手芯片",
                        "id": 212735
                    }, {
                        "name": "东京快手信息服务",
                        "id": 212736
                    }, {
                        "name": "深圳滴滴通信",
                        "id": 212737
                    }, {
                        "name": "北京美团地摊",
                        "id": 212738
                    }, {
                        "name": "东莞奈雪旅游有限公司",
                        "id": 212739
                    }, {
                        "name": "厦门亚马逊医院控股集团",
                        "id": 212740
                    }, {
                        "name": "杭州小米科技",
                        "id": 212741
                    }, {
                        "name": "天津肯德基芯片",
                        "id": 212742
                    }, {
                        "name": "广州京东汽车控股集团",
                        "id": 212743
                    }, {
                        "name": "首尔瑞幸软件控股集团",
                        "id": 212744
                    }]
                }, {
                    "name": "杭州字节芯片有限公司",
                    "id": 212745,
                    "children": [{
                        "name": "香港滴滴银行有限公司",
                        "id": 212746
                    }, {
                        "name": "广州奈雪电商控股集团",
                        "id": 212747
                    }, {
                        "name": "首尔肯德基牧业",
                        "id": 212748
                    }, {
                        "name": "上海欧珀制造有限公司",
                        "id": 212749
                    }, {
                        "name": "上海欧珀医院",
                        "id": 212750
                    }, {
                        "name": "广州蚂蚁医药",
                        "id": 212751
                    }, {
                        "name": "厦门奈雪养殖",
                        "id": 212752
                    }, {
                        "name": "纽约字节旅游",
                        "id": 212753
                    }, {
                        "name": "北京微软渔业",
                        "id": 212754
                    }, {
                        "name": "东京滴滴地摊",
                        "id": 212755
                    }, {
                        "name": "杭州星巴克软件",
                        "id": 212756
                    }]
                }, {
                    "name": "厦门腾讯制造控股集团",
                    "id": 212757
                }, {
                    "name": "东京字节通信控股集团",
                    "id": 212758
                }, {
                    "name": "首尔特斯拉信息服务",
                    "id": 212759
                }, {
                    "name": "香港美团信息服务",
                    "id": 212760
                }, {
                    "name": "杭州瑞幸计算机",
                    "id": 212761
                }, {
                    "name": "杭州必胜客信息服务控股集团",
                    "id": 212762
                }, {
                    "name": "南京星巴克信息服务",
                    "id": 212763
                }, {
                    "name": "北京百度互金",
                    "id": 212764
                }, {
                    "name": "厦门必胜客控股集团",
                    "id": 212765
                }, {
                    "name": "上海瑞幸旅游",
                    "id": 212766
                }, {
                    "name": "纽约字节芯片",
                    "id": 212767,
                    "children": [{
                        "name": "深圳快手互金",
                        "id": 212768
                    }, {
                        "name": "天津谷歌计算机有限公司",
                        "id": 212769
                    }, {
                        "name": "厦门京东电商",
                        "id": 212770
                    }, {
                        "name": "台北华为通信控股集团",
                        "id": 212771
                    }, {
                        "name": "天津字节",
                        "id": 212772
                    }, {
                        "name": "纽约谷歌芯片有限公司",
                        "id": 212773
                    }, {
                        "name": "首尔腾讯",
                        "id": 212774
                    }, {
                        "name": "纽约字节证券",
                        "id": 212775
                    }, {
                        "name": "南京微软科技",
                        "id": 212776
                    }, {
                        "name": "上海特斯拉有限公司",
                        "id": 212777
                    }, {
                        "name": "东京平安通信",
                        "id": 212778
                    }, {
                        "name": "上海华为科技",
                        "id": 212779
                    }, {
                        "name": "杭州瑞幸",
                        "id": 212780
                    }, {
                        "name": "东京谷歌银行",
                        "id": 212781
                    }, {
                        "name": "上海快手石油",
                        "id": 212782
                    }, {
                        "name": "天津美团软件控股集团",
                        "id": 212783
                    }, {
                        "name": "南京美团石油",
                        "id": 212784
                    }, {
                        "name": "东莞百度证券",
                        "id": 212785
                    }, {
                        "name": "纽约肯德基证券有限公司",
                        "id": 212786
                    }, {
                        "name": "杭州亚马逊通信控股集团",
                        "id": 212787
                    }, {
                        "name": "厦门蚂蚁养殖控股集团",
                        "id": 212788
                    }, {
                        "name": "杭州奈雪牧业",
                        "id": 212789
                    }, {
                        "name": "首尔快手软件",
                        "id": 212790
                    }, {
                        "name": "杭州喜茶地摊有限公司",
                        "id": 212791
                    }, {
                        "name": "上海苹果银行有限公司",
                        "id": 212792
                    }, {
                        "name": "东京特斯拉科技有限公司",
                        "id": 212793
                    }, {
                        "name": "天津小米餐饮",
                        "id": 212794
                    }, {
                        "name": "深圳苹果基金有限公司",
                        "id": 212795
                    }, {
                        "name": "天津特斯拉餐饮",
                        "id": 212796
                    }, {
                        "name": "深圳百度通讯控股集团",
                        "id": 212797
                    }]
                }]
            }, {
                "name": "首尔百度通讯",
                "id": 212798,
                "children": [{
                    "name": "纽约奈雪金融",
                    "id": 212799,
                    "children": [{
                        "name": "北京亚马逊证券",
                        "id": 212800
                    }, {
                        "name": "北京快手制造",
                        "id": 212801
                    }, {
                        "name": "东莞肯德基电商",
                        "id": 212802
                    }, {
                        "name": "首尔星巴克医院",
                        "id": 212803
                    }, {
                        "name": "厦门蚂蚁银行",
                        "id": 212804
                    }, {
                        "name": "南京欧珀航空有限公司",
                        "id": 212805
                    }, {
                        "name": "东京谷歌航空控股集团",
                        "id": 212806
                    }, {
                        "name": "天津平安医药",
                        "id": 212807
                    }, {
                        "name": "东莞腾讯牧业",
                        "id": 212808
                    }, {
                        "name": "首尔滴滴制造有限公司",
                        "id": 212809
                    }]
                }, {
                    "name": "杭州腾讯通讯",
                    "id": 212810,
                    "children": [{
                        "name": "东京百度芯片控股集团",
                        "id": 212811
                    }, {
                        "name": "东京滴滴互金",
                        "id": 212812
                    }, {
                        "name": "广州星巴克芯片控股集团",
                        "id": 212813
                    }, {
                        "name": "香港特斯拉农业",
                        "id": 212814
                    }, {
                        "name": "纽约苹果计算机控股集团",
                        "id": 212815
                    }, {
                        "name": "北京奈雪汽车",
                        "id": 212816
                    }, {
                        "name": "南京微软互金控股集团",
                        "id": 212817
                    }, {
                        "name": "台北微软石油",
                        "id": 212818
                    }, {
                        "name": "首尔美团诊所",
                        "id": 212819
                    }, {
                        "name": "上海苹果新能源控股集团",
                        "id": 212820
                    }]
                }, {
                    "name": "杭州小米互金",
                    "id": 212821
                }, {
                    "name": "深圳喜茶计算机",
                    "id": 212822,
                    "children": [{
                        "name": "首尔特斯拉",
                        "id": 212823
                    }, {
                        "name": "上海字节信息服务",
                        "id": 212824
                    }, {
                        "name": "纽约蚂蚁基金",
                        "id": 212825
                    }, {
                        "name": "香港苹果诊所控股集团",
                        "id": 212826
                    }, {
                        "name": "厦门京东互金",
                        "id": 212827
                    }, {
                        "name": "深圳谷歌新能源控股集团",
                        "id": 212828
                    }, {
                        "name": "东莞字节芯片有限公司",
                        "id": 212829
                    }, {
                        "name": "南京小米信息服务有限公司",
                        "id": 212830
                    }, {
                        "name": "北京阿里信息服务",
                        "id": 212831
                    }, {
                        "name": "东京腾讯软件",
                        "id": 212832
                    }, {
                        "name": "东莞快手石油",
                        "id": 212833
                    }, {
                        "name": "台北瑞幸农业控股集团",
                        "id": 212834
                    }, {
                        "name": "东莞腾讯软件",
                        "id": 212835
                    }, {
                        "name": "南京快手医药控股集团",
                        "id": 212836
                    }, {
                        "name": "纽约字节科技控股集团",
                        "id": 212837
                    }, {
                        "name": "广州瑞幸芯片",
                        "id": 212838
                    }, {
                        "name": "香港腾讯通信",
                        "id": 212839
                    }, {
                        "name": "东京喜茶",
                        "id": 212840
                    }, {
                        "name": "台北亚马逊互金",
                        "id": 212841
                    }, {
                        "name": "东莞苹果餐饮",
                        "id": 212842
                    }, {
                        "name": "东莞肯德基互金有限公司",
                        "id": 212843
                    }, {
                        "name": "东莞平安智能有限公司",
                        "id": 212844
                    }, {
                        "name": "台北华为基金",
                        "id": 212845
                    }, {
                        "name": "厦门奈雪制造",
                        "id": 212846
                    }, {
                        "name": "南京阿里新能源有限公司",
                        "id": 212847
                    }, {
                        "name": "杭州滴滴地摊控股集团",
                        "id": 212848
                    }, {
                        "name": "南京喜茶餐饮",
                        "id": 212849
                    }, {
                        "name": "北京星巴克通讯",
                        "id": 212850
                    }, {
                        "name": "香港特斯拉基金",
                        "id": 212851
                    }]
                }, {
                    "name": "深圳肯德基渔业",
                    "id": 212852
                }, {
                    "name": "天津瑞幸芯片",
                    "id": 212853,
                    "children": [{
                        "name": "首尔美团电商控股集团",
                        "id": 212854
                    }, {
                        "name": "纽约瑞幸牧业",
                        "id": 212855
                    }, {
                        "name": "广州腾讯软件",
                        "id": 212856
                    }, {
                        "name": "上海阿里通信有限公司",
                        "id": 212857
                    }, {
                        "name": "广州欧珀智能",
                        "id": 212858
                    }, {
                        "name": "北京字节信息服务",
                        "id": 212859
                    }, {
                        "name": "香港微软控股集团",
                        "id": 212860
                    }, {
                        "name": "北京百度养殖控股集团",
                        "id": 212861
                    }, {
                        "name": "天津华为软件",
                        "id": 212862
                    }, {
                        "name": "东京腾讯芯片",
                        "id": 212863
                    }, {
                        "name": "南京喜茶金融",
                        "id": 212864
                    }, {
                        "name": "天津瑞幸银行",
                        "id": 212865
                    }, {
                        "name": "东莞星巴克医院控股集团",
                        "id": 212866
                    }, {
                        "name": "香港小米计算机",
                        "id": 212867
                    }, {
                        "name": "南京美团新能源",
                        "id": 212868
                    }, {
                        "name": "东京欧珀诊所控股集团",
                        "id": 212869
                    }, {
                        "name": "厦门小米养殖",
                        "id": 212870
                    }]
                }, {
                    "name": "广州百度有限公司",
                    "id": 212871
                }, {
                    "name": "纽约百度通讯有限公司",
                    "id": 212872
                }, {
                    "name": "杭州滴滴计算机有限公司",
                    "id": 212873
                }, {
                    "name": "东京滴滴餐饮控股集团",
                    "id": 212874
                }, {
                    "name": "天津特斯拉电商",
                    "id": 212875
                }, {
                    "name": "香港瑞幸餐饮有限公司",
                    "id": 212876,
                    "children": [{
                        "name": "首尔特斯拉养殖",
                        "id": 212877
                    }, {
                        "name": "天津肯德基金融",
                        "id": 212878
                    }, {
                        "name": "天津欧珀牧业",
                        "id": 212879
                    }, {
                        "name": "上海谷歌地摊",
                        "id": 212880
                    }, {
                        "name": "纽约美团制造",
                        "id": 212881
                    }, {
                        "name": "首尔京东",
                        "id": 212882
                    }, {
                        "name": "杭州星巴克通讯",
                        "id": 212883
                    }, {
                        "name": "杭州阿里电商有限公司",
                        "id": 212884
                    }, {
                        "name": "北京阿里医院",
                        "id": 212885
                    }, {
                        "name": "上海美团银行",
                        "id": 212886
                    }, {
                        "name": "厦门字节医药",
                        "id": 212887
                    }, {
                        "name": "厦门京东有限公司",
                        "id": 212888
                    }, {
                        "name": "深圳肯德基",
                        "id": 212889
                    }, {
                        "name": "首尔百度农业",
                        "id": 212890
                    }, {
                        "name": "深圳字节证券控股集团",
                        "id": 212891
                    }, {
                        "name": "香港肯德基有限公司",
                        "id": 212892
                    }, {
                        "name": "香港京东农业",
                        "id": 212893
                    }, {
                        "name": "杭州喜茶计算机控股集团",
                        "id": 212894
                    }, {
                        "name": "深圳奈雪软件",
                        "id": 212895
                    }]
                }, {
                    "name": "纽约滴滴养殖",
                    "id": 212896
                }]
            }, {
                "name": "北京腾讯旅游",
                "id": 212897,
                "children": [{
                    "name": "台北京东地摊",
                    "id": 212898
                }, {
                    "name": "天津小米芯片",
                    "id": 212899
                }, {
                    "name": "深圳腾讯牧业",
                    "id": 212900
                }, {
                    "name": "首尔瑞幸证券",
                    "id": 212901
                }, {
                    "name": "上海蚂蚁旅游",
                    "id": 212902
                }, {
                    "name": "北京特斯拉汽车",
                    "id": 212903
                }, {
                    "name": "香港滴滴通信",
                    "id": 212904
                }, {
                    "name": "首尔亚马逊诊所",
                    "id": 212905
                }, {
                    "name": "深圳蚂蚁石油",
                    "id": 212906
                }, {
                    "name": "天津微软信息服务",
                    "id": 212907
                }, {
                    "name": "首尔华为餐饮",
                    "id": 212908
                }, {
                    "name": "上海字节电商",
                    "id": 212909,
                    "children": [{
                        "name": "广州阿里证券",
                        "id": 212910
                    }, {
                        "name": "杭州星巴克养殖有限公司",
                        "id": 212911
                    }, {
                        "name": "台北滴滴通信",
                        "id": 212912
                    }, {
                        "name": "厦门美团科技",
                        "id": 212913
                    }, {
                        "name": "纽约奈雪石油",
                        "id": 212914
                    }, {
                        "name": "天津字节控股集团",
                        "id": 212915
                    }, {
                        "name": "杭州快手通讯",
                        "id": 212916
                    }, {
                        "name": "首尔奈雪计算机",
                        "id": 212917
                    }, {
                        "name": "上海美团新能源",
                        "id": 212918
                    }, {
                        "name": "广州特斯拉通信有限公司",
                        "id": 212919
                    }, {
                        "name": "深圳欧珀",
                        "id": 212920
                    }, {
                        "name": "杭州美团金融",
                        "id": 212921
                    }, {
                        "name": "厦门瑞幸医院有限公司",
                        "id": 212922
                    }, {
                        "name": "杭州星巴克电商",
                        "id": 212923
                    }, {
                        "name": "上海字节互金",
                        "id": 212924
                    }, {
                        "name": "厦门奈雪渔业",
                        "id": 212925
                    }, {
                        "name": "杭州必胜客旅游",
                        "id": 212926
                    }, {
                        "name": "东京谷歌证券有限公司",
                        "id": 212927
                    }, {
                        "name": "南京必胜客通讯",
                        "id": 212928
                    }, {
                        "name": "东莞快手旅游有限公司",
                        "id": 212929
                    }, {
                        "name": "深圳平安金融",
                        "id": 212930
                    }, {
                        "name": "东莞华为制造控股集团",
                        "id": 212931
                    }]
                }, {
                    "name": "东莞谷歌电商控股集团",
                    "id": 212932
                }, {
                    "name": "北京亚马逊科技",
                    "id": 212933
                }, {
                    "name": "香港奈雪芯片",
                    "id": 212934
                }, {
                    "name": "首尔欧珀基金",
                    "id": 212935
                }, {
                    "name": "北京奈雪农业",
                    "id": 212936
                }, {
                    "name": "东莞美团航空有限公司",
                    "id": 212937,
                    "children": [{
                        "name": "厦门滴滴汽车",
                        "id": 212938
                    }, {
                        "name": "南京美团银行",
                        "id": 212939
                    }, {
                        "name": "东莞欧珀汽车",
                        "id": 212940
                    }, {
                        "name": "广州肯德基银行",
                        "id": 212941
                    }, {
                        "name": "上海微软航空有限公司",
                        "id": 212942
                    }, {
                        "name": "首尔喜茶芯片控股集团",
                        "id": 212943
                    }, {
                        "name": "首尔美团通讯",
                        "id": 212944
                    }, {
                        "name": "杭州蚂蚁软件",
                        "id": 212945
                    }, {
                        "name": "东京微软石油",
                        "id": 212946
                    }, {
                        "name": "杭州瑞幸",
                        "id": 212947
                    }, {
                        "name": "天津快手有限公司",
                        "id": 212948
                    }, {
                        "name": "台北喜茶银行",
                        "id": 212949
                    }, {
                        "name": "纽约京东电商控股集团",
                        "id": 212950
                    }, {
                        "name": "东莞苹果汽车有限公司",
                        "id": 212951
                    }, {
                        "name": "杭州肯德基牧业",
                        "id": 212952
                    }, {
                        "name": "天津平安餐饮",
                        "id": 212953
                    }, {
                        "name": "香港瑞幸芯片控股集团",
                        "id": 212954
                    }, {
                        "name": "上海美团渔业控股集团",
                        "id": 212955
                    }, {
                        "name": "台北亚马逊地摊",
                        "id": 212956
                    }, {
                        "name": "厦门特斯拉渔业",
                        "id": 212957
                    }, {
                        "name": "杭州瑞幸牧业控股集团",
                        "id": 212958
                    }, {
                        "name": "厦门京东旅游",
                        "id": 212959
                    }, {
                        "name": "南京喜茶通信",
                        "id": 212960
                    }, {
                        "name": "杭州必胜客制造",
                        "id": 212961
                    }, {
                        "name": "杭州平安旅游",
                        "id": 212962
                    }, {
                        "name": "南京瑞幸证券",
                        "id": 212963
                    }, {
                        "name": "南京微软有限公司",
                        "id": 212964
                    }, {
                        "name": "首尔肯德基证券有限公司",
                        "id": 212965
                    }, {
                        "name": "深圳字节新能源",
                        "id": 212966
                    }, {
                        "name": "北京小米医院有限公司",
                        "id": 212967
                    }, {
                        "name": "台北京东银行",
                        "id": 212968
                    }, {
                        "name": "广州喜茶石油",
                        "id": 212969
                    }, {
                        "name": "首尔奈雪",
                        "id": 212970
                    }, {
                        "name": "东京字节电商",
                        "id": 212971
                    }]
                }, {
                    "name": "广州奈雪旅游",
                    "id": 212972
                }]
            }, {
                "name": "厦门腾讯航空",
                "id": 212973
            }, {
                "name": "纽约微软地产",
                "id": 212974
            }, {
                "name": "厦门字节航空",
                "id": 212975
            }, {
                "name": "纽约阿里石油有限公司",
                "id": 212976
            }, {
                "name": "南京欧珀通信",
                "id": 212977
            }]
        }, {
            "name": "南京星巴克互金",
            "id": 212978,
            "children": [{
                "name": "杭州蚂蚁医药",
                "id": 212979
            }, {
                "name": "北京快手证券控股集团",
                "id": 212980
            }, {
                "name": "杭州特斯拉控股集团",
                "id": 212981
            }, {
                "name": "杭州必胜客互金有限公司",
                "id": 212982
            }, {
                "name": "天津字节地摊",
                "id": 212983
            }, {
                "name": "东京星巴克旅游控股集团",
                "id": 212984
            }, {
                "name": "香港微软养殖",
                "id": 212985
            }, {
                "name": "首尔阿里计算机",
                "id": 212986,
                "children": [{
                    "name": "上海平安地产",
                    "id": 212987
                }, {
                    "name": "天津奈雪医药",
                    "id": 212988
                }, {
                    "name": "广州瑞幸",
                    "id": 212989
                }, {
                    "name": "南京苹果牧业有限公司",
                    "id": 212990
                }, {
                    "name": "东莞字节芯片",
                    "id": 212991
                }, {
                    "name": "台北亚马逊诊所有限公司",
                    "id": 212992,
                    "children": [{
                        "name": "南京谷歌医院",
                        "id": 212993
                    }, {
                        "name": "杭州亚马逊石油",
                        "id": 212994
                    }, {
                        "name": "南京小米金融",
                        "id": 212995
                    }, {
                        "name": "杭州美团",
                        "id": 212996
                    }, {
                        "name": "厦门奈雪",
                        "id": 212997
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 212998
                    }, {
                        "name": "北京肯德基汽车有限公司",
                        "id": 212999
                    }, {
                        "name": "香港百度智能",
                        "id": 213000
                    }, {
                        "name": "东京京东证券有限公司",
                        "id": 213001
                    }, {
                        "name": "杭州瑞幸软件控股集团",
                        "id": 213002
                    }, {
                        "name": "杭州字节智能",
                        "id": 213003
                    }, {
                        "name": "纽约亚马逊互金有限公司",
                        "id": 213004
                    }, {
                        "name": "东莞滴滴电商",
                        "id": 213005
                    }, {
                        "name": "北京腾讯地摊",
                        "id": 213006
                    }, {
                        "name": "上海阿里通讯控股集团",
                        "id": 213007
                    }, {
                        "name": "广州肯德基互金",
                        "id": 213008
                    }, {
                        "name": "首尔肯德基石油",
                        "id": 213009
                    }, {
                        "name": "北京阿里旅游有限公司",
                        "id": 213010
                    }, {
                        "name": "杭州奈雪金融",
                        "id": 213011
                    }]
                }, {
                    "name": "杭州滴滴农业",
                    "id": 213012
                }, {
                    "name": "杭州小米餐饮",
                    "id": 213013
                }, {
                    "name": "东京字节科技控股集团",
                    "id": 213014
                }, {
                    "name": "深圳华为新能源",
                    "id": 213015
                }, {
                    "name": "天津字节地摊",
                    "id": 213016,
                    "children": [{
                        "name": "厦门平安养殖",
                        "id": 213017
                    }, {
                        "name": "香港星巴克牧业",
                        "id": 213018
                    }, {
                        "name": "天津谷歌地产控股集团",
                        "id": 213019
                    }, {
                        "name": "南京华为通讯有限公司",
                        "id": 213020
                    }, {
                        "name": "杭州京东基金控股集团",
                        "id": 213021
                    }, {
                        "name": "纽约喜茶汽车",
                        "id": 213022
                    }, {
                        "name": "首尔美团旅游控股集团",
                        "id": 213023
                    }, {
                        "name": "杭州肯德基基金控股集团",
                        "id": 213024
                    }, {
                        "name": "杭州瑞幸控股集团",
                        "id": 213025
                    }, {
                        "name": "台北美团牧业有限公司",
                        "id": 213026
                    }, {
                        "name": "东莞欧珀控股集团",
                        "id": 213027
                    }, {
                        "name": "杭州腾讯石油",
                        "id": 213028
                    }, {
                        "name": "深圳特斯拉证券",
                        "id": 213029
                    }, {
                        "name": "天津腾讯诊所",
                        "id": 213030
                    }, {
                        "name": "香港奈雪地产控股集团",
                        "id": 213031
                    }, {
                        "name": "上海滴滴石油",
                        "id": 213032
                    }, {
                        "name": "上海腾讯地摊控股集团",
                        "id": 213033
                    }, {
                        "name": "广州欧珀芯片有限公司",
                        "id": 213034
                    }, {
                        "name": "首尔谷歌牧业",
                        "id": 213035
                    }, {
                        "name": "北京京东渔业控股集团",
                        "id": 213036
                    }, {
                        "name": "东莞瑞幸金融",
                        "id": 213037
                    }, {
                        "name": "上海京东石油",
                        "id": 213038
                    }, {
                        "name": "深圳华为信息服务",
                        "id": 213039
                    }, {
                        "name": "香港必胜客通信",
                        "id": 213040
                    }, {
                        "name": "广州京东",
                        "id": 213041
                    }, {
                        "name": "厦门滴滴旅游控股集团",
                        "id": 213042
                    }, {
                        "name": "北京字节电商有限公司",
                        "id": 213043
                    }, {
                        "name": "杭州亚马逊软件",
                        "id": 213044
                    }, {
                        "name": "台北京东科技有限公司",
                        "id": 213045
                    }, {
                        "name": "杭州奈雪餐饮",
                        "id": 213046
                    }, {
                        "name": "首尔华为牧业有限公司",
                        "id": 213047
                    }, {
                        "name": "东莞喜茶计算机有限公司",
                        "id": 213048
                    }, {
                        "name": "台北百度石油控股集团",
                        "id": 213049
                    }, {
                        "name": "纽约奈雪控股集团",
                        "id": 213050
                    }, {
                        "name": "北京苹果地摊有限公司",
                        "id": 213051
                    }, {
                        "name": "北京滴滴电商控股集团",
                        "id": 213052
                    }]
                }, {
                    "name": "广州欧珀软件",
                    "id": 213053,
                    "children": [{
                        "name": "杭州阿里信息服务控股集团",
                        "id": 213054
                    }, {
                        "name": "东京百度医药有限公司",
                        "id": 213055
                    }, {
                        "name": "东莞星巴克",
                        "id": 213056
                    }, {
                        "name": "深圳平安控股集团",
                        "id": 213057
                    }, {
                        "name": "深圳喜茶基金有限公司",
                        "id": 213058
                    }, {
                        "name": "深圳蚂蚁石油",
                        "id": 213059
                    }, {
                        "name": "台北阿里银行有限公司",
                        "id": 213060
                    }, {
                        "name": "首尔瑞幸汽车",
                        "id": 213061
                    }, {
                        "name": "厦门微软基金控股集团",
                        "id": 213062
                    }, {
                        "name": "杭州奈雪地摊",
                        "id": 213063
                    }, {
                        "name": "香港微软石油",
                        "id": 213064
                    }, {
                        "name": "天津滴滴计算机",
                        "id": 213065
                    }, {
                        "name": "上海蚂蚁旅游控股集团",
                        "id": 213066
                    }, {
                        "name": "香港苹果互金",
                        "id": 213067
                    }, {
                        "name": "北京百度证券",
                        "id": 213068
                    }, {
                        "name": "首尔谷歌金融有限公司",
                        "id": 213069
                    }, {
                        "name": "香港喜茶控股集团",
                        "id": 213070
                    }, {
                        "name": "天津美团有限公司",
                        "id": 213071
                    }, {
                        "name": "天津小米汽车有限公司",
                        "id": 213072
                    }, {
                        "name": "台北字节",
                        "id": 213073
                    }, {
                        "name": "深圳腾讯计算机有限公司",
                        "id": 213074
                    }, {
                        "name": "北京瑞幸",
                        "id": 213075
                    }, {
                        "name": "纽约京东控股集团",
                        "id": 213076
                    }, {
                        "name": "北京小米信息服务有限公司",
                        "id": 213077
                    }, {
                        "name": "香港滴滴互金有限公司",
                        "id": 213078
                    }, {
                        "name": "广州华为农业",
                        "id": 213079
                    }, {
                        "name": "广州快手",
                        "id": 213080
                    }, {
                        "name": "香港星巴克银行",
                        "id": 213081
                    }, {
                        "name": "香港微软",
                        "id": 213082
                    }, {
                        "name": "南京谷歌渔业有限公司",
                        "id": 213083
                    }]
                }, {
                    "name": "天津华为渔业",
                    "id": 213084
                }, {
                    "name": "天津快手金融",
                    "id": 213085,
                    "children": [{
                        "name": "天津京东软件",
                        "id": 213086
                    }, {
                        "name": "上海平安养殖",
                        "id": 213087
                    }, {
                        "name": "首尔谷歌牧业有限公司",
                        "id": 213088
                    }]
                }, {
                    "name": "天津阿里牧业",
                    "id": 213089
                }, {
                    "name": "台北微软科技控股集团",
                    "id": 213090
                }, {
                    "name": "北京喜茶通讯",
                    "id": 213091
                }, {
                    "name": "深圳百度地产",
                    "id": 213092
                }, {
                    "name": "东京特斯拉地产",
                    "id": 213093
                }, {
                    "name": "纽约京东制造",
                    "id": 213094,
                    "children": [{
                        "name": "杭州谷歌餐饮",
                        "id": 213095
                    }, {
                        "name": "广州谷歌通讯",
                        "id": 213096
                    }, {
                        "name": "杭州微软通讯控股集团",
                        "id": 213097
                    }, {
                        "name": "上海平安芯片",
                        "id": 213098
                    }, {
                        "name": "广州百度芯片控股集团",
                        "id": 213099
                    }, {
                        "name": "南京百度旅游",
                        "id": 213100
                    }, {
                        "name": "广州美团新能源有限公司",
                        "id": 213101
                    }, {
                        "name": "台北必胜客基金",
                        "id": 213102
                    }, {
                        "name": "香港平安芯片",
                        "id": 213103
                    }, {
                        "name": "首尔特斯拉餐饮",
                        "id": 213104
                    }, {
                        "name": "广州蚂蚁石油",
                        "id": 213105
                    }, {
                        "name": "广州滴滴金融",
                        "id": 213106
                    }, {
                        "name": "首尔星巴克",
                        "id": 213107
                    }, {
                        "name": "上海快手医药有限公司",
                        "id": 213108
                    }]
                }, {
                    "name": "杭州肯德基制造有限公司",
                    "id": 213109
                }]
            }, {
                "name": "东京快手控股集团",
                "id": 213110
            }, {
                "name": "南京小米电商",
                "id": 213111
            }, {
                "name": "南京欧珀软件",
                "id": 213112,
                "children": [{
                    "name": "上海京东证券控股集团",
                    "id": 213113
                }, {
                    "name": "南京亚马逊",
                    "id": 213114
                }, {
                    "name": "北京京东智能控股集团",
                    "id": 213115
                }, {
                    "name": "纽约平安金融有限公司",
                    "id": 213116,
                    "children": [{
                        "name": "香港谷歌软件控股集团",
                        "id": 213117
                    }]
                }, {
                    "name": "南京滴滴地摊有限公司",
                    "id": 213118
                }, {
                    "name": "香港谷歌新能源",
                    "id": 213119,
                    "children": [{
                        "name": "台北必胜客汽车有限公司",
                        "id": 213120
                    }, {
                        "name": "纽约小米新能源",
                        "id": 213121
                    }, {
                        "name": "纽约小米智能有限公司",
                        "id": 213122
                    }, {
                        "name": "台北苹果地产",
                        "id": 213123
                    }, {
                        "name": "天津百度航空",
                        "id": 213124
                    }, {
                        "name": "台北微软医药有限公司",
                        "id": 213125
                    }, {
                        "name": "广州平安有限公司",
                        "id": 213126
                    }, {
                        "name": "香港瑞幸软件",
                        "id": 213127
                    }, {
                        "name": "东莞快手",
                        "id": 213128
                    }, {
                        "name": "北京特斯拉汽车",
                        "id": 213129
                    }, {
                        "name": "天津奈雪航空有限公司",
                        "id": 213130
                    }, {
                        "name": "厦门肯德基信息服务",
                        "id": 213131
                    }, {
                        "name": "东京谷歌通讯",
                        "id": 213132
                    }, {
                        "name": "杭州微软证券",
                        "id": 213133
                    }, {
                        "name": "北京欧珀",
                        "id": 213134
                    }, {
                        "name": "深圳星巴克航空",
                        "id": 213135
                    }, {
                        "name": "东莞腾讯石油",
                        "id": 213136
                    }, {
                        "name": "东莞腾讯基金有限公司",
                        "id": 213137
                    }, {
                        "name": "东京小米科技",
                        "id": 213138
                    }, {
                        "name": "上海阿里医院",
                        "id": 213139
                    }, {
                        "name": "香港滴滴信息服务控股集团",
                        "id": 213140
                    }, {
                        "name": "杭州蚂蚁互金",
                        "id": 213141
                    }, {
                        "name": "深圳快手新能源",
                        "id": 213142
                    }, {
                        "name": "台北华为金融控股集团",
                        "id": 213143
                    }, {
                        "name": "东莞喜茶医院",
                        "id": 213144
                    }, {
                        "name": "南京苹果信息服务",
                        "id": 213145
                    }, {
                        "name": "首尔微软计算机有限公司",
                        "id": 213146
                    }, {
                        "name": "北京蚂蚁医院",
                        "id": 213147
                    }, {
                        "name": "杭州华为养殖",
                        "id": 213148
                    }, {
                        "name": "广州蚂蚁诊所有限公司",
                        "id": 213149
                    }, {
                        "name": "东莞平安信息服务控股集团",
                        "id": 213150
                    }, {
                        "name": "香港平安渔业",
                        "id": 213151
                    }, {
                        "name": "杭州平安电商",
                        "id": 213152
                    }, {
                        "name": "深圳肯德基汽车",
                        "id": 213153
                    }]
                }, {
                    "name": "厦门欧珀通信控股集团",
                    "id": 213154
                }, {
                    "name": "香港奈雪餐饮控股集团",
                    "id": 213155
                }, {
                    "name": "深圳腾讯电商",
                    "id": 213156,
                    "children": [{
                        "name": "天津瑞幸电商",
                        "id": 213157
                    }, {
                        "name": "南京平安计算机",
                        "id": 213158
                    }, {
                        "name": "杭州京东软件",
                        "id": 213159
                    }, {
                        "name": "深圳微软渔业",
                        "id": 213160
                    }, {
                        "name": "杭州肯德基银行有限公司",
                        "id": 213161
                    }, {
                        "name": "天津奈雪智能控股集团",
                        "id": 213162
                    }, {
                        "name": "首尔快手有限公司",
                        "id": 213163
                    }, {
                        "name": "厦门小米基金",
                        "id": 213164
                    }, {
                        "name": "台北谷歌诊所",
                        "id": 213165
                    }, {
                        "name": "首尔瑞幸医院",
                        "id": 213166
                    }, {
                        "name": "深圳字节农业",
                        "id": 213167
                    }, {
                        "name": "广州腾讯养殖有限公司",
                        "id": 213168
                    }, {
                        "name": "广州喜茶牧业控股集团",
                        "id": 213169
                    }, {
                        "name": "上海美团",
                        "id": 213170
                    }, {
                        "name": "东莞京东金融",
                        "id": 213171
                    }, {
                        "name": "天津瑞幸软件",
                        "id": 213172
                    }, {
                        "name": "南京必胜客航空控股集团",
                        "id": 213173
                    }, {
                        "name": "杭州平安计算机",
                        "id": 213174
                    }, {
                        "name": "纽约必胜客养殖有限公司",
                        "id": 213175
                    }, {
                        "name": "纽约京东通讯",
                        "id": 213176
                    }, {
                        "name": "深圳快手养殖有限公司",
                        "id": 213177
                    }, {
                        "name": "香港必胜客新能源",
                        "id": 213178
                    }, {
                        "name": "杭州阿里芯片控股集团",
                        "id": 213179
                    }]
                }, {
                    "name": "杭州华为芯片控股集团",
                    "id": 213180,
                    "children": [{
                        "name": "东莞滴滴芯片",
                        "id": 213181
                    }, {
                        "name": "杭州亚马逊地摊",
                        "id": 213182
                    }, {
                        "name": "上海苹果通讯",
                        "id": 213183
                    }, {
                        "name": "东莞快手医药",
                        "id": 213184
                    }, {
                        "name": "厦门奈雪",
                        "id": 213185
                    }, {
                        "name": "香港腾讯",
                        "id": 213186
                    }, {
                        "name": "杭州奈雪科技",
                        "id": 213187
                    }, {
                        "name": "南京腾讯航空",
                        "id": 213188
                    }, {
                        "name": "台北腾讯金融有限公司",
                        "id": 213189
                    }, {
                        "name": "东京小米电商有限公司",
                        "id": 213190
                    }, {
                        "name": "北京喜茶银行",
                        "id": 213191
                    }, {
                        "name": "上海滴滴金融",
                        "id": 213192
                    }, {
                        "name": "纽约蚂蚁控股集团",
                        "id": 213193
                    }, {
                        "name": "杭州快手石油",
                        "id": 213194
                    }, {
                        "name": "广州小米渔业",
                        "id": 213195
                    }, {
                        "name": "北京小米农业",
                        "id": 213196
                    }, {
                        "name": "台北肯德基地产",
                        "id": 213197
                    }, {
                        "name": "深圳亚马逊农业",
                        "id": 213198
                    }, {
                        "name": "天津小米新能源",
                        "id": 213199
                    }, {
                        "name": "广州微软地产",
                        "id": 213200
                    }, {
                        "name": "香港亚马逊软件",
                        "id": 213201
                    }, {
                        "name": "杭州谷歌航空",
                        "id": 213202
                    }, {
                        "name": "深圳必胜客证券控股集团",
                        "id": 213203
                    }, {
                        "name": "南京苹果科技",
                        "id": 213204
                    }, {
                        "name": "杭州美团信息服务",
                        "id": 213205
                    }, {
                        "name": "广州谷歌医院",
                        "id": 213206
                    }, {
                        "name": "深圳小米计算机",
                        "id": 213207
                    }, {
                        "name": "纽约亚马逊汽车控股集团",
                        "id": 213208
                    }]
                }, {
                    "name": "首尔特斯拉软件",
                    "id": 213209
                }, {
                    "name": "杭州奈雪石油",
                    "id": 213210,
                    "children": [{
                        "name": "东莞苹果制造",
                        "id": 213211
                    }, {
                        "name": "东莞苹果计算机",
                        "id": 213212
                    }, {
                        "name": "台北小米牧业",
                        "id": 213213
                    }, {
                        "name": "杭州腾讯制造有限公司",
                        "id": 213214
                    }, {
                        "name": "首尔星巴克制造",
                        "id": 213215
                    }, {
                        "name": "香港百度证券",
                        "id": 213216
                    }, {
                        "name": "深圳滴滴金融控股集团",
                        "id": 213217
                    }, {
                        "name": "南京奈雪旅游",
                        "id": 213218
                    }, {
                        "name": "杭州华为地摊",
                        "id": 213219
                    }, {
                        "name": "首尔蚂蚁计算机",
                        "id": 213220
                    }, {
                        "name": "厦门肯德基汽车",
                        "id": 213221
                    }, {
                        "name": "厦门必胜客养殖控股集团",
                        "id": 213222
                    }, {
                        "name": "东京华为汽车有限公司",
                        "id": 213223
                    }, {
                        "name": "天津特斯拉新能源",
                        "id": 213224
                    }, {
                        "name": "首尔欧珀餐饮",
                        "id": 213225
                    }, {
                        "name": "天津华为汽车控股集团",
                        "id": 213226
                    }, {
                        "name": "纽约微软餐饮",
                        "id": 213227
                    }, {
                        "name": "广州星巴克",
                        "id": 213228
                    }, {
                        "name": "首尔华为电商有限公司",
                        "id": 213229
                    }, {
                        "name": "东莞华为制造",
                        "id": 213230
                    }, {
                        "name": "香港星巴克医药",
                        "id": 213231
                    }, {
                        "name": "南京星巴克养殖",
                        "id": 213232
                    }, {
                        "name": "南京亚马逊芯片控股集团",
                        "id": 213233
                    }, {
                        "name": "东莞微软旅游控股集团",
                        "id": 213234
                    }, {
                        "name": "厦门平安医药",
                        "id": 213235
                    }, {
                        "name": "南京小米制造",
                        "id": 213236
                    }]
                }, {
                    "name": "东莞苹果诊所",
                    "id": 213237,
                    "children": [{
                        "name": "东莞奈雪智能",
                        "id": 213238
                    }, {
                        "name": "上海瑞幸医院控股集团",
                        "id": 213239
                    }, {
                        "name": "北京滴滴控股集团",
                        "id": 213240
                    }, {
                        "name": "深圳必胜客地产",
                        "id": 213241
                    }, {
                        "name": "上海滴滴控股集团",
                        "id": 213242
                    }, {
                        "name": "杭州蚂蚁芯片",
                        "id": 213243
                    }, {
                        "name": "深圳美团芯片",
                        "id": 213244
                    }, {
                        "name": "上海特斯拉汽车有限公司",
                        "id": 213245
                    }, {
                        "name": "上海苹果金融",
                        "id": 213246
                    }, {
                        "name": "天津滴滴地产有限公司",
                        "id": 213247
                    }]
                }, {
                    "name": "东莞腾讯诊所控股集团",
                    "id": 213248
                }, {
                    "name": "杭州肯德基互金",
                    "id": 213249
                }, {
                    "name": "北京必胜客智能",
                    "id": 213250
                }, {
                    "name": "纽约特斯拉养殖",
                    "id": 213251
                }, {
                    "name": "首尔特斯拉医院有限公司",
                    "id": 213252,
                    "children": [{
                        "name": "香港亚马逊计算机控股集团",
                        "id": 213253
                    }]
                }, {
                    "name": "北京亚马逊诊所控股集团",
                    "id": 213254
                }, {
                    "name": "上海小米信息服务",
                    "id": 213255,
                    "children": [{
                        "name": "香港美团通讯有限公司",
                        "id": 213256
                    }, {
                        "name": "南京京东银行有限公司",
                        "id": 213257
                    }, {
                        "name": "广州星巴克信息服务",
                        "id": 213258
                    }, {
                        "name": "台北华为诊所",
                        "id": 213259
                    }, {
                        "name": "首尔字节制造有限公司",
                        "id": 213260
                    }, {
                        "name": "香港谷歌石油",
                        "id": 213261
                    }, {
                        "name": "杭州小米渔业有限公司",
                        "id": 213262
                    }, {
                        "name": "首尔喜茶科技有限公司",
                        "id": 213263
                    }, {
                        "name": "东京星巴克银行控股集团",
                        "id": 213264
                    }, {
                        "name": "厦门微软餐饮",
                        "id": 213265
                    }, {
                        "name": "台北亚马逊",
                        "id": 213266
                    }, {
                        "name": "北京星巴克互金控股集团",
                        "id": 213267
                    }, {
                        "name": "杭州微软计算机",
                        "id": 213268
                    }, {
                        "name": "首尔奈雪",
                        "id": 213269
                    }, {
                        "name": "南京平安医药有限公司",
                        "id": 213270
                    }, {
                        "name": "东莞星巴克汽车",
                        "id": 213271
                    }, {
                        "name": "台北华为金融",
                        "id": 213272
                    }, {
                        "name": "厦门欧珀软件",
                        "id": 213273
                    }, {
                        "name": "首尔欧珀医药",
                        "id": 213274
                    }, {
                        "name": "杭州奈雪软件控股集团",
                        "id": 213275
                    }, {
                        "name": "台北字节信息服务",
                        "id": 213276
                    }, {
                        "name": "北京星巴克地产",
                        "id": 213277
                    }, {
                        "name": "杭州华为医药",
                        "id": 213278
                    }, {
                        "name": "杭州蚂蚁旅游",
                        "id": 213279
                    }, {
                        "name": "南京美团新能源控股集团",
                        "id": 213280
                    }, {
                        "name": "东莞华为证券",
                        "id": 213281
                    }, {
                        "name": "纽约阿里旅游有限公司",
                        "id": 213282
                    }, {
                        "name": "杭州平安牧业",
                        "id": 213283
                    }, {
                        "name": "台北蚂蚁控股集团",
                        "id": 213284
                    }, {
                        "name": "台北必胜客旅游控股集团",
                        "id": 213285
                    }, {
                        "name": "北京京东制造",
                        "id": 213286
                    }, {
                        "name": "上海亚马逊渔业",
                        "id": 213287
                    }, {
                        "name": "深圳欧珀智能",
                        "id": 213288
                    }]
                }, {
                    "name": "上海京东智能",
                    "id": 213289,
                    "children": [{
                        "name": "香港苹果石油有限公司",
                        "id": 213290
                    }, {
                        "name": "北京必胜客计算机",
                        "id": 213291
                    }, {
                        "name": "深圳肯德基",
                        "id": 213292
                    }, {
                        "name": "台北字节医药",
                        "id": 213293
                    }, {
                        "name": "天津京东汽车",
                        "id": 213294
                    }, {
                        "name": "上海平安地产",
                        "id": 213295
                    }, {
                        "name": "香港肯德基养殖有限公司",
                        "id": 213296
                    }, {
                        "name": "南京腾讯证券",
                        "id": 213297
                    }, {
                        "name": "香港奈雪医院",
                        "id": 213298
                    }, {
                        "name": "台北苹果农业有限公司",
                        "id": 213299
                    }, {
                        "name": "杭州谷歌计算机有限公司",
                        "id": 213300
                    }, {
                        "name": "台北蚂蚁",
                        "id": 213301
                    }, {
                        "name": "杭州微软",
                        "id": 213302
                    }, {
                        "name": "东莞必胜客农业控股集团",
                        "id": 213303
                    }, {
                        "name": "纽约欧珀地产",
                        "id": 213304
                    }, {
                        "name": "深圳美团电商",
                        "id": 213305
                    }, {
                        "name": "天津肯德基石油控股集团",
                        "id": 213306
                    }, {
                        "name": "东莞奈雪金融",
                        "id": 213307
                    }, {
                        "name": "东莞平安餐饮有限公司",
                        "id": 213308
                    }, {
                        "name": "南京滴滴证券控股集团",
                        "id": 213309
                    }, {
                        "name": "上海腾讯航空",
                        "id": 213310
                    }, {
                        "name": "首尔必胜客基金",
                        "id": 213311
                    }, {
                        "name": "杭州滴滴制造有限公司",
                        "id": 213312
                    }, {
                        "name": "东京字节金融",
                        "id": 213313
                    }, {
                        "name": "东莞华为养殖",
                        "id": 213314
                    }]
                }, {
                    "name": "香港滴滴信息服务",
                    "id": 213315
                }]
            }, {
                "name": "东莞腾讯旅游",
                "id": 213316,
                "children": [{
                    "name": "杭州特斯拉通信",
                    "id": 213317,
                    "children": [{
                        "name": "北京滴滴软件",
                        "id": 213318
                    }, {
                        "name": "东京瑞幸银行有限公司",
                        "id": 213319
                    }, {
                        "name": "纽约蚂蚁互金",
                        "id": 213320
                    }, {
                        "name": "台北百度芯片",
                        "id": 213321
                    }, {
                        "name": "北京小米航空",
                        "id": 213322
                    }, {
                        "name": "首尔谷歌旅游",
                        "id": 213323
                    }, {
                        "name": "杭州肯德基计算机控股集团",
                        "id": 213324
                    }, {
                        "name": "深圳腾讯医院有限公司",
                        "id": 213325
                    }, {
                        "name": "天津苹果石油",
                        "id": 213326
                    }, {
                        "name": "厦门奈雪医院",
                        "id": 213327
                    }, {
                        "name": "台北奈雪计算机",
                        "id": 213328
                    }, {
                        "name": "上海微软通讯有限公司",
                        "id": 213329
                    }, {
                        "name": "首尔瑞幸智能",
                        "id": 213330
                    }, {
                        "name": "天津奈雪智能控股集团",
                        "id": 213331
                    }, {
                        "name": "厦门特斯拉石油",
                        "id": 213332
                    }, {
                        "name": "首尔微软",
                        "id": 213333
                    }, {
                        "name": "杭州星巴克渔业",
                        "id": 213334
                    }, {
                        "name": "厦门小米智能",
                        "id": 213335
                    }, {
                        "name": "杭州谷歌金融",
                        "id": 213336
                    }, {
                        "name": "广州阿里石油",
                        "id": 213337
                    }, {
                        "name": "台北美团智能",
                        "id": 213338
                    }, {
                        "name": "香港美团石油",
                        "id": 213339
                    }, {
                        "name": "纽约京东渔业",
                        "id": 213340
                    }, {
                        "name": "厦门平安通讯",
                        "id": 213341
                    }, {
                        "name": "厦门欧珀新能源",
                        "id": 213342
                    }, {
                        "name": "东莞京东渔业",
                        "id": 213343
                    }, {
                        "name": "杭州阿里科技",
                        "id": 213344
                    }, {
                        "name": "上海肯德基",
                        "id": 213345
                    }, {
                        "name": "台北滴滴科技控股集团",
                        "id": 213346
                    }, {
                        "name": "纽约瑞幸新能源",
                        "id": 213347
                    }, {
                        "name": "香港百度医药",
                        "id": 213348
                    }, {
                        "name": "天津平安牧业",
                        "id": 213349
                    }, {
                        "name": "杭州苹果养殖",
                        "id": 213350
                    }, {
                        "name": "广州苹果汽车",
                        "id": 213351
                    }, {
                        "name": "杭州喜茶航空",
                        "id": 213352
                    }, {
                        "name": "东京美团诊所",
                        "id": 213353
                    }]
                }, {
                    "name": "上海腾讯互金",
                    "id": 213354
                }, {
                    "name": "杭州瑞幸农业有限公司",
                    "id": 213355
                }, {
                    "name": "首尔星巴克航空控股集团",
                    "id": 213356
                }, {
                    "name": "厦门亚马逊控股集团",
                    "id": 213357
                }, {
                    "name": "天津亚马逊旅游",
                    "id": 213358
                }, {
                    "name": "上海特斯拉渔业有限公司",
                    "id": 213359
                }, {
                    "name": "深圳平安新能源控股集团",
                    "id": 213360
                }, {
                    "name": "广州喜茶科技",
                    "id": 213361,
                    "children": [{
                        "name": "台北字节证券有限公司",
                        "id": 213362
                    }, {
                        "name": "纽约亚马逊诊所",
                        "id": 213363
                    }, {
                        "name": "杭州字节医院控股集团",
                        "id": 213364
                    }, {
                        "name": "广州肯德基控股集团",
                        "id": 213365
                    }, {
                        "name": "南京平安科技控股集团",
                        "id": 213366
                    }, {
                        "name": "深圳微软芯片",
                        "id": 213367
                    }, {
                        "name": "厦门阿里医院",
                        "id": 213368
                    }, {
                        "name": "东京必胜客有限公司",
                        "id": 213369
                    }, {
                        "name": "深圳瑞幸汽车控股集团",
                        "id": 213370
                    }, {
                        "name": "北京肯德基",
                        "id": 213371
                    }, {
                        "name": "首尔华为旅游",
                        "id": 213372
                    }, {
                        "name": "东京特斯拉银行有限公司",
                        "id": 213373
                    }, {
                        "name": "南京蚂蚁地产",
                        "id": 213374
                    }, {
                        "name": "台北快手新能源",
                        "id": 213375
                    }]
                }, {
                    "name": "杭州苹果航空",
                    "id": 213376
                }, {
                    "name": "东京美团电商",
                    "id": 213377
                }]
            }, {
                "name": "广州美团医院",
                "id": 213378,
                "children": [{
                    "name": "东京肯德基控股集团",
                    "id": 213379
                }, {
                    "name": "天津肯德基金融",
                    "id": 213380
                }, {
                    "name": "杭州特斯拉",
                    "id": 213381
                }, {
                    "name": "首尔快手旅游",
                    "id": 213382,
                    "children": [{
                        "name": "东京字节电商有限公司",
                        "id": 213383
                    }, {
                        "name": "台北阿里渔业",
                        "id": 213384
                    }, {
                        "name": "首尔华为信息服务",
                        "id": 213385
                    }, {
                        "name": "台北平安农业",
                        "id": 213386
                    }, {
                        "name": "北京瑞幸石油",
                        "id": 213387
                    }, {
                        "name": "南京腾讯金融",
                        "id": 213388
                    }, {
                        "name": "台北字节养殖控股集团",
                        "id": 213389
                    }, {
                        "name": "天津谷歌医药",
                        "id": 213390
                    }, {
                        "name": "纽约腾讯科技",
                        "id": 213391
                    }, {
                        "name": "纽约苹果软件有限公司",
                        "id": 213392
                    }, {
                        "name": "南京滴滴医院",
                        "id": 213393
                    }, {
                        "name": "杭州华为科技控股集团",
                        "id": 213394
                    }, {
                        "name": "台北特斯拉有限公司",
                        "id": 213395
                    }, {
                        "name": "台北肯德基航空控股集团",
                        "id": 213396
                    }, {
                        "name": "杭州亚马逊医药",
                        "id": 213397
                    }]
                }, {
                    "name": "深圳百度渔业",
                    "id": 213398
                }, {
                    "name": "北京特斯拉地产控股集团",
                    "id": 213399
                }, {
                    "name": "首尔苹果信息服务",
                    "id": 213400
                }, {
                    "name": "广州字节通讯控股集团",
                    "id": 213401
                }, {
                    "name": "香港华为通信控股集团",
                    "id": 213402,
                    "children": [{
                        "name": "厦门滴滴电商控股集团",
                        "id": 213403
                    }, {
                        "name": "香港微软通讯",
                        "id": 213404
                    }, {
                        "name": "上海奈雪地产",
                        "id": 213405
                    }, {
                        "name": "杭州快手通信",
                        "id": 213406
                    }, {
                        "name": "深圳瑞幸石油有限公司",
                        "id": 213407
                    }, {
                        "name": "广州谷歌制造",
                        "id": 213408
                    }, {
                        "name": "杭州字节养殖控股集团",
                        "id": 213409
                    }, {
                        "name": "深圳华为基金",
                        "id": 213410
                    }, {
                        "name": "深圳肯德基餐饮控股集团",
                        "id": 213411
                    }, {
                        "name": "深圳欧珀通讯控股集团",
                        "id": 213412
                    }, {
                        "name": "广州京东医院",
                        "id": 213413
                    }, {
                        "name": "杭州奈雪电商",
                        "id": 213414
                    }, {
                        "name": "北京腾讯餐饮",
                        "id": 213415
                    }]
                }, {
                    "name": "首尔华为旅游",
                    "id": 213416
                }, {
                    "name": "厦门喜茶有限公司",
                    "id": 213417
                }, {
                    "name": "深圳腾讯制造",
                    "id": 213418
                }, {
                    "name": "杭州快手基金",
                    "id": 213419
                }, {
                    "name": "首尔谷歌旅游",
                    "id": 213420
                }, {
                    "name": "南京华为",
                    "id": 213421
                }, {
                    "name": "纽约瑞幸智能",
                    "id": 213422
                }, {
                    "name": "台北美团地产",
                    "id": 213423,
                    "children": [{
                        "name": "北京瑞幸制造",
                        "id": 213424
                    }, {
                        "name": "纽约谷歌芯片有限公司",
                        "id": 213425
                    }, {
                        "name": "南京滴滴信息服务",
                        "id": 213426
                    }, {
                        "name": "首尔腾讯芯片",
                        "id": 213427
                    }, {
                        "name": "天津阿里证券",
                        "id": 213428
                    }, {
                        "name": "台北星巴克制造",
                        "id": 213429
                    }, {
                        "name": "东京百度",
                        "id": 213430
                    }, {
                        "name": "天津喜茶渔业",
                        "id": 213431
                    }, {
                        "name": "杭州特斯拉",
                        "id": 213432
                    }, {
                        "name": "首尔奈雪牧业",
                        "id": 213433
                    }, {
                        "name": "深圳蚂蚁证券控股集团",
                        "id": 213434
                    }, {
                        "name": "首尔字节地摊控股集团",
                        "id": 213435
                    }, {
                        "name": "纽约欧珀石油",
                        "id": 213436
                    }, {
                        "name": "杭州肯德基科技控股集团",
                        "id": 213437
                    }, {
                        "name": "上海微软软件",
                        "id": 213438
                    }, {
                        "name": "纽约谷歌通信控股集团",
                        "id": 213439
                    }, {
                        "name": "台北星巴克医药控股集团",
                        "id": 213440
                    }, {
                        "name": "厦门平安有限公司",
                        "id": 213441
                    }, {
                        "name": "北京奈雪旅游有限公司",
                        "id": 213442
                    }, {
                        "name": "香港腾讯航空有限公司",
                        "id": 213443
                    }]
                }, {
                    "name": "广州特斯拉芯片有限公司",
                    "id": 213444
                }, {
                    "name": "北京奈雪农业",
                    "id": 213445
                }]
            }, {
                "name": "广州奈雪石油有限公司",
                "id": 213446
            }, {
                "name": "东莞美团信息服务",
                "id": 213447
            }, {
                "name": "北京星巴克芯片有限公司",
                "id": 213448
            }]
        }, {
            "name": "杭州欧珀旅游控股集团",
            "id": 213449
        }, {
            "name": "南京亚马逊汽车有限公司",
            "id": 213450
        }, {
            "name": "东莞百度养殖",
            "id": 213451
        }, {
            "name": "北京快手渔业有限公司",
            "id": 213452
        }, {
            "name": "东莞快手电商",
            "id": 213453
        }, {
            "name": "南京小米",
            "id": 213454
        }, {
            "name": "厦门百度银行",
            "id": 213455
        }, {
            "name": "台北肯德基计算机",
            "id": 213456,
            "children": [{
                "name": "天津亚马逊旅游",
                "id": 213457
            }, {
                "name": "纽约奈雪证券",
                "id": 213458
            }, {
                "name": "东京腾讯金融",
                "id": 213459
            }, {
                "name": "首尔平安通信",
                "id": 213460
            }, {
                "name": "香港百度医药",
                "id": 213461,
                "children": [{
                    "name": "厦门特斯拉汽车",
                    "id": 213462
                }, {
                    "name": "纽约快手旅游",
                    "id": 213463
                }, {
                    "name": "北京腾讯互金",
                    "id": 213464
                }, {
                    "name": "台北蚂蚁基金",
                    "id": 213465,
                    "children": [{
                        "name": "东京欧珀石油",
                        "id": 213466
                    }, {
                        "name": "天津蚂蚁信息服务",
                        "id": 213467
                    }, {
                        "name": "东京滴滴餐饮有限公司",
                        "id": 213468
                    }, {
                        "name": "台北瑞幸基金",
                        "id": 213469
                    }]
                }, {
                    "name": "纽约瑞幸航空有限公司",
                    "id": 213470
                }, {
                    "name": "首尔星巴克航空",
                    "id": 213471
                }, {
                    "name": "东莞华为基金",
                    "id": 213472
                }, {
                    "name": "广州京东地产有限公司",
                    "id": 213473
                }]
            }, {
                "name": "东莞奈雪",
                "id": 213474
            }, {
                "name": "东莞苹果智能",
                "id": 213475
            }, {
                "name": "上海阿里芯片",
                "id": 213476
            }, {
                "name": "广州谷歌养殖",
                "id": 213477
            }, {
                "name": "杭州小米石油",
                "id": 213478
            }, {
                "name": "纽约微软汽车控股集团",
                "id": 213479
            }, {
                "name": "北京滴滴渔业",
                "id": 213480
            }, {
                "name": "天津平安芯片有限公司",
                "id": 213481
            }, {
                "name": "深圳字节互金控股集团",
                "id": 213482,
                "children": [{
                    "name": "天津奈雪渔业",
                    "id": 213483
                }, {
                    "name": "首尔欧珀石油",
                    "id": 213484
                }, {
                    "name": "杭州阿里互金",
                    "id": 213485,
                    "children": [{
                        "name": "上海美团芯片",
                        "id": 213486
                    }, {
                        "name": "杭州小米通信",
                        "id": 213487
                    }, {
                        "name": "东莞字节软件有限公司",
                        "id": 213488
                    }, {
                        "name": "上海滴滴旅游",
                        "id": 213489
                    }]
                }, {
                    "name": "天津奈雪餐饮",
                    "id": 213490
                }, {
                    "name": "台北星巴克有限公司",
                    "id": 213491,
                    "children": [{
                        "name": "杭州必胜客渔业",
                        "id": 213492
                    }, {
                        "name": "上海微软证券有限公司",
                        "id": 213493
                    }, {
                        "name": "北京蚂蚁银行",
                        "id": 213494
                    }, {
                        "name": "广州亚马逊芯片控股集团",
                        "id": 213495
                    }, {
                        "name": "上海特斯拉有限公司",
                        "id": 213496
                    }, {
                        "name": "东莞平安新能源",
                        "id": 213497
                    }, {
                        "name": "深圳阿里",
                        "id": 213498
                    }, {
                        "name": "东京字节智能有限公司",
                        "id": 213499
                    }, {
                        "name": "南京奈雪科技",
                        "id": 213500
                    }, {
                        "name": "天津华为信息服务有限公司",
                        "id": 213501
                    }, {
                        "name": "东京京东牧业",
                        "id": 213502
                    }, {
                        "name": "东莞滴滴制造",
                        "id": 213503
                    }, {
                        "name": "东莞阿里地产",
                        "id": 213504
                    }, {
                        "name": "东京苹果有限公司",
                        "id": 213505
                    }, {
                        "name": "香港小米汽车",
                        "id": 213506
                    }, {
                        "name": "首尔滴滴智能",
                        "id": 213507
                    }, {
                        "name": "纽约必胜客电商",
                        "id": 213508
                    }, {
                        "name": "杭州蚂蚁互金",
                        "id": 213509
                    }, {
                        "name": "厦门微软渔业",
                        "id": 213510
                    }, {
                        "name": "厦门美团基金",
                        "id": 213511
                    }, {
                        "name": "厦门特斯拉牧业有限公司",
                        "id": 213512
                    }, {
                        "name": "东莞百度计算机",
                        "id": 213513
                    }, {
                        "name": "深圳字节科技",
                        "id": 213514
                    }, {
                        "name": "首尔谷歌金融",
                        "id": 213515
                    }, {
                        "name": "香港谷歌科技",
                        "id": 213516
                    }, {
                        "name": "首尔快手餐饮有限公司",
                        "id": 213517
                    }, {
                        "name": "广州蚂蚁证券有限公司",
                        "id": 213518
                    }, {
                        "name": "东京蚂蚁电商",
                        "id": 213519
                    }, {
                        "name": "上海喜茶养殖",
                        "id": 213520
                    }, {
                        "name": "上海阿里新能源有限公司",
                        "id": 213521
                    }, {
                        "name": "台北美团医药控股集团",
                        "id": 213522
                    }]
                }]
            }, {
                "name": "东莞特斯拉银行有限公司",
                "id": 213523
            }, {
                "name": "北京瑞幸金融",
                "id": 213524
            }, {
                "name": "厦门瑞幸科技",
                "id": 213525
            }, {
                "name": "台北欧珀科技",
                "id": 213526
            }, {
                "name": "深圳百度地产",
                "id": 213527,
                "children": [{
                    "name": "上海奈雪新能源控股集团",
                    "id": 213528
                }, {
                    "name": "东京蚂蚁石油",
                    "id": 213529
                }, {
                    "name": "纽约阿里新能源有限公司",
                    "id": 213530
                }, {
                    "name": "广州阿里农业",
                    "id": 213531,
                    "children": [{
                        "name": "北京华为医院",
                        "id": 213532
                    }, {
                        "name": "东京阿里养殖",
                        "id": 213533
                    }, {
                        "name": "东莞喜茶金融",
                        "id": 213534
                    }, {
                        "name": "东京谷歌科技",
                        "id": 213535
                    }, {
                        "name": "深圳喜茶诊所有限公司",
                        "id": 213536
                    }, {
                        "name": "深圳肯德基智能",
                        "id": 213537
                    }, {
                        "name": "香港百度地产",
                        "id": 213538
                    }, {
                        "name": "南京字节软件",
                        "id": 213539
                    }, {
                        "name": "东莞喜茶基金",
                        "id": 213540
                    }, {
                        "name": "纽约腾讯农业",
                        "id": 213541
                    }, {
                        "name": "上海京东渔业",
                        "id": 213542
                    }, {
                        "name": "广州快手旅游有限公司",
                        "id": 213543
                    }]
                }, {
                    "name": "东莞喜茶地产",
                    "id": 213544
                }, {
                    "name": "深圳星巴克通讯",
                    "id": 213545,
                    "children": [{
                        "name": "上海快手",
                        "id": 213546
                    }, {
                        "name": "天津苹果基金",
                        "id": 213547
                    }, {
                        "name": "首尔滴滴制造控股集团",
                        "id": 213548
                    }, {
                        "name": "台北微软牧业有限公司",
                        "id": 213549
                    }, {
                        "name": "台北微软控股集团",
                        "id": 213550
                    }, {
                        "name": "北京喜茶航空控股集团",
                        "id": 213551
                    }, {
                        "name": "杭州小米制造",
                        "id": 213552
                    }, {
                        "name": "上海瑞幸渔业控股集团",
                        "id": 213553
                    }, {
                        "name": "杭州肯德基医药控股集团",
                        "id": 213554
                    }, {
                        "name": "天津滴滴牧业控股集团",
                        "id": 213555
                    }, {
                        "name": "南京百度渔业",
                        "id": 213556
                    }, {
                        "name": "纽约腾讯互金有限公司",
                        "id": 213557
                    }, {
                        "name": "首尔欧珀地产",
                        "id": 213558
                    }, {
                        "name": "台北苹果",
                        "id": 213559
                    }, {
                        "name": "广州奈雪牧业",
                        "id": 213560
                    }]
                }, {
                    "name": "香港瑞幸软件",
                    "id": 213561
                }, {
                    "name": "天津蚂蚁餐饮",
                    "id": 213562
                }, {
                    "name": "东莞奈雪医院",
                    "id": 213563
                }, {
                    "name": "广州腾讯通信",
                    "id": 213564
                }, {
                    "name": "杭州美团信息服务",
                    "id": 213565
                }, {
                    "name": "深圳亚马逊",
                    "id": 213566
                }]
            }, {
                "name": "南京必胜客渔业",
                "id": 213567
            }, {
                "name": "北京苹果软件",
                "id": 213568
            }, {
                "name": "东京奈雪医药有限公司",
                "id": 213569,
                "children": [{
                    "name": "香港亚马逊汽车",
                    "id": 213570
                }, {
                    "name": "首尔特斯拉医院",
                    "id": 213571
                }, {
                    "name": "南京微软银行有限公司",
                    "id": 213572
                }, {
                    "name": "纽约京东电商控股集团",
                    "id": 213573,
                    "children": [{
                        "name": "杭州平安石油",
                        "id": 213574
                    }, {
                        "name": "东京滴滴",
                        "id": 213575
                    }, {
                        "name": "厦门瑞幸有限公司",
                        "id": 213576
                    }, {
                        "name": "东京平安软件",
                        "id": 213577
                    }, {
                        "name": "深圳喜茶诊所",
                        "id": 213578
                    }, {
                        "name": "上海滴滴",
                        "id": 213579
                    }, {
                        "name": "香港美团软件控股集团",
                        "id": 213580
                    }, {
                        "name": "杭州苹果银行",
                        "id": 213581
                    }, {
                        "name": "杭州微软汽车控股集团",
                        "id": 213582
                    }, {
                        "name": "杭州百度基金",
                        "id": 213583
                    }, {
                        "name": "首尔喜茶控股集团",
                        "id": 213584
                    }, {
                        "name": "台北平安汽车",
                        "id": 213585
                    }, {
                        "name": "纽约必胜客通信",
                        "id": 213586
                    }, {
                        "name": "上海奈雪旅游控股集团",
                        "id": 213587
                    }, {
                        "name": "北京亚马逊医药",
                        "id": 213588
                    }, {
                        "name": "纽约谷歌医院",
                        "id": 213589
                    }, {
                        "name": "杭州奈雪医院",
                        "id": 213590
                    }, {
                        "name": "天津瑞幸制造",
                        "id": 213591
                    }, {
                        "name": "上海百度渔业有限公司",
                        "id": 213592
                    }, {
                        "name": "厦门美团智能",
                        "id": 213593
                    }, {
                        "name": "上海微软银行控股集团",
                        "id": 213594
                    }, {
                        "name": "深圳亚马逊旅游",
                        "id": 213595
                    }, {
                        "name": "杭州肯德基证券",
                        "id": 213596
                    }, {
                        "name": "上海欧珀互金",
                        "id": 213597
                    }, {
                        "name": "天津必胜客银行",
                        "id": 213598
                    }, {
                        "name": "东京蚂蚁地产",
                        "id": 213599
                    }, {
                        "name": "香港必胜客计算机",
                        "id": 213600
                    }, {
                        "name": "台北百度牧业",
                        "id": 213601
                    }, {
                        "name": "广州特斯拉通讯",
                        "id": 213602
                    }, {
                        "name": "东京喜茶诊所控股集团",
                        "id": 213603
                    }, {
                        "name": "北京喜茶控股集团",
                        "id": 213604
                    }, {
                        "name": "广州美团旅游",
                        "id": 213605
                    }, {
                        "name": "东京星巴克医药控股集团",
                        "id": 213606
                    }]
                }, {
                    "name": "南京华为诊所有限公司",
                    "id": 213607,
                    "children": [{
                        "name": "北京字节控股集团",
                        "id": 213608
                    }, {
                        "name": "台北字节养殖控股集团",
                        "id": 213609
                    }, {
                        "name": "厦门美团",
                        "id": 213610
                    }, {
                        "name": "首尔欧珀渔业有限公司",
                        "id": 213611
                    }, {
                        "name": "天津京东渔业",
                        "id": 213612
                    }, {
                        "name": "杭州苹果通信有限公司",
                        "id": 213613
                    }, {
                        "name": "台北必胜客新能源",
                        "id": 213614
                    }, {
                        "name": "北京星巴克互金",
                        "id": 213615
                    }, {
                        "name": "上海瑞幸电商",
                        "id": 213616
                    }, {
                        "name": "北京谷歌通讯",
                        "id": 213617
                    }, {
                        "name": "南京京东信息服务",
                        "id": 213618
                    }, {
                        "name": "东莞肯德基牧业",
                        "id": 213619
                    }, {
                        "name": "杭州必胜客制造",
                        "id": 213620
                    }, {
                        "name": "纽约谷歌汽车有限公司",
                        "id": 213621
                    }, {
                        "name": "东莞腾讯渔业",
                        "id": 213622
                    }, {
                        "name": "东莞小米互金",
                        "id": 213623
                    }, {
                        "name": "南京亚马逊",
                        "id": 213624
                    }, {
                        "name": "北京京东牧业",
                        "id": 213625
                    }, {
                        "name": "台北字节牧业",
                        "id": 213626
                    }, {
                        "name": "香港瑞幸芯片控股集团",
                        "id": 213627
                    }, {
                        "name": "深圳百度证券",
                        "id": 213628
                    }, {
                        "name": "东莞星巴克农业",
                        "id": 213629
                    }, {
                        "name": "广州阿里渔业控股集团",
                        "id": 213630
                    }, {
                        "name": "深圳小米",
                        "id": 213631
                    }, {
                        "name": "东莞小米养殖",
                        "id": 213632
                    }, {
                        "name": "厦门必胜客",
                        "id": 213633
                    }, {
                        "name": "纽约小米互金控股集团",
                        "id": 213634
                    }]
                }, {
                    "name": "杭州微软地产有限公司",
                    "id": 213635
                }, {
                    "name": "广州微软地摊",
                    "id": 213636,
                    "children": [{
                        "name": "南京特斯拉诊所控股集团",
                        "id": 213637
                    }, {
                        "name": "上海快手通讯",
                        "id": 213638
                    }, {
                        "name": "杭州欧珀证券",
                        "id": 213639
                    }, {
                        "name": "上海谷歌电商有限公司",
                        "id": 213640
                    }, {
                        "name": "厦门特斯拉渔业",
                        "id": 213641
                    }, {
                        "name": "深圳欧珀计算机有限公司",
                        "id": 213642
                    }, {
                        "name": "天津字节地产",
                        "id": 213643
                    }, {
                        "name": "广州必胜客渔业",
                        "id": 213644
                    }, {
                        "name": "东京百度地摊有限公司",
                        "id": 213645
                    }, {
                        "name": "杭州字节牧业",
                        "id": 213646
                    }, {
                        "name": "南京阿里医药",
                        "id": 213647
                    }, {
                        "name": "纽约苹果通讯控股集团",
                        "id": 213648
                    }, {
                        "name": "纽约微软餐饮控股集团",
                        "id": 213649
                    }, {
                        "name": "厦门特斯拉基金控股集团",
                        "id": 213650
                    }, {
                        "name": "上海阿里通信有限公司",
                        "id": 213651
                    }, {
                        "name": "天津微软银行控股集团",
                        "id": 213652
                    }, {
                        "name": "上海字节银行",
                        "id": 213653
                    }, {
                        "name": "纽约小米",
                        "id": 213654
                    }, {
                        "name": "东莞阿里芯片",
                        "id": 213655
                    }, {
                        "name": "广州特斯拉汽车",
                        "id": 213656
                    }, {
                        "name": "香港微软渔业",
                        "id": 213657
                    }, {
                        "name": "广州小米基金",
                        "id": 213658
                    }, {
                        "name": "香港微软智能有限公司",
                        "id": 213659
                    }, {
                        "name": "南京星巴克医药",
                        "id": 213660
                    }, {
                        "name": "上海奈雪地摊有限公司",
                        "id": 213661
                    }, {
                        "name": "广州苹果餐饮控股集团",
                        "id": 213662
                    }, {
                        "name": "北京瑞幸渔业",
                        "id": 213663
                    }, {
                        "name": "天津京东地摊有限公司",
                        "id": 213664
                    }, {
                        "name": "东莞亚马逊银行控股集团",
                        "id": 213665
                    }, {
                        "name": "杭州谷歌软件",
                        "id": 213666
                    }]
                }, {
                    "name": "东莞美团餐饮",
                    "id": 213667
                }, {
                    "name": "香港小米汽车",
                    "id": 213668
                }, {
                    "name": "杭州美团银行",
                    "id": 213669,
                    "children": [{
                        "name": "纽约苹果新能源",
                        "id": 213670
                    }, {
                        "name": "首尔快手软件",
                        "id": 213671
                    }, {
                        "name": "北京快手汽车",
                        "id": 213672
                    }, {
                        "name": "上海快手证券控股集团",
                        "id": 213673
                    }, {
                        "name": "厦门奈雪旅游",
                        "id": 213674
                    }, {
                        "name": "台北平安渔业有限公司",
                        "id": 213675
                    }, {
                        "name": "东莞字节渔业",
                        "id": 213676
                    }, {
                        "name": "厦门特斯拉航空有限公司",
                        "id": 213677
                    }, {
                        "name": "香港小米芯片",
                        "id": 213678
                    }, {
                        "name": "天津喜茶芯片",
                        "id": 213679
                    }, {
                        "name": "首尔喜茶通讯",
                        "id": 213680
                    }, {
                        "name": "台北必胜客餐饮",
                        "id": 213681
                    }, {
                        "name": "厦门亚马逊医药控股集团",
                        "id": 213682
                    }, {
                        "name": "厦门腾讯金融",
                        "id": 213683
                    }, {
                        "name": "天津平安通讯控股集团",
                        "id": 213684
                    }, {
                        "name": "广州亚马逊航空控股集团",
                        "id": 213685
                    }, {
                        "name": "北京美团",
                        "id": 213686
                    }, {
                        "name": "厦门腾讯医院",
                        "id": 213687
                    }, {
                        "name": "广州亚马逊石油有限公司",
                        "id": 213688
                    }, {
                        "name": "纽约百度地产",
                        "id": 213689
                    }, {
                        "name": "上海平安诊所",
                        "id": 213690
                    }, {
                        "name": "东京快手餐饮有限公司",
                        "id": 213691
                    }, {
                        "name": "首尔奈雪互金",
                        "id": 213692
                    }, {
                        "name": "香港百度养殖",
                        "id": 213693
                    }, {
                        "name": "东莞京东有限公司",
                        "id": 213694
                    }, {
                        "name": "纽约肯德基",
                        "id": 213695
                    }, {
                        "name": "北京华为",
                        "id": 213696
                    }, {
                        "name": "杭州肯德基通讯",
                        "id": 213697
                    }, {
                        "name": "南京星巴克诊所",
                        "id": 213698
                    }, {
                        "name": "香港肯德基有限公司",
                        "id": 213699
                    }, {
                        "name": "杭州谷歌牧业",
                        "id": 213700
                    }, {
                        "name": "杭州特斯拉诊所",
                        "id": 213701
                    }, {
                        "name": "纽约苹果渔业控股集团",
                        "id": 213702
                    }, {
                        "name": "杭州喜茶",
                        "id": 213703
                    }, {
                        "name": "香港快手农业控股集团",
                        "id": 213704
                    }, {
                        "name": "杭州奈雪软件控股集团",
                        "id": 213705
                    }]
                }, {
                    "name": "杭州滴滴地产控股集团",
                    "id": 213706
                }, {
                    "name": "厦门喜茶石油",
                    "id": 213707,
                    "children": [{
                        "name": "广州平安地摊",
                        "id": 213708
                    }, {
                        "name": "香港微软地摊",
                        "id": 213709
                    }, {
                        "name": "广州平安医院",
                        "id": 213710
                    }, {
                        "name": "台北百度渔业",
                        "id": 213711
                    }, {
                        "name": "上海滴滴农业",
                        "id": 213712
                    }, {
                        "name": "天津腾讯计算机",
                        "id": 213713
                    }, {
                        "name": "纽约百度医院",
                        "id": 213714
                    }, {
                        "name": "广州亚马逊信息服务有限公司",
                        "id": 213715
                    }, {
                        "name": "杭州华为医药",
                        "id": 213716
                    }, {
                        "name": "天津必胜客诊所有限公司",
                        "id": 213717
                    }, {
                        "name": "香港苹果证券有限公司",
                        "id": 213718
                    }, {
                        "name": "上海喜茶汽车",
                        "id": 213719
                    }, {
                        "name": "首尔必胜客医院",
                        "id": 213720
                    }, {
                        "name": "上海特斯拉银行控股集团",
                        "id": 213721
                    }, {
                        "name": "东京必胜客养殖控股集团",
                        "id": 213722
                    }, {
                        "name": "上海华为互金控股集团",
                        "id": 213723
                    }, {
                        "name": "杭州特斯拉通讯有限公司",
                        "id": 213724
                    }, {
                        "name": "天津腾讯银行控股集团",
                        "id": 213725
                    }, {
                        "name": "台北快手",
                        "id": 213726
                    }, {
                        "name": "广州特斯拉农业",
                        "id": 213727
                    }, {
                        "name": "上海快手金融",
                        "id": 213728
                    }, {
                        "name": "广州奈雪基金有限公司",
                        "id": 213729
                    }, {
                        "name": "杭州奈雪基金控股集团",
                        "id": 213730
                    }, {
                        "name": "香港苹果电商",
                        "id": 213731
                    }, {
                        "name": "首尔滴滴基金控股集团",
                        "id": 213732
                    }]
                }, {
                    "name": "南京平安旅游控股集团",
                    "id": 213733
                }, {
                    "name": "北京喜茶牧业",
                    "id": 213734,
                    "children": [{
                        "name": "天津字节信息服务",
                        "id": 213735
                    }, {
                        "name": "深圳快手医药",
                        "id": 213736
                    }, {
                        "name": "北京平安渔业",
                        "id": 213737
                    }, {
                        "name": "杭州美团",
                        "id": 213738
                    }, {
                        "name": "杭州亚马逊金融",
                        "id": 213739
                    }, {
                        "name": "北京平安通讯",
                        "id": 213740
                    }, {
                        "name": "香港奈雪农业有限公司",
                        "id": 213741
                    }, {
                        "name": "厦门奈雪银行",
                        "id": 213742
                    }, {
                        "name": "广州腾讯计算机",
                        "id": 213743
                    }, {
                        "name": "香港喜茶有限公司",
                        "id": 213744
                    }, {
                        "name": "天津百度基金",
                        "id": 213745
                    }, {
                        "name": "广州华为有限公司",
                        "id": 213746
                    }, {
                        "name": "东莞苹果金融",
                        "id": 213747
                    }, {
                        "name": "首尔奈雪航空有限公司",
                        "id": 213748
                    }, {
                        "name": "东京蚂蚁养殖",
                        "id": 213749
                    }, {
                        "name": "纽约蚂蚁银行",
                        "id": 213750
                    }, {
                        "name": "上海华为银行控股集团",
                        "id": 213751
                    }, {
                        "name": "香港美团医院",
                        "id": 213752
                    }, {
                        "name": "首尔字节养殖",
                        "id": 213753
                    }, {
                        "name": "上海华为石油控股集团",
                        "id": 213754
                    }, {
                        "name": "杭州华为软件",
                        "id": 213755
                    }, {
                        "name": "杭州亚马逊养殖",
                        "id": 213756
                    }, {
                        "name": "上海亚马逊农业有限公司",
                        "id": 213757
                    }, {
                        "name": "东京字节基金有限公司",
                        "id": 213758
                    }, {
                        "name": "厦门微软电商控股集团",
                        "id": 213759
                    }, {
                        "name": "广州腾讯石油",
                        "id": 213760
                    }, {
                        "name": "深圳滴滴医院",
                        "id": 213761
                    }, {
                        "name": "厦门平安医院",
                        "id": 213762
                    }, {
                        "name": "首尔蚂蚁旅游有限公司",
                        "id": 213763
                    }, {
                        "name": "台北平安制造",
                        "id": 213764
                    }, {
                        "name": "广州欧珀汽车有限公司",
                        "id": 213765
                    }, {
                        "name": "杭州蚂蚁航空",
                        "id": 213766
                    }, {
                        "name": "台北快手地摊控股集团",
                        "id": 213767
                    }, {
                        "name": "北京奈雪通讯",
                        "id": 213768
                    }, {
                        "name": "杭州华为计算机",
                        "id": 213769
                    }, {
                        "name": "杭州华为养殖有限公司",
                        "id": 213770
                    }]
                }, {
                    "name": "东莞亚马逊证券",
                    "id": 213771
                }, {
                    "name": "天津阿里石油",
                    "id": 213772,
                    "children": [{
                        "name": "香港苹果银行控股集团",
                        "id": 213773
                    }, {
                        "name": "深圳百度汽车",
                        "id": 213774
                    }, {
                        "name": "天津亚马逊医院",
                        "id": 213775
                    }, {
                        "name": "南京特斯拉医院",
                        "id": 213776
                    }]
                }, {
                    "name": "广州小米互金",
                    "id": 213777
                }, {
                    "name": "深圳华为计算机",
                    "id": 213778
                }, {
                    "name": "北京欧珀农业控股集团",
                    "id": 213779,
                    "children": [{
                        "name": "广州苹果芯片",
                        "id": 213780
                    }, {
                        "name": "天津快手智能",
                        "id": 213781
                    }, {
                        "name": "天津蚂蚁芯片",
                        "id": 213782
                    }, {
                        "name": "杭州滴滴证券有限公司",
                        "id": 213783
                    }, {
                        "name": "纽约美团通讯控股集团",
                        "id": 213784
                    }, {
                        "name": "台北蚂蚁证券有限公司",
                        "id": 213785
                    }, {
                        "name": "深圳瑞幸计算机控股集团",
                        "id": 213786
                    }, {
                        "name": "南京平安石油",
                        "id": 213787
                    }, {
                        "name": "天津亚马逊科技",
                        "id": 213788
                    }, {
                        "name": "深圳字节石油控股集团",
                        "id": 213789
                    }, {
                        "name": "天津滴滴信息服务",
                        "id": 213790
                    }, {
                        "name": "南京京东有限公司",
                        "id": 213791
                    }, {
                        "name": "杭州特斯拉证券",
                        "id": 213792
                    }, {
                        "name": "东莞小米基金",
                        "id": 213793
                    }, {
                        "name": "深圳谷歌牧业有限公司",
                        "id": 213794
                    }, {
                        "name": "东京小米",
                        "id": 213795
                    }, {
                        "name": "杭州腾讯医药",
                        "id": 213796
                    }, {
                        "name": "纽约腾讯渔业控股集团",
                        "id": 213797
                    }, {
                        "name": "纽约腾讯计算机",
                        "id": 213798
                    }, {
                        "name": "香港蚂蚁科技控股集团",
                        "id": 213799
                    }, {
                        "name": "东莞华为金融",
                        "id": 213800
                    }, {
                        "name": "香港滴滴信息服务",
                        "id": 213801
                    }, {
                        "name": "东莞快手基金",
                        "id": 213802
                    }, {
                        "name": "南京阿里通讯",
                        "id": 213803
                    }, {
                        "name": "广州腾讯有限公司",
                        "id": 213804
                    }, {
                        "name": "厦门字节旅游",
                        "id": 213805
                    }, {
                        "name": "东莞蚂蚁渔业",
                        "id": 213806
                    }, {
                        "name": "广州小米银行控股集团",
                        "id": 213807
                    }, {
                        "name": "台北喜茶电商有限公司",
                        "id": 213808
                    }, {
                        "name": "广州腾讯汽车有限公司",
                        "id": 213809
                    }, {
                        "name": "深圳喜茶智能",
                        "id": 213810
                    }, {
                        "name": "香港欧珀旅游",
                        "id": 213811
                    }, {
                        "name": "深圳腾讯制造",
                        "id": 213812
                    }, {
                        "name": "上海腾讯石油",
                        "id": 213813
                    }]
                }, {
                    "name": "北京快手控股集团",
                    "id": 213814
                }, {
                    "name": "杭州平安智能",
                    "id": 213815
                }, {
                    "name": "广州特斯拉诊所",
                    "id": 213816
                }, {
                    "name": "南京星巴克汽车",
                    "id": 213817
                }, {
                    "name": "北京亚马逊芯片",
                    "id": 213818
                }, {
                    "name": "上海星巴克餐饮",
                    "id": 213819
                }, {
                    "name": "东京奈雪银行有限公司",
                    "id": 213820
                }, {
                    "name": "东京谷歌航空",
                    "id": 213821,
                    "children": [{
                        "name": "台北苹果农业",
                        "id": 213822
                    }, {
                        "name": "纽约蚂蚁牧业",
                        "id": 213823
                    }, {
                        "name": "首尔平安医药控股集团",
                        "id": 213824
                    }, {
                        "name": "杭州华为制造",
                        "id": 213825
                    }, {
                        "name": "深圳欧珀诊所",
                        "id": 213826
                    }, {
                        "name": "东莞美团地产",
                        "id": 213827
                    }, {
                        "name": "杭州快手诊所有限公司",
                        "id": 213828
                    }, {
                        "name": "深圳蚂蚁医药",
                        "id": 213829
                    }, {
                        "name": "深圳谷歌渔业",
                        "id": 213830
                    }, {
                        "name": "东莞快手餐饮",
                        "id": 213831
                    }, {
                        "name": "香港小米",
                        "id": 213832
                    }, {
                        "name": "香港苹果医药",
                        "id": 213833
                    }, {
                        "name": "台北微软农业",
                        "id": 213834
                    }, {
                        "name": "东莞肯德基",
                        "id": 213835
                    }, {
                        "name": "北京亚马逊智能",
                        "id": 213836
                    }, {
                        "name": "上海阿里通讯有限公司",
                        "id": 213837
                    }, {
                        "name": "厦门华为牧业",
                        "id": 213838
                    }, {
                        "name": "杭州字节旅游控股集团",
                        "id": 213839
                    }, {
                        "name": "纽约奈雪电商有限公司",
                        "id": 213840
                    }, {
                        "name": "杭州瑞幸汽车",
                        "id": 213841
                    }, {
                        "name": "首尔苹果地摊",
                        "id": 213842
                    }, {
                        "name": "厦门瑞幸计算机控股集团",
                        "id": 213843
                    }, {
                        "name": "东莞欧珀",
                        "id": 213844
                    }, {
                        "name": "北京美团餐饮",
                        "id": 213845
                    }, {
                        "name": "杭州蚂蚁科技",
                        "id": 213846
                    }]
                }, {
                    "name": "天津字节旅游有限公司",
                    "id": 213847
                }, {
                    "name": "东莞苹果通讯有限公司",
                    "id": 213848
                }, {
                    "name": "深圳小米基金",
                    "id": 213849
                }, {
                    "name": "香港星巴克航空有限公司",
                    "id": 213850
                }]
            }]
        }, {
            "name": "香港星巴克农业",
            "id": 213851
        }]
    }, {
        "name": "广州字节制造",
        "id": 213852
    }, {
        "name": "南京瑞幸地摊控股集团",
        "id": 213853,
        "children": [{
            "name": "纽约谷歌芯片",
            "id": 213854
        }, {
            "name": "首尔特斯拉地产",
            "id": 213855
        }, {
            "name": "台北特斯拉证券",
            "id": 213856,
            "children": [{
                "name": "南京喜茶芯片控股集团",
                "id": 213857
            }, {
                "name": "杭州滴滴金融控股集团",
                "id": 213858
            }, {
                "name": "上海奈雪证券",
                "id": 213859,
                "children": [{
                    "name": "北京喜茶计算机",
                    "id": 213860,
                    "children": [{
                        "name": "深圳欧珀餐饮控股集团",
                        "id": 213861
                    }, {
                        "name": "香港小米",
                        "id": 213862
                    }, {
                        "name": "杭州星巴克地产控股集团",
                        "id": 213863
                    }, {
                        "name": "东京必胜客石油",
                        "id": 213864
                    }]
                }]
            }]
        }, {
            "name": "杭州瑞幸通讯",
            "id": 213865
        }, {
            "name": "广州微软证券",
            "id": 213866,
            "children": [{
                "name": "厦门字节基金",
                "id": 213867,
                "children": [{
                    "name": "深圳华为地摊",
                    "id": 213868
                }, {
                    "name": "杭州亚马逊互金",
                    "id": 213869
                }, {
                    "name": "杭州阿里石油",
                    "id": 213870,
                    "children": [{
                        "name": "北京快手旅游",
                        "id": 213871
                    }, {
                        "name": "香港星巴克科技有限公司",
                        "id": 213872
                    }, {
                        "name": "天津百度",
                        "id": 213873
                    }, {
                        "name": "广州欧珀软件",
                        "id": 213874
                    }, {
                        "name": "东京谷歌芯片",
                        "id": 213875
                    }, {
                        "name": "台北奈雪芯片有限公司",
                        "id": 213876
                    }, {
                        "name": "东京喜茶牧业有限公司",
                        "id": 213877
                    }, {
                        "name": "北京特斯拉石油",
                        "id": 213878
                    }, {
                        "name": "北京京东通讯",
                        "id": 213879
                    }, {
                        "name": "首尔苹果石油",
                        "id": 213880
                    }, {
                        "name": "纽约美团通信",
                        "id": 213881
                    }, {
                        "name": "首尔星巴克医院",
                        "id": 213882
                    }, {
                        "name": "杭州百度医院",
                        "id": 213883
                    }, {
                        "name": "台北腾讯医药",
                        "id": 213884
                    }, {
                        "name": "东莞小米地产控股集团",
                        "id": 213885
                    }, {
                        "name": "广州美团科技",
                        "id": 213886
                    }, {
                        "name": "上海字节农业有限公司",
                        "id": 213887
                    }, {
                        "name": "厦门星巴克证券",
                        "id": 213888
                    }, {
                        "name": "厦门字节",
                        "id": 213889
                    }, {
                        "name": "台北百度信息服务",
                        "id": 213890
                    }, {
                        "name": "南京小米诊所有限公司",
                        "id": 213891
                    }, {
                        "name": "天津苹果控股集团",
                        "id": 213892
                    }, {
                        "name": "东京阿里电商",
                        "id": 213893
                    }, {
                        "name": "北京瑞幸农业",
                        "id": 213894
                    }, {
                        "name": "天津喜茶医院",
                        "id": 213895
                    }, {
                        "name": "厦门喜茶科技有限公司",
                        "id": 213896
                    }, {
                        "name": "台北亚马逊制造",
                        "id": 213897
                    }, {
                        "name": "纽约特斯拉信息服务",
                        "id": 213898
                    }, {
                        "name": "东京快手证券有限公司",
                        "id": 213899
                    }, {
                        "name": "香港滴滴石油",
                        "id": 213900
                    }, {
                        "name": "首尔平安医院",
                        "id": 213901
                    }, {
                        "name": "南京肯德基农业",
                        "id": 213902
                    }]
                }, {
                    "name": "台北快手银行",
                    "id": 213903,
                    "children": [{
                        "name": "广州星巴克制造控股集团",
                        "id": 213904
                    }, {
                        "name": "东莞欧珀通信",
                        "id": 213905
                    }, {
                        "name": "杭州阿里渔业",
                        "id": 213906
                    }, {
                        "name": "上海肯德基汽车",
                        "id": 213907
                    }, {
                        "name": "北京华为地产",
                        "id": 213908
                    }, {
                        "name": "杭州蚂蚁汽车",
                        "id": 213909
                    }, {
                        "name": "纽约苹果牧业控股集团",
                        "id": 213910
                    }, {
                        "name": "东莞特斯拉养殖",
                        "id": 213911
                    }, {
                        "name": "上海美团计算机",
                        "id": 213912
                    }, {
                        "name": "杭州字节",
                        "id": 213913
                    }, {
                        "name": "厦门蚂蚁通讯",
                        "id": 213914
                    }, {
                        "name": "东京必胜客智能",
                        "id": 213915
                    }, {
                        "name": "杭州肯德基制造",
                        "id": 213916
                    }, {
                        "name": "北京奈雪医院",
                        "id": 213917
                    }, {
                        "name": "北京奈雪通信控股集团",
                        "id": 213918
                    }, {
                        "name": "香港微软养殖",
                        "id": 213919
                    }]
                }, {
                    "name": "杭州平安智能",
                    "id": 213920
                }, {
                    "name": "杭州谷歌汽车控股集团",
                    "id": 213921
                }]
            }, {
                "name": "东莞蚂蚁计算机",
                "id": 213922
            }, {
                "name": "纽约欧珀证券控股集团",
                "id": 213923
            }, {
                "name": "东京腾讯证券有限公司",
                "id": 213924
            }, {
                "name": "北京奈雪牧业",
                "id": 213925
            }, {
                "name": "杭州特斯拉新能源",
                "id": 213926
            }, {
                "name": "台北瑞幸通讯",
                "id": 213927
            }, {
                "name": "南京蚂蚁计算机",
                "id": 213928
            }, {
                "name": "南京阿里农业",
                "id": 213929,
                "children": [{
                    "name": "杭州瑞幸诊所控股集团",
                    "id": 213930
                }, {
                    "name": "厦门美团基金",
                    "id": 213931
                }, {
                    "name": "首尔喜茶智能",
                    "id": 213932
                }, {
                    "name": "香港奈雪农业",
                    "id": 213933
                }, {
                    "name": "广州美团银行控股集团",
                    "id": 213934
                }, {
                    "name": "东京奈雪芯片",
                    "id": 213935
                }, {
                    "name": "杭州肯德基信息服务",
                    "id": 213936,
                    "children": [{
                        "name": "深圳阿里石油",
                        "id": 213937
                    }, {
                        "name": "厦门谷歌通讯控股集团",
                        "id": 213938
                    }, {
                        "name": "台北华为证券",
                        "id": 213939
                    }, {
                        "name": "台北肯德基科技",
                        "id": 213940
                    }, {
                        "name": "杭州瑞幸通讯",
                        "id": 213941
                    }, {
                        "name": "台北瑞幸信息服务有限公司",
                        "id": 213942
                    }, {
                        "name": "北京奈雪",
                        "id": 213943
                    }, {
                        "name": "首尔京东新能源有限公司",
                        "id": 213944
                    }, {
                        "name": "南京亚马逊证券",
                        "id": 213945
                    }, {
                        "name": "天津谷歌通讯",
                        "id": 213946
                    }, {
                        "name": "纽约美团金融",
                        "id": 213947
                    }, {
                        "name": "上海百度",
                        "id": 213948
                    }, {
                        "name": "深圳谷歌汽车",
                        "id": 213949
                    }, {
                        "name": "广州蚂蚁电商",
                        "id": 213950
                    }, {
                        "name": "广州华为",
                        "id": 213951
                    }, {
                        "name": "纽约苹果养殖",
                        "id": 213952
                    }, {
                        "name": "深圳腾讯计算机",
                        "id": 213953
                    }, {
                        "name": "北京特斯拉科技",
                        "id": 213954
                    }, {
                        "name": "台北特斯拉互金",
                        "id": 213955
                    }, {
                        "name": "纽约华为软件",
                        "id": 213956
                    }, {
                        "name": "杭州阿里牧业",
                        "id": 213957
                    }, {
                        "name": "台北京东软件",
                        "id": 213958
                    }, {
                        "name": "天津百度互金",
                        "id": 213959
                    }, {
                        "name": "东莞奈雪有限公司",
                        "id": 213960
                    }, {
                        "name": "南京美团养殖",
                        "id": 213961
                    }, {
                        "name": "广州肯德基计算机有限公司",
                        "id": 213962
                    }, {
                        "name": "杭州京东",
                        "id": 213963
                    }, {
                        "name": "台北阿里芯片",
                        "id": 213964
                    }, {
                        "name": "天津微软信息服务",
                        "id": 213965
                    }, {
                        "name": "杭州微软地摊",
                        "id": 213966
                    }, {
                        "name": "北京特斯拉旅游",
                        "id": 213967
                    }, {
                        "name": "东京蚂蚁新能源",
                        "id": 213968
                    }, {
                        "name": "纽约苹果制造控股集团",
                        "id": 213969
                    }, {
                        "name": "天津华为石油",
                        "id": 213970
                    }, {
                        "name": "首尔瑞幸通讯",
                        "id": 213971
                    }, {
                        "name": "南京美团旅游有限公司",
                        "id": 213972
                    }]
                }, {
                    "name": "纽约华为旅游有限公司",
                    "id": 213973
                }, {
                    "name": "杭州腾讯银行有限公司",
                    "id": 213974
                }, {
                    "name": "东莞微软新能源",
                    "id": 213975
                }, {
                    "name": "厦门肯德基地摊",
                    "id": 213976
                }, {
                    "name": "杭州肯德基通信",
                    "id": 213977
                }, {
                    "name": "深圳亚马逊互金有限公司",
                    "id": 213978,
                    "children": [{
                        "name": "北京美团智能",
                        "id": 213979
                    }, {
                        "name": "深圳喜茶通讯",
                        "id": 213980
                    }, {
                        "name": "东莞华为医院有限公司",
                        "id": 213981
                    }, {
                        "name": "深圳肯德基证券",
                        "id": 213982
                    }, {
                        "name": "杭州平安航空控股集团",
                        "id": 213983
                    }]
                }, {
                    "name": "首尔平安",
                    "id": 213984,
                    "children": [{
                        "name": "台北阿里通讯有限公司",
                        "id": 213985
                    }, {
                        "name": "广州华为医院控股集团",
                        "id": 213986
                    }, {
                        "name": "杭州京东电商",
                        "id": 213987
                    }, {
                        "name": "广州星巴克金融",
                        "id": 213988
                    }, {
                        "name": "杭州肯德基证券",
                        "id": 213989
                    }, {
                        "name": "东京欧珀电商",
                        "id": 213990
                    }, {
                        "name": "深圳必胜客",
                        "id": 213991
                    }, {
                        "name": "纽约奈雪航空",
                        "id": 213992
                    }, {
                        "name": "杭州必胜客餐饮",
                        "id": 213993
                    }, {
                        "name": "上海美团农业有限公司",
                        "id": 213994
                    }, {
                        "name": "上海京东",
                        "id": 213995
                    }, {
                        "name": "杭州美团渔业",
                        "id": 213996
                    }, {
                        "name": "杭州美团医院",
                        "id": 213997
                    }, {
                        "name": "北京华为餐饮",
                        "id": 213998
                    }, {
                        "name": "台北阿里制造有限公司",
                        "id": 213999
                    }, {
                        "name": "杭州平安汽车",
                        "id": 214000
                    }, {
                        "name": "东莞星巴克智能",
                        "id": 214001
                    }, {
                        "name": "南京小米农业",
                        "id": 214002
                    }, {
                        "name": "南京必胜客通讯",
                        "id": 214003
                    }, {
                        "name": "台北美团农业控股集团",
                        "id": 214004
                    }, {
                        "name": "上海奈雪通讯控股集团",
                        "id": 214005
                    }, {
                        "name": "台北必胜客农业",
                        "id": 214006
                    }, {
                        "name": "上海必胜客地产",
                        "id": 214007
                    }, {
                        "name": "东京瑞幸通信",
                        "id": 214008
                    }, {
                        "name": "首尔亚马逊通信",
                        "id": 214009
                    }]
                }, {
                    "name": "上海特斯拉餐饮",
                    "id": 214010
                }, {
                    "name": "北京美团银行",
                    "id": 214011
                }, {
                    "name": "纽约蚂蚁养殖",
                    "id": 214012
                }, {
                    "name": "北京百度医院",
                    "id": 214013
                }, {
                    "name": "台北快手旅游有限公司",
                    "id": 214014
                }, {
                    "name": "台北奈雪渔业",
                    "id": 214015
                }, {
                    "name": "杭州谷歌医院",
                    "id": 214016
                }]
            }, {
                "name": "北京美团诊所",
                "id": 214017,
                "children": [{
                    "name": "南京华为餐饮",
                    "id": 214018
                }, {
                    "name": "杭州字节养殖",
                    "id": 214019
                }, {
                    "name": "台北亚马逊医院有限公司",
                    "id": 214020,
                    "children": [{
                        "name": "香港美团渔业有限公司",
                        "id": 214021
                    }, {
                        "name": "上海快手芯片",
                        "id": 214022
                    }, {
                        "name": "上海欧珀银行",
                        "id": 214023
                    }, {
                        "name": "杭州平安信息服务控股集团",
                        "id": 214024
                    }, {
                        "name": "东京京东电商有限公司",
                        "id": 214025
                    }, {
                        "name": "上海奈雪互金有限公司",
                        "id": 214026
                    }, {
                        "name": "天津字节养殖有限公司",
                        "id": 214027
                    }, {
                        "name": "杭州喜茶养殖",
                        "id": 214028
                    }, {
                        "name": "杭州快手软件",
                        "id": 214029
                    }, {
                        "name": "纽约苹果电商有限公司",
                        "id": 214030
                    }, {
                        "name": "上海肯德基",
                        "id": 214031
                    }, {
                        "name": "杭州阿里医院",
                        "id": 214032
                    }, {
                        "name": "天津微软医院有限公司",
                        "id": 214033
                    }, {
                        "name": "北京瑞幸石油",
                        "id": 214034
                    }, {
                        "name": "香港美团制造有限公司",
                        "id": 214035
                    }, {
                        "name": "首尔必胜客牧业",
                        "id": 214036
                    }, {
                        "name": "上海平安计算机有限公司",
                        "id": 214037
                    }, {
                        "name": "东莞美团银行",
                        "id": 214038
                    }, {
                        "name": "北京亚马逊",
                        "id": 214039
                    }, {
                        "name": "厦门美团餐饮",
                        "id": 214040
                    }, {
                        "name": "上海快手互金",
                        "id": 214041
                    }, {
                        "name": "杭州特斯拉地产有限公司",
                        "id": 214042
                    }, {
                        "name": "深圳谷歌科技",
                        "id": 214043
                    }, {
                        "name": "台北华为牧业",
                        "id": 214044
                    }, {
                        "name": "广州谷歌芯片控股集团",
                        "id": 214045
                    }, {
                        "name": "杭州蚂蚁地产有限公司",
                        "id": 214046
                    }, {
                        "name": "首尔平安通讯有限公司",
                        "id": 214047
                    }, {
                        "name": "首尔华为计算机控股集团",
                        "id": 214048
                    }, {
                        "name": "上海欧珀计算机",
                        "id": 214049
                    }, {
                        "name": "香港蚂蚁软件",
                        "id": 214050
                    }]
                }]
            }, {
                "name": "杭州平安医药有限公司",
                "id": 214051
            }, {
                "name": "台北京东互金",
                "id": 214052,
                "children": [{
                    "name": "首尔谷歌信息服务",
                    "id": 214053
                }, {
                    "name": "台北星巴克智能",
                    "id": 214054
                }, {
                    "name": "东莞肯德基证券",
                    "id": 214055,
                    "children": [{
                        "name": "纽约亚马逊养殖",
                        "id": 214056
                    }, {
                        "name": "南京瑞幸有限公司",
                        "id": 214057
                    }, {
                        "name": "纽约字节汽车",
                        "id": 214058
                    }, {
                        "name": "杭州谷歌计算机",
                        "id": 214059
                    }, {
                        "name": "纽约肯德基航空",
                        "id": 214060
                    }, {
                        "name": "纽约百度计算机",
                        "id": 214061
                    }, {
                        "name": "首尔喜茶医药",
                        "id": 214062
                    }, {
                        "name": "上海肯德基医药控股集团",
                        "id": 214063
                    }, {
                        "name": "台北必胜客基金有限公司",
                        "id": 214064
                    }, {
                        "name": "深圳特斯拉基金",
                        "id": 214065
                    }, {
                        "name": "北京滴滴信息服务控股集团",
                        "id": 214066
                    }, {
                        "name": "北京小米科技控股集团",
                        "id": 214067
                    }]
                }, {
                    "name": "广州星巴克石油",
                    "id": 214068
                }, {
                    "name": "东莞平安",
                    "id": 214069,
                    "children": [{
                        "name": "杭州小米旅游",
                        "id": 214070
                    }, {
                        "name": "广州快手石油有限公司",
                        "id": 214071
                    }, {
                        "name": "上海快手地摊",
                        "id": 214072
                    }, {
                        "name": "南京苹果医院",
                        "id": 214073
                    }, {
                        "name": "杭州小米牧业",
                        "id": 214074
                    }, {
                        "name": "天津必胜客芯片",
                        "id": 214075
                    }, {
                        "name": "深圳肯德基计算机",
                        "id": 214076
                    }, {
                        "name": "上海字节芯片",
                        "id": 214077
                    }, {
                        "name": "厦门谷歌金融有限公司",
                        "id": 214078
                    }, {
                        "name": "杭州腾讯控股集团",
                        "id": 214079
                    }, {
                        "name": "台北小米汽车",
                        "id": 214080
                    }, {
                        "name": "首尔微软",
                        "id": 214081
                    }, {
                        "name": "天津欧珀餐饮",
                        "id": 214082
                    }, {
                        "name": "杭州苹果科技",
                        "id": 214083
                    }, {
                        "name": "厦门蚂蚁航空",
                        "id": 214084
                    }, {
                        "name": "深圳小米旅游",
                        "id": 214085
                    }, {
                        "name": "台北星巴克智能",
                        "id": 214086
                    }, {
                        "name": "台北肯德基智能",
                        "id": 214087
                    }, {
                        "name": "东莞微软信息服务",
                        "id": 214088
                    }, {
                        "name": "东京阿里地摊有限公司",
                        "id": 214089
                    }, {
                        "name": "厦门字节航空",
                        "id": 214090
                    }, {
                        "name": "首尔快手证券",
                        "id": 214091
                    }, {
                        "name": "香港蚂蚁医院",
                        "id": 214092
                    }, {
                        "name": "东莞滴滴医院有限公司",
                        "id": 214093
                    }, {
                        "name": "东莞阿里农业",
                        "id": 214094
                    }, {
                        "name": "杭州喜茶石油控股集团",
                        "id": 214095
                    }, {
                        "name": "首尔腾讯养殖",
                        "id": 214096
                    }, {
                        "name": "深圳微软牧业",
                        "id": 214097
                    }, {
                        "name": "深圳奈雪控股集团",
                        "id": 214098
                    }, {
                        "name": "天津腾讯制造有限公司",
                        "id": 214099
                    }, {
                        "name": "南京瑞幸餐饮",
                        "id": 214100
                    }, {
                        "name": "北京亚马逊科技有限公司",
                        "id": 214101
                    }, {
                        "name": "上海奈雪地摊",
                        "id": 214102
                    }, {
                        "name": "深圳京东智能",
                        "id": 214103
                    }, {
                        "name": "上海欧珀",
                        "id": 214104
                    }]
                }, {
                    "name": "香港亚马逊金融",
                    "id": 214105
                }, {
                    "name": "台北平安互金有限公司",
                    "id": 214106
                }, {
                    "name": "深圳滴滴医药",
                    "id": 214107
                }, {
                    "name": "深圳谷歌软件",
                    "id": 214108,
                    "children": [{
                        "name": "台北星巴克养殖",
                        "id": 214109
                    }, {
                        "name": "天津肯德基新能源",
                        "id": 214110
                    }, {
                        "name": "首尔谷歌银行",
                        "id": 214111
                    }, {
                        "name": "东莞奈雪航空",
                        "id": 214112
                    }, {
                        "name": "北京喜茶旅游控股集团",
                        "id": 214113
                    }, {
                        "name": "广州阿里渔业",
                        "id": 214114
                    }, {
                        "name": "东莞亚马逊互金",
                        "id": 214115
                    }, {
                        "name": "北京华为通信",
                        "id": 214116
                    }, {
                        "name": "杭州星巴克餐饮",
                        "id": 214117
                    }, {
                        "name": "深圳腾讯地摊",
                        "id": 214118
                    }, {
                        "name": "广州谷歌互金控股集团",
                        "id": 214119
                    }, {
                        "name": "深圳小米基金",
                        "id": 214120
                    }]
                }, {
                    "name": "纽约亚马逊信息服务",
                    "id": 214121
                }, {
                    "name": "杭州百度医药",
                    "id": 214122,
                    "children": [{
                        "name": "东莞星巴克通信控股集团",
                        "id": 214123
                    }, {
                        "name": "北京微软证券有限公司",
                        "id": 214124
                    }, {
                        "name": "杭州喜茶证券有限公司",
                        "id": 214125
                    }, {
                        "name": "香港奈雪石油",
                        "id": 214126
                    }, {
                        "name": "台北特斯拉医药",
                        "id": 214127
                    }, {
                        "name": "北京蚂蚁农业控股集团",
                        "id": 214128
                    }, {
                        "name": "杭州苹果",
                        "id": 214129
                    }, {
                        "name": "香港微软芯片",
                        "id": 214130
                    }, {
                        "name": "香港瑞幸地产",
                        "id": 214131
                    }, {
                        "name": "杭州苹果通讯有限公司",
                        "id": 214132
                    }, {
                        "name": "台北字节芯片有限公司",
                        "id": 214133
                    }, {
                        "name": "天津华为金融",
                        "id": 214134
                    }, {
                        "name": "首尔奈雪地摊",
                        "id": 214135
                    }, {
                        "name": "首尔苹果信息服务",
                        "id": 214136
                    }, {
                        "name": "杭州特斯拉餐饮控股集团",
                        "id": 214137
                    }, {
                        "name": "深圳小米旅游",
                        "id": 214138
                    }, {
                        "name": "台北喜茶",
                        "id": 214139
                    }, {
                        "name": "厦门喜茶航空",
                        "id": 214140
                    }, {
                        "name": "上海小米医院",
                        "id": 214141
                    }, {
                        "name": "天津亚马逊餐饮",
                        "id": 214142
                    }, {
                        "name": "杭州京东诊所",
                        "id": 214143
                    }, {
                        "name": "北京喜茶软件",
                        "id": 214144
                    }, {
                        "name": "东莞特斯拉芯片有限公司",
                        "id": 214145
                    }, {
                        "name": "纽约奈雪航空",
                        "id": 214146
                    }, {
                        "name": "广州欧珀汽车",
                        "id": 214147
                    }, {
                        "name": "厦门亚马逊控股集团",
                        "id": 214148
                    }]
                }, {
                    "name": "天津欧珀电商",
                    "id": 214149
                }, {
                    "name": "厦门谷歌渔业",
                    "id": 214150
                }, {
                    "name": "南京欧珀诊所",
                    "id": 214151
                }, {
                    "name": "南京华为智能",
                    "id": 214152
                }, {
                    "name": "东京华为医药控股集团",
                    "id": 214153
                }, {
                    "name": "台北小米餐饮",
                    "id": 214154
                }, {
                    "name": "深圳微软电商控股集团",
                    "id": 214155
                }, {
                    "name": "首尔微软旅游",
                    "id": 214156
                }, {
                    "name": "香港滴滴通讯",
                    "id": 214157
                }, {
                    "name": "北京小米证券",
                    "id": 214158
                }, {
                    "name": "东莞瑞幸有限公司",
                    "id": 214159,
                    "children": [{
                        "name": "东京百度航空有限公司",
                        "id": 214160
                    }, {
                        "name": "天津谷歌科技",
                        "id": 214161
                    }, {
                        "name": "台北蚂蚁基金",
                        "id": 214162
                    }, {
                        "name": "东莞苹果医院",
                        "id": 214163
                    }]
                }, {
                    "name": "杭州华为互金有限公司",
                    "id": 214164
                }, {
                    "name": "杭州奈雪医院",
                    "id": 214165,
                    "children": [{
                        "name": "首尔华为汽车",
                        "id": 214166
                    }, {
                        "name": "南京苹果通讯控股集团",
                        "id": 214167
                    }, {
                        "name": "纽约微软信息服务",
                        "id": 214168
                    }, {
                        "name": "广州小米基金",
                        "id": 214169
                    }, {
                        "name": "香港小米互金",
                        "id": 214170
                    }, {
                        "name": "纽约平安计算机有限公司",
                        "id": 214171
                    }, {
                        "name": "北京肯德基旅游",
                        "id": 214172
                    }, {
                        "name": "杭州平安医药有限公司",
                        "id": 214173
                    }, {
                        "name": "上海京东航空有限公司",
                        "id": 214174
                    }, {
                        "name": "深圳字节软件有限公司",
                        "id": 214175
                    }, {
                        "name": "厦门小米计算机",
                        "id": 214176
                    }, {
                        "name": "上海奈雪餐饮",
                        "id": 214177
                    }, {
                        "name": "广州平安餐饮有限公司",
                        "id": 214178
                    }, {
                        "name": "厦门蚂蚁牧业",
                        "id": 214179
                    }, {
                        "name": "深圳微软控股集团",
                        "id": 214180
                    }, {
                        "name": "广州必胜客基金",
                        "id": 214181
                    }, {
                        "name": "纽约平安地产",
                        "id": 214182
                    }, {
                        "name": "东京星巴克养殖",
                        "id": 214183
                    }, {
                        "name": "东莞星巴克计算机控股集团",
                        "id": 214184
                    }, {
                        "name": "香港特斯拉控股集团",
                        "id": 214185
                    }, {
                        "name": "上海亚马逊通信",
                        "id": 214186
                    }, {
                        "name": "东莞阿里",
                        "id": 214187
                    }, {
                        "name": "首尔肯德基航空控股集团",
                        "id": 214188
                    }, {
                        "name": "台北美团渔业",
                        "id": 214189
                    }, {
                        "name": "杭州微软地产",
                        "id": 214190
                    }, {
                        "name": "深圳奈雪牧业控股集团",
                        "id": 214191
                    }, {
                        "name": "香港苹果芯片",
                        "id": 214192
                    }, {
                        "name": "北京特斯拉医药",
                        "id": 214193
                    }, {
                        "name": "纽约平安养殖",
                        "id": 214194
                    }, {
                        "name": "香港星巴克科技",
                        "id": 214195
                    }]
                }, {
                    "name": "杭州必胜客航空",
                    "id": 214196
                }, {
                    "name": "纽约谷歌智能",
                    "id": 214197
                }, {
                    "name": "杭州百度通信控股集团",
                    "id": 214198
                }, {
                    "name": "台北亚马逊地产",
                    "id": 214199
                }, {
                    "name": "杭州华为互金",
                    "id": 214200
                }, {
                    "name": "香港美团医院",
                    "id": 214201
                }, {
                    "name": "南京小米通讯有限公司",
                    "id": 214202,
                    "children": [{
                        "name": "南京滴滴地产",
                        "id": 214203
                    }, {
                        "name": "深圳快手牧业有限公司",
                        "id": 214204
                    }, {
                        "name": "纽约谷歌信息服务",
                        "id": 214205
                    }, {
                        "name": "天津蚂蚁通信",
                        "id": 214206
                    }, {
                        "name": "东京瑞幸金融",
                        "id": 214207
                    }, {
                        "name": "北京亚马逊通信",
                        "id": 214208
                    }, {
                        "name": "台北奈雪通讯有限公司",
                        "id": 214209
                    }, {
                        "name": "杭州华为新能源",
                        "id": 214210
                    }, {
                        "name": "首尔华为互金",
                        "id": 214211
                    }, {
                        "name": "杭州华为餐饮",
                        "id": 214212
                    }, {
                        "name": "厦门腾讯",
                        "id": 214213
                    }, {
                        "name": "纽约苹果计算机",
                        "id": 214214
                    }, {
                        "name": "纽约奈雪汽车",
                        "id": 214215
                    }, {
                        "name": "首尔美团信息服务控股集团",
                        "id": 214216
                    }, {
                        "name": "杭州京东牧业有限公司",
                        "id": 214217
                    }, {
                        "name": "东京必胜客石油",
                        "id": 214218
                    }, {
                        "name": "上海阿里诊所",
                        "id": 214219
                    }, {
                        "name": "上海美团互金",
                        "id": 214220
                    }, {
                        "name": "纽约星巴克养殖",
                        "id": 214221
                    }, {
                        "name": "香港华为通讯",
                        "id": 214222
                    }, {
                        "name": "广州微软医院",
                        "id": 214223
                    }, {
                        "name": "南京亚马逊信息服务有限公司",
                        "id": 214224
                    }, {
                        "name": "南京欧珀控股集团",
                        "id": 214225
                    }]
                }, {
                    "name": "广州微软",
                    "id": 214226
                }, {
                    "name": "南京欧珀通讯控股集团",
                    "id": 214227
                }, {
                    "name": "南京星巴克餐饮控股集团",
                    "id": 214228
                }]
            }, {
                "name": "香港星巴克牧业",
                "id": 214229
            }, {
                "name": "杭州奈雪旅游",
                "id": 214230
            }, {
                "name": "上海百度科技控股集团",
                "id": 214231
            }, {
                "name": "香港腾讯控股集团",
                "id": 214232
            }, {
                "name": "南京特斯拉",
                "id": 214233
            }, {
                "name": "上海华为汽车",
                "id": 214234
            }, {
                "name": "香港瑞幸养殖",
                "id": 214235
            }, {
                "name": "首尔百度信息服务有限公司",
                "id": 214236
            }, {
                "name": "台北苹果地产",
                "id": 214237
            }, {
                "name": "东京微软养殖",
                "id": 214238,
                "children": [{
                    "name": "天津谷歌石油",
                    "id": 214239
                }, {
                    "name": "纽约平安基金",
                    "id": 214240
                }, {
                    "name": "香港奈雪餐饮",
                    "id": 214241
                }, {
                    "name": "天津奈雪银行控股集团",
                    "id": 214242
                }, {
                    "name": "台北百度地产",
                    "id": 214243
                }, {
                    "name": "南京喜茶制造",
                    "id": 214244,
                    "children": [{
                        "name": "北京小米科技",
                        "id": 214245
                    }]
                }, {
                    "name": "北京喜茶芯片",
                    "id": 214246
                }, {
                    "name": "香港谷歌基金控股集团",
                    "id": 214247
                }, {
                    "name": "厦门蚂蚁农业",
                    "id": 214248,
                    "children": [{
                        "name": "香港小米证券",
                        "id": 214249
                    }, {
                        "name": "东京欧珀养殖控股集团",
                        "id": 214250
                    }, {
                        "name": "纽约微软科技控股集团",
                        "id": 214251
                    }, {
                        "name": "首尔阿里汽车有限公司",
                        "id": 214252
                    }, {
                        "name": "杭州字节诊所有限公司",
                        "id": 214253
                    }, {
                        "name": "香港小米银行",
                        "id": 214254
                    }, {
                        "name": "纽约谷歌有限公司",
                        "id": 214255
                    }, {
                        "name": "广州亚马逊石油",
                        "id": 214256
                    }, {
                        "name": "杭州小米银行",
                        "id": 214257
                    }, {
                        "name": "广州字节信息服务有限公司",
                        "id": 214258
                    }, {
                        "name": "首尔快手通信有限公司",
                        "id": 214259
                    }, {
                        "name": "广州京东汽车",
                        "id": 214260
                    }, {
                        "name": "深圳滴滴养殖控股集团",
                        "id": 214261
                    }, {
                        "name": "深圳肯德基渔业控股集团",
                        "id": 214262
                    }, {
                        "name": "南京欧珀石油",
                        "id": 214263
                    }, {
                        "name": "杭州亚马逊智能",
                        "id": 214264
                    }, {
                        "name": "杭州苹果银行",
                        "id": 214265
                    }, {
                        "name": "香港阿里软件",
                        "id": 214266
                    }, {
                        "name": "天津平安诊所",
                        "id": 214267
                    }, {
                        "name": "深圳蚂蚁地产",
                        "id": 214268
                    }, {
                        "name": "东京腾讯银行",
                        "id": 214269
                    }, {
                        "name": "台北肯德基新能源",
                        "id": 214270
                    }, {
                        "name": "厦门微软旅游",
                        "id": 214271
                    }, {
                        "name": "南京谷歌电商",
                        "id": 214272
                    }, {
                        "name": "南京瑞幸医院",
                        "id": 214273
                    }, {
                        "name": "上海星巴克诊所有限公司",
                        "id": 214274
                    }, {
                        "name": "天津必胜客通信控股集团",
                        "id": 214275
                    }, {
                        "name": "北京苹果",
                        "id": 214276
                    }, {
                        "name": "上海特斯拉石油",
                        "id": 214277
                    }, {
                        "name": "台北谷歌基金控股集团",
                        "id": 214278
                    }, {
                        "name": "杭州平安证券",
                        "id": 214279
                    }, {
                        "name": "东京阿里餐饮有限公司",
                        "id": 214280
                    }, {
                        "name": "纽约快手智能",
                        "id": 214281
                    }]
                }, {
                    "name": "杭州滴滴科技",
                    "id": 214282
                }, {
                    "name": "广州必胜客",
                    "id": 214283
                }, {
                    "name": "东京华为科技",
                    "id": 214284
                }, {
                    "name": "台北腾讯诊所",
                    "id": 214285
                }, {
                    "name": "纽约瑞幸汽车",
                    "id": 214286,
                    "children": [{
                        "name": "上海肯德基基金控股集团",
                        "id": 214287
                    }, {
                        "name": "厦门腾讯航空有限公司",
                        "id": 214288
                    }, {
                        "name": "首尔必胜客制造",
                        "id": 214289
                    }, {
                        "name": "纽约腾讯通信",
                        "id": 214290
                    }, {
                        "name": "北京谷歌农业控股集团",
                        "id": 214291
                    }, {
                        "name": "天津星巴克智能有限公司",
                        "id": 214292
                    }, {
                        "name": "北京星巴克证券有限公司",
                        "id": 214293
                    }, {
                        "name": "东莞快手信息服务控股集团",
                        "id": 214294
                    }, {
                        "name": "天津特斯拉医药有限公司",
                        "id": 214295
                    }, {
                        "name": "上海华为餐饮有限公司",
                        "id": 214296
                    }, {
                        "name": "台北星巴克诊所控股集团",
                        "id": 214297
                    }, {
                        "name": "杭州蚂蚁芯片",
                        "id": 214298
                    }, {
                        "name": "深圳华为渔业有限公司",
                        "id": 214299
                    }, {
                        "name": "上海百度智能",
                        "id": 214300
                    }, {
                        "name": "东莞亚马逊医院控股集团",
                        "id": 214301
                    }, {
                        "name": "东莞滴滴信息服务",
                        "id": 214302
                    }, {
                        "name": "杭州华为智能控股集团",
                        "id": 214303
                    }]
                }, {
                    "name": "深圳星巴克信息服务",
                    "id": 214304
                }, {
                    "name": "厦门欧珀通信控股集团",
                    "id": 214305
                }, {
                    "name": "北京华为信息服务",
                    "id": 214306
                }, {
                    "name": "广州平安",
                    "id": 214307
                }, {
                    "name": "广州奈雪电商",
                    "id": 214308
                }, {
                    "name": "东莞谷歌芯片控股集团",
                    "id": 214309
                }, {
                    "name": "北京平安基金",
                    "id": 214310,
                    "children": [{
                        "name": "杭州小米科技",
                        "id": 214311
                    }, {
                        "name": "深圳特斯拉地产",
                        "id": 214312
                    }, {
                        "name": "台北字节牧业",
                        "id": 214313
                    }, {
                        "name": "东京星巴克智能",
                        "id": 214314
                    }, {
                        "name": "首尔平安电商有限公司",
                        "id": 214315
                    }, {
                        "name": "杭州百度计算机有限公司",
                        "id": 214316
                    }, {
                        "name": "东莞苹果地摊",
                        "id": 214317
                    }, {
                        "name": "深圳奈雪金融",
                        "id": 214318
                    }, {
                        "name": "东京谷歌制造",
                        "id": 214319
                    }, {
                        "name": "台北美团渔业",
                        "id": 214320
                    }, {
                        "name": "东莞谷歌制造",
                        "id": 214321
                    }, {
                        "name": "东京蚂蚁新能源",
                        "id": 214322
                    }, {
                        "name": "南京滴滴",
                        "id": 214323
                    }, {
                        "name": "北京百度地摊",
                        "id": 214324
                    }, {
                        "name": "纽约滴滴新能源有限公司",
                        "id": 214325
                    }, {
                        "name": "上海苹果智能",
                        "id": 214326
                    }, {
                        "name": "东莞谷歌智能有限公司",
                        "id": 214327
                    }, {
                        "name": "杭州苹果科技控股集团",
                        "id": 214328
                    }, {
                        "name": "香港必胜客基金",
                        "id": 214329
                    }, {
                        "name": "天津蚂蚁金融",
                        "id": 214330
                    }, {
                        "name": "南京瑞幸新能源",
                        "id": 214331
                    }, {
                        "name": "北京奈雪信息服务控股集团",
                        "id": 214332
                    }, {
                        "name": "东京谷歌软件",
                        "id": 214333
                    }, {
                        "name": "香港苹果医院",
                        "id": 214334
                    }, {
                        "name": "北京字节制造",
                        "id": 214335
                    }, {
                        "name": "杭州百度基金",
                        "id": 214336
                    }, {
                        "name": "台北奈雪信息服务",
                        "id": 214337
                    }]
                }, {
                    "name": "上海字节牧业",
                    "id": 214338
                }, {
                    "name": "上海字节互金",
                    "id": 214339
                }]
            }, {
                "name": "深圳微软通信",
                "id": 214340,
                "children": [{
                    "name": "杭州亚马逊医药有限公司",
                    "id": 214341
                }, {
                    "name": "东莞苹果医药",
                    "id": 214342
                }, {
                    "name": "杭州快手新能源控股集团",
                    "id": 214343,
                    "children": [{
                        "name": "首尔快手互金",
                        "id": 214344
                    }, {
                        "name": "厦门腾讯农业",
                        "id": 214345
                    }, {
                        "name": "东京腾讯基金控股集团",
                        "id": 214346
                    }, {
                        "name": "深圳快手医院",
                        "id": 214347
                    }, {
                        "name": "纽约肯德基智能",
                        "id": 214348
                    }, {
                        "name": "天津字节",
                        "id": 214349
                    }, {
                        "name": "深圳星巴克航空有限公司",
                        "id": 214350
                    }, {
                        "name": "天津滴滴计算机",
                        "id": 214351
                    }, {
                        "name": "北京平安",
                        "id": 214352
                    }, {
                        "name": "东京苹果诊所",
                        "id": 214353
                    }, {
                        "name": "厦门阿里互金有限公司",
                        "id": 214354
                    }, {
                        "name": "纽约阿里航空控股集团",
                        "id": 214355
                    }, {
                        "name": "天津肯德基新能源控股集团",
                        "id": 214356
                    }, {
                        "name": "东莞谷歌农业控股集团",
                        "id": 214357
                    }, {
                        "name": "北京欧珀农业",
                        "id": 214358
                    }, {
                        "name": "台北字节渔业",
                        "id": 214359
                    }, {
                        "name": "杭州特斯拉农业",
                        "id": 214360
                    }, {
                        "name": "北京平安芯片",
                        "id": 214361
                    }, {
                        "name": "首尔小米制造有限公司",
                        "id": 214362
                    }, {
                        "name": "南京瑞幸餐饮",
                        "id": 214363
                    }, {
                        "name": "香港京东",
                        "id": 214364
                    }, {
                        "name": "东莞阿里农业控股集团",
                        "id": 214365
                    }, {
                        "name": "北京星巴克软件控股集团",
                        "id": 214366
                    }, {
                        "name": "南京百度电商",
                        "id": 214367
                    }, {
                        "name": "上海京东农业有限公司",
                        "id": 214368
                    }]
                }, {
                    "name": "深圳瑞幸通信",
                    "id": 214369
                }, {
                    "name": "东京腾讯旅游",
                    "id": 214370,
                    "children": [{
                        "name": "广州瑞幸农业控股集团",
                        "id": 214371
                    }, {
                        "name": "上海滴滴",
                        "id": 214372
                    }, {
                        "name": "天津必胜客医药控股集团",
                        "id": 214373
                    }, {
                        "name": "杭州快手控股集团",
                        "id": 214374
                    }, {
                        "name": "台北腾讯旅游",
                        "id": 214375
                    }, {
                        "name": "香港快手航空控股集团",
                        "id": 214376
                    }, {
                        "name": "东莞特斯拉软件",
                        "id": 214377
                    }, {
                        "name": "北京瑞幸电商有限公司",
                        "id": 214378
                    }, {
                        "name": "台北腾讯旅游",
                        "id": 214379
                    }, {
                        "name": "台北特斯拉汽车控股集团",
                        "id": 214380
                    }, {
                        "name": "杭州必胜客金融",
                        "id": 214381
                    }, {
                        "name": "北京瑞幸地摊",
                        "id": 214382
                    }, {
                        "name": "东莞喜茶医药",
                        "id": 214383
                    }, {
                        "name": "纽约美团电商",
                        "id": 214384
                    }, {
                        "name": "香港平安芯片控股集团",
                        "id": 214385
                    }, {
                        "name": "北京肯德基诊所",
                        "id": 214386
                    }, {
                        "name": "东京腾讯石油",
                        "id": 214387
                    }, {
                        "name": "纽约华为养殖有限公司",
                        "id": 214388
                    }, {
                        "name": "东京瑞幸互金",
                        "id": 214389
                    }, {
                        "name": "台北滴滴芯片",
                        "id": 214390
                    }, {
                        "name": "深圳阿里有限公司",
                        "id": 214391
                    }, {
                        "name": "广州喜茶养殖",
                        "id": 214392
                    }, {
                        "name": "东莞喜茶地产",
                        "id": 214393
                    }, {
                        "name": "北京百度渔业控股集团",
                        "id": 214394
                    }]
                }, {
                    "name": "杭州华为金融",
                    "id": 214395
                }, {
                    "name": "南京瑞幸汽车控股集团",
                    "id": 214396
                }, {
                    "name": "东京苹果银行",
                    "id": 214397
                }, {
                    "name": "香港微软制造",
                    "id": 214398
                }, {
                    "name": "上海谷歌地产",
                    "id": 214399
                }, {
                    "name": "纽约亚马逊金融",
                    "id": 214400,
                    "children": [{
                        "name": "香港瑞幸汽车",
                        "id": 214401
                    }, {
                        "name": "天津必胜客制造有限公司",
                        "id": 214402
                    }, {
                        "name": "东京字节",
                        "id": 214403
                    }, {
                        "name": "东莞奈雪地摊",
                        "id": 214404
                    }, {
                        "name": "南京瑞幸养殖",
                        "id": 214405
                    }, {
                        "name": "厦门美团",
                        "id": 214406
                    }, {
                        "name": "厦门美团地产控股集团",
                        "id": 214407
                    }, {
                        "name": "南京谷歌牧业",
                        "id": 214408
                    }, {
                        "name": "首尔腾讯有限公司",
                        "id": 214409
                    }, {
                        "name": "上海谷歌计算机",
                        "id": 214410
                    }, {
                        "name": "厦门腾讯制造",
                        "id": 214411
                    }, {
                        "name": "首尔亚马逊有限公司",
                        "id": 214412
                    }, {
                        "name": "东莞谷歌石油",
                        "id": 214413
                    }, {
                        "name": "南京阿里",
                        "id": 214414
                    }, {
                        "name": "厦门华为医药",
                        "id": 214415
                    }, {
                        "name": "首尔腾讯石油",
                        "id": 214416
                    }, {
                        "name": "深圳谷歌银行有限公司",
                        "id": 214417
                    }]
                }, {
                    "name": "厦门美团计算机",
                    "id": 214418
                }, {
                    "name": "深圳奈雪牧业",
                    "id": 214419,
                    "children": [{
                        "name": "上海腾讯芯片有限公司",
                        "id": 214420
                    }, {
                        "name": "广州腾讯计算机",
                        "id": 214421
                    }, {
                        "name": "上海华为软件",
                        "id": 214422
                    }, {
                        "name": "上海腾讯制造有限公司",
                        "id": 214423
                    }, {
                        "name": "杭州蚂蚁基金",
                        "id": 214424
                    }, {
                        "name": "杭州肯德基互金控股集团",
                        "id": 214425
                    }, {
                        "name": "东莞亚马逊互金有限公司",
                        "id": 214426
                    }, {
                        "name": "杭州华为芯片",
                        "id": 214427
                    }, {
                        "name": "东京华为电商",
                        "id": 214428
                    }, {
                        "name": "天津滴滴信息服务",
                        "id": 214429
                    }, {
                        "name": "首尔奈雪渔业",
                        "id": 214430
                    }, {
                        "name": "深圳华为证券",
                        "id": 214431
                    }, {
                        "name": "深圳腾讯渔业",
                        "id": 214432
                    }, {
                        "name": "东京快手控股集团",
                        "id": 214433
                    }, {
                        "name": "纽约亚马逊信息服务",
                        "id": 214434
                    }, {
                        "name": "广州微软医药",
                        "id": 214435
                    }, {
                        "name": "香港特斯拉通讯",
                        "id": 214436
                    }, {
                        "name": "北京欧珀金融控股集团",
                        "id": 214437
                    }, {
                        "name": "上海华为控股集团",
                        "id": 214438
                    }, {
                        "name": "首尔微软电商有限公司",
                        "id": 214439
                    }, {
                        "name": "北京肯德基科技",
                        "id": 214440
                    }, {
                        "name": "杭州肯德基信息服务",
                        "id": 214441
                    }, {
                        "name": "厦门谷歌地产有限公司",
                        "id": 214442
                    }, {
                        "name": "天津京东信息服务",
                        "id": 214443
                    }, {
                        "name": "台北百度汽车",
                        "id": 214444
                    }, {
                        "name": "天津华为通讯",
                        "id": 214445
                    }, {
                        "name": "北京小米",
                        "id": 214446
                    }, {
                        "name": "首尔美团通讯有限公司",
                        "id": 214447
                    }, {
                        "name": "台北蚂蚁基金",
                        "id": 214448
                    }, {
                        "name": "厦门华为汽车有限公司",
                        "id": 214449
                    }, {
                        "name": "北京谷歌航空控股集团",
                        "id": 214450
                    }]
                }, {
                    "name": "北京百度信息服务有限公司",
                    "id": 214451,
                    "children": [{
                        "name": "杭州蚂蚁信息服务",
                        "id": 214452
                    }, {
                        "name": "杭州奈雪",
                        "id": 214453
                    }, {
                        "name": "香港星巴克汽车",
                        "id": 214454
                    }, {
                        "name": "厦门瑞幸互金",
                        "id": 214455
                    }, {
                        "name": "天津滴滴芯片有限公司",
                        "id": 214456
                    }, {
                        "name": "台北喜茶航空",
                        "id": 214457
                    }, {
                        "name": "深圳亚马逊石油",
                        "id": 214458
                    }, {
                        "name": "天津星巴克电商",
                        "id": 214459
                    }, {
                        "name": "北京苹果旅游",
                        "id": 214460
                    }, {
                        "name": "厦门华为餐饮有限公司",
                        "id": 214461
                    }, {
                        "name": "台北字节牧业",
                        "id": 214462
                    }, {
                        "name": "杭州亚马逊芯片",
                        "id": 214463
                    }, {
                        "name": "台北阿里诊所有限公司",
                        "id": 214464
                    }, {
                        "name": "厦门百度有限公司",
                        "id": 214465
                    }, {
                        "name": "东京平安基金",
                        "id": 214466
                    }, {
                        "name": "纽约必胜客牧业",
                        "id": 214467
                    }, {
                        "name": "厦门字节地摊控股集团",
                        "id": 214468
                    }, {
                        "name": "香港特斯拉养殖有限公司",
                        "id": 214469
                    }, {
                        "name": "台北腾讯信息服务",
                        "id": 214470
                    }, {
                        "name": "南京美团有限公司",
                        "id": 214471
                    }, {
                        "name": "杭州平安地产",
                        "id": 214472
                    }, {
                        "name": "香港苹果新能源",
                        "id": 214473
                    }, {
                        "name": "南京必胜客养殖",
                        "id": 214474
                    }, {
                        "name": "杭州喜茶软件",
                        "id": 214475
                    }, {
                        "name": "南京喜茶农业",
                        "id": 214476
                    }, {
                        "name": "深圳瑞幸诊所控股集团",
                        "id": 214477
                    }, {
                        "name": "香港苹果汽车",
                        "id": 214478
                    }, {
                        "name": "香港欧珀旅游控股集团",
                        "id": 214479
                    }, {
                        "name": "南京肯德基地产",
                        "id": 214480
                    }, {
                        "name": "上海百度航空",
                        "id": 214481
                    }, {
                        "name": "东莞欧珀芯片",
                        "id": 214482
                    }]
                }, {
                    "name": "首尔美团通信",
                    "id": 214483
                }, {
                    "name": "纽约百度地产控股集团",
                    "id": 214484
                }, {
                    "name": "台北京东新能源",
                    "id": 214485
                }, {
                    "name": "纽约平安",
                    "id": 214486
                }, {
                    "name": "香港字节牧业",
                    "id": 214487
                }, {
                    "name": "东京星巴克医院",
                    "id": 214488
                }, {
                    "name": "天津小米地摊有限公司",
                    "id": 214489
                }, {
                    "name": "东京必胜客计算机",
                    "id": 214490
                }, {
                    "name": "杭州星巴克旅游",
                    "id": 214491
                }, {
                    "name": "纽约亚马逊银行",
                    "id": 214492
                }, {
                    "name": "北京字节信息服务",
                    "id": 214493
                }, {
                    "name": "纽约苹果芯片",
                    "id": 214494
                }, {
                    "name": "厦门瑞幸养殖控股集团",
                    "id": 214495
                }, {
                    "name": "杭州欧珀地摊",
                    "id": 214496,
                    "children": [{
                        "name": "首尔滴滴医药",
                        "id": 214497
                    }, {
                        "name": "广州快手智能有限公司",
                        "id": 214498
                    }, {
                        "name": "北京亚马逊医药",
                        "id": 214499
                    }, {
                        "name": "首尔快手制造有限公司",
                        "id": 214500
                    }, {
                        "name": "东京苹果",
                        "id": 214501
                    }, {
                        "name": "台北京东软件",
                        "id": 214502
                    }, {
                        "name": "厦门字节石油",
                        "id": 214503
                    }, {
                        "name": "香港百度电商",
                        "id": 214504
                    }, {
                        "name": "东京腾讯医药",
                        "id": 214505
                    }, {
                        "name": "南京喜茶芯片控股集团",
                        "id": 214506
                    }, {
                        "name": "杭州华为石油有限公司",
                        "id": 214507
                    }]
                }, {
                    "name": "广州快手通讯",
                    "id": 214508,
                    "children": [{
                        "name": "广州华为农业控股集团",
                        "id": 214509
                    }, {
                        "name": "南京喜茶",
                        "id": 214510
                    }, {
                        "name": "东莞华为汽车",
                        "id": 214511
                    }, {
                        "name": "广州百度智能控股集团",
                        "id": 214512
                    }, {
                        "name": "广州特斯拉渔业",
                        "id": 214513
                    }, {
                        "name": "南京微软互金",
                        "id": 214514
                    }, {
                        "name": "纽约瑞幸银行",
                        "id": 214515
                    }, {
                        "name": "东莞瑞幸互金",
                        "id": 214516
                    }, {
                        "name": "深圳快手石油",
                        "id": 214517
                    }, {
                        "name": "北京快手地产",
                        "id": 214518
                    }, {
                        "name": "纽约谷歌智能",
                        "id": 214519
                    }, {
                        "name": "杭州腾讯汽车",
                        "id": 214520
                    }, {
                        "name": "杭州字节科技",
                        "id": 214521
                    }, {
                        "name": "深圳谷歌地摊控股集团",
                        "id": 214522
                    }, {
                        "name": "香港阿里医药",
                        "id": 214523
                    }, {
                        "name": "厦门阿里旅游",
                        "id": 214524
                    }, {
                        "name": "纽约字节软件",
                        "id": 214525
                    }, {
                        "name": "南京美团新能源控股集团",
                        "id": 214526
                    }, {
                        "name": "首尔阿里汽车",
                        "id": 214527
                    }, {
                        "name": "纽约平安医院",
                        "id": 214528
                    }, {
                        "name": "厦门喜茶牧业控股集团",
                        "id": 214529
                    }, {
                        "name": "南京平安医院",
                        "id": 214530
                    }, {
                        "name": "广州亚马逊地摊",
                        "id": 214531
                    }, {
                        "name": "纽约星巴克金融",
                        "id": 214532
                    }, {
                        "name": "广州喜茶渔业",
                        "id": 214533
                    }, {
                        "name": "台北瑞幸诊所控股集团",
                        "id": 214534
                    }, {
                        "name": "北京喜茶",
                        "id": 214535
                    }, {
                        "name": "首尔欧珀医院",
                        "id": 214536
                    }, {
                        "name": "东京字节制造",
                        "id": 214537
                    }, {
                        "name": "北京腾讯餐饮",
                        "id": 214538
                    }, {
                        "name": "厦门欧珀软件",
                        "id": 214539
                    }, {
                        "name": "东京阿里地产控股集团",
                        "id": 214540
                    }, {
                        "name": "香港瑞幸牧业有限公司",
                        "id": 214541
                    }, {
                        "name": "台北欧珀芯片",
                        "id": 214542
                    }]
                }, {
                    "name": "北京蚂蚁航空",
                    "id": 214543
                }, {
                    "name": "首尔美团控股集团",
                    "id": 214544
                }]
            }, {
                "name": "南京谷歌控股集团",
                "id": 214545
            }, {
                "name": "天津小米智能",
                "id": 214546
            }, {
                "name": "深圳百度餐饮",
                "id": 214547
            }, {
                "name": "深圳特斯拉证券",
                "id": 214548
            }, {
                "name": "北京腾讯信息服务",
                "id": 214549
            }, {
                "name": "香港谷歌地产",
                "id": 214550,
                "children": [{
                    "name": "上海微软智能有限公司",
                    "id": 214551,
                    "children": [{
                        "name": "广州必胜客控股集团",
                        "id": 214552
                    }, {
                        "name": "东莞喜茶医院控股集团",
                        "id": 214553
                    }, {
                        "name": "广州美团餐饮",
                        "id": 214554
                    }, {
                        "name": "天津肯德基计算机",
                        "id": 214555
                    }, {
                        "name": "南京必胜客科技",
                        "id": 214556
                    }, {
                        "name": "香港蚂蚁通讯控股集团",
                        "id": 214557
                    }, {
                        "name": "南京美团牧业",
                        "id": 214558
                    }, {
                        "name": "首尔京东信息服务",
                        "id": 214559
                    }, {
                        "name": "深圳苹果基金",
                        "id": 214560
                    }, {
                        "name": "北京奈雪航空有限公司",
                        "id": 214561
                    }, {
                        "name": "台北苹果地摊有限公司",
                        "id": 214562
                    }, {
                        "name": "厦门腾讯通讯",
                        "id": 214563
                    }, {
                        "name": "北京必胜客控股集团",
                        "id": 214564
                    }, {
                        "name": "东京亚马逊",
                        "id": 214565
                    }, {
                        "name": "东京腾讯地产控股集团",
                        "id": 214566
                    }, {
                        "name": "杭州谷歌渔业",
                        "id": 214567
                    }, {
                        "name": "上海星巴克金融有限公司",
                        "id": 214568
                    }, {
                        "name": "深圳喜茶有限公司",
                        "id": 214569
                    }, {
                        "name": "南京谷歌石油有限公司",
                        "id": 214570
                    }, {
                        "name": "东莞肯德基诊所控股集团",
                        "id": 214571
                    }, {
                        "name": "东京京东石油有限公司",
                        "id": 214572
                    }, {
                        "name": "杭州喜茶互金",
                        "id": 214573
                    }, {
                        "name": "深圳亚马逊证券",
                        "id": 214574
                    }, {
                        "name": "北京华为软件",
                        "id": 214575
                    }, {
                        "name": "天津微软信息服务",
                        "id": 214576
                    }, {
                        "name": "厦门喜茶牧业",
                        "id": 214577
                    }, {
                        "name": "纽约京东新能源",
                        "id": 214578
                    }, {
                        "name": "东莞蚂蚁餐饮",
                        "id": 214579
                    }, {
                        "name": "杭州喜茶诊所",
                        "id": 214580
                    }, {
                        "name": "上海腾讯农业",
                        "id": 214581
                    }, {
                        "name": "台北瑞幸银行",
                        "id": 214582
                    }, {
                        "name": "杭州亚马逊",
                        "id": 214583
                    }, {
                        "name": "杭州快手",
                        "id": 214584
                    }, {
                        "name": "上海百度科技",
                        "id": 214585
                    }]
                }, {
                    "name": "天津快手计算机有限公司",
                    "id": 214586
                }, {
                    "name": "杭州蚂蚁渔业",
                    "id": 214587
                }, {
                    "name": "南京字节石油",
                    "id": 214588
                }, {
                    "name": "深圳亚马逊芯片",
                    "id": 214589
                }, {
                    "name": "纽约亚马逊石油",
                    "id": 214590,
                    "children": [{
                        "name": "天津阿里智能有限公司",
                        "id": 214591
                    }, {
                        "name": "台北喜茶科技",
                        "id": 214592
                    }, {
                        "name": "纽约肯德基汽车",
                        "id": 214593
                    }, {
                        "name": "杭州快手",
                        "id": 214594
                    }, {
                        "name": "上海喜茶制造有限公司",
                        "id": 214595
                    }, {
                        "name": "杭州苹果诊所",
                        "id": 214596
                    }, {
                        "name": "香港谷歌医院",
                        "id": 214597
                    }, {
                        "name": "天津肯德基地产",
                        "id": 214598
                    }, {
                        "name": "杭州华为新能源",
                        "id": 214599
                    }, {
                        "name": "天津喜茶航空",
                        "id": 214600
                    }, {
                        "name": "上海腾讯互金",
                        "id": 214601
                    }, {
                        "name": "杭州肯德基智能",
                        "id": 214602
                    }, {
                        "name": "杭州欧珀农业控股集团",
                        "id": 214603
                    }, {
                        "name": "厦门星巴克智能有限公司",
                        "id": 214604
                    }, {
                        "name": "深圳瑞幸有限公司",
                        "id": 214605
                    }, {
                        "name": "东京阿里控股集团",
                        "id": 214606
                    }, {
                        "name": "深圳小米证券",
                        "id": 214607
                    }]
                }, {
                    "name": "东京微软通信控股集团",
                    "id": 214608
                }, {
                    "name": "首尔滴滴",
                    "id": 214609
                }, {
                    "name": "首尔特斯拉",
                    "id": 214610,
                    "children": [{
                        "name": "南京欧珀医院控股集团",
                        "id": 214611
                    }, {
                        "name": "香港瑞幸芯片控股集团",
                        "id": 214612
                    }, {
                        "name": "杭州蚂蚁诊所",
                        "id": 214613
                    }, {
                        "name": "香港肯德基旅游",
                        "id": 214614
                    }, {
                        "name": "南京必胜客医药",
                        "id": 214615
                    }, {
                        "name": "天津谷歌智能有限公司",
                        "id": 214616
                    }, {
                        "name": "北京快手银行",
                        "id": 214617
                    }, {
                        "name": "杭州滴滴通讯有限公司",
                        "id": 214618
                    }, {
                        "name": "东京瑞幸牧业",
                        "id": 214619
                    }, {
                        "name": "北京字节餐饮",
                        "id": 214620
                    }, {
                        "name": "东京喜茶制造",
                        "id": 214621
                    }, {
                        "name": "广州美团旅游",
                        "id": 214622
                    }, {
                        "name": "广州必胜客通讯",
                        "id": 214623
                    }, {
                        "name": "纽约京东智能控股集团",
                        "id": 214624
                    }, {
                        "name": "上海快手",
                        "id": 214625
                    }, {
                        "name": "深圳星巴克医药",
                        "id": 214626
                    }, {
                        "name": "台北百度信息服务有限公司",
                        "id": 214627
                    }, {
                        "name": "台北喜茶证券",
                        "id": 214628
                    }, {
                        "name": "深圳蚂蚁新能源",
                        "id": 214629
                    }, {
                        "name": "深圳腾讯电商有限公司",
                        "id": 214630
                    }]
                }, {
                    "name": "深圳特斯拉证券",
                    "id": 214631
                }, {
                    "name": "深圳亚马逊养殖",
                    "id": 214632,
                    "children": [{
                        "name": "杭州小米医院控股集团",
                        "id": 214633
                    }, {
                        "name": "东莞特斯拉地摊有限公司",
                        "id": 214634
                    }, {
                        "name": "厦门肯德基渔业",
                        "id": 214635
                    }, {
                        "name": "杭州华为餐饮",
                        "id": 214636
                    }, {
                        "name": "上海喜茶智能",
                        "id": 214637
                    }, {
                        "name": "东莞亚马逊诊所",
                        "id": 214638
                    }, {
                        "name": "厦门腾讯芯片控股集团",
                        "id": 214639
                    }, {
                        "name": "厦门喜茶",
                        "id": 214640
                    }, {
                        "name": "纽约欧珀汽车控股集团",
                        "id": 214641
                    }, {
                        "name": "香港京东通信有限公司",
                        "id": 214642
                    }, {
                        "name": "香港亚马逊电商",
                        "id": 214643
                    }, {
                        "name": "北京谷歌银行",
                        "id": 214644
                    }, {
                        "name": "杭州小米制造",
                        "id": 214645
                    }, {
                        "name": "首尔微软地摊",
                        "id": 214646
                    }, {
                        "name": "广州苹果智能有限公司",
                        "id": 214647
                    }, {
                        "name": "东莞蚂蚁证券控股集团",
                        "id": 214648
                    }, {
                        "name": "杭州星巴克银行",
                        "id": 214649
                    }, {
                        "name": "东京华为金融有限公司",
                        "id": 214650
                    }, {
                        "name": "北京腾讯基金",
                        "id": 214651
                    }]
                }, {
                    "name": "上海必胜客通讯控股集团",
                    "id": 214652
                }, {
                    "name": "上海喜茶",
                    "id": 214653,
                    "children": [{
                        "name": "东莞腾讯科技控股集团",
                        "id": 214654
                    }, {
                        "name": "北京瑞幸有限公司",
                        "id": 214655
                    }, {
                        "name": "北京喜茶养殖",
                        "id": 214656
                    }, {
                        "name": "首尔百度控股集团",
                        "id": 214657
                    }, {
                        "name": "杭州平安科技",
                        "id": 214658
                    }, {
                        "name": "天津美团地摊控股集团",
                        "id": 214659
                    }, {
                        "name": "厦门必胜客芯片",
                        "id": 214660
                    }, {
                        "name": "北京苹果科技",
                        "id": 214661
                    }, {
                        "name": "东京字节地摊控股集团",
                        "id": 214662
                    }, {
                        "name": "纽约瑞幸汽车",
                        "id": 214663
                    }, {
                        "name": "广州特斯拉控股集团",
                        "id": 214664
                    }, {
                        "name": "首尔喜茶控股集团",
                        "id": 214665
                    }, {
                        "name": "东京百度旅游",
                        "id": 214666
                    }, {
                        "name": "厦门谷歌餐饮控股集团",
                        "id": 214667
                    }, {
                        "name": "上海亚马逊互金有限公司",
                        "id": 214668
                    }, {
                        "name": "首尔字节软件控股集团",
                        "id": 214669
                    }, {
                        "name": "天津平安智能有限公司",
                        "id": 214670
                    }, {
                        "name": "首尔谷歌",
                        "id": 214671
                    }, {
                        "name": "广州苹果",
                        "id": 214672
                    }, {
                        "name": "杭州阿里地摊控股集团",
                        "id": 214673
                    }, {
                        "name": "杭州字节科技",
                        "id": 214674
                    }, {
                        "name": "南京瑞幸证券控股集团",
                        "id": 214675
                    }, {
                        "name": "厦门平安航空控股集团",
                        "id": 214676
                    }, {
                        "name": "台北字节地摊",
                        "id": 214677
                    }]
                }, {
                    "name": "香港欧珀软件",
                    "id": 214678,
                    "children": [{
                        "name": "厦门苹果医院",
                        "id": 214679
                    }, {
                        "name": "广州阿里石油控股集团",
                        "id": 214680
                    }, {
                        "name": "厦门星巴克诊所",
                        "id": 214681
                    }, {
                        "name": "东京微软金融有限公司",
                        "id": 214682
                    }, {
                        "name": "首尔特斯拉通讯有限公司",
                        "id": 214683
                    }, {
                        "name": "杭州蚂蚁石油有限公司",
                        "id": 214684
                    }, {
                        "name": "上海亚马逊智能控股集团",
                        "id": 214685
                    }, {
                        "name": "首尔蚂蚁牧业",
                        "id": 214686
                    }, {
                        "name": "香港星巴克汽车控股集团",
                        "id": 214687
                    }, {
                        "name": "天津百度软件",
                        "id": 214688
                    }, {
                        "name": "东莞蚂蚁智能",
                        "id": 214689
                    }, {
                        "name": "东京苹果渔业控股集团",
                        "id": 214690
                    }, {
                        "name": "上海阿里互金有限公司",
                        "id": 214691
                    }, {
                        "name": "广州星巴克新能源控股集团",
                        "id": 214692
                    }, {
                        "name": "东京阿里芯片",
                        "id": 214693
                    }, {
                        "name": "香港美团医院控股集团",
                        "id": 214694
                    }, {
                        "name": "杭州阿里新能源",
                        "id": 214695
                    }, {
                        "name": "南京平安电商",
                        "id": 214696
                    }, {
                        "name": "杭州谷歌餐饮有限公司",
                        "id": 214697
                    }]
                }, {
                    "name": "东莞微软汽车",
                    "id": 214698
                }, {
                    "name": "东莞欧珀计算机",
                    "id": 214699
                }, {
                    "name": "杭州平安互金有限公司",
                    "id": 214700
                }, {
                    "name": "东莞欧珀电商",
                    "id": 214701
                }, {
                    "name": "东莞京东新能源",
                    "id": 214702
                }, {
                    "name": "上海欧珀通讯",
                    "id": 214703
                }, {
                    "name": "天津必胜客地摊控股集团",
                    "id": 214704
                }, {
                    "name": "杭州蚂蚁基金",
                    "id": 214705,
                    "children": [{
                        "name": "纽约腾讯电商",
                        "id": 214706
                    }, {
                        "name": "台北必胜客石油",
                        "id": 214707
                    }, {
                        "name": "东京快手基金",
                        "id": 214708
                    }, {
                        "name": "厦门瑞幸芯片",
                        "id": 214709
                    }, {
                        "name": "纽约平安金融有限公司",
                        "id": 214710
                    }, {
                        "name": "纽约滴滴",
                        "id": 214711
                    }, {
                        "name": "南京百度",
                        "id": 214712
                    }, {
                        "name": "北京阿里新能源有限公司",
                        "id": 214713
                    }, {
                        "name": "广州百度互金控股集团",
                        "id": 214714
                    }, {
                        "name": "香港滴滴通讯",
                        "id": 214715
                    }, {
                        "name": "杭州谷歌养殖控股集团",
                        "id": 214716
                    }, {
                        "name": "台北百度石油有限公司",
                        "id": 214717
                    }]
                }]
            }, {
                "name": "东京特斯拉基金",
                "id": 214718
            }, {
                "name": "杭州平安餐饮",
                "id": 214719
            }, {
                "name": "东莞必胜客电商",
                "id": 214720
            }, {
                "name": "首尔平安制造",
                "id": 214721
            }, {
                "name": "台北星巴克银行",
                "id": 214722
            }, {
                "name": "天津必胜客汽车控股集团",
                "id": 214723
            }, {
                "name": "香港肯德基科技有限公司",
                "id": 214724,
                "children": [{
                    "name": "北京快手科技",
                    "id": 214725,
                    "children": [{
                        "name": "香港奈雪汽车",
                        "id": 214726
                    }, {
                        "name": "厦门快手养殖",
                        "id": 214727
                    }, {
                        "name": "台北美团金融",
                        "id": 214728
                    }, {
                        "name": "北京亚马逊",
                        "id": 214729
                    }, {
                        "name": "厦门快手地摊有限公司",
                        "id": 214730
                    }, {
                        "name": "南京亚马逊渔业有限公司",
                        "id": 214731
                    }, {
                        "name": "杭州喜茶有限公司",
                        "id": 214732
                    }, {
                        "name": "杭州小米银行",
                        "id": 214733
                    }, {
                        "name": "杭州阿里石油",
                        "id": 214734
                    }, {
                        "name": "纽约亚马逊渔业有限公司",
                        "id": 214735
                    }]
                }, {
                    "name": "杭州瑞幸计算机",
                    "id": 214736
                }, {
                    "name": "香港百度诊所控股集团",
                    "id": 214737,
                    "children": [{
                        "name": "深圳奈雪医院",
                        "id": 214738
                    }, {
                        "name": "深圳欧珀石油",
                        "id": 214739
                    }, {
                        "name": "上海星巴克养殖",
                        "id": 214740
                    }, {
                        "name": "广州谷歌渔业",
                        "id": 214741
                    }, {
                        "name": "首尔京东汽车",
                        "id": 214742
                    }, {
                        "name": "杭州亚马逊医院有限公司",
                        "id": 214743
                    }, {
                        "name": "首尔亚马逊芯片",
                        "id": 214744
                    }, {
                        "name": "厦门欧珀航空",
                        "id": 214745
                    }, {
                        "name": "首尔瑞幸基金",
                        "id": 214746
                    }, {
                        "name": "东莞瑞幸石油有限公司",
                        "id": 214747
                    }, {
                        "name": "首尔苹果软件",
                        "id": 214748
                    }]
                }, {
                    "name": "杭州华为地摊控股集团",
                    "id": 214749
                }]
            }]
        }, {
            "name": "台北滴滴",
            "id": 214750
        }, {
            "name": "上海平安石油",
            "id": 214751
        }, {
            "name": "南京欧珀石油",
            "id": 214752
        }, {
            "name": "天津星巴克制造",
            "id": 214753
        }, {
            "name": "杭州平安航空有限公司",
            "id": 214754
        }, {
            "name": "东莞苹果",
            "id": 214755
        }, {
            "name": "东莞微软汽车",
            "id": 214756
        }, {
            "name": "杭州必胜客基金控股集团",
            "id": 214757
        }, {
            "name": "杭州必胜客智能控股集团",
            "id": 214758
        }, {
            "name": "南京阿里医药控股集团",
            "id": 214759
        }]
    }, {
        "name": "纽约瑞幸渔业控股集团",
        "id": 214760
    }, {
        "name": "南京必胜客汽车控股集团",
        "id": 214761
    }, {
        "name": "深圳特斯拉控股集团",
        "id": 214762,
        "children": [{
            "name": "首尔美团证券",
            "id": 214763
        }, {
            "name": "东莞平安牧业",
            "id": 214764
        }, {
            "name": "深圳美团基金有限公司",
            "id": 214765
        }, {
            "name": "首尔必胜客银行控股集团",
            "id": 214766
        }, {
            "name": "厦门亚马逊证券",
            "id": 214767
        }, {
            "name": "杭州亚马逊芯片控股集团",
            "id": 214768
        }, {
            "name": "杭州星巴克金融",
            "id": 214769,
            "children": [{
                "name": "北京奈雪旅游控股集团",
                "id": 214770
            }, {
                "name": "杭州平安地摊",
                "id": 214771
            }, {
                "name": "东京平安电商",
                "id": 214772
            }, {
                "name": "广州星巴克证券",
                "id": 214773,
                "children": [{
                    "name": "广州快手养殖",
                    "id": 214774,
                    "children": [{
                        "name": "天津字节诊所有限公司",
                        "id": 214775
                    }, {
                        "name": "天津欧珀",
                        "id": 214776
                    }, {
                        "name": "台北小米智能",
                        "id": 214777
                    }, {
                        "name": "香港滴滴诊所",
                        "id": 214778
                    }, {
                        "name": "上海字节芯片",
                        "id": 214779
                    }, {
                        "name": "纽约喜茶基金",
                        "id": 214780
                    }, {
                        "name": "东莞喜茶旅游",
                        "id": 214781
                    }, {
                        "name": "纽约滴滴农业",
                        "id": 214782
                    }, {
                        "name": "深圳欧珀",
                        "id": 214783
                    }, {
                        "name": "杭州瑞幸旅游控股集团",
                        "id": 214784
                    }, {
                        "name": "厦门谷歌诊所",
                        "id": 214785
                    }, {
                        "name": "南京平安证券有限公司",
                        "id": 214786
                    }, {
                        "name": "纽约滴滴软件有限公司",
                        "id": 214787
                    }, {
                        "name": "厦门特斯拉基金",
                        "id": 214788
                    }, {
                        "name": "厦门欧珀医院",
                        "id": 214789
                    }, {
                        "name": "广州美团石油",
                        "id": 214790
                    }, {
                        "name": "天津特斯拉新能源控股集团",
                        "id": 214791
                    }, {
                        "name": "台北百度",
                        "id": 214792
                    }, {
                        "name": "香港小米信息服务",
                        "id": 214793
                    }, {
                        "name": "天津必胜客地产控股集团",
                        "id": 214794
                    }, {
                        "name": "上海微软石油",
                        "id": 214795
                    }, {
                        "name": "东莞微软芯片",
                        "id": 214796
                    }, {
                        "name": "厦门特斯拉农业",
                        "id": 214797
                    }, {
                        "name": "杭州小米医药",
                        "id": 214798
                    }, {
                        "name": "深圳必胜客银行",
                        "id": 214799
                    }, {
                        "name": "东京百度旅游控股集团",
                        "id": 214800
                    }, {
                        "name": "纽约滴滴地产",
                        "id": 214801
                    }]
                }, {
                    "name": "上海美团通讯",
                    "id": 214802
                }, {
                    "name": "天津必胜客航空",
                    "id": 214803
                }, {
                    "name": "首尔京东智能",
                    "id": 214804
                }, {
                    "name": "杭州谷歌医药",
                    "id": 214805
                }, {
                    "name": "杭州星巴克",
                    "id": 214806
                }, {
                    "name": "上海美团医院控股集团",
                    "id": 214807,
                    "children": [{
                        "name": "香港华为农业",
                        "id": 214808
                    }, {
                        "name": "上海平安地摊",
                        "id": 214809
                    }, {
                        "name": "上海奈雪农业控股集团",
                        "id": 214810
                    }, {
                        "name": "厦门字节信息服务控股集团",
                        "id": 214811
                    }, {
                        "name": "广州阿里互金有限公司",
                        "id": 214812
                    }, {
                        "name": "首尔快手基金控股集团",
                        "id": 214813
                    }, {
                        "name": "首尔特斯拉制造",
                        "id": 214814
                    }, {
                        "name": "杭州腾讯控股集团",
                        "id": 214815
                    }, {
                        "name": "首尔谷歌地摊",
                        "id": 214816
                    }, {
                        "name": "杭州瑞幸医院",
                        "id": 214817
                    }, {
                        "name": "香港滴滴科技控股集团",
                        "id": 214818
                    }, {
                        "name": "广州华为控股集团",
                        "id": 214819
                    }, {
                        "name": "首尔阿里新能源",
                        "id": 214820
                    }, {
                        "name": "纽约肯德基计算机控股集团",
                        "id": 214821
                    }, {
                        "name": "厦门百度科技",
                        "id": 214822
                    }, {
                        "name": "杭州百度诊所",
                        "id": 214823
                    }, {
                        "name": "杭州腾讯渔业",
                        "id": 214824
                    }, {
                        "name": "天津京东计算机控股集团",
                        "id": 214825
                    }, {
                        "name": "纽约奈雪通讯",
                        "id": 214826
                    }, {
                        "name": "天津必胜客控股集团",
                        "id": 214827
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 214828
                    }, {
                        "name": "杭州快手地产",
                        "id": 214829
                    }, {
                        "name": "纽约小米金融",
                        "id": 214830
                    }, {
                        "name": "北京华为银行",
                        "id": 214831
                    }, {
                        "name": "首尔瑞幸诊所",
                        "id": 214832
                    }, {
                        "name": "深圳阿里智能",
                        "id": 214833
                    }, {
                        "name": "纽约特斯拉基金",
                        "id": 214834
                    }, {
                        "name": "广州瑞幸证券控股集团",
                        "id": 214835
                    }, {
                        "name": "厦门平安地摊",
                        "id": 214836
                    }, {
                        "name": "深圳蚂蚁智能",
                        "id": 214837
                    }, {
                        "name": "纽约蚂蚁金融控股集团",
                        "id": 214838
                    }, {
                        "name": "香港喜茶信息服务",
                        "id": 214839
                    }, {
                        "name": "东莞奈雪养殖",
                        "id": 214840
                    }]
                }]
            }, {
                "name": "东莞奈雪航空",
                "id": 214841
            }, {
                "name": "北京瑞幸金融有限公司",
                "id": 214842,
                "children": [{
                    "name": "纽约欧珀",
                    "id": 214843
                }, {
                    "name": "深圳腾讯银行",
                    "id": 214844
                }, {
                    "name": "南京字节餐饮有限公司",
                    "id": 214845
                }, {
                    "name": "南京奈雪金融",
                    "id": 214846,
                    "children": [{
                        "name": "东莞苹果",
                        "id": 214847
                    }, {
                        "name": "深圳快手银行",
                        "id": 214848
                    }, {
                        "name": "天津滴滴汽车",
                        "id": 214849
                    }, {
                        "name": "北京苹果控股集团",
                        "id": 214850
                    }, {
                        "name": "台北欧珀金融",
                        "id": 214851
                    }, {
                        "name": "台北华为航空有限公司",
                        "id": 214852
                    }, {
                        "name": "厦门滴滴渔业",
                        "id": 214853
                    }, {
                        "name": "广州肯德基科技有限公司",
                        "id": 214854
                    }, {
                        "name": "杭州快手汽车",
                        "id": 214855
                    }, {
                        "name": "东莞小米软件控股集团",
                        "id": 214856
                    }, {
                        "name": "杭州亚马逊牧业有限公司",
                        "id": 214857
                    }, {
                        "name": "深圳滴滴电商",
                        "id": 214858
                    }, {
                        "name": "东莞快手",
                        "id": 214859
                    }, {
                        "name": "广州滴滴诊所控股集团",
                        "id": 214860
                    }, {
                        "name": "杭州谷歌航空",
                        "id": 214861
                    }, {
                        "name": "纽约小米银行控股集团",
                        "id": 214862
                    }, {
                        "name": "杭州谷歌餐饮",
                        "id": 214863
                    }, {
                        "name": "广州蚂蚁农业控股集团",
                        "id": 214864
                    }, {
                        "name": "东京星巴克餐饮",
                        "id": 214865
                    }, {
                        "name": "北京华为养殖",
                        "id": 214866
                    }, {
                        "name": "东莞苹果软件",
                        "id": 214867
                    }, {
                        "name": "杭州华为芯片控股集团",
                        "id": 214868
                    }, {
                        "name": "台北谷歌诊所",
                        "id": 214869
                    }, {
                        "name": "上海平安地摊",
                        "id": 214870
                    }, {
                        "name": "香港欧珀餐饮",
                        "id": 214871
                    }, {
                        "name": "天津小米地摊",
                        "id": 214872
                    }, {
                        "name": "纽约亚马逊计算机控股集团",
                        "id": 214873
                    }, {
                        "name": "香港阿里航空",
                        "id": 214874
                    }, {
                        "name": "东京欧珀渔业",
                        "id": 214875
                    }, {
                        "name": "杭州快手农业",
                        "id": 214876
                    }, {
                        "name": "香港瑞幸计算机",
                        "id": 214877
                    }, {
                        "name": "深圳美团银行",
                        "id": 214878
                    }]
                }, {
                    "name": "上海微软科技有限公司",
                    "id": 214879
                }, {
                    "name": "首尔苹果有限公司",
                    "id": 214880
                }, {
                    "name": "东莞小米医药",
                    "id": 214881
                }, {
                    "name": "杭州华为地产有限公司",
                    "id": 214882
                }, {
                    "name": "杭州阿里牧业控股集团",
                    "id": 214883
                }, {
                    "name": "首尔喜茶芯片",
                    "id": 214884,
                    "children": [{
                        "name": "纽约苹果金融",
                        "id": 214885
                    }, {
                        "name": "台北字节航空",
                        "id": 214886
                    }, {
                        "name": "杭州小米通讯有限公司",
                        "id": 214887
                    }, {
                        "name": "香港阿里芯片有限公司",
                        "id": 214888
                    }, {
                        "name": "纽约美团新能源",
                        "id": 214889
                    }, {
                        "name": "东莞喜茶制造控股集团",
                        "id": 214890
                    }]
                }, {
                    "name": "香港快手芯片",
                    "id": 214891
                }, {
                    "name": "杭州百度证券",
                    "id": 214892
                }, {
                    "name": "广州微软地产",
                    "id": 214893,
                    "children": [{
                        "name": "香港谷歌电商",
                        "id": 214894
                    }, {
                        "name": "东京特斯拉科技",
                        "id": 214895
                    }, {
                        "name": "首尔星巴克养殖有限公司",
                        "id": 214896
                    }, {
                        "name": "杭州滴滴金融",
                        "id": 214897
                    }, {
                        "name": "东莞微软科技",
                        "id": 214898
                    }, {
                        "name": "天津阿里医院",
                        "id": 214899
                    }, {
                        "name": "杭州谷歌地产",
                        "id": 214900
                    }, {
                        "name": "东京奈雪",
                        "id": 214901
                    }, {
                        "name": "东莞必胜客石油",
                        "id": 214902
                    }, {
                        "name": "北京亚马逊诊所有限公司",
                        "id": 214903
                    }]
                }, {
                    "name": "纽约奈雪芯片",
                    "id": 214904
                }, {
                    "name": "深圳必胜客航空",
                    "id": 214905
                }, {
                    "name": "纽约华为牧业有限公司",
                    "id": 214906
                }, {
                    "name": "杭州蚂蚁诊所",
                    "id": 214907
                }, {
                    "name": "东京阿里芯片",
                    "id": 214908
                }, {
                    "name": "广州喜茶汽车",
                    "id": 214909
                }, {
                    "name": "台北腾讯互金有限公司",
                    "id": 214910
                }, {
                    "name": "广州华为控股集团",
                    "id": 214911
                }, {
                    "name": "广州微软",
                    "id": 214912
                }, {
                    "name": "纽约腾讯有限公司",
                    "id": 214913
                }, {
                    "name": "天津喜茶养殖控股集团",
                    "id": 214914
                }, {
                    "name": "天津奈雪医院",
                    "id": 214915
                }, {
                    "name": "纽约滴滴证券",
                    "id": 214916,
                    "children": [{
                        "name": "香港美团银行",
                        "id": 214917
                    }]
                }, {
                    "name": "厦门肯德基互金",
                    "id": 214918
                }]
            }, {
                "name": "杭州微软金融",
                "id": 214919
            }, {
                "name": "杭州特斯拉芯片",
                "id": 214920
            }, {
                "name": "天津谷歌石油",
                "id": 214921,
                "children": [{
                    "name": "广州谷歌餐饮控股集团",
                    "id": 214922,
                    "children": [{
                        "name": "深圳欧珀新能源",
                        "id": 214923
                    }, {
                        "name": "杭州美团芯片",
                        "id": 214924
                    }, {
                        "name": "杭州百度地摊控股集团",
                        "id": 214925
                    }, {
                        "name": "广州平安",
                        "id": 214926
                    }, {
                        "name": "北京蚂蚁农业",
                        "id": 214927
                    }, {
                        "name": "杭州滴滴",
                        "id": 214928
                    }, {
                        "name": "广州瑞幸银行",
                        "id": 214929
                    }, {
                        "name": "广州必胜客",
                        "id": 214930
                    }, {
                        "name": "台北阿里软件",
                        "id": 214931
                    }, {
                        "name": "杭州美团计算机有限公司",
                        "id": 214932
                    }, {
                        "name": "东莞特斯拉新能源",
                        "id": 214933
                    }, {
                        "name": "上海欧珀",
                        "id": 214934
                    }, {
                        "name": "杭州肯德基地摊",
                        "id": 214935
                    }, {
                        "name": "杭州喜茶科技有限公司",
                        "id": 214936
                    }, {
                        "name": "北京滴滴证券",
                        "id": 214937
                    }]
                }, {
                    "name": "杭州美团芯片",
                    "id": 214938
                }, {
                    "name": "首尔亚马逊互金",
                    "id": 214939
                }, {
                    "name": "广州欧珀芯片控股集团",
                    "id": 214940,
                    "children": [{
                        "name": "纽约腾讯银行",
                        "id": 214941
                    }, {
                        "name": "北京百度通信",
                        "id": 214942
                    }, {
                        "name": "东莞美团地摊有限公司",
                        "id": 214943
                    }, {
                        "name": "台北肯德基银行有限公司",
                        "id": 214944
                    }, {
                        "name": "纽约瑞幸农业",
                        "id": 214945
                    }, {
                        "name": "台北京东航空控股集团",
                        "id": 214946
                    }, {
                        "name": "南京特斯拉金融",
                        "id": 214947
                    }, {
                        "name": "深圳星巴克互金",
                        "id": 214948
                    }, {
                        "name": "台北滴滴",
                        "id": 214949
                    }, {
                        "name": "南京百度航空",
                        "id": 214950
                    }, {
                        "name": "杭州特斯拉农业有限公司",
                        "id": 214951
                    }, {
                        "name": "深圳喜茶基金",
                        "id": 214952
                    }, {
                        "name": "台北苹果农业有限公司",
                        "id": 214953
                    }, {
                        "name": "厦门特斯拉石油",
                        "id": 214954
                    }]
                }, {
                    "name": "南京百度石油控股集团",
                    "id": 214955
                }, {
                    "name": "上海滴滴计算机",
                    "id": 214956
                }, {
                    "name": "台北美团诊所控股集团",
                    "id": 214957
                }, {
                    "name": "台北阿里养殖",
                    "id": 214958
                }, {
                    "name": "杭州肯德基汽车控股集团",
                    "id": 214959
                }, {
                    "name": "厦门字节芯片",
                    "id": 214960
                }, {
                    "name": "杭州苹果软件",
                    "id": 214961
                }, {
                    "name": "广州平安电商控股集团",
                    "id": 214962
                }, {
                    "name": "杭州瑞幸航空",
                    "id": 214963,
                    "children": [{
                        "name": "杭州喜茶芯片",
                        "id": 214964
                    }, {
                        "name": "北京微软电商",
                        "id": 214965
                    }, {
                        "name": "南京必胜客电商",
                        "id": 214966
                    }, {
                        "name": "杭州快手农业",
                        "id": 214967
                    }, {
                        "name": "杭州平安芯片",
                        "id": 214968
                    }, {
                        "name": "东京滴滴计算机",
                        "id": 214969
                    }, {
                        "name": "厦门谷歌餐饮",
                        "id": 214970
                    }, {
                        "name": "纽约苹果汽车",
                        "id": 214971
                    }, {
                        "name": "台北必胜客牧业",
                        "id": 214972
                    }, {
                        "name": "上海京东信息服务",
                        "id": 214973
                    }, {
                        "name": "深圳谷歌科技控股集团",
                        "id": 214974
                    }, {
                        "name": "厦门星巴克科技",
                        "id": 214975
                    }, {
                        "name": "台北小米科技",
                        "id": 214976
                    }, {
                        "name": "深圳特斯拉餐饮",
                        "id": 214977
                    }, {
                        "name": "杭州腾讯制造有限公司",
                        "id": 214978
                    }, {
                        "name": "天津亚马逊",
                        "id": 214979
                    }]
                }, {
                    "name": "东莞喜茶通讯控股集团",
                    "id": 214980,
                    "children": [{
                        "name": "深圳瑞幸银行控股集团",
                        "id": 214981
                    }, {
                        "name": "东京京东",
                        "id": 214982
                    }, {
                        "name": "天津蚂蚁",
                        "id": 214983
                    }, {
                        "name": "东莞亚马逊通信",
                        "id": 214984
                    }, {
                        "name": "台北亚马逊金融有限公司",
                        "id": 214985
                    }, {
                        "name": "杭州星巴克餐饮",
                        "id": 214986
                    }, {
                        "name": "东莞必胜客",
                        "id": 214987
                    }, {
                        "name": "北京阿里通讯",
                        "id": 214988
                    }, {
                        "name": "北京蚂蚁地产",
                        "id": 214989
                    }, {
                        "name": "首尔蚂蚁制造控股集团",
                        "id": 214990
                    }, {
                        "name": "北京喜茶制造控股集团",
                        "id": 214991
                    }, {
                        "name": "香港喜茶医院控股集团",
                        "id": 214992
                    }, {
                        "name": "天津星巴克新能源",
                        "id": 214993
                    }, {
                        "name": "首尔华为医院",
                        "id": 214994
                    }, {
                        "name": "杭州小米地产",
                        "id": 214995
                    }, {
                        "name": "台北微软通信",
                        "id": 214996
                    }]
                }, {
                    "name": "东莞蚂蚁计算机有限公司",
                    "id": 214997
                }, {
                    "name": "台北字节金融",
                    "id": 214998
                }, {
                    "name": "杭州瑞幸证券",
                    "id": 214999
                }, {
                    "name": "天津特斯拉汽车",
                    "id": 215000
                }, {
                    "name": "杭州谷歌电商",
                    "id": 215001
                }, {
                    "name": "上海必胜客银行有限公司",
                    "id": 215002
                }, {
                    "name": "广州必胜客汽车控股集团",
                    "id": 215003,
                    "children": [{
                        "name": "香港字节农业",
                        "id": 215004
                    }]
                }, {
                    "name": "杭州华为信息服务",
                    "id": 215005
                }, {
                    "name": "天津苹果医药",
                    "id": 215006,
                    "children": [{
                        "name": "深圳滴滴通讯",
                        "id": 215007
                    }, {
                        "name": "北京蚂蚁农业",
                        "id": 215008
                    }, {
                        "name": "首尔谷歌旅游",
                        "id": 215009
                    }, {
                        "name": "天津喜茶餐饮",
                        "id": 215010
                    }, {
                        "name": "北京特斯拉基金",
                        "id": 215011
                    }, {
                        "name": "东京平安医药",
                        "id": 215012
                    }, {
                        "name": "纽约百度牧业控股集团",
                        "id": 215013
                    }, {
                        "name": "台北滴滴石油控股集团",
                        "id": 215014
                    }, {
                        "name": "杭州字节软件有限公司",
                        "id": 215015
                    }, {
                        "name": "深圳快手地产",
                        "id": 215016
                    }, {
                        "name": "南京欧珀",
                        "id": 215017
                    }, {
                        "name": "东京字节诊所",
                        "id": 215018
                    }, {
                        "name": "天津必胜客汽车",
                        "id": 215019
                    }, {
                        "name": "香港百度制造",
                        "id": 215020
                    }, {
                        "name": "南京亚马逊新能源控股集团",
                        "id": 215021
                    }, {
                        "name": "北京美团诊所有限公司",
                        "id": 215022
                    }, {
                        "name": "上海必胜客航空",
                        "id": 215023
                    }, {
                        "name": "南京百度牧业",
                        "id": 215024
                    }, {
                        "name": "台北百度医院",
                        "id": 215025
                    }, {
                        "name": "东莞星巴克银行",
                        "id": 215026
                    }, {
                        "name": "杭州苹果芯片",
                        "id": 215027
                    }, {
                        "name": "深圳欧珀计算机有限公司",
                        "id": 215028
                    }, {
                        "name": "深圳字节证券",
                        "id": 215029
                    }, {
                        "name": "南京苹果金融",
                        "id": 215030
                    }, {
                        "name": "东莞微软互金",
                        "id": 215031
                    }, {
                        "name": "杭州京东计算机",
                        "id": 215032
                    }, {
                        "name": "南京苹果石油",
                        "id": 215033
                    }, {
                        "name": "台北快手金融",
                        "id": 215034
                    }, {
                        "name": "台北谷歌科技",
                        "id": 215035
                    }, {
                        "name": "纽约苹果计算机",
                        "id": 215036
                    }, {
                        "name": "广州亚马逊通讯",
                        "id": 215037
                    }, {
                        "name": "杭州腾讯医药",
                        "id": 215038
                    }, {
                        "name": "南京微软石油",
                        "id": 215039
                    }, {
                        "name": "南京京东旅游有限公司",
                        "id": 215040
                    }, {
                        "name": "北京平安",
                        "id": 215041
                    }, {
                        "name": "杭州平安牧业",
                        "id": 215042
                    }]
                }, {
                    "name": "厦门华为银行有限公司",
                    "id": 215043
                }, {
                    "name": "东京快手银行控股集团",
                    "id": 215044
                }, {
                    "name": "纽约欧珀养殖有限公司",
                    "id": 215045
                }, {
                    "name": "上海肯德基证券",
                    "id": 215046
                }, {
                    "name": "上海美团控股集团",
                    "id": 215047,
                    "children": [{
                        "name": "广州苹果电商",
                        "id": 215048
                    }, {
                        "name": "杭州星巴克控股集团",
                        "id": 215049
                    }, {
                        "name": "东莞滴滴电商",
                        "id": 215050
                    }, {
                        "name": "厦门小米证券控股集团",
                        "id": 215051
                    }]
                }, {
                    "name": "纽约快手计算机",
                    "id": 215052
                }, {
                    "name": "东莞阿里地产",
                    "id": 215053
                }, {
                    "name": "上海苹果地摊",
                    "id": 215054
                }, {
                    "name": "深圳欧珀互金",
                    "id": 215055
                }]
            }, {
                "name": "台北华为软件",
                "id": 215056,
                "children": [{
                    "name": "南京欧珀基金",
                    "id": 215057
                }, {
                    "name": "厦门腾讯医院",
                    "id": 215058
                }, {
                    "name": "首尔喜茶科技控股集团",
                    "id": 215059
                }, {
                    "name": "北京微软医院",
                    "id": 215060
                }, {
                    "name": "南京小米汽车有限公司",
                    "id": 215061,
                    "children": [{
                        "name": "广州腾讯科技",
                        "id": 215062
                    }, {
                        "name": "首尔瑞幸通讯",
                        "id": 215063
                    }, {
                        "name": "首尔美团金融有限公司",
                        "id": 215064
                    }, {
                        "name": "广州京东智能有限公司",
                        "id": 215065
                    }, {
                        "name": "香港谷歌旅游",
                        "id": 215066
                    }, {
                        "name": "北京微软计算机",
                        "id": 215067
                    }, {
                        "name": "东莞百度诊所",
                        "id": 215068
                    }, {
                        "name": "香港欧珀基金",
                        "id": 215069
                    }, {
                        "name": "深圳微软",
                        "id": 215070
                    }, {
                        "name": "纽约京东基金",
                        "id": 215071
                    }, {
                        "name": "杭州快手信息服务",
                        "id": 215072
                    }, {
                        "name": "香港特斯拉通信",
                        "id": 215073
                    }, {
                        "name": "北京阿里农业",
                        "id": 215074
                    }, {
                        "name": "北京谷歌牧业控股集团",
                        "id": 215075
                    }, {
                        "name": "天津苹果",
                        "id": 215076
                    }, {
                        "name": "广州苹果航空有限公司",
                        "id": 215077
                    }, {
                        "name": "天津滴滴",
                        "id": 215078
                    }, {
                        "name": "广州滴滴通信有限公司",
                        "id": 215079
                    }, {
                        "name": "杭州阿里汽车",
                        "id": 215080
                    }, {
                        "name": "南京腾讯地摊",
                        "id": 215081
                    }, {
                        "name": "东京快手",
                        "id": 215082
                    }, {
                        "name": "杭州奈雪农业",
                        "id": 215083
                    }, {
                        "name": "南京字节信息服务",
                        "id": 215084
                    }, {
                        "name": "东京美团芯片",
                        "id": 215085
                    }, {
                        "name": "首尔微软软件",
                        "id": 215086
                    }, {
                        "name": "杭州滴滴基金",
                        "id": 215087
                    }, {
                        "name": "上海蚂蚁制造",
                        "id": 215088
                    }, {
                        "name": "首尔亚马逊智能控股集团",
                        "id": 215089
                    }, {
                        "name": "上海奈雪证券",
                        "id": 215090
                    }, {
                        "name": "杭州华为汽车控股集团",
                        "id": 215091
                    }, {
                        "name": "厦门字节地产",
                        "id": 215092
                    }]
                }, {
                    "name": "东京阿里信息服务",
                    "id": 215093,
                    "children": [{
                        "name": "纽约星巴克科技有限公司",
                        "id": 215094
                    }, {
                        "name": "北京星巴克汽车",
                        "id": 215095
                    }, {
                        "name": "首尔必胜客新能源",
                        "id": 215096
                    }, {
                        "name": "杭州喜茶医药",
                        "id": 215097
                    }, {
                        "name": "东京滴滴互金",
                        "id": 215098
                    }, {
                        "name": "首尔奈雪计算机有限公司",
                        "id": 215099
                    }, {
                        "name": "首尔快手信息服务有限公司",
                        "id": 215100
                    }, {
                        "name": "广州苹果餐饮",
                        "id": 215101
                    }, {
                        "name": "广州欧珀芯片",
                        "id": 215102
                    }, {
                        "name": "厦门亚马逊信息服务",
                        "id": 215103
                    }, {
                        "name": "北京京东通信控股集团",
                        "id": 215104
                    }, {
                        "name": "纽约肯德基航空",
                        "id": 215105
                    }, {
                        "name": "台北百度养殖控股集团",
                        "id": 215106
                    }, {
                        "name": "杭州华为医院",
                        "id": 215107
                    }, {
                        "name": "厦门肯德基通信控股集团",
                        "id": 215108
                    }, {
                        "name": "首尔欧珀证券控股集团",
                        "id": 215109
                    }, {
                        "name": "深圳平安金融",
                        "id": 215110
                    }, {
                        "name": "深圳必胜客农业",
                        "id": 215111
                    }, {
                        "name": "厦门阿里银行有限公司",
                        "id": 215112
                    }, {
                        "name": "东京喜茶通信",
                        "id": 215113
                    }]
                }, {
                    "name": "南京阿里航空",
                    "id": 215114
                }, {
                    "name": "杭州字节电商控股集团",
                    "id": 215115
                }, {
                    "name": "东京华为农业",
                    "id": 215116,
                    "children": [{
                        "name": "台北欧珀诊所",
                        "id": 215117
                    }, {
                        "name": "杭州华为诊所",
                        "id": 215118
                    }, {
                        "name": "杭州阿里计算机有限公司",
                        "id": 215119
                    }, {
                        "name": "东京肯德基制造控股集团",
                        "id": 215120
                    }, {
                        "name": "东莞肯德基石油",
                        "id": 215121
                    }, {
                        "name": "深圳美团诊所控股集团",
                        "id": 215122
                    }, {
                        "name": "香港美团",
                        "id": 215123
                    }]
                }, {
                    "name": "深圳谷歌旅游",
                    "id": 215124
                }, {
                    "name": "纽约欧珀软件控股集团",
                    "id": 215125
                }, {
                    "name": "杭州美团医院",
                    "id": 215126,
                    "children": [{
                        "name": "厦门百度证券",
                        "id": 215127
                    }, {
                        "name": "天津华为信息服务有限公司",
                        "id": 215128
                    }, {
                        "name": "广州谷歌软件",
                        "id": 215129
                    }, {
                        "name": "香港美团科技控股集团",
                        "id": 215130
                    }, {
                        "name": "纽约亚马逊汽车",
                        "id": 215131
                    }, {
                        "name": "东京平安金融控股集团",
                        "id": 215132
                    }, {
                        "name": "北京必胜客证券有限公司",
                        "id": 215133
                    }, {
                        "name": "首尔特斯拉有限公司",
                        "id": 215134
                    }, {
                        "name": "上海华为软件有限公司",
                        "id": 215135
                    }, {
                        "name": "深圳平安地产",
                        "id": 215136
                    }, {
                        "name": "东莞平安银行",
                        "id": 215137
                    }, {
                        "name": "深圳腾讯互金控股集团",
                        "id": 215138
                    }, {
                        "name": "台北字节",
                        "id": 215139
                    }, {
                        "name": "厦门字节软件",
                        "id": 215140
                    }, {
                        "name": "北京阿里旅游",
                        "id": 215141
                    }, {
                        "name": "深圳快手诊所",
                        "id": 215142
                    }]
                }, {
                    "name": "杭州星巴克餐饮",
                    "id": 215143
                }, {
                    "name": "南京瑞幸",
                    "id": 215144
                }, {
                    "name": "广州腾讯证券",
                    "id": 215145,
                    "children": [{
                        "name": "上海百度餐饮",
                        "id": 215146
                    }, {
                        "name": "香港百度牧业控股集团",
                        "id": 215147
                    }, {
                        "name": "台北特斯拉通讯控股集团",
                        "id": 215148
                    }, {
                        "name": "香港腾讯航空",
                        "id": 215149
                    }, {
                        "name": "杭州微软旅游",
                        "id": 215150
                    }, {
                        "name": "首尔欧珀软件",
                        "id": 215151
                    }, {
                        "name": "北京腾讯航空",
                        "id": 215152
                    }, {
                        "name": "北京亚马逊通讯控股集团",
                        "id": 215153
                    }, {
                        "name": "广州华为地摊有限公司",
                        "id": 215154
                    }, {
                        "name": "杭州字节基金",
                        "id": 215155
                    }, {
                        "name": "东京平安医药",
                        "id": 215156
                    }, {
                        "name": "广州蚂蚁软件控股集团",
                        "id": 215157
                    }, {
                        "name": "杭州蚂蚁汽车",
                        "id": 215158
                    }, {
                        "name": "东莞喜茶农业有限公司",
                        "id": 215159
                    }, {
                        "name": "东莞苹果信息服务",
                        "id": 215160
                    }, {
                        "name": "首尔肯德基电商控股集团",
                        "id": 215161
                    }, {
                        "name": "南京奈雪软件",
                        "id": 215162
                    }]
                }, {
                    "name": "南京苹果智能有限公司",
                    "id": 215163,
                    "children": [{
                        "name": "深圳百度金融",
                        "id": 215164
                    }, {
                        "name": "东京滴滴医药",
                        "id": 215165
                    }, {
                        "name": "南京快手新能源",
                        "id": 215166
                    }, {
                        "name": "天津喜茶有限公司",
                        "id": 215167
                    }, {
                        "name": "香港瑞幸信息服务控股集团",
                        "id": 215168
                    }, {
                        "name": "厦门腾讯智能",
                        "id": 215169
                    }, {
                        "name": "纽约蚂蚁渔业",
                        "id": 215170
                    }, {
                        "name": "东莞滴滴证券控股集团",
                        "id": 215171
                    }, {
                        "name": "天津苹果牧业",
                        "id": 215172
                    }, {
                        "name": "台北肯德基石油控股集团",
                        "id": 215173
                    }, {
                        "name": "东莞肯德基通讯",
                        "id": 215174
                    }, {
                        "name": "北京阿里农业有限公司",
                        "id": 215175
                    }, {
                        "name": "东莞星巴克证券控股集团",
                        "id": 215176
                    }, {
                        "name": "东京蚂蚁诊所",
                        "id": 215177
                    }, {
                        "name": "东莞字节基金",
                        "id": 215178
                    }, {
                        "name": "天津滴滴证券",
                        "id": 215179
                    }, {
                        "name": "香港欧珀银行",
                        "id": 215180
                    }, {
                        "name": "台北美团地摊有限公司",
                        "id": 215181
                    }, {
                        "name": "广州星巴克医院",
                        "id": 215182
                    }, {
                        "name": "东莞特斯拉互金有限公司",
                        "id": 215183
                    }, {
                        "name": "首尔欧珀基金控股集团",
                        "id": 215184
                    }, {
                        "name": "杭州字节银行",
                        "id": 215185
                    }, {
                        "name": "深圳阿里",
                        "id": 215186
                    }, {
                        "name": "厦门喜茶金融控股集团",
                        "id": 215187
                    }]
                }, {
                    "name": "台北谷歌诊所",
                    "id": 215188
                }, {
                    "name": "南京百度科技",
                    "id": 215189
                }, {
                    "name": "东京滴滴计算机",
                    "id": 215190
                }]
            }, {
                "name": "广州苹果通讯",
                "id": 215191
            }, {
                "name": "纽约瑞幸有限公司",
                "id": 215192
            }, {
                "name": "深圳瑞幸科技控股集团",
                "id": 215193,
                "children": [{
                    "name": "北京滴滴有限公司",
                    "id": 215194
                }, {
                    "name": "广州京东银行",
                    "id": 215195,
                    "children": [{
                        "name": "天津阿里诊所",
                        "id": 215196
                    }, {
                        "name": "上海谷歌计算机",
                        "id": 215197
                    }, {
                        "name": "东莞美团软件",
                        "id": 215198
                    }, {
                        "name": "上海亚马逊计算机",
                        "id": 215199
                    }, {
                        "name": "首尔谷歌牧业有限公司",
                        "id": 215200
                    }, {
                        "name": "东莞百度航空有限公司",
                        "id": 215201
                    }, {
                        "name": "上海阿里信息服务",
                        "id": 215202
                    }, {
                        "name": "东京字节软件",
                        "id": 215203
                    }, {
                        "name": "台北亚马逊通信",
                        "id": 215204
                    }, {
                        "name": "首尔苹果牧业",
                        "id": 215205
                    }, {
                        "name": "东京京东农业控股集团",
                        "id": 215206
                    }, {
                        "name": "厦门瑞幸牧业",
                        "id": 215207
                    }, {
                        "name": "广州微软控股集团",
                        "id": 215208
                    }, {
                        "name": "天津瑞幸地摊有限公司",
                        "id": 215209
                    }, {
                        "name": "杭州星巴克医院",
                        "id": 215210
                    }, {
                        "name": "北京奈雪基金控股集团",
                        "id": 215211
                    }, {
                        "name": "南京亚马逊电商控股集团",
                        "id": 215212
                    }]
                }, {
                    "name": "天津欧珀医药",
                    "id": 215213
                }, {
                    "name": "南京小米新能源",
                    "id": 215214
                }, {
                    "name": "天津微软通讯有限公司",
                    "id": 215215
                }, {
                    "name": "北京谷歌医院有限公司",
                    "id": 215216,
                    "children": [{
                        "name": "首尔小米电商",
                        "id": 215217
                    }, {
                        "name": "东莞美团智能",
                        "id": 215218
                    }, {
                        "name": "首尔蚂蚁牧业",
                        "id": 215219
                    }, {
                        "name": "台北百度计算机控股集团",
                        "id": 215220
                    }, {
                        "name": "深圳欧珀电商",
                        "id": 215221
                    }, {
                        "name": "深圳平安通信控股集团",
                        "id": 215222
                    }, {
                        "name": "东京京东地产",
                        "id": 215223
                    }, {
                        "name": "天津字节旅游",
                        "id": 215224
                    }, {
                        "name": "东京亚马逊科技",
                        "id": 215225
                    }, {
                        "name": "杭州京东软件",
                        "id": 215226
                    }, {
                        "name": "台北喜茶石油",
                        "id": 215227
                    }, {
                        "name": "杭州特斯拉渔业",
                        "id": 215228
                    }, {
                        "name": "纽约微软计算机",
                        "id": 215229
                    }, {
                        "name": "杭州快手计算机控股集团",
                        "id": 215230
                    }, {
                        "name": "天津必胜客餐饮",
                        "id": 215231
                    }, {
                        "name": "东莞百度互金",
                        "id": 215232
                    }, {
                        "name": "杭州喜茶地产",
                        "id": 215233
                    }, {
                        "name": "首尔美团银行",
                        "id": 215234
                    }, {
                        "name": "上海阿里软件",
                        "id": 215235
                    }, {
                        "name": "厦门蚂蚁计算机有限公司",
                        "id": 215236
                    }, {
                        "name": "香港苹果金融有限公司",
                        "id": 215237
                    }, {
                        "name": "杭州百度银行",
                        "id": 215238
                    }, {
                        "name": "香港京东软件控股集团",
                        "id": 215239
                    }, {
                        "name": "北京谷歌地摊有限公司",
                        "id": 215240
                    }, {
                        "name": "台北肯德基银行有限公司",
                        "id": 215241
                    }, {
                        "name": "广州谷歌通讯",
                        "id": 215242
                    }, {
                        "name": "南京喜茶石油",
                        "id": 215243
                    }, {
                        "name": "南京京东农业",
                        "id": 215244
                    }, {
                        "name": "厦门京东科技控股集团",
                        "id": 215245
                    }, {
                        "name": "东京瑞幸旅游",
                        "id": 215246
                    }, {
                        "name": "东莞星巴克餐饮",
                        "id": 215247
                    }, {
                        "name": "天津必胜客旅游",
                        "id": 215248
                    }, {
                        "name": "北京瑞幸地摊",
                        "id": 215249
                    }]
                }, {
                    "name": "南京蚂蚁养殖控股集团",
                    "id": 215250
                }, {
                    "name": "杭州谷歌旅游",
                    "id": 215251
                }, {
                    "name": "东京微软互金控股集团",
                    "id": 215252
                }, {
                    "name": "纽约必胜客农业",
                    "id": 215253
                }, {
                    "name": "香港小米医药",
                    "id": 215254
                }, {
                    "name": "杭州字节通信有限公司",
                    "id": 215255
                }, {
                    "name": "杭州平安渔业",
                    "id": 215256
                }, {
                    "name": "上海平安地产",
                    "id": 215257
                }, {
                    "name": "天津小米地摊",
                    "id": 215258,
                    "children": [{
                        "name": "东莞亚马逊软件有限公司",
                        "id": 215259
                    }, {
                        "name": "台北奈雪诊所",
                        "id": 215260
                    }, {
                        "name": "广州华为石油",
                        "id": 215261
                    }, {
                        "name": "香港平安证券有限公司",
                        "id": 215262
                    }, {
                        "name": "台北阿里牧业控股集团",
                        "id": 215263
                    }, {
                        "name": "东莞奈雪养殖",
                        "id": 215264
                    }, {
                        "name": "北京阿里制造有限公司",
                        "id": 215265
                    }, {
                        "name": "杭州蚂蚁航空",
                        "id": 215266
                    }, {
                        "name": "广州亚马逊信息服务",
                        "id": 215267
                    }, {
                        "name": "厦门亚马逊芯片",
                        "id": 215268
                    }, {
                        "name": "纽约滴滴智能",
                        "id": 215269
                    }, {
                        "name": "杭州字节农业",
                        "id": 215270
                    }, {
                        "name": "首尔蚂蚁新能源",
                        "id": 215271
                    }, {
                        "name": "天津特斯拉航空有限公司",
                        "id": 215272
                    }, {
                        "name": "广州美团证券控股集团",
                        "id": 215273
                    }, {
                        "name": "台北星巴克新能源",
                        "id": 215274
                    }, {
                        "name": "杭州欧珀旅游",
                        "id": 215275
                    }, {
                        "name": "天津腾讯信息服务",
                        "id": 215276
                    }, {
                        "name": "杭州蚂蚁基金控股集团",
                        "id": 215277
                    }, {
                        "name": "上海喜茶餐饮",
                        "id": 215278
                    }, {
                        "name": "香港百度牧业",
                        "id": 215279
                    }, {
                        "name": "香港小米医药",
                        "id": 215280
                    }, {
                        "name": "上海百度基金",
                        "id": 215281
                    }, {
                        "name": "上海阿里基金",
                        "id": 215282
                    }, {
                        "name": "深圳微软农业",
                        "id": 215283
                    }]
                }, {
                    "name": "广州平安电商有限公司",
                    "id": 215284,
                    "children": [{
                        "name": "首尔必胜客诊所有限公司",
                        "id": 215285
                    }, {
                        "name": "东莞字节诊所控股集团",
                        "id": 215286
                    }, {
                        "name": "首尔京东电商",
                        "id": 215287
                    }, {
                        "name": "台北快手医院控股集团",
                        "id": 215288
                    }, {
                        "name": "杭州百度农业",
                        "id": 215289
                    }, {
                        "name": "南京奈雪智能有限公司",
                        "id": 215290
                    }, {
                        "name": "上海苹果互金有限公司",
                        "id": 215291
                    }, {
                        "name": "南京腾讯医院",
                        "id": 215292
                    }, {
                        "name": "天津微软制造",
                        "id": 215293
                    }, {
                        "name": "纽约美团科技有限公司",
                        "id": 215294
                    }, {
                        "name": "北京特斯拉医院",
                        "id": 215295
                    }]
                }, {
                    "name": "杭州蚂蚁养殖",
                    "id": 215296
                }, {
                    "name": "南京快手",
                    "id": 215297
                }, {
                    "name": "广州小米新能源",
                    "id": 215298
                }, {
                    "name": "台北平安信息服务",
                    "id": 215299,
                    "children": [{
                        "name": "广州亚马逊互金有限公司",
                        "id": 215300
                    }, {
                        "name": "广州必胜客地产",
                        "id": 215301
                    }, {
                        "name": "北京星巴克通讯",
                        "id": 215302
                    }, {
                        "name": "上海亚马逊基金",
                        "id": 215303
                    }, {
                        "name": "上海字节通信有限公司",
                        "id": 215304
                    }, {
                        "name": "台北快手医药",
                        "id": 215305
                    }, {
                        "name": "杭州星巴克航空",
                        "id": 215306
                    }, {
                        "name": "台北特斯拉地产",
                        "id": 215307
                    }, {
                        "name": "广州喜茶制造有限公司",
                        "id": 215308
                    }, {
                        "name": "台北蚂蚁牧业",
                        "id": 215309
                    }, {
                        "name": "杭州腾讯互金",
                        "id": 215310
                    }, {
                        "name": "东莞字节渔业控股集团",
                        "id": 215311
                    }, {
                        "name": "南京百度银行",
                        "id": 215312
                    }, {
                        "name": "天津阿里地产控股集团",
                        "id": 215313
                    }, {
                        "name": "南京欧珀基金有限公司",
                        "id": 215314
                    }, {
                        "name": "纽约亚马逊银行控股集团",
                        "id": 215315
                    }, {
                        "name": "天津百度有限公司",
                        "id": 215316
                    }, {
                        "name": "北京华为旅游",
                        "id": 215317
                    }]
                }, {
                    "name": "上海奈雪医药",
                    "id": 215318,
                    "children": [{
                        "name": "天津小米信息服务",
                        "id": 215319
                    }, {
                        "name": "上海奈雪制造",
                        "id": 215320
                    }, {
                        "name": "杭州阿里航空有限公司",
                        "id": 215321
                    }, {
                        "name": "北京喜茶计算机",
                        "id": 215322
                    }, {
                        "name": "杭州苹果旅游",
                        "id": 215323
                    }, {
                        "name": "杭州小米通讯",
                        "id": 215324
                    }, {
                        "name": "东京星巴克芯片有限公司",
                        "id": 215325
                    }, {
                        "name": "厦门谷歌汽车",
                        "id": 215326
                    }, {
                        "name": "纽约谷歌电商",
                        "id": 215327
                    }, {
                        "name": "深圳腾讯银行",
                        "id": 215328
                    }, {
                        "name": "东京字节证券",
                        "id": 215329
                    }, {
                        "name": "杭州快手通信有限公司",
                        "id": 215330
                    }, {
                        "name": "香港欧珀基金有限公司",
                        "id": 215331
                    }, {
                        "name": "东莞百度银行",
                        "id": 215332
                    }, {
                        "name": "上海苹果电商",
                        "id": 215333
                    }, {
                        "name": "杭州滴滴旅游",
                        "id": 215334
                    }, {
                        "name": "香港腾讯汽车",
                        "id": 215335
                    }, {
                        "name": "上海必胜客基金",
                        "id": 215336
                    }, {
                        "name": "广州腾讯医院控股集团",
                        "id": 215337
                    }, {
                        "name": "东京星巴克石油控股集团",
                        "id": 215338
                    }, {
                        "name": "东莞特斯拉诊所有限公司",
                        "id": 215339
                    }, {
                        "name": "东莞蚂蚁石油",
                        "id": 215340
                    }, {
                        "name": "纽约亚马逊餐饮",
                        "id": 215341
                    }, {
                        "name": "台北亚马逊餐饮控股集团",
                        "id": 215342
                    }, {
                        "name": "南京滴滴电商",
                        "id": 215343
                    }, {
                        "name": "东莞必胜客计算机",
                        "id": 215344
                    }, {
                        "name": "香港微软通信控股集团",
                        "id": 215345
                    }, {
                        "name": "杭州滴滴银行",
                        "id": 215346
                    }, {
                        "name": "台北奈雪计算机",
                        "id": 215347
                    }, {
                        "name": "香港美团医院",
                        "id": 215348
                    }, {
                        "name": "杭州瑞幸汽车",
                        "id": 215349
                    }, {
                        "name": "南京快手餐饮控股集团",
                        "id": 215350
                    }, {
                        "name": "天津欧珀芯片控股集团",
                        "id": 215351
                    }, {
                        "name": "东莞星巴克",
                        "id": 215352
                    }]
                }, {
                    "name": "杭州小米医院有限公司",
                    "id": 215353
                }, {
                    "name": "东莞瑞幸互金有限公司",
                    "id": 215354
                }, {
                    "name": "天津蚂蚁计算机",
                    "id": 215355
                }, {
                    "name": "东京肯德基软件",
                    "id": 215356
                }, {
                    "name": "深圳喜茶证券有限公司",
                    "id": 215357
                }, {
                    "name": "深圳腾讯养殖控股集团",
                    "id": 215358
                }, {
                    "name": "东莞字节汽车",
                    "id": 215359
                }, {
                    "name": "香港微软新能源",
                    "id": 215360
                }, {
                    "name": "杭州特斯拉餐饮",
                    "id": 215361
                }, {
                    "name": "香港欧珀基金",
                    "id": 215362
                }, {
                    "name": "杭州谷歌医药",
                    "id": 215363
                }, {
                    "name": "深圳喜茶航空有限公司",
                    "id": 215364
                }, {
                    "name": "南京微软医药",
                    "id": 215365
                }, {
                    "name": "纽约京东智能有限公司",
                    "id": 215366
                }]
            }, {
                "name": "台北瑞幸芯片",
                "id": 215367
            }, {
                "name": "杭州腾讯软件有限公司",
                "id": 215368
            }, {
                "name": "台北滴滴养殖",
                "id": 215369
            }, {
                "name": "北京滴滴医院",
                "id": 215370
            }, {
                "name": "香港蚂蚁石油",
                "id": 215371
            }, {
                "name": "北京滴滴科技",
                "id": 215372
            }, {
                "name": "深圳奈雪互金",
                "id": 215373
            }, {
                "name": "杭州奈雪养殖",
                "id": 215374
            }, {
                "name": "台北百度证券有限公司",
                "id": 215375,
                "children": [{
                    "name": "杭州喜茶石油",
                    "id": 215376
                }, {
                    "name": "东莞欧珀科技",
                    "id": 215377
                }, {
                    "name": "纽约华为基金有限公司",
                    "id": 215378,
                    "children": [{
                        "name": "南京滴滴电商",
                        "id": 215379
                    }, {
                        "name": "首尔快手牧业",
                        "id": 215380
                    }, {
                        "name": "南京平安",
                        "id": 215381
                    }, {
                        "name": "东京阿里牧业",
                        "id": 215382
                    }, {
                        "name": "杭州字节牧业控股集团",
                        "id": 215383
                    }, {
                        "name": "杭州美团通讯有限公司",
                        "id": 215384
                    }, {
                        "name": "广州苹果石油",
                        "id": 215385
                    }, {
                        "name": "纽约欧珀制造控股集团",
                        "id": 215386
                    }, {
                        "name": "广州百度渔业",
                        "id": 215387
                    }, {
                        "name": "杭州滴滴证券",
                        "id": 215388
                    }, {
                        "name": "纽约美团互金",
                        "id": 215389
                    }, {
                        "name": "上海肯德基通讯",
                        "id": 215390
                    }, {
                        "name": "台北美团金融",
                        "id": 215391
                    }, {
                        "name": "杭州喜茶医院控股集团",
                        "id": 215392
                    }, {
                        "name": "上海瑞幸诊所",
                        "id": 215393
                    }, {
                        "name": "天津欧珀芯片有限公司",
                        "id": 215394
                    }, {
                        "name": "上海谷歌",
                        "id": 215395
                    }, {
                        "name": "厦门京东新能源",
                        "id": 215396
                    }, {
                        "name": "杭州滴滴渔业",
                        "id": 215397
                    }, {
                        "name": "天津瑞幸航空",
                        "id": 215398
                    }]
                }, {
                    "name": "上海华为信息服务",
                    "id": 215399
                }, {
                    "name": "南京星巴克旅游",
                    "id": 215400
                }, {
                    "name": "香港美团金融",
                    "id": 215401,
                    "children": [{
                        "name": "北京喜茶银行",
                        "id": 215402
                    }, {
                        "name": "深圳平安新能源",
                        "id": 215403
                    }, {
                        "name": "杭州奈雪农业",
                        "id": 215404
                    }, {
                        "name": "东京华为芯片",
                        "id": 215405
                    }, {
                        "name": "深圳蚂蚁芯片",
                        "id": 215406
                    }, {
                        "name": "杭州百度石油控股集团",
                        "id": 215407
                    }, {
                        "name": "深圳华为渔业",
                        "id": 215408
                    }, {
                        "name": "上海星巴克互金",
                        "id": 215409
                    }, {
                        "name": "北京苹果牧业",
                        "id": 215410
                    }, {
                        "name": "东莞微软金融",
                        "id": 215411
                    }, {
                        "name": "首尔苹果养殖有限公司",
                        "id": 215412
                    }, {
                        "name": "香港星巴克互金有限公司",
                        "id": 215413
                    }, {
                        "name": "上海腾讯有限公司",
                        "id": 215414
                    }, {
                        "name": "厦门谷歌银行控股集团",
                        "id": 215415
                    }, {
                        "name": "厦门美团芯片",
                        "id": 215416
                    }, {
                        "name": "杭州华为通讯有限公司",
                        "id": 215417
                    }, {
                        "name": "上海喜茶银行",
                        "id": 215418
                    }, {
                        "name": "厦门美团金融",
                        "id": 215419
                    }, {
                        "name": "厦门腾讯渔业",
                        "id": 215420
                    }, {
                        "name": "东莞平安智能",
                        "id": 215421
                    }, {
                        "name": "南京瑞幸通讯",
                        "id": 215422
                    }, {
                        "name": "上海谷歌",
                        "id": 215423
                    }, {
                        "name": "天津谷歌互金",
                        "id": 215424
                    }, {
                        "name": "杭州瑞幸汽车",
                        "id": 215425
                    }, {
                        "name": "上海欧珀石油控股集团",
                        "id": 215426
                    }, {
                        "name": "香港华为农业",
                        "id": 215427
                    }]
                }, {
                    "name": "杭州腾讯金融",
                    "id": 215428,
                    "children": [{
                        "name": "杭州阿里基金",
                        "id": 215429
                    }, {
                        "name": "首尔小米餐饮",
                        "id": 215430
                    }, {
                        "name": "杭州小米石油",
                        "id": 215431
                    }, {
                        "name": "杭州肯德基制造有限公司",
                        "id": 215432
                    }, {
                        "name": "天津奈雪旅游",
                        "id": 215433
                    }, {
                        "name": "东京喜茶汽车有限公司",
                        "id": 215434
                    }, {
                        "name": "东京喜茶农业有限公司",
                        "id": 215435
                    }, {
                        "name": "台北腾讯医药控股集团",
                        "id": 215436
                    }, {
                        "name": "杭州京东诊所控股集团",
                        "id": 215437
                    }, {
                        "name": "杭州蚂蚁农业",
                        "id": 215438
                    }, {
                        "name": "杭州小米",
                        "id": 215439
                    }, {
                        "name": "东京亚马逊餐饮",
                        "id": 215440
                    }, {
                        "name": "杭州百度新能源",
                        "id": 215441
                    }, {
                        "name": "天津特斯拉金融",
                        "id": 215442
                    }, {
                        "name": "杭州京东芯片控股集团",
                        "id": 215443
                    }, {
                        "name": "杭州滴滴芯片",
                        "id": 215444
                    }, {
                        "name": "杭州欧珀牧业",
                        "id": 215445
                    }, {
                        "name": "上海字节控股集团",
                        "id": 215446
                    }, {
                        "name": "南京必胜客制造控股集团",
                        "id": 215447
                    }, {
                        "name": "东莞平安汽车有限公司",
                        "id": 215448
                    }, {
                        "name": "北京亚马逊智能",
                        "id": 215449
                    }, {
                        "name": "天津欧珀通信有限公司",
                        "id": 215450
                    }]
                }, {
                    "name": "上海腾讯金融控股集团",
                    "id": 215451
                }, {
                    "name": "广州喜茶石油",
                    "id": 215452
                }, {
                    "name": "广州阿里旅游",
                    "id": 215453
                }, {
                    "name": "天津字节餐饮",
                    "id": 215454
                }, {
                    "name": "杭州喜茶通讯有限公司",
                    "id": 215455,
                    "children": [{
                        "name": "深圳百度银行",
                        "id": 215456
                    }, {
                        "name": "厦门谷歌",
                        "id": 215457
                    }, {
                        "name": "台北华为牧业",
                        "id": 215458
                    }, {
                        "name": "北京谷歌汽车",
                        "id": 215459
                    }, {
                        "name": "北京喜茶通信",
                        "id": 215460
                    }, {
                        "name": "天津华为通信有限公司",
                        "id": 215461
                    }, {
                        "name": "上海苹果证券有限公司",
                        "id": 215462
                    }, {
                        "name": "台北平安基金",
                        "id": 215463
                    }, {
                        "name": "广州特斯拉诊所有限公司",
                        "id": 215464
                    }, {
                        "name": "广州肯德基通讯",
                        "id": 215465
                    }, {
                        "name": "厦门小米科技",
                        "id": 215466
                    }, {
                        "name": "杭州奈雪石油控股集团",
                        "id": 215467
                    }, {
                        "name": "东莞瑞幸智能",
                        "id": 215468
                    }, {
                        "name": "深圳腾讯信息服务",
                        "id": 215469
                    }, {
                        "name": "东莞必胜客计算机",
                        "id": 215470
                    }, {
                        "name": "首尔苹果银行",
                        "id": 215471
                    }, {
                        "name": "上海微软地产有限公司",
                        "id": 215472
                    }, {
                        "name": "天津欧珀金融控股集团",
                        "id": 215473
                    }, {
                        "name": "杭州快手通信控股集团",
                        "id": 215474
                    }, {
                        "name": "纽约蚂蚁汽车",
                        "id": 215475
                    }, {
                        "name": "北京星巴克通讯",
                        "id": 215476
                    }, {
                        "name": "北京亚马逊地摊",
                        "id": 215477
                    }, {
                        "name": "上海阿里制造控股集团",
                        "id": 215478
                    }, {
                        "name": "杭州肯德基石油",
                        "id": 215479
                    }, {
                        "name": "深圳星巴克餐饮",
                        "id": 215480
                    }, {
                        "name": "南京滴滴银行",
                        "id": 215481
                    }, {
                        "name": "上海特斯拉汽车",
                        "id": 215482
                    }, {
                        "name": "首尔亚马逊医院控股集团",
                        "id": 215483
                    }]
                }, {
                    "name": "纽约百度",
                    "id": 215484
                }, {
                    "name": "纽约阿里通讯",
                    "id": 215485
                }, {
                    "name": "东京百度旅游控股集团",
                    "id": 215486
                }, {
                    "name": "东莞欧珀汽车控股集团",
                    "id": 215487,
                    "children": [{
                        "name": "上海蚂蚁芯片",
                        "id": 215488
                    }, {
                        "name": "深圳字节电商",
                        "id": 215489
                    }, {
                        "name": "天津快手石油控股集团",
                        "id": 215490
                    }, {
                        "name": "东莞谷歌",
                        "id": 215491
                    }, {
                        "name": "东京阿里牧业",
                        "id": 215492
                    }, {
                        "name": "东莞苹果石油",
                        "id": 215493
                    }]
                }, {
                    "name": "天津微软旅游",
                    "id": 215494
                }]
            }, {
                "name": "广州微软地摊",
                "id": 215495
            }, {
                "name": "南京腾讯航空有限公司",
                "id": 215496
            }, {
                "name": "南京美团软件",
                "id": 215497,
                "children": [{
                    "name": "深圳特斯拉",
                    "id": 215498
                }, {
                    "name": "广州苹果制造",
                    "id": 215499
                }, {
                    "name": "杭州奈雪科技",
                    "id": 215500,
                    "children": [{
                        "name": "南京亚马逊诊所",
                        "id": 215501
                    }, {
                        "name": "杭州字节智能",
                        "id": 215502
                    }, {
                        "name": "东京微软电商控股集团",
                        "id": 215503
                    }, {
                        "name": "纽约微软旅游控股集团",
                        "id": 215504
                    }, {
                        "name": "台北小米有限公司",
                        "id": 215505
                    }, {
                        "name": "北京小米通讯控股集团",
                        "id": 215506
                    }, {
                        "name": "深圳喜茶诊所有限公司",
                        "id": 215507
                    }, {
                        "name": "台北微软基金",
                        "id": 215508
                    }, {
                        "name": "厦门百度芯片",
                        "id": 215509
                    }, {
                        "name": "东京亚马逊基金有限公司",
                        "id": 215510
                    }, {
                        "name": "纽约星巴克石油有限公司",
                        "id": 215511
                    }, {
                        "name": "深圳特斯拉互金",
                        "id": 215512
                    }, {
                        "name": "东莞亚马逊新能源",
                        "id": 215513
                    }, {
                        "name": "厦门亚马逊医药控股集团",
                        "id": 215514
                    }, {
                        "name": "北京必胜客互金",
                        "id": 215515
                    }, {
                        "name": "北京亚马逊诊所",
                        "id": 215516
                    }, {
                        "name": "东莞快手",
                        "id": 215517
                    }, {
                        "name": "杭州腾讯农业有限公司",
                        "id": 215518
                    }, {
                        "name": "东莞亚马逊",
                        "id": 215519
                    }, {
                        "name": "东京肯德基通讯控股集团",
                        "id": 215520
                    }, {
                        "name": "纽约小米证券",
                        "id": 215521
                    }, {
                        "name": "东莞滴滴计算机控股集团",
                        "id": 215522
                    }, {
                        "name": "南京快手智能",
                        "id": 215523
                    }, {
                        "name": "厦门瑞幸电商",
                        "id": 215524
                    }, {
                        "name": "南京字节软件有限公司",
                        "id": 215525
                    }, {
                        "name": "广州京东证券",
                        "id": 215526
                    }, {
                        "name": "杭州瑞幸芯片有限公司",
                        "id": 215527
                    }, {
                        "name": "杭州亚马逊餐饮有限公司",
                        "id": 215528
                    }, {
                        "name": "台北百度控股集团",
                        "id": 215529
                    }, {
                        "name": "纽约欧珀医院",
                        "id": 215530
                    }, {
                        "name": "广州美团医药有限公司",
                        "id": 215531
                    }, {
                        "name": "北京阿里牧业",
                        "id": 215532
                    }, {
                        "name": "杭州亚马逊制造有限公司",
                        "id": 215533
                    }, {
                        "name": "南京谷歌牧业",
                        "id": 215534
                    }, {
                        "name": "首尔华为农业控股集团",
                        "id": 215535
                    }]
                }, {
                    "name": "杭州欧珀餐饮控股集团",
                    "id": 215536
                }, {
                    "name": "广州美团通信",
                    "id": 215537
                }, {
                    "name": "东莞奈雪地产有限公司",
                    "id": 215538
                }, {
                    "name": "杭州华为新能源控股集团",
                    "id": 215539,
                    "children": [{
                        "name": "首尔华为牧业控股集团",
                        "id": 215540
                    }, {
                        "name": "上海星巴克银行控股集团",
                        "id": 215541
                    }, {
                        "name": "杭州特斯拉新能源",
                        "id": 215542
                    }, {
                        "name": "首尔美团金融",
                        "id": 215543
                    }, {
                        "name": "天津平安餐饮",
                        "id": 215544
                    }, {
                        "name": "香港欧珀汽车",
                        "id": 215545
                    }, {
                        "name": "天津小米计算机控股集团",
                        "id": 215546
                    }, {
                        "name": "南京肯德基控股集团",
                        "id": 215547
                    }, {
                        "name": "东京快手信息服务控股集团",
                        "id": 215548
                    }, {
                        "name": "东京瑞幸通讯有限公司",
                        "id": 215549
                    }, {
                        "name": "北京美团医药",
                        "id": 215550
                    }, {
                        "name": "杭州苹果控股集团",
                        "id": 215551
                    }, {
                        "name": "首尔喜茶电商控股集团",
                        "id": 215552
                    }, {
                        "name": "北京快手金融",
                        "id": 215553
                    }, {
                        "name": "上海奈雪信息服务有限公司",
                        "id": 215554
                    }, {
                        "name": "上海阿里石油",
                        "id": 215555
                    }, {
                        "name": "杭州阿里农业控股集团",
                        "id": 215556
                    }, {
                        "name": "厦门苹果农业",
                        "id": 215557
                    }, {
                        "name": "天津百度智能",
                        "id": 215558
                    }, {
                        "name": "东京微软银行",
                        "id": 215559
                    }, {
                        "name": "香港快手通讯",
                        "id": 215560
                    }]
                }, {
                    "name": "东京百度诊所有限公司",
                    "id": 215561
                }, {
                    "name": "上海喜茶银行有限公司",
                    "id": 215562
                }, {
                    "name": "杭州欧珀通讯",
                    "id": 215563
                }, {
                    "name": "厦门快手制造控股集团",
                    "id": 215564
                }, {
                    "name": "香港字节互金有限公司",
                    "id": 215565,
                    "children": [{
                        "name": "杭州华为",
                        "id": 215566
                    }, {
                        "name": "深圳苹果诊所",
                        "id": 215567
                    }, {
                        "name": "杭州喜茶金融",
                        "id": 215568
                    }, {
                        "name": "南京特斯拉科技",
                        "id": 215569
                    }, {
                        "name": "北京奈雪新能源",
                        "id": 215570
                    }, {
                        "name": "厦门美团渔业",
                        "id": 215571
                    }, {
                        "name": "杭州蚂蚁航空",
                        "id": 215572
                    }, {
                        "name": "纽约腾讯养殖",
                        "id": 215573
                    }, {
                        "name": "杭州欧珀石油有限公司",
                        "id": 215574
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 215575
                    }, {
                        "name": "南京肯德基医院",
                        "id": 215576
                    }, {
                        "name": "纽约奈雪计算机",
                        "id": 215577
                    }, {
                        "name": "香港苹果地摊控股集团",
                        "id": 215578
                    }, {
                        "name": "上海亚马逊农业",
                        "id": 215579
                    }, {
                        "name": "香港肯德基地摊控股集团",
                        "id": 215580
                    }, {
                        "name": "纽约小米餐饮",
                        "id": 215581
                    }, {
                        "name": "南京华为地摊控股集团",
                        "id": 215582
                    }, {
                        "name": "上海苹果基金有限公司",
                        "id": 215583
                    }, {
                        "name": "天津美团金融",
                        "id": 215584
                    }, {
                        "name": "东京平安信息服务控股集团",
                        "id": 215585
                    }, {
                        "name": "杭州京东电商",
                        "id": 215586
                    }, {
                        "name": "东京腾讯电商控股集团",
                        "id": 215587
                    }, {
                        "name": "北京欧珀旅游",
                        "id": 215588
                    }, {
                        "name": "南京美团诊所",
                        "id": 215589
                    }, {
                        "name": "深圳苹果基金",
                        "id": 215590
                    }, {
                        "name": "天津必胜客餐饮",
                        "id": 215591
                    }]
                }, {
                    "name": "杭州欧珀智能控股集团",
                    "id": 215592
                }, {
                    "name": "东莞滴滴智能",
                    "id": 215593
                }, {
                    "name": "天津蚂蚁智能控股集团",
                    "id": 215594
                }, {
                    "name": "广州喜茶智能有限公司",
                    "id": 215595
                }, {
                    "name": "厦门京东地摊有限公司",
                    "id": 215596
                }, {
                    "name": "纽约蚂蚁智能",
                    "id": 215597
                }, {
                    "name": "上海星巴克通讯有限公司",
                    "id": 215598,
                    "children": [{
                        "name": "北京肯德基控股集团",
                        "id": 215599
                    }]
                }, {
                    "name": "纽约字节银行有限公司",
                    "id": 215600,
                    "children": [{
                        "name": "香港小米",
                        "id": 215601
                    }, {
                        "name": "上海京东金融",
                        "id": 215602
                    }, {
                        "name": "台北快手新能源",
                        "id": 215603
                    }, {
                        "name": "南京阿里养殖有限公司",
                        "id": 215604
                    }, {
                        "name": "香港小米航空有限公司",
                        "id": 215605
                    }, {
                        "name": "北京蚂蚁",
                        "id": 215606
                    }, {
                        "name": "深圳苹果金融",
                        "id": 215607
                    }, {
                        "name": "首尔快手渔业控股集团",
                        "id": 215608
                    }, {
                        "name": "台北字节计算机控股集团",
                        "id": 215609
                    }, {
                        "name": "台北微软电商",
                        "id": 215610
                    }, {
                        "name": "首尔微软",
                        "id": 215611
                    }, {
                        "name": "东京肯德基",
                        "id": 215612
                    }, {
                        "name": "纽约欧珀石油",
                        "id": 215613
                    }, {
                        "name": "上海阿里",
                        "id": 215614
                    }, {
                        "name": "香港微软渔业",
                        "id": 215615
                    }, {
                        "name": "天津特斯拉基金",
                        "id": 215616
                    }, {
                        "name": "纽约奈雪牧业",
                        "id": 215617
                    }, {
                        "name": "南京美团银行",
                        "id": 215618
                    }, {
                        "name": "杭州腾讯控股集团",
                        "id": 215619
                    }, {
                        "name": "广州欧珀科技",
                        "id": 215620
                    }, {
                        "name": "天津小米",
                        "id": 215621
                    }, {
                        "name": "东莞平安通讯有限公司",
                        "id": 215622
                    }, {
                        "name": "杭州阿里有限公司",
                        "id": 215623
                    }, {
                        "name": "东京亚马逊通讯有限公司",
                        "id": 215624
                    }]
                }, {
                    "name": "广州特斯拉航空",
                    "id": 215625
                }, {
                    "name": "台北美团医院",
                    "id": 215626
                }, {
                    "name": "上海肯德基新能源",
                    "id": 215627,
                    "children": [{
                        "name": "纽约滴滴地摊有限公司",
                        "id": 215628
                    }]
                }, {
                    "name": "北京谷歌信息服务控股集团",
                    "id": 215629
                }, {
                    "name": "厦门美团汽车",
                    "id": 215630
                }, {
                    "name": "广州亚马逊地产",
                    "id": 215631,
                    "children": [{
                        "name": "厦门华为通讯",
                        "id": 215632
                    }, {
                        "name": "深圳小米软件有限公司",
                        "id": 215633
                    }, {
                        "name": "首尔亚马逊农业有限公司",
                        "id": 215634
                    }, {
                        "name": "首尔美团餐饮控股集团",
                        "id": 215635
                    }, {
                        "name": "台北京东制造",
                        "id": 215636
                    }, {
                        "name": "台北谷歌金融控股集团",
                        "id": 215637
                    }, {
                        "name": "东莞瑞幸牧业",
                        "id": 215638
                    }, {
                        "name": "厦门百度牧业",
                        "id": 215639
                    }, {
                        "name": "上海星巴克",
                        "id": 215640
                    }, {
                        "name": "东京美团医药控股集团",
                        "id": 215641
                    }, {
                        "name": "北京微软",
                        "id": 215642
                    }, {
                        "name": "北京微软银行",
                        "id": 215643
                    }, {
                        "name": "深圳奈雪",
                        "id": 215644
                    }, {
                        "name": "香港肯德基智能有限公司",
                        "id": 215645
                    }, {
                        "name": "东京阿里软件",
                        "id": 215646
                    }, {
                        "name": "香港滴滴基金",
                        "id": 215647
                    }]
                }, {
                    "name": "深圳腾讯农业",
                    "id": 215648
                }, {
                    "name": "香港微软证券控股集团",
                    "id": 215649,
                    "children": [{
                        "name": "北京快手芯片",
                        "id": 215650
                    }, {
                        "name": "广州必胜客",
                        "id": 215651
                    }, {
                        "name": "深圳微软电商",
                        "id": 215652
                    }, {
                        "name": "杭州微软证券",
                        "id": 215653
                    }, {
                        "name": "香港肯德基科技控股集团",
                        "id": 215654
                    }, {
                        "name": "上海京东餐饮",
                        "id": 215655
                    }, {
                        "name": "香港阿里电商控股集团",
                        "id": 215656
                    }, {
                        "name": "东京滴滴养殖",
                        "id": 215657
                    }]
                }, {
                    "name": "首尔阿里",
                    "id": 215658
                }, {
                    "name": "北京滴滴电商",
                    "id": 215659
                }, {
                    "name": "台北腾讯信息服务",
                    "id": 215660
                }, {
                    "name": "北京腾讯软件",
                    "id": 215661,
                    "children": [{
                        "name": "首尔快手制造有限公司",
                        "id": 215662
                    }, {
                        "name": "杭州谷歌航空控股集团",
                        "id": 215663
                    }, {
                        "name": "深圳肯德基智能",
                        "id": 215664
                    }, {
                        "name": "深圳平安渔业",
                        "id": 215665
                    }, {
                        "name": "东莞京东养殖",
                        "id": 215666
                    }, {
                        "name": "杭州小米计算机",
                        "id": 215667
                    }, {
                        "name": "香港必胜客医院",
                        "id": 215668
                    }, {
                        "name": "北京美团银行",
                        "id": 215669
                    }, {
                        "name": "东莞欧珀农业",
                        "id": 215670
                    }, {
                        "name": "香港谷歌有限公司",
                        "id": 215671
                    }, {
                        "name": "东京华为",
                        "id": 215672
                    }, {
                        "name": "东京华为医院",
                        "id": 215673
                    }, {
                        "name": "东莞谷歌旅游",
                        "id": 215674
                    }, {
                        "name": "香港京东新能源",
                        "id": 215675
                    }, {
                        "name": "深圳小米计算机",
                        "id": 215676
                    }, {
                        "name": "深圳蚂蚁",
                        "id": 215677
                    }, {
                        "name": "东莞字节餐饮",
                        "id": 215678
                    }, {
                        "name": "首尔星巴克软件",
                        "id": 215679
                    }, {
                        "name": "东莞肯德基地摊",
                        "id": 215680
                    }, {
                        "name": "纽约腾讯互金有限公司",
                        "id": 215681
                    }, {
                        "name": "北京百度金融",
                        "id": 215682
                    }]
                }, {
                    "name": "台北微软基金",
                    "id": 215683
                }, {
                    "name": "深圳字节医院控股集团",
                    "id": 215684,
                    "children": [{
                        "name": "南京腾讯通讯",
                        "id": 215685
                    }, {
                        "name": "深圳微软石油控股集团",
                        "id": 215686
                    }, {
                        "name": "厦门喜茶农业有限公司",
                        "id": 215687
                    }, {
                        "name": "纽约美团电商",
                        "id": 215688
                    }, {
                        "name": "东莞必胜客基金",
                        "id": 215689
                    }, {
                        "name": "深圳特斯拉牧业",
                        "id": 215690
                    }, {
                        "name": "上海阿里科技",
                        "id": 215691
                    }, {
                        "name": "香港美团石油",
                        "id": 215692
                    }, {
                        "name": "杭州亚马逊计算机有限公司",
                        "id": 215693
                    }, {
                        "name": "天津欧珀智能",
                        "id": 215694
                    }, {
                        "name": "东莞必胜客餐饮",
                        "id": 215695
                    }, {
                        "name": "上海亚马逊银行",
                        "id": 215696
                    }, {
                        "name": "杭州奈雪汽车控股集团",
                        "id": 215697
                    }, {
                        "name": "杭州欧珀制造",
                        "id": 215698
                    }, {
                        "name": "东莞苹果新能源",
                        "id": 215699
                    }, {
                        "name": "东京小米电商有限公司",
                        "id": 215700
                    }, {
                        "name": "纽约肯德基有限公司",
                        "id": 215701
                    }, {
                        "name": "天津京东养殖",
                        "id": 215702
                    }, {
                        "name": "北京蚂蚁餐饮",
                        "id": 215703
                    }, {
                        "name": "北京欧珀旅游有限公司",
                        "id": 215704
                    }, {
                        "name": "杭州必胜客农业有限公司",
                        "id": 215705
                    }, {
                        "name": "上海亚马逊石油控股集团",
                        "id": 215706
                    }, {
                        "name": "杭州喜茶科技",
                        "id": 215707
                    }, {
                        "name": "广州蚂蚁医院",
                        "id": 215708
                    }, {
                        "name": "天津字节智能",
                        "id": 215709
                    }, {
                        "name": "杭州美团电商",
                        "id": 215710
                    }, {
                        "name": "南京肯德基餐饮",
                        "id": 215711
                    }, {
                        "name": "厦门瑞幸银行",
                        "id": 215712
                    }, {
                        "name": "纽约蚂蚁金融有限公司",
                        "id": 215713
                    }, {
                        "name": "台北滴滴通信有限公司",
                        "id": 215714
                    }]
                }, {
                    "name": "北京亚马逊航空",
                    "id": 215715
                }]
            }, {
                "name": "南京星巴克餐饮",
                "id": 215716
            }, {
                "name": "首尔快手银行",
                "id": 215717,
                "children": [{
                    "name": "厦门奈雪银行",
                    "id": 215718
                }, {
                    "name": "台北欧珀制造",
                    "id": 215719
                }, {
                    "name": "东京肯德基信息服务控股集团",
                    "id": 215720,
                    "children": [{
                        "name": "台北快手芯片",
                        "id": 215721
                    }, {
                        "name": "上海瑞幸证券有限公司",
                        "id": 215722
                    }, {
                        "name": "东京苹果石油",
                        "id": 215723
                    }, {
                        "name": "杭州华为医院控股集团",
                        "id": 215724
                    }, {
                        "name": "东莞滴滴信息服务控股集团",
                        "id": 215725
                    }, {
                        "name": "香港微软科技",
                        "id": 215726
                    }, {
                        "name": "东莞肯德基诊所",
                        "id": 215727
                    }, {
                        "name": "东京苹果餐饮",
                        "id": 215728
                    }, {
                        "name": "东莞必胜客渔业控股集团",
                        "id": 215729
                    }]
                }, {
                    "name": "台北喜茶有限公司",
                    "id": 215730
                }, {
                    "name": "杭州平安互金控股集团",
                    "id": 215731
                }, {
                    "name": "南京腾讯信息服务有限公司",
                    "id": 215732
                }, {
                    "name": "东京微软通信",
                    "id": 215733
                }, {
                    "name": "南京星巴克养殖",
                    "id": 215734,
                    "children": [{
                        "name": "上海星巴克",
                        "id": 215735
                    }, {
                        "name": "台北快手牧业",
                        "id": 215736
                    }, {
                        "name": "深圳必胜客信息服务有限公司",
                        "id": 215737
                    }, {
                        "name": "北京特斯拉",
                        "id": 215738
                    }, {
                        "name": "上海谷歌互金",
                        "id": 215739
                    }, {
                        "name": "纽约瑞幸医药",
                        "id": 215740
                    }, {
                        "name": "香港欧珀金融",
                        "id": 215741
                    }, {
                        "name": "东莞奈雪电商",
                        "id": 215742
                    }, {
                        "name": "杭州美团科技有限公司",
                        "id": 215743
                    }, {
                        "name": "天津蚂蚁新能源有限公司",
                        "id": 215744
                    }, {
                        "name": "香港蚂蚁渔业",
                        "id": 215745
                    }, {
                        "name": "东莞必胜客证券",
                        "id": 215746
                    }]
                }, {
                    "name": "北京京东餐饮",
                    "id": 215747
                }, {
                    "name": "台北肯德基计算机有限公司",
                    "id": 215748,
                    "children": [{
                        "name": "纽约美团渔业有限公司",
                        "id": 215749
                    }, {
                        "name": "东莞星巴克医药有限公司",
                        "id": 215750
                    }, {
                        "name": "台北亚马逊石油",
                        "id": 215751
                    }, {
                        "name": "台北微软银行",
                        "id": 215752
                    }, {
                        "name": "厦门特斯拉证券",
                        "id": 215753
                    }, {
                        "name": "北京百度医院",
                        "id": 215754
                    }, {
                        "name": "东京快手餐饮",
                        "id": 215755
                    }, {
                        "name": "天津小米计算机",
                        "id": 215756
                    }, {
                        "name": "深圳特斯拉软件",
                        "id": 215757
                    }, {
                        "name": "东莞瑞幸地产",
                        "id": 215758
                    }, {
                        "name": "厦门微软银行",
                        "id": 215759
                    }, {
                        "name": "南京瑞幸餐饮控股集团",
                        "id": 215760
                    }, {
                        "name": "台北快手控股集团",
                        "id": 215761
                    }, {
                        "name": "杭州喜茶新能源控股集团",
                        "id": 215762
                    }, {
                        "name": "东京星巴克渔业",
                        "id": 215763
                    }, {
                        "name": "杭州小米石油有限公司",
                        "id": 215764
                    }, {
                        "name": "深圳亚马逊控股集团",
                        "id": 215765
                    }, {
                        "name": "首尔小米餐饮",
                        "id": 215766
                    }, {
                        "name": "杭州微软有限公司",
                        "id": 215767
                    }, {
                        "name": "纽约瑞幸汽车",
                        "id": 215768
                    }, {
                        "name": "首尔喜茶科技",
                        "id": 215769
                    }, {
                        "name": "香港小米医药有限公司",
                        "id": 215770
                    }, {
                        "name": "广州滴滴信息服务控股集团",
                        "id": 215771
                    }, {
                        "name": "台北滴滴通讯",
                        "id": 215772
                    }, {
                        "name": "香港小米智能有限公司",
                        "id": 215773
                    }, {
                        "name": "杭州快手通讯有限公司",
                        "id": 215774
                    }, {
                        "name": "杭州欧珀有限公司",
                        "id": 215775
                    }, {
                        "name": "东莞小米芯片控股集团",
                        "id": 215776
                    }, {
                        "name": "杭州平安医药",
                        "id": 215777
                    }]
                }, {
                    "name": "首尔星巴克智能",
                    "id": 215778,
                    "children": [{
                        "name": "东莞奈雪通讯",
                        "id": 215779
                    }, {
                        "name": "纽约华为银行",
                        "id": 215780
                    }, {
                        "name": "首尔特斯拉农业",
                        "id": 215781
                    }, {
                        "name": "东京喜茶智能",
                        "id": 215782
                    }, {
                        "name": "杭州瑞幸科技有限公司",
                        "id": 215783
                    }, {
                        "name": "纽约蚂蚁养殖",
                        "id": 215784
                    }, {
                        "name": "厦门肯德基软件",
                        "id": 215785
                    }, {
                        "name": "杭州肯德基渔业",
                        "id": 215786
                    }, {
                        "name": "上海平安芯片",
                        "id": 215787
                    }, {
                        "name": "广州瑞幸地产",
                        "id": 215788
                    }, {
                        "name": "南京平安",
                        "id": 215789
                    }, {
                        "name": "东京喜茶金融",
                        "id": 215790
                    }, {
                        "name": "杭州特斯拉地产",
                        "id": 215791
                    }, {
                        "name": "南京美团农业",
                        "id": 215792
                    }, {
                        "name": "深圳星巴克金融控股集团",
                        "id": 215793
                    }, {
                        "name": "深圳微软新能源",
                        "id": 215794
                    }, {
                        "name": "东京腾讯证券",
                        "id": 215795
                    }, {
                        "name": "天津小米互金控股集团",
                        "id": 215796
                    }, {
                        "name": "东莞肯德基金融控股集团",
                        "id": 215797
                    }]
                }, {
                    "name": "广州腾讯",
                    "id": 215798
                }, {
                    "name": "深圳特斯拉基金有限公司",
                    "id": 215799,
                    "children": [{
                        "name": "广州京东新能源",
                        "id": 215800
                    }, {
                        "name": "北京平安信息服务",
                        "id": 215801
                    }, {
                        "name": "深圳喜茶智能",
                        "id": 215802
                    }, {
                        "name": "深圳谷歌农业",
                        "id": 215803
                    }, {
                        "name": "东莞微软牧业",
                        "id": 215804
                    }, {
                        "name": "厦门蚂蚁证券控股集团",
                        "id": 215805
                    }, {
                        "name": "台北小米软件有限公司",
                        "id": 215806
                    }, {
                        "name": "东京腾讯",
                        "id": 215807
                    }, {
                        "name": "南京必胜客航空",
                        "id": 215808
                    }, {
                        "name": "东京百度互金控股集团",
                        "id": 215809
                    }, {
                        "name": "东京肯德基诊所",
                        "id": 215810
                    }, {
                        "name": "深圳美团计算机",
                        "id": 215811
                    }, {
                        "name": "香港微软养殖",
                        "id": 215812
                    }, {
                        "name": "杭州快手渔业",
                        "id": 215813
                    }, {
                        "name": "台北美团通信控股集团",
                        "id": 215814
                    }, {
                        "name": "纽约肯德基养殖",
                        "id": 215815
                    }, {
                        "name": "东莞亚马逊信息服务",
                        "id": 215816
                    }, {
                        "name": "北京特斯拉",
                        "id": 215817
                    }, {
                        "name": "北京必胜客软件",
                        "id": 215818
                    }, {
                        "name": "上海小米石油有限公司",
                        "id": 215819
                    }, {
                        "name": "东京美团有限公司",
                        "id": 215820
                    }, {
                        "name": "杭州美团地产",
                        "id": 215821
                    }, {
                        "name": "东莞京东地摊控股集团",
                        "id": 215822
                    }, {
                        "name": "东京快手软件有限公司",
                        "id": 215823
                    }, {
                        "name": "杭州快手信息服务",
                        "id": 215824
                    }, {
                        "name": "纽约快手信息服务有限公司",
                        "id": 215825
                    }, {
                        "name": "首尔蚂蚁信息服务",
                        "id": 215826
                    }, {
                        "name": "台北苹果医院",
                        "id": 215827
                    }, {
                        "name": "杭州京东诊所控股集团",
                        "id": 215828
                    }, {
                        "name": "纽约瑞幸地摊",
                        "id": 215829
                    }, {
                        "name": "广州星巴克医院控股集团",
                        "id": 215830
                    }, {
                        "name": "南京奈雪芯片",
                        "id": 215831
                    }, {
                        "name": "杭州必胜客诊所",
                        "id": 215832
                    }, {
                        "name": "东莞亚马逊汽车",
                        "id": 215833
                    }]
                }, {
                    "name": "首尔百度控股集团",
                    "id": 215834
                }, {
                    "name": "东莞快手互金控股集团",
                    "id": 215835
                }, {
                    "name": "北京蚂蚁汽车",
                    "id": 215836
                }, {
                    "name": "东莞奈雪通讯",
                    "id": 215837
                }, {
                    "name": "深圳百度软件",
                    "id": 215838
                }, {
                    "name": "天津小米银行有限公司",
                    "id": 215839
                }]
            }, {
                "name": "北京欧珀计算机",
                "id": 215840
            }, {
                "name": "香港百度餐饮有限公司",
                "id": 215841
            }, {
                "name": "北京欧珀地产",
                "id": 215842,
                "children": [{
                    "name": "天津必胜客餐饮",
                    "id": 215843
                }, {
                    "name": "首尔美团软件",
                    "id": 215844,
                    "children": [{
                        "name": "东莞微软渔业",
                        "id": 215845
                    }, {
                        "name": "上海星巴克养殖",
                        "id": 215846
                    }, {
                        "name": "东京阿里",
                        "id": 215847
                    }, {
                        "name": "香港亚马逊科技控股集团",
                        "id": 215848
                    }, {
                        "name": "杭州小米芯片控股集团",
                        "id": 215849
                    }, {
                        "name": "北京欧珀诊所",
                        "id": 215850
                    }, {
                        "name": "上海华为诊所有限公司",
                        "id": 215851
                    }, {
                        "name": "东莞阿里渔业",
                        "id": 215852
                    }, {
                        "name": "杭州平安制造",
                        "id": 215853
                    }, {
                        "name": "首尔华为基金",
                        "id": 215854
                    }, {
                        "name": "杭州肯德基软件",
                        "id": 215855
                    }, {
                        "name": "天津亚马逊餐饮控股集团",
                        "id": 215856
                    }]
                }, {
                    "name": "深圳特斯拉石油",
                    "id": 215857
                }, {
                    "name": "北京快手",
                    "id": 215858,
                    "children": [{
                        "name": "深圳滴滴新能源",
                        "id": 215859
                    }, {
                        "name": "深圳苹果养殖有限公司",
                        "id": 215860
                    }, {
                        "name": "南京亚马逊软件",
                        "id": 215861
                    }, {
                        "name": "北京阿里石油有限公司",
                        "id": 215862
                    }, {
                        "name": "南京必胜客证券",
                        "id": 215863
                    }, {
                        "name": "广州必胜客基金有限公司",
                        "id": 215864
                    }, {
                        "name": "首尔百度通信控股集团",
                        "id": 215865
                    }, {
                        "name": "台北苹果金融",
                        "id": 215866
                    }, {
                        "name": "上海奈雪金融",
                        "id": 215867
                    }, {
                        "name": "东莞平安互金",
                        "id": 215868
                    }, {
                        "name": "深圳苹果地产有限公司",
                        "id": 215869
                    }, {
                        "name": "台北美团通信",
                        "id": 215870
                    }, {
                        "name": "东京瑞幸医药控股集团",
                        "id": 215871
                    }, {
                        "name": "厦门瑞幸",
                        "id": 215872
                    }, {
                        "name": "杭州喜茶证券",
                        "id": 215873
                    }, {
                        "name": "香港喜茶智能",
                        "id": 215874
                    }, {
                        "name": "东京阿里新能源",
                        "id": 215875
                    }, {
                        "name": "纽约阿里证券控股集团",
                        "id": 215876
                    }, {
                        "name": "北京字节控股集团",
                        "id": 215877
                    }, {
                        "name": "厦门苹果科技控股集团",
                        "id": 215878
                    }, {
                        "name": "天津滴滴信息服务有限公司",
                        "id": 215879
                    }, {
                        "name": "台北华为石油有限公司",
                        "id": 215880
                    }, {
                        "name": "香港京东新能源",
                        "id": 215881
                    }, {
                        "name": "广州必胜客诊所有限公司",
                        "id": 215882
                    }, {
                        "name": "厦门滴滴互金控股集团",
                        "id": 215883
                    }, {
                        "name": "台北肯德基",
                        "id": 215884
                    }, {
                        "name": "上海字节证券",
                        "id": 215885
                    }, {
                        "name": "广州阿里",
                        "id": 215886
                    }, {
                        "name": "天津微软软件控股集团",
                        "id": 215887
                    }, {
                        "name": "天津欧珀软件控股集团",
                        "id": 215888
                    }, {
                        "name": "首尔百度证券有限公司",
                        "id": 215889
                    }, {
                        "name": "南京欧珀证券",
                        "id": 215890
                    }, {
                        "name": "南京谷歌新能源",
                        "id": 215891
                    }, {
                        "name": "杭州欧珀软件有限公司",
                        "id": 215892
                    }]
                }, {
                    "name": "深圳奈雪计算机",
                    "id": 215893,
                    "children": [{
                        "name": "首尔华为信息服务",
                        "id": 215894
                    }, {
                        "name": "香港奈雪信息服务控股集团",
                        "id": 215895
                    }, {
                        "name": "杭州喜茶旅游",
                        "id": 215896
                    }, {
                        "name": "杭州苹果",
                        "id": 215897
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 215898
                    }]
                }, {
                    "name": "天津腾讯银行",
                    "id": 215899
                }, {
                    "name": "纽约阿里计算机有限公司",
                    "id": 215900
                }, {
                    "name": "南京小米信息服务有限公司",
                    "id": 215901
                }, {
                    "name": "台北阿里医院",
                    "id": 215902
                }, {
                    "name": "厦门苹果通讯",
                    "id": 215903,
                    "children": [{
                        "name": "广州美团软件",
                        "id": 215904
                    }, {
                        "name": "东莞奈雪有限公司",
                        "id": 215905
                    }, {
                        "name": "北京喜茶制造",
                        "id": 215906
                    }, {
                        "name": "北京欧珀航空",
                        "id": 215907
                    }, {
                        "name": "东莞快手养殖",
                        "id": 215908
                    }, {
                        "name": "台北星巴克银行",
                        "id": 215909
                    }, {
                        "name": "广州奈雪农业",
                        "id": 215910
                    }, {
                        "name": "厦门瑞幸餐饮",
                        "id": 215911
                    }, {
                        "name": "杭州谷歌",
                        "id": 215912
                    }, {
                        "name": "广州腾讯芯片控股集团",
                        "id": 215913
                    }, {
                        "name": "东莞喜茶智能有限公司",
                        "id": 215914
                    }, {
                        "name": "北京平安医药控股集团",
                        "id": 215915
                    }, {
                        "name": "上海必胜客旅游",
                        "id": 215916
                    }, {
                        "name": "纽约亚马逊信息服务",
                        "id": 215917
                    }, {
                        "name": "杭州百度医院",
                        "id": 215918
                    }, {
                        "name": "东莞奈雪地摊有限公司",
                        "id": 215919
                    }, {
                        "name": "厦门星巴克电商",
                        "id": 215920
                    }, {
                        "name": "上海平安新能源",
                        "id": 215921
                    }, {
                        "name": "杭州阿里",
                        "id": 215922
                    }, {
                        "name": "首尔快手制造",
                        "id": 215923
                    }, {
                        "name": "杭州微软互金",
                        "id": 215924
                    }, {
                        "name": "上海欧珀芯片有限公司",
                        "id": 215925
                    }, {
                        "name": "杭州微软牧业",
                        "id": 215926
                    }, {
                        "name": "厦门肯德基汽车",
                        "id": 215927
                    }, {
                        "name": "上海星巴克信息服务控股集团",
                        "id": 215928
                    }, {
                        "name": "北京阿里控股集团",
                        "id": 215929
                    }, {
                        "name": "上海腾讯有限公司",
                        "id": 215930
                    }, {
                        "name": "广州肯德基电商有限公司",
                        "id": 215931
                    }, {
                        "name": "南京微软农业控股集团",
                        "id": 215932
                    }, {
                        "name": "东莞亚马逊软件控股集团",
                        "id": 215933
                    }, {
                        "name": "首尔瑞幸汽车",
                        "id": 215934
                    }]
                }, {
                    "name": "香港星巴克",
                    "id": 215935
                }, {
                    "name": "纽约特斯拉芯片控股集团",
                    "id": 215936,
                    "children": [{
                        "name": "深圳亚马逊医药",
                        "id": 215937
                    }, {
                        "name": "东莞快手新能源控股集团",
                        "id": 215938
                    }, {
                        "name": "杭州京东旅游有限公司",
                        "id": 215939
                    }, {
                        "name": "香港快手医院",
                        "id": 215940
                    }, {
                        "name": "东京欧珀航空",
                        "id": 215941
                    }, {
                        "name": "厦门平安",
                        "id": 215942
                    }, {
                        "name": "南京百度通信有限公司",
                        "id": 215943
                    }, {
                        "name": "广州微软医药有限公司",
                        "id": 215944
                    }, {
                        "name": "上海必胜客基金控股集团",
                        "id": 215945
                    }, {
                        "name": "东莞瑞幸芯片控股集团",
                        "id": 215946
                    }, {
                        "name": "深圳快手地产控股集团",
                        "id": 215947
                    }, {
                        "name": "天津奈雪制造",
                        "id": 215948
                    }, {
                        "name": "台北美团旅游有限公司",
                        "id": 215949
                    }, {
                        "name": "东京腾讯石油",
                        "id": 215950
                    }, {
                        "name": "台北滴滴有限公司",
                        "id": 215951
                    }, {
                        "name": "台北微软汽车控股集团",
                        "id": 215952
                    }, {
                        "name": "首尔字节农业",
                        "id": 215953
                    }, {
                        "name": "北京微软金融",
                        "id": 215954
                    }]
                }, {
                    "name": "厦门奈雪制造",
                    "id": 215955
                }]
            }, {
                "name": "深圳快手软件",
                "id": 215956
            }, {
                "name": "杭州喜茶芯片",
                "id": 215957
            }, {
                "name": "北京星巴克通信控股集团",
                "id": 215958
            }, {
                "name": "东莞阿里农业",
                "id": 215959
            }, {
                "name": "厦门平安养殖",
                "id": 215960,
                "children": [{
                    "name": "厦门喜茶医院",
                    "id": 215961
                }, {
                    "name": "厦门亚马逊餐饮",
                    "id": 215962
                }, {
                    "name": "台北微软渔业控股集团",
                    "id": 215963
                }, {
                    "name": "杭州瑞幸智能控股集团",
                    "id": 215964
                }, {
                    "name": "东莞喜茶地产有限公司",
                    "id": 215965
                }, {
                    "name": "上海喜茶航空",
                    "id": 215966,
                    "children": [{
                        "name": "香港奈雪证券有限公司",
                        "id": 215967
                    }, {
                        "name": "广州腾讯航空",
                        "id": 215968
                    }, {
                        "name": "香港喜茶软件",
                        "id": 215969
                    }, {
                        "name": "厦门奈雪牧业",
                        "id": 215970
                    }, {
                        "name": "纽约滴滴牧业",
                        "id": 215971
                    }, {
                        "name": "广州小米科技",
                        "id": 215972
                    }, {
                        "name": "南京快手牧业",
                        "id": 215973
                    }, {
                        "name": "北京京东旅游",
                        "id": 215974
                    }, {
                        "name": "天津平安计算机",
                        "id": 215975
                    }, {
                        "name": "台北喜茶航空",
                        "id": 215976
                    }, {
                        "name": "深圳瑞幸银行",
                        "id": 215977
                    }, {
                        "name": "南京蚂蚁地摊",
                        "id": 215978
                    }, {
                        "name": "香港谷歌制造控股集团",
                        "id": 215979
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 215980
                    }, {
                        "name": "东莞字节有限公司",
                        "id": 215981
                    }, {
                        "name": "杭州美团通讯有限公司",
                        "id": 215982
                    }, {
                        "name": "东莞喜茶软件",
                        "id": 215983
                    }, {
                        "name": "杭州腾讯医药有限公司",
                        "id": 215984
                    }, {
                        "name": "东京京东制造",
                        "id": 215985
                    }]
                }]
            }, {
                "name": "东莞肯德基餐饮",
                "id": 215986
            }]
        }, {
            "name": "杭州平安地产控股集团",
            "id": 215987
        }, {
            "name": "上海亚马逊石油",
            "id": 215988
        }, {
            "name": "厦门小米渔业有限公司",
            "id": 215989
        }, {
            "name": "广州滴滴芯片",
            "id": 215990,
            "children": [{
                "name": "首尔苹果餐饮",
                "id": 215991
            }, {
                "name": "东京平安软件有限公司",
                "id": 215992
            }, {
                "name": "天津滴滴制造有限公司",
                "id": 215993
            }, {
                "name": "天津特斯拉通信",
                "id": 215994
            }, {
                "name": "杭州瑞幸银行",
                "id": 215995
            }, {
                "name": "纽约喜茶金融控股集团",
                "id": 215996
            }, {
                "name": "东京腾讯信息服务",
                "id": 215997
            }, {
                "name": "广州华为石油",
                "id": 215998
            }, {
                "name": "杭州瑞幸银行",
                "id": 215999
            }, {
                "name": "纽约微软信息服务",
                "id": 216000
            }, {
                "name": "台北百度计算机",
                "id": 216001
            }, {
                "name": "台北腾讯智能",
                "id": 216002
            }, {
                "name": "厦门平安航空",
                "id": 216003
            }, {
                "name": "杭州谷歌芯片",
                "id": 216004
            }, {
                "name": "东莞滴滴证券",
                "id": 216005
            }, {
                "name": "东莞快手通信控股集团",
                "id": 216006
            }, {
                "name": "杭州苹果医院控股集团",
                "id": 216007
            }, {
                "name": "杭州华为计算机",
                "id": 216008
            }, {
                "name": "厦门腾讯航空有限公司",
                "id": 216009
            }, {
                "name": "首尔肯德基信息服务",
                "id": 216010
            }, {
                "name": "东京欧珀信息服务",
                "id": 216011
            }, {
                "name": "杭州华为地摊",
                "id": 216012
            }, {
                "name": "东莞必胜客芯片",
                "id": 216013
            }, {
                "name": "纽约特斯拉航空有限公司",
                "id": 216014
            }, {
                "name": "北京欧珀银行",
                "id": 216015
            }, {
                "name": "东京滴滴餐饮有限公司",
                "id": 216016
            }, {
                "name": "香港阿里医院有限公司",
                "id": 216017
            }, {
                "name": "南京奈雪智能",
                "id": 216018,
                "children": [{
                    "name": "天津滴滴地摊控股集团",
                    "id": 216019
                }, {
                    "name": "上海腾讯证券",
                    "id": 216020
                }, {
                    "name": "杭州滴滴芯片",
                    "id": 216021
                }, {
                    "name": "东京必胜客互金有限公司",
                    "id": 216022,
                    "children": [{
                        "name": "香港华为新能源有限公司",
                        "id": 216023
                    }, {
                        "name": "南京特斯拉养殖",
                        "id": 216024
                    }, {
                        "name": "南京亚马逊制造",
                        "id": 216025
                    }, {
                        "name": "杭州特斯拉牧业",
                        "id": 216026
                    }, {
                        "name": "天津快手制造有限公司",
                        "id": 216027
                    }, {
                        "name": "北京喜茶通信控股集团",
                        "id": 216028
                    }, {
                        "name": "东京必胜客航空",
                        "id": 216029
                    }, {
                        "name": "天津亚马逊基金有限公司",
                        "id": 216030
                    }, {
                        "name": "厦门微软医药",
                        "id": 216031
                    }, {
                        "name": "深圳特斯拉牧业",
                        "id": 216032
                    }, {
                        "name": "北京京东银行有限公司",
                        "id": 216033
                    }]
                }, {
                    "name": "杭州快手",
                    "id": 216034,
                    "children": [{
                        "name": "天津谷歌通讯有限公司",
                        "id": 216035
                    }, {
                        "name": "南京美团旅游有限公司",
                        "id": 216036
                    }, {
                        "name": "首尔华为制造",
                        "id": 216037
                    }, {
                        "name": "杭州字节农业",
                        "id": 216038
                    }, {
                        "name": "首尔谷歌新能源",
                        "id": 216039
                    }, {
                        "name": "香港微软互金控股集团",
                        "id": 216040
                    }, {
                        "name": "香港奈雪地摊",
                        "id": 216041
                    }, {
                        "name": "首尔特斯拉地产有限公司",
                        "id": 216042
                    }, {
                        "name": "厦门平安智能",
                        "id": 216043
                    }, {
                        "name": "南京苹果养殖有限公司",
                        "id": 216044
                    }, {
                        "name": "上海京东金融有限公司",
                        "id": 216045
                    }, {
                        "name": "南京奈雪科技控股集团",
                        "id": 216046
                    }, {
                        "name": "香港奈雪软件控股集团",
                        "id": 216047
                    }, {
                        "name": "上海喜茶石油控股集团",
                        "id": 216048
                    }, {
                        "name": "厦门阿里牧业控股集团",
                        "id": 216049
                    }, {
                        "name": "台北平安电商控股集团",
                        "id": 216050
                    }, {
                        "name": "杭州平安农业",
                        "id": 216051
                    }, {
                        "name": "杭州特斯拉通信有限公司",
                        "id": 216052
                    }, {
                        "name": "东莞欧珀有限公司",
                        "id": 216053
                    }, {
                        "name": "深圳蚂蚁",
                        "id": 216054
                    }, {
                        "name": "东京喜茶智能有限公司",
                        "id": 216055
                    }, {
                        "name": "纽约百度",
                        "id": 216056
                    }, {
                        "name": "香港腾讯软件控股集团",
                        "id": 216057
                    }, {
                        "name": "南京蚂蚁养殖有限公司",
                        "id": 216058
                    }, {
                        "name": "台北腾讯养殖控股集团",
                        "id": 216059
                    }, {
                        "name": "广州亚马逊医院有限公司",
                        "id": 216060
                    }, {
                        "name": "天津奈雪石油有限公司",
                        "id": 216061
                    }, {
                        "name": "深圳京东智能",
                        "id": 216062
                    }, {
                        "name": "广州必胜客制造控股集团",
                        "id": 216063
                    }, {
                        "name": "南京奈雪制造",
                        "id": 216064
                    }]
                }, {
                    "name": "深圳瑞幸电商",
                    "id": 216065
                }, {
                    "name": "上海亚马逊旅游有限公司",
                    "id": 216066
                }, {
                    "name": "首尔肯德基金融有限公司",
                    "id": 216067
                }, {
                    "name": "台北美团科技",
                    "id": 216068
                }, {
                    "name": "厦门阿里餐饮",
                    "id": 216069
                }, {
                    "name": "东京特斯拉",
                    "id": 216070
                }, {
                    "name": "东莞奈雪基金控股集团",
                    "id": 216071
                }, {
                    "name": "纽约蚂蚁",
                    "id": 216072
                }, {
                    "name": "上海星巴克通讯",
                    "id": 216073
                }, {
                    "name": "上海美团地摊",
                    "id": 216074
                }, {
                    "name": "台北蚂蚁信息服务",
                    "id": 216075
                }, {
                    "name": "北京京东通信",
                    "id": 216076
                }, {
                    "name": "香港腾讯通信",
                    "id": 216077
                }, {
                    "name": "杭州奈雪制造",
                    "id": 216078,
                    "children": [{
                        "name": "深圳瑞幸医院",
                        "id": 216079
                    }, {
                        "name": "南京滴滴信息服务有限公司",
                        "id": 216080
                    }, {
                        "name": "杭州喜茶石油",
                        "id": 216081
                    }, {
                        "name": "上海欧珀互金",
                        "id": 216082
                    }, {
                        "name": "东京苹果基金",
                        "id": 216083
                    }, {
                        "name": "北京欧珀芯片",
                        "id": 216084
                    }, {
                        "name": "天津谷歌信息服务",
                        "id": 216085
                    }, {
                        "name": "厦门瑞幸银行",
                        "id": 216086
                    }, {
                        "name": "首尔阿里通讯",
                        "id": 216087
                    }, {
                        "name": "首尔阿里医药",
                        "id": 216088
                    }, {
                        "name": "东京平安养殖控股集团",
                        "id": 216089
                    }, {
                        "name": "台北美团养殖控股集团",
                        "id": 216090
                    }, {
                        "name": "香港滴滴养殖",
                        "id": 216091
                    }, {
                        "name": "东莞字节新能源",
                        "id": 216092
                    }, {
                        "name": "厦门欧珀计算机",
                        "id": 216093
                    }, {
                        "name": "杭州喜茶医药",
                        "id": 216094
                    }, {
                        "name": "上海字节旅游",
                        "id": 216095
                    }, {
                        "name": "东莞百度诊所",
                        "id": 216096
                    }]
                }, {
                    "name": "上海腾讯餐饮",
                    "id": 216097
                }, {
                    "name": "香港谷歌地摊有限公司",
                    "id": 216098,
                    "children": [{
                        "name": "首尔奈雪航空控股集团",
                        "id": 216099
                    }, {
                        "name": "香港星巴克石油控股集团",
                        "id": 216100
                    }, {
                        "name": "南京华为餐饮控股集团",
                        "id": 216101
                    }, {
                        "name": "首尔瑞幸制造控股集团",
                        "id": 216102
                    }, {
                        "name": "台北华为诊所控股集团",
                        "id": 216103
                    }, {
                        "name": "天津百度软件有限公司",
                        "id": 216104
                    }]
                }, {
                    "name": "纽约美团医药有限公司",
                    "id": 216105
                }, {
                    "name": "台北微软医院有限公司",
                    "id": 216106
                }, {
                    "name": "香港星巴克地产有限公司",
                    "id": 216107
                }, {
                    "name": "杭州亚马逊通信",
                    "id": 216108
                }, {
                    "name": "香港星巴克软件",
                    "id": 216109
                }, {
                    "name": "台北美团互金",
                    "id": 216110
                }, {
                    "name": "东京瑞幸计算机",
                    "id": 216111
                }, {
                    "name": "北京星巴克新能源",
                    "id": 216112
                }, {
                    "name": "东京京东制造控股集团",
                    "id": 216113
                }, {
                    "name": "厦门奈雪电商",
                    "id": 216114,
                    "children": [{
                        "name": "杭州微软诊所",
                        "id": 216115
                    }, {
                        "name": "南京谷歌医药",
                        "id": 216116
                    }, {
                        "name": "台北特斯拉有限公司",
                        "id": 216117
                    }, {
                        "name": "香港快手牧业",
                        "id": 216118
                    }, {
                        "name": "香港字节餐饮",
                        "id": 216119
                    }, {
                        "name": "杭州微软医药控股集团",
                        "id": 216120
                    }, {
                        "name": "东莞腾讯牧业",
                        "id": 216121
                    }, {
                        "name": "首尔欧珀银行",
                        "id": 216122
                    }, {
                        "name": "深圳肯德基科技",
                        "id": 216123
                    }, {
                        "name": "首尔小米芯片",
                        "id": 216124
                    }, {
                        "name": "台北百度基金",
                        "id": 216125
                    }, {
                        "name": "东莞苹果互金",
                        "id": 216126
                    }, {
                        "name": "东莞亚马逊信息服务",
                        "id": 216127
                    }, {
                        "name": "首尔喜茶地产",
                        "id": 216128
                    }, {
                        "name": "东京字节餐饮有限公司",
                        "id": 216129
                    }, {
                        "name": "台北平安地产控股集团",
                        "id": 216130
                    }, {
                        "name": "深圳快手有限公司",
                        "id": 216131
                    }, {
                        "name": "深圳特斯拉医药",
                        "id": 216132
                    }, {
                        "name": "北京腾讯智能",
                        "id": 216133
                    }, {
                        "name": "广州奈雪农业有限公司",
                        "id": 216134
                    }, {
                        "name": "杭州星巴克地摊有限公司",
                        "id": 216135
                    }, {
                        "name": "东京喜茶控股集团",
                        "id": 216136
                    }, {
                        "name": "台北欧珀医药有限公司",
                        "id": 216137
                    }, {
                        "name": "东莞谷歌基金有限公司",
                        "id": 216138
                    }, {
                        "name": "广州蚂蚁诊所控股集团",
                        "id": 216139
                    }, {
                        "name": "台北亚马逊电商",
                        "id": 216140
                    }, {
                        "name": "东京百度证券",
                        "id": 216141
                    }, {
                        "name": "上海快手芯片",
                        "id": 216142
                    }, {
                        "name": "天津微软通信控股集团",
                        "id": 216143
                    }, {
                        "name": "杭州微软牧业",
                        "id": 216144
                    }, {
                        "name": "东京欧珀证券",
                        "id": 216145
                    }]
                }, {
                    "name": "厦门必胜客互金控股集团",
                    "id": 216146,
                    "children": [{
                        "name": "深圳谷歌制造",
                        "id": 216147
                    }, {
                        "name": "首尔瑞幸医院",
                        "id": 216148
                    }, {
                        "name": "上海字节医药",
                        "id": 216149
                    }, {
                        "name": "台北小米电商控股集团",
                        "id": 216150
                    }, {
                        "name": "南京谷歌航空有限公司",
                        "id": 216151
                    }, {
                        "name": "东京蚂蚁牧业",
                        "id": 216152
                    }, {
                        "name": "台北快手养殖",
                        "id": 216153
                    }, {
                        "name": "纽约肯德基科技控股集团",
                        "id": 216154
                    }, {
                        "name": "东莞奈雪医院有限公司",
                        "id": 216155
                    }, {
                        "name": "深圳喜茶医药",
                        "id": 216156
                    }, {
                        "name": "厦门欧珀养殖",
                        "id": 216157
                    }, {
                        "name": "香港快手电商",
                        "id": 216158
                    }, {
                        "name": "台北亚马逊渔业",
                        "id": 216159
                    }, {
                        "name": "北京必胜客新能源",
                        "id": 216160
                    }, {
                        "name": "香港微软银行有限公司",
                        "id": 216161
                    }, {
                        "name": "杭州平安汽车控股集团",
                        "id": 216162
                    }, {
                        "name": "天津特斯拉地摊有限公司",
                        "id": 216163
                    }, {
                        "name": "东京奈雪新能源",
                        "id": 216164
                    }, {
                        "name": "首尔小米芯片有限公司",
                        "id": 216165
                    }, {
                        "name": "厦门字节金融",
                        "id": 216166
                    }]
                }, {
                    "name": "深圳字节芯片",
                    "id": 216167
                }, {
                    "name": "东莞必胜客新能源",
                    "id": 216168,
                    "children": [{
                        "name": "南京百度通信",
                        "id": 216169
                    }, {
                        "name": "广州小米基金",
                        "id": 216170
                    }, {
                        "name": "深圳腾讯诊所",
                        "id": 216171
                    }, {
                        "name": "东莞小米新能源",
                        "id": 216172
                    }, {
                        "name": "杭州华为农业控股集团",
                        "id": 216173
                    }, {
                        "name": "杭州百度新能源",
                        "id": 216174
                    }, {
                        "name": "广州腾讯计算机",
                        "id": 216175
                    }, {
                        "name": "杭州瑞幸科技",
                        "id": 216176
                    }, {
                        "name": "天津美团有限公司",
                        "id": 216177
                    }, {
                        "name": "杭州瑞幸互金控股集团",
                        "id": 216178
                    }, {
                        "name": "杭州阿里金融控股集团",
                        "id": 216179
                    }, {
                        "name": "香港星巴克汽车",
                        "id": 216180
                    }, {
                        "name": "北京特斯拉基金",
                        "id": 216181
                    }, {
                        "name": "杭州微软金融",
                        "id": 216182
                    }, {
                        "name": "东莞百度信息服务有限公司",
                        "id": 216183
                    }, {
                        "name": "南京苹果",
                        "id": 216184
                    }, {
                        "name": "东京小米诊所有限公司",
                        "id": 216185
                    }, {
                        "name": "南京必胜客地产有限公司",
                        "id": 216186
                    }, {
                        "name": "深圳快手科技",
                        "id": 216187
                    }, {
                        "name": "台北瑞幸科技控股集团",
                        "id": 216188
                    }]
                }, {
                    "name": "东莞星巴克制造",
                    "id": 216189
                }]
            }, {
                "name": "上海美团牧业",
                "id": 216190
            }, {
                "name": "深圳奈雪互金",
                "id": 216191
            }, {
                "name": "南京快手信息服务",
                "id": 216192
            }]
        }]
    }, {
        "name": "东京星巴克软件",
        "id": 216193
    }, {
        "name": "南京谷歌渔业",
        "id": 216194,
        "children": [{
            "name": "上海字节基金",
            "id": 216195
        }, {
            "name": "东莞苹果科技控股集团",
            "id": 216196,
            "children": [{
                "name": "台北阿里控股集团",
                "id": 216197
            }, {
                "name": "天津星巴克电商",
                "id": 216198
            }, {
                "name": "上海苹果互金",
                "id": 216199
            }, {
                "name": "杭州平安医药",
                "id": 216200
            }, {
                "name": "杭州星巴克制造",
                "id": 216201
            }, {
                "name": "东莞亚马逊金融控股集团",
                "id": 216202
            }, {
                "name": "深圳百度电商有限公司",
                "id": 216203
            }, {
                "name": "北京肯德基控股集团",
                "id": 216204
            }, {
                "name": "台北欧珀证券",
                "id": 216205
            }, {
                "name": "香港美团",
                "id": 216206
            }, {
                "name": "广州苹果诊所",
                "id": 216207
            }, {
                "name": "深圳阿里金融",
                "id": 216208
            }, {
                "name": "台北瑞幸农业有限公司",
                "id": 216209,
                "children": [{
                    "name": "南京快手地摊控股集团",
                    "id": 216210,
                    "children": [{
                        "name": "天津百度牧业控股集团",
                        "id": 216211
                    }, {
                        "name": "南京星巴克石油",
                        "id": 216212
                    }, {
                        "name": "纽约平安银行有限公司",
                        "id": 216213
                    }, {
                        "name": "厦门百度基金有限公司",
                        "id": 216214
                    }, {
                        "name": "首尔星巴克渔业",
                        "id": 216215
                    }, {
                        "name": "天津蚂蚁通讯",
                        "id": 216216
                    }, {
                        "name": "首尔瑞幸地产控股集团",
                        "id": 216217
                    }, {
                        "name": "深圳蚂蚁石油",
                        "id": 216218
                    }, {
                        "name": "杭州肯德基诊所",
                        "id": 216219
                    }, {
                        "name": "纽约喜茶医院有限公司",
                        "id": 216220
                    }]
                }, {
                    "name": "杭州蚂蚁控股集团",
                    "id": 216221
                }]
            }]
        }, {
            "name": "杭州亚马逊地摊有限公司",
            "id": 216222
        }, {
            "name": "台北瑞幸石油控股集团",
            "id": 216223
        }, {
            "name": "杭州肯德基诊所",
            "id": 216224,
            "children": [{
                "name": "北京百度地产",
                "id": 216225
            }, {
                "name": "纽约瑞幸通讯有限公司",
                "id": 216226,
                "children": [{
                    "name": "杭州亚马逊",
                    "id": 216227,
                    "children": [{
                        "name": "北京小米医院",
                        "id": 216228
                    }, {
                        "name": "台北特斯拉智能",
                        "id": 216229
                    }, {
                        "name": "北京喜茶互金控股集团",
                        "id": 216230
                    }, {
                        "name": "台北星巴克航空",
                        "id": 216231
                    }, {
                        "name": "香港欧珀信息服务控股集团",
                        "id": 216232
                    }, {
                        "name": "东莞谷歌信息服务有限公司",
                        "id": 216233
                    }, {
                        "name": "台北蚂蚁汽车",
                        "id": 216234
                    }, {
                        "name": "首尔星巴克证券有限公司",
                        "id": 216235
                    }, {
                        "name": "杭州滴滴新能源有限公司",
                        "id": 216236
                    }, {
                        "name": "南京必胜客诊所",
                        "id": 216237
                    }, {
                        "name": "深圳平安芯片有限公司",
                        "id": 216238
                    }, {
                        "name": "厦门瑞幸芯片",
                        "id": 216239
                    }, {
                        "name": "南京百度芯片",
                        "id": 216240
                    }, {
                        "name": "广州欧珀汽车有限公司",
                        "id": 216241
                    }, {
                        "name": "深圳必胜客软件",
                        "id": 216242
                    }, {
                        "name": "香港喜茶餐饮",
                        "id": 216243
                    }, {
                        "name": "东京百度有限公司",
                        "id": 216244
                    }, {
                        "name": "纽约亚马逊科技",
                        "id": 216245
                    }, {
                        "name": "台北谷歌信息服务",
                        "id": 216246
                    }, {
                        "name": "台北微软科技控股集团",
                        "id": 216247
                    }, {
                        "name": "深圳奈雪通信",
                        "id": 216248
                    }, {
                        "name": "深圳肯德基信息服务",
                        "id": 216249
                    }, {
                        "name": "广州必胜客地摊",
                        "id": 216250
                    }, {
                        "name": "天津奈雪互金",
                        "id": 216251
                    }, {
                        "name": "上海苹果基金",
                        "id": 216252
                    }, {
                        "name": "杭州亚马逊诊所",
                        "id": 216253
                    }, {
                        "name": "南京蚂蚁",
                        "id": 216254
                    }, {
                        "name": "北京特斯拉制造控股集团",
                        "id": 216255
                    }, {
                        "name": "天津特斯拉科技",
                        "id": 216256
                    }, {
                        "name": "杭州星巴克互金",
                        "id": 216257
                    }, {
                        "name": "深圳百度农业",
                        "id": 216258
                    }, {
                        "name": "纽约小米牧业",
                        "id": 216259
                    }, {
                        "name": "深圳阿里地产控股集团",
                        "id": 216260
                    }, {
                        "name": "广州快手制造",
                        "id": 216261
                    }]
                }, {
                    "name": "纽约阿里养殖",
                    "id": 216262
                }, {
                    "name": "纽约小米医院",
                    "id": 216263,
                    "children": [{
                        "name": "杭州必胜客医院",
                        "id": 216264
                    }, {
                        "name": "杭州特斯拉新能源",
                        "id": 216265
                    }, {
                        "name": "厦门京东银行",
                        "id": 216266
                    }, {
                        "name": "南京肯德基诊所控股集团",
                        "id": 216267
                    }, {
                        "name": "天津亚马逊新能源",
                        "id": 216268
                    }, {
                        "name": "东莞特斯拉旅游",
                        "id": 216269
                    }, {
                        "name": "北京滴滴通讯有限公司",
                        "id": 216270
                    }, {
                        "name": "台北奈雪芯片",
                        "id": 216271
                    }, {
                        "name": "杭州平安地产",
                        "id": 216272
                    }, {
                        "name": "杭州特斯拉信息服务",
                        "id": 216273
                    }, {
                        "name": "天津百度智能",
                        "id": 216274
                    }, {
                        "name": "深圳蚂蚁石油",
                        "id": 216275
                    }, {
                        "name": "台北亚马逊制造",
                        "id": 216276
                    }, {
                        "name": "深圳美团智能控股集团",
                        "id": 216277
                    }, {
                        "name": "广州华为智能",
                        "id": 216278
                    }, {
                        "name": "上海瑞幸基金",
                        "id": 216279
                    }]
                }, {
                    "name": "杭州肯德基芯片",
                    "id": 216280
                }, {
                    "name": "广州瑞幸医药",
                    "id": 216281
                }, {
                    "name": "深圳百度通信控股集团",
                    "id": 216282,
                    "children": [{
                        "name": "香港美团基金",
                        "id": 216283
                    }]
                }, {
                    "name": "广州蚂蚁",
                    "id": 216284,
                    "children": [{
                        "name": "东京滴滴金融有限公司",
                        "id": 216285
                    }, {
                        "name": "纽约百度通讯控股集团",
                        "id": 216286
                    }, {
                        "name": "杭州特斯拉医药",
                        "id": 216287
                    }, {
                        "name": "广州字节汽车",
                        "id": 216288
                    }, {
                        "name": "杭州小米渔业控股集团",
                        "id": 216289
                    }, {
                        "name": "台北小米计算机有限公司",
                        "id": 216290
                    }, {
                        "name": "首尔百度航空",
                        "id": 216291
                    }]
                }]
            }, {
                "name": "杭州蚂蚁航空",
                "id": 216292,
                "children": [{
                    "name": "北京喜茶旅游有限公司",
                    "id": 216293
                }, {
                    "name": "香港苹果地产",
                    "id": 216294,
                    "children": [{
                        "name": "香港百度芯片",
                        "id": 216295
                    }, {
                        "name": "香港亚马逊",
                        "id": 216296
                    }, {
                        "name": "北京阿里制造控股集团",
                        "id": 216297
                    }, {
                        "name": "纽约蚂蚁软件",
                        "id": 216298
                    }, {
                        "name": "天津小米医药有限公司",
                        "id": 216299
                    }, {
                        "name": "广州百度通讯控股集团",
                        "id": 216300
                    }, {
                        "name": "杭州微软制造",
                        "id": 216301
                    }, {
                        "name": "厦门字节航空控股集团",
                        "id": 216302
                    }, {
                        "name": "东京华为",
                        "id": 216303
                    }, {
                        "name": "广州微软信息服务",
                        "id": 216304
                    }, {
                        "name": "东京京东新能源",
                        "id": 216305
                    }, {
                        "name": "东京美团智能",
                        "id": 216306
                    }, {
                        "name": "天津特斯拉餐饮",
                        "id": 216307
                    }, {
                        "name": "杭州小米石油",
                        "id": 216308
                    }, {
                        "name": "香港小米芯片有限公司",
                        "id": 216309
                    }]
                }, {
                    "name": "广州阿里新能源",
                    "id": 216310
                }, {
                    "name": "深圳喜茶金融",
                    "id": 216311
                }, {
                    "name": "上海腾讯电商",
                    "id": 216312,
                    "children": [{
                        "name": "天津蚂蚁诊所控股集团",
                        "id": 216313
                    }, {
                        "name": "厦门奈雪餐饮有限公司",
                        "id": 216314
                    }, {
                        "name": "南京字节地摊控股集团",
                        "id": 216315
                    }, {
                        "name": "首尔京东旅游控股集团",
                        "id": 216316
                    }, {
                        "name": "纽约腾讯旅游有限公司",
                        "id": 216317
                    }, {
                        "name": "杭州阿里制造",
                        "id": 216318
                    }, {
                        "name": "南京肯德基科技",
                        "id": 216319
                    }, {
                        "name": "台北特斯拉地摊有限公司",
                        "id": 216320
                    }, {
                        "name": "东京星巴克通讯",
                        "id": 216321
                    }, {
                        "name": "厦门星巴克信息服务有限公司",
                        "id": 216322
                    }, {
                        "name": "南京平安诊所",
                        "id": 216323
                    }, {
                        "name": "广州肯德基地摊有限公司",
                        "id": 216324
                    }, {
                        "name": "天津奈雪信息服务",
                        "id": 216325
                    }, {
                        "name": "深圳美团科技有限公司",
                        "id": 216326
                    }, {
                        "name": "首尔奈雪诊所",
                        "id": 216327
                    }, {
                        "name": "北京必胜客芯片控股集团",
                        "id": 216328
                    }, {
                        "name": "南京华为地摊控股集团",
                        "id": 216329
                    }, {
                        "name": "上海谷歌通信有限公司",
                        "id": 216330
                    }, {
                        "name": "天津亚马逊软件",
                        "id": 216331
                    }, {
                        "name": "厦门华为医药",
                        "id": 216332
                    }, {
                        "name": "东京微软新能源",
                        "id": 216333
                    }, {
                        "name": "台北瑞幸航空有限公司",
                        "id": 216334
                    }, {
                        "name": "南京腾讯石油",
                        "id": 216335
                    }, {
                        "name": "台北肯德基牧业",
                        "id": 216336
                    }, {
                        "name": "南京谷歌互金",
                        "id": 216337
                    }, {
                        "name": "天津亚马逊地产",
                        "id": 216338
                    }, {
                        "name": "厦门字节旅游控股集团",
                        "id": 216339
                    }]
                }, {
                    "name": "台北星巴克养殖",
                    "id": 216340,
                    "children": [{
                        "name": "首尔星巴克控股集团",
                        "id": 216341
                    }, {
                        "name": "南京滴滴金融",
                        "id": 216342
                    }, {
                        "name": "东京肯德基石油",
                        "id": 216343
                    }, {
                        "name": "东莞平安医药控股集团",
                        "id": 216344
                    }, {
                        "name": "东莞星巴克医院",
                        "id": 216345
                    }, {
                        "name": "广州京东银行",
                        "id": 216346
                    }, {
                        "name": "香港小米证券",
                        "id": 216347
                    }, {
                        "name": "东京小米农业",
                        "id": 216348
                    }, {
                        "name": "台北快手软件有限公司",
                        "id": 216349
                    }, {
                        "name": "深圳星巴克通信",
                        "id": 216350
                    }]
                }, {
                    "name": "东京特斯拉医院",
                    "id": 216351
                }, {
                    "name": "广州欧珀金融",
                    "id": 216352
                }]
            }, {
                "name": "天津字节软件",
                "id": 216353,
                "children": [{
                    "name": "首尔必胜客旅游",
                    "id": 216354
                }, {
                    "name": "杭州特斯拉电商控股集团",
                    "id": 216355
                }, {
                    "name": "深圳阿里新能源",
                    "id": 216356
                }, {
                    "name": "台北华为石油",
                    "id": 216357
                }, {
                    "name": "厦门美团计算机有限公司",
                    "id": 216358
                }, {
                    "name": "南京腾讯金融",
                    "id": 216359
                }, {
                    "name": "杭州小米渔业",
                    "id": 216360
                }, {
                    "name": "广州微软通信",
                    "id": 216361
                }, {
                    "name": "南京滴滴基金",
                    "id": 216362,
                    "children": [{
                        "name": "东京星巴克",
                        "id": 216363
                    }, {
                        "name": "天津特斯拉养殖",
                        "id": 216364
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 216365
                    }, {
                        "name": "香港必胜客电商",
                        "id": 216366
                    }, {
                        "name": "东京瑞幸智能有限公司",
                        "id": 216367
                    }, {
                        "name": "台北喜茶旅游控股集团",
                        "id": 216368
                    }, {
                        "name": "首尔快手通讯",
                        "id": 216369
                    }, {
                        "name": "深圳滴滴医药",
                        "id": 216370
                    }, {
                        "name": "深圳微软科技控股集团",
                        "id": 216371
                    }, {
                        "name": "东莞华为信息服务",
                        "id": 216372
                    }, {
                        "name": "纽约滴滴牧业控股集团",
                        "id": 216373
                    }, {
                        "name": "厦门字节科技",
                        "id": 216374
                    }, {
                        "name": "首尔肯德基通信控股集团",
                        "id": 216375
                    }, {
                        "name": "南京平安通讯",
                        "id": 216376
                    }, {
                        "name": "杭州快手电商",
                        "id": 216377
                    }, {
                        "name": "深圳华为地摊",
                        "id": 216378
                    }, {
                        "name": "深圳必胜客农业",
                        "id": 216379
                    }, {
                        "name": "厦门喜茶智能",
                        "id": 216380
                    }, {
                        "name": "台北肯德基汽车",
                        "id": 216381
                    }]
                }, {
                    "name": "广州京东地摊有限公司",
                    "id": 216382,
                    "children": [{
                        "name": "东京谷歌证券",
                        "id": 216383
                    }, {
                        "name": "北京瑞幸餐饮有限公司",
                        "id": 216384
                    }]
                }, {
                    "name": "南京谷歌证券控股集团",
                    "id": 216385,
                    "children": [{
                        "name": "台北小米新能源",
                        "id": 216386
                    }, {
                        "name": "纽约特斯拉软件",
                        "id": 216387
                    }, {
                        "name": "深圳百度制造",
                        "id": 216388
                    }, {
                        "name": "天津肯德基航空",
                        "id": 216389
                    }, {
                        "name": "深圳喜茶芯片",
                        "id": 216390
                    }, {
                        "name": "台北喜茶旅游",
                        "id": 216391
                    }, {
                        "name": "香港奈雪地产",
                        "id": 216392
                    }, {
                        "name": "东莞平安养殖",
                        "id": 216393
                    }, {
                        "name": "杭州腾讯智能",
                        "id": 216394
                    }, {
                        "name": "上海滴滴医药",
                        "id": 216395
                    }, {
                        "name": "天津星巴克医院控股集团",
                        "id": 216396
                    }, {
                        "name": "南京微软地产",
                        "id": 216397
                    }, {
                        "name": "杭州奈雪银行",
                        "id": 216398
                    }, {
                        "name": "北京京东科技",
                        "id": 216399
                    }]
                }, {
                    "name": "广州美团养殖",
                    "id": 216400,
                    "children": [{
                        "name": "纽约滴滴牧业控股集团",
                        "id": 216401
                    }, {
                        "name": "台北美团地产控股集团",
                        "id": 216402
                    }, {
                        "name": "台北微软银行有限公司",
                        "id": 216403
                    }, {
                        "name": "上海滴滴制造有限公司",
                        "id": 216404
                    }, {
                        "name": "天津腾讯互金",
                        "id": 216405
                    }, {
                        "name": "上海谷歌养殖",
                        "id": 216406
                    }, {
                        "name": "南京平安互金",
                        "id": 216407
                    }, {
                        "name": "南京奈雪诊所控股集团",
                        "id": 216408
                    }, {
                        "name": "首尔欧珀智能控股集团",
                        "id": 216409
                    }, {
                        "name": "杭州瑞幸通讯",
                        "id": 216410
                    }, {
                        "name": "天津平安渔业",
                        "id": 216411
                    }, {
                        "name": "香港亚马逊制造",
                        "id": 216412
                    }, {
                        "name": "东莞瑞幸新能源",
                        "id": 216413
                    }, {
                        "name": "南京谷歌信息服务控股集团",
                        "id": 216414
                    }, {
                        "name": "广州微软信息服务",
                        "id": 216415
                    }, {
                        "name": "上海肯德基证券有限公司",
                        "id": 216416
                    }, {
                        "name": "广州星巴克渔业",
                        "id": 216417
                    }, {
                        "name": "东京平安通讯",
                        "id": 216418
                    }, {
                        "name": "厦门欧珀基金",
                        "id": 216419
                    }, {
                        "name": "东京奈雪证券控股集团",
                        "id": 216420
                    }, {
                        "name": "东莞谷歌互金",
                        "id": 216421
                    }]
                }, {
                    "name": "深圳亚马逊通信",
                    "id": 216422
                }, {
                    "name": "深圳欧珀诊所控股集团",
                    "id": 216423
                }, {
                    "name": "深圳美团农业",
                    "id": 216424
                }, {
                    "name": "天津华为农业",
                    "id": 216425
                }, {
                    "name": "纽约平安基金",
                    "id": 216426
                }, {
                    "name": "杭州亚马逊地产",
                    "id": 216427
                }, {
                    "name": "深圳阿里通讯",
                    "id": 216428
                }, {
                    "name": "台北平安电商控股集团",
                    "id": 216429
                }, {
                    "name": "香港平安餐饮",
                    "id": 216430
                }, {
                    "name": "东京奈雪诊所",
                    "id": 216431,
                    "children": [{
                        "name": "深圳蚂蚁控股集团",
                        "id": 216432
                    }, {
                        "name": "深圳苹果控股集团",
                        "id": 216433
                    }, {
                        "name": "香港肯德基互金",
                        "id": 216434
                    }, {
                        "name": "香港苹果金融有限公司",
                        "id": 216435
                    }, {
                        "name": "上海华为芯片有限公司",
                        "id": 216436
                    }, {
                        "name": "首尔京东计算机控股集团",
                        "id": 216437
                    }, {
                        "name": "香港亚马逊新能源控股集团",
                        "id": 216438
                    }, {
                        "name": "首尔亚马逊有限公司",
                        "id": 216439
                    }, {
                        "name": "深圳字节农业控股集团",
                        "id": 216440
                    }, {
                        "name": "杭州必胜客互金",
                        "id": 216441
                    }, {
                        "name": "厦门滴滴制造有限公司",
                        "id": 216442
                    }, {
                        "name": "首尔奈雪汽车有限公司",
                        "id": 216443
                    }, {
                        "name": "台北快手牧业",
                        "id": 216444
                    }, {
                        "name": "上海肯德基金融",
                        "id": 216445
                    }, {
                        "name": "厦门喜茶银行",
                        "id": 216446
                    }, {
                        "name": "东京阿里基金",
                        "id": 216447
                    }, {
                        "name": "深圳特斯拉新能源控股集团",
                        "id": 216448
                    }, {
                        "name": "南京字节电商有限公司",
                        "id": 216449
                    }, {
                        "name": "北京蚂蚁新能源",
                        "id": 216450
                    }, {
                        "name": "杭州腾讯制造",
                        "id": 216451
                    }]
                }, {
                    "name": "杭州京东餐饮",
                    "id": 216452,
                    "children": [{
                        "name": "杭州京东",
                        "id": 216453
                    }, {
                        "name": "杭州小米制造",
                        "id": 216454
                    }, {
                        "name": "首尔美团互金",
                        "id": 216455
                    }, {
                        "name": "首尔星巴克石油控股集团",
                        "id": 216456
                    }, {
                        "name": "香港字节医院",
                        "id": 216457
                    }, {
                        "name": "上海谷歌信息服务",
                        "id": 216458
                    }, {
                        "name": "深圳瑞幸旅游",
                        "id": 216459
                    }, {
                        "name": "上海奈雪旅游有限公司",
                        "id": 216460
                    }, {
                        "name": "深圳滴滴智能",
                        "id": 216461
                    }, {
                        "name": "首尔必胜客餐饮",
                        "id": 216462
                    }, {
                        "name": "厦门微软智能控股集团",
                        "id": 216463
                    }, {
                        "name": "东京京东互金有限公司",
                        "id": 216464
                    }, {
                        "name": "台北瑞幸新能源有限公司",
                        "id": 216465
                    }, {
                        "name": "上海特斯拉医药",
                        "id": 216466
                    }, {
                        "name": "杭州星巴克渔业控股集团",
                        "id": 216467
                    }]
                }, {
                    "name": "北京肯德基计算机控股集团",
                    "id": 216468
                }, {
                    "name": "香港亚马逊新能源",
                    "id": 216469,
                    "children": [{
                        "name": "纽约苹果石油",
                        "id": 216470
                    }, {
                        "name": "东京百度基金控股集团",
                        "id": 216471
                    }, {
                        "name": "上海瑞幸信息服务",
                        "id": 216472
                    }, {
                        "name": "香港腾讯有限公司",
                        "id": 216473
                    }, {
                        "name": "纽约腾讯科技",
                        "id": 216474
                    }, {
                        "name": "厦门华为控股集团",
                        "id": 216475
                    }, {
                        "name": "深圳谷歌芯片",
                        "id": 216476
                    }, {
                        "name": "南京滴滴地摊",
                        "id": 216477
                    }, {
                        "name": "杭州肯德基诊所",
                        "id": 216478
                    }, {
                        "name": "北京亚马逊航空",
                        "id": 216479
                    }, {
                        "name": "广州奈雪",
                        "id": 216480
                    }, {
                        "name": "杭州京东航空",
                        "id": 216481
                    }, {
                        "name": "上海美团渔业",
                        "id": 216482
                    }, {
                        "name": "广州小米养殖",
                        "id": 216483
                    }, {
                        "name": "纽约华为医院",
                        "id": 216484
                    }, {
                        "name": "北京亚马逊地摊有限公司",
                        "id": 216485
                    }, {
                        "name": "杭州快手餐饮",
                        "id": 216486
                    }, {
                        "name": "北京腾讯基金有限公司",
                        "id": 216487
                    }, {
                        "name": "广州苹果通信有限公司",
                        "id": 216488
                    }, {
                        "name": "天津滴滴通信",
                        "id": 216489
                    }, {
                        "name": "台北苹果新能源有限公司",
                        "id": 216490
                    }, {
                        "name": "纽约谷歌通讯控股集团",
                        "id": 216491
                    }, {
                        "name": "杭州小米诊所",
                        "id": 216492
                    }, {
                        "name": "广州腾讯地摊",
                        "id": 216493
                    }, {
                        "name": "杭州必胜客医院",
                        "id": 216494
                    }, {
                        "name": "广州百度医院",
                        "id": 216495
                    }, {
                        "name": "杭州京东航空有限公司",
                        "id": 216496
                    }, {
                        "name": "深圳平安农业有限公司",
                        "id": 216497
                    }, {
                        "name": "台北平安科技有限公司",
                        "id": 216498
                    }, {
                        "name": "厦门快手信息服务",
                        "id": 216499
                    }]
                }, {
                    "name": "首尔美团软件控股集团",
                    "id": 216500
                }, {
                    "name": "北京特斯拉通信",
                    "id": 216501
                }, {
                    "name": "杭州苹果地摊控股集团",
                    "id": 216502
                }]
            }, {
                "name": "杭州谷歌通讯",
                "id": 216503
            }, {
                "name": "香港必胜客旅游控股集团",
                "id": 216504
            }]
        }, {
            "name": "杭州蚂蚁通信",
            "id": 216505,
            "children": [{
                "name": "纽约京东地摊",
                "id": 216506,
                "children": [{
                    "name": "广州喜茶通讯",
                    "id": 216507
                }, {
                    "name": "杭州蚂蚁医药",
                    "id": 216508
                }, {
                    "name": "东莞阿里新能源",
                    "id": 216509,
                    "children": [{
                        "name": "首尔特斯拉智能",
                        "id": 216510
                    }, {
                        "name": "深圳腾讯软件控股集团",
                        "id": 216511
                    }, {
                        "name": "杭州喜茶",
                        "id": 216512
                    }, {
                        "name": "广州星巴克医院有限公司",
                        "id": 216513
                    }, {
                        "name": "首尔喜茶航空有限公司",
                        "id": 216514
                    }, {
                        "name": "杭州星巴克",
                        "id": 216515
                    }, {
                        "name": "深圳瑞幸渔业",
                        "id": 216516
                    }, {
                        "name": "东莞亚马逊金融",
                        "id": 216517
                    }, {
                        "name": "首尔必胜客证券",
                        "id": 216518
                    }, {
                        "name": "深圳阿里旅游有限公司",
                        "id": 216519
                    }, {
                        "name": "北京喜茶通讯",
                        "id": 216520
                    }, {
                        "name": "南京肯德基航空",
                        "id": 216521
                    }, {
                        "name": "台北星巴克通信有限公司",
                        "id": 216522
                    }, {
                        "name": "广州微软地产",
                        "id": 216523
                    }, {
                        "name": "东京蚂蚁石油",
                        "id": 216524
                    }, {
                        "name": "上海快手有限公司",
                        "id": 216525
                    }, {
                        "name": "首尔欧珀诊所",
                        "id": 216526
                    }, {
                        "name": "深圳滴滴农业控股集团",
                        "id": 216527
                    }, {
                        "name": "广州美团制造",
                        "id": 216528
                    }]
                }, {
                    "name": "香港谷歌地摊",
                    "id": 216529,
                    "children": [{
                        "name": "厦门美团航空",
                        "id": 216530
                    }, {
                        "name": "厦门华为餐饮控股集团",
                        "id": 216531
                    }, {
                        "name": "东莞谷歌地产有限公司",
                        "id": 216532
                    }]
                }, {
                    "name": "香港阿里互金有限公司",
                    "id": 216533
                }, {
                    "name": "东莞蚂蚁汽车",
                    "id": 216534
                }, {
                    "name": "天津必胜客",
                    "id": 216535
                }, {
                    "name": "首尔苹果养殖",
                    "id": 216536
                }, {
                    "name": "上海腾讯养殖",
                    "id": 216537
                }, {
                    "name": "首尔字节石油",
                    "id": 216538
                }, {
                    "name": "首尔肯德基通信",
                    "id": 216539
                }, {
                    "name": "首尔微软银行有限公司",
                    "id": 216540,
                    "children": [{
                        "name": "杭州欧珀牧业控股集团",
                        "id": 216541
                    }, {
                        "name": "杭州欧珀银行",
                        "id": 216542
                    }, {
                        "name": "深圳星巴克汽车",
                        "id": 216543
                    }, {
                        "name": "杭州微软",
                        "id": 216544
                    }, {
                        "name": "深圳蚂蚁汽车",
                        "id": 216545
                    }, {
                        "name": "台北喜茶诊所",
                        "id": 216546
                    }, {
                        "name": "上海谷歌软件有限公司",
                        "id": 216547
                    }, {
                        "name": "深圳华为汽车",
                        "id": 216548
                    }, {
                        "name": "厦门快手银行控股集团",
                        "id": 216549
                    }, {
                        "name": "东莞平安电商",
                        "id": 216550
                    }]
                }, {
                    "name": "香港喜茶",
                    "id": 216551
                }, {
                    "name": "广州欧珀渔业",
                    "id": 216552
                }, {
                    "name": "厦门美团餐饮",
                    "id": 216553
                }]
            }, {
                "name": "深圳瑞幸旅游",
                "id": 216554
            }, {
                "name": "东京蚂蚁科技控股集团",
                "id": 216555
            }, {
                "name": "广州腾讯旅游",
                "id": 216556
            }, {
                "name": "台北亚马逊互金",
                "id": 216557
            }, {
                "name": "东京星巴克农业",
                "id": 216558
            }, {
                "name": "北京美团控股集团",
                "id": 216559
            }, {
                "name": "天津美团餐饮控股集团",
                "id": 216560,
                "children": [{
                    "name": "深圳亚马逊电商",
                    "id": 216561,
                    "children": [{
                        "name": "首尔京东医院",
                        "id": 216562
                    }, {
                        "name": "首尔平安软件控股集团",
                        "id": 216563
                    }, {
                        "name": "天津星巴克汽车",
                        "id": 216564
                    }, {
                        "name": "广州亚马逊金融",
                        "id": 216565
                    }, {
                        "name": "广州谷歌餐饮",
                        "id": 216566
                    }, {
                        "name": "香港奈雪通讯",
                        "id": 216567
                    }, {
                        "name": "台北平安证券",
                        "id": 216568
                    }, {
                        "name": "上海京东科技",
                        "id": 216569
                    }, {
                        "name": "广州谷歌渔业",
                        "id": 216570
                    }, {
                        "name": "南京喜茶航空",
                        "id": 216571
                    }, {
                        "name": "东京亚马逊新能源",
                        "id": 216572
                    }, {
                        "name": "台北阿里医院控股集团",
                        "id": 216573
                    }, {
                        "name": "东莞滴滴地摊",
                        "id": 216574
                    }, {
                        "name": "东莞微软通信有限公司",
                        "id": 216575
                    }, {
                        "name": "北京特斯拉",
                        "id": 216576
                    }]
                }]
            }, {
                "name": "台北肯德基金融",
                "id": 216577
            }, {
                "name": "广州腾讯基金控股集团",
                "id": 216578
            }, {
                "name": "天津百度有限公司",
                "id": 216579
            }, {
                "name": "杭州必胜客智能",
                "id": 216580
            }, {
                "name": "天津阿里地产",
                "id": 216581
            }, {
                "name": "北京快手计算机有限公司",
                "id": 216582
            }, {
                "name": "天津亚马逊养殖有限公司",
                "id": 216583,
                "children": [{
                    "name": "广州亚马逊医院有限公司",
                    "id": 216584,
                    "children": [{
                        "name": "东京字节通信",
                        "id": 216585
                    }, {
                        "name": "广州平安渔业有限公司",
                        "id": 216586
                    }, {
                        "name": "东莞必胜客控股集团",
                        "id": 216587
                    }, {
                        "name": "杭州喜茶航空",
                        "id": 216588
                    }, {
                        "name": "厦门小米牧业有限公司",
                        "id": 216589
                    }, {
                        "name": "杭州肯德基汽车",
                        "id": 216590
                    }, {
                        "name": "首尔京东软件",
                        "id": 216591
                    }, {
                        "name": "杭州亚马逊医药控股集团",
                        "id": 216592
                    }, {
                        "name": "南京星巴克航空有限公司",
                        "id": 216593
                    }, {
                        "name": "东莞平安通讯控股集团",
                        "id": 216594
                    }, {
                        "name": "南京滴滴地产控股集团",
                        "id": 216595
                    }, {
                        "name": "台北华为石油控股集团",
                        "id": 216596
                    }, {
                        "name": "香港肯德基有限公司",
                        "id": 216597
                    }, {
                        "name": "首尔字节软件",
                        "id": 216598
                    }, {
                        "name": "南京滴滴地摊",
                        "id": 216599
                    }, {
                        "name": "首尔腾讯新能源",
                        "id": 216600
                    }, {
                        "name": "杭州苹果医院",
                        "id": 216601
                    }, {
                        "name": "纽约亚马逊医药控股集团",
                        "id": 216602
                    }, {
                        "name": "首尔滴滴新能源控股集团",
                        "id": 216603
                    }, {
                        "name": "东莞欧珀新能源控股集团",
                        "id": 216604
                    }, {
                        "name": "杭州必胜客通信",
                        "id": 216605
                    }, {
                        "name": "深圳字节石油",
                        "id": 216606
                    }, {
                        "name": "上海京东信息服务控股集团",
                        "id": 216607
                    }, {
                        "name": "首尔华为诊所有限公司",
                        "id": 216608
                    }, {
                        "name": "南京欧珀养殖有限公司",
                        "id": 216609
                    }, {
                        "name": "东京星巴克诊所",
                        "id": 216610
                    }, {
                        "name": "香港星巴克养殖",
                        "id": 216611
                    }]
                }]
            }, {
                "name": "杭州必胜客通讯有限公司",
                "id": 216612
            }, {
                "name": "台北平安旅游有限公司",
                "id": 216613
            }, {
                "name": "杭州华为诊所",
                "id": 216614
            }, {
                "name": "天津苹果航空",
                "id": 216615,
                "children": [{
                    "name": "杭州谷歌通讯控股集团",
                    "id": 216616,
                    "children": [{
                        "name": "上海星巴克有限公司",
                        "id": 216617
                    }, {
                        "name": "台北喜茶软件",
                        "id": 216618
                    }, {
                        "name": "纽约平安地产",
                        "id": 216619
                    }, {
                        "name": "东京小米有限公司",
                        "id": 216620
                    }, {
                        "name": "首尔星巴克计算机",
                        "id": 216621
                    }, {
                        "name": "首尔快手航空",
                        "id": 216622
                    }, {
                        "name": "东京谷歌旅游",
                        "id": 216623
                    }, {
                        "name": "广州肯德基航空控股集团",
                        "id": 216624
                    }, {
                        "name": "天津美团",
                        "id": 216625
                    }, {
                        "name": "天津星巴克诊所",
                        "id": 216626
                    }, {
                        "name": "厦门快手基金",
                        "id": 216627
                    }, {
                        "name": "上海微软地产",
                        "id": 216628
                    }, {
                        "name": "天津滴滴金融",
                        "id": 216629
                    }, {
                        "name": "首尔星巴克软件控股集团",
                        "id": 216630
                    }, {
                        "name": "天津小米",
                        "id": 216631
                    }, {
                        "name": "首尔美团渔业",
                        "id": 216632
                    }, {
                        "name": "上海欧珀金融有限公司",
                        "id": 216633
                    }, {
                        "name": "香港谷歌汽车",
                        "id": 216634
                    }, {
                        "name": "深圳腾讯餐饮",
                        "id": 216635
                    }, {
                        "name": "南京谷歌软件",
                        "id": 216636
                    }, {
                        "name": "北京喜茶科技",
                        "id": 216637
                    }, {
                        "name": "广州华为通讯",
                        "id": 216638
                    }, {
                        "name": "广州滴滴渔业有限公司",
                        "id": 216639
                    }, {
                        "name": "杭州微软金融控股集团",
                        "id": 216640
                    }, {
                        "name": "南京腾讯通讯",
                        "id": 216641
                    }, {
                        "name": "东京星巴克基金",
                        "id": 216642
                    }, {
                        "name": "东京奈雪科技控股集团",
                        "id": 216643
                    }, {
                        "name": "东京快手芯片",
                        "id": 216644
                    }, {
                        "name": "厦门喜茶汽车",
                        "id": 216645
                    }, {
                        "name": "台北腾讯信息服务",
                        "id": 216646
                    }, {
                        "name": "杭州京东电商",
                        "id": 216647
                    }, {
                        "name": "杭州肯德基科技",
                        "id": 216648
                    }]
                }, {
                    "name": "北京星巴克诊所有限公司",
                    "id": 216649,
                    "children": [{
                        "name": "杭州必胜客地产",
                        "id": 216650
                    }, {
                        "name": "厦门必胜客智能",
                        "id": 216651
                    }, {
                        "name": "厦门星巴克牧业",
                        "id": 216652
                    }, {
                        "name": "香港瑞幸牧业",
                        "id": 216653
                    }, {
                        "name": "杭州华为通信",
                        "id": 216654
                    }, {
                        "name": "杭州肯德基新能源",
                        "id": 216655
                    }, {
                        "name": "厦门阿里基金有限公司",
                        "id": 216656
                    }, {
                        "name": "东莞星巴克信息服务",
                        "id": 216657
                    }, {
                        "name": "上海必胜客通讯",
                        "id": 216658
                    }, {
                        "name": "香港喜茶互金控股集团",
                        "id": 216659
                    }, {
                        "name": "上海星巴克诊所",
                        "id": 216660
                    }, {
                        "name": "香港阿里信息服务",
                        "id": 216661
                    }, {
                        "name": "北京小米电商",
                        "id": 216662
                    }, {
                        "name": "纽约京东地摊",
                        "id": 216663
                    }, {
                        "name": "厦门美团金融",
                        "id": 216664
                    }, {
                        "name": "南京华为计算机",
                        "id": 216665
                    }, {
                        "name": "东京肯德基诊所",
                        "id": 216666
                    }, {
                        "name": "香港特斯拉航空有限公司",
                        "id": 216667
                    }, {
                        "name": "南京必胜客软件",
                        "id": 216668
                    }, {
                        "name": "杭州百度",
                        "id": 216669
                    }, {
                        "name": "南京华为农业",
                        "id": 216670
                    }, {
                        "name": "东莞奈雪金融有限公司",
                        "id": 216671
                    }, {
                        "name": "纽约快手计算机",
                        "id": 216672
                    }, {
                        "name": "台北谷歌汽车控股集团",
                        "id": 216673
                    }]
                }, {
                    "name": "深圳滴滴养殖",
                    "id": 216674,
                    "children": [{
                        "name": "首尔瑞幸新能源",
                        "id": 216675
                    }, {
                        "name": "台北喜茶通讯",
                        "id": 216676
                    }, {
                        "name": "广州华为通讯",
                        "id": 216677
                    }, {
                        "name": "台北百度通讯控股集团",
                        "id": 216678
                    }, {
                        "name": "东京肯德基计算机控股集团",
                        "id": 216679
                    }, {
                        "name": "广州平安新能源",
                        "id": 216680
                    }, {
                        "name": "深圳谷歌信息服务",
                        "id": 216681
                    }, {
                        "name": "香港腾讯通信",
                        "id": 216682
                    }, {
                        "name": "天津喜茶芯片有限公司",
                        "id": 216683
                    }, {
                        "name": "纽约必胜客控股集团",
                        "id": 216684
                    }, {
                        "name": "天津京东科技",
                        "id": 216685
                    }, {
                        "name": "天津字节渔业",
                        "id": 216686
                    }, {
                        "name": "深圳瑞幸制造有限公司",
                        "id": 216687
                    }, {
                        "name": "东莞平安控股集团",
                        "id": 216688
                    }, {
                        "name": "东京苹果控股集团",
                        "id": 216689
                    }, {
                        "name": "台北小米信息服务",
                        "id": 216690
                    }, {
                        "name": "纽约快手智能",
                        "id": 216691
                    }, {
                        "name": "深圳京东",
                        "id": 216692
                    }, {
                        "name": "杭州蚂蚁汽车",
                        "id": 216693
                    }, {
                        "name": "广州平安证券有限公司",
                        "id": 216694
                    }, {
                        "name": "广州百度通信有限公司",
                        "id": 216695
                    }]
                }, {
                    "name": "上海快手养殖有限公司",
                    "id": 216696
                }, {
                    "name": "深圳特斯拉地摊",
                    "id": 216697
                }]
            }, {
                "name": "杭州小米信息服务",
                "id": 216698,
                "children": [{
                    "name": "北京微软汽车",
                    "id": 216699
                }, {
                    "name": "首尔华为证券控股集团",
                    "id": 216700
                }, {
                    "name": "台北华为互金",
                    "id": 216701,
                    "children": [{
                        "name": "天津字节芯片",
                        "id": 216702
                    }, {
                        "name": "杭州华为农业",
                        "id": 216703
                    }, {
                        "name": "深圳腾讯科技",
                        "id": 216704
                    }, {
                        "name": "厦门必胜客基金",
                        "id": 216705
                    }]
                }, {
                    "name": "厦门平安餐饮控股集团",
                    "id": 216706
                }, {
                    "name": "深圳华为计算机控股集团",
                    "id": 216707
                }, {
                    "name": "首尔瑞幸渔业",
                    "id": 216708
                }, {
                    "name": "东莞亚马逊医药",
                    "id": 216709
                }, {
                    "name": "上海华为新能源",
                    "id": 216710,
                    "children": [{
                        "name": "南京星巴克证券有限公司",
                        "id": 216711
                    }, {
                        "name": "厦门快手基金控股集团",
                        "id": 216712
                    }, {
                        "name": "香港平安地产",
                        "id": 216713
                    }, {
                        "name": "上海星巴克基金",
                        "id": 216714
                    }, {
                        "name": "深圳特斯拉医药",
                        "id": 216715
                    }, {
                        "name": "杭州谷歌智能",
                        "id": 216716
                    }, {
                        "name": "东莞必胜客渔业",
                        "id": 216717
                    }, {
                        "name": "上海谷歌",
                        "id": 216718
                    }, {
                        "name": "北京星巴克银行",
                        "id": 216719
                    }, {
                        "name": "北京星巴克控股集团",
                        "id": 216720
                    }, {
                        "name": "上海小米制造",
                        "id": 216721
                    }, {
                        "name": "北京瑞幸芯片控股集团",
                        "id": 216722
                    }, {
                        "name": "台北快手通信",
                        "id": 216723
                    }, {
                        "name": "台北苹果芯片",
                        "id": 216724
                    }, {
                        "name": "天津特斯拉制造",
                        "id": 216725
                    }, {
                        "name": "台北小米牧业",
                        "id": 216726
                    }, {
                        "name": "北京必胜客通讯",
                        "id": 216727
                    }, {
                        "name": "东莞肯德基旅游",
                        "id": 216728
                    }, {
                        "name": "首尔阿里旅游",
                        "id": 216729
                    }, {
                        "name": "东京星巴克银行",
                        "id": 216730
                    }, {
                        "name": "首尔微软新能源有限公司",
                        "id": 216731
                    }, {
                        "name": "天津字节信息服务",
                        "id": 216732
                    }]
                }, {
                    "name": "南京微软餐饮",
                    "id": 216733
                }]
            }, {
                "name": "天津肯德基",
                "id": 216734
            }, {
                "name": "天津蚂蚁医院",
                "id": 216735,
                "children": [{
                    "name": "北京平安航空",
                    "id": 216736
                }, {
                    "name": "天津必胜客地产",
                    "id": 216737
                }, {
                    "name": "香港特斯拉互金",
                    "id": 216738
                }, {
                    "name": "深圳快手汽车有限公司",
                    "id": 216739
                }, {
                    "name": "北京京东电商",
                    "id": 216740,
                    "children": [{
                        "name": "纽约蚂蚁地产",
                        "id": 216741
                    }, {
                        "name": "东莞微软",
                        "id": 216742
                    }, {
                        "name": "首尔肯德基互金",
                        "id": 216743
                    }, {
                        "name": "东莞字节证券",
                        "id": 216744
                    }, {
                        "name": "上海瑞幸医院",
                        "id": 216745
                    }, {
                        "name": "广州快手医药控股集团",
                        "id": 216746
                    }, {
                        "name": "南京亚马逊信息服务",
                        "id": 216747
                    }, {
                        "name": "杭州百度汽车",
                        "id": 216748
                    }, {
                        "name": "上海谷歌医院控股集团",
                        "id": 216749
                    }, {
                        "name": "杭州喜茶证券",
                        "id": 216750
                    }, {
                        "name": "天津京东信息服务",
                        "id": 216751
                    }, {
                        "name": "纽约阿里地产",
                        "id": 216752
                    }, {
                        "name": "香港小米证券",
                        "id": 216753
                    }, {
                        "name": "深圳蚂蚁金融",
                        "id": 216754
                    }, {
                        "name": "香港亚马逊通讯",
                        "id": 216755
                    }, {
                        "name": "天津百度新能源",
                        "id": 216756
                    }, {
                        "name": "纽约滴滴科技",
                        "id": 216757
                    }, {
                        "name": "台北小米科技有限公司",
                        "id": 216758
                    }, {
                        "name": "东莞华为诊所",
                        "id": 216759
                    }, {
                        "name": "台北腾讯软件",
                        "id": 216760
                    }, {
                        "name": "南京微软芯片",
                        "id": 216761
                    }, {
                        "name": "厦门平安旅游有限公司",
                        "id": 216762
                    }, {
                        "name": "东莞蚂蚁医院",
                        "id": 216763
                    }, {
                        "name": "天津快手农业",
                        "id": 216764
                    }, {
                        "name": "杭州奈雪农业控股集团",
                        "id": 216765
                    }, {
                        "name": "广州百度",
                        "id": 216766
                    }, {
                        "name": "北京京东制造",
                        "id": 216767
                    }, {
                        "name": "东莞阿里汽车",
                        "id": 216768
                    }, {
                        "name": "台北欧珀智能有限公司",
                        "id": 216769
                    }]
                }, {
                    "name": "深圳微软诊所",
                    "id": 216770,
                    "children": [{
                        "name": "北京亚马逊证券",
                        "id": 216771
                    }, {
                        "name": "广州蚂蚁医院",
                        "id": 216772
                    }, {
                        "name": "东京京东科技",
                        "id": 216773
                    }, {
                        "name": "纽约亚马逊养殖",
                        "id": 216774
                    }]
                }, {
                    "name": "南京微软电商",
                    "id": 216775
                }, {
                    "name": "天津微软养殖",
                    "id": 216776
                }, {
                    "name": "上海喜茶养殖有限公司",
                    "id": 216777
                }, {
                    "name": "上海滴滴餐饮",
                    "id": 216778
                }, {
                    "name": "台北阿里养殖",
                    "id": 216779
                }, {
                    "name": "首尔滴滴智能控股集团",
                    "id": 216780,
                    "children": [{
                        "name": "上海必胜客通信",
                        "id": 216781
                    }, {
                        "name": "首尔欧珀养殖有限公司",
                        "id": 216782
                    }, {
                        "name": "东莞蚂蚁通讯",
                        "id": 216783
                    }, {
                        "name": "香港滴滴新能源控股集团",
                        "id": 216784
                    }, {
                        "name": "杭州平安航空",
                        "id": 216785
                    }, {
                        "name": "深圳华为证券",
                        "id": 216786
                    }, {
                        "name": "北京小米牧业",
                        "id": 216787
                    }, {
                        "name": "上海蚂蚁金融",
                        "id": 216788
                    }, {
                        "name": "天津腾讯芯片",
                        "id": 216789
                    }, {
                        "name": "上海百度证券有限公司",
                        "id": 216790
                    }, {
                        "name": "杭州肯德基基金",
                        "id": 216791
                    }, {
                        "name": "台北喜茶互金",
                        "id": 216792
                    }, {
                        "name": "首尔肯德基",
                        "id": 216793
                    }, {
                        "name": "台北滴滴石油",
                        "id": 216794
                    }, {
                        "name": "上海欧珀养殖",
                        "id": 216795
                    }, {
                        "name": "广州亚马逊互金",
                        "id": 216796
                    }, {
                        "name": "东京字节智能",
                        "id": 216797
                    }, {
                        "name": "厦门阿里诊所",
                        "id": 216798
                    }]
                }, {
                    "name": "厦门喜茶诊所",
                    "id": 216799
                }, {
                    "name": "厦门喜茶养殖",
                    "id": 216800
                }, {
                    "name": "首尔滴滴养殖控股集团",
                    "id": 216801
                }, {
                    "name": "台北星巴克新能源",
                    "id": 216802,
                    "children": [{
                        "name": "台北喜茶通信控股集团",
                        "id": 216803
                    }, {
                        "name": "厦门特斯拉地摊",
                        "id": 216804
                    }, {
                        "name": "东莞字节银行",
                        "id": 216805
                    }, {
                        "name": "台北必胜客信息服务控股集团",
                        "id": 216806
                    }, {
                        "name": "首尔滴滴渔业",
                        "id": 216807
                    }, {
                        "name": "首尔蚂蚁地产",
                        "id": 216808
                    }, {
                        "name": "纽约百度旅游",
                        "id": 216809
                    }, {
                        "name": "深圳小米",
                        "id": 216810
                    }, {
                        "name": "北京平安",
                        "id": 216811
                    }, {
                        "name": "北京百度医药控股集团",
                        "id": 216812
                    }, {
                        "name": "纽约美团诊所控股集团",
                        "id": 216813
                    }, {
                        "name": "北京腾讯制造控股集团",
                        "id": 216814
                    }, {
                        "name": "深圳微软农业",
                        "id": 216815
                    }, {
                        "name": "深圳谷歌新能源",
                        "id": 216816
                    }, {
                        "name": "深圳亚马逊芯片控股集团",
                        "id": 216817
                    }, {
                        "name": "杭州阿里医药控股集团",
                        "id": 216818
                    }, {
                        "name": "厦门快手新能源",
                        "id": 216819
                    }, {
                        "name": "杭州星巴克证券",
                        "id": 216820
                    }, {
                        "name": "南京瑞幸新能源控股集团",
                        "id": 216821
                    }, {
                        "name": "东莞平安有限公司",
                        "id": 216822
                    }, {
                        "name": "纽约百度电商控股集团",
                        "id": 216823
                    }, {
                        "name": "广州谷歌基金控股集团",
                        "id": 216824
                    }, {
                        "name": "东京华为医药",
                        "id": 216825
                    }, {
                        "name": "东莞特斯拉智能",
                        "id": 216826
                    }, {
                        "name": "纽约星巴克芯片",
                        "id": 216827
                    }, {
                        "name": "广州亚马逊农业控股集团",
                        "id": 216828
                    }, {
                        "name": "纽约特斯拉证券",
                        "id": 216829
                    }, {
                        "name": "香港肯德基基金有限公司",
                        "id": 216830
                    }, {
                        "name": "东莞平安信息服务",
                        "id": 216831
                    }]
                }, {
                    "name": "杭州苹果旅游",
                    "id": 216832
                }, {
                    "name": "广州瑞幸医院",
                    "id": 216833
                }, {
                    "name": "北京瑞幸渔业",
                    "id": 216834
                }, {
                    "name": "台北字节基金",
                    "id": 216835
                }, {
                    "name": "厦门字节芯片",
                    "id": 216836
                }, {
                    "name": "北京喜茶医院",
                    "id": 216837
                }, {
                    "name": "台北字节控股集团",
                    "id": 216838
                }, {
                    "name": "广州小米",
                    "id": 216839,
                    "children": [{
                        "name": "深圳谷歌互金",
                        "id": 216840
                    }, {
                        "name": "杭州阿里牧业控股集团",
                        "id": 216841
                    }, {
                        "name": "东京京东石油",
                        "id": 216842
                    }, {
                        "name": "杭州亚马逊通讯",
                        "id": 216843
                    }, {
                        "name": "首尔百度芯片",
                        "id": 216844
                    }, {
                        "name": "杭州星巴克航空",
                        "id": 216845
                    }, {
                        "name": "广州平安电商有限公司",
                        "id": 216846
                    }, {
                        "name": "香港华为诊所",
                        "id": 216847
                    }, {
                        "name": "天津百度地摊",
                        "id": 216848
                    }, {
                        "name": "厦门滴滴",
                        "id": 216849
                    }, {
                        "name": "香港腾讯农业有限公司",
                        "id": 216850
                    }, {
                        "name": "东莞滴滴通信",
                        "id": 216851
                    }, {
                        "name": "厦门小米汽车",
                        "id": 216852
                    }, {
                        "name": "首尔蚂蚁科技控股集团",
                        "id": 216853
                    }, {
                        "name": "天津蚂蚁养殖",
                        "id": 216854
                    }, {
                        "name": "杭州微软智能控股集团",
                        "id": 216855
                    }, {
                        "name": "纽约肯德基芯片",
                        "id": 216856
                    }, {
                        "name": "上海苹果通信",
                        "id": 216857
                    }, {
                        "name": "广州蚂蚁地产",
                        "id": 216858
                    }, {
                        "name": "杭州微软农业",
                        "id": 216859
                    }, {
                        "name": "南京星巴克牧业",
                        "id": 216860
                    }, {
                        "name": "深圳蚂蚁芯片",
                        "id": 216861
                    }, {
                        "name": "香港必胜客石油有限公司",
                        "id": 216862
                    }, {
                        "name": "杭州平安软件",
                        "id": 216863
                    }, {
                        "name": "东京奈雪基金控股集团",
                        "id": 216864
                    }]
                }, {
                    "name": "东京字节",
                    "id": 216865
                }, {
                    "name": "上海百度证券控股集团",
                    "id": 216866
                }, {
                    "name": "台北滴滴计算机",
                    "id": 216867,
                    "children": [{
                        "name": "南京百度金融",
                        "id": 216868
                    }, {
                        "name": "南京百度农业有限公司",
                        "id": 216869
                    }, {
                        "name": "北京苹果银行",
                        "id": 216870
                    }, {
                        "name": "上海肯德基金融",
                        "id": 216871
                    }, {
                        "name": "厦门喜茶通信有限公司",
                        "id": 216872
                    }, {
                        "name": "上海谷歌牧业有限公司",
                        "id": 216873
                    }, {
                        "name": "厦门谷歌养殖有限公司",
                        "id": 216874
                    }, {
                        "name": "台北华为牧业有限公司",
                        "id": 216875
                    }, {
                        "name": "纽约美团芯片",
                        "id": 216876
                    }, {
                        "name": "上海百度信息服务",
                        "id": 216877
                    }, {
                        "name": "上海腾讯地产",
                        "id": 216878
                    }, {
                        "name": "广州腾讯餐饮控股集团",
                        "id": 216879
                    }, {
                        "name": "上海星巴克地产",
                        "id": 216880
                    }, {
                        "name": "天津平安牧业控股集团",
                        "id": 216881
                    }, {
                        "name": "深圳蚂蚁诊所",
                        "id": 216882
                    }, {
                        "name": "台北蚂蚁智能",
                        "id": 216883
                    }, {
                        "name": "广州星巴克科技控股集团",
                        "id": 216884
                    }, {
                        "name": "深圳瑞幸渔业控股集团",
                        "id": 216885
                    }, {
                        "name": "天津肯德基石油",
                        "id": 216886
                    }, {
                        "name": "南京瑞幸银行",
                        "id": 216887
                    }, {
                        "name": "香港美团地摊有限公司",
                        "id": 216888
                    }, {
                        "name": "杭州小米控股集团",
                        "id": 216889
                    }, {
                        "name": "台北瑞幸石油控股集团",
                        "id": 216890
                    }]
                }, {
                    "name": "广州星巴克电商",
                    "id": 216891
                }, {
                    "name": "台北肯德基农业",
                    "id": 216892
                }, {
                    "name": "纽约美团芯片",
                    "id": 216893
                }, {
                    "name": "上海快手互金",
                    "id": 216894
                }, {
                    "name": "首尔蚂蚁金融",
                    "id": 216895
                }, {
                    "name": "厦门亚马逊新能源",
                    "id": 216896
                }]
            }, {
                "name": "首尔欧珀航空",
                "id": 216897
            }, {
                "name": "北京平安地摊控股集团",
                "id": 216898
            }, {
                "name": "厦门星巴克金融",
                "id": 216899
            }, {
                "name": "东京阿里芯片",
                "id": 216900
            }, {
                "name": "广州谷歌计算机控股集团",
                "id": 216901
            }, {
                "name": "杭州华为证券控股集团",
                "id": 216902
            }, {
                "name": "纽约蚂蚁医院",
                "id": 216903
            }, {
                "name": "厦门肯德基智能",
                "id": 216904,
                "children": [{
                    "name": "深圳瑞幸电商",
                    "id": 216905,
                    "children": [{
                        "name": "台北亚马逊电商",
                        "id": 216906
                    }, {
                        "name": "上海谷歌金融",
                        "id": 216907
                    }, {
                        "name": "香港滴滴",
                        "id": 216908
                    }, {
                        "name": "厦门美团汽车",
                        "id": 216909
                    }, {
                        "name": "纽约华为电商",
                        "id": 216910
                    }, {
                        "name": "纽约微软证券有限公司",
                        "id": 216911
                    }, {
                        "name": "深圳喜茶新能源",
                        "id": 216912
                    }, {
                        "name": "上海平安汽车",
                        "id": 216913
                    }, {
                        "name": "香港奈雪计算机",
                        "id": 216914
                    }, {
                        "name": "厦门特斯拉渔业",
                        "id": 216915
                    }, {
                        "name": "天津瑞幸新能源有限公司",
                        "id": 216916
                    }, {
                        "name": "东京百度计算机有限公司",
                        "id": 216917
                    }, {
                        "name": "北京苹果芯片",
                        "id": 216918
                    }, {
                        "name": "北京美团软件控股集团",
                        "id": 216919
                    }, {
                        "name": "深圳星巴克地产",
                        "id": 216920
                    }, {
                        "name": "纽约瑞幸软件",
                        "id": 216921
                    }, {
                        "name": "东京瑞幸",
                        "id": 216922
                    }, {
                        "name": "广州华为餐饮控股集团",
                        "id": 216923
                    }, {
                        "name": "香港快手证券",
                        "id": 216924
                    }, {
                        "name": "杭州瑞幸医药",
                        "id": 216925
                    }, {
                        "name": "北京星巴克基金",
                        "id": 216926
                    }, {
                        "name": "天津百度医院",
                        "id": 216927
                    }, {
                        "name": "杭州华为牧业",
                        "id": 216928
                    }, {
                        "name": "首尔小米芯片",
                        "id": 216929
                    }, {
                        "name": "杭州亚马逊基金",
                        "id": 216930
                    }, {
                        "name": "东莞谷歌有限公司",
                        "id": 216931
                    }, {
                        "name": "台北亚马逊银行有限公司",
                        "id": 216932
                    }, {
                        "name": "台北瑞幸餐饮有限公司",
                        "id": 216933
                    }, {
                        "name": "南京小米医院控股集团",
                        "id": 216934
                    }, {
                        "name": "香港平安新能源有限公司",
                        "id": 216935
                    }]
                }]
            }, {
                "name": "厦门谷歌",
                "id": 216936
            }, {
                "name": "纽约欧珀农业有限公司",
                "id": 216937
            }, {
                "name": "天津星巴克航空",
                "id": 216938
            }, {
                "name": "南京京东科技",
                "id": 216939
            }, {
                "name": "上海蚂蚁汽车控股集团",
                "id": 216940
            }]
        }, {
            "name": "深圳瑞幸通讯",
            "id": 216941,
            "children": [{
                "name": "台北亚马逊计算机",
                "id": 216942
            }, {
                "name": "东京华为医药有限公司",
                "id": 216943
            }, {
                "name": "深圳京东医药控股集团",
                "id": 216944
            }, {
                "name": "深圳平安餐饮有限公司",
                "id": 216945
            }, {
                "name": "厦门苹果",
                "id": 216946
            }, {
                "name": "香港星巴克餐饮控股集团",
                "id": 216947
            }, {
                "name": "上海苹果医院",
                "id": 216948,
                "children": [{
                    "name": "东莞必胜客餐饮",
                    "id": 216949,
                    "children": [{
                        "name": "厦门美团石油",
                        "id": 216950
                    }, {
                        "name": "北京瑞幸信息服务",
                        "id": 216951
                    }, {
                        "name": "杭州谷歌计算机",
                        "id": 216952
                    }, {
                        "name": "厦门蚂蚁控股集团",
                        "id": 216953
                    }, {
                        "name": "香港奈雪石油",
                        "id": 216954
                    }, {
                        "name": "杭州小米汽车",
                        "id": 216955
                    }, {
                        "name": "纽约瑞幸金融控股集团",
                        "id": 216956
                    }, {
                        "name": "厦门喜茶智能控股集团",
                        "id": 216957
                    }, {
                        "name": "台北阿里旅游控股集团",
                        "id": 216958
                    }, {
                        "name": "首尔百度",
                        "id": 216959
                    }, {
                        "name": "深圳星巴克农业",
                        "id": 216960
                    }, {
                        "name": "杭州欧珀计算机有限公司",
                        "id": 216961
                    }, {
                        "name": "杭州肯德基旅游",
                        "id": 216962
                    }, {
                        "name": "首尔瑞幸计算机",
                        "id": 216963
                    }, {
                        "name": "广州滴滴互金有限公司",
                        "id": 216964
                    }, {
                        "name": "北京蚂蚁新能源控股集团",
                        "id": 216965
                    }, {
                        "name": "东莞滴滴地产",
                        "id": 216966
                    }, {
                        "name": "广州蚂蚁银行控股集团",
                        "id": 216967
                    }, {
                        "name": "台北亚马逊牧业",
                        "id": 216968
                    }, {
                        "name": "香港滴滴信息服务",
                        "id": 216969
                    }, {
                        "name": "广州滴滴汽车",
                        "id": 216970
                    }, {
                        "name": "东京特斯拉养殖",
                        "id": 216971
                    }, {
                        "name": "东莞华为信息服务有限公司",
                        "id": 216972
                    }, {
                        "name": "香港谷歌养殖",
                        "id": 216973
                    }, {
                        "name": "天津喜茶制造有限公司",
                        "id": 216974
                    }, {
                        "name": "广州星巴克电商控股集团",
                        "id": 216975
                    }, {
                        "name": "天津美团餐饮",
                        "id": 216976
                    }, {
                        "name": "天津百度证券控股集团",
                        "id": 216977
                    }, {
                        "name": "厦门欧珀地摊",
                        "id": 216978
                    }, {
                        "name": "北京欧珀",
                        "id": 216979
                    }, {
                        "name": "南京美团软件有限公司",
                        "id": 216980
                    }, {
                        "name": "首尔快手农业",
                        "id": 216981
                    }, {
                        "name": "天津微软地摊",
                        "id": 216982
                    }, {
                        "name": "纽约小米芯片有限公司",
                        "id": 216983
                    }, {
                        "name": "北京美团互金",
                        "id": 216984
                    }, {
                        "name": "厦门百度石油",
                        "id": 216985
                    }]
                }, {
                    "name": "杭州阿里金融控股集团",
                    "id": 216986
                }, {
                    "name": "杭州必胜客餐饮",
                    "id": 216987
                }, {
                    "name": "东莞谷歌计算机控股集团",
                    "id": 216988
                }, {
                    "name": "首尔字节养殖",
                    "id": 216989
                }, {
                    "name": "纽约必胜客航空",
                    "id": 216990
                }, {
                    "name": "北京滴滴金融",
                    "id": 216991,
                    "children": [{
                        "name": "广州谷歌餐饮",
                        "id": 216992
                    }, {
                        "name": "杭州星巴克牧业",
                        "id": 216993
                    }, {
                        "name": "天津特斯拉证券",
                        "id": 216994
                    }, {
                        "name": "广州喜茶渔业",
                        "id": 216995
                    }, {
                        "name": "香港滴滴软件控股集团",
                        "id": 216996
                    }, {
                        "name": "厦门京东通讯控股集团",
                        "id": 216997
                    }]
                }, {
                    "name": "厦门百度通讯",
                    "id": 216998
                }, {
                    "name": "杭州蚂蚁科技控股集团",
                    "id": 216999
                }, {
                    "name": "香港谷歌芯片",
                    "id": 217000
                }, {
                    "name": "香港奈雪制造有限公司",
                    "id": 217001
                }, {
                    "name": "杭州微软",
                    "id": 217002
                }, {
                    "name": "东京腾讯通讯控股集团",
                    "id": 217003
                }, {
                    "name": "厦门肯德基有限公司",
                    "id": 217004
                }, {
                    "name": "北京微软制造",
                    "id": 217005
                }, {
                    "name": "广州星巴克银行",
                    "id": 217006
                }, {
                    "name": "上海平安有限公司",
                    "id": 217007
                }, {
                    "name": "纽约百度地摊",
                    "id": 217008
                }, {
                    "name": "厦门肯德基石油控股集团",
                    "id": 217009
                }, {
                    "name": "首尔特斯拉证券",
                    "id": 217010,
                    "children": [{
                        "name": "南京平安诊所",
                        "id": 217011
                    }, {
                        "name": "首尔星巴克餐饮有限公司",
                        "id": 217012
                    }, {
                        "name": "纽约微软",
                        "id": 217013
                    }, {
                        "name": "台北喜茶智能有限公司",
                        "id": 217014
                    }, {
                        "name": "上海阿里",
                        "id": 217015
                    }, {
                        "name": "天津谷歌软件",
                        "id": 217016
                    }, {
                        "name": "杭州星巴克",
                        "id": 217017
                    }, {
                        "name": "北京字节电商控股集团",
                        "id": 217018
                    }]
                }, {
                    "name": "厦门阿里渔业",
                    "id": 217019
                }, {
                    "name": "东京瑞幸医院",
                    "id": 217020
                }, {
                    "name": "台北必胜客汽车有限公司",
                    "id": 217021
                }, {
                    "name": "纽约字节芯片控股集团",
                    "id": 217022
                }, {
                    "name": "纽约谷歌信息服务控股集团",
                    "id": 217023
                }, {
                    "name": "北京蚂蚁农业控股集团",
                    "id": 217024,
                    "children": [{
                        "name": "北京蚂蚁软件控股集团",
                        "id": 217025
                    }, {
                        "name": "东莞华为证券",
                        "id": 217026
                    }, {
                        "name": "南京腾讯信息服务有限公司",
                        "id": 217027
                    }, {
                        "name": "南京华为基金控股集团",
                        "id": 217028
                    }, {
                        "name": "东莞百度汽车",
                        "id": 217029
                    }, {
                        "name": "杭州瑞幸通信",
                        "id": 217030
                    }, {
                        "name": "北京美团制造",
                        "id": 217031
                    }, {
                        "name": "东京字节",
                        "id": 217032
                    }, {
                        "name": "北京百度航空",
                        "id": 217033
                    }, {
                        "name": "深圳快手",
                        "id": 217034
                    }, {
                        "name": "香港字节新能源",
                        "id": 217035
                    }, {
                        "name": "东莞平安地摊控股集团",
                        "id": 217036
                    }, {
                        "name": "北京特斯拉",
                        "id": 217037
                    }, {
                        "name": "广州小米通讯",
                        "id": 217038
                    }, {
                        "name": "北京瑞幸医药控股集团",
                        "id": 217039
                    }, {
                        "name": "东莞瑞幸制造",
                        "id": 217040
                    }, {
                        "name": "杭州字节通信有限公司",
                        "id": 217041
                    }, {
                        "name": "首尔谷歌软件",
                        "id": 217042
                    }]
                }, {
                    "name": "首尔华为航空",
                    "id": 217043
                }, {
                    "name": "纽约奈雪航空",
                    "id": 217044
                }]
            }, {
                "name": "深圳美团地摊有限公司",
                "id": 217045
            }, {
                "name": "香港字节养殖",
                "id": 217046
            }, {
                "name": "上海美团科技",
                "id": 217047
            }, {
                "name": "深圳肯德基航空",
                "id": 217048
            }, {
                "name": "东莞微软养殖控股集团",
                "id": 217049
            }, {
                "name": "上海微软石油",
                "id": 217050,
                "children": [{
                    "name": "东京百度通信控股集团",
                    "id": 217051
                }, {
                    "name": "台北华为通讯",
                    "id": 217052
                }, {
                    "name": "天津欧珀旅游",
                    "id": 217053
                }, {
                    "name": "东莞阿里软件",
                    "id": 217054
                }, {
                    "name": "纽约苹果医院",
                    "id": 217055
                }, {
                    "name": "天津喜茶养殖控股集团",
                    "id": 217056
                }, {
                    "name": "上海喜茶芯片",
                    "id": 217057
                }, {
                    "name": "南京亚马逊通信",
                    "id": 217058
                }, {
                    "name": "北京蚂蚁旅游",
                    "id": 217059
                }, {
                    "name": "杭州微软证券控股集团",
                    "id": 217060
                }, {
                    "name": "台北美团通信",
                    "id": 217061,
                    "children": [{
                        "name": "杭州京东信息服务",
                        "id": 217062
                    }, {
                        "name": "北京阿里地产有限公司",
                        "id": 217063
                    }, {
                        "name": "广州华为牧业",
                        "id": 217064
                    }, {
                        "name": "东京京东航空有限公司",
                        "id": 217065
                    }, {
                        "name": "天津美团互金",
                        "id": 217066
                    }, {
                        "name": "东京快手航空有限公司",
                        "id": 217067
                    }, {
                        "name": "台北小米航空控股集团",
                        "id": 217068
                    }, {
                        "name": "北京苹果智能有限公司",
                        "id": 217069
                    }, {
                        "name": "深圳微软银行",
                        "id": 217070
                    }, {
                        "name": "南京苹果",
                        "id": 217071
                    }, {
                        "name": "纽约星巴克养殖",
                        "id": 217072
                    }, {
                        "name": "东莞快手诊所",
                        "id": 217073
                    }, {
                        "name": "台北百度科技",
                        "id": 217074
                    }, {
                        "name": "上海阿里芯片",
                        "id": 217075
                    }, {
                        "name": "杭州京东渔业",
                        "id": 217076
                    }, {
                        "name": "天津滴滴计算机控股集团",
                        "id": 217077
                    }, {
                        "name": "北京谷歌通信",
                        "id": 217078
                    }, {
                        "name": "北京快手通信",
                        "id": 217079
                    }]
                }, {
                    "name": "深圳小米旅游",
                    "id": 217080
                }, {
                    "name": "香港快手计算机",
                    "id": 217081,
                    "children": [{
                        "name": "杭州星巴克",
                        "id": 217082
                    }, {
                        "name": "杭州字节计算机",
                        "id": 217083
                    }, {
                        "name": "天津星巴克信息服务",
                        "id": 217084
                    }, {
                        "name": "香港京东医药",
                        "id": 217085
                    }, {
                        "name": "东莞字节科技有限公司",
                        "id": 217086
                    }, {
                        "name": "厦门苹果航空",
                        "id": 217087
                    }, {
                        "name": "纽约平安餐饮",
                        "id": 217088
                    }]
                }, {
                    "name": "首尔字节软件",
                    "id": 217089
                }, {
                    "name": "纽约肯德基计算机有限公司",
                    "id": 217090,
                    "children": [{
                        "name": "首尔平安诊所",
                        "id": 217091
                    }, {
                        "name": "首尔快手通讯",
                        "id": 217092
                    }, {
                        "name": "上海肯德基通讯有限公司",
                        "id": 217093
                    }]
                }, {
                    "name": "南京京东医药",
                    "id": 217094
                }]
            }, {
                "name": "台北谷歌计算机",
                "id": 217095
            }, {
                "name": "天津百度银行控股集团",
                "id": 217096,
                "children": [{
                    "name": "天津京东银行",
                    "id": 217097
                }, {
                    "name": "东京小米农业",
                    "id": 217098
                }, {
                    "name": "台北京东计算机",
                    "id": 217099
                }, {
                    "name": "东莞华为医药",
                    "id": 217100
                }, {
                    "name": "深圳谷歌计算机",
                    "id": 217101
                }, {
                    "name": "台北平安农业控股集团",
                    "id": 217102,
                    "children": [{
                        "name": "首尔腾讯芯片",
                        "id": 217103
                    }, {
                        "name": "香港平安",
                        "id": 217104
                    }, {
                        "name": "首尔瑞幸",
                        "id": 217105
                    }, {
                        "name": "广州肯德基诊所有限公司",
                        "id": 217106
                    }, {
                        "name": "东莞小米通讯",
                        "id": 217107
                    }, {
                        "name": "深圳字节通信",
                        "id": 217108
                    }]
                }, {
                    "name": "东京特斯拉医药",
                    "id": 217109
                }, {
                    "name": "首尔特斯拉银行有限公司",
                    "id": 217110
                }, {
                    "name": "台北美团旅游有限公司",
                    "id": 217111
                }, {
                    "name": "南京特斯拉汽车",
                    "id": 217112
                }, {
                    "name": "台北苹果控股集团",
                    "id": 217113
                }]
            }, {
                "name": "台北微软计算机",
                "id": 217114
            }, {
                "name": "香港美团智能",
                "id": 217115
            }, {
                "name": "首尔瑞幸制造",
                "id": 217116
            }, {
                "name": "北京欧珀基金",
                "id": 217117
            }, {
                "name": "杭州星巴克芯片",
                "id": 217118
            }, {
                "name": "天津瑞幸软件",
                "id": 217119,
                "children": [{
                    "name": "上海必胜客渔业",
                    "id": 217120
                }, {
                    "name": "广州阿里智能",
                    "id": 217121
                }, {
                    "name": "纽约字节医药",
                    "id": 217122
                }, {
                    "name": "纽约亚马逊医药",
                    "id": 217123
                }, {
                    "name": "香港微软餐饮控股集团",
                    "id": 217124,
                    "children": [{
                        "name": "东莞特斯拉地产",
                        "id": 217125
                    }, {
                        "name": "杭州快手金融控股集团",
                        "id": 217126
                    }, {
                        "name": "广州阿里餐饮",
                        "id": 217127
                    }]
                }, {
                    "name": "东莞星巴克智能控股集团",
                    "id": 217128
                }, {
                    "name": "东莞字节",
                    "id": 217129
                }, {
                    "name": "杭州瑞幸养殖",
                    "id": 217130
                }, {
                    "name": "深圳喜茶餐饮控股集团",
                    "id": 217131
                }, {
                    "name": "香港华为通讯",
                    "id": 217132
                }, {
                    "name": "东莞瑞幸制造",
                    "id": 217133,
                    "children": [{
                        "name": "厦门快手通信有限公司",
                        "id": 217134
                    }]
                }, {
                    "name": "东莞美团养殖",
                    "id": 217135,
                    "children": [{
                        "name": "上海瑞幸金融",
                        "id": 217136
                    }, {
                        "name": "南京瑞幸诊所有限公司",
                        "id": 217137
                    }, {
                        "name": "纽约苹果通信",
                        "id": 217138
                    }, {
                        "name": "台北阿里计算机",
                        "id": 217139
                    }, {
                        "name": "深圳欧珀航空控股集团",
                        "id": 217140
                    }, {
                        "name": "北京滴滴计算机",
                        "id": 217141
                    }, {
                        "name": "首尔微软信息服务",
                        "id": 217142
                    }, {
                        "name": "纽约滴滴计算机有限公司",
                        "id": 217143
                    }, {
                        "name": "深圳瑞幸科技",
                        "id": 217144
                    }, {
                        "name": "广州瑞幸芯片",
                        "id": 217145
                    }, {
                        "name": "南京苹果电商有限公司",
                        "id": 217146
                    }, {
                        "name": "东京欧珀",
                        "id": 217147
                    }, {
                        "name": "纽约阿里",
                        "id": 217148
                    }, {
                        "name": "纽约肯德基科技",
                        "id": 217149
                    }, {
                        "name": "纽约京东软件",
                        "id": 217150
                    }, {
                        "name": "东莞蚂蚁科技",
                        "id": 217151
                    }, {
                        "name": "纽约特斯拉软件",
                        "id": 217152
                    }, {
                        "name": "广州微软控股集团",
                        "id": 217153
                    }, {
                        "name": "南京阿里电商",
                        "id": 217154
                    }]
                }, {
                    "name": "台北美团餐饮",
                    "id": 217155
                }, {
                    "name": "纽约亚马逊电商控股集团",
                    "id": 217156,
                    "children": [{
                        "name": "厦门腾讯石油控股集团",
                        "id": 217157
                    }, {
                        "name": "深圳字节通讯有限公司",
                        "id": 217158
                    }, {
                        "name": "首尔喜茶智能",
                        "id": 217159
                    }, {
                        "name": "杭州亚马逊农业控股集团",
                        "id": 217160
                    }, {
                        "name": "台北平安医药有限公司",
                        "id": 217161
                    }, {
                        "name": "深圳欧珀通讯有限公司",
                        "id": 217162
                    }, {
                        "name": "北京滴滴",
                        "id": 217163
                    }, {
                        "name": "首尔平安通讯",
                        "id": 217164
                    }, {
                        "name": "香港苹果医药",
                        "id": 217165
                    }, {
                        "name": "南京谷歌通信",
                        "id": 217166
                    }, {
                        "name": "杭州奈雪科技",
                        "id": 217167
                    }, {
                        "name": "东京特斯拉地产",
                        "id": 217168
                    }, {
                        "name": "杭州欧珀",
                        "id": 217169
                    }, {
                        "name": "纽约滴滴有限公司",
                        "id": 217170
                    }, {
                        "name": "南京特斯拉电商",
                        "id": 217171
                    }]
                }, {
                    "name": "杭州快手养殖控股集团",
                    "id": 217172,
                    "children": [{
                        "name": "厦门华为航空有限公司",
                        "id": 217173
                    }, {
                        "name": "深圳美团制造",
                        "id": 217174
                    }, {
                        "name": "广州小米地产",
                        "id": 217175
                    }, {
                        "name": "台北苹果电商",
                        "id": 217176
                    }, {
                        "name": "东京星巴克电商",
                        "id": 217177
                    }, {
                        "name": "杭州星巴克石油有限公司",
                        "id": 217178
                    }, {
                        "name": "首尔星巴克餐饮",
                        "id": 217179
                    }, {
                        "name": "东京平安地产",
                        "id": 217180
                    }, {
                        "name": "杭州字节",
                        "id": 217181
                    }, {
                        "name": "南京阿里牧业控股集团",
                        "id": 217182
                    }, {
                        "name": "首尔字节诊所",
                        "id": 217183
                    }, {
                        "name": "首尔腾讯汽车控股集团",
                        "id": 217184
                    }, {
                        "name": "东京瑞幸地产",
                        "id": 217185
                    }, {
                        "name": "首尔必胜客制造",
                        "id": 217186
                    }, {
                        "name": "台北百度地产",
                        "id": 217187
                    }, {
                        "name": "东京特斯拉农业",
                        "id": 217188
                    }, {
                        "name": "纽约滴滴通讯",
                        "id": 217189
                    }, {
                        "name": "纽约百度诊所",
                        "id": 217190
                    }, {
                        "name": "台北腾讯智能",
                        "id": 217191
                    }, {
                        "name": "纽约喜茶汽车",
                        "id": 217192
                    }, {
                        "name": "东莞美团有限公司",
                        "id": 217193
                    }, {
                        "name": "纽约瑞幸医药",
                        "id": 217194
                    }, {
                        "name": "杭州快手医药",
                        "id": 217195
                    }, {
                        "name": "上海快手智能",
                        "id": 217196
                    }, {
                        "name": "香港谷歌银行",
                        "id": 217197
                    }, {
                        "name": "杭州京东养殖",
                        "id": 217198
                    }, {
                        "name": "上海蚂蚁地产",
                        "id": 217199
                    }, {
                        "name": "纽约字节新能源",
                        "id": 217200
                    }]
                }, {
                    "name": "厦门奈雪医药",
                    "id": 217201
                }, {
                    "name": "东莞谷歌银行",
                    "id": 217202
                }, {
                    "name": "深圳亚马逊信息服务",
                    "id": 217203
                }, {
                    "name": "首尔小米农业控股集团",
                    "id": 217204
                }]
            }]
        }, {
            "name": "杭州谷歌牧业有限公司",
            "id": 217205
        }, {
            "name": "天津美团牧业",
            "id": 217206,
            "children": [{
                "name": "上海腾讯制造控股集团",
                "id": 217207
            }, {
                "name": "杭州百度养殖",
                "id": 217208
            }, {
                "name": "东莞星巴克餐饮",
                "id": 217209,
                "children": [{
                    "name": "台北小米诊所",
                    "id": 217210
                }, {
                    "name": "东京必胜客诊所",
                    "id": 217211
                }, {
                    "name": "香港奈雪金融",
                    "id": 217212
                }, {
                    "name": "首尔必胜客农业有限公司",
                    "id": 217213
                }, {
                    "name": "东莞滴滴通讯",
                    "id": 217214,
                    "children": [{
                        "name": "上海谷歌渔业",
                        "id": 217215
                    }, {
                        "name": "东莞美团通信",
                        "id": 217216
                    }, {
                        "name": "纽约华为科技",
                        "id": 217217
                    }, {
                        "name": "广州华为计算机",
                        "id": 217218
                    }, {
                        "name": "纽约苹果航空有限公司",
                        "id": 217219
                    }, {
                        "name": "北京阿里航空",
                        "id": 217220
                    }, {
                        "name": "深圳特斯拉基金控股集团",
                        "id": 217221
                    }, {
                        "name": "上海京东石油控股集团",
                        "id": 217222
                    }, {
                        "name": "北京快手新能源",
                        "id": 217223
                    }, {
                        "name": "厦门蚂蚁餐饮有限公司",
                        "id": 217224
                    }, {
                        "name": "天津星巴克医院",
                        "id": 217225
                    }]
                }, {
                    "name": "东京瑞幸计算机",
                    "id": 217226
                }, {
                    "name": "东莞微软",
                    "id": 217227
                }, {
                    "name": "纽约滴滴有限公司",
                    "id": 217228
                }, {
                    "name": "杭州美团通讯",
                    "id": 217229
                }, {
                    "name": "厦门百度地产有限公司",
                    "id": 217230
                }, {
                    "name": "上海亚马逊医院",
                    "id": 217231,
                    "children": [{
                        "name": "南京微软牧业",
                        "id": 217232
                    }, {
                        "name": "深圳快手新能源",
                        "id": 217233
                    }, {
                        "name": "杭州京东",
                        "id": 217234
                    }]
                }, {
                    "name": "天津瑞幸制造",
                    "id": 217235
                }, {
                    "name": "台北苹果",
                    "id": 217236
                }, {
                    "name": "台北百度证券",
                    "id": 217237
                }, {
                    "name": "东莞京东石油控股集团",
                    "id": 217238
                }, {
                    "name": "深圳必胜客科技",
                    "id": 217239
                }]
            }, {
                "name": "上海平安航空",
                "id": 217240
            }, {
                "name": "香港苹果计算机",
                "id": 217241
            }, {
                "name": "天津喜茶牧业",
                "id": 217242
            }, {
                "name": "香港京东通讯",
                "id": 217243
            }, {
                "name": "杭州腾讯地摊",
                "id": 217244
            }, {
                "name": "南京京东智能",
                "id": 217245
            }, {
                "name": "上海苹果科技",
                "id": 217246,
                "children": [{
                    "name": "杭州肯德基科技",
                    "id": 217247
                }, {
                    "name": "上海腾讯证券控股集团",
                    "id": 217248
                }, {
                    "name": "东莞阿里医药",
                    "id": 217249
                }, {
                    "name": "广州小米互金",
                    "id": 217250
                }, {
                    "name": "台北京东软件控股集团",
                    "id": 217251,
                    "children": [{
                        "name": "杭州字节制造",
                        "id": 217252
                    }, {
                        "name": "深圳肯德基诊所",
                        "id": 217253
                    }, {
                        "name": "北京微软软件",
                        "id": 217254
                    }, {
                        "name": "纽约欧珀互金控股集团",
                        "id": 217255
                    }, {
                        "name": "东京亚马逊医院控股集团",
                        "id": 217256
                    }, {
                        "name": "广州瑞幸通信",
                        "id": 217257
                    }, {
                        "name": "天津快手地产",
                        "id": 217258
                    }, {
                        "name": "东京星巴克养殖",
                        "id": 217259
                    }, {
                        "name": "首尔字节芯片",
                        "id": 217260
                    }, {
                        "name": "首尔字节新能源有限公司",
                        "id": 217261
                    }, {
                        "name": "深圳蚂蚁通讯",
                        "id": 217262
                    }, {
                        "name": "天津字节诊所",
                        "id": 217263
                    }, {
                        "name": "台北必胜客养殖有限公司",
                        "id": 217264
                    }, {
                        "name": "天津字节科技控股集团",
                        "id": 217265
                    }, {
                        "name": "上海阿里信息服务",
                        "id": 217266
                    }, {
                        "name": "台北谷歌餐饮",
                        "id": 217267
                    }, {
                        "name": "台北蚂蚁智能",
                        "id": 217268
                    }, {
                        "name": "广州微软牧业",
                        "id": 217269
                    }, {
                        "name": "南京平安旅游",
                        "id": 217270
                    }, {
                        "name": "上海京东科技有限公司",
                        "id": 217271
                    }, {
                        "name": "杭州小米信息服务",
                        "id": 217272
                    }, {
                        "name": "东京平安通讯控股集团",
                        "id": 217273
                    }, {
                        "name": "杭州喜茶农业控股集团",
                        "id": 217274
                    }, {
                        "name": "杭州字节科技",
                        "id": 217275
                    }, {
                        "name": "上海奈雪证券控股集团",
                        "id": 217276
                    }, {
                        "name": "东莞蚂蚁石油",
                        "id": 217277
                    }]
                }, {
                    "name": "香港快手制造",
                    "id": 217278
                }, {
                    "name": "天津必胜客科技",
                    "id": 217279
                }, {
                    "name": "厦门百度银行",
                    "id": 217280,
                    "children": [{
                        "name": "上海亚马逊地摊",
                        "id": 217281
                    }, {
                        "name": "北京特斯拉牧业有限公司",
                        "id": 217282
                    }, {
                        "name": "杭州欧珀渔业",
                        "id": 217283
                    }, {
                        "name": "深圳亚马逊信息服务控股集团",
                        "id": 217284
                    }, {
                        "name": "南京瑞幸电商",
                        "id": 217285
                    }, {
                        "name": "广州谷歌地摊",
                        "id": 217286
                    }, {
                        "name": "台北瑞幸新能源控股集团",
                        "id": 217287
                    }, {
                        "name": "南京谷歌信息服务",
                        "id": 217288
                    }, {
                        "name": "东莞特斯拉金融",
                        "id": 217289
                    }, {
                        "name": "天津百度金融",
                        "id": 217290
                    }, {
                        "name": "纽约百度证券",
                        "id": 217291
                    }, {
                        "name": "东莞小米",
                        "id": 217292
                    }, {
                        "name": "东莞京东芯片控股集团",
                        "id": 217293
                    }, {
                        "name": "纽约滴滴计算机有限公司",
                        "id": 217294
                    }, {
                        "name": "首尔小米",
                        "id": 217295
                    }, {
                        "name": "广州特斯拉有限公司",
                        "id": 217296
                    }, {
                        "name": "深圳快手电商",
                        "id": 217297
                    }, {
                        "name": "北京亚马逊航空",
                        "id": 217298
                    }, {
                        "name": "上海苹果石油",
                        "id": 217299
                    }, {
                        "name": "广州美团医药",
                        "id": 217300
                    }, {
                        "name": "东莞特斯拉计算机",
                        "id": 217301
                    }]
                }, {
                    "name": "广州肯德基智能",
                    "id": 217302
                }]
            }, {
                "name": "天津华为",
                "id": 217303,
                "children": [{
                    "name": "上海平安汽车有限公司",
                    "id": 217304,
                    "children": [{
                        "name": "北京苹果控股集团",
                        "id": 217305
                    }, {
                        "name": "厦门微软汽车",
                        "id": 217306
                    }, {
                        "name": "杭州必胜客地摊",
                        "id": 217307
                    }, {
                        "name": "南京字节银行有限公司",
                        "id": 217308
                    }, {
                        "name": "天津腾讯软件",
                        "id": 217309
                    }, {
                        "name": "南京必胜客制造",
                        "id": 217310
                    }, {
                        "name": "东莞苹果智能",
                        "id": 217311
                    }, {
                        "name": "东京奈雪石油",
                        "id": 217312
                    }, {
                        "name": "纽约特斯拉证券",
                        "id": 217313
                    }, {
                        "name": "厦门华为通信",
                        "id": 217314
                    }, {
                        "name": "东莞滴滴渔业有限公司",
                        "id": 217315
                    }, {
                        "name": "广州百度农业控股集团",
                        "id": 217316
                    }, {
                        "name": "深圳奈雪诊所控股集团",
                        "id": 217317
                    }, {
                        "name": "天津苹果汽车",
                        "id": 217318
                    }, {
                        "name": "纽约奈雪诊所",
                        "id": 217319
                    }]
                }, {
                    "name": "杭州微软汽车",
                    "id": 217320
                }, {
                    "name": "深圳平安金融",
                    "id": 217321
                }, {
                    "name": "天津美团基金控股集团",
                    "id": 217322,
                    "children": [{
                        "name": "厦门平安养殖有限公司",
                        "id": 217323
                    }, {
                        "name": "台北腾讯地产",
                        "id": 217324
                    }, {
                        "name": "香港阿里基金有限公司",
                        "id": 217325
                    }, {
                        "name": "台北星巴克科技",
                        "id": 217326
                    }, {
                        "name": "杭州喜茶制造",
                        "id": 217327
                    }, {
                        "name": "厦门欧珀控股集团",
                        "id": 217328
                    }, {
                        "name": "东莞华为",
                        "id": 217329
                    }]
                }, {
                    "name": "北京平安养殖",
                    "id": 217330
                }, {
                    "name": "东京美团芯片",
                    "id": 217331
                }, {
                    "name": "东莞亚马逊软件有限公司",
                    "id": 217332
                }, {
                    "name": "台北谷歌渔业",
                    "id": 217333
                }, {
                    "name": "北京必胜客餐饮",
                    "id": 217334
                }, {
                    "name": "东京奈雪餐饮控股集团",
                    "id": 217335
                }, {
                    "name": "广州百度信息服务",
                    "id": 217336
                }, {
                    "name": "首尔欧珀新能源",
                    "id": 217337
                }, {
                    "name": "杭州美团基金有限公司",
                    "id": 217338,
                    "children": [{
                        "name": "厦门滴滴基金有限公司",
                        "id": 217339
                    }, {
                        "name": "首尔肯德基汽车",
                        "id": 217340
                    }, {
                        "name": "上海微软牧业有限公司",
                        "id": 217341
                    }, {
                        "name": "南京星巴克渔业",
                        "id": 217342
                    }, {
                        "name": "南京星巴克诊所有限公司",
                        "id": 217343
                    }, {
                        "name": "东莞百度渔业",
                        "id": 217344
                    }, {
                        "name": "北京蚂蚁渔业",
                        "id": 217345
                    }, {
                        "name": "东京必胜客航空",
                        "id": 217346
                    }, {
                        "name": "南京美团信息服务",
                        "id": 217347
                    }, {
                        "name": "杭州瑞幸银行",
                        "id": 217348
                    }, {
                        "name": "深圳小米通信有限公司",
                        "id": 217349
                    }, {
                        "name": "杭州必胜客智能控股集团",
                        "id": 217350
                    }, {
                        "name": "首尔蚂蚁航空",
                        "id": 217351
                    }, {
                        "name": "厦门喜茶餐饮",
                        "id": 217352
                    }, {
                        "name": "香港阿里汽车",
                        "id": 217353
                    }, {
                        "name": "深圳美团",
                        "id": 217354
                    }, {
                        "name": "南京奈雪电商控股集团",
                        "id": 217355
                    }, {
                        "name": "杭州百度医药控股集团",
                        "id": 217356
                    }, {
                        "name": "香港华为制造",
                        "id": 217357
                    }, {
                        "name": "纽约滴滴计算机",
                        "id": 217358
                    }, {
                        "name": "东京平安农业有限公司",
                        "id": 217359
                    }]
                }, {
                    "name": "东京奈雪科技",
                    "id": 217360
                }, {
                    "name": "南京百度医药控股集团",
                    "id": 217361
                }, {
                    "name": "杭州百度养殖",
                    "id": 217362
                }, {
                    "name": "北京微软互金",
                    "id": 217363,
                    "children": [{
                        "name": "台北腾讯医药",
                        "id": 217364
                    }, {
                        "name": "深圳必胜客金融有限公司",
                        "id": 217365
                    }, {
                        "name": "杭州字节医院",
                        "id": 217366
                    }, {
                        "name": "厦门欧珀地摊",
                        "id": 217367
                    }, {
                        "name": "上海肯德基",
                        "id": 217368
                    }, {
                        "name": "北京奈雪汽车控股集团",
                        "id": 217369
                    }, {
                        "name": "南京滴滴基金控股集团",
                        "id": 217370
                    }, {
                        "name": "台北平安",
                        "id": 217371
                    }, {
                        "name": "首尔腾讯银行有限公司",
                        "id": 217372
                    }, {
                        "name": "杭州美团",
                        "id": 217373
                    }, {
                        "name": "广州平安电商控股集团",
                        "id": 217374
                    }, {
                        "name": "北京特斯拉信息服务",
                        "id": 217375
                    }, {
                        "name": "北京肯德基电商控股集团",
                        "id": 217376
                    }, {
                        "name": "北京亚马逊银行",
                        "id": 217377
                    }]
                }, {
                    "name": "天津瑞幸通信有限公司",
                    "id": 217378
                }, {
                    "name": "香港特斯拉计算机",
                    "id": 217379
                }, {
                    "name": "深圳滴滴基金",
                    "id": 217380
                }, {
                    "name": "广州京东养殖有限公司",
                    "id": 217381,
                    "children": [{
                        "name": "杭州奈雪医药",
                        "id": 217382
                    }, {
                        "name": "纽约必胜客地摊",
                        "id": 217383
                    }, {
                        "name": "香港谷歌餐饮",
                        "id": 217384
                    }, {
                        "name": "杭州腾讯牧业有限公司",
                        "id": 217385
                    }, {
                        "name": "东京亚马逊银行",
                        "id": 217386
                    }, {
                        "name": "东莞腾讯航空控股集团",
                        "id": 217387
                    }, {
                        "name": "上海小米新能源",
                        "id": 217388
                    }, {
                        "name": "广州百度互金",
                        "id": 217389
                    }, {
                        "name": "厦门欧珀芯片控股集团",
                        "id": 217390
                    }, {
                        "name": "上海华为信息服务",
                        "id": 217391
                    }, {
                        "name": "纽约必胜客证券控股集团",
                        "id": 217392
                    }, {
                        "name": "厦门奈雪地摊",
                        "id": 217393
                    }, {
                        "name": "上海阿里芯片",
                        "id": 217394
                    }, {
                        "name": "厦门华为新能源",
                        "id": 217395
                    }, {
                        "name": "东莞喜茶证券",
                        "id": 217396
                    }, {
                        "name": "南京谷歌医院",
                        "id": 217397
                    }, {
                        "name": "杭州奈雪有限公司",
                        "id": 217398
                    }, {
                        "name": "杭州亚马逊渔业",
                        "id": 217399
                    }, {
                        "name": "杭州华为",
                        "id": 217400
                    }, {
                        "name": "杭州华为科技",
                        "id": 217401
                    }, {
                        "name": "广州字节银行有限公司",
                        "id": 217402
                    }, {
                        "name": "北京京东医药",
                        "id": 217403
                    }, {
                        "name": "广州特斯拉控股集团",
                        "id": 217404
                    }, {
                        "name": "首尔美团医院",
                        "id": 217405
                    }, {
                        "name": "东莞谷歌牧业",
                        "id": 217406
                    }, {
                        "name": "纽约华为地产",
                        "id": 217407
                    }, {
                        "name": "上海星巴克新能源",
                        "id": 217408
                    }, {
                        "name": "上海京东电商",
                        "id": 217409
                    }]
                }, {
                    "name": "厦门字节渔业有限公司",
                    "id": 217410,
                    "children": [{
                        "name": "杭州喜茶地摊",
                        "id": 217411
                    }, {
                        "name": "上海平安银行",
                        "id": 217412
                    }, {
                        "name": "北京苹果医院",
                        "id": 217413
                    }, {
                        "name": "杭州阿里制造",
                        "id": 217414
                    }, {
                        "name": "杭州小米通信",
                        "id": 217415
                    }, {
                        "name": "南京肯德基制造",
                        "id": 217416
                    }, {
                        "name": "首尔特斯拉计算机",
                        "id": 217417
                    }, {
                        "name": "台北美团智能",
                        "id": 217418
                    }, {
                        "name": "杭州亚马逊证券有限公司",
                        "id": 217419
                    }, {
                        "name": "东京阿里银行",
                        "id": 217420
                    }, {
                        "name": "台北奈雪互金有限公司",
                        "id": 217421
                    }, {
                        "name": "深圳瑞幸餐饮",
                        "id": 217422
                    }, {
                        "name": "东莞字节芯片控股集团",
                        "id": 217423
                    }, {
                        "name": "上海奈雪科技有限公司",
                        "id": 217424
                    }]
                }, {
                    "name": "北京蚂蚁新能源控股集团",
                    "id": 217425
                }, {
                    "name": "首尔星巴克地摊有限公司",
                    "id": 217426
                }, {
                    "name": "南京瑞幸",
                    "id": 217427
                }, {
                    "name": "厦门谷歌科技",
                    "id": 217428
                }, {
                    "name": "厦门谷歌基金有限公司",
                    "id": 217429
                }, {
                    "name": "杭州美团渔业有限公司",
                    "id": 217430
                }, {
                    "name": "广州腾讯证券",
                    "id": 217431,
                    "children": [{
                        "name": "首尔阿里石油有限公司",
                        "id": 217432
                    }, {
                        "name": "上海瑞幸通讯",
                        "id": 217433
                    }, {
                        "name": "台北欧珀医药",
                        "id": 217434
                    }, {
                        "name": "南京星巴克电商",
                        "id": 217435
                    }, {
                        "name": "香港阿里",
                        "id": 217436
                    }, {
                        "name": "东莞谷歌旅游",
                        "id": 217437
                    }, {
                        "name": "广州苹果地摊",
                        "id": 217438
                    }, {
                        "name": "上海谷歌诊所",
                        "id": 217439
                    }, {
                        "name": "上海腾讯通信有限公司",
                        "id": 217440
                    }, {
                        "name": "厦门美团医院控股集团",
                        "id": 217441
                    }]
                }, {
                    "name": "上海瑞幸制造",
                    "id": 217442,
                    "children": [{
                        "name": "天津苹果餐饮",
                        "id": 217443
                    }, {
                        "name": "北京腾讯地产",
                        "id": 217444
                    }, {
                        "name": "东京特斯拉旅游",
                        "id": 217445
                    }, {
                        "name": "香港小米",
                        "id": 217446
                    }, {
                        "name": "上海亚马逊地摊",
                        "id": 217447
                    }, {
                        "name": "台北瑞幸养殖",
                        "id": 217448
                    }, {
                        "name": "台北欧珀基金",
                        "id": 217449
                    }, {
                        "name": "北京特斯拉计算机",
                        "id": 217450
                    }, {
                        "name": "台北喜茶基金",
                        "id": 217451
                    }, {
                        "name": "天津滴滴金融",
                        "id": 217452
                    }, {
                        "name": "厦门亚马逊渔业",
                        "id": 217453
                    }, {
                        "name": "北京字节控股集团",
                        "id": 217454
                    }, {
                        "name": "杭州欧珀",
                        "id": 217455
                    }, {
                        "name": "杭州苹果餐饮有限公司",
                        "id": 217456
                    }]
                }, {
                    "name": "厦门瑞幸通讯控股集团",
                    "id": 217457
                }, {
                    "name": "东莞蚂蚁软件有限公司",
                    "id": 217458
                }, {
                    "name": "东京微软农业",
                    "id": 217459
                }, {
                    "name": "北京滴滴医院控股集团",
                    "id": 217460,
                    "children": [{
                        "name": "广州快手汽车",
                        "id": 217461
                    }, {
                        "name": "纽约特斯拉",
                        "id": 217462
                    }, {
                        "name": "台北微软芯片",
                        "id": 217463
                    }, {
                        "name": "纽约蚂蚁通信",
                        "id": 217464
                    }, {
                        "name": "深圳星巴克",
                        "id": 217465
                    }, {
                        "name": "天津苹果通讯",
                        "id": 217466
                    }, {
                        "name": "香港阿里计算机",
                        "id": 217467
                    }, {
                        "name": "杭州华为航空",
                        "id": 217468
                    }, {
                        "name": "东京欧珀石油有限公司",
                        "id": 217469
                    }, {
                        "name": "上海蚂蚁餐饮",
                        "id": 217470
                    }, {
                        "name": "上海京东芯片控股集团",
                        "id": 217471
                    }, {
                        "name": "东莞京东医药",
                        "id": 217472
                    }, {
                        "name": "香港小米地摊控股集团",
                        "id": 217473
                    }, {
                        "name": "东莞奈雪控股集团",
                        "id": 217474
                    }, {
                        "name": "首尔美团养殖",
                        "id": 217475
                    }, {
                        "name": "广州滴滴有限公司",
                        "id": 217476
                    }, {
                        "name": "纽约苹果航空控股集团",
                        "id": 217477
                    }, {
                        "name": "上海京东通讯",
                        "id": 217478
                    }, {
                        "name": "北京京东电商",
                        "id": 217479
                    }, {
                        "name": "北京奈雪智能",
                        "id": 217480
                    }, {
                        "name": "南京星巴克养殖有限公司",
                        "id": 217481
                    }, {
                        "name": "杭州肯德基通讯",
                        "id": 217482
                    }, {
                        "name": "东莞滴滴医药控股集团",
                        "id": 217483
                    }, {
                        "name": "深圳必胜客新能源",
                        "id": 217484
                    }, {
                        "name": "东京微软农业",
                        "id": 217485
                    }, {
                        "name": "广州瑞幸地摊",
                        "id": 217486
                    }, {
                        "name": "南京奈雪通讯",
                        "id": 217487
                    }, {
                        "name": "厦门阿里控股集团",
                        "id": 217488
                    }]
                }, {
                    "name": "台北小米科技",
                    "id": 217489,
                    "children": [{
                        "name": "东京腾讯银行",
                        "id": 217490
                    }, {
                        "name": "厦门阿里金融",
                        "id": 217491
                    }, {
                        "name": "北京华为计算机",
                        "id": 217492
                    }, {
                        "name": "北京京东银行",
                        "id": 217493
                    }]
                }]
            }, {
                "name": "杭州美团航空",
                "id": 217494,
                "children": [{
                    "name": "深圳苹果渔业",
                    "id": 217495
                }, {
                    "name": "杭州肯德基科技",
                    "id": 217496
                }, {
                    "name": "南京欧珀农业",
                    "id": 217497,
                    "children": [{
                        "name": "香港亚马逊诊所",
                        "id": 217498
                    }, {
                        "name": "首尔美团银行控股集团",
                        "id": 217499
                    }, {
                        "name": "东莞百度",
                        "id": 217500
                    }, {
                        "name": "杭州喜茶基金",
                        "id": 217501
                    }, {
                        "name": "东莞美团金融",
                        "id": 217502
                    }, {
                        "name": "东京必胜客餐饮",
                        "id": 217503
                    }, {
                        "name": "杭州小米科技有限公司",
                        "id": 217504
                    }, {
                        "name": "香港特斯拉通信",
                        "id": 217505
                    }, {
                        "name": "香港平安农业",
                        "id": 217506
                    }, {
                        "name": "首尔亚马逊通信",
                        "id": 217507
                    }, {
                        "name": "东京瑞幸软件有限公司",
                        "id": 217508
                    }, {
                        "name": "北京腾讯银行",
                        "id": 217509
                    }, {
                        "name": "厦门瑞幸信息服务",
                        "id": 217510
                    }, {
                        "name": "香港欧珀通讯",
                        "id": 217511
                    }, {
                        "name": "首尔平安牧业控股集团",
                        "id": 217512
                    }, {
                        "name": "广州腾讯",
                        "id": 217513
                    }, {
                        "name": "北京喜茶银行有限公司",
                        "id": 217514
                    }, {
                        "name": "台北谷歌地摊",
                        "id": 217515
                    }, {
                        "name": "杭州京东渔业",
                        "id": 217516
                    }, {
                        "name": "上海苹果农业",
                        "id": 217517
                    }, {
                        "name": "纽约谷歌新能源控股集团",
                        "id": 217518
                    }, {
                        "name": "台北奈雪新能源",
                        "id": 217519
                    }, {
                        "name": "厦门百度软件控股集团",
                        "id": 217520
                    }, {
                        "name": "南京蚂蚁",
                        "id": 217521
                    }, {
                        "name": "北京苹果医院",
                        "id": 217522
                    }, {
                        "name": "台北京东医药",
                        "id": 217523
                    }, {
                        "name": "东莞蚂蚁航空",
                        "id": 217524
                    }, {
                        "name": "厦门必胜客信息服务",
                        "id": 217525
                    }, {
                        "name": "南京微软基金",
                        "id": 217526
                    }, {
                        "name": "东莞小米地产",
                        "id": 217527
                    }, {
                        "name": "杭州快手制造有限公司",
                        "id": 217528
                    }, {
                        "name": "北京苹果银行",
                        "id": 217529
                    }, {
                        "name": "上海阿里地产",
                        "id": 217530
                    }, {
                        "name": "深圳小米航空",
                        "id": 217531
                    }, {
                        "name": "纽约快手地产",
                        "id": 217532
                    }]
                }, {
                    "name": "深圳小米制造控股集团",
                    "id": 217533
                }, {
                    "name": "广州欧珀新能源",
                    "id": 217534
                }, {
                    "name": "香港必胜客软件",
                    "id": 217535
                }, {
                    "name": "东莞京东制造",
                    "id": 217536
                }, {
                    "name": "天津必胜客通信",
                    "id": 217537
                }, {
                    "name": "东莞小米航空",
                    "id": 217538
                }, {
                    "name": "北京必胜客通信控股集团",
                    "id": 217539
                }, {
                    "name": "广州欧珀基金控股集团",
                    "id": 217540
                }, {
                    "name": "上海快手电商",
                    "id": 217541
                }, {
                    "name": "香港特斯拉渔业",
                    "id": 217542
                }, {
                    "name": "杭州肯德基医药",
                    "id": 217543
                }, {
                    "name": "东莞肯德基金融有限公司",
                    "id": 217544
                }, {
                    "name": "厦门喜茶",
                    "id": 217545,
                    "children": [{
                        "name": "北京蚂蚁金融",
                        "id": 217546
                    }, {
                        "name": "北京百度智能",
                        "id": 217547
                    }, {
                        "name": "东京特斯拉石油",
                        "id": 217548
                    }, {
                        "name": "香港亚马逊牧业",
                        "id": 217549
                    }, {
                        "name": "南京星巴克银行",
                        "id": 217550
                    }, {
                        "name": "上海瑞幸旅游",
                        "id": 217551
                    }, {
                        "name": "上海奈雪计算机",
                        "id": 217552
                    }, {
                        "name": "南京喜茶农业有限公司",
                        "id": 217553
                    }, {
                        "name": "天津星巴克地产控股集团",
                        "id": 217554
                    }, {
                        "name": "东莞百度互金",
                        "id": 217555
                    }, {
                        "name": "天津京东计算机",
                        "id": 217556
                    }, {
                        "name": "杭州星巴克制造控股集团",
                        "id": 217557
                    }, {
                        "name": "深圳微软通讯有限公司",
                        "id": 217558
                    }, {
                        "name": "首尔华为银行",
                        "id": 217559
                    }, {
                        "name": "首尔肯德基银行有限公司",
                        "id": 217560
                    }, {
                        "name": "杭州京东软件",
                        "id": 217561
                    }, {
                        "name": "东莞华为",
                        "id": 217562
                    }, {
                        "name": "北京小米软件",
                        "id": 217563
                    }, {
                        "name": "南京美团养殖",
                        "id": 217564
                    }, {
                        "name": "纽约美团银行有限公司",
                        "id": 217565
                    }, {
                        "name": "厦门肯德基软件有限公司",
                        "id": 217566
                    }, {
                        "name": "上海百度航空",
                        "id": 217567
                    }, {
                        "name": "厦门苹果互金",
                        "id": 217568
                    }, {
                        "name": "东京京东",
                        "id": 217569
                    }, {
                        "name": "首尔阿里石油",
                        "id": 217570
                    }, {
                        "name": "首尔必胜客诊所",
                        "id": 217571
                    }, {
                        "name": "香港美团计算机有限公司",
                        "id": 217572
                    }]
                }, {
                    "name": "东京欧珀地摊",
                    "id": 217573
                }, {
                    "name": "上海字节制造",
                    "id": 217574,
                    "children": [{
                        "name": "香港小米诊所",
                        "id": 217575
                    }, {
                        "name": "香港快手农业",
                        "id": 217576
                    }, {
                        "name": "北京必胜客汽车有限公司",
                        "id": 217577
                    }, {
                        "name": "上海京东智能",
                        "id": 217578
                    }, {
                        "name": "杭州特斯拉渔业",
                        "id": 217579
                    }, {
                        "name": "首尔腾讯通讯",
                        "id": 217580
                    }, {
                        "name": "上海星巴克航空",
                        "id": 217581
                    }, {
                        "name": "广州微软医院有限公司",
                        "id": 217582
                    }, {
                        "name": "首尔亚马逊科技",
                        "id": 217583
                    }, {
                        "name": "首尔字节医药",
                        "id": 217584
                    }, {
                        "name": "杭州瑞幸渔业",
                        "id": 217585
                    }, {
                        "name": "南京欧珀渔业",
                        "id": 217586
                    }, {
                        "name": "天津快手旅游",
                        "id": 217587
                    }, {
                        "name": "东莞喜茶农业控股集团",
                        "id": 217588
                    }]
                }, {
                    "name": "首尔京东餐饮",
                    "id": 217589
                }, {
                    "name": "厦门京东银行",
                    "id": 217590
                }, {
                    "name": "广州百度制造有限公司",
                    "id": 217591
                }, {
                    "name": "东京亚马逊旅游有限公司",
                    "id": 217592
                }, {
                    "name": "北京百度通信控股集团",
                    "id": 217593
                }]
            }, {
                "name": "北京瑞幸互金有限公司",
                "id": 217594
            }, {
                "name": "天津百度诊所",
                "id": 217595,
                "children": [{
                    "name": "厦门蚂蚁",
                    "id": 217596
                }, {
                    "name": "东莞谷歌旅游有限公司",
                    "id": 217597
                }, {
                    "name": "厦门微软石油",
                    "id": 217598
                }, {
                    "name": "杭州腾讯科技有限公司",
                    "id": 217599,
                    "children": [{
                        "name": "上海美团信息服务控股集团",
                        "id": 217600
                    }, {
                        "name": "东京微软软件",
                        "id": 217601
                    }, {
                        "name": "深圳百度地产",
                        "id": 217602
                    }, {
                        "name": "东莞苹果石油有限公司",
                        "id": 217603
                    }, {
                        "name": "北京平安地摊",
                        "id": 217604
                    }, {
                        "name": "杭州阿里智能有限公司",
                        "id": 217605
                    }, {
                        "name": "台北小米智能",
                        "id": 217606
                    }, {
                        "name": "南京特斯拉新能源有限公司",
                        "id": 217607
                    }, {
                        "name": "杭州小米有限公司",
                        "id": 217608
                    }, {
                        "name": "上海字节控股集团",
                        "id": 217609
                    }]
                }, {
                    "name": "厦门京东地产",
                    "id": 217610
                }, {
                    "name": "东京字节控股集团",
                    "id": 217611,
                    "children": [{
                        "name": "纽约苹果地摊",
                        "id": 217612
                    }, {
                        "name": "北京美团银行",
                        "id": 217613
                    }, {
                        "name": "杭州谷歌通信",
                        "id": 217614
                    }, {
                        "name": "广州百度餐饮控股集团",
                        "id": 217615
                    }, {
                        "name": "首尔美团",
                        "id": 217616
                    }, {
                        "name": "广州百度基金",
                        "id": 217617
                    }, {
                        "name": "东京蚂蚁旅游控股集团",
                        "id": 217618
                    }, {
                        "name": "南京小米基金",
                        "id": 217619
                    }, {
                        "name": "杭州微软制造控股集团",
                        "id": 217620
                    }, {
                        "name": "杭州美团地摊",
                        "id": 217621
                    }, {
                        "name": "天津特斯拉",
                        "id": 217622
                    }, {
                        "name": "台北滴滴汽车有限公司",
                        "id": 217623
                    }, {
                        "name": "南京瑞幸旅游",
                        "id": 217624
                    }, {
                        "name": "香港小米诊所",
                        "id": 217625
                    }, {
                        "name": "深圳亚马逊有限公司",
                        "id": 217626
                    }]
                }, {
                    "name": "杭州华为养殖",
                    "id": 217627
                }, {
                    "name": "上海瑞幸科技",
                    "id": 217628
                }, {
                    "name": "台北腾讯通信",
                    "id": 217629,
                    "children": [{
                        "name": "深圳苹果牧业",
                        "id": 217630
                    }, {
                        "name": "北京微软软件控股集团",
                        "id": 217631
                    }, {
                        "name": "杭州欧珀互金",
                        "id": 217632
                    }, {
                        "name": "厦门谷歌航空",
                        "id": 217633
                    }, {
                        "name": "香港特斯拉芯片",
                        "id": 217634
                    }, {
                        "name": "东莞微软牧业控股集团",
                        "id": 217635
                    }, {
                        "name": "天津快手农业",
                        "id": 217636
                    }, {
                        "name": "天津华为基金",
                        "id": 217637
                    }, {
                        "name": "天津小米电商",
                        "id": 217638
                    }, {
                        "name": "深圳特斯拉",
                        "id": 217639
                    }, {
                        "name": "天津星巴克科技",
                        "id": 217640
                    }, {
                        "name": "南京亚马逊控股集团",
                        "id": 217641
                    }, {
                        "name": "杭州必胜客",
                        "id": 217642
                    }, {
                        "name": "纽约瑞幸汽车",
                        "id": 217643
                    }]
                }, {
                    "name": "首尔腾讯餐饮",
                    "id": 217644
                }, {
                    "name": "东京美团通讯",
                    "id": 217645
                }, {
                    "name": "上海蚂蚁科技",
                    "id": 217646
                }, {
                    "name": "首尔平安智能",
                    "id": 217647
                }, {
                    "name": "东京蚂蚁科技",
                    "id": 217648,
                    "children": [{
                        "name": "南京苹果金融控股集团",
                        "id": 217649
                    }, {
                        "name": "杭州特斯拉通信有限公司",
                        "id": 217650
                    }, {
                        "name": "首尔腾讯医院控股集团",
                        "id": 217651
                    }, {
                        "name": "东莞亚马逊软件",
                        "id": 217652
                    }, {
                        "name": "厦门蚂蚁汽车",
                        "id": 217653
                    }, {
                        "name": "厦门谷歌渔业",
                        "id": 217654
                    }, {
                        "name": "上海小米渔业",
                        "id": 217655
                    }, {
                        "name": "上海腾讯旅游",
                        "id": 217656
                    }, {
                        "name": "厦门小米新能源",
                        "id": 217657
                    }, {
                        "name": "台北字节石油",
                        "id": 217658
                    }, {
                        "name": "北京京东医药",
                        "id": 217659
                    }, {
                        "name": "广州欧珀",
                        "id": 217660
                    }, {
                        "name": "杭州百度医院有限公司",
                        "id": 217661
                    }, {
                        "name": "纽约蚂蚁证券",
                        "id": 217662
                    }, {
                        "name": "厦门华为医院",
                        "id": 217663
                    }, {
                        "name": "首尔华为智能",
                        "id": 217664
                    }, {
                        "name": "深圳奈雪汽车",
                        "id": 217665
                    }, {
                        "name": "杭州京东餐饮",
                        "id": 217666
                    }, {
                        "name": "杭州肯德基制造",
                        "id": 217667
                    }, {
                        "name": "上海星巴克电商有限公司",
                        "id": 217668
                    }, {
                        "name": "南京亚马逊渔业",
                        "id": 217669
                    }, {
                        "name": "东莞华为石油",
                        "id": 217670
                    }, {
                        "name": "杭州华为",
                        "id": 217671
                    }, {
                        "name": "厦门星巴克金融",
                        "id": 217672
                    }, {
                        "name": "深圳微软银行有限公司",
                        "id": 217673
                    }, {
                        "name": "厦门欧珀互金",
                        "id": 217674
                    }, {
                        "name": "东京滴滴证券",
                        "id": 217675
                    }, {
                        "name": "北京百度通讯有限公司",
                        "id": 217676
                    }, {
                        "name": "杭州必胜客石油",
                        "id": 217677
                    }]
                }, {
                    "name": "首尔微软科技有限公司",
                    "id": 217678,
                    "children": [{
                        "name": "北京小米基金",
                        "id": 217679
                    }, {
                        "name": "香港小米基金",
                        "id": 217680
                    }, {
                        "name": "东京华为通信有限公司",
                        "id": 217681
                    }, {
                        "name": "首尔京东新能源",
                        "id": 217682
                    }, {
                        "name": "首尔亚马逊餐饮",
                        "id": 217683
                    }, {
                        "name": "北京必胜客养殖",
                        "id": 217684
                    }, {
                        "name": "天津小米证券控股集团",
                        "id": 217685
                    }, {
                        "name": "首尔亚马逊牧业",
                        "id": 217686
                    }, {
                        "name": "深圳百度互金",
                        "id": 217687
                    }, {
                        "name": "首尔美团智能",
                        "id": 217688
                    }, {
                        "name": "天津微软医院",
                        "id": 217689
                    }, {
                        "name": "南京瑞幸地摊",
                        "id": 217690
                    }, {
                        "name": "首尔美团牧业",
                        "id": 217691
                    }, {
                        "name": "纽约京东医院",
                        "id": 217692
                    }, {
                        "name": "东莞星巴克医院",
                        "id": 217693
                    }, {
                        "name": "杭州百度旅游",
                        "id": 217694
                    }, {
                        "name": "东京阿里旅游",
                        "id": 217695
                    }, {
                        "name": "东莞肯德基地产",
                        "id": 217696
                    }, {
                        "name": "首尔腾讯渔业",
                        "id": 217697
                    }, {
                        "name": "杭州滴滴汽车有限公司",
                        "id": 217698
                    }, {
                        "name": "杭州肯德基芯片控股集团",
                        "id": 217699
                    }, {
                        "name": "东莞奈雪新能源",
                        "id": 217700
                    }]
                }, {
                    "name": "杭州京东餐饮",
                    "id": 217701,
                    "children": [{
                        "name": "东京谷歌信息服务",
                        "id": 217702
                    }, {
                        "name": "杭州肯德基芯片",
                        "id": 217703
                    }, {
                        "name": "广州瑞幸制造",
                        "id": 217704
                    }, {
                        "name": "东京肯德基汽车",
                        "id": 217705
                    }, {
                        "name": "杭州星巴克农业",
                        "id": 217706
                    }, {
                        "name": "首尔阿里控股集团",
                        "id": 217707
                    }, {
                        "name": "南京亚马逊养殖",
                        "id": 217708
                    }, {
                        "name": "杭州百度证券",
                        "id": 217709
                    }, {
                        "name": "深圳快手牧业",
                        "id": 217710
                    }, {
                        "name": "首尔微软电商",
                        "id": 217711
                    }, {
                        "name": "南京谷歌金融",
                        "id": 217712
                    }, {
                        "name": "北京滴滴新能源",
                        "id": 217713
                    }]
                }, {
                    "name": "首尔谷歌芯片控股集团",
                    "id": 217714
                }, {
                    "name": "香港谷歌计算机",
                    "id": 217715,
                    "children": [{
                        "name": "东京阿里信息服务有限公司",
                        "id": 217716
                    }, {
                        "name": "杭州美团制造",
                        "id": 217717
                    }, {
                        "name": "南京京东通讯",
                        "id": 217718
                    }, {
                        "name": "台北小米证券",
                        "id": 217719
                    }, {
                        "name": "深圳谷歌医药",
                        "id": 217720
                    }, {
                        "name": "杭州苹果通讯",
                        "id": 217721
                    }]
                }, {
                    "name": "纽约瑞幸银行",
                    "id": 217722
                }, {
                    "name": "深圳平安养殖",
                    "id": 217723
                }, {
                    "name": "南京星巴克证券控股集团",
                    "id": 217724
                }, {
                    "name": "东莞苹果软件",
                    "id": 217725
                }, {
                    "name": "天津京东",
                    "id": 217726
                }, {
                    "name": "杭州美团诊所控股集团",
                    "id": 217727
                }, {
                    "name": "广州星巴克证券控股集团",
                    "id": 217728
                }, {
                    "name": "香港阿里软件",
                    "id": 217729
                }, {
                    "name": "深圳欧珀农业",
                    "id": 217730
                }, {
                    "name": "天津必胜客地摊",
                    "id": 217731
                }, {
                    "name": "杭州快手信息服务控股集团",
                    "id": 217732,
                    "children": [{
                        "name": "上海奈雪通信",
                        "id": 217733
                    }]
                }, {
                    "name": "南京蚂蚁电商控股集团",
                    "id": 217734,
                    "children": [{
                        "name": "北京微软餐饮控股集团",
                        "id": 217735
                    }, {
                        "name": "首尔腾讯芯片",
                        "id": 217736
                    }, {
                        "name": "东莞小米通讯",
                        "id": 217737
                    }, {
                        "name": "首尔欧珀地产",
                        "id": 217738
                    }, {
                        "name": "东京喜茶科技",
                        "id": 217739
                    }, {
                        "name": "纽约京东智能",
                        "id": 217740
                    }, {
                        "name": "上海谷歌智能控股集团",
                        "id": 217741
                    }, {
                        "name": "北京特斯拉有限公司",
                        "id": 217742
                    }, {
                        "name": "杭州星巴克科技",
                        "id": 217743
                    }]
                }, {
                    "name": "杭州谷歌电商有限公司",
                    "id": 217744
                }, {
                    "name": "杭州百度餐饮",
                    "id": 217745,
                    "children": [{
                        "name": "南京小米牧业",
                        "id": 217746
                    }, {
                        "name": "东莞蚂蚁汽车",
                        "id": 217747
                    }, {
                        "name": "香港喜茶航空",
                        "id": 217748
                    }, {
                        "name": "上海小米汽车控股集团",
                        "id": 217749
                    }, {
                        "name": "广州瑞幸互金控股集团",
                        "id": 217750
                    }, {
                        "name": "深圳小米养殖",
                        "id": 217751
                    }, {
                        "name": "南京谷歌农业",
                        "id": 217752
                    }, {
                        "name": "杭州谷歌信息服务有限公司",
                        "id": 217753
                    }, {
                        "name": "杭州必胜客银行",
                        "id": 217754
                    }, {
                        "name": "香港滴滴地摊有限公司",
                        "id": 217755
                    }, {
                        "name": "首尔苹果医药控股集团",
                        "id": 217756
                    }, {
                        "name": "香港小米旅游",
                        "id": 217757
                    }, {
                        "name": "上海欧珀航空",
                        "id": 217758
                    }, {
                        "name": "广州特斯拉计算机",
                        "id": 217759
                    }, {
                        "name": "南京字节",
                        "id": 217760
                    }, {
                        "name": "杭州腾讯通信",
                        "id": 217761
                    }, {
                        "name": "深圳必胜客医院",
                        "id": 217762
                    }, {
                        "name": "厦门瑞幸软件",
                        "id": 217763
                    }, {
                        "name": "东莞喜茶银行",
                        "id": 217764
                    }, {
                        "name": "广州肯德基信息服务有限公司",
                        "id": 217765
                    }, {
                        "name": "杭州特斯拉汽车有限公司",
                        "id": 217766
                    }, {
                        "name": "杭州奈雪互金",
                        "id": 217767
                    }, {
                        "name": "东莞欧珀证券",
                        "id": 217768
                    }, {
                        "name": "东莞快手牧业",
                        "id": 217769
                    }, {
                        "name": "东莞喜茶航空控股集团",
                        "id": 217770
                    }, {
                        "name": "首尔快手医院",
                        "id": 217771
                    }, {
                        "name": "厦门欧珀金融",
                        "id": 217772
                    }, {
                        "name": "杭州亚马逊旅游",
                        "id": 217773
                    }, {
                        "name": "杭州华为石油",
                        "id": 217774
                    }, {
                        "name": "杭州星巴克科技",
                        "id": 217775
                    }, {
                        "name": "南京小米科技",
                        "id": 217776
                    }, {
                        "name": "天津谷歌通讯",
                        "id": 217777
                    }, {
                        "name": "东京必胜客汽车控股集团",
                        "id": 217778
                    }]
                }, {
                    "name": "杭州蚂蚁航空",
                    "id": 217779
                }, {
                    "name": "纽约欧珀新能源",
                    "id": 217780
                }, {
                    "name": "南京谷歌科技控股集团",
                    "id": 217781
                }]
            }, {
                "name": "纽约亚马逊农业控股集团",
                "id": 217782,
                "children": [{
                    "name": "台北平安智能有限公司",
                    "id": 217783,
                    "children": [{
                        "name": "天津字节养殖",
                        "id": 217784
                    }, {
                        "name": "南京腾讯养殖",
                        "id": 217785
                    }, {
                        "name": "香港小米基金",
                        "id": 217786
                    }, {
                        "name": "东京腾讯牧业",
                        "id": 217787
                    }, {
                        "name": "东莞腾讯基金有限公司",
                        "id": 217788
                    }, {
                        "name": "首尔肯德基地摊控股集团",
                        "id": 217789
                    }, {
                        "name": "纽约快手医院控股集团",
                        "id": 217790
                    }, {
                        "name": "香港平安牧业控股集团",
                        "id": 217791
                    }, {
                        "name": "杭州微软信息服务",
                        "id": 217792
                    }, {
                        "name": "东莞华为通信",
                        "id": 217793
                    }, {
                        "name": "首尔蚂蚁农业有限公司",
                        "id": 217794
                    }, {
                        "name": "厦门欧珀电商有限公司",
                        "id": 217795
                    }, {
                        "name": "台北华为软件",
                        "id": 217796
                    }, {
                        "name": "南京滴滴医药",
                        "id": 217797
                    }, {
                        "name": "东京瑞幸地摊",
                        "id": 217798
                    }, {
                        "name": "天津欧珀银行",
                        "id": 217799
                    }, {
                        "name": "杭州微软诊所有限公司",
                        "id": 217800
                    }, {
                        "name": "香港平安航空",
                        "id": 217801
                    }, {
                        "name": "上海腾讯制造",
                        "id": 217802
                    }, {
                        "name": "纽约腾讯控股集团",
                        "id": 217803
                    }, {
                        "name": "纽约微软通讯",
                        "id": 217804
                    }, {
                        "name": "上海平安牧业",
                        "id": 217805
                    }, {
                        "name": "深圳腾讯地摊有限公司",
                        "id": 217806
                    }, {
                        "name": "首尔苹果电商",
                        "id": 217807
                    }, {
                        "name": "厦门小米控股集团",
                        "id": 217808
                    }, {
                        "name": "台北欧珀地摊",
                        "id": 217809
                    }, {
                        "name": "香港微软信息服务",
                        "id": 217810
                    }, {
                        "name": "广州谷歌医药控股集团",
                        "id": 217811
                    }, {
                        "name": "广州快手诊所",
                        "id": 217812
                    }, {
                        "name": "东莞瑞幸",
                        "id": 217813
                    }, {
                        "name": "广州字节芯片控股集团",
                        "id": 217814
                    }, {
                        "name": "首尔特斯拉牧业",
                        "id": 217815
                    }]
                }, {
                    "name": "台北腾讯农业",
                    "id": 217816,
                    "children": [{
                        "name": "纽约欧珀科技",
                        "id": 217817
                    }, {
                        "name": "杭州华为养殖",
                        "id": 217818
                    }, {
                        "name": "东莞京东石油有限公司",
                        "id": 217819
                    }, {
                        "name": "东莞苹果渔业",
                        "id": 217820
                    }, {
                        "name": "台北微软软件",
                        "id": 217821
                    }, {
                        "name": "东京肯德基制造",
                        "id": 217822
                    }, {
                        "name": "东莞必胜客制造",
                        "id": 217823
                    }, {
                        "name": "广州小米电商控股集团",
                        "id": 217824
                    }, {
                        "name": "北京蚂蚁有限公司",
                        "id": 217825
                    }, {
                        "name": "杭州小米信息服务有限公司",
                        "id": 217826
                    }]
                }, {
                    "name": "香港肯德基新能源",
                    "id": 217827
                }, {
                    "name": "上海奈雪互金",
                    "id": 217828
                }, {
                    "name": "东莞美团新能源",
                    "id": 217829
                }, {
                    "name": "杭州京东航空控股集团",
                    "id": 217830
                }, {
                    "name": "香港阿里智能",
                    "id": 217831
                }]
            }, {
                "name": "首尔奈雪通讯有限公司",
                "id": 217832
            }, {
                "name": "上海美团农业",
                "id": 217833
            }, {
                "name": "广州喜茶医院",
                "id": 217834
            }, {
                "name": "杭州阿里互金",
                "id": 217835
            }, {
                "name": "杭州必胜客旅游有限公司",
                "id": 217836
            }, {
                "name": "纽约阿里智能",
                "id": 217837
            }, {
                "name": "上海字节石油控股集团",
                "id": 217838
            }, {
                "name": "北京谷歌旅游控股集团",
                "id": 217839
            }, {
                "name": "杭州必胜客汽车有限公司",
                "id": 217840,
                "children": [{
                    "name": "东莞小米诊所",
                    "id": 217841
                }, {
                    "name": "香港苹果石油",
                    "id": 217842
                }, {
                    "name": "东莞小米芯片",
                    "id": 217843
                }, {
                    "name": "厦门美团信息服务有限公司",
                    "id": 217844
                }, {
                    "name": "上海微软制造",
                    "id": 217845
                }, {
                    "name": "深圳京东信息服务",
                    "id": 217846
                }, {
                    "name": "厦门特斯拉通信",
                    "id": 217847
                }, {
                    "name": "东莞阿里互金有限公司",
                    "id": 217848
                }, {
                    "name": "深圳苹果金融控股集团",
                    "id": 217849
                }, {
                    "name": "台北必胜客地产",
                    "id": 217850
                }, {
                    "name": "东莞奈雪医院",
                    "id": 217851
                }, {
                    "name": "杭州欧珀",
                    "id": 217852
                }, {
                    "name": "上海百度医药",
                    "id": 217853
                }, {
                    "name": "上海肯德基农业",
                    "id": 217854
                }, {
                    "name": "北京星巴克控股集团",
                    "id": 217855
                }, {
                    "name": "天津平安芯片",
                    "id": 217856
                }, {
                    "name": "北京谷歌软件控股集团",
                    "id": 217857,
                    "children": [{
                        "name": "首尔谷歌汽车控股集团",
                        "id": 217858
                    }, {
                        "name": "厦门肯德基金融有限公司",
                        "id": 217859
                    }, {
                        "name": "纽约快手银行",
                        "id": 217860
                    }, {
                        "name": "台北必胜客养殖",
                        "id": 217861
                    }, {
                        "name": "香港腾讯医药",
                        "id": 217862
                    }, {
                        "name": "深圳快手计算机",
                        "id": 217863
                    }, {
                        "name": "首尔奈雪金融",
                        "id": 217864
                    }, {
                        "name": "杭州百度诊所",
                        "id": 217865
                    }, {
                        "name": "东莞星巴克电商有限公司",
                        "id": 217866
                    }, {
                        "name": "纽约字节芯片",
                        "id": 217867
                    }, {
                        "name": "东莞腾讯新能源有限公司",
                        "id": 217868
                    }, {
                        "name": "深圳蚂蚁智能",
                        "id": 217869
                    }, {
                        "name": "香港亚马逊石油",
                        "id": 217870
                    }, {
                        "name": "广州瑞幸",
                        "id": 217871
                    }, {
                        "name": "纽约星巴克软件",
                        "id": 217872
                    }, {
                        "name": "天津百度石油",
                        "id": 217873
                    }, {
                        "name": "厦门平安软件控股集团",
                        "id": 217874
                    }, {
                        "name": "首尔腾讯电商控股集团",
                        "id": 217875
                    }, {
                        "name": "天津谷歌通信",
                        "id": 217876
                    }, {
                        "name": "东莞谷歌汽车",
                        "id": 217877
                    }, {
                        "name": "南京奈雪芯片",
                        "id": 217878
                    }, {
                        "name": "香港京东诊所",
                        "id": 217879
                    }, {
                        "name": "首尔快手智能",
                        "id": 217880
                    }, {
                        "name": "广州瑞幸科技控股集团",
                        "id": 217881
                    }, {
                        "name": "杭州阿里",
                        "id": 217882
                    }, {
                        "name": "天津星巴克旅游",
                        "id": 217883
                    }, {
                        "name": "杭州苹果信息服务",
                        "id": 217884
                    }, {
                        "name": "香港亚马逊芯片控股集团",
                        "id": 217885
                    }, {
                        "name": "东京微软有限公司",
                        "id": 217886
                    }, {
                        "name": "上海喜茶智能",
                        "id": 217887
                    }]
                }, {
                    "name": "纽约美团石油控股集团",
                    "id": 217888
                }, {
                    "name": "首尔腾讯科技",
                    "id": 217889
                }, {
                    "name": "杭州美团科技",
                    "id": 217890
                }, {
                    "name": "杭州瑞幸医药",
                    "id": 217891
                }]
            }, {
                "name": "东京星巴克地产",
                "id": 217892
            }, {
                "name": "东莞小米医院有限公司",
                "id": 217893
            }, {
                "name": "北京苹果通讯",
                "id": 217894
            }]
        }, {
            "name": "北京滴滴基金",
            "id": 217895
        }, {
            "name": "东京瑞幸地摊",
            "id": 217896,
            "children": [{
                "name": "台北肯德基新能源",
                "id": 217897,
                "children": [{
                    "name": "香港奈雪地摊",
                    "id": 217898,
                    "children": [{
                        "name": "首尔华为软件",
                        "id": 217899
                    }, {
                        "name": "东京必胜客农业有限公司",
                        "id": 217900
                    }, {
                        "name": "天津欧珀基金有限公司",
                        "id": 217901
                    }, {
                        "name": "天津阿里餐饮",
                        "id": 217902
                    }, {
                        "name": "广州喜茶智能",
                        "id": 217903
                    }, {
                        "name": "杭州腾讯信息服务",
                        "id": 217904
                    }, {
                        "name": "台北小米计算机",
                        "id": 217905
                    }]
                }, {
                    "name": "厦门瑞幸地产",
                    "id": 217906,
                    "children": [{
                        "name": "上海瑞幸通信",
                        "id": 217907
                    }, {
                        "name": "北京百度电商",
                        "id": 217908
                    }, {
                        "name": "上海谷歌通讯",
                        "id": 217909
                    }, {
                        "name": "首尔星巴克医药控股集团",
                        "id": 217910
                    }, {
                        "name": "东京喜茶新能源控股集团",
                        "id": 217911
                    }, {
                        "name": "东莞京东证券",
                        "id": 217912
                    }, {
                        "name": "北京喜茶制造",
                        "id": 217913
                    }, {
                        "name": "天津百度诊所",
                        "id": 217914
                    }, {
                        "name": "东莞特斯拉制造",
                        "id": 217915
                    }, {
                        "name": "天津小米通讯",
                        "id": 217916
                    }, {
                        "name": "广州滴滴养殖控股集团",
                        "id": 217917
                    }, {
                        "name": "深圳特斯拉互金",
                        "id": 217918
                    }, {
                        "name": "北京肯德基诊所",
                        "id": 217919
                    }, {
                        "name": "厦门瑞幸金融控股集团",
                        "id": 217920
                    }, {
                        "name": "杭州瑞幸金融",
                        "id": 217921
                    }, {
                        "name": "纽约字节智能",
                        "id": 217922
                    }, {
                        "name": "杭州百度",
                        "id": 217923
                    }, {
                        "name": "厦门欧珀地摊",
                        "id": 217924
                    }, {
                        "name": "杭州肯德基基金",
                        "id": 217925
                    }, {
                        "name": "广州腾讯计算机",
                        "id": 217926
                    }, {
                        "name": "台北必胜客旅游",
                        "id": 217927
                    }]
                }, {
                    "name": "香港特斯拉计算机",
                    "id": 217928,
                    "children": [{
                        "name": "上海亚马逊诊所有限公司",
                        "id": 217929
                    }, {
                        "name": "上海微软诊所",
                        "id": 217930
                    }, {
                        "name": "杭州特斯拉旅游",
                        "id": 217931
                    }, {
                        "name": "杭州平安软件",
                        "id": 217932
                    }, {
                        "name": "香港腾讯通信控股集团",
                        "id": 217933
                    }, {
                        "name": "香港腾讯基金",
                        "id": 217934
                    }, {
                        "name": "台北蚂蚁",
                        "id": 217935
                    }, {
                        "name": "深圳滴滴智能控股集团",
                        "id": 217936
                    }, {
                        "name": "首尔滴滴银行控股集团",
                        "id": 217937
                    }, {
                        "name": "台北平安软件",
                        "id": 217938
                    }, {
                        "name": "北京滴滴养殖",
                        "id": 217939
                    }, {
                        "name": "厦门滴滴制造有限公司",
                        "id": 217940
                    }, {
                        "name": "纽约蚂蚁养殖",
                        "id": 217941
                    }, {
                        "name": "上海微软",
                        "id": 217942
                    }, {
                        "name": "首尔腾讯计算机",
                        "id": 217943
                    }, {
                        "name": "杭州欧珀医院控股集团",
                        "id": 217944
                    }, {
                        "name": "天津特斯拉航空",
                        "id": 217945
                    }, {
                        "name": "深圳快手医院有限公司",
                        "id": 217946
                    }, {
                        "name": "杭州华为航空",
                        "id": 217947
                    }, {
                        "name": "首尔华为基金",
                        "id": 217948
                    }]
                }, {
                    "name": "厦门微软旅游控股集团",
                    "id": 217949,
                    "children": [{
                        "name": "南京平安航空",
                        "id": 217950
                    }, {
                        "name": "天津谷歌医院",
                        "id": 217951
                    }, {
                        "name": "厦门肯德基控股集团",
                        "id": 217952
                    }, {
                        "name": "广州腾讯医院",
                        "id": 217953
                    }, {
                        "name": "纽约滴滴制造",
                        "id": 217954
                    }, {
                        "name": "北京阿里软件",
                        "id": 217955
                    }, {
                        "name": "北京腾讯通信",
                        "id": 217956
                    }, {
                        "name": "东京谷歌电商",
                        "id": 217957
                    }, {
                        "name": "东京小米芯片有限公司",
                        "id": 217958
                    }, {
                        "name": "上海星巴克通讯",
                        "id": 217959
                    }, {
                        "name": "杭州苹果渔业",
                        "id": 217960
                    }, {
                        "name": "杭州喜茶汽车有限公司",
                        "id": 217961
                    }, {
                        "name": "天津华为地摊",
                        "id": 217962
                    }, {
                        "name": "杭州美团地产有限公司",
                        "id": 217963
                    }, {
                        "name": "厦门奈雪金融有限公司",
                        "id": 217964
                    }]
                }, {
                    "name": "天津星巴克信息服务",
                    "id": 217965
                }]
            }, {
                "name": "东京平安互金控股集团",
                "id": 217966
            }, {
                "name": "纽约小米新能源",
                "id": 217967
            }, {
                "name": "北京快手航空",
                "id": 217968
            }, {
                "name": "台北特斯拉农业",
                "id": 217969
            }, {
                "name": "首尔阿里新能源",
                "id": 217970
            }, {
                "name": "厦门喜茶金融",
                "id": 217971,
                "children": [{
                    "name": "杭州肯德基制造控股集团",
                    "id": 217972
                }, {
                    "name": "杭州腾讯银行控股集团",
                    "id": 217973
                }, {
                    "name": "台北苹果",
                    "id": 217974,
                    "children": [{
                        "name": "深圳滴滴制造",
                        "id": 217975
                    }, {
                        "name": "杭州阿里电商",
                        "id": 217976
                    }, {
                        "name": "厦门苹果控股集团",
                        "id": 217977
                    }, {
                        "name": "北京平安计算机",
                        "id": 217978
                    }, {
                        "name": "北京瑞幸基金",
                        "id": 217979
                    }, {
                        "name": "上海京东基金",
                        "id": 217980
                    }]
                }, {
                    "name": "北京奈雪养殖有限公司",
                    "id": 217981
                }, {
                    "name": "香港瑞幸金融",
                    "id": 217982
                }, {
                    "name": "天津京东智能",
                    "id": 217983,
                    "children": [{
                        "name": "杭州苹果通信",
                        "id": 217984
                    }, {
                        "name": "深圳平安医院",
                        "id": 217985
                    }, {
                        "name": "杭州瑞幸银行控股集团",
                        "id": 217986
                    }, {
                        "name": "南京瑞幸计算机有限公司",
                        "id": 217987
                    }, {
                        "name": "台北蚂蚁计算机",
                        "id": 217988
                    }, {
                        "name": "天津星巴克银行控股集团",
                        "id": 217989
                    }, {
                        "name": "香港苹果互金",
                        "id": 217990
                    }, {
                        "name": "台北华为地产",
                        "id": 217991
                    }, {
                        "name": "深圳苹果",
                        "id": 217992
                    }, {
                        "name": "杭州腾讯银行",
                        "id": 217993
                    }, {
                        "name": "北京必胜客旅游",
                        "id": 217994
                    }, {
                        "name": "东京亚马逊芯片",
                        "id": 217995
                    }, {
                        "name": "东京阿里诊所",
                        "id": 217996
                    }, {
                        "name": "厦门星巴克基金有限公司",
                        "id": 217997
                    }, {
                        "name": "首尔字节",
                        "id": 217998
                    }, {
                        "name": "杭州欧珀计算机",
                        "id": 217999
                    }, {
                        "name": "杭州华为通信",
                        "id": 218000
                    }, {
                        "name": "南京字节航空有限公司",
                        "id": 218001
                    }, {
                        "name": "首尔瑞幸石油",
                        "id": 218002
                    }]
                }, {
                    "name": "深圳谷歌计算机有限公司",
                    "id": 218003
                }, {
                    "name": "纽约腾讯有限公司",
                    "id": 218004
                }, {
                    "name": "北京小米证券",
                    "id": 218005
                }, {
                    "name": "东京平安证券有限公司",
                    "id": 218006
                }, {
                    "name": "台北百度航空有限公司",
                    "id": 218007,
                    "children": [{
                        "name": "台北小米科技",
                        "id": 218008
                    }, {
                        "name": "纽约阿里医院",
                        "id": 218009
                    }]
                }, {
                    "name": "纽约小米芯片控股集团",
                    "id": 218010
                }, {
                    "name": "南京特斯拉软件控股集团",
                    "id": 218011
                }, {
                    "name": "纽约字节地摊",
                    "id": 218012
                }, {
                    "name": "上海滴滴计算机有限公司",
                    "id": 218013
                }, {
                    "name": "台北京东石油",
                    "id": 218014
                }, {
                    "name": "纽约亚马逊",
                    "id": 218015
                }, {
                    "name": "厦门蚂蚁信息服务",
                    "id": 218016
                }, {
                    "name": "杭州欧珀医院",
                    "id": 218017
                }, {
                    "name": "南京滴滴软件",
                    "id": 218018
                }, {
                    "name": "天津蚂蚁科技控股集团",
                    "id": 218019
                }, {
                    "name": "上海百度信息服务有限公司",
                    "id": 218020
                }, {
                    "name": "厦门蚂蚁互金控股集团",
                    "id": 218021,
                    "children": [{
                        "name": "天津美团石油有限公司",
                        "id": 218022
                    }, {
                        "name": "香港华为制造",
                        "id": 218023
                    }, {
                        "name": "杭州字节航空",
                        "id": 218024
                    }, {
                        "name": "东京京东地摊有限公司",
                        "id": 218025
                    }, {
                        "name": "南京苹果餐饮",
                        "id": 218026
                    }, {
                        "name": "纽约字节银行",
                        "id": 218027
                    }, {
                        "name": "杭州肯德基汽车控股集团",
                        "id": 218028
                    }, {
                        "name": "天津字节",
                        "id": 218029
                    }, {
                        "name": "纽约欧珀地摊有限公司",
                        "id": 218030
                    }, {
                        "name": "南京华为制造控股集团",
                        "id": 218031
                    }, {
                        "name": "首尔星巴克医药",
                        "id": 218032
                    }, {
                        "name": "南京瑞幸地产",
                        "id": 218033
                    }, {
                        "name": "广州微软信息服务",
                        "id": 218034
                    }]
                }, {
                    "name": "广州京东基金有限公司",
                    "id": 218035
                }, {
                    "name": "杭州谷歌地产有限公司",
                    "id": 218036
                }, {
                    "name": "天津百度信息服务",
                    "id": 218037,
                    "children": [{
                        "name": "上海滴滴软件",
                        "id": 218038
                    }, {
                        "name": "天津滴滴汽车有限公司",
                        "id": 218039
                    }, {
                        "name": "上海奈雪医药控股集团",
                        "id": 218040
                    }, {
                        "name": "东莞字节养殖",
                        "id": 218041
                    }, {
                        "name": "广州苹果餐饮控股集团",
                        "id": 218042
                    }, {
                        "name": "广州星巴克有限公司",
                        "id": 218043
                    }, {
                        "name": "南京奈雪医院",
                        "id": 218044
                    }, {
                        "name": "首尔特斯拉芯片",
                        "id": 218045
                    }, {
                        "name": "北京奈雪汽车",
                        "id": 218046
                    }, {
                        "name": "杭州百度旅游",
                        "id": 218047
                    }, {
                        "name": "东京阿里银行",
                        "id": 218048
                    }, {
                        "name": "香港瑞幸农业",
                        "id": 218049
                    }, {
                        "name": "杭州平安制造有限公司",
                        "id": 218050
                    }]
                }, {
                    "name": "天津奈雪基金有限公司",
                    "id": 218051
                }]
            }, {
                "name": "香港肯德基通讯",
                "id": 218052
            }, {
                "name": "东京蚂蚁地产有限公司",
                "id": 218053
            }, {
                "name": "天津特斯拉诊所控股集团",
                "id": 218054,
                "children": [{
                    "name": "广州小米通讯",
                    "id": 218055,
                    "children": [{
                        "name": "北京星巴克航空控股集团",
                        "id": 218056
                    }, {
                        "name": "杭州小米地产控股集团",
                        "id": 218057
                    }, {
                        "name": "杭州奈雪通信控股集团",
                        "id": 218058
                    }, {
                        "name": "深圳特斯拉旅游",
                        "id": 218059
                    }, {
                        "name": "杭州必胜客芯片",
                        "id": 218060
                    }, {
                        "name": "香港蚂蚁餐饮有限公司",
                        "id": 218061
                    }, {
                        "name": "东京喜茶智能",
                        "id": 218062
                    }, {
                        "name": "天津肯德基航空",
                        "id": 218063
                    }, {
                        "name": "天津欧珀制造",
                        "id": 218064
                    }, {
                        "name": "上海华为智能",
                        "id": 218065
                    }, {
                        "name": "厦门肯德基银行",
                        "id": 218066
                    }, {
                        "name": "广州苹果证券",
                        "id": 218067
                    }, {
                        "name": "香港平安医药",
                        "id": 218068
                    }, {
                        "name": "天津欧珀医药",
                        "id": 218069
                    }, {
                        "name": "天津星巴克制造有限公司",
                        "id": 218070
                    }, {
                        "name": "天津快手养殖有限公司",
                        "id": 218071
                    }, {
                        "name": "北京喜茶牧业有限公司",
                        "id": 218072
                    }, {
                        "name": "杭州小米证券",
                        "id": 218073
                    }, {
                        "name": "上海蚂蚁软件",
                        "id": 218074
                    }, {
                        "name": "杭州欧珀",
                        "id": 218075
                    }, {
                        "name": "南京滴滴芯片",
                        "id": 218076
                    }, {
                        "name": "厦门星巴克基金控股集团",
                        "id": 218077
                    }, {
                        "name": "天津微软有限公司",
                        "id": 218078
                    }, {
                        "name": "上海平安科技",
                        "id": 218079
                    }, {
                        "name": "东京肯德基地摊",
                        "id": 218080
                    }, {
                        "name": "台北华为信息服务",
                        "id": 218081
                    }]
                }, {
                    "name": "北京滴滴智能",
                    "id": 218082
                }, {
                    "name": "天津瑞幸芯片",
                    "id": 218083,
                    "children": [{
                        "name": "纽约华为通信",
                        "id": 218084
                    }, {
                        "name": "天津特斯拉银行",
                        "id": 218085
                    }, {
                        "name": "东京平安医院",
                        "id": 218086
                    }, {
                        "name": "台北小米新能源",
                        "id": 218087
                    }, {
                        "name": "深圳平安地摊",
                        "id": 218088
                    }, {
                        "name": "北京星巴克银行",
                        "id": 218089
                    }, {
                        "name": "杭州华为",
                        "id": 218090
                    }, {
                        "name": "厦门星巴克通信",
                        "id": 218091
                    }, {
                        "name": "杭州京东汽车有限公司",
                        "id": 218092
                    }, {
                        "name": "杭州微软汽车",
                        "id": 218093
                    }, {
                        "name": "台北腾讯芯片",
                        "id": 218094
                    }, {
                        "name": "南京谷歌诊所",
                        "id": 218095
                    }, {
                        "name": "香港字节渔业",
                        "id": 218096
                    }, {
                        "name": "香港特斯拉控股集团",
                        "id": 218097
                    }, {
                        "name": "东莞亚马逊养殖有限公司",
                        "id": 218098
                    }, {
                        "name": "东莞必胜客牧业",
                        "id": 218099
                    }]
                }, {
                    "name": "广州瑞幸制造",
                    "id": 218100,
                    "children": [{
                        "name": "香港平安基金",
                        "id": 218101
                    }, {
                        "name": "东京奈雪制造",
                        "id": 218102
                    }, {
                        "name": "广州字节证券控股集团",
                        "id": 218103
                    }, {
                        "name": "纽约百度医院",
                        "id": 218104
                    }, {
                        "name": "香港特斯拉金融",
                        "id": 218105
                    }, {
                        "name": "厦门瑞幸汽车",
                        "id": 218106
                    }, {
                        "name": "东莞快手医药控股集团",
                        "id": 218107
                    }, {
                        "name": "上海特斯拉证券有限公司",
                        "id": 218108
                    }, {
                        "name": "上海喜茶牧业控股集团",
                        "id": 218109
                    }]
                }, {
                    "name": "东京京东渔业",
                    "id": 218110
                }, {
                    "name": "上海肯德基银行",
                    "id": 218111
                }, {
                    "name": "北京阿里智能有限公司",
                    "id": 218112
                }, {
                    "name": "香港奈雪餐饮",
                    "id": 218113
                }, {
                    "name": "广州滴滴智能",
                    "id": 218114,
                    "children": [{
                        "name": "纽约字节诊所",
                        "id": 218115
                    }, {
                        "name": "纽约奈雪",
                        "id": 218116
                    }, {
                        "name": "台北喜茶制造",
                        "id": 218117
                    }, {
                        "name": "首尔特斯拉银行控股集团",
                        "id": 218118
                    }, {
                        "name": "北京阿里芯片",
                        "id": 218119
                    }, {
                        "name": "香港华为软件控股集团",
                        "id": 218120
                    }, {
                        "name": "东莞苹果养殖",
                        "id": 218121
                    }, {
                        "name": "深圳美团养殖",
                        "id": 218122
                    }, {
                        "name": "首尔滴滴电商",
                        "id": 218123
                    }, {
                        "name": "香港华为农业",
                        "id": 218124
                    }, {
                        "name": "杭州蚂蚁基金",
                        "id": 218125
                    }, {
                        "name": "东京亚马逊地产",
                        "id": 218126
                    }, {
                        "name": "纽约蚂蚁餐饮",
                        "id": 218127
                    }, {
                        "name": "首尔京东通信",
                        "id": 218128
                    }, {
                        "name": "首尔奈雪银行",
                        "id": 218129
                    }, {
                        "name": "杭州亚马逊地产控股集团",
                        "id": 218130
                    }, {
                        "name": "北京阿里渔业",
                        "id": 218131
                    }, {
                        "name": "厦门滴滴地产",
                        "id": 218132
                    }, {
                        "name": "广州阿里制造",
                        "id": 218133
                    }, {
                        "name": "南京谷歌有限公司",
                        "id": 218134
                    }, {
                        "name": "广州喜茶医院",
                        "id": 218135
                    }, {
                        "name": "北京字节旅游",
                        "id": 218136
                    }, {
                        "name": "纽约美团地摊控股集团",
                        "id": 218137
                    }, {
                        "name": "东京小米",
                        "id": 218138
                    }, {
                        "name": "纽约特斯拉智能控股集团",
                        "id": 218139
                    }, {
                        "name": "首尔喜茶控股集团",
                        "id": 218140
                    }, {
                        "name": "深圳星巴克信息服务",
                        "id": 218141
                    }, {
                        "name": "杭州星巴克互金",
                        "id": 218142
                    }, {
                        "name": "杭州肯德基地产",
                        "id": 218143
                    }, {
                        "name": "北京小米计算机",
                        "id": 218144
                    }, {
                        "name": "深圳亚马逊汽车",
                        "id": 218145
                    }, {
                        "name": "深圳小米互金",
                        "id": 218146
                    }]
                }, {
                    "name": "香港苹果农业",
                    "id": 218147
                }, {
                    "name": "上海谷歌新能源控股集团",
                    "id": 218148,
                    "children": [{
                        "name": "东京谷歌通信有限公司",
                        "id": 218149
                    }, {
                        "name": "北京特斯拉地摊",
                        "id": 218150
                    }, {
                        "name": "杭州星巴克汽车",
                        "id": 218151
                    }, {
                        "name": "深圳欧珀智能",
                        "id": 218152
                    }, {
                        "name": "台北快手地产",
                        "id": 218153
                    }, {
                        "name": "香港华为电商",
                        "id": 218154
                    }, {
                        "name": "天津百度旅游控股集团",
                        "id": 218155
                    }, {
                        "name": "东京京东智能",
                        "id": 218156
                    }]
                }, {
                    "name": "北京百度科技",
                    "id": 218157
                }, {
                    "name": "台北华为地产",
                    "id": 218158
                }, {
                    "name": "深圳微软科技",
                    "id": 218159
                }]
            }, {
                "name": "深圳星巴克制造",
                "id": 218160
            }, {
                "name": "上海微软基金",
                "id": 218161
            }, {
                "name": "台北蚂蚁信息服务",
                "id": 218162,
                "children": [{
                    "name": "南京必胜客渔业",
                    "id": 218163
                }, {
                    "name": "南京小米金融",
                    "id": 218164
                }, {
                    "name": "杭州腾讯互金",
                    "id": 218165,
                    "children": [{
                        "name": "杭州平安石油",
                        "id": 218166
                    }, {
                        "name": "广州阿里计算机",
                        "id": 218167
                    }, {
                        "name": "厦门苹果养殖",
                        "id": 218168
                    }, {
                        "name": "香港华为地摊",
                        "id": 218169
                    }, {
                        "name": "上海字节医院控股集团",
                        "id": 218170
                    }, {
                        "name": "深圳字节计算机有限公司",
                        "id": 218171
                    }, {
                        "name": "厦门瑞幸餐饮",
                        "id": 218172
                    }, {
                        "name": "香港百度航空",
                        "id": 218173
                    }, {
                        "name": "南京肯德基制造",
                        "id": 218174
                    }, {
                        "name": "杭州阿里餐饮",
                        "id": 218175
                    }, {
                        "name": "首尔星巴克银行",
                        "id": 218176
                    }, {
                        "name": "南京特斯拉",
                        "id": 218177
                    }, {
                        "name": "深圳奈雪",
                        "id": 218178
                    }, {
                        "name": "深圳字节牧业",
                        "id": 218179
                    }, {
                        "name": "东莞平安新能源",
                        "id": 218180
                    }, {
                        "name": "东京快手电商控股集团",
                        "id": 218181
                    }, {
                        "name": "深圳必胜客渔业",
                        "id": 218182
                    }, {
                        "name": "深圳肯德基旅游",
                        "id": 218183
                    }, {
                        "name": "东京字节智能有限公司",
                        "id": 218184
                    }, {
                        "name": "北京谷歌软件",
                        "id": 218185
                    }, {
                        "name": "纽约必胜客汽车控股集团",
                        "id": 218186
                    }, {
                        "name": "香港星巴克基金",
                        "id": 218187
                    }, {
                        "name": "纽约滴滴软件有限公司",
                        "id": 218188
                    }, {
                        "name": "南京字节芯片",
                        "id": 218189
                    }, {
                        "name": "杭州肯德基证券",
                        "id": 218190
                    }, {
                        "name": "首尔百度金融有限公司",
                        "id": 218191
                    }, {
                        "name": "东京谷歌牧业有限公司",
                        "id": 218192
                    }, {
                        "name": "东京喜茶芯片",
                        "id": 218193
                    }, {
                        "name": "台北阿里科技有限公司",
                        "id": 218194
                    }, {
                        "name": "广州欧珀银行",
                        "id": 218195
                    }, {
                        "name": "天津美团",
                        "id": 218196
                    }, {
                        "name": "东京亚马逊金融",
                        "id": 218197
                    }, {
                        "name": "香港必胜客金融有限公司",
                        "id": 218198
                    }]
                }, {
                    "name": "天津亚马逊医院",
                    "id": 218199,
                    "children": [{
                        "name": "首尔美团地产",
                        "id": 218200
                    }, {
                        "name": "杭州快手金融有限公司",
                        "id": 218201
                    }, {
                        "name": "纽约百度农业",
                        "id": 218202
                    }, {
                        "name": "台北瑞幸智能",
                        "id": 218203
                    }, {
                        "name": "纽约喜茶有限公司",
                        "id": 218204
                    }]
                }, {
                    "name": "厦门字节旅游控股集团",
                    "id": 218205
                }]
            }]
        }, {
            "name": "香港喜茶科技",
            "id": 218206
        }, {
            "name": "天津特斯拉渔业",
            "id": 218207
        }]
    }, {
        "name": "天津蚂蚁",
        "id": 218208
    }, {
        "name": "深圳美团基金",
        "id": 218209
    }, {
        "name": "厦门喜茶制造",
        "id": 218210
    }, {
        "name": "首尔特斯拉金融",
        "id": 218211
    }]
}